# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class DialoguePDUs:

    _name_  = u'DialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 2, 1]
    
    _obj_ = [
        u'dialogue-as-id',
        u'DialoguePDU',
        u'AARQ-apdu',
        u'AARE-apdu',
        u'RLRQ-apdu',
        u'RLRE-apdu',
        u'ABRT-apdu',
        u'ABRT-source',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'Release-request-reason',
        u'Release-response-reason',
        ]
    _type_ = [
        u'DialoguePDU',
        u'AARQ-apdu',
        u'AARE-apdu',
        u'RLRQ-apdu',
        u'RLRE-apdu',
        u'ABRT-apdu',
        u'ABRT-source',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'Release-request-reason',
        u'Release-response-reason',
        ]
    _set_ = [
        ]
    _val_ = [
        u'dialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< dialogue-as-id >-----#
    dialogue_as_id = OID(name=u'dialogue-as-id', mode=MODE_VALUE)
    dialogue_as_id._val = (0, 0, 17, 773, 1, 1, 1)
    
    #-----< DialoguePDU >-----#
    DialoguePDU = CHOICE(name=u'DialoguePDU', mode=MODE_TYPE)
    _DialoguePDU_dialogueRequest = SEQ(name=u'dialogueRequest', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARQ-apdu')))
    _DialoguePDU_dialogueResponse = SEQ(name=u'dialogueResponse', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARE-apdu')))
    _DialoguePDU_dialogueAbort = SEQ(name=u'dialogueAbort', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'ABRT-apdu')))
    DialoguePDU._cont = ASN1Dict([
        (u'dialogueRequest', _DialoguePDU_dialogueRequest),
        (u'dialogueResponse', _DialoguePDU_dialogueResponse),
        (u'dialogueAbort', _DialoguePDU_dialogueAbort),
        ])
    DialoguePDU._ext = None
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name=u'AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AARQ_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARQ_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARQ_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _AARQ_apdu_user_information._cont = __AARQ_apdu_user_information__item_
    AARQ_apdu._cont = ASN1Dict([
        (u'protocol-version', _AARQ_apdu_protocol_version),
        (u'application-context-name', _AARQ_apdu_application_context_name),
        (u'user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = None
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name=u'AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AARE_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARE_apdu_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-source-diagnostic')))
    _AARE_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARE_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _AARE_apdu_user_information._cont = __AARE_apdu_user_information__item_
    AARE_apdu._cont = ASN1Dict([
        (u'protocol-version', _AARE_apdu_protocol_version),
        (u'application-context-name', _AARE_apdu_application_context_name),
        (u'result', _AARE_apdu_result),
        (u'result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        (u'user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = None
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name=u'RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRQ_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _RLRQ_apdu_user_information._cont = __RLRQ_apdu_user_information__item_
    RLRQ_apdu._cont = ASN1Dict([
        (u'reason', _RLRQ_apdu_reason),
        (u'user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = None
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name=u'RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRE_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _RLRE_apdu_user_information._cont = __RLRE_apdu_user_information__item_
    RLRE_apdu._cont = ASN1Dict([
        (u'reason', _RLRE_apdu_reason),
        (u'user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = None
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name=u'ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name=u'abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'ABRT-source')))
    _ABRT_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ABRT_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _ABRT_apdu_user_information._cont = __ABRT_apdu_user_information__item_
    ABRT_apdu._cont = ASN1Dict([
        (u'abort-source', _ABRT_apdu_abort_source),
        (u'user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name=u'ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([(u'dialogue-service-user', 0), (u'dialogue-service-provider', 1)])
    
    #-----< Associate-result >-----#
    Associate_result = INT(name=u'Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([(u'accepted', 0), (u'reject-permanent', 1)])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name=u'Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_dialogue_service_user = INT(name=u'dialogue-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_user._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'application-context-name-not-supported', 2)])
    _Associate_source_diagnostic_dialogue_service_provider = INT(name=u'dialogue-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_provider._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'no-common-dialogue-portion', 2)])
    Associate_source_diagnostic._cont = ASN1Dict([
        (u'dialogue-service-user', _Associate_source_diagnostic_dialogue_service_user),
        (u'dialogue-service-provider', _Associate_source_diagnostic_dialogue_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name=u'Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([(u'normal', 0), (u'urgent', 1), (u'user-defined', 30)])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name=u'Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([(u'normal', 0), (u'not-finished', 1), (u'user-defined', 30)])
    
    _all_ = [
        dialogue_as_id,
        _DialoguePDU_dialogueRequest,
        _DialoguePDU_dialogueResponse,
        _DialoguePDU_dialogueAbort,
        DialoguePDU,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        __AARQ_apdu_user_information__item_,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        __AARE_apdu_user_information__item_,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        __RLRQ_apdu_user_information__item_,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        __RLRE_apdu_user_information__item_,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        __ABRT_apdu_user_information__item_,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_source,
        Associate_result,
        _Associate_source_diagnostic_dialogue_service_user,
        _Associate_source_diagnostic_dialogue_service_provider,
        Associate_source_diagnostic,
        Release_request_reason,
        Release_response_reason,
    ]

class UnidialoguePDUs:

    _name_  = u'UnidialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 3, 1]
    
    _obj_ = [
        u'uniDialogue-as-id',
        u'UniDialoguePDU',
        u'AUDT-apdu',
        ]
    _type_ = [
        u'UniDialoguePDU',
        u'AUDT-apdu',
        ]
    _set_ = [
        ]
    _val_ = [
        u'uniDialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< uniDialogue-as-id >-----#
    uniDialogue_as_id = OID(name=u'uniDialogue-as-id', mode=MODE_VALUE)
    uniDialogue_as_id._val = (0, 0, 17, 773, 1, 2, 1)
    
    #-----< UniDialoguePDU >-----#
    UniDialoguePDU = CHOICE(name=u'UniDialoguePDU', mode=MODE_TYPE)
    _UniDialoguePDU_unidialoguePDU = SEQ(name=u'unidialoguePDU', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'AUDT-apdu')))
    UniDialoguePDU._cont = ASN1Dict([
        (u'unidialoguePDU', _UniDialoguePDU_unidialoguePDU),
        ])
    UniDialoguePDU._ext = None
    
    #-----< AUDT-apdu >-----#
    AUDT_apdu = SEQ(name=u'AUDT-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AUDT_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AUDT_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AUDT_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AUDT_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AUDT_apdu_user_information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    _AUDT_apdu_user_information._cont = __AUDT_apdu_user_information__item_
    AUDT_apdu._cont = ASN1Dict([
        (u'protocol-version', _AUDT_apdu_protocol_version),
        (u'application-context-name', _AUDT_apdu_application_context_name),
        (u'user-information', _AUDT_apdu_user_information),
        ])
    AUDT_apdu._ext = None
    
    _all_ = [
        uniDialogue_as_id,
        _UniDialoguePDU_unidialoguePDU,
        UniDialoguePDU,
        _AUDT_apdu_protocol_version,
        _AUDT_apdu_application_context_name,
        __AUDT_apdu_user_information__item_,
        _AUDT_apdu_user_information,
        AUDT_apdu,
    ]

class Remote_Operations_Generic_ROS_PDUs:

    _name_  = u'Remote-Operations-Generic-ROS-PDUs'
    _oid_   = [2, 4, 6, 0]
    
    _obj_ = [
        u'ROS',
        u'Invoke',
        u'ReturnResult',
        u'ReturnError',
        u'Reject',
        u'GeneralProblem',
        u'InvokeProblem',
        u'ReturnResultProblem',
        u'ReturnErrorProblem',
        u'RejectProblem',
        u'InvokeId',
        u'noInvokeId',
        u'NoInvokeId',
        u'Errors',
        u'Bind',
        u'Unbind',
        ]
    _type_ = [
        u'ROS',
        u'Invoke',
        u'ReturnResult',
        u'ReturnError',
        u'Reject',
        u'GeneralProblem',
        u'InvokeProblem',
        u'ReturnResultProblem',
        u'ReturnErrorProblem',
        u'RejectProblem',
        u'InvokeId',
        u'Bind',
        u'Unbind',
        ]
    _set_ = [
        u'NoInvokeId',
        u'Errors',
        ]
    _val_ = [
        u'noInvokeId',
        ]
    _class_ = [
        u'Errors',
        ]
    _param_ = [
        u'ROS',
        u'Invoke',
        u'ReturnResult',
        u'ReturnError',
        u'Errors',
        u'Bind',
        u'Unbind',
        ]
    
    #-----< ROS >-----#
    ROS = CHOICE(name=u'ROS', mode=MODE_TYPE, param=True)
    
    #-----< Invoke >-----#
    Invoke = SEQ(name=u'Invoke', mode=MODE_TYPE, param=True)
    
    #-----< ReturnResult >-----#
    ReturnResult = SEQ(name=u'ReturnResult', mode=MODE_TYPE, param=True)
    
    #-----< ReturnError >-----#
    ReturnError = SEQ(name=u'ReturnError', mode=MODE_TYPE, param=True)
    
    #-----< Reject >-----#
    Reject = SEQ(name=u'Reject', mode=MODE_TYPE)
    _Reject_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _Reject_problem = CHOICE(name=u'problem', mode=MODE_TYPE)
    __Reject_problem_general = INT(name=u'general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'GeneralProblem')))
    __Reject_problem_invoke = INT(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeProblem')))
    __Reject_problem_returnResult = INT(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResultProblem')))
    __Reject_problem_returnError = INT(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnErrorProblem')))
    _Reject_problem._cont = ASN1Dict([
        (u'general', __Reject_problem_general),
        (u'invoke', __Reject_problem_invoke),
        (u'returnResult', __Reject_problem_returnResult),
        (u'returnError', __Reject_problem_returnError),
        ])
    _Reject_problem._ext = None
    Reject._cont = ASN1Dict([
        (u'invokeId', _Reject_invokeId),
        (u'problem', _Reject_problem),
        ])
    Reject._ext = None
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name=u'GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([(u'unrecognizedPDU', 0), (u'mistypedPDU', 1), (u'badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name=u'InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([(u'duplicateInvocation', 0), (u'unrecognizedOperation', 1), (u'mistypedArgument', 2), (u'resourceLimitation', 3), (u'releaseInProgress', 4), (u'unrecognizedLinkedId', 5), (u'linkedResponseUnexpected', 6), (u'unexpectedLinkedOperation', 7)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name=u'ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([(u'unrecognizedInvocation', 0), (u'resultResponseUnexpected', 1), (u'mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name=u'ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([(u'unrecognizedInvocation', 0), (u'errorResponseUnexpected', 1), (u'unrecognizedError', 2), (u'unexpectedError', 3), (u'mistypedParameter', 4)])
    
    #-----< RejectProblem >-----#
    RejectProblem = INT(name=u'RejectProblem', mode=MODE_TYPE)
    RejectProblem._cont = ASN1Dict([(u'general-unrecognizedPDU', 0), (u'general-mistypedPDU', 1), (u'general-badlyStructuredPDU', 2), (u'invoke-duplicateInvocation', 10), (u'invoke-unrecognizedOperation', 11), (u'invoke-mistypedArgument', 12), (u'invoke-resourceLimitation', 13), (u'invoke-releaseInProgress', 14), (u'invoke-unrecognizedLinkedId', 15), (u'invoke-linkedResponseUnexpected', 16), (u'invoke-unexpectedLinkedOperation', 17), (u'returnResult-unrecognizedInvocation', 20), (u'returnResult-resultResponseUnexpected', 21), (u'returnResult-mistypedResult', 22), (u'returnError-unrecognizedInvocation', 30), (u'returnError-errorResponseUnexpected', 31), (u'returnError-unrecognizedError', 32), (u'returnError-unexpectedError', 33), (u'returnError-mistypedParameter', 34)])
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name=u'InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name=u'present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name=u'absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        (u'present', _InvokeId_present),
        (u'absent', _InvokeId_absent),
        ])
    InvokeId._ext = None
    
    #-----< noInvokeId >-----#
    noInvokeId = CHOICE(name=u'noInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    noInvokeId._val = (u'absent', 0)
    
    #-----< NoInvokeId >-----#
    NoInvokeId = CHOICE(name=u'NoInvokeId', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    NoInvokeId._val = ASN1Set(rv=[(u'absent', 0)], rr=[], ev=None, er=[])
    
    #-----< Errors >-----#
    Errors = CLASS(name=u'Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), param=True)
    
    #-----< Bind >-----#
    Bind = CHOICE(name=u'Bind', mode=MODE_TYPE, param=True)
    
    #-----< Unbind >-----#
    Unbind = CHOICE(name=u'Unbind', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _Reject_invokeId,
        __Reject_problem_general,
        __Reject_problem_invoke,
        __Reject_problem_returnResult,
        __Reject_problem_returnError,
        _Reject_problem,
        Reject,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        RejectProblem,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        noInvokeId,
        NoInvokeId,
    ]

class Remote_Operations_Information_Objects:

    _name_  = u'Remote-Operations-Information-Objects'
    _oid_   = [2, 4, 5, 0]
    
    _obj_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'Code',
        u'Priority',
        ]
    _type_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'Code',
        u'Priority',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name=u'OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name=u'ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_argumentTypeOptional = BOOL(name=u'argumentTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_returnResult = BOOL(name=u'returnResult', mode=MODE_VALUE, default=True)
    _OPERATION_ResultType = OPEN(name=u'ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_resultTypeOptional = BOOL(name=u'resultTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_Errors = CLASS(name=u'Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), opt=True)
    _OPERATION_Linked = CLASS(name=u'Linked', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_synchronous = BOOL(name=u'synchronous', mode=MODE_VALUE, default=False)
    _OPERATION_alwaysReturns = BOOL(name=u'alwaysReturns', mode=MODE_VALUE, default=True)
    _OPERATION_InvokePriority = INT(name=u'InvokePriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_ResultPriority = INT(name=u'ResultPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_operationCode = CHOICE(name=u'operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        (u'ArgumentType', _OPERATION_ArgumentType),
        (u'argumentTypeOptional', _OPERATION_argumentTypeOptional),
        (u'returnResult', _OPERATION_returnResult),
        (u'ResultType', _OPERATION_ResultType),
        (u'resultTypeOptional', _OPERATION_resultTypeOptional),
        (u'Errors', _OPERATION_Errors),
        (u'Linked', _OPERATION_Linked),
        (u'synchronous', _OPERATION_synchronous),
        (u'alwaysReturns', _OPERATION_alwaysReturns),
        (u'InvokePriority', _OPERATION_InvokePriority),
        (u'ResultPriority', _OPERATION_ResultPriority),
        (u'operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name=u'ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name=u'ParameterType', mode=MODE_TYPE, opt=True)
    _ERROR_parameterTypeOptional = BOOL(name=u'parameterTypeOptional', mode=MODE_VALUE, opt=True)
    _ERROR_ErrorPriority = INT(name=u'ErrorPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _ERROR_errorCode = CHOICE(name=u'errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        (u'ParameterType', _ERROR_ParameterType),
        (u'parameterTypeOptional', _ERROR_parameterTypeOptional),
        (u'ErrorPriority', _ERROR_ErrorPriority),
        (u'errorCode', _ERROR_errorCode),
        ])
    
    #-----< OPERATION-PACKAGE >-----#
    OPERATION_PACKAGE = CLASS(name=u'OPERATION-PACKAGE', mode=MODE_TYPE)
    _OPERATION_PACKAGE_Both = CLASS(name=u'Both', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Consumer = CLASS(name=u'Consumer', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Supplier = CLASS(name=u'Supplier', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    OPERATION_PACKAGE._cont = ASN1Dict([
        (u'Both', _OPERATION_PACKAGE_Both),
        (u'Consumer', _OPERATION_PACKAGE_Consumer),
        (u'Supplier', _OPERATION_PACKAGE_Supplier),
        (u'id', _OPERATION_PACKAGE_id),
        ])
    
    #-----< CONNECTION-PACKAGE >-----#
    CONNECTION_PACKAGE = CLASS(name=u'CONNECTION-PACKAGE', mode=MODE_TYPE)
    _CONNECTION_PACKAGE_bind = CLASS(name=u'bind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([(u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', -1))])], rr=[], ev=None, er=[])), (u'synchronous', True)]))
    _CONNECTION_PACKAGE_unbind = CLASS(name=u'unbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([(u'synchronous', True)]))
    _CONNECTION_PACKAGE_responderCanUnbind = BOOL(name=u'responderCanUnbind', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_unbindCanFail = BOOL(name=u'unbindCanFail', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    CONNECTION_PACKAGE._cont = ASN1Dict([
        (u'bind', _CONNECTION_PACKAGE_bind),
        (u'unbind', _CONNECTION_PACKAGE_unbind),
        (u'responderCanUnbind', _CONNECTION_PACKAGE_responderCanUnbind),
        (u'unbindCanFail', _CONNECTION_PACKAGE_unbindCanFail),
        (u'id', _CONNECTION_PACKAGE_id),
        ])
    
    #-----< CONTRACT >-----#
    CONTRACT = CLASS(name=u'CONTRACT', mode=MODE_TYPE)
    _CONTRACT_connection = CLASS(name=u'connection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONNECTION-PACKAGE')), opt=True)
    _CONTRACT_OperationsOf = CLASS(name=u'OperationsOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorConsumerOf = CLASS(name=u'InitiatorConsumerOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorSupplierOf = CLASS(name=u'InitiatorSupplierOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    CONTRACT._cont = ASN1Dict([
        (u'connection', _CONTRACT_connection),
        (u'OperationsOf', _CONTRACT_OperationsOf),
        (u'InitiatorConsumerOf', _CONTRACT_InitiatorConsumerOf),
        (u'InitiatorSupplierOf', _CONTRACT_InitiatorSupplierOf),
        (u'id', _CONTRACT_id),
        ])
    
    #-----< ROS-OBJECT-CLASS >-----#
    ROS_OBJECT_CLASS = CLASS(name=u'ROS-OBJECT-CLASS', mode=MODE_TYPE)
    _ROS_OBJECT_CLASS_Is = CLASS(name=u'Is', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')), opt=True)
    _ROS_OBJECT_CLASS_Initiates = CLASS(name=u'Initiates', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_Responds = CLASS(name=u'Responds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_InitiatesAndResponds = CLASS(name=u'InitiatesAndResponds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    ROS_OBJECT_CLASS._cont = ASN1Dict([
        (u'Is', _ROS_OBJECT_CLASS_Is),
        (u'Initiates', _ROS_OBJECT_CLASS_Initiates),
        (u'Responds', _ROS_OBJECT_CLASS_Responds),
        (u'InitiatesAndResponds', _ROS_OBJECT_CLASS_InitiatesAndResponds),
        (u'id', _ROS_OBJECT_CLASS_id),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name=u'Code', mode=MODE_TYPE)
    _Code_local = INT(name=u'local', mode=MODE_TYPE)
    _Code_global_ = OID(name=u'global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        (u'local', _Code_local),
        (u'global', _Code_global_),
        ])
    Code._ext = None
    
    #-----< Priority >-----#
    Priority = INT(name=u'Priority', mode=MODE_TYPE)
    Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_argumentTypeOptional,
        _OPERATION_returnResult,
        _OPERATION_ResultType,
        _OPERATION_resultTypeOptional,
        _OPERATION_Errors,
        _OPERATION_Linked,
        _OPERATION_synchronous,
        _OPERATION_alwaysReturns,
        _OPERATION_InvokePriority,
        _OPERATION_ResultPriority,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_parameterTypeOptional,
        _ERROR_ErrorPriority,
        _ERROR_errorCode,
        ERROR,
        _OPERATION_PACKAGE_Both,
        _OPERATION_PACKAGE_Consumer,
        _OPERATION_PACKAGE_Supplier,
        _OPERATION_PACKAGE_id,
        OPERATION_PACKAGE,
        _CONNECTION_PACKAGE_bind,
        _CONNECTION_PACKAGE_unbind,
        _CONNECTION_PACKAGE_responderCanUnbind,
        _CONNECTION_PACKAGE_unbindCanFail,
        _CONNECTION_PACKAGE_id,
        CONNECTION_PACKAGE,
        _CONTRACT_connection,
        _CONTRACT_OperationsOf,
        _CONTRACT_InitiatorConsumerOf,
        _CONTRACT_InitiatorSupplierOf,
        _CONTRACT_id,
        CONTRACT,
        _ROS_OBJECT_CLASS_Is,
        _ROS_OBJECT_CLASS_Initiates,
        _ROS_OBJECT_CLASS_Responds,
        _ROS_OBJECT_CLASS_InitiatesAndResponds,
        _ROS_OBJECT_CLASS_id,
        ROS_OBJECT_CLASS,
        _Code_local,
        _Code_global_,
        Code,
        Priority,
    ]

class Remote_Operations_Useful_Definitions:

    _name_  = u'Remote-Operations-Useful-Definitions'
    _oid_   = [2, 4, 7, 0]
    
    _obj_ = [
        u'emptyBind',
        u'emptyUnbind',
        u'refuse',
        u'no-op',
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        u'recode',
        u'switch',
        u'combine',
        u'ROS-SingleAS',
        u'ROS-ConsumerAS',
        u'ROS-SupplierAS',
        ]
    _type_ = [
        u'ROS-SingleAS',
        u'ROS-ConsumerAS',
        u'ROS-SupplierAS',
        ]
    _set_ = [
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        ]
    _val_ = [
        u'emptyBind',
        u'emptyUnbind',
        u'refuse',
        u'no-op',
        u'recode',
        u'switch',
        u'combine',
        ]
    _class_ = [
        u'emptyBind',
        u'emptyUnbind',
        u'refuse',
        u'no-op',
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        u'recode',
        u'switch',
        u'combine',
        ]
    _param_ = [
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        u'recode',
        u'switch',
        u'combine',
        u'ROS-SingleAS',
        u'ROS-ConsumerAS',
        u'ROS-SupplierAS',
        ]
    
    #-----< emptyBind >-----#
    emptyBind = CLASS(name=u'emptyBind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyBind._val = dict([(u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', -1))])], rr=[], ev=None, er=[])), (u'synchronous', True)])
    
    #-----< emptyUnbind >-----#
    emptyUnbind = CLASS(name=u'emptyUnbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyUnbind._val = dict([(u'synchronous', True)])
    
    #-----< refuse >-----#
    refuse = CLASS(name=u'refuse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    refuse._val = dict([(u'errorCode', (u'local', -1))])
    
    #-----< no-op >-----#
    no_op = CLASS(name=u'no-op', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    no_op._val = dict([(u'alwaysReturns', False), (u'operationCode', (u'local', -1))])
    
    #-----< Forward >-----#
    Forward = CLASS(name=u'Forward', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< Reverse >-----#
    Reverse = CLASS(name=u'Reverse', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConsumerPerforms >-----#
    ConsumerPerforms = CLASS(name=u'ConsumerPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SupplierPerforms >-----#
    SupplierPerforms = CLASS(name=u'SupplierPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AllOperations >-----#
    AllOperations = CLASS(name=u'AllOperations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< recode >-----#
    recode = CLASS(name=u'recode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< switch >-----#
    switch = CLASS(name=u'switch', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< combine >-----#
    combine = CLASS(name=u'combine', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ROS-SingleAS >-----#
    ROS_SingleAS = CHOICE(name=u'ROS-SingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-ConsumerAS >-----#
    ROS_ConsumerAS = CHOICE(name=u'ROS-ConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-SupplierAS >-----#
    ROS_SupplierAS = CHOICE(name=u'ROS-SupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    _all_ = [
        emptyBind,
        emptyUnbind,
        refuse,
        no_op,
    ]

class MAP_BS_Code:

    _name_  = u'MAP-BS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 20, 19]
    
    _obj_ = [
        u'BearerServiceCode',
        u'Ext-BearerServiceCode',
        u'allBearerServices',
        u'allDataCDA-Services',
        u'dataCDA-300bps',
        u'dataCDA-1200bps',
        u'dataCDA-1200-75bps',
        u'dataCDA-2400bps',
        u'dataCDA-4800bps',
        u'dataCDA-9600bps',
        u'general-dataCDA',
        u'allDataCDS-Services',
        u'dataCDS-1200bps',
        u'dataCDS-2400bps',
        u'dataCDS-4800bps',
        u'dataCDS-9600bps',
        u'general-dataCDS',
        u'allPadAccessCA-Services',
        u'padAccessCA-300bps',
        u'padAccessCA-1200bps',
        u'padAccessCA-1200-75bps',
        u'padAccessCA-2400bps',
        u'padAccessCA-4800bps',
        u'padAccessCA-9600bps',
        u'general-padAccessCA',
        u'allDataPDS-Services',
        u'dataPDS-2400bps',
        u'dataPDS-4800bps',
        u'dataPDS-9600bps',
        u'general-dataPDS',
        u'allAlternateSpeech-DataCDA',
        u'allAlternateSpeech-DataCDS',
        u'allSpeechFollowedByDataCDA',
        u'allSpeechFollowedByDataCDS',
        u'allDataCircuitAsynchronous',
        u'allAsynchronousServices',
        u'allDataCircuitSynchronous',
        u'allSynchronousServices',
        u'allPLMN-specificBS',
        u'plmn-specificBS-1',
        u'plmn-specificBS-2',
        u'plmn-specificBS-3',
        u'plmn-specificBS-4',
        u'plmn-specificBS-5',
        u'plmn-specificBS-6',
        u'plmn-specificBS-7',
        u'plmn-specificBS-8',
        u'plmn-specificBS-9',
        u'plmn-specificBS-A',
        u'plmn-specificBS-B',
        u'plmn-specificBS-C',
        u'plmn-specificBS-D',
        u'plmn-specificBS-E',
        u'plmn-specificBS-F',
        ]
    _type_ = [
        u'BearerServiceCode',
        u'Ext-BearerServiceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        u'allBearerServices',
        u'allDataCDA-Services',
        u'dataCDA-300bps',
        u'dataCDA-1200bps',
        u'dataCDA-1200-75bps',
        u'dataCDA-2400bps',
        u'dataCDA-4800bps',
        u'dataCDA-9600bps',
        u'general-dataCDA',
        u'allDataCDS-Services',
        u'dataCDS-1200bps',
        u'dataCDS-2400bps',
        u'dataCDS-4800bps',
        u'dataCDS-9600bps',
        u'general-dataCDS',
        u'allPadAccessCA-Services',
        u'padAccessCA-300bps',
        u'padAccessCA-1200bps',
        u'padAccessCA-1200-75bps',
        u'padAccessCA-2400bps',
        u'padAccessCA-4800bps',
        u'padAccessCA-9600bps',
        u'general-padAccessCA',
        u'allDataPDS-Services',
        u'dataPDS-2400bps',
        u'dataPDS-4800bps',
        u'dataPDS-9600bps',
        u'general-dataPDS',
        u'allAlternateSpeech-DataCDA',
        u'allAlternateSpeech-DataCDS',
        u'allSpeechFollowedByDataCDA',
        u'allSpeechFollowedByDataCDS',
        u'allDataCircuitAsynchronous',
        u'allAsynchronousServices',
        u'allDataCircuitSynchronous',
        u'allSynchronousServices',
        u'allPLMN-specificBS',
        u'plmn-specificBS-1',
        u'plmn-specificBS-2',
        u'plmn-specificBS-3',
        u'plmn-specificBS-4',
        u'plmn-specificBS-5',
        u'plmn-specificBS-6',
        u'plmn-specificBS-7',
        u'plmn-specificBS-8',
        u'plmn-specificBS-9',
        u'plmn-specificBS-A',
        u'plmn-specificBS-B',
        u'plmn-specificBS-C',
        u'plmn-specificBS-D',
        u'plmn-specificBS-E',
        u'plmn-specificBS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BearerServiceCode >-----#
    BearerServiceCode = OCT_STR(name=u'BearerServiceCode', mode=MODE_TYPE)
    BearerServiceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-BearerServiceCode >-----#
    Ext_BearerServiceCode = OCT_STR(name=u'Ext-BearerServiceCode', mode=MODE_TYPE)
    Ext_BearerServiceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allBearerServices >-----#
    allBearerServices = OCT_STR(name=u'allBearerServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allBearerServices._val = b'\x00'
    
    #-----< allDataCDA-Services >-----#
    allDataCDA_Services = OCT_STR(name=u'allDataCDA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDA_Services._val = b'\x10'
    
    #-----< dataCDA-300bps >-----#
    dataCDA_300bps = OCT_STR(name=u'dataCDA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_300bps._val = b'\x11'
    
    #-----< dataCDA-1200bps >-----#
    dataCDA_1200bps = OCT_STR(name=u'dataCDA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200bps._val = b'\x12'
    
    #-----< dataCDA-1200-75bps >-----#
    dataCDA_1200_75bps = OCT_STR(name=u'dataCDA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200_75bps._val = b'\x13'
    
    #-----< dataCDA-2400bps >-----#
    dataCDA_2400bps = OCT_STR(name=u'dataCDA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_2400bps._val = b'\x14'
    
    #-----< dataCDA-4800bps >-----#
    dataCDA_4800bps = OCT_STR(name=u'dataCDA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_4800bps._val = b'\x15'
    
    #-----< dataCDA-9600bps >-----#
    dataCDA_9600bps = OCT_STR(name=u'dataCDA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_9600bps._val = b'\x16'
    
    #-----< general-dataCDA >-----#
    general_dataCDA = OCT_STR(name=u'general-dataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDA._val = b'\x17'
    
    #-----< allDataCDS-Services >-----#
    allDataCDS_Services = OCT_STR(name=u'allDataCDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDS_Services._val = b'\x18'
    
    #-----< dataCDS-1200bps >-----#
    dataCDS_1200bps = OCT_STR(name=u'dataCDS-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_1200bps._val = b'\x1a'
    
    #-----< dataCDS-2400bps >-----#
    dataCDS_2400bps = OCT_STR(name=u'dataCDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_2400bps._val = b'\x1c'
    
    #-----< dataCDS-4800bps >-----#
    dataCDS_4800bps = OCT_STR(name=u'dataCDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_4800bps._val = b'\x1d'
    
    #-----< dataCDS-9600bps >-----#
    dataCDS_9600bps = OCT_STR(name=u'dataCDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_9600bps._val = b'\x1e'
    
    #-----< general-dataCDS >-----#
    general_dataCDS = OCT_STR(name=u'general-dataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDS._val = b'\x1f'
    
    #-----< allPadAccessCA-Services >-----#
    allPadAccessCA_Services = OCT_STR(name=u'allPadAccessCA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPadAccessCA_Services._val = b' '
    
    #-----< padAccessCA-300bps >-----#
    padAccessCA_300bps = OCT_STR(name=u'padAccessCA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_300bps._val = b'!'
    
    #-----< padAccessCA-1200bps >-----#
    padAccessCA_1200bps = OCT_STR(name=u'padAccessCA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200bps._val = b'"'
    
    #-----< padAccessCA-1200-75bps >-----#
    padAccessCA_1200_75bps = OCT_STR(name=u'padAccessCA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200_75bps._val = b'#'
    
    #-----< padAccessCA-2400bps >-----#
    padAccessCA_2400bps = OCT_STR(name=u'padAccessCA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_2400bps._val = b'$'
    
    #-----< padAccessCA-4800bps >-----#
    padAccessCA_4800bps = OCT_STR(name=u'padAccessCA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_4800bps._val = b'%'
    
    #-----< padAccessCA-9600bps >-----#
    padAccessCA_9600bps = OCT_STR(name=u'padAccessCA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_9600bps._val = b'&'
    
    #-----< general-padAccessCA >-----#
    general_padAccessCA = OCT_STR(name=u'general-padAccessCA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_padAccessCA._val = b"'"
    
    #-----< allDataPDS-Services >-----#
    allDataPDS_Services = OCT_STR(name=u'allDataPDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataPDS_Services._val = b'('
    
    #-----< dataPDS-2400bps >-----#
    dataPDS_2400bps = OCT_STR(name=u'dataPDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_2400bps._val = b','
    
    #-----< dataPDS-4800bps >-----#
    dataPDS_4800bps = OCT_STR(name=u'dataPDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_4800bps._val = b'-'
    
    #-----< dataPDS-9600bps >-----#
    dataPDS_9600bps = OCT_STR(name=u'dataPDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_9600bps._val = b'.'
    
    #-----< general-dataPDS >-----#
    general_dataPDS = OCT_STR(name=u'general-dataPDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataPDS._val = b'/'
    
    #-----< allAlternateSpeech-DataCDA >-----#
    allAlternateSpeech_DataCDA = OCT_STR(name=u'allAlternateSpeech-DataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDA._val = b'0'
    
    #-----< allAlternateSpeech-DataCDS >-----#
    allAlternateSpeech_DataCDS = OCT_STR(name=u'allAlternateSpeech-DataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDS._val = b'8'
    
    #-----< allSpeechFollowedByDataCDA >-----#
    allSpeechFollowedByDataCDA = OCT_STR(name=u'allSpeechFollowedByDataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDA._val = b'@'
    
    #-----< allSpeechFollowedByDataCDS >-----#
    allSpeechFollowedByDataCDS = OCT_STR(name=u'allSpeechFollowedByDataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDS._val = b'H'
    
    #-----< allDataCircuitAsynchronous >-----#
    allDataCircuitAsynchronous = OCT_STR(name=u'allDataCircuitAsynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitAsynchronous._val = b'P'
    
    #-----< allAsynchronousServices >-----#
    allAsynchronousServices = OCT_STR(name=u'allAsynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAsynchronousServices._val = b'`'
    
    #-----< allDataCircuitSynchronous >-----#
    allDataCircuitSynchronous = OCT_STR(name=u'allDataCircuitSynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitSynchronous._val = b'X'
    
    #-----< allSynchronousServices >-----#
    allSynchronousServices = OCT_STR(name=u'allSynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSynchronousServices._val = b'h'
    
    #-----< allPLMN-specificBS >-----#
    allPLMN_specificBS = OCT_STR(name=u'allPLMN-specificBS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPLMN_specificBS._val = b'\xd0'
    
    #-----< plmn-specificBS-1 >-----#
    plmn_specificBS_1 = OCT_STR(name=u'plmn-specificBS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_1._val = b'\xd1'
    
    #-----< plmn-specificBS-2 >-----#
    plmn_specificBS_2 = OCT_STR(name=u'plmn-specificBS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_2._val = b'\xd2'
    
    #-----< plmn-specificBS-3 >-----#
    plmn_specificBS_3 = OCT_STR(name=u'plmn-specificBS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_3._val = b'\xd3'
    
    #-----< plmn-specificBS-4 >-----#
    plmn_specificBS_4 = OCT_STR(name=u'plmn-specificBS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_4._val = b'\xd4'
    
    #-----< plmn-specificBS-5 >-----#
    plmn_specificBS_5 = OCT_STR(name=u'plmn-specificBS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_5._val = b'\xd5'
    
    #-----< plmn-specificBS-6 >-----#
    plmn_specificBS_6 = OCT_STR(name=u'plmn-specificBS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_6._val = b'\xd6'
    
    #-----< plmn-specificBS-7 >-----#
    plmn_specificBS_7 = OCT_STR(name=u'plmn-specificBS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_7._val = b'\xd7'
    
    #-----< plmn-specificBS-8 >-----#
    plmn_specificBS_8 = OCT_STR(name=u'plmn-specificBS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_8._val = b'\xd8'
    
    #-----< plmn-specificBS-9 >-----#
    plmn_specificBS_9 = OCT_STR(name=u'plmn-specificBS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_9._val = b'\xd9'
    
    #-----< plmn-specificBS-A >-----#
    plmn_specificBS_A = OCT_STR(name=u'plmn-specificBS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_A._val = b'\xda'
    
    #-----< plmn-specificBS-B >-----#
    plmn_specificBS_B = OCT_STR(name=u'plmn-specificBS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_B._val = b'\xdb'
    
    #-----< plmn-specificBS-C >-----#
    plmn_specificBS_C = OCT_STR(name=u'plmn-specificBS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_C._val = b'\xdc'
    
    #-----< plmn-specificBS-D >-----#
    plmn_specificBS_D = OCT_STR(name=u'plmn-specificBS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_D._val = b'\xdd'
    
    #-----< plmn-specificBS-E >-----#
    plmn_specificBS_E = OCT_STR(name=u'plmn-specificBS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_E._val = b'\xde'
    
    #-----< plmn-specificBS-F >-----#
    plmn_specificBS_F = OCT_STR(name=u'plmn-specificBS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_F._val = b'\xdf'
    
    _all_ = [
        BearerServiceCode,
        Ext_BearerServiceCode,
        allBearerServices,
        allDataCDA_Services,
        dataCDA_300bps,
        dataCDA_1200bps,
        dataCDA_1200_75bps,
        dataCDA_2400bps,
        dataCDA_4800bps,
        dataCDA_9600bps,
        general_dataCDA,
        allDataCDS_Services,
        dataCDS_1200bps,
        dataCDS_2400bps,
        dataCDS_4800bps,
        dataCDS_9600bps,
        general_dataCDS,
        allPadAccessCA_Services,
        padAccessCA_300bps,
        padAccessCA_1200bps,
        padAccessCA_1200_75bps,
        padAccessCA_2400bps,
        padAccessCA_4800bps,
        padAccessCA_9600bps,
        general_padAccessCA,
        allDataPDS_Services,
        dataPDS_2400bps,
        dataPDS_4800bps,
        dataPDS_9600bps,
        general_dataPDS,
        allAlternateSpeech_DataCDA,
        allAlternateSpeech_DataCDS,
        allSpeechFollowedByDataCDA,
        allSpeechFollowedByDataCDS,
        allDataCircuitAsynchronous,
        allAsynchronousServices,
        allDataCircuitSynchronous,
        allSynchronousServices,
        allPLMN_specificBS,
        plmn_specificBS_1,
        plmn_specificBS_2,
        plmn_specificBS_3,
        plmn_specificBS_4,
        plmn_specificBS_5,
        plmn_specificBS_6,
        plmn_specificBS_7,
        plmn_specificBS_8,
        plmn_specificBS_9,
        plmn_specificBS_A,
        plmn_specificBS_B,
        plmn_specificBS_C,
        plmn_specificBS_D,
        plmn_specificBS_E,
        plmn_specificBS_F,
    ]

class MAP_CH_DataTypes:

    _name_  = u'MAP-CH-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 13, 19]
    
    _obj_ = [
        u'CUG-CheckInfo',
        u'NumberOfForwarding',
        u'SendRoutingInfoArg',
        u'SuppressionOfAnnouncement',
        u'SuppressMTSS',
        u'InterrogationType',
        u'OR-Phase',
        u'CallReferenceNumber',
        u'ForwardingReason',
        u'SupportedCCBS-Phase',
        u'CallDiversionTreatmentIndicator',
        u'SendRoutingInfoRes',
        u'AllowedServices',
        u'UnavailabilityCause',
        u'CCBS-Indicators',
        u'RoutingInfo',
        u'ForwardingData',
        u'ProvideRoamingNumberArg',
        u'ProvideRoamingNumberRes',
        u'ResumeCallHandlingArg',
        u'UU-Data',
        u'UUIndicator',
        u'UUI',
        u'ResumeCallHandlingRes',
        u'CamelInfo',
        u'ExtendedRoutingInfo',
        u'CamelRoutingInfo',
        u'GmscCamelSubscriptionInfo',
        u'SetReportingStateArg',
        u'ReportingState',
        u'SetReportingStateRes',
        u'CCBS-SubscriberStatus',
        u'StatusReportArg',
        u'EventReportData',
        u'CallReportData',
        u'MonitoringMode',
        u'CallOutcome',
        u'StatusReportRes',
        u'RemoteUserFreeArg',
        u'RemoteUserFreeRes',
        u'RUF-Outcome',
        u'IST-AlertArg',
        u'IST-AlertRes',
        u'IST-CommandArg',
        u'IST-CommandRes',
        u'CallTerminationIndicator',
        u'ReleaseResourcesArg',
        u'ReleaseResourcesRes',
        ]
    _type_ = [
        u'CUG-CheckInfo',
        u'NumberOfForwarding',
        u'SendRoutingInfoArg',
        u'SuppressionOfAnnouncement',
        u'SuppressMTSS',
        u'InterrogationType',
        u'OR-Phase',
        u'CallReferenceNumber',
        u'ForwardingReason',
        u'SupportedCCBS-Phase',
        u'CallDiversionTreatmentIndicator',
        u'SendRoutingInfoRes',
        u'AllowedServices',
        u'UnavailabilityCause',
        u'CCBS-Indicators',
        u'RoutingInfo',
        u'ForwardingData',
        u'ProvideRoamingNumberArg',
        u'ProvideRoamingNumberRes',
        u'ResumeCallHandlingArg',
        u'UU-Data',
        u'UUIndicator',
        u'UUI',
        u'ResumeCallHandlingRes',
        u'CamelInfo',
        u'ExtendedRoutingInfo',
        u'CamelRoutingInfo',
        u'GmscCamelSubscriptionInfo',
        u'SetReportingStateArg',
        u'ReportingState',
        u'SetReportingStateRes',
        u'CCBS-SubscriberStatus',
        u'StatusReportArg',
        u'EventReportData',
        u'CallReportData',
        u'MonitoringMode',
        u'CallOutcome',
        u'StatusReportRes',
        u'RemoteUserFreeArg',
        u'RemoteUserFreeRes',
        u'RUF-Outcome',
        u'IST-AlertArg',
        u'IST-AlertRes',
        u'IST-CommandArg',
        u'IST-CommandRes',
        u'CallTerminationIndicator',
        u'ReleaseResourcesArg',
        u'ReleaseResourcesRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CUG-CheckInfo >-----#
    CUG_CheckInfo = SEQ(name=u'CUG-CheckInfo', mode=MODE_TYPE)
    _CUG_CheckInfo_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_CheckInfo_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, opt=True)
    _CUG_CheckInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_CheckInfo._cont = ASN1Dict([
        (u'cug-Interlock', _CUG_CheckInfo_cug_Interlock),
        (u'cug-OutgoingAccess', _CUG_CheckInfo_cug_OutgoingAccess),
        (u'extensionContainer', _CUG_CheckInfo_extensionContainer),
        ])
    CUG_CheckInfo._ext = []
    
    #-----< NumberOfForwarding >-----#
    NumberOfForwarding = INT(name=u'NumberOfForwarding', mode=MODE_TYPE)
    NumberOfForwarding._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< SendRoutingInfoArg >-----#
    SendRoutingInfoArg = SEQ(name=u'SendRoutingInfoArg', mode=MODE_TYPE)
    _SendRoutingInfoArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_cug_CheckInfo = SEQ(name=u'cug-CheckInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoArg_numberOfForwarding = INT(name=u'numberOfForwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    _SendRoutingInfoArg_interrogationType = ENUM(name=u'interrogationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'InterrogationType')))
    _SendRoutingInfoArg_or_Interrogation = NULL(name=u'or-Interrogation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_or_Capability = INT(name=u'or-Capability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'OR-Phase')), opt=True)
    _SendRoutingInfoArg_gmsc_OrGsmSCF_Address = OCT_STR(name=u'gmsc-OrGsmSCF-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _SendRoutingInfoArg_forwardingReason = ENUM(name=u'forwardingReason', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingReason')), opt=True)
    _SendRoutingInfoArg_basicServiceGroup = CHOICE(name=u'basicServiceGroup', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo = SEQ(name=u'networkSignalInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_camelInfo = SEQ(name=u'camelInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelInfo')), opt=True)
    _SendRoutingInfoArg_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _SendRoutingInfoArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoArg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _SendRoutingInfoArg_ccbs_Call = NULL(name=u'ccbs-Call', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_supportedCCBS_Phase = INT(name=u'supportedCCBS-Phase', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SupportedCCBS-Phase')), opt=True)
    _SendRoutingInfoArg_additionalSignalInfo = SEQ(name=u'additionalSignalInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_istSupportIndicator = ENUM(name=u'istSupportIndicator', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _SendRoutingInfoArg_pre_pagingSupported = NULL(name=u'pre-pagingSupported', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callDiversionTreatmentIndicator = OCT_STR(name=u'callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallDiversionTreatmentIndicator')), opt=True)
    _SendRoutingInfoArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppress_VT_CSI = NULL(name=u'suppress-VT-CSI', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppressIncomingCallBarring = NULL(name=u'suppressIncomingCallBarring', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_gsmSCF_InitiatedCall = NULL(name=u'gsmSCF-InitiatedCall', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_basicServiceGroup2 = CHOICE(name=u'basicServiceGroup2', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo2 = SEQ(name=u'networkSignalInfo2', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_suppressMTSS = BIT_STR(name=u'suppressMTSS', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressMTSS')), opt=True)
    _SendRoutingInfoArg_mtRoamingRetrySupported = NULL(name=u'mtRoamingRetrySupported', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callPriority = INT(name=u'callPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    SendRoutingInfoArg._cont = ASN1Dict([
        (u'msisdn', _SendRoutingInfoArg_msisdn),
        (u'cug-CheckInfo', _SendRoutingInfoArg_cug_CheckInfo),
        (u'numberOfForwarding', _SendRoutingInfoArg_numberOfForwarding),
        (u'interrogationType', _SendRoutingInfoArg_interrogationType),
        (u'or-Interrogation', _SendRoutingInfoArg_or_Interrogation),
        (u'or-Capability', _SendRoutingInfoArg_or_Capability),
        (u'gmsc-OrGsmSCF-Address', _SendRoutingInfoArg_gmsc_OrGsmSCF_Address),
        (u'callReferenceNumber', _SendRoutingInfoArg_callReferenceNumber),
        (u'forwardingReason', _SendRoutingInfoArg_forwardingReason),
        (u'basicServiceGroup', _SendRoutingInfoArg_basicServiceGroup),
        (u'networkSignalInfo', _SendRoutingInfoArg_networkSignalInfo),
        (u'camelInfo', _SendRoutingInfoArg_camelInfo),
        (u'suppressionOfAnnouncement', _SendRoutingInfoArg_suppressionOfAnnouncement),
        (u'extensionContainer', _SendRoutingInfoArg_extensionContainer),
        (u'alertingPattern', _SendRoutingInfoArg_alertingPattern),
        (u'ccbs-Call', _SendRoutingInfoArg_ccbs_Call),
        (u'supportedCCBS-Phase', _SendRoutingInfoArg_supportedCCBS_Phase),
        (u'additionalSignalInfo', _SendRoutingInfoArg_additionalSignalInfo),
        (u'istSupportIndicator', _SendRoutingInfoArg_istSupportIndicator),
        (u'pre-pagingSupported', _SendRoutingInfoArg_pre_pagingSupported),
        (u'callDiversionTreatmentIndicator', _SendRoutingInfoArg_callDiversionTreatmentIndicator),
        (u'longFTN-Supported', _SendRoutingInfoArg_longFTN_Supported),
        (u'suppress-VT-CSI', _SendRoutingInfoArg_suppress_VT_CSI),
        (u'suppressIncomingCallBarring', _SendRoutingInfoArg_suppressIncomingCallBarring),
        (u'gsmSCF-InitiatedCall', _SendRoutingInfoArg_gsmSCF_InitiatedCall),
        (u'basicServiceGroup2', _SendRoutingInfoArg_basicServiceGroup2),
        (u'networkSignalInfo2', _SendRoutingInfoArg_networkSignalInfo2),
        (u'suppressMTSS', _SendRoutingInfoArg_suppressMTSS),
        (u'mtRoamingRetrySupported', _SendRoutingInfoArg_mtRoamingRetrySupported),
        (u'callPriority', _SendRoutingInfoArg_callPriority),
        ])
    SendRoutingInfoArg._ext = [u'alertingPattern', u'ccbs-Call', u'supportedCCBS-Phase', u'additionalSignalInfo', u'istSupportIndicator', u'pre-pagingSupported', u'callDiversionTreatmentIndicator', u'longFTN-Supported', u'suppress-VT-CSI', u'suppressIncomingCallBarring', u'gsmSCF-InitiatedCall', u'basicServiceGroup2', u'networkSignalInfo2', u'suppressMTSS', u'mtRoamingRetrySupported', u'callPriority']
    
    #-----< SuppressionOfAnnouncement >-----#
    SuppressionOfAnnouncement = NULL(name=u'SuppressionOfAnnouncement', mode=MODE_TYPE)
    
    #-----< SuppressMTSS >-----#
    SuppressMTSS = BIT_STR(name=u'SuppressMTSS', mode=MODE_TYPE)
    SuppressMTSS._cont = ASN1Dict([(u'suppressCUG', 0), (u'suppressCCBS', 1)])
    SuppressMTSS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< InterrogationType >-----#
    InterrogationType = ENUM(name=u'InterrogationType', mode=MODE_TYPE)
    InterrogationType._cont = ASN1Dict([(u'basicCall', 0), (u'forwarding', 1)])
    InterrogationType._ext = None
    
    #-----< OR-Phase >-----#
    OR_Phase = INT(name=u'OR-Phase', mode=MODE_TYPE)
    OR_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallReferenceNumber >-----#
    CallReferenceNumber = OCT_STR(name=u'CallReferenceNumber', mode=MODE_TYPE)
    CallReferenceNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ForwardingReason >-----#
    ForwardingReason = ENUM(name=u'ForwardingReason', mode=MODE_TYPE)
    ForwardingReason._cont = ASN1Dict([(u'notReachable', 0), (u'busy', 1), (u'noReply', 2)])
    ForwardingReason._ext = None
    
    #-----< SupportedCCBS-Phase >-----#
    SupportedCCBS_Phase = INT(name=u'SupportedCCBS-Phase', mode=MODE_TYPE)
    SupportedCCBS_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallDiversionTreatmentIndicator >-----#
    CallDiversionTreatmentIndicator = OCT_STR(name=u'CallDiversionTreatmentIndicator', mode=MODE_TYPE)
    CallDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendRoutingInfoRes >-----#
    SendRoutingInfoRes = SEQ(name=u'SendRoutingInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendRoutingInfoRes_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendRoutingInfoRes_extendedRoutingInfo = CHOICE(name=u'extendedRoutingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ExtendedRoutingInfo')), opt=True)
    _SendRoutingInfoRes_cug_CheckInfo = SEQ(name=u'cug-CheckInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoRes_cugSubscriptionFlag = NULL(name=u'cugSubscriptionFlag', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_subscriberInfo = SEQ(name=u'subscriberInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')), opt=True)
    _SendRoutingInfoRes_ss_List = SEQ_OF(name=u'ss-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_forwardingInterrogationRequired = NULL(name=u'forwardingInterrogationRequired', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_vmsc_Address = OCT_STR(name=u'vmsc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoRes_naea_PreferredCI = SEQ(name=u'naea-PreferredCI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _SendRoutingInfoRes_ccbs_Indicators = SEQ(name=u'ccbs-Indicators', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-Indicators')), opt=True)
    _SendRoutingInfoRes_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_numberPortabilityStatus = ENUM(name=u'numberPortabilityStatus', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _SendRoutingInfoRes_istAlertTimer = INT(name=u'istAlertTimer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _SendRoutingInfoRes_supportedCamelPhasesInVMSC = BIT_STR(name=u'supportedCamelPhasesInVMSC', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SendRoutingInfoRes_offeredCamel4CSIsInVMSC = BIT_STR(name=u'offeredCamel4CSIsInVMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SendRoutingInfoRes_routingInfo2 = CHOICE(name=u'routingInfo2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')), opt=True)
    _SendRoutingInfoRes_ss_List2 = SEQ_OF(name=u'ss-List2', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService2 = CHOICE(name=u'basicService2', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_allowedServices = BIT_STR(name=u'allowedServices', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'AllowedServices')), opt=True)
    _SendRoutingInfoRes_unavailabilityCause = ENUM(name=u'unavailabilityCause', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UnavailabilityCause')), opt=True)
    _SendRoutingInfoRes_releaseResourcesSupported = NULL(name=u'releaseResourcesSupported', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_gsm_BearerCapability = SEQ(name=u'gsm-BearerCapability', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    SendRoutingInfoRes._cont = ASN1Dict([
        (u'imsi', _SendRoutingInfoRes_imsi),
        (u'extendedRoutingInfo', _SendRoutingInfoRes_extendedRoutingInfo),
        (u'cug-CheckInfo', _SendRoutingInfoRes_cug_CheckInfo),
        (u'cugSubscriptionFlag', _SendRoutingInfoRes_cugSubscriptionFlag),
        (u'subscriberInfo', _SendRoutingInfoRes_subscriberInfo),
        (u'ss-List', _SendRoutingInfoRes_ss_List),
        (u'basicService', _SendRoutingInfoRes_basicService),
        (u'forwardingInterrogationRequired', _SendRoutingInfoRes_forwardingInterrogationRequired),
        (u'vmsc-Address', _SendRoutingInfoRes_vmsc_Address),
        (u'extensionContainer', _SendRoutingInfoRes_extensionContainer),
        (u'naea-PreferredCI', _SendRoutingInfoRes_naea_PreferredCI),
        (u'ccbs-Indicators', _SendRoutingInfoRes_ccbs_Indicators),
        (u'msisdn', _SendRoutingInfoRes_msisdn),
        (u'numberPortabilityStatus', _SendRoutingInfoRes_numberPortabilityStatus),
        (u'istAlertTimer', _SendRoutingInfoRes_istAlertTimer),
        (u'supportedCamelPhasesInVMSC', _SendRoutingInfoRes_supportedCamelPhasesInVMSC),
        (u'offeredCamel4CSIsInVMSC', _SendRoutingInfoRes_offeredCamel4CSIsInVMSC),
        (u'routingInfo2', _SendRoutingInfoRes_routingInfo2),
        (u'ss-List2', _SendRoutingInfoRes_ss_List2),
        (u'basicService2', _SendRoutingInfoRes_basicService2),
        (u'allowedServices', _SendRoutingInfoRes_allowedServices),
        (u'unavailabilityCause', _SendRoutingInfoRes_unavailabilityCause),
        (u'releaseResourcesSupported', _SendRoutingInfoRes_releaseResourcesSupported),
        (u'gsm-BearerCapability', _SendRoutingInfoRes_gsm_BearerCapability),
        ])
    SendRoutingInfoRes._ext = [u'naea-PreferredCI', u'ccbs-Indicators', u'msisdn', u'numberPortabilityStatus', u'istAlertTimer', u'supportedCamelPhasesInVMSC', u'offeredCamel4CSIsInVMSC', u'routingInfo2', u'ss-List2', u'basicService2', u'allowedServices', u'unavailabilityCause', u'releaseResourcesSupported', u'gsm-BearerCapability']
    
    #-----< AllowedServices >-----#
    AllowedServices = BIT_STR(name=u'AllowedServices', mode=MODE_TYPE)
    AllowedServices._cont = ASN1Dict([(u'firstServiceAllowed', 0), (u'secondServiceAllowed', 1)])
    AllowedServices._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UnavailabilityCause >-----#
    UnavailabilityCause = ENUM(name=u'UnavailabilityCause', mode=MODE_TYPE)
    UnavailabilityCause._cont = ASN1Dict([(u'bearerServiceNotProvisioned', 1), (u'teleserviceNotProvisioned', 2), (u'absentSubscriber', 3), (u'busySubscriber', 4), (u'callBarred', 5), (u'cug-Reject', 6)])
    UnavailabilityCause._ext = []
    
    #-----< CCBS-Indicators >-----#
    CCBS_Indicators = SEQ(name=u'CCBS-Indicators', mode=MODE_TYPE)
    _CCBS_Indicators_ccbs_Possible = NULL(name=u'ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_keepCCBS_CallIndicator = NULL(name=u'keepCCBS-CallIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CCBS_Indicators._cont = ASN1Dict([
        (u'ccbs-Possible', _CCBS_Indicators_ccbs_Possible),
        (u'keepCCBS-CallIndicator', _CCBS_Indicators_keepCCBS_CallIndicator),
        (u'extensionContainer', _CCBS_Indicators_extensionContainer),
        ])
    CCBS_Indicators._ext = []
    
    #-----< RoutingInfo >-----#
    RoutingInfo = CHOICE(name=u'RoutingInfo', mode=MODE_TYPE)
    _RoutingInfo_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfo_forwardingData = SEQ(name=u'forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')))
    RoutingInfo._cont = ASN1Dict([
        (u'roamingNumber', _RoutingInfo_roamingNumber),
        (u'forwardingData', _RoutingInfo_forwardingData),
        ])
    RoutingInfo._ext = None
    
    #-----< ForwardingData >-----#
    ForwardingData = SEQ(name=u'ForwardingData', mode=MODE_TYPE)
    _ForwardingData_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingData_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingData_forwardingOptions = OCT_STR(name=u'forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardingData_longForwardedToNumber = OCT_STR(name=u'longForwardedToNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingData._cont = ASN1Dict([
        (u'forwardedToNumber', _ForwardingData_forwardedToNumber),
        (u'forwardedToSubaddress', _ForwardingData_forwardedToSubaddress),
        (u'forwardingOptions', _ForwardingData_forwardingOptions),
        (u'extensionContainer', _ForwardingData_extensionContainer),
        (u'longForwardedToNumber', _ForwardingData_longForwardedToNumber),
        ])
    ForwardingData._ext = [u'longForwardedToNumber']
    
    #-----< ProvideRoamingNumberArg >-----#
    ProvideRoamingNumberArg = SEQ(name=u'ProvideRoamingNumberArg', mode=MODE_TYPE)
    _ProvideRoamingNumberArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideRoamingNumberArg_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideRoamingNumberArg_gsm_BearerCapability = SEQ(name=u'gsm-BearerCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_networkSignalInfo = SEQ(name=u'networkSignalInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _ProvideRoamingNumberArg_gmsc_Address = OCT_STR(name=u'gmsc-Address', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ProvideRoamingNumberArg_or_Interrogation = NULL(name=u'or-Interrogation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberArg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _ProvideRoamingNumberArg_ccbs_Call = NULL(name=u'ccbs-Call', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode = BIT_STR(name=u'supportedCamelPhasesInInterrogatingNode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _ProvideRoamingNumberArg_additionalSignalInfo = SEQ(name=u'additionalSignalInfo', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_orNotSupportedInGMSC = NULL(name=u'orNotSupportedInGMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pre_pagingSupported = NULL(name=u'pre-pagingSupported', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_suppress_VT_CSI = NULL(name=u'suppress-VT-CSI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode = BIT_STR(name=u'offeredCamel4CSIsInInterrogatingNode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _ProvideRoamingNumberArg_mtRoamingRetrySupported = NULL(name=u'mtRoamingRetrySupported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pagingArea = SEQ_OF(name=u'pagingArea', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _ProvideRoamingNumberArg_callPriority = INT(name=u'callPriority', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _ProvideRoamingNumberArg_mtrf_Indicator = NULL(name=u'mtrf-Indicator', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_oldMSC_Number = OCT_STR(name=u'oldMSC-Number', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lastUsedLtePLMN_Id = OCT_STR(name=u'lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    ProvideRoamingNumberArg._cont = ASN1Dict([
        (u'imsi', _ProvideRoamingNumberArg_imsi),
        (u'msc-Number', _ProvideRoamingNumberArg_msc_Number),
        (u'msisdn', _ProvideRoamingNumberArg_msisdn),
        (u'lmsi', _ProvideRoamingNumberArg_lmsi),
        (u'gsm-BearerCapability', _ProvideRoamingNumberArg_gsm_BearerCapability),
        (u'networkSignalInfo', _ProvideRoamingNumberArg_networkSignalInfo),
        (u'suppressionOfAnnouncement', _ProvideRoamingNumberArg_suppressionOfAnnouncement),
        (u'gmsc-Address', _ProvideRoamingNumberArg_gmsc_Address),
        (u'callReferenceNumber', _ProvideRoamingNumberArg_callReferenceNumber),
        (u'or-Interrogation', _ProvideRoamingNumberArg_or_Interrogation),
        (u'extensionContainer', _ProvideRoamingNumberArg_extensionContainer),
        (u'alertingPattern', _ProvideRoamingNumberArg_alertingPattern),
        (u'ccbs-Call', _ProvideRoamingNumberArg_ccbs_Call),
        (u'supportedCamelPhasesInInterrogatingNode', _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode),
        (u'additionalSignalInfo', _ProvideRoamingNumberArg_additionalSignalInfo),
        (u'orNotSupportedInGMSC', _ProvideRoamingNumberArg_orNotSupportedInGMSC),
        (u'pre-pagingSupported', _ProvideRoamingNumberArg_pre_pagingSupported),
        (u'longFTN-Supported', _ProvideRoamingNumberArg_longFTN_Supported),
        (u'suppress-VT-CSI', _ProvideRoamingNumberArg_suppress_VT_CSI),
        (u'offeredCamel4CSIsInInterrogatingNode', _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode),
        (u'mtRoamingRetrySupported', _ProvideRoamingNumberArg_mtRoamingRetrySupported),
        (u'pagingArea', _ProvideRoamingNumberArg_pagingArea),
        (u'callPriority', _ProvideRoamingNumberArg_callPriority),
        (u'mtrf-Indicator', _ProvideRoamingNumberArg_mtrf_Indicator),
        (u'oldMSC-Number', _ProvideRoamingNumberArg_oldMSC_Number),
        (u'lastUsedLtePLMN-Id', _ProvideRoamingNumberArg_lastUsedLtePLMN_Id),
        ])
    ProvideRoamingNumberArg._ext = [u'alertingPattern', u'ccbs-Call', u'supportedCamelPhasesInInterrogatingNode', u'additionalSignalInfo', u'orNotSupportedInGMSC', u'pre-pagingSupported', u'longFTN-Supported', u'suppress-VT-CSI', u'offeredCamel4CSIsInInterrogatingNode', u'mtRoamingRetrySupported', u'pagingArea', u'callPriority', u'mtrf-Indicator', u'oldMSC-Number', u'lastUsedLtePLMN-Id']
    
    #-----< ProvideRoamingNumberRes >-----#
    ProvideRoamingNumberRes = SEQ(name=u'ProvideRoamingNumberRes', mode=MODE_TYPE)
    _ProvideRoamingNumberRes_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberRes_releaseResourcesSupported = NULL(name=u'releaseResourcesSupported', mode=MODE_TYPE, opt=True)
    _ProvideRoamingNumberRes_vmsc_Address = OCT_STR(name=u'vmsc-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ProvideRoamingNumberRes._cont = ASN1Dict([
        (u'roamingNumber', _ProvideRoamingNumberRes_roamingNumber),
        (u'extensionContainer', _ProvideRoamingNumberRes_extensionContainer),
        (u'releaseResourcesSupported', _ProvideRoamingNumberRes_releaseResourcesSupported),
        (u'vmsc-Address', _ProvideRoamingNumberRes_vmsc_Address),
        ])
    ProvideRoamingNumberRes._ext = [u'releaseResourcesSupported', u'vmsc-Address']
    
    #-----< ResumeCallHandlingArg >-----#
    ResumeCallHandlingArg = SEQ(name=u'ResumeCallHandlingArg', mode=MODE_TYPE)
    _ResumeCallHandlingArg_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup = CHOICE(name=u'basicServiceGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_forwardingData = SEQ(name=u'forwardingData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _ResumeCallHandlingArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ResumeCallHandlingArg_cug_CheckInfo = SEQ(name=u'cug-CheckInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _ResumeCallHandlingArg_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _ResumeCallHandlingArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResumeCallHandlingArg_ccbs_Possible = NULL(name=u'ccbs-Possible', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ResumeCallHandlingArg_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    _ResumeCallHandlingArg_allInformationSent = NULL(name=u'allInformationSent', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_d_csi = SEQ(name=u'd-csi', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList = SEQ_OF(name=u'o-BcsmCamelTDPCriteriaList', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup2 = CHOICE(name=u'basicServiceGroup2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_mtRoamingRetry = NULL(name=u'mtRoamingRetry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ResumeCallHandlingArg._cont = ASN1Dict([
        (u'callReferenceNumber', _ResumeCallHandlingArg_callReferenceNumber),
        (u'basicServiceGroup', _ResumeCallHandlingArg_basicServiceGroup),
        (u'forwardingData', _ResumeCallHandlingArg_forwardingData),
        (u'imsi', _ResumeCallHandlingArg_imsi),
        (u'cug-CheckInfo', _ResumeCallHandlingArg_cug_CheckInfo),
        (u'o-CSI', _ResumeCallHandlingArg_o_CSI),
        (u'extensionContainer', _ResumeCallHandlingArg_extensionContainer),
        (u'ccbs-Possible', _ResumeCallHandlingArg_ccbs_Possible),
        (u'msisdn', _ResumeCallHandlingArg_msisdn),
        (u'uu-Data', _ResumeCallHandlingArg_uu_Data),
        (u'allInformationSent', _ResumeCallHandlingArg_allInformationSent),
        (u'd-csi', _ResumeCallHandlingArg_d_csi),
        (u'o-BcsmCamelTDPCriteriaList', _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList),
        (u'basicServiceGroup2', _ResumeCallHandlingArg_basicServiceGroup2),
        (u'mtRoamingRetry', _ResumeCallHandlingArg_mtRoamingRetry),
        ])
    ResumeCallHandlingArg._ext = [u'd-csi', u'o-BcsmCamelTDPCriteriaList', u'basicServiceGroup2', u'mtRoamingRetry']
    
    #-----< UU-Data >-----#
    UU_Data = SEQ(name=u'UU-Data', mode=MODE_TYPE)
    _UU_Data_uuIndicator = OCT_STR(name=u'uuIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUIndicator')), opt=True)
    _UU_Data_uui = OCT_STR(name=u'uui', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUI')), opt=True)
    _UU_Data_uusCFInteraction = NULL(name=u'uusCFInteraction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UU_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UU_Data._cont = ASN1Dict([
        (u'uuIndicator', _UU_Data_uuIndicator),
        (u'uui', _UU_Data_uui),
        (u'uusCFInteraction', _UU_Data_uusCFInteraction),
        (u'extensionContainer', _UU_Data_extensionContainer),
        ])
    UU_Data._ext = []
    
    #-----< UUIndicator >-----#
    UUIndicator = OCT_STR(name=u'UUIndicator', mode=MODE_TYPE)
    UUIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< UUI >-----#
    UUI = OCT_STR(name=u'UUI', mode=MODE_TYPE)
    UUI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131)], ev=None, er=[])
    
    #-----< ResumeCallHandlingRes >-----#
    ResumeCallHandlingRes = SEQ(name=u'ResumeCallHandlingRes', mode=MODE_TYPE)
    _ResumeCallHandlingRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResumeCallHandlingRes._cont = ASN1Dict([
        (u'extensionContainer', _ResumeCallHandlingRes_extensionContainer),
        ])
    ResumeCallHandlingRes._ext = []
    
    #-----< CamelInfo >-----#
    CamelInfo = SEQ(name=u'CamelInfo', mode=MODE_TYPE)
    _CamelInfo_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')))
    _CamelInfo_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, opt=True)
    _CamelInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CamelInfo_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    CamelInfo._cont = ASN1Dict([
        (u'supportedCamelPhases', _CamelInfo_supportedCamelPhases),
        (u'suppress-T-CSI', _CamelInfo_suppress_T_CSI),
        (u'extensionContainer', _CamelInfo_extensionContainer),
        (u'offeredCamel4CSIs', _CamelInfo_offeredCamel4CSIs),
        ])
    CamelInfo._ext = [u'offeredCamel4CSIs']
    
    #-----< ExtendedRoutingInfo >-----#
    ExtendedRoutingInfo = CHOICE(name=u'ExtendedRoutingInfo', mode=MODE_TYPE)
    _ExtendedRoutingInfo_routingInfo = CHOICE(name=u'routingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')))
    _ExtendedRoutingInfo_camelRoutingInfo = SEQ(name=u'camelRoutingInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelRoutingInfo')))
    ExtendedRoutingInfo._cont = ASN1Dict([
        (u'routingInfo', _ExtendedRoutingInfo_routingInfo),
        (u'camelRoutingInfo', _ExtendedRoutingInfo_camelRoutingInfo),
        ])
    ExtendedRoutingInfo._ext = None
    
    #-----< CamelRoutingInfo >-----#
    CamelRoutingInfo = SEQ(name=u'CamelRoutingInfo', mode=MODE_TYPE)
    _CamelRoutingInfo_forwardingData = SEQ(name=u'forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _CamelRoutingInfo_gmscCamelSubscriptionInfo = SEQ(name=u'gmscCamelSubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'GmscCamelSubscriptionInfo')))
    _CamelRoutingInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CamelRoutingInfo._cont = ASN1Dict([
        (u'forwardingData', _CamelRoutingInfo_forwardingData),
        (u'gmscCamelSubscriptionInfo', _CamelRoutingInfo_gmscCamelSubscriptionInfo),
        (u'extensionContainer', _CamelRoutingInfo_extensionContainer),
        ])
    CamelRoutingInfo._ext = []
    
    #-----< GmscCamelSubscriptionInfo >-----#
    GmscCamelSubscriptionInfo = SEQ(name=u'GmscCamelSubscriptionInfo', mode=MODE_TYPE)
    _GmscCamelSubscriptionInfo_t_CSI = SEQ(name=u't-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u't-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_d_csi = SEQ(name=u'd-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    GmscCamelSubscriptionInfo._cont = ASN1Dict([
        (u't-CSI', _GmscCamelSubscriptionInfo_t_CSI),
        (u'o-CSI', _GmscCamelSubscriptionInfo_o_CSI),
        (u'extensionContainer', _GmscCamelSubscriptionInfo_extensionContainer),
        (u'o-BcsmCamelTDP-CriteriaList', _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        (u't-BCSM-CAMEL-TDP-CriteriaList', _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        (u'd-csi', _GmscCamelSubscriptionInfo_d_csi),
        ])
    GmscCamelSubscriptionInfo._ext = [u'o-BcsmCamelTDP-CriteriaList', u't-BCSM-CAMEL-TDP-CriteriaList', u'd-csi']
    
    #-----< SetReportingStateArg >-----#
    SetReportingStateArg = SEQ(name=u'SetReportingStateArg', mode=MODE_TYPE)
    _SetReportingStateArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SetReportingStateArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _SetReportingStateArg_ccbs_Monitoring = ENUM(name=u'ccbs-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ReportingState')), opt=True)
    _SetReportingStateArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateArg._cont = ASN1Dict([
        (u'imsi', _SetReportingStateArg_imsi),
        (u'lmsi', _SetReportingStateArg_lmsi),
        (u'ccbs-Monitoring', _SetReportingStateArg_ccbs_Monitoring),
        (u'extensionContainer', _SetReportingStateArg_extensionContainer),
        ])
    SetReportingStateArg._ext = []
    
    #-----< ReportingState >-----#
    ReportingState = ENUM(name=u'ReportingState', mode=MODE_TYPE)
    ReportingState._cont = ASN1Dict([(u'stopMonitoring', 0), (u'startMonitoring', 1)])
    ReportingState._ext = []
    
    #-----< SetReportingStateRes >-----#
    SetReportingStateRes = SEQ(name=u'SetReportingStateRes', mode=MODE_TYPE)
    _SetReportingStateRes_ccbs_SubscriberStatus = ENUM(name=u'ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _SetReportingStateRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateRes._cont = ASN1Dict([
        (u'ccbs-SubscriberStatus', _SetReportingStateRes_ccbs_SubscriberStatus),
        (u'extensionContainer', _SetReportingStateRes_extensionContainer),
        ])
    SetReportingStateRes._ext = []
    
    #-----< CCBS-SubscriberStatus >-----#
    CCBS_SubscriberStatus = ENUM(name=u'CCBS-SubscriberStatus', mode=MODE_TYPE)
    CCBS_SubscriberStatus._cont = ASN1Dict([(u'ccbsNotIdle', 0), (u'ccbsIdle', 1), (u'ccbsNotReachable', 2)])
    CCBS_SubscriberStatus._ext = []
    
    #-----< StatusReportArg >-----#
    StatusReportArg = SEQ(name=u'StatusReportArg', mode=MODE_TYPE)
    _StatusReportArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _StatusReportArg_eventReportData = SEQ(name=u'eventReportData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'EventReportData')), opt=True)
    _StatusReportArg_callReportdata = SEQ(name=u'callReportdata', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReportData')), opt=True)
    _StatusReportArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportArg._cont = ASN1Dict([
        (u'imsi', _StatusReportArg_imsi),
        (u'eventReportData', _StatusReportArg_eventReportData),
        (u'callReportdata', _StatusReportArg_callReportdata),
        (u'extensionContainer', _StatusReportArg_extensionContainer),
        ])
    StatusReportArg._ext = []
    
    #-----< EventReportData >-----#
    EventReportData = SEQ(name=u'EventReportData', mode=MODE_TYPE)
    _EventReportData_ccbs_SubscriberStatus = ENUM(name=u'ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _EventReportData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EventReportData._cont = ASN1Dict([
        (u'ccbs-SubscriberStatus', _EventReportData_ccbs_SubscriberStatus),
        (u'extensionContainer', _EventReportData_extensionContainer),
        ])
    EventReportData._ext = []
    
    #-----< CallReportData >-----#
    CallReportData = SEQ(name=u'CallReportData', mode=MODE_TYPE)
    _CallReportData_monitoringMode = ENUM(name=u'monitoringMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'MonitoringMode')), opt=True)
    _CallReportData_callOutcome = ENUM(name=u'callOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallOutcome')), opt=True)
    _CallReportData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallReportData._cont = ASN1Dict([
        (u'monitoringMode', _CallReportData_monitoringMode),
        (u'callOutcome', _CallReportData_callOutcome),
        (u'extensionContainer', _CallReportData_extensionContainer),
        ])
    CallReportData._ext = []
    
    #-----< MonitoringMode >-----#
    MonitoringMode = ENUM(name=u'MonitoringMode', mode=MODE_TYPE)
    MonitoringMode._cont = ASN1Dict([(u'a-side', 0), (u'b-side', 1)])
    MonitoringMode._ext = []
    
    #-----< CallOutcome >-----#
    CallOutcome = ENUM(name=u'CallOutcome', mode=MODE_TYPE)
    CallOutcome._cont = ASN1Dict([(u'success', 0), (u'failure', 1), (u'busy', 2)])
    CallOutcome._ext = []
    
    #-----< StatusReportRes >-----#
    StatusReportRes = SEQ(name=u'StatusReportRes', mode=MODE_TYPE)
    _StatusReportRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportRes._cont = ASN1Dict([
        (u'extensionContainer', _StatusReportRes_extensionContainer),
        ])
    StatusReportRes._ext = []
    
    #-----< RemoteUserFreeArg >-----#
    RemoteUserFreeArg = SEQ(name=u'RemoteUserFreeArg', mode=MODE_TYPE)
    _RemoteUserFreeArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RemoteUserFreeArg_callInfo = SEQ(name=u'callInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _RemoteUserFreeArg_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _RemoteUserFreeArg_translatedB_Number = OCT_STR(name=u'translatedB-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RemoteUserFreeArg_replaceB_Number = NULL(name=u'replaceB-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RemoteUserFreeArg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _RemoteUserFreeArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeArg._cont = ASN1Dict([
        (u'imsi', _RemoteUserFreeArg_imsi),
        (u'callInfo', _RemoteUserFreeArg_callInfo),
        (u'ccbs-Feature', _RemoteUserFreeArg_ccbs_Feature),
        (u'translatedB-Number', _RemoteUserFreeArg_translatedB_Number),
        (u'replaceB-Number', _RemoteUserFreeArg_replaceB_Number),
        (u'alertingPattern', _RemoteUserFreeArg_alertingPattern),
        (u'extensionContainer', _RemoteUserFreeArg_extensionContainer),
        ])
    RemoteUserFreeArg._ext = []
    
    #-----< RemoteUserFreeRes >-----#
    RemoteUserFreeRes = SEQ(name=u'RemoteUserFreeRes', mode=MODE_TYPE)
    _RemoteUserFreeRes_ruf_Outcome = ENUM(name=u'ruf-Outcome', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RUF-Outcome')))
    _RemoteUserFreeRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeRes._cont = ASN1Dict([
        (u'ruf-Outcome', _RemoteUserFreeRes_ruf_Outcome),
        (u'extensionContainer', _RemoteUserFreeRes_extensionContainer),
        ])
    RemoteUserFreeRes._ext = []
    
    #-----< RUF-Outcome >-----#
    RUF_Outcome = ENUM(name=u'RUF-Outcome', mode=MODE_TYPE)
    RUF_Outcome._cont = ASN1Dict([(u'accepted', 0), (u'rejected', 1), (u'noResponseFromFreeMS', 2), (u'noResponseFromBusyMS', 3), (u'udubFromFreeMS', 4), (u'udubFromBusyMS', 5)])
    RUF_Outcome._ext = []
    
    #-----< IST-AlertArg >-----#
    IST_AlertArg = SEQ(name=u'IST-AlertArg', mode=MODE_TYPE)
    _IST_AlertArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_AlertArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertArg._cont = ASN1Dict([
        (u'imsi', _IST_AlertArg_imsi),
        (u'extensionContainer', _IST_AlertArg_extensionContainer),
        ])
    IST_AlertArg._ext = []
    
    #-----< IST-AlertRes >-----#
    IST_AlertRes = SEQ(name=u'IST-AlertRes', mode=MODE_TYPE)
    _IST_AlertRes_istAlertTimer = INT(name=u'istAlertTimer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _IST_AlertRes_istInformationWithdraw = NULL(name=u'istInformationWithdraw', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IST_AlertRes_callTerminationIndicator = ENUM(name=u'callTerminationIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallTerminationIndicator')), opt=True)
    _IST_AlertRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertRes._cont = ASN1Dict([
        (u'istAlertTimer', _IST_AlertRes_istAlertTimer),
        (u'istInformationWithdraw', _IST_AlertRes_istInformationWithdraw),
        (u'callTerminationIndicator', _IST_AlertRes_callTerminationIndicator),
        (u'extensionContainer', _IST_AlertRes_extensionContainer),
        ])
    IST_AlertRes._ext = []
    
    #-----< IST-CommandArg >-----#
    IST_CommandArg = SEQ(name=u'IST-CommandArg', mode=MODE_TYPE)
    _IST_CommandArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_CommandArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandArg._cont = ASN1Dict([
        (u'imsi', _IST_CommandArg_imsi),
        (u'extensionContainer', _IST_CommandArg_extensionContainer),
        ])
    IST_CommandArg._ext = []
    
    #-----< IST-CommandRes >-----#
    IST_CommandRes = SEQ(name=u'IST-CommandRes', mode=MODE_TYPE)
    _IST_CommandRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandRes._cont = ASN1Dict([
        (u'extensionContainer', _IST_CommandRes_extensionContainer),
        ])
    IST_CommandRes._ext = []
    
    #-----< CallTerminationIndicator >-----#
    CallTerminationIndicator = ENUM(name=u'CallTerminationIndicator', mode=MODE_TYPE)
    CallTerminationIndicator._cont = ASN1Dict([(u'terminateCallActivityReferred', 0), (u'terminateAllCallActivities', 1)])
    CallTerminationIndicator._ext = []
    
    #-----< ReleaseResourcesArg >-----#
    ReleaseResourcesArg = SEQ(name=u'ReleaseResourcesArg', mode=MODE_TYPE)
    _ReleaseResourcesArg_msrn = OCT_STR(name=u'msrn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ReleaseResourcesArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesArg._cont = ASN1Dict([
        (u'msrn', _ReleaseResourcesArg_msrn),
        (u'extensionContainer', _ReleaseResourcesArg_extensionContainer),
        ])
    ReleaseResourcesArg._ext = []
    
    #-----< ReleaseResourcesRes >-----#
    ReleaseResourcesRes = SEQ(name=u'ReleaseResourcesRes', mode=MODE_TYPE)
    _ReleaseResourcesRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesRes._cont = ASN1Dict([
        (u'extensionContainer', _ReleaseResourcesRes_extensionContainer),
        ])
    ReleaseResourcesRes._ext = []
    
    _all_ = [
        _CUG_CheckInfo_cug_Interlock,
        _CUG_CheckInfo_cug_OutgoingAccess,
        _CUG_CheckInfo_extensionContainer,
        CUG_CheckInfo,
        NumberOfForwarding,
        _SendRoutingInfoArg_msisdn,
        _SendRoutingInfoArg_cug_CheckInfo,
        _SendRoutingInfoArg_numberOfForwarding,
        _SendRoutingInfoArg_interrogationType,
        _SendRoutingInfoArg_or_Interrogation,
        _SendRoutingInfoArg_or_Capability,
        _SendRoutingInfoArg_gmsc_OrGsmSCF_Address,
        _SendRoutingInfoArg_callReferenceNumber,
        _SendRoutingInfoArg_forwardingReason,
        _SendRoutingInfoArg_basicServiceGroup,
        _SendRoutingInfoArg_networkSignalInfo,
        _SendRoutingInfoArg_camelInfo,
        _SendRoutingInfoArg_suppressionOfAnnouncement,
        _SendRoutingInfoArg_extensionContainer,
        _SendRoutingInfoArg_alertingPattern,
        _SendRoutingInfoArg_ccbs_Call,
        _SendRoutingInfoArg_supportedCCBS_Phase,
        _SendRoutingInfoArg_additionalSignalInfo,
        _SendRoutingInfoArg_istSupportIndicator,
        _SendRoutingInfoArg_pre_pagingSupported,
        _SendRoutingInfoArg_callDiversionTreatmentIndicator,
        _SendRoutingInfoArg_longFTN_Supported,
        _SendRoutingInfoArg_suppress_VT_CSI,
        _SendRoutingInfoArg_suppressIncomingCallBarring,
        _SendRoutingInfoArg_gsmSCF_InitiatedCall,
        _SendRoutingInfoArg_basicServiceGroup2,
        _SendRoutingInfoArg_networkSignalInfo2,
        _SendRoutingInfoArg_suppressMTSS,
        _SendRoutingInfoArg_mtRoamingRetrySupported,
        _SendRoutingInfoArg_callPriority,
        SendRoutingInfoArg,
        SuppressionOfAnnouncement,
        SuppressMTSS,
        InterrogationType,
        OR_Phase,
        CallReferenceNumber,
        ForwardingReason,
        SupportedCCBS_Phase,
        CallDiversionTreatmentIndicator,
        _SendRoutingInfoRes_imsi,
        _SendRoutingInfoRes_extendedRoutingInfo,
        _SendRoutingInfoRes_cug_CheckInfo,
        _SendRoutingInfoRes_cugSubscriptionFlag,
        _SendRoutingInfoRes_subscriberInfo,
        _SendRoutingInfoRes_ss_List,
        _SendRoutingInfoRes_basicService,
        _SendRoutingInfoRes_forwardingInterrogationRequired,
        _SendRoutingInfoRes_vmsc_Address,
        _SendRoutingInfoRes_extensionContainer,
        _SendRoutingInfoRes_naea_PreferredCI,
        _SendRoutingInfoRes_ccbs_Indicators,
        _SendRoutingInfoRes_msisdn,
        _SendRoutingInfoRes_numberPortabilityStatus,
        _SendRoutingInfoRes_istAlertTimer,
        _SendRoutingInfoRes_supportedCamelPhasesInVMSC,
        _SendRoutingInfoRes_offeredCamel4CSIsInVMSC,
        _SendRoutingInfoRes_routingInfo2,
        _SendRoutingInfoRes_ss_List2,
        _SendRoutingInfoRes_basicService2,
        _SendRoutingInfoRes_allowedServices,
        _SendRoutingInfoRes_unavailabilityCause,
        _SendRoutingInfoRes_releaseResourcesSupported,
        _SendRoutingInfoRes_gsm_BearerCapability,
        SendRoutingInfoRes,
        AllowedServices,
        UnavailabilityCause,
        _CCBS_Indicators_ccbs_Possible,
        _CCBS_Indicators_keepCCBS_CallIndicator,
        _CCBS_Indicators_extensionContainer,
        CCBS_Indicators,
        _RoutingInfo_roamingNumber,
        _RoutingInfo_forwardingData,
        RoutingInfo,
        _ForwardingData_forwardedToNumber,
        _ForwardingData_forwardedToSubaddress,
        _ForwardingData_forwardingOptions,
        _ForwardingData_extensionContainer,
        _ForwardingData_longForwardedToNumber,
        ForwardingData,
        _ProvideRoamingNumberArg_imsi,
        _ProvideRoamingNumberArg_msc_Number,
        _ProvideRoamingNumberArg_msisdn,
        _ProvideRoamingNumberArg_lmsi,
        _ProvideRoamingNumberArg_gsm_BearerCapability,
        _ProvideRoamingNumberArg_networkSignalInfo,
        _ProvideRoamingNumberArg_suppressionOfAnnouncement,
        _ProvideRoamingNumberArg_gmsc_Address,
        _ProvideRoamingNumberArg_callReferenceNumber,
        _ProvideRoamingNumberArg_or_Interrogation,
        _ProvideRoamingNumberArg_extensionContainer,
        _ProvideRoamingNumberArg_alertingPattern,
        _ProvideRoamingNumberArg_ccbs_Call,
        _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode,
        _ProvideRoamingNumberArg_additionalSignalInfo,
        _ProvideRoamingNumberArg_orNotSupportedInGMSC,
        _ProvideRoamingNumberArg_pre_pagingSupported,
        _ProvideRoamingNumberArg_longFTN_Supported,
        _ProvideRoamingNumberArg_suppress_VT_CSI,
        _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode,
        _ProvideRoamingNumberArg_mtRoamingRetrySupported,
        _ProvideRoamingNumberArg_pagingArea,
        _ProvideRoamingNumberArg_callPriority,
        _ProvideRoamingNumberArg_mtrf_Indicator,
        _ProvideRoamingNumberArg_oldMSC_Number,
        _ProvideRoamingNumberArg_lastUsedLtePLMN_Id,
        ProvideRoamingNumberArg,
        _ProvideRoamingNumberRes_roamingNumber,
        _ProvideRoamingNumberRes_extensionContainer,
        _ProvideRoamingNumberRes_releaseResourcesSupported,
        _ProvideRoamingNumberRes_vmsc_Address,
        ProvideRoamingNumberRes,
        _ResumeCallHandlingArg_callReferenceNumber,
        _ResumeCallHandlingArg_basicServiceGroup,
        _ResumeCallHandlingArg_forwardingData,
        _ResumeCallHandlingArg_imsi,
        _ResumeCallHandlingArg_cug_CheckInfo,
        _ResumeCallHandlingArg_o_CSI,
        _ResumeCallHandlingArg_extensionContainer,
        _ResumeCallHandlingArg_ccbs_Possible,
        _ResumeCallHandlingArg_msisdn,
        _ResumeCallHandlingArg_uu_Data,
        _ResumeCallHandlingArg_allInformationSent,
        _ResumeCallHandlingArg_d_csi,
        _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList,
        _ResumeCallHandlingArg_basicServiceGroup2,
        _ResumeCallHandlingArg_mtRoamingRetry,
        ResumeCallHandlingArg,
        _UU_Data_uuIndicator,
        _UU_Data_uui,
        _UU_Data_uusCFInteraction,
        _UU_Data_extensionContainer,
        UU_Data,
        UUIndicator,
        UUI,
        _ResumeCallHandlingRes_extensionContainer,
        ResumeCallHandlingRes,
        _CamelInfo_supportedCamelPhases,
        _CamelInfo_suppress_T_CSI,
        _CamelInfo_extensionContainer,
        _CamelInfo_offeredCamel4CSIs,
        CamelInfo,
        _ExtendedRoutingInfo_routingInfo,
        _ExtendedRoutingInfo_camelRoutingInfo,
        ExtendedRoutingInfo,
        _CamelRoutingInfo_forwardingData,
        _CamelRoutingInfo_gmscCamelSubscriptionInfo,
        _CamelRoutingInfo_extensionContainer,
        CamelRoutingInfo,
        _GmscCamelSubscriptionInfo_t_CSI,
        _GmscCamelSubscriptionInfo_o_CSI,
        _GmscCamelSubscriptionInfo_extensionContainer,
        _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _GmscCamelSubscriptionInfo_d_csi,
        GmscCamelSubscriptionInfo,
        _SetReportingStateArg_imsi,
        _SetReportingStateArg_lmsi,
        _SetReportingStateArg_ccbs_Monitoring,
        _SetReportingStateArg_extensionContainer,
        SetReportingStateArg,
        ReportingState,
        _SetReportingStateRes_ccbs_SubscriberStatus,
        _SetReportingStateRes_extensionContainer,
        SetReportingStateRes,
        CCBS_SubscriberStatus,
        _StatusReportArg_imsi,
        _StatusReportArg_eventReportData,
        _StatusReportArg_callReportdata,
        _StatusReportArg_extensionContainer,
        StatusReportArg,
        _EventReportData_ccbs_SubscriberStatus,
        _EventReportData_extensionContainer,
        EventReportData,
        _CallReportData_monitoringMode,
        _CallReportData_callOutcome,
        _CallReportData_extensionContainer,
        CallReportData,
        MonitoringMode,
        CallOutcome,
        _StatusReportRes_extensionContainer,
        StatusReportRes,
        _RemoteUserFreeArg_imsi,
        _RemoteUserFreeArg_callInfo,
        _RemoteUserFreeArg_ccbs_Feature,
        _RemoteUserFreeArg_translatedB_Number,
        _RemoteUserFreeArg_replaceB_Number,
        _RemoteUserFreeArg_alertingPattern,
        _RemoteUserFreeArg_extensionContainer,
        RemoteUserFreeArg,
        _RemoteUserFreeRes_ruf_Outcome,
        _RemoteUserFreeRes_extensionContainer,
        RemoteUserFreeRes,
        RUF_Outcome,
        _IST_AlertArg_imsi,
        _IST_AlertArg_extensionContainer,
        IST_AlertArg,
        _IST_AlertRes_istAlertTimer,
        _IST_AlertRes_istInformationWithdraw,
        _IST_AlertRes_callTerminationIndicator,
        _IST_AlertRes_extensionContainer,
        IST_AlertRes,
        _IST_CommandArg_imsi,
        _IST_CommandArg_extensionContainer,
        IST_CommandArg,
        _IST_CommandRes_extensionContainer,
        IST_CommandRes,
        CallTerminationIndicator,
        _ReleaseResourcesArg_msrn,
        _ReleaseResourcesArg_extensionContainer,
        ReleaseResourcesArg,
        _ReleaseResourcesRes_extensionContainer,
        ReleaseResourcesRes,
    ]

class MAP_CommonDataTypes:

    _name_  = u'MAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 18, 19]
    
    _obj_ = [
        u'TBCD-STRING',
        u'DiameterIdentity',
        u'AddressString',
        u'maxAddressLength',
        u'ISDN-AddressString',
        u'maxISDN-AddressLength',
        u'FTN-AddressString',
        u'maxFTN-AddressLength',
        u'ISDN-SubaddressString',
        u'maxISDN-SubaddressLength',
        u'ExternalSignalInfo',
        u'SignalInfo',
        u'maxSignalInfoLength',
        u'ProtocolId',
        u'Ext-ExternalSignalInfo',
        u'Ext-ProtocolId',
        u'AccessNetworkSignalInfo',
        u'LongSignalInfo',
        u'maxLongSignalInfoLength',
        u'AccessNetworkProtocolId',
        u'AlertingPattern',
        u'alertingLevel-0',
        u'alertingLevel-1',
        u'alertingLevel-2',
        u'alertingCategory-1',
        u'alertingCategory-2',
        u'alertingCategory-3',
        u'alertingCategory-4',
        u'alertingCategory-5',
        u'GSN-Address',
        u'Time',
        u'IMSI',
        u'Identity',
        u'IMSI-WithLMSI',
        u'ASCI-CallReference',
        u'TMSI',
        u'SubscriberId',
        u'IMEI',
        u'HLR-Id',
        u'HLR-List',
        u'maxNumOfHLR-Id',
        u'LMSI',
        u'GlobalCellId',
        u'NetworkResource',
        u'AdditionalNetworkResource',
        u'NAEA-PreferredCI',
        u'NAEA-CIC',
        u'SubscriberIdentity',
        u'LCSClientExternalID',
        u'LCSClientInternalID',
        u'LCSServiceTypeID',
        u'emergencyServices',
        u'emergencyAlertServices',
        u'personTracking',
        u'fleetManagement',
        u'assetManagement',
        u'trafficCongestionReporting',
        u'roadsideAssistance',
        u'routingToNearestCommercialEnterprise',
        u'navigation',
        u'citySightseeing',
        u'localizedAdvertising',
        u'mobileYellowPages',
        u'trafficAndPublicTransportationInfo',
        u'weather',
        u'assetAndServiceFinding',
        u'gaming',
        u'findYourFriend',
        u'dating',
        u'chatting',
        u'routeFinding',
        u'whereAmI',
        u'serv64',
        u'serv65',
        u'serv66',
        u'serv67',
        u'serv68',
        u'serv69',
        u'serv70',
        u'serv71',
        u'serv72',
        u'serv73',
        u'serv74',
        u'serv75',
        u'serv76',
        u'serv77',
        u'serv78',
        u'serv79',
        u'serv80',
        u'serv81',
        u'serv82',
        u'serv83',
        u'serv84',
        u'serv85',
        u'serv86',
        u'serv87',
        u'serv88',
        u'serv89',
        u'serv90',
        u'serv91',
        u'serv92',
        u'serv93',
        u'serv94',
        u'serv95',
        u'serv96',
        u'serv97',
        u'serv98',
        u'serv99',
        u'serv100',
        u'serv101',
        u'serv102',
        u'serv103',
        u'serv104',
        u'serv105',
        u'serv106',
        u'serv107',
        u'serv108',
        u'serv109',
        u'serv110',
        u'serv111',
        u'serv112',
        u'serv113',
        u'serv114',
        u'serv115',
        u'serv116',
        u'serv117',
        u'serv118',
        u'serv119',
        u'serv120',
        u'serv121',
        u'serv122',
        u'serv123',
        u'serv124',
        u'serv125',
        u'serv126',
        u'serv127',
        u'PLMN-Id',
        u'E-UTRAN-CGI',
        u'NR-CGI',
        u'TA-Id',
        u'NR-TA-Id',
        u'RAIdentity',
        u'NetworkNodeDiameterAddress',
        u'CellGlobalIdOrServiceAreaIdOrLAI',
        u'CellGlobalIdOrServiceAreaIdFixedLength',
        u'LAIFixedLength',
        u'BasicServiceCode',
        u'Ext-BasicServiceCode',
        u'EMLPP-Info',
        u'EMLPP-Priority',
        u'priorityLevelA',
        u'priorityLevelB',
        u'priorityLevel0',
        u'priorityLevel1',
        u'priorityLevel2',
        u'priorityLevel3',
        u'priorityLevel4',
        u'MC-SS-Info',
        u'MaxMC-Bearers',
        u'MC-Bearers',
        u'maxNumOfMC-Bearers',
        u'Ext-SS-Status',
        u'AgeOfLocationInformation',
        ]
    _type_ = [
        u'TBCD-STRING',
        u'DiameterIdentity',
        u'AddressString',
        u'ISDN-AddressString',
        u'FTN-AddressString',
        u'ISDN-SubaddressString',
        u'ExternalSignalInfo',
        u'SignalInfo',
        u'ProtocolId',
        u'Ext-ExternalSignalInfo',
        u'Ext-ProtocolId',
        u'AccessNetworkSignalInfo',
        u'LongSignalInfo',
        u'AccessNetworkProtocolId',
        u'AlertingPattern',
        u'GSN-Address',
        u'Time',
        u'IMSI',
        u'Identity',
        u'IMSI-WithLMSI',
        u'ASCI-CallReference',
        u'TMSI',
        u'SubscriberId',
        u'IMEI',
        u'HLR-Id',
        u'HLR-List',
        u'LMSI',
        u'GlobalCellId',
        u'NetworkResource',
        u'AdditionalNetworkResource',
        u'NAEA-PreferredCI',
        u'NAEA-CIC',
        u'SubscriberIdentity',
        u'LCSClientExternalID',
        u'LCSClientInternalID',
        u'LCSServiceTypeID',
        u'PLMN-Id',
        u'E-UTRAN-CGI',
        u'NR-CGI',
        u'TA-Id',
        u'NR-TA-Id',
        u'RAIdentity',
        u'NetworkNodeDiameterAddress',
        u'CellGlobalIdOrServiceAreaIdOrLAI',
        u'CellGlobalIdOrServiceAreaIdFixedLength',
        u'LAIFixedLength',
        u'BasicServiceCode',
        u'Ext-BasicServiceCode',
        u'EMLPP-Info',
        u'EMLPP-Priority',
        u'MC-SS-Info',
        u'MaxMC-Bearers',
        u'MC-Bearers',
        u'Ext-SS-Status',
        u'AgeOfLocationInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxAddressLength',
        u'maxISDN-AddressLength',
        u'maxFTN-AddressLength',
        u'maxISDN-SubaddressLength',
        u'maxSignalInfoLength',
        u'maxLongSignalInfoLength',
        u'alertingLevel-0',
        u'alertingLevel-1',
        u'alertingLevel-2',
        u'alertingCategory-1',
        u'alertingCategory-2',
        u'alertingCategory-3',
        u'alertingCategory-4',
        u'alertingCategory-5',
        u'maxNumOfHLR-Id',
        u'emergencyServices',
        u'emergencyAlertServices',
        u'personTracking',
        u'fleetManagement',
        u'assetManagement',
        u'trafficCongestionReporting',
        u'roadsideAssistance',
        u'routingToNearestCommercialEnterprise',
        u'navigation',
        u'citySightseeing',
        u'localizedAdvertising',
        u'mobileYellowPages',
        u'trafficAndPublicTransportationInfo',
        u'weather',
        u'assetAndServiceFinding',
        u'gaming',
        u'findYourFriend',
        u'dating',
        u'chatting',
        u'routeFinding',
        u'whereAmI',
        u'serv64',
        u'serv65',
        u'serv66',
        u'serv67',
        u'serv68',
        u'serv69',
        u'serv70',
        u'serv71',
        u'serv72',
        u'serv73',
        u'serv74',
        u'serv75',
        u'serv76',
        u'serv77',
        u'serv78',
        u'serv79',
        u'serv80',
        u'serv81',
        u'serv82',
        u'serv83',
        u'serv84',
        u'serv85',
        u'serv86',
        u'serv87',
        u'serv88',
        u'serv89',
        u'serv90',
        u'serv91',
        u'serv92',
        u'serv93',
        u'serv94',
        u'serv95',
        u'serv96',
        u'serv97',
        u'serv98',
        u'serv99',
        u'serv100',
        u'serv101',
        u'serv102',
        u'serv103',
        u'serv104',
        u'serv105',
        u'serv106',
        u'serv107',
        u'serv108',
        u'serv109',
        u'serv110',
        u'serv111',
        u'serv112',
        u'serv113',
        u'serv114',
        u'serv115',
        u'serv116',
        u'serv117',
        u'serv118',
        u'serv119',
        u'serv120',
        u'serv121',
        u'serv122',
        u'serv123',
        u'serv124',
        u'serv125',
        u'serv126',
        u'serv127',
        u'priorityLevelA',
        u'priorityLevelB',
        u'priorityLevel0',
        u'priorityLevel1',
        u'priorityLevel2',
        u'priorityLevel3',
        u'priorityLevel4',
        u'maxNumOfMC-Bearers',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name=u'TBCD-STRING', mode=MODE_TYPE)
    
    #-----< DiameterIdentity >-----#
    DiameterIdentity = OCT_STR(name=u'DiameterIdentity', mode=MODE_TYPE)
    DiameterIdentity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< AddressString >-----#
    AddressString = OCT_STR(name=u'AddressString', mode=MODE_TYPE)
    AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxAddressLength >-----#
    maxAddressLength = INT(name=u'maxAddressLength', mode=MODE_VALUE)
    maxAddressLength._val = 20
    
    #-----< ISDN-AddressString >-----#
    ISDN_AddressString = OCT_STR(name=u'ISDN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    ISDN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxISDN-AddressLength >-----#
    maxISDN_AddressLength = INT(name=u'maxISDN-AddressLength', mode=MODE_VALUE)
    maxISDN_AddressLength._val = 9
    
    #-----< FTN-AddressString >-----#
    FTN_AddressString = OCT_STR(name=u'FTN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    FTN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxFTN-AddressLength >-----#
    maxFTN_AddressLength = INT(name=u'maxFTN-AddressLength', mode=MODE_VALUE)
    maxFTN_AddressLength._val = 15
    
    #-----< ISDN-SubaddressString >-----#
    ISDN_SubaddressString = OCT_STR(name=u'ISDN-SubaddressString', mode=MODE_TYPE)
    ISDN_SubaddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=21)], ev=None, er=[])
    
    #-----< maxISDN-SubaddressLength >-----#
    maxISDN_SubaddressLength = INT(name=u'maxISDN-SubaddressLength', mode=MODE_VALUE)
    maxISDN_SubaddressLength._val = 21
    
    #-----< ExternalSignalInfo >-----#
    ExternalSignalInfo = SEQ(name=u'ExternalSignalInfo', mode=MODE_TYPE)
    _ExternalSignalInfo_protocolId = ENUM(name=u'protocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ProtocolId')))
    _ExternalSignalInfo_signalInfo = OCT_STR(name=u'signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _ExternalSignalInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalSignalInfo._cont = ASN1Dict([
        (u'protocolId', _ExternalSignalInfo_protocolId),
        (u'signalInfo', _ExternalSignalInfo_signalInfo),
        (u'extensionContainer', _ExternalSignalInfo_extensionContainer),
        ])
    ExternalSignalInfo._ext = []
    
    #-----< SignalInfo >-----#
    SignalInfo = OCT_STR(name=u'SignalInfo', mode=MODE_TYPE)
    SignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    
    #-----< maxSignalInfoLength >-----#
    maxSignalInfoLength = INT(name=u'maxSignalInfoLength', mode=MODE_VALUE)
    maxSignalInfoLength._val = 200
    
    #-----< ProtocolId >-----#
    ProtocolId = ENUM(name=u'ProtocolId', mode=MODE_TYPE)
    ProtocolId._cont = ASN1Dict([(u'gsm-0408', 1), (u'gsm-0806', 2), (u'gsm-BSSMAP', 3), (u'ets-300102-1', 4)])
    ProtocolId._ext = None
    
    #-----< Ext-ExternalSignalInfo >-----#
    Ext_ExternalSignalInfo = SEQ(name=u'Ext-ExternalSignalInfo', mode=MODE_TYPE)
    _Ext_ExternalSignalInfo_ext_ProtocolId = ENUM(name=u'ext-ProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ProtocolId')))
    _Ext_ExternalSignalInfo_signalInfo = OCT_STR(name=u'signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _Ext_ExternalSignalInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ExternalSignalInfo._cont = ASN1Dict([
        (u'ext-ProtocolId', _Ext_ExternalSignalInfo_ext_ProtocolId),
        (u'signalInfo', _Ext_ExternalSignalInfo_signalInfo),
        (u'extensionContainer', _Ext_ExternalSignalInfo_extensionContainer),
        ])
    Ext_ExternalSignalInfo._ext = []
    
    #-----< Ext-ProtocolId >-----#
    Ext_ProtocolId = ENUM(name=u'Ext-ProtocolId', mode=MODE_TYPE)
    Ext_ProtocolId._cont = ASN1Dict([(u'ets-300356', 1)])
    Ext_ProtocolId._ext = []
    
    #-----< AccessNetworkSignalInfo >-----#
    AccessNetworkSignalInfo = SEQ(name=u'AccessNetworkSignalInfo', mode=MODE_TYPE)
    _AccessNetworkSignalInfo_accessNetworkProtocolId = ENUM(name=u'accessNetworkProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkProtocolId')))
    _AccessNetworkSignalInfo_signalInfo = OCT_STR(name=u'signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LongSignalInfo')))
    _AccessNetworkSignalInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AccessNetworkSignalInfo._cont = ASN1Dict([
        (u'accessNetworkProtocolId', _AccessNetworkSignalInfo_accessNetworkProtocolId),
        (u'signalInfo', _AccessNetworkSignalInfo_signalInfo),
        (u'extensionContainer', _AccessNetworkSignalInfo_extensionContainer),
        ])
    AccessNetworkSignalInfo._ext = []
    
    #-----< LongSignalInfo >-----#
    LongSignalInfo = OCT_STR(name=u'LongSignalInfo', mode=MODE_TYPE)
    LongSignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2560)], ev=None, er=[])
    
    #-----< maxLongSignalInfoLength >-----#
    maxLongSignalInfoLength = INT(name=u'maxLongSignalInfoLength', mode=MODE_VALUE)
    maxLongSignalInfoLength._val = 2560
    
    #-----< AccessNetworkProtocolId >-----#
    AccessNetworkProtocolId = ENUM(name=u'AccessNetworkProtocolId', mode=MODE_TYPE)
    AccessNetworkProtocolId._cont = ASN1Dict([(u'ts3G-48006', 1), (u'ts3G-25413', 2)])
    AccessNetworkProtocolId._ext = []
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name=u'AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< alertingLevel-0 >-----#
    alertingLevel_0 = OCT_STR(name=u'alertingLevel-0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_0._val = b'\x00'
    
    #-----< alertingLevel-1 >-----#
    alertingLevel_1 = OCT_STR(name=u'alertingLevel-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_1._val = b'\x01'
    
    #-----< alertingLevel-2 >-----#
    alertingLevel_2 = OCT_STR(name=u'alertingLevel-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_2._val = b'\x02'
    
    #-----< alertingCategory-1 >-----#
    alertingCategory_1 = OCT_STR(name=u'alertingCategory-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_1._val = b'\x04'
    
    #-----< alertingCategory-2 >-----#
    alertingCategory_2 = OCT_STR(name=u'alertingCategory-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_2._val = b'\x05'
    
    #-----< alertingCategory-3 >-----#
    alertingCategory_3 = OCT_STR(name=u'alertingCategory-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_3._val = b'\x06'
    
    #-----< alertingCategory-4 >-----#
    alertingCategory_4 = OCT_STR(name=u'alertingCategory-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_4._val = b'\x07'
    
    #-----< alertingCategory-5 >-----#
    alertingCategory_5 = OCT_STR(name=u'alertingCategory-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_5._val = b'\x08'
    
    #-----< GSN-Address >-----#
    GSN_Address = OCT_STR(name=u'GSN-Address', mode=MODE_TYPE)
    GSN_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    
    #-----< Time >-----#
    Time = OCT_STR(name=u'Time', mode=MODE_TYPE)
    Time._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name=u'IMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< Identity >-----#
    Identity = CHOICE(name=u'Identity', mode=MODE_TYPE)
    _Identity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _Identity_imsi_WithLMSI = SEQ(name=u'imsi-WithLMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI-WithLMSI')))
    Identity._cont = ASN1Dict([
        (u'imsi', _Identity_imsi),
        (u'imsi-WithLMSI', _Identity_imsi_WithLMSI),
        ])
    Identity._ext = None
    
    #-----< IMSI-WithLMSI >-----#
    IMSI_WithLMSI = SEQ(name=u'IMSI-WithLMSI', mode=MODE_TYPE)
    _IMSI_WithLMSI_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IMSI_WithLMSI_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')))
    IMSI_WithLMSI._cont = ASN1Dict([
        (u'imsi', _IMSI_WithLMSI_imsi),
        (u'lmsi', _IMSI_WithLMSI_lmsi),
        ])
    IMSI_WithLMSI._ext = []
    
    #-----< ASCI-CallReference >-----#
    ASCI_CallReference = OCT_STR(name=u'ASCI-CallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    ASCI_CallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TMSI >-----#
    TMSI = OCT_STR(name=u'TMSI', mode=MODE_TYPE)
    TMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< SubscriberId >-----#
    SubscriberId = CHOICE(name=u'SubscriberId', mode=MODE_TYPE)
    _SubscriberId_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberId_tmsi = OCT_STR(name=u'tmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    SubscriberId._cont = ASN1Dict([
        (u'imsi', _SubscriberId_imsi),
        (u'tmsi', _SubscriberId_tmsi),
        ])
    SubscriberId._ext = None
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name=u'IMEI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HLR-Id >-----#
    HLR_Id = OCT_STR(name=u'HLR-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    
    #-----< HLR-List >-----#
    HLR_List = SEQ_OF(name=u'HLR-List', mode=MODE_TYPE)
    _HLR_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-Id')))
    HLR_List._cont = _HLR_List__item_
    HLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfHLR-Id >-----#
    maxNumOfHLR_Id = INT(name=u'maxNumOfHLR-Id', mode=MODE_VALUE)
    maxNumOfHLR_Id._val = 50
    
    #-----< LMSI >-----#
    LMSI = OCT_STR(name=u'LMSI', mode=MODE_TYPE)
    LMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GlobalCellId >-----#
    GlobalCellId = OCT_STR(name=u'GlobalCellId', mode=MODE_TYPE)
    GlobalCellId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< NetworkResource >-----#
    NetworkResource = ENUM(name=u'NetworkResource', mode=MODE_TYPE)
    NetworkResource._cont = ASN1Dict([(u'plmn', 0), (u'hlr', 1), (u'vlr', 2), (u'pvlr', 3), (u'controllingMSC', 4), (u'vmsc', 5), (u'eir', 6), (u'rss', 7)])
    NetworkResource._ext = None
    
    #-----< AdditionalNetworkResource >-----#
    AdditionalNetworkResource = ENUM(name=u'AdditionalNetworkResource', mode=MODE_TYPE)
    AdditionalNetworkResource._cont = ASN1Dict([(u'sgsn', 0), (u'ggsn', 1), (u'gmlc', 2), (u'gsmSCF', 3), (u'nplr', 4), (u'auc', 5), (u'ue', 6), (u'mme', 7)])
    AdditionalNetworkResource._ext = [u'ue', u'mme']
    
    #-----< NAEA-PreferredCI >-----#
    NAEA_PreferredCI = SEQ(name=u'NAEA-PreferredCI', mode=MODE_TYPE)
    _NAEA_PreferredCI_naea_PreferredCIC = OCT_STR(name=u'naea-PreferredCIC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-CIC')))
    _NAEA_PreferredCI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NAEA_PreferredCI._cont = ASN1Dict([
        (u'naea-PreferredCIC', _NAEA_PreferredCI_naea_PreferredCIC),
        (u'extensionContainer', _NAEA_PreferredCI_extensionContainer),
        ])
    NAEA_PreferredCI._ext = []
    
    #-----< NAEA-CIC >-----#
    NAEA_CIC = OCT_STR(name=u'NAEA-CIC', mode=MODE_TYPE)
    NAEA_CIC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SubscriberIdentity >-----#
    SubscriberIdentity = CHOICE(name=u'SubscriberIdentity', mode=MODE_TYPE)
    _SubscriberIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberIdentity_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SubscriberIdentity._cont = ASN1Dict([
        (u'imsi', _SubscriberIdentity_imsi),
        (u'msisdn', _SubscriberIdentity_msisdn),
        ])
    SubscriberIdentity._ext = None
    
    #-----< LCSClientExternalID >-----#
    LCSClientExternalID = SEQ(name=u'LCSClientExternalID', mode=MODE_TYPE)
    _LCSClientExternalID_externalAddress = OCT_STR(name=u'externalAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LCSClientExternalID_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LCSClientExternalID._cont = ASN1Dict([
        (u'externalAddress', _LCSClientExternalID_externalAddress),
        (u'extensionContainer', _LCSClientExternalID_extensionContainer),
        ])
    LCSClientExternalID._ext = []
    
    #-----< LCSClientInternalID >-----#
    LCSClientInternalID = ENUM(name=u'LCSClientInternalID', mode=MODE_TYPE)
    LCSClientInternalID._cont = ASN1Dict([(u'broadcastService', 0), (u'o-andM-HPLMN', 1), (u'o-andM-VPLMN', 2), (u'anonymousLocation', 3), (u'targetMSsubscribedService', 4)])
    LCSClientInternalID._ext = []
    
    #-----< LCSServiceTypeID >-----#
    LCSServiceTypeID = INT(name=u'LCSServiceTypeID', mode=MODE_TYPE)
    LCSServiceTypeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< emergencyServices >-----#
    emergencyServices = INT(name=u'emergencyServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyServices._val = 0
    
    #-----< emergencyAlertServices >-----#
    emergencyAlertServices = INT(name=u'emergencyAlertServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyAlertServices._val = 1
    
    #-----< personTracking >-----#
    personTracking = INT(name=u'personTracking', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    personTracking._val = 2
    
    #-----< fleetManagement >-----#
    fleetManagement = INT(name=u'fleetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    fleetManagement._val = 3
    
    #-----< assetManagement >-----#
    assetManagement = INT(name=u'assetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetManagement._val = 4
    
    #-----< trafficCongestionReporting >-----#
    trafficCongestionReporting = INT(name=u'trafficCongestionReporting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficCongestionReporting._val = 5
    
    #-----< roadsideAssistance >-----#
    roadsideAssistance = INT(name=u'roadsideAssistance', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    roadsideAssistance._val = 6
    
    #-----< routingToNearestCommercialEnterprise >-----#
    routingToNearestCommercialEnterprise = INT(name=u'routingToNearestCommercialEnterprise', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routingToNearestCommercialEnterprise._val = 7
    
    #-----< navigation >-----#
    navigation = INT(name=u'navigation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    navigation._val = 8
    
    #-----< citySightseeing >-----#
    citySightseeing = INT(name=u'citySightseeing', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    citySightseeing._val = 9
    
    #-----< localizedAdvertising >-----#
    localizedAdvertising = INT(name=u'localizedAdvertising', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    localizedAdvertising._val = 10
    
    #-----< mobileYellowPages >-----#
    mobileYellowPages = INT(name=u'mobileYellowPages', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    mobileYellowPages._val = 11
    
    #-----< trafficAndPublicTransportationInfo >-----#
    trafficAndPublicTransportationInfo = INT(name=u'trafficAndPublicTransportationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficAndPublicTransportationInfo._val = 12
    
    #-----< weather >-----#
    weather = INT(name=u'weather', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    weather._val = 13
    
    #-----< assetAndServiceFinding >-----#
    assetAndServiceFinding = INT(name=u'assetAndServiceFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetAndServiceFinding._val = 14
    
    #-----< gaming >-----#
    gaming = INT(name=u'gaming', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    gaming._val = 15
    
    #-----< findYourFriend >-----#
    findYourFriend = INT(name=u'findYourFriend', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    findYourFriend._val = 16
    
    #-----< dating >-----#
    dating = INT(name=u'dating', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    dating._val = 17
    
    #-----< chatting >-----#
    chatting = INT(name=u'chatting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    chatting._val = 18
    
    #-----< routeFinding >-----#
    routeFinding = INT(name=u'routeFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routeFinding._val = 19
    
    #-----< whereAmI >-----#
    whereAmI = INT(name=u'whereAmI', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    whereAmI._val = 20
    
    #-----< serv64 >-----#
    serv64 = INT(name=u'serv64', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv64._val = 64
    
    #-----< serv65 >-----#
    serv65 = INT(name=u'serv65', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv65._val = 65
    
    #-----< serv66 >-----#
    serv66 = INT(name=u'serv66', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv66._val = 66
    
    #-----< serv67 >-----#
    serv67 = INT(name=u'serv67', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv67._val = 67
    
    #-----< serv68 >-----#
    serv68 = INT(name=u'serv68', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv68._val = 68
    
    #-----< serv69 >-----#
    serv69 = INT(name=u'serv69', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv69._val = 69
    
    #-----< serv70 >-----#
    serv70 = INT(name=u'serv70', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv70._val = 70
    
    #-----< serv71 >-----#
    serv71 = INT(name=u'serv71', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv71._val = 71
    
    #-----< serv72 >-----#
    serv72 = INT(name=u'serv72', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv72._val = 72
    
    #-----< serv73 >-----#
    serv73 = INT(name=u'serv73', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv73._val = 73
    
    #-----< serv74 >-----#
    serv74 = INT(name=u'serv74', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv74._val = 74
    
    #-----< serv75 >-----#
    serv75 = INT(name=u'serv75', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv75._val = 75
    
    #-----< serv76 >-----#
    serv76 = INT(name=u'serv76', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv76._val = 76
    
    #-----< serv77 >-----#
    serv77 = INT(name=u'serv77', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv77._val = 77
    
    #-----< serv78 >-----#
    serv78 = INT(name=u'serv78', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv78._val = 78
    
    #-----< serv79 >-----#
    serv79 = INT(name=u'serv79', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv79._val = 79
    
    #-----< serv80 >-----#
    serv80 = INT(name=u'serv80', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv80._val = 80
    
    #-----< serv81 >-----#
    serv81 = INT(name=u'serv81', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv81._val = 81
    
    #-----< serv82 >-----#
    serv82 = INT(name=u'serv82', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv82._val = 82
    
    #-----< serv83 >-----#
    serv83 = INT(name=u'serv83', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv83._val = 83
    
    #-----< serv84 >-----#
    serv84 = INT(name=u'serv84', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv84._val = 84
    
    #-----< serv85 >-----#
    serv85 = INT(name=u'serv85', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv85._val = 85
    
    #-----< serv86 >-----#
    serv86 = INT(name=u'serv86', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv86._val = 86
    
    #-----< serv87 >-----#
    serv87 = INT(name=u'serv87', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv87._val = 87
    
    #-----< serv88 >-----#
    serv88 = INT(name=u'serv88', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv88._val = 88
    
    #-----< serv89 >-----#
    serv89 = INT(name=u'serv89', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv89._val = 89
    
    #-----< serv90 >-----#
    serv90 = INT(name=u'serv90', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv90._val = 90
    
    #-----< serv91 >-----#
    serv91 = INT(name=u'serv91', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv91._val = 91
    
    #-----< serv92 >-----#
    serv92 = INT(name=u'serv92', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv92._val = 92
    
    #-----< serv93 >-----#
    serv93 = INT(name=u'serv93', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv93._val = 93
    
    #-----< serv94 >-----#
    serv94 = INT(name=u'serv94', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv94._val = 94
    
    #-----< serv95 >-----#
    serv95 = INT(name=u'serv95', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv95._val = 95
    
    #-----< serv96 >-----#
    serv96 = INT(name=u'serv96', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv96._val = 96
    
    #-----< serv97 >-----#
    serv97 = INT(name=u'serv97', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv97._val = 97
    
    #-----< serv98 >-----#
    serv98 = INT(name=u'serv98', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv98._val = 98
    
    #-----< serv99 >-----#
    serv99 = INT(name=u'serv99', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv99._val = 99
    
    #-----< serv100 >-----#
    serv100 = INT(name=u'serv100', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv100._val = 100
    
    #-----< serv101 >-----#
    serv101 = INT(name=u'serv101', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv101._val = 101
    
    #-----< serv102 >-----#
    serv102 = INT(name=u'serv102', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv102._val = 102
    
    #-----< serv103 >-----#
    serv103 = INT(name=u'serv103', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv103._val = 103
    
    #-----< serv104 >-----#
    serv104 = INT(name=u'serv104', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv104._val = 104
    
    #-----< serv105 >-----#
    serv105 = INT(name=u'serv105', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv105._val = 105
    
    #-----< serv106 >-----#
    serv106 = INT(name=u'serv106', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv106._val = 106
    
    #-----< serv107 >-----#
    serv107 = INT(name=u'serv107', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv107._val = 107
    
    #-----< serv108 >-----#
    serv108 = INT(name=u'serv108', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv108._val = 108
    
    #-----< serv109 >-----#
    serv109 = INT(name=u'serv109', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv109._val = 109
    
    #-----< serv110 >-----#
    serv110 = INT(name=u'serv110', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv110._val = 110
    
    #-----< serv111 >-----#
    serv111 = INT(name=u'serv111', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv111._val = 111
    
    #-----< serv112 >-----#
    serv112 = INT(name=u'serv112', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv112._val = 112
    
    #-----< serv113 >-----#
    serv113 = INT(name=u'serv113', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv113._val = 113
    
    #-----< serv114 >-----#
    serv114 = INT(name=u'serv114', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv114._val = 114
    
    #-----< serv115 >-----#
    serv115 = INT(name=u'serv115', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv115._val = 115
    
    #-----< serv116 >-----#
    serv116 = INT(name=u'serv116', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv116._val = 116
    
    #-----< serv117 >-----#
    serv117 = INT(name=u'serv117', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv117._val = 117
    
    #-----< serv118 >-----#
    serv118 = INT(name=u'serv118', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv118._val = 118
    
    #-----< serv119 >-----#
    serv119 = INT(name=u'serv119', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv119._val = 119
    
    #-----< serv120 >-----#
    serv120 = INT(name=u'serv120', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv120._val = 120
    
    #-----< serv121 >-----#
    serv121 = INT(name=u'serv121', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv121._val = 121
    
    #-----< serv122 >-----#
    serv122 = INT(name=u'serv122', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv122._val = 122
    
    #-----< serv123 >-----#
    serv123 = INT(name=u'serv123', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv123._val = 123
    
    #-----< serv124 >-----#
    serv124 = INT(name=u'serv124', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv124._val = 124
    
    #-----< serv125 >-----#
    serv125 = INT(name=u'serv125', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv125._val = 125
    
    #-----< serv126 >-----#
    serv126 = INT(name=u'serv126', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv126._val = 126
    
    #-----< serv127 >-----#
    serv127 = INT(name=u'serv127', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv127._val = 127
    
    #-----< PLMN-Id >-----#
    PLMN_Id = OCT_STR(name=u'PLMN-Id', mode=MODE_TYPE)
    PLMN_Id._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< E-UTRAN-CGI >-----#
    E_UTRAN_CGI = OCT_STR(name=u'E-UTRAN-CGI', mode=MODE_TYPE)
    E_UTRAN_CGI._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = OCT_STR(name=u'NR-CGI', mode=MODE_TYPE)
    NR_CGI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TA-Id >-----#
    TA_Id = OCT_STR(name=u'TA-Id', mode=MODE_TYPE)
    TA_Id._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< NR-TA-Id >-----#
    NR_TA_Id = OCT_STR(name=u'NR-TA-Id', mode=MODE_TYPE)
    NR_TA_Id._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< RAIdentity >-----#
    RAIdentity = OCT_STR(name=u'RAIdentity', mode=MODE_TYPE)
    RAIdentity._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< NetworkNodeDiameterAddress >-----#
    NetworkNodeDiameterAddress = SEQ(name=u'NetworkNodeDiameterAddress', mode=MODE_TYPE)
    _NetworkNodeDiameterAddress_diameter_Name = OCT_STR(name=u'diameter-Name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    _NetworkNodeDiameterAddress_diameter_Realm = OCT_STR(name=u'diameter-Realm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    NetworkNodeDiameterAddress._cont = ASN1Dict([
        (u'diameter-Name', _NetworkNodeDiameterAddress_diameter_Name),
        (u'diameter-Realm', _NetworkNodeDiameterAddress_diameter_Realm),
        ])
    NetworkNodeDiameterAddress._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdOrLAI >-----#
    CellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name=u'CellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE)
    _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name=u'cellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength = OCT_STR(name=u'laiFixedLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    CellGlobalIdOrServiceAreaIdOrLAI._cont = ASN1Dict([
        (u'cellGlobalIdOrServiceAreaIdFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength),
        (u'laiFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength),
        ])
    CellGlobalIdOrServiceAreaIdOrLAI._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdFixedLength >-----#
    CellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name=u'CellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE)
    CellGlobalIdOrServiceAreaIdFixedLength._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< LAIFixedLength >-----#
    LAIFixedLength = OCT_STR(name=u'LAIFixedLength', mode=MODE_TYPE)
    LAIFixedLength._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< BasicServiceCode >-----#
    BasicServiceCode = CHOICE(name=u'BasicServiceCode', mode=MODE_TYPE)
    _BasicServiceCode_bearerService = OCT_STR(name=u'bearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    _BasicServiceCode_teleservice = OCT_STR(name=u'teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    BasicServiceCode._cont = ASN1Dict([
        (u'bearerService', _BasicServiceCode_bearerService),
        (u'teleservice', _BasicServiceCode_teleservice),
        ])
    BasicServiceCode._ext = None
    
    #-----< Ext-BasicServiceCode >-----#
    Ext_BasicServiceCode = CHOICE(name=u'Ext-BasicServiceCode', mode=MODE_TYPE)
    _Ext_BasicServiceCode_ext_BearerService = OCT_STR(name=u'ext-BearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    _Ext_BasicServiceCode_ext_Teleservice = OCT_STR(name=u'ext-Teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    Ext_BasicServiceCode._cont = ASN1Dict([
        (u'ext-BearerService', _Ext_BasicServiceCode_ext_BearerService),
        (u'ext-Teleservice', _Ext_BasicServiceCode_ext_Teleservice),
        ])
    Ext_BasicServiceCode._ext = None
    
    #-----< EMLPP-Info >-----#
    EMLPP_Info = SEQ(name=u'EMLPP-Info', mode=MODE_TYPE)
    _EMLPP_Info_maximumentitledPriority = INT(name=u'maximumentitledPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EMLPP_Info._cont = ASN1Dict([
        (u'maximumentitledPriority', _EMLPP_Info_maximumentitledPriority),
        (u'defaultPriority', _EMLPP_Info_defaultPriority),
        (u'extensionContainer', _EMLPP_Info_extensionContainer),
        ])
    EMLPP_Info._ext = []
    
    #-----< EMLPP-Priority >-----#
    EMLPP_Priority = INT(name=u'EMLPP-Priority', mode=MODE_TYPE)
    EMLPP_Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< priorityLevelA >-----#
    priorityLevelA = INT(name=u'priorityLevelA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelA._val = 6
    
    #-----< priorityLevelB >-----#
    priorityLevelB = INT(name=u'priorityLevelB', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelB._val = 5
    
    #-----< priorityLevel0 >-----#
    priorityLevel0 = INT(name=u'priorityLevel0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel0._val = 0
    
    #-----< priorityLevel1 >-----#
    priorityLevel1 = INT(name=u'priorityLevel1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel1._val = 1
    
    #-----< priorityLevel2 >-----#
    priorityLevel2 = INT(name=u'priorityLevel2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel2._val = 2
    
    #-----< priorityLevel3 >-----#
    priorityLevel3 = INT(name=u'priorityLevel3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel3._val = 3
    
    #-----< priorityLevel4 >-----#
    priorityLevel4 = INT(name=u'priorityLevel4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel4._val = 4
    
    #-----< MC-SS-Info >-----#
    MC_SS_Info = SEQ(name=u'MC-SS-Info', mode=MODE_TYPE)
    _MC_SS_Info_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MC_SS_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MC_SS_Info_nbrSB = INT(name=u'nbrSB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')))
    _MC_SS_Info_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')))
    _MC_SS_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MC_SS_Info._cont = ASN1Dict([
        (u'ss-Code', _MC_SS_Info_ss_Code),
        (u'ss-Status', _MC_SS_Info_ss_Status),
        (u'nbrSB', _MC_SS_Info_nbrSB),
        (u'nbrUser', _MC_SS_Info_nbrUser),
        (u'extensionContainer', _MC_SS_Info_extensionContainer),
        ])
    MC_SS_Info._ext = []
    
    #-----< MaxMC-Bearers >-----#
    MaxMC_Bearers = INT(name=u'MaxMC-Bearers', mode=MODE_TYPE)
    MaxMC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=7)], ev=None, er=[])
    
    #-----< MC-Bearers >-----#
    MC_Bearers = INT(name=u'MC-Bearers', mode=MODE_TYPE)
    MC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< maxNumOfMC-Bearers >-----#
    maxNumOfMC_Bearers = INT(name=u'maxNumOfMC-Bearers', mode=MODE_VALUE)
    maxNumOfMC_Bearers._val = 7
    
    #-----< Ext-SS-Status >-----#
    Ext_SS_Status = OCT_STR(name=u'Ext-SS-Status', mode=MODE_TYPE)
    Ext_SS_Status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AgeOfLocationInformation >-----#
    AgeOfLocationInformation = INT(name=u'AgeOfLocationInformation', mode=MODE_TYPE)
    AgeOfLocationInformation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    _all_ = [
        TBCD_STRING,
        DiameterIdentity,
        AddressString,
        maxAddressLength,
        ISDN_AddressString,
        maxISDN_AddressLength,
        FTN_AddressString,
        maxFTN_AddressLength,
        ISDN_SubaddressString,
        maxISDN_SubaddressLength,
        _ExternalSignalInfo_protocolId,
        _ExternalSignalInfo_signalInfo,
        _ExternalSignalInfo_extensionContainer,
        ExternalSignalInfo,
        SignalInfo,
        maxSignalInfoLength,
        ProtocolId,
        _Ext_ExternalSignalInfo_ext_ProtocolId,
        _Ext_ExternalSignalInfo_signalInfo,
        _Ext_ExternalSignalInfo_extensionContainer,
        Ext_ExternalSignalInfo,
        Ext_ProtocolId,
        _AccessNetworkSignalInfo_accessNetworkProtocolId,
        _AccessNetworkSignalInfo_signalInfo,
        _AccessNetworkSignalInfo_extensionContainer,
        AccessNetworkSignalInfo,
        LongSignalInfo,
        maxLongSignalInfoLength,
        AccessNetworkProtocolId,
        AlertingPattern,
        alertingLevel_0,
        alertingLevel_1,
        alertingLevel_2,
        alertingCategory_1,
        alertingCategory_2,
        alertingCategory_3,
        alertingCategory_4,
        alertingCategory_5,
        GSN_Address,
        Time,
        IMSI,
        _Identity_imsi,
        _Identity_imsi_WithLMSI,
        Identity,
        _IMSI_WithLMSI_imsi,
        _IMSI_WithLMSI_lmsi,
        IMSI_WithLMSI,
        ASCI_CallReference,
        TMSI,
        _SubscriberId_imsi,
        _SubscriberId_tmsi,
        SubscriberId,
        IMEI,
        HLR_Id,
        _HLR_List__item_,
        HLR_List,
        maxNumOfHLR_Id,
        LMSI,
        GlobalCellId,
        NetworkResource,
        AdditionalNetworkResource,
        _NAEA_PreferredCI_naea_PreferredCIC,
        _NAEA_PreferredCI_extensionContainer,
        NAEA_PreferredCI,
        NAEA_CIC,
        _SubscriberIdentity_imsi,
        _SubscriberIdentity_msisdn,
        SubscriberIdentity,
        _LCSClientExternalID_externalAddress,
        _LCSClientExternalID_extensionContainer,
        LCSClientExternalID,
        LCSClientInternalID,
        LCSServiceTypeID,
        emergencyServices,
        emergencyAlertServices,
        personTracking,
        fleetManagement,
        assetManagement,
        trafficCongestionReporting,
        roadsideAssistance,
        routingToNearestCommercialEnterprise,
        navigation,
        citySightseeing,
        localizedAdvertising,
        mobileYellowPages,
        trafficAndPublicTransportationInfo,
        weather,
        assetAndServiceFinding,
        gaming,
        findYourFriend,
        dating,
        chatting,
        routeFinding,
        whereAmI,
        serv64,
        serv65,
        serv66,
        serv67,
        serv68,
        serv69,
        serv70,
        serv71,
        serv72,
        serv73,
        serv74,
        serv75,
        serv76,
        serv77,
        serv78,
        serv79,
        serv80,
        serv81,
        serv82,
        serv83,
        serv84,
        serv85,
        serv86,
        serv87,
        serv88,
        serv89,
        serv90,
        serv91,
        serv92,
        serv93,
        serv94,
        serv95,
        serv96,
        serv97,
        serv98,
        serv99,
        serv100,
        serv101,
        serv102,
        serv103,
        serv104,
        serv105,
        serv106,
        serv107,
        serv108,
        serv109,
        serv110,
        serv111,
        serv112,
        serv113,
        serv114,
        serv115,
        serv116,
        serv117,
        serv118,
        serv119,
        serv120,
        serv121,
        serv122,
        serv123,
        serv124,
        serv125,
        serv126,
        serv127,
        PLMN_Id,
        E_UTRAN_CGI,
        NR_CGI,
        TA_Id,
        NR_TA_Id,
        RAIdentity,
        _NetworkNodeDiameterAddress_diameter_Name,
        _NetworkNodeDiameterAddress_diameter_Realm,
        NetworkNodeDiameterAddress,
        _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength,
        _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength,
        CellGlobalIdOrServiceAreaIdOrLAI,
        CellGlobalIdOrServiceAreaIdFixedLength,
        LAIFixedLength,
        _BasicServiceCode_bearerService,
        _BasicServiceCode_teleservice,
        BasicServiceCode,
        _Ext_BasicServiceCode_ext_BearerService,
        _Ext_BasicServiceCode_ext_Teleservice,
        Ext_BasicServiceCode,
        _EMLPP_Info_maximumentitledPriority,
        _EMLPP_Info_defaultPriority,
        _EMLPP_Info_extensionContainer,
        EMLPP_Info,
        EMLPP_Priority,
        priorityLevelA,
        priorityLevelB,
        priorityLevel0,
        priorityLevel1,
        priorityLevel2,
        priorityLevel3,
        priorityLevel4,
        _MC_SS_Info_ss_Code,
        _MC_SS_Info_ss_Status,
        _MC_SS_Info_nbrSB,
        _MC_SS_Info_nbrUser,
        _MC_SS_Info_extensionContainer,
        MC_SS_Info,
        MaxMC_Bearers,
        MC_Bearers,
        maxNumOfMC_Bearers,
        Ext_SS_Status,
        AgeOfLocationInformation,
    ]

class MAP_ER_DataTypes:

    _name_  = u'MAP-ER-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 17, 19]
    
    _obj_ = [
        u'RoamingNotAllowedParam',
        u'AdditionalRoamingNotAllowedCause',
        u'RoamingNotAllowedCause',
        u'CallBarredParam',
        u'CallBarringCause',
        u'ExtensibleCallBarredParam',
        u'CUG-RejectParam',
        u'CUG-RejectCause',
        u'SS-IncompatibilityCause',
        u'PW-RegistrationFailureCause',
        u'SM-EnumeratedDeliveryFailureCause',
        u'SM-DeliveryFailureCause',
        u'AbsentSubscriberSM-Param',
        u'AbsentSubscriberDiagnosticSM',
        u'SystemFailureParam',
        u'ExtensibleSystemFailureParam',
        u'FailureCauseParam',
        u'DataMissingParam',
        u'UnexpectedDataParam',
        u'FacilityNotSupParam',
        u'OR-NotAllowedParam',
        u'UnknownSubscriberParam',
        u'UnknownSubscriberDiagnostic',
        u'NumberChangedParam',
        u'UnidentifiedSubParam',
        u'IllegalSubscriberParam',
        u'IllegalEquipmentParam',
        u'BearerServNotProvParam',
        u'TeleservNotProvParam',
        u'TracingBufferFullParam',
        u'NoRoamingNbParam',
        u'AbsentSubscriberParam',
        u'AbsentSubscriberReason',
        u'BusySubscriberParam',
        u'NoSubscriberReplyParam',
        u'ForwardingViolationParam',
        u'ForwardingFailedParam',
        u'ATI-NotAllowedParam',
        u'ATSI-NotAllowedParam',
        u'ATM-NotAllowedParam',
        u'IllegalSS-OperationParam',
        u'SS-NotAvailableParam',
        u'SS-SubscriptionViolationParam',
        u'InformationNotAvailableParam',
        u'SubBusyForMT-SMS-Param',
        u'MessageWaitListFullParam',
        u'ResourceLimitationParam',
        u'NoGroupCallNbParam',
        u'IncompatibleTerminalParam',
        u'ShortTermDenialParam',
        u'LongTermDenialParam',
        u'UnauthorizedRequestingNetwork-Param',
        u'UnauthorizedLCSClient-Param',
        u'UnauthorizedLCSClient-Diagnostic',
        u'PositionMethodFailure-Param',
        u'PositionMethodFailure-Diagnostic',
        u'UnknownOrUnreachableLCSClient-Param',
        u'MM-EventNotSupported-Param',
        u'TargetCellOutsideGCA-Param',
        u'OngoingGroupCallParam',
        ]
    _type_ = [
        u'RoamingNotAllowedParam',
        u'AdditionalRoamingNotAllowedCause',
        u'RoamingNotAllowedCause',
        u'CallBarredParam',
        u'CallBarringCause',
        u'ExtensibleCallBarredParam',
        u'CUG-RejectParam',
        u'CUG-RejectCause',
        u'SS-IncompatibilityCause',
        u'PW-RegistrationFailureCause',
        u'SM-EnumeratedDeliveryFailureCause',
        u'SM-DeliveryFailureCause',
        u'AbsentSubscriberSM-Param',
        u'AbsentSubscriberDiagnosticSM',
        u'SystemFailureParam',
        u'ExtensibleSystemFailureParam',
        u'FailureCauseParam',
        u'DataMissingParam',
        u'UnexpectedDataParam',
        u'FacilityNotSupParam',
        u'OR-NotAllowedParam',
        u'UnknownSubscriberParam',
        u'UnknownSubscriberDiagnostic',
        u'NumberChangedParam',
        u'UnidentifiedSubParam',
        u'IllegalSubscriberParam',
        u'IllegalEquipmentParam',
        u'BearerServNotProvParam',
        u'TeleservNotProvParam',
        u'TracingBufferFullParam',
        u'NoRoamingNbParam',
        u'AbsentSubscriberParam',
        u'AbsentSubscriberReason',
        u'BusySubscriberParam',
        u'NoSubscriberReplyParam',
        u'ForwardingViolationParam',
        u'ForwardingFailedParam',
        u'ATI-NotAllowedParam',
        u'ATSI-NotAllowedParam',
        u'ATM-NotAllowedParam',
        u'IllegalSS-OperationParam',
        u'SS-NotAvailableParam',
        u'SS-SubscriptionViolationParam',
        u'InformationNotAvailableParam',
        u'SubBusyForMT-SMS-Param',
        u'MessageWaitListFullParam',
        u'ResourceLimitationParam',
        u'NoGroupCallNbParam',
        u'IncompatibleTerminalParam',
        u'ShortTermDenialParam',
        u'LongTermDenialParam',
        u'UnauthorizedRequestingNetwork-Param',
        u'UnauthorizedLCSClient-Param',
        u'UnauthorizedLCSClient-Diagnostic',
        u'PositionMethodFailure-Param',
        u'PositionMethodFailure-Diagnostic',
        u'UnknownOrUnreachableLCSClient-Param',
        u'MM-EventNotSupported-Param',
        u'TargetCellOutsideGCA-Param',
        u'OngoingGroupCallParam',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoamingNotAllowedParam >-----#
    RoamingNotAllowedParam = SEQ(name=u'RoamingNotAllowedParam', mode=MODE_TYPE)
    _RoamingNotAllowedParam_roamingNotAllowedCause = ENUM(name=u'roamingNotAllowedCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'RoamingNotAllowedCause')))
    _RoamingNotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoamingNotAllowedParam_additionalRoamingNotAllowedCause = ENUM(name=u'additionalRoamingNotAllowedCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AdditionalRoamingNotAllowedCause')), opt=True)
    RoamingNotAllowedParam._cont = ASN1Dict([
        (u'roamingNotAllowedCause', _RoamingNotAllowedParam_roamingNotAllowedCause),
        (u'extensionContainer', _RoamingNotAllowedParam_extensionContainer),
        (u'additionalRoamingNotAllowedCause', _RoamingNotAllowedParam_additionalRoamingNotAllowedCause),
        ])
    RoamingNotAllowedParam._ext = [u'additionalRoamingNotAllowedCause']
    
    #-----< AdditionalRoamingNotAllowedCause >-----#
    AdditionalRoamingNotAllowedCause = ENUM(name=u'AdditionalRoamingNotAllowedCause', mode=MODE_TYPE)
    AdditionalRoamingNotAllowedCause._cont = ASN1Dict([(u'supportedRAT-TypesNotAllowed', 0)])
    AdditionalRoamingNotAllowedCause._ext = []
    
    #-----< RoamingNotAllowedCause >-----#
    RoamingNotAllowedCause = ENUM(name=u'RoamingNotAllowedCause', mode=MODE_TYPE)
    RoamingNotAllowedCause._cont = ASN1Dict([(u'plmnRoamingNotAllowed', 0), (u'operatorDeterminedBarring', 3)])
    RoamingNotAllowedCause._ext = None
    
    #-----< CallBarredParam >-----#
    CallBarredParam = CHOICE(name=u'CallBarredParam', mode=MODE_TYPE)
    _CallBarredParam_callBarringCause = ENUM(name=u'callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')))
    _CallBarredParam_extensibleCallBarredParam = SEQ(name=u'extensibleCallBarredParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleCallBarredParam')))
    CallBarredParam._cont = ASN1Dict([
        (u'callBarringCause', _CallBarredParam_callBarringCause),
        (u'extensibleCallBarredParam', _CallBarredParam_extensibleCallBarredParam),
        ])
    CallBarredParam._ext = None
    
    #-----< CallBarringCause >-----#
    CallBarringCause = ENUM(name=u'CallBarringCause', mode=MODE_TYPE)
    CallBarringCause._cont = ASN1Dict([(u'barringServiceActive', 0), (u'operatorBarring', 1)])
    CallBarringCause._ext = None
    
    #-----< ExtensibleCallBarredParam >-----#
    ExtensibleCallBarredParam = SEQ(name=u'ExtensibleCallBarredParam', mode=MODE_TYPE)
    _ExtensibleCallBarredParam_callBarringCause = ENUM(name=u'callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')), opt=True)
    _ExtensibleCallBarredParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleCallBarredParam_unauthorisedMessageOriginator = NULL(name=u'unauthorisedMessageOriginator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtensibleCallBarredParam_anonymousCallRejection = NULL(name=u'anonymousCallRejection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtensibleCallBarredParam._cont = ASN1Dict([
        (u'callBarringCause', _ExtensibleCallBarredParam_callBarringCause),
        (u'extensionContainer', _ExtensibleCallBarredParam_extensionContainer),
        (u'unauthorisedMessageOriginator', _ExtensibleCallBarredParam_unauthorisedMessageOriginator),
        (u'anonymousCallRejection', _ExtensibleCallBarredParam_anonymousCallRejection),
        ])
    ExtensibleCallBarredParam._ext = [u'unauthorisedMessageOriginator', u'anonymousCallRejection']
    
    #-----< CUG-RejectParam >-----#
    CUG_RejectParam = SEQ(name=u'CUG-RejectParam', mode=MODE_TYPE)
    _CUG_RejectParam_cug_RejectCause = ENUM(name=u'cug-RejectCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CUG-RejectCause')), opt=True)
    _CUG_RejectParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_RejectParam._cont = ASN1Dict([
        (u'cug-RejectCause', _CUG_RejectParam_cug_RejectCause),
        (u'extensionContainer', _CUG_RejectParam_extensionContainer),
        ])
    CUG_RejectParam._ext = []
    
    #-----< CUG-RejectCause >-----#
    CUG_RejectCause = ENUM(name=u'CUG-RejectCause', mode=MODE_TYPE)
    CUG_RejectCause._cont = ASN1Dict([(u'incomingCallsBarredWithinCUG', 0), (u'subscriberNotMemberOfCUG', 1), (u'requestedBasicServiceViolatesCUG-Constraints', 5), (u'calledPartySS-InteractionViolation', 7)])
    CUG_RejectCause._ext = None
    
    #-----< SS-IncompatibilityCause >-----#
    SS_IncompatibilityCause = SEQ(name=u'SS-IncompatibilityCause', mode=MODE_TYPE)
    _SS_IncompatibilityCause_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_IncompatibilityCause_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_IncompatibilityCause_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    SS_IncompatibilityCause._cont = ASN1Dict([
        (u'ss-Code', _SS_IncompatibilityCause_ss_Code),
        (u'basicService', _SS_IncompatibilityCause_basicService),
        (u'ss-Status', _SS_IncompatibilityCause_ss_Status),
        ])
    SS_IncompatibilityCause._ext = []
    
    #-----< PW-RegistrationFailureCause >-----#
    PW_RegistrationFailureCause = ENUM(name=u'PW-RegistrationFailureCause', mode=MODE_TYPE)
    PW_RegistrationFailureCause._cont = ASN1Dict([(u'undetermined', 0), (u'invalidFormat', 1), (u'newPasswordsMismatch', 2)])
    PW_RegistrationFailureCause._ext = None
    
    #-----< SM-EnumeratedDeliveryFailureCause >-----#
    SM_EnumeratedDeliveryFailureCause = ENUM(name=u'SM-EnumeratedDeliveryFailureCause', mode=MODE_TYPE)
    SM_EnumeratedDeliveryFailureCause._cont = ASN1Dict([(u'memoryCapacityExceeded', 0), (u'equipmentProtocolError', 1), (u'equipmentNotSM-Equipped', 2), (u'unknownServiceCentre', 3), (u'sc-Congestion', 4), (u'invalidSME-Address', 5), (u'subscriberNotSC-Subscriber', 6)])
    SM_EnumeratedDeliveryFailureCause._ext = None
    
    #-----< SM-DeliveryFailureCause >-----#
    SM_DeliveryFailureCause = SEQ(name=u'SM-DeliveryFailureCause', mode=MODE_TYPE)
    _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause = ENUM(name=u'sm-EnumeratedDeliveryFailureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'SM-EnumeratedDeliveryFailureCause')))
    _SM_DeliveryFailureCause_diagnosticInfo = OCT_STR(name=u'diagnosticInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _SM_DeliveryFailureCause_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SM_DeliveryFailureCause._cont = ASN1Dict([
        (u'sm-EnumeratedDeliveryFailureCause', _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause),
        (u'diagnosticInfo', _SM_DeliveryFailureCause_diagnosticInfo),
        (u'extensionContainer', _SM_DeliveryFailureCause_extensionContainer),
        ])
    SM_DeliveryFailureCause._ext = []
    
    #-----< AbsentSubscriberSM-Param >-----#
    AbsentSubscriberSM_Param = SEQ(name=u'AbsentSubscriberSM-Param', mode=MODE_TYPE)
    _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM = INT(name=u'absentSubscriberDiagnosticSM', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM = INT(name=u'additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _AbsentSubscriberSM_Param_requestedRetransmissionTime = OCT_STR(name=u'requestedRetransmissionTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _AbsentSubscriberSM_Param_userIdentifierAlert = OCT_STR(name=u'userIdentifierAlert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    AbsentSubscriberSM_Param._cont = ASN1Dict([
        (u'absentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM),
        (u'extensionContainer', _AbsentSubscriberSM_Param_extensionContainer),
        (u'additionalAbsentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM),
        (u'imsi', _AbsentSubscriberSM_Param_imsi),
        (u'requestedRetransmissionTime', _AbsentSubscriberSM_Param_requestedRetransmissionTime),
        (u'userIdentifierAlert', _AbsentSubscriberSM_Param_userIdentifierAlert),
        ])
    AbsentSubscriberSM_Param._ext = [u'additionalAbsentSubscriberDiagnosticSM', u'imsi', u'requestedRetransmissionTime', u'userIdentifierAlert']
    
    #-----< AbsentSubscriberDiagnosticSM >-----#
    AbsentSubscriberDiagnosticSM = INT(name=u'AbsentSubscriberDiagnosticSM', mode=MODE_TYPE)
    AbsentSubscriberDiagnosticSM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SystemFailureParam >-----#
    SystemFailureParam = CHOICE(name=u'SystemFailureParam', mode=MODE_TYPE)
    _SystemFailureParam_networkResource = ENUM(name=u'networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')))
    _SystemFailureParam_extensibleSystemFailureParam = SEQ(name=u'extensibleSystemFailureParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleSystemFailureParam')))
    SystemFailureParam._cont = ASN1Dict([
        (u'networkResource', _SystemFailureParam_networkResource),
        (u'extensibleSystemFailureParam', _SystemFailureParam_extensibleSystemFailureParam),
        ])
    SystemFailureParam._ext = None
    
    #-----< ExtensibleSystemFailureParam >-----#
    ExtensibleSystemFailureParam = SEQ(name=u'ExtensibleSystemFailureParam', mode=MODE_TYPE)
    _ExtensibleSystemFailureParam_networkResource = ENUM(name=u'networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleSystemFailureParam_additionalNetworkResource = ENUM(name=u'additionalNetworkResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AdditionalNetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_failureCauseParam = ENUM(name=u'failureCauseParam', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'FailureCauseParam')), opt=True)
    ExtensibleSystemFailureParam._cont = ASN1Dict([
        (u'networkResource', _ExtensibleSystemFailureParam_networkResource),
        (u'extensionContainer', _ExtensibleSystemFailureParam_extensionContainer),
        (u'additionalNetworkResource', _ExtensibleSystemFailureParam_additionalNetworkResource),
        (u'failureCauseParam', _ExtensibleSystemFailureParam_failureCauseParam),
        ])
    ExtensibleSystemFailureParam._ext = [u'additionalNetworkResource', u'failureCauseParam']
    
    #-----< FailureCauseParam >-----#
    FailureCauseParam = ENUM(name=u'FailureCauseParam', mode=MODE_TYPE)
    FailureCauseParam._cont = ASN1Dict([(u'limitReachedOnNumberOfConcurrentLocationRequests', 0)])
    FailureCauseParam._ext = []
    
    #-----< DataMissingParam >-----#
    DataMissingParam = SEQ(name=u'DataMissingParam', mode=MODE_TYPE)
    _DataMissingParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DataMissingParam._cont = ASN1Dict([
        (u'extensionContainer', _DataMissingParam_extensionContainer),
        ])
    DataMissingParam._ext = []
    
    #-----< UnexpectedDataParam >-----#
    UnexpectedDataParam = SEQ(name=u'UnexpectedDataParam', mode=MODE_TYPE)
    _UnexpectedDataParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnexpectedDataParam_unexpectedSubscriber = NULL(name=u'unexpectedSubscriber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UnexpectedDataParam._cont = ASN1Dict([
        (u'extensionContainer', _UnexpectedDataParam_extensionContainer),
        (u'unexpectedSubscriber', _UnexpectedDataParam_unexpectedSubscriber),
        ])
    UnexpectedDataParam._ext = [u'unexpectedSubscriber']
    
    #-----< FacilityNotSupParam >-----#
    FacilityNotSupParam = SEQ(name=u'FacilityNotSupParam', mode=MODE_TYPE)
    _FacilityNotSupParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _FacilityNotSupParam_shapeOfLocationEstimateNotSupported = NULL(name=u'shapeOfLocationEstimateNotSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode = NULL(name=u'neededLcsCapabilityNotSupportedInServingNode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    FacilityNotSupParam._cont = ASN1Dict([
        (u'extensionContainer', _FacilityNotSupParam_extensionContainer),
        (u'shapeOfLocationEstimateNotSupported', _FacilityNotSupParam_shapeOfLocationEstimateNotSupported),
        (u'neededLcsCapabilityNotSupportedInServingNode', _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode),
        ])
    FacilityNotSupParam._ext = [u'shapeOfLocationEstimateNotSupported', u'neededLcsCapabilityNotSupportedInServingNode']
    
    #-----< OR-NotAllowedParam >-----#
    OR_NotAllowedParam = SEQ(name=u'OR-NotAllowedParam', mode=MODE_TYPE)
    _OR_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OR_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _OR_NotAllowedParam_extensionContainer),
        ])
    OR_NotAllowedParam._ext = []
    
    #-----< UnknownSubscriberParam >-----#
    UnknownSubscriberParam = SEQ(name=u'UnknownSubscriberParam', mode=MODE_TYPE)
    _UnknownSubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnknownSubscriberParam_unknownSubscriberDiagnostic = ENUM(name=u'unknownSubscriberDiagnostic', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnknownSubscriberDiagnostic')), opt=True)
    UnknownSubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _UnknownSubscriberParam_extensionContainer),
        (u'unknownSubscriberDiagnostic', _UnknownSubscriberParam_unknownSubscriberDiagnostic),
        ])
    UnknownSubscriberParam._ext = [u'unknownSubscriberDiagnostic']
    
    #-----< UnknownSubscriberDiagnostic >-----#
    UnknownSubscriberDiagnostic = ENUM(name=u'UnknownSubscriberDiagnostic', mode=MODE_TYPE)
    UnknownSubscriberDiagnostic._cont = ASN1Dict([(u'imsiUnknown', 0), (u'gprs-eps-SubscriptionUnknown', 1), (u'npdbMismatch', 2)])
    UnknownSubscriberDiagnostic._ext = [u'npdbMismatch']
    
    #-----< NumberChangedParam >-----#
    NumberChangedParam = SEQ(name=u'NumberChangedParam', mode=MODE_TYPE)
    _NumberChangedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NumberChangedParam._cont = ASN1Dict([
        (u'extensionContainer', _NumberChangedParam_extensionContainer),
        ])
    NumberChangedParam._ext = []
    
    #-----< UnidentifiedSubParam >-----#
    UnidentifiedSubParam = SEQ(name=u'UnidentifiedSubParam', mode=MODE_TYPE)
    _UnidentifiedSubParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnidentifiedSubParam._cont = ASN1Dict([
        (u'extensionContainer', _UnidentifiedSubParam_extensionContainer),
        ])
    UnidentifiedSubParam._ext = []
    
    #-----< IllegalSubscriberParam >-----#
    IllegalSubscriberParam = SEQ(name=u'IllegalSubscriberParam', mode=MODE_TYPE)
    _IllegalSubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _IllegalSubscriberParam_extensionContainer),
        ])
    IllegalSubscriberParam._ext = []
    
    #-----< IllegalEquipmentParam >-----#
    IllegalEquipmentParam = SEQ(name=u'IllegalEquipmentParam', mode=MODE_TYPE)
    _IllegalEquipmentParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalEquipmentParam._cont = ASN1Dict([
        (u'extensionContainer', _IllegalEquipmentParam_extensionContainer),
        ])
    IllegalEquipmentParam._ext = []
    
    #-----< BearerServNotProvParam >-----#
    BearerServNotProvParam = SEQ(name=u'BearerServNotProvParam', mode=MODE_TYPE)
    _BearerServNotProvParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    BearerServNotProvParam._cont = ASN1Dict([
        (u'extensionContainer', _BearerServNotProvParam_extensionContainer),
        ])
    BearerServNotProvParam._ext = []
    
    #-----< TeleservNotProvParam >-----#
    TeleservNotProvParam = SEQ(name=u'TeleservNotProvParam', mode=MODE_TYPE)
    _TeleservNotProvParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TeleservNotProvParam._cont = ASN1Dict([
        (u'extensionContainer', _TeleservNotProvParam_extensionContainer),
        ])
    TeleservNotProvParam._ext = []
    
    #-----< TracingBufferFullParam >-----#
    TracingBufferFullParam = SEQ(name=u'TracingBufferFullParam', mode=MODE_TYPE)
    _TracingBufferFullParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TracingBufferFullParam._cont = ASN1Dict([
        (u'extensionContainer', _TracingBufferFullParam_extensionContainer),
        ])
    TracingBufferFullParam._ext = []
    
    #-----< NoRoamingNbParam >-----#
    NoRoamingNbParam = SEQ(name=u'NoRoamingNbParam', mode=MODE_TYPE)
    _NoRoamingNbParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoRoamingNbParam._cont = ASN1Dict([
        (u'extensionContainer', _NoRoamingNbParam_extensionContainer),
        ])
    NoRoamingNbParam._ext = []
    
    #-----< AbsentSubscriberParam >-----#
    AbsentSubscriberParam = SEQ(name=u'AbsentSubscriberParam', mode=MODE_TYPE)
    _AbsentSubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberParam_absentSubscriberReason = ENUM(name=u'absentSubscriberReason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberReason')), opt=True)
    AbsentSubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _AbsentSubscriberParam_extensionContainer),
        (u'absentSubscriberReason', _AbsentSubscriberParam_absentSubscriberReason),
        ])
    AbsentSubscriberParam._ext = [u'absentSubscriberReason']
    
    #-----< AbsentSubscriberReason >-----#
    AbsentSubscriberReason = ENUM(name=u'AbsentSubscriberReason', mode=MODE_TYPE)
    AbsentSubscriberReason._cont = ASN1Dict([(u'imsiDetach', 0), (u'restrictedArea', 1), (u'noPageResponse', 2), (u'purgedMS', 3), (u'mtRoamingRetry', 4), (u'busySubscriber', 5)])
    AbsentSubscriberReason._ext = [u'purgedMS', u'mtRoamingRetry', u'busySubscriber']
    
    #-----< BusySubscriberParam >-----#
    BusySubscriberParam = SEQ(name=u'BusySubscriberParam', mode=MODE_TYPE)
    _BusySubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _BusySubscriberParam_ccbs_Possible = NULL(name=u'ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BusySubscriberParam_ccbs_Busy = NULL(name=u'ccbs-Busy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BusySubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _BusySubscriberParam_extensionContainer),
        (u'ccbs-Possible', _BusySubscriberParam_ccbs_Possible),
        (u'ccbs-Busy', _BusySubscriberParam_ccbs_Busy),
        ])
    BusySubscriberParam._ext = [u'ccbs-Possible', u'ccbs-Busy']
    
    #-----< NoSubscriberReplyParam >-----#
    NoSubscriberReplyParam = SEQ(name=u'NoSubscriberReplyParam', mode=MODE_TYPE)
    _NoSubscriberReplyParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoSubscriberReplyParam._cont = ASN1Dict([
        (u'extensionContainer', _NoSubscriberReplyParam_extensionContainer),
        ])
    NoSubscriberReplyParam._ext = []
    
    #-----< ForwardingViolationParam >-----#
    ForwardingViolationParam = SEQ(name=u'ForwardingViolationParam', mode=MODE_TYPE)
    _ForwardingViolationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingViolationParam._cont = ASN1Dict([
        (u'extensionContainer', _ForwardingViolationParam_extensionContainer),
        ])
    ForwardingViolationParam._ext = []
    
    #-----< ForwardingFailedParam >-----#
    ForwardingFailedParam = SEQ(name=u'ForwardingFailedParam', mode=MODE_TYPE)
    _ForwardingFailedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingFailedParam._cont = ASN1Dict([
        (u'extensionContainer', _ForwardingFailedParam_extensionContainer),
        ])
    ForwardingFailedParam._ext = []
    
    #-----< ATI-NotAllowedParam >-----#
    ATI_NotAllowedParam = SEQ(name=u'ATI-NotAllowedParam', mode=MODE_TYPE)
    _ATI_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATI_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _ATI_NotAllowedParam_extensionContainer),
        ])
    ATI_NotAllowedParam._ext = []
    
    #-----< ATSI-NotAllowedParam >-----#
    ATSI_NotAllowedParam = SEQ(name=u'ATSI-NotAllowedParam', mode=MODE_TYPE)
    _ATSI_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATSI_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _ATSI_NotAllowedParam_extensionContainer),
        ])
    ATSI_NotAllowedParam._ext = []
    
    #-----< ATM-NotAllowedParam >-----#
    ATM_NotAllowedParam = SEQ(name=u'ATM-NotAllowedParam', mode=MODE_TYPE)
    _ATM_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATM_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _ATM_NotAllowedParam_extensionContainer),
        ])
    ATM_NotAllowedParam._ext = []
    
    #-----< IllegalSS-OperationParam >-----#
    IllegalSS_OperationParam = SEQ(name=u'IllegalSS-OperationParam', mode=MODE_TYPE)
    _IllegalSS_OperationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSS_OperationParam._cont = ASN1Dict([
        (u'extensionContainer', _IllegalSS_OperationParam_extensionContainer),
        ])
    IllegalSS_OperationParam._ext = []
    
    #-----< SS-NotAvailableParam >-----#
    SS_NotAvailableParam = SEQ(name=u'SS-NotAvailableParam', mode=MODE_TYPE)
    _SS_NotAvailableParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_NotAvailableParam._cont = ASN1Dict([
        (u'extensionContainer', _SS_NotAvailableParam_extensionContainer),
        ])
    SS_NotAvailableParam._ext = []
    
    #-----< SS-SubscriptionViolationParam >-----#
    SS_SubscriptionViolationParam = SEQ(name=u'SS-SubscriptionViolationParam', mode=MODE_TYPE)
    _SS_SubscriptionViolationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_SubscriptionViolationParam._cont = ASN1Dict([
        (u'extensionContainer', _SS_SubscriptionViolationParam_extensionContainer),
        ])
    SS_SubscriptionViolationParam._ext = []
    
    #-----< InformationNotAvailableParam >-----#
    InformationNotAvailableParam = SEQ(name=u'InformationNotAvailableParam', mode=MODE_TYPE)
    _InformationNotAvailableParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    InformationNotAvailableParam._cont = ASN1Dict([
        (u'extensionContainer', _InformationNotAvailableParam_extensionContainer),
        ])
    InformationNotAvailableParam._ext = []
    
    #-----< SubBusyForMT-SMS-Param >-----#
    SubBusyForMT_SMS_Param = SEQ(name=u'SubBusyForMT-SMS-Param', mode=MODE_TYPE)
    _SubBusyForMT_SMS_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubBusyForMT_SMS_Param_gprsConnectionSuspended = NULL(name=u'gprsConnectionSuspended', mode=MODE_TYPE, opt=True)
    SubBusyForMT_SMS_Param._cont = ASN1Dict([
        (u'extensionContainer', _SubBusyForMT_SMS_Param_extensionContainer),
        (u'gprsConnectionSuspended', _SubBusyForMT_SMS_Param_gprsConnectionSuspended),
        ])
    SubBusyForMT_SMS_Param._ext = [u'gprsConnectionSuspended']
    
    #-----< MessageWaitListFullParam >-----#
    MessageWaitListFullParam = SEQ(name=u'MessageWaitListFullParam', mode=MODE_TYPE)
    _MessageWaitListFullParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MessageWaitListFullParam._cont = ASN1Dict([
        (u'extensionContainer', _MessageWaitListFullParam_extensionContainer),
        ])
    MessageWaitListFullParam._ext = []
    
    #-----< ResourceLimitationParam >-----#
    ResourceLimitationParam = SEQ(name=u'ResourceLimitationParam', mode=MODE_TYPE)
    _ResourceLimitationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResourceLimitationParam._cont = ASN1Dict([
        (u'extensionContainer', _ResourceLimitationParam_extensionContainer),
        ])
    ResourceLimitationParam._ext = []
    
    #-----< NoGroupCallNbParam >-----#
    NoGroupCallNbParam = SEQ(name=u'NoGroupCallNbParam', mode=MODE_TYPE)
    _NoGroupCallNbParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoGroupCallNbParam._cont = ASN1Dict([
        (u'extensionContainer', _NoGroupCallNbParam_extensionContainer),
        ])
    NoGroupCallNbParam._ext = []
    
    #-----< IncompatibleTerminalParam >-----#
    IncompatibleTerminalParam = SEQ(name=u'IncompatibleTerminalParam', mode=MODE_TYPE)
    _IncompatibleTerminalParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IncompatibleTerminalParam._cont = ASN1Dict([
        (u'extensionContainer', _IncompatibleTerminalParam_extensionContainer),
        ])
    IncompatibleTerminalParam._ext = []
    
    #-----< ShortTermDenialParam >-----#
    ShortTermDenialParam = SEQ(name=u'ShortTermDenialParam', mode=MODE_TYPE)
    ShortTermDenialParam._cont = ASN1Dict([
        ])
    ShortTermDenialParam._ext = []
    
    #-----< LongTermDenialParam >-----#
    LongTermDenialParam = SEQ(name=u'LongTermDenialParam', mode=MODE_TYPE)
    LongTermDenialParam._cont = ASN1Dict([
        ])
    LongTermDenialParam._ext = []
    
    #-----< UnauthorizedRequestingNetwork-Param >-----#
    UnauthorizedRequestingNetwork_Param = SEQ(name=u'UnauthorizedRequestingNetwork-Param', mode=MODE_TYPE)
    _UnauthorizedRequestingNetwork_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedRequestingNetwork_Param._cont = ASN1Dict([
        (u'extensionContainer', _UnauthorizedRequestingNetwork_Param_extensionContainer),
        ])
    UnauthorizedRequestingNetwork_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Param >-----#
    UnauthorizedLCSClient_Param = SEQ(name=u'UnauthorizedLCSClient-Param', mode=MODE_TYPE)
    _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic = ENUM(name=u'unauthorizedLCSClient-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnauthorizedLCSClient-Diagnostic')), opt=True)
    _UnauthorizedLCSClient_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedLCSClient_Param._cont = ASN1Dict([
        (u'unauthorizedLCSClient-Diagnostic', _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic),
        (u'extensionContainer', _UnauthorizedLCSClient_Param_extensionContainer),
        ])
    UnauthorizedLCSClient_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Diagnostic >-----#
    UnauthorizedLCSClient_Diagnostic = ENUM(name=u'UnauthorizedLCSClient-Diagnostic', mode=MODE_TYPE)
    UnauthorizedLCSClient_Diagnostic._cont = ASN1Dict([(u'noAdditionalInformation', 0), (u'clientNotInMSPrivacyExceptionList', 1), (u'callToClientNotSetup', 2), (u'privacyOverrideNotApplicable', 3), (u'disallowedByLocalRegulatoryRequirements', 4), (u'unauthorizedPrivacyClass', 5), (u'unauthorizedCallSessionUnrelatedExternalClient', 6), (u'unauthorizedCallSessionRelatedExternalClient', 7)])
    UnauthorizedLCSClient_Diagnostic._ext = [u'unauthorizedPrivacyClass', u'unauthorizedCallSessionUnrelatedExternalClient', u'unauthorizedCallSessionRelatedExternalClient']
    
    #-----< PositionMethodFailure-Param >-----#
    PositionMethodFailure_Param = SEQ(name=u'PositionMethodFailure-Param', mode=MODE_TYPE)
    _PositionMethodFailure_Param_positionMethodFailure_Diagnostic = ENUM(name=u'positionMethodFailure-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'PositionMethodFailure-Diagnostic')), opt=True)
    _PositionMethodFailure_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PositionMethodFailure_Param._cont = ASN1Dict([
        (u'positionMethodFailure-Diagnostic', _PositionMethodFailure_Param_positionMethodFailure_Diagnostic),
        (u'extensionContainer', _PositionMethodFailure_Param_extensionContainer),
        ])
    PositionMethodFailure_Param._ext = []
    
    #-----< PositionMethodFailure-Diagnostic >-----#
    PositionMethodFailure_Diagnostic = ENUM(name=u'PositionMethodFailure-Diagnostic', mode=MODE_TYPE)
    PositionMethodFailure_Diagnostic._cont = ASN1Dict([(u'congestion', 0), (u'insufficientResources', 1), (u'insufficientMeasurementData', 2), (u'inconsistentMeasurementData', 3), (u'locationProcedureNotCompleted', 4), (u'locationProcedureNotSupportedByTargetMS', 5), (u'qoSNotAttainable', 6), (u'positionMethodNotAvailableInNetwork', 7), (u'positionMethodNotAvailableInLocationArea', 8)])
    PositionMethodFailure_Diagnostic._ext = []
    
    #-----< UnknownOrUnreachableLCSClient-Param >-----#
    UnknownOrUnreachableLCSClient_Param = SEQ(name=u'UnknownOrUnreachableLCSClient-Param', mode=MODE_TYPE)
    _UnknownOrUnreachableLCSClient_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnknownOrUnreachableLCSClient_Param._cont = ASN1Dict([
        (u'extensionContainer', _UnknownOrUnreachableLCSClient_Param_extensionContainer),
        ])
    UnknownOrUnreachableLCSClient_Param._ext = []
    
    #-----< MM-EventNotSupported-Param >-----#
    MM_EventNotSupported_Param = SEQ(name=u'MM-EventNotSupported-Param', mode=MODE_TYPE)
    _MM_EventNotSupported_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MM_EventNotSupported_Param._cont = ASN1Dict([
        (u'extensionContainer', _MM_EventNotSupported_Param_extensionContainer),
        ])
    MM_EventNotSupported_Param._ext = []
    
    #-----< TargetCellOutsideGCA-Param >-----#
    TargetCellOutsideGCA_Param = SEQ(name=u'TargetCellOutsideGCA-Param', mode=MODE_TYPE)
    _TargetCellOutsideGCA_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TargetCellOutsideGCA_Param._cont = ASN1Dict([
        (u'extensionContainer', _TargetCellOutsideGCA_Param_extensionContainer),
        ])
    TargetCellOutsideGCA_Param._ext = []
    
    #-----< OngoingGroupCallParam >-----#
    OngoingGroupCallParam = SEQ(name=u'OngoingGroupCallParam', mode=MODE_TYPE)
    _OngoingGroupCallParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OngoingGroupCallParam._cont = ASN1Dict([
        (u'extensionContainer', _OngoingGroupCallParam_extensionContainer),
        ])
    OngoingGroupCallParam._ext = []
    
    _all_ = [
        _RoamingNotAllowedParam_roamingNotAllowedCause,
        _RoamingNotAllowedParam_extensionContainer,
        _RoamingNotAllowedParam_additionalRoamingNotAllowedCause,
        RoamingNotAllowedParam,
        AdditionalRoamingNotAllowedCause,
        RoamingNotAllowedCause,
        _CallBarredParam_callBarringCause,
        _CallBarredParam_extensibleCallBarredParam,
        CallBarredParam,
        CallBarringCause,
        _ExtensibleCallBarredParam_callBarringCause,
        _ExtensibleCallBarredParam_extensionContainer,
        _ExtensibleCallBarredParam_unauthorisedMessageOriginator,
        _ExtensibleCallBarredParam_anonymousCallRejection,
        ExtensibleCallBarredParam,
        _CUG_RejectParam_cug_RejectCause,
        _CUG_RejectParam_extensionContainer,
        CUG_RejectParam,
        CUG_RejectCause,
        _SS_IncompatibilityCause_ss_Code,
        _SS_IncompatibilityCause_basicService,
        _SS_IncompatibilityCause_ss_Status,
        SS_IncompatibilityCause,
        PW_RegistrationFailureCause,
        SM_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_diagnosticInfo,
        _SM_DeliveryFailureCause_extensionContainer,
        SM_DeliveryFailureCause,
        _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_extensionContainer,
        _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_imsi,
        _AbsentSubscriberSM_Param_requestedRetransmissionTime,
        _AbsentSubscriberSM_Param_userIdentifierAlert,
        AbsentSubscriberSM_Param,
        AbsentSubscriberDiagnosticSM,
        _SystemFailureParam_networkResource,
        _SystemFailureParam_extensibleSystemFailureParam,
        SystemFailureParam,
        _ExtensibleSystemFailureParam_networkResource,
        _ExtensibleSystemFailureParam_extensionContainer,
        _ExtensibleSystemFailureParam_additionalNetworkResource,
        _ExtensibleSystemFailureParam_failureCauseParam,
        ExtensibleSystemFailureParam,
        FailureCauseParam,
        _DataMissingParam_extensionContainer,
        DataMissingParam,
        _UnexpectedDataParam_extensionContainer,
        _UnexpectedDataParam_unexpectedSubscriber,
        UnexpectedDataParam,
        _FacilityNotSupParam_extensionContainer,
        _FacilityNotSupParam_shapeOfLocationEstimateNotSupported,
        _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode,
        FacilityNotSupParam,
        _OR_NotAllowedParam_extensionContainer,
        OR_NotAllowedParam,
        _UnknownSubscriberParam_extensionContainer,
        _UnknownSubscriberParam_unknownSubscriberDiagnostic,
        UnknownSubscriberParam,
        UnknownSubscriberDiagnostic,
        _NumberChangedParam_extensionContainer,
        NumberChangedParam,
        _UnidentifiedSubParam_extensionContainer,
        UnidentifiedSubParam,
        _IllegalSubscriberParam_extensionContainer,
        IllegalSubscriberParam,
        _IllegalEquipmentParam_extensionContainer,
        IllegalEquipmentParam,
        _BearerServNotProvParam_extensionContainer,
        BearerServNotProvParam,
        _TeleservNotProvParam_extensionContainer,
        TeleservNotProvParam,
        _TracingBufferFullParam_extensionContainer,
        TracingBufferFullParam,
        _NoRoamingNbParam_extensionContainer,
        NoRoamingNbParam,
        _AbsentSubscriberParam_extensionContainer,
        _AbsentSubscriberParam_absentSubscriberReason,
        AbsentSubscriberParam,
        AbsentSubscriberReason,
        _BusySubscriberParam_extensionContainer,
        _BusySubscriberParam_ccbs_Possible,
        _BusySubscriberParam_ccbs_Busy,
        BusySubscriberParam,
        _NoSubscriberReplyParam_extensionContainer,
        NoSubscriberReplyParam,
        _ForwardingViolationParam_extensionContainer,
        ForwardingViolationParam,
        _ForwardingFailedParam_extensionContainer,
        ForwardingFailedParam,
        _ATI_NotAllowedParam_extensionContainer,
        ATI_NotAllowedParam,
        _ATSI_NotAllowedParam_extensionContainer,
        ATSI_NotAllowedParam,
        _ATM_NotAllowedParam_extensionContainer,
        ATM_NotAllowedParam,
        _IllegalSS_OperationParam_extensionContainer,
        IllegalSS_OperationParam,
        _SS_NotAvailableParam_extensionContainer,
        SS_NotAvailableParam,
        _SS_SubscriptionViolationParam_extensionContainer,
        SS_SubscriptionViolationParam,
        _InformationNotAvailableParam_extensionContainer,
        InformationNotAvailableParam,
        _SubBusyForMT_SMS_Param_extensionContainer,
        _SubBusyForMT_SMS_Param_gprsConnectionSuspended,
        SubBusyForMT_SMS_Param,
        _MessageWaitListFullParam_extensionContainer,
        MessageWaitListFullParam,
        _ResourceLimitationParam_extensionContainer,
        ResourceLimitationParam,
        _NoGroupCallNbParam_extensionContainer,
        NoGroupCallNbParam,
        _IncompatibleTerminalParam_extensionContainer,
        IncompatibleTerminalParam,
        ShortTermDenialParam,
        LongTermDenialParam,
        _UnauthorizedRequestingNetwork_Param_extensionContainer,
        UnauthorizedRequestingNetwork_Param,
        _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic,
        _UnauthorizedLCSClient_Param_extensionContainer,
        UnauthorizedLCSClient_Param,
        UnauthorizedLCSClient_Diagnostic,
        _PositionMethodFailure_Param_positionMethodFailure_Diagnostic,
        _PositionMethodFailure_Param_extensionContainer,
        PositionMethodFailure_Param,
        PositionMethodFailure_Diagnostic,
        _UnknownOrUnreachableLCSClient_Param_extensionContainer,
        UnknownOrUnreachableLCSClient_Param,
        _MM_EventNotSupported_Param_extensionContainer,
        MM_EventNotSupported_Param,
        _TargetCellOutsideGCA_Param_extensionContainer,
        TargetCellOutsideGCA_Param,
        _OngoingGroupCallParam_extensionContainer,
        OngoingGroupCallParam,
    ]

class MAP_ExtensionDataTypes:

    _name_  = u'MAP-ExtensionDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 21, 19]
    
    _obj_ = [
        u'MAP-EXTENSION',
        u'ExtensionContainer',
        u'SLR-ArgExtensionContainer',
        u'PrivateExtensionList',
        u'PrivateExtension',
        u'maxNumOfPrivateExtensions',
        u'ExtensionSet',
        u'PCS-Extensions',
        u'SLR-Arg-PCS-Extensions',
        ]
    _type_ = [
        u'MAP-EXTENSION',
        u'ExtensionContainer',
        u'SLR-ArgExtensionContainer',
        u'PrivateExtensionList',
        u'PrivateExtension',
        u'PCS-Extensions',
        u'SLR-Arg-PCS-Extensions',
        ]
    _set_ = [
        u'ExtensionSet',
        ]
    _val_ = [
        u'maxNumOfPrivateExtensions',
        ]
    _class_ = [
        u'MAP-EXTENSION',
        u'ExtensionSet',
        ]
    _param_ = [
        ]
    
    #-----< MAP-EXTENSION >-----#
    MAP_EXTENSION = CLASS(name=u'MAP-EXTENSION', mode=MODE_TYPE)
    _MAP_EXTENSION_ExtensionType = OPEN(name=u'ExtensionType', mode=MODE_TYPE, opt=True)
    _MAP_EXTENSION_extensionId = OID(name=u'extensionId', mode=MODE_VALUE)
    MAP_EXTENSION._cont = ASN1Dict([
        (u'ExtensionType', _MAP_EXTENSION_ExtensionType),
        (u'extensionId', _MAP_EXTENSION_extensionId),
        ])
    
    #-----< ExtensionContainer >-----#
    ExtensionContainer = SEQ(name=u'ExtensionContainer', mode=MODE_TYPE)
    _ExtensionContainer_privateExtensionList = SEQ_OF(name=u'privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _ExtensionContainer_pcs_Extensions = SEQ(name=u'pcs-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PCS-Extensions')), opt=True)
    ExtensionContainer._cont = ASN1Dict([
        (u'privateExtensionList', _ExtensionContainer_privateExtensionList),
        (u'pcs-Extensions', _ExtensionContainer_pcs_Extensions),
        ])
    ExtensionContainer._ext = []
    
    #-----< SLR-ArgExtensionContainer >-----#
    SLR_ArgExtensionContainer = SEQ(name=u'SLR-ArgExtensionContainer', mode=MODE_TYPE)
    _SLR_ArgExtensionContainer_privateExtensionList = SEQ_OF(name=u'privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions = SEQ(name=u'slr-Arg-PCS-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'SLR-Arg-PCS-Extensions')), opt=True)
    SLR_ArgExtensionContainer._cont = ASN1Dict([
        (u'privateExtensionList', _SLR_ArgExtensionContainer_privateExtensionList),
        (u'slr-Arg-PCS-Extensions', _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions),
        ])
    SLR_ArgExtensionContainer._ext = []
    
    #-----< PrivateExtensionList >-----#
    PrivateExtensionList = SEQ_OF(name=u'PrivateExtensionList', mode=MODE_TYPE)
    _PrivateExtensionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtension')))
    PrivateExtensionList._cont = _PrivateExtensionList__item_
    PrivateExtensionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< PrivateExtension >-----#
    PrivateExtension = SEQ(name=u'PrivateExtension', mode=MODE_TYPE)
    _PrivateExtension_extId = OID(name=u'extId', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), [u'extensionId']))
    __PrivateExtension_extId_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extId._const_tab = __PrivateExtension_extId_tab
    _PrivateExtension_extId._const_tab_at = None
    _PrivateExtension_extId._const_tab_id = u'extensionId'
    _PrivateExtension_extType = OPEN(name=u'extType', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), [u'ExtensionType']), opt=True)
    __PrivateExtension_extType_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extType._const_tab = __PrivateExtension_extType_tab
    _PrivateExtension_extType._const_tab_at = ('..', u'extId')
    _PrivateExtension_extType._const_tab_id = u'ExtensionType'
    PrivateExtension._cont = ASN1Dict([
        (u'extId', _PrivateExtension_extId),
        (u'extType', _PrivateExtension_extType),
        ])
    PrivateExtension._ext = None
    
    #-----< maxNumOfPrivateExtensions >-----#
    maxNumOfPrivateExtensions = INT(name=u'maxNumOfPrivateExtensions', mode=MODE_VALUE)
    maxNumOfPrivateExtensions._val = 10
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name=u'ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCS-Extensions >-----#
    PCS_Extensions = SEQ(name=u'PCS-Extensions', mode=MODE_TYPE)
    PCS_Extensions._cont = ASN1Dict([
        ])
    PCS_Extensions._ext = []
    
    #-----< SLR-Arg-PCS-Extensions >-----#
    SLR_Arg_PCS_Extensions = SEQ(name=u'SLR-Arg-PCS-Extensions', mode=MODE_TYPE)
    _SLR_Arg_PCS_Extensions_na_ESRK_Request = NULL(name=u'na-ESRK-Request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SLR_Arg_PCS_Extensions._cont = ASN1Dict([
        (u'na-ESRK-Request', _SLR_Arg_PCS_Extensions_na_ESRK_Request),
        ])
    SLR_Arg_PCS_Extensions._ext = [u'na-ESRK-Request']
    
    _all_ = [
        _MAP_EXTENSION_ExtensionType,
        _MAP_EXTENSION_extensionId,
        MAP_EXTENSION,
        _ExtensionContainer_privateExtensionList,
        _ExtensionContainer_pcs_Extensions,
        ExtensionContainer,
        _SLR_ArgExtensionContainer_privateExtensionList,
        _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions,
        SLR_ArgExtensionContainer,
        _PrivateExtensionList__item_,
        PrivateExtensionList,
        __PrivateExtension_extId_tab,
        _PrivateExtension_extId,
        __PrivateExtension_extType_tab,
        _PrivateExtension_extType,
        PrivateExtension,
        maxNumOfPrivateExtensions,
        ExtensionSet,
        PCS_Extensions,
        _SLR_Arg_PCS_Extensions_na_ESRK_Request,
        SLR_Arg_PCS_Extensions,
    ]

class MAP_MS_DataTypes:

    _name_  = u'MAP-MS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 11, 19]
    
    _obj_ = [
        u'UpdateLocationArg',
        u'VLR-Capability',
        u'SupportedRAT-Types',
        u'SuperChargerInfo',
        u'AgeIndicator',
        u'IST-SupportIndicator',
        u'SupportedLCS-CapabilitySets',
        u'UpdateLocationRes',
        u'ADD-Info',
        u'PagingArea',
        u'LocationArea',
        u'LAC',
        u'CancelLocationArg',
        u'TypeOfUpdate',
        u'CancellationType',
        u'CancelLocationRes',
        u'PurgeMS-Arg',
        u'PurgeMS-Res',
        u'SendIdentificationArg',
        u'HopCounter',
        u'SendIdentificationRes',
        u'AuthenticationSetList',
        u'TripletList',
        u'QuintupletList',
        u'AuthenticationTriplet',
        u'AuthenticationQuintuplet',
        u'CurrentSecurityContext',
        u'GSM-SecurityContextData',
        u'UMTS-SecurityContextData',
        u'RAND',
        u'SRES',
        u'Kc',
        u'XRES',
        u'CK',
        u'IK',
        u'AUTN',
        u'AUTS',
        u'Cksn',
        u'KSI',
        u'AuthenticationFailureReportArg',
        u'AccessType',
        u'AuthenticationFailureReportRes',
        u'FailureCause',
        u'UpdateGprsLocationArg',
        u'SMSRegisterRequest',
        u'Used-RAT-Type',
        u'EPS-Info',
        u'PDN-GW-Update',
        u'ISR-Information',
        u'SGSN-Capability',
        u'SupportedFeatures',
        u'Ext-SupportedFeatures',
        u'UE-SRVCC-Capability',
        u'UpdateGprsLocationRes',
        u'EPLMN-List',
        u'AdjacentPLMN-List',
        u'ForwardAccessSignalling-Arg',
        u'AllowedGSM-Algorithms',
        u'AllowedUMTS-Algorithms',
        u'PermittedIntegrityProtectionAlgorithms',
        u'maxPermittedIntegrityProtectionAlgorithmsLength',
        u'PermittedEncryptionAlgorithms',
        u'maxPermittedEncryptionAlgorithmsLength',
        u'KeyStatus',
        u'PrepareHO-Arg',
        u'LCLS-GlobalCallReference',
        u'LCLS-Negotiation',
        u'LCLS-ConfigurationPreference',
        u'BSSMAP-ServiceHandoverList',
        u'BSSMAP-ServiceHandoverInfo',
        u'maxNumOfServiceHandovers',
        u'BSSMAP-ServiceHandover',
        u'RANAP-ServiceHandover',
        u'RadioResourceList',
        u'RadioResource',
        u'maxNumOfRadioResources',
        u'PrepareHO-Res',
        u'SelectedUMTS-Algorithms',
        u'ChosenIntegrityProtectionAlgorithm',
        u'ChosenEncryptionAlgorithm',
        u'ChosenRadioResourceInformation',
        u'ChosenChannelInfo',
        u'ChosenSpeechVersion',
        u'PrepareSubsequentHO-Arg',
        u'PrepareSubsequentHO-Res',
        u'ProcessAccessSignalling-Arg',
        u'AoIPCodecsList',
        u'AoIPCodec',
        u'SupportedCodecsList',
        u'CodecList',
        u'Codec',
        u'GERAN-Classmark',
        u'SelectedGSM-Algorithm',
        u'SendEndSignal-Arg',
        u'SendEndSignal-Res',
        u'RNCId',
        u'RelocationNumberList',
        u'MulticallBearerInfo',
        u'RelocationNumber',
        u'RAB-Id',
        u'maxNrOfRABs',
        u'maxNumOfRelocationNumber',
        u'RadioResourceInformation',
        u'IntegrityProtectionInformation',
        u'maxNumOfIntegrityInfo',
        u'EncryptionInformation',
        u'maxNumOfEncryptionInfo',
        u'SendAuthenticationInfoArg',
        u'NumberOfRequestedVectors',
        u'Re-synchronisationInfo',
        u'SendAuthenticationInfoRes',
        u'EPS-AuthenticationSetList',
        u'UE-UsageType',
        u'EPC-AV',
        u'KASME',
        u'RequestingNodeType',
        u'CheckIMEI-Arg',
        u'CheckIMEI-Res',
        u'RequestedEquipmentInfo',
        u'UESBI-Iu',
        u'UESBI-IuA',
        u'UESBI-IuB',
        u'EquipmentStatus',
        u'InsertSubscriberDataArg',
        u'EDRX-Cycle-Length-List',
        u'EDRX-Cycle-Length',
        u'EDRX-Cycle-Length-Value',
        u'Reset-Id-List',
        u'Reset-Id',
        u'DL-Buffering-Suggested-Packet-Count',
        u'Group-Service-ID',
        u'Local-GroupID',
        u'IMSI-GroupIdList',
        u'IMSI-GroupId',
        u'SubscribedPeriodicRAUTAUtimer',
        u'SubscribedPeriodicLAUtimer',
        u'CSG-SubscriptionDataList',
        u'CSG-SubscriptionData',
        u'VPLMN-CSG-SubscriptionDataList',
        u'CSG-Id',
        u'LIPA-AllowedAPNList',
        u'maxNumOfLIPAAllowedAPN',
        u'EPS-SubscriptionData',
        u'APN-OI-Replacement',
        u'RFSP-ID',
        u'APN-ConfigurationProfile',
        u'EPS-DataList',
        u'maxNumOfAPN-Configurations',
        u'APN-Configuration',
        u'PDN-ConnectionContinuity',
        u'NIDD-Mechanism',
        u'PDN-Type',
        u'EPS-QoS-Subscribed',
        u'AMBR',
        u'SpecificAPNInfoList',
        u'maxNumOfSpecificAPNInfos',
        u'SpecificAPNInfo',
        u'Bandwidth',
        u'BandwidthExt',
        u'QoS-Class-Identifier',
        u'Allocation-Retention-Priority',
        u'PDN-GW-Identity',
        u'FQDN',
        u'PDN-GW-AllocationType',
        u'WLAN-Offloadability',
        u'WLAN-Offloadability-Indication',
        u'AccessRestrictionData',
        u'Ext-AccessRestrictionData',
        u'AdjacentAccessRestrictionDataList',
        u'AdjacentAccessRestrictionData',
        u'CS-AllocationRetentionPriority',
        u'IST-AlertTimerValue',
        u'LCSInformation',
        u'GMLC-List',
        u'maxNumOfGMLC',
        u'NetworkAccessMode',
        u'GPRSDataList',
        u'maxNumOfPDP-Contexts',
        u'PDP-Context',
        u'Restoration-Priority',
        u'SIPTO-Permission',
        u'SIPTO-Local-Network-Permission',
        u'LIPA-Permission',
        u'ContextId',
        u'GPRSSubscriptionData',
        u'SGSN-CAMEL-SubscriptionInfo',
        u'GPRS-CSI',
        u'GPRS-CamelTDPDataList',
        u'GPRS-CamelTDPData',
        u'DefaultGPRS-Handling',
        u'GPRS-TriggerDetectionPoint',
        u'APN',
        u'PDP-Type',
        u'Ext-PDP-Type',
        u'PDP-Address',
        u'QoS-Subscribed',
        u'Ext-QoS-Subscribed',
        u'Ext2-QoS-Subscribed',
        u'Ext3-QoS-Subscribed',
        u'Ext4-QoS-Subscribed',
        u'ChargingCharacteristics',
        u'LSAOnlyAccessIndicator',
        u'LSADataList',
        u'maxNumOfLSAs',
        u'LSAData',
        u'LSAInformation',
        u'LSAIdentity',
        u'LSAAttributes',
        u'SubscriberData',
        u'Category',
        u'SubscriberStatus',
        u'BearerServiceList',
        u'maxNumOfBearerServices',
        u'TeleserviceList',
        u'maxNumOfTeleservices',
        u'ODB-Data',
        u'ODB-GeneralData',
        u'ODB-HPLMN-Data',
        u'Ext-SS-InfoList',
        u'Ext-SS-Info',
        u'Ext-ForwInfo',
        u'Ext-ForwFeatureList',
        u'Ext-ForwFeature',
        u'Ext-ForwOptions',
        u'Ext-NoRepCondTime',
        u'Ext-CallBarInfo',
        u'Ext-CallBarFeatureList',
        u'Ext-CallBarringFeature',
        u'CUG-Info',
        u'CUG-SubscriptionList',
        u'CUG-Subscription',
        u'CUG-Index',
        u'CUG-Interlock',
        u'IntraCUG-Options',
        u'maxNumOfCUG',
        u'CUG-FeatureList',
        u'Ext-BasicServiceGroupList',
        u'maxNumOfExt-BasicServiceGroups',
        u'CUG-Feature',
        u'InterCUG-Restrictions',
        u'Ext-SS-Data',
        u'LCS-PrivacyExceptionList',
        u'maxNumOfPrivacyClass',
        u'LCS-PrivacyClass',
        u'ExternalClientList',
        u'maxNumOfExternalClient',
        u'PLMNClientList',
        u'maxNumOfPLMNClient',
        u'Ext-ExternalClientList',
        u'maxNumOfExt-ExternalClient',
        u'ExternalClient',
        u'GMLC-Restriction',
        u'NotificationToMSUser',
        u'ServiceTypeList',
        u'maxNumOfServiceType',
        u'ServiceType',
        u'MOLR-List',
        u'maxNumOfMOLR-Class',
        u'MOLR-Class',
        u'ZoneCodeList',
        u'ZoneCode',
        u'maxNumOfZoneCodes',
        u'InsertSubscriberDataRes',
        u'RegionalSubscriptionResponse',
        u'DeleteSubscriberDataArg',
        u'SpecificCSI-Withdraw',
        u'GPRSSubscriptionDataWithdraw',
        u'EPS-SubscriptionDataWithdraw',
        u'ContextIdList',
        u'LSAInformationWithdraw',
        u'LSAIdentityList',
        u'BasicServiceList',
        u'maxNumOfBasicServices',
        u'DeleteSubscriberDataRes',
        u'VlrCamelSubscriptionInfo',
        u'MT-smsCAMELTDP-CriteriaList',
        u'MT-smsCAMELTDP-Criteria',
        u'TPDU-TypeCriterion',
        u'maxNumOfTPDUTypes',
        u'MT-SMS-TPDU-Type',
        u'D-CSI',
        u'DP-AnalysedInfoCriteriaList',
        u'maxNumOfDP-AnalysedInfoCriteria',
        u'DP-AnalysedInfoCriterium',
        u'SS-CSI',
        u'SS-CamelData',
        u'SS-EventList',
        u'maxNumOfCamelSSEvents',
        u'O-CSI',
        u'O-BcsmCamelTDPDataList',
        u'maxNumOfCamelTDPData',
        u'O-BcsmCamelTDPData',
        u'ServiceKey',
        u'O-BcsmTriggerDetectionPoint',
        u'O-BcsmCamelTDPCriteriaList',
        u'T-BCSM-CAMEL-TDP-CriteriaList',
        u'O-BcsmCamelTDP-Criteria',
        u'T-BCSM-CAMEL-TDP-Criteria',
        u'DestinationNumberCriteria',
        u'DestinationNumberList',
        u'DestinationNumberLengthList',
        u'BasicServiceCriteria',
        u'maxNumOfISDN-AddressDigits',
        u'maxNumOfCamelDestinationNumbers',
        u'maxNumOfCamelDestinationNumberLengths',
        u'maxNumOfCamelBasicServiceCriteria',
        u'CallTypeCriteria',
        u'MatchType',
        u'O-CauseValueCriteria',
        u'T-CauseValueCriteria',
        u'maxNumOfCAMEL-O-CauseValueCriteria',
        u'maxNumOfCAMEL-T-CauseValueCriteria',
        u'CauseValue',
        u'DefaultCallHandling',
        u'CamelCapabilityHandling',
        u'SupportedCamelPhases',
        u'OfferedCamel4CSIs',
        u'OfferedCamel4Functionalities',
        u'SMS-CSI',
        u'SMS-CAMEL-TDP-DataList',
        u'SMS-CAMEL-TDP-Data',
        u'SMS-TriggerDetectionPoint',
        u'DefaultSMS-Handling',
        u'M-CSI',
        u'MG-CSI',
        u'MobilityTriggers',
        u'maxNumOfMobilityTriggers',
        u'MM-Code',
        u'T-CSI',
        u'T-BcsmCamelTDPDataList',
        u'T-BcsmCamelTDPData',
        u'T-BcsmTriggerDetectionPoint',
        u'SendRoutingInfoForGprsArg',
        u'SendRoutingInfoForGprsRes',
        u'FailureReportArg',
        u'FailureReportRes',
        u'NoteMsPresentForGprsArg',
        u'NoteMsPresentForGprsRes',
        u'ResetArg',
        u'SendingNode-Number',
        u'RestoreDataArg',
        u'RestoreDataRes',
        u'VBSDataList',
        u'VGCSDataList',
        u'maxNumOfVBSGroupIds',
        u'maxNumOfVGCSGroupIds',
        u'VoiceGroupCallData',
        u'AdditionalInfo',
        u'AdditionalSubscriptions',
        u'VoiceBroadcastData',
        u'GroupId',
        u'Long-GroupId',
        u'ProvideSubscriberInfoArg',
        u'ProvideSubscriberInfoRes',
        u'SubscriberInfo',
        u'IMS-VoiceOverPS-SessionsInd',
        u'TimeZone',
        u'DaylightSavingTime',
        u'MNPInfoRes',
        u'RouteingNumber',
        u'NumberPortabilityStatus',
        u'MS-Classmark2',
        u'GPRSMSClass',
        u'MSNetworkCapability',
        u'MSRadioAccessCapability',
        u'RequestedInfo',
        u'DomainType',
        u'RequestedNodes',
        u'LocationInformation',
        u'LocationInformationEPS',
        u'LocationInformationGPRS',
        u'LocationInformation5GS',
        u'UserCSGInformation',
        u'GeographicalInformation',
        u'GeodeticInformation',
        u'LocationNumber',
        u'SubscriberState',
        u'PS-SubscriberState',
        u'PDP-ContextInfoList',
        u'PDP-ContextInfo',
        u'NSAPI',
        u'TransactionId',
        u'TEID',
        u'GPRSChargingID',
        u'NotReachableReason',
        u'AnyTimeInterrogationArg',
        u'AnyTimeInterrogationRes',
        u'AnyTimeSubscriptionInterrogationArg',
        u'AnyTimeSubscriptionInterrogationRes',
        u'CallWaitingData',
        u'Ext-CwFeatureList',
        u'Ext-CwFeature',
        u'ClipData',
        u'ClirData',
        u'CallHoldData',
        u'EctData',
        u'RequestedSubscriptionInfo',
        u'MSISDN-BS-List',
        u'maxNumOfMSISDN',
        u'MSISDN-BS',
        u'RequestedCAMEL-SubscriptionInfo',
        u'AdditionalRequestedCAMEL-SubscriptionInfo',
        u'CallForwardingData',
        u'CallBarringData',
        u'WrongPasswordAttemptsCounter',
        u'ODB-Info',
        u'CAMEL-SubscriptionInfo',
        u'AnyTimeModificationArg',
        u'ModificationRequestFor-CW-Info',
        u'ModificationRequestFor-CH-Info',
        u'ModificationRequestFor-ECT-Info',
        u'ModificationRequestFor-CLIR-Info',
        u'ModificationRequestFor-CLIP-Info',
        u'ModificationRequestFor-CSG',
        u'RequestedServingNode',
        u'ServingNode',
        u'AnyTimeModificationRes',
        u'ModificationRequestFor-CF-Info',
        u'ModificationRequestFor-CB-Info',
        u'ModificationRequestFor-ODB-data',
        u'ModificationRequestFor-CSI',
        u'ModificationRequestFor-IP-SM-GW-Data',
        u'ModificationInstruction',
        u'NoteSubscriberDataModifiedArg',
        u'NoteSubscriberDataModifiedRes',
        u'NoteMM-EventArg',
        u'NoteMM-EventRes',
        u'Ext-SS-InfoFor-CSE',
        u'Ext-ForwardingInfoFor-CSE',
        u'Ext-CallBarringInfoFor-CSE',
        u'UpdateVcsgLocationArg',
        u'UpdateVcsgLocationRes',
        u'CancelVcsgLocationArg',
        u'CancelVcsgLocationRes',
        ]
    _type_ = [
        u'UpdateLocationArg',
        u'VLR-Capability',
        u'SupportedRAT-Types',
        u'SuperChargerInfo',
        u'AgeIndicator',
        u'IST-SupportIndicator',
        u'SupportedLCS-CapabilitySets',
        u'UpdateLocationRes',
        u'ADD-Info',
        u'PagingArea',
        u'LocationArea',
        u'LAC',
        u'CancelLocationArg',
        u'TypeOfUpdate',
        u'CancellationType',
        u'CancelLocationRes',
        u'PurgeMS-Arg',
        u'PurgeMS-Res',
        u'SendIdentificationArg',
        u'HopCounter',
        u'SendIdentificationRes',
        u'AuthenticationSetList',
        u'TripletList',
        u'QuintupletList',
        u'AuthenticationTriplet',
        u'AuthenticationQuintuplet',
        u'CurrentSecurityContext',
        u'GSM-SecurityContextData',
        u'UMTS-SecurityContextData',
        u'RAND',
        u'SRES',
        u'Kc',
        u'XRES',
        u'CK',
        u'IK',
        u'AUTN',
        u'AUTS',
        u'Cksn',
        u'KSI',
        u'AuthenticationFailureReportArg',
        u'AccessType',
        u'AuthenticationFailureReportRes',
        u'FailureCause',
        u'UpdateGprsLocationArg',
        u'SMSRegisterRequest',
        u'Used-RAT-Type',
        u'EPS-Info',
        u'PDN-GW-Update',
        u'ISR-Information',
        u'SGSN-Capability',
        u'SupportedFeatures',
        u'Ext-SupportedFeatures',
        u'UE-SRVCC-Capability',
        u'UpdateGprsLocationRes',
        u'EPLMN-List',
        u'AdjacentPLMN-List',
        u'ForwardAccessSignalling-Arg',
        u'AllowedGSM-Algorithms',
        u'AllowedUMTS-Algorithms',
        u'PermittedIntegrityProtectionAlgorithms',
        u'PermittedEncryptionAlgorithms',
        u'KeyStatus',
        u'PrepareHO-Arg',
        u'LCLS-GlobalCallReference',
        u'LCLS-Negotiation',
        u'LCLS-ConfigurationPreference',
        u'BSSMAP-ServiceHandoverList',
        u'BSSMAP-ServiceHandoverInfo',
        u'BSSMAP-ServiceHandover',
        u'RANAP-ServiceHandover',
        u'RadioResourceList',
        u'RadioResource',
        u'PrepareHO-Res',
        u'SelectedUMTS-Algorithms',
        u'ChosenIntegrityProtectionAlgorithm',
        u'ChosenEncryptionAlgorithm',
        u'ChosenRadioResourceInformation',
        u'ChosenChannelInfo',
        u'ChosenSpeechVersion',
        u'PrepareSubsequentHO-Arg',
        u'PrepareSubsequentHO-Res',
        u'ProcessAccessSignalling-Arg',
        u'AoIPCodecsList',
        u'AoIPCodec',
        u'SupportedCodecsList',
        u'CodecList',
        u'Codec',
        u'GERAN-Classmark',
        u'SelectedGSM-Algorithm',
        u'SendEndSignal-Arg',
        u'SendEndSignal-Res',
        u'RNCId',
        u'RelocationNumberList',
        u'MulticallBearerInfo',
        u'RelocationNumber',
        u'RAB-Id',
        u'RadioResourceInformation',
        u'IntegrityProtectionInformation',
        u'EncryptionInformation',
        u'SendAuthenticationInfoArg',
        u'NumberOfRequestedVectors',
        u'Re-synchronisationInfo',
        u'SendAuthenticationInfoRes',
        u'EPS-AuthenticationSetList',
        u'UE-UsageType',
        u'EPC-AV',
        u'KASME',
        u'RequestingNodeType',
        u'CheckIMEI-Arg',
        u'CheckIMEI-Res',
        u'RequestedEquipmentInfo',
        u'UESBI-Iu',
        u'UESBI-IuA',
        u'UESBI-IuB',
        u'EquipmentStatus',
        u'InsertSubscriberDataArg',
        u'EDRX-Cycle-Length-List',
        u'EDRX-Cycle-Length',
        u'EDRX-Cycle-Length-Value',
        u'Reset-Id-List',
        u'Reset-Id',
        u'DL-Buffering-Suggested-Packet-Count',
        u'Group-Service-ID',
        u'Local-GroupID',
        u'IMSI-GroupIdList',
        u'IMSI-GroupId',
        u'SubscribedPeriodicRAUTAUtimer',
        u'SubscribedPeriodicLAUtimer',
        u'CSG-SubscriptionDataList',
        u'CSG-SubscriptionData',
        u'VPLMN-CSG-SubscriptionDataList',
        u'CSG-Id',
        u'LIPA-AllowedAPNList',
        u'EPS-SubscriptionData',
        u'APN-OI-Replacement',
        u'RFSP-ID',
        u'APN-ConfigurationProfile',
        u'EPS-DataList',
        u'APN-Configuration',
        u'PDN-ConnectionContinuity',
        u'NIDD-Mechanism',
        u'PDN-Type',
        u'EPS-QoS-Subscribed',
        u'AMBR',
        u'SpecificAPNInfoList',
        u'SpecificAPNInfo',
        u'Bandwidth',
        u'BandwidthExt',
        u'QoS-Class-Identifier',
        u'Allocation-Retention-Priority',
        u'PDN-GW-Identity',
        u'FQDN',
        u'PDN-GW-AllocationType',
        u'WLAN-Offloadability',
        u'WLAN-Offloadability-Indication',
        u'AccessRestrictionData',
        u'Ext-AccessRestrictionData',
        u'AdjacentAccessRestrictionDataList',
        u'AdjacentAccessRestrictionData',
        u'CS-AllocationRetentionPriority',
        u'IST-AlertTimerValue',
        u'LCSInformation',
        u'GMLC-List',
        u'NetworkAccessMode',
        u'GPRSDataList',
        u'PDP-Context',
        u'Restoration-Priority',
        u'SIPTO-Permission',
        u'SIPTO-Local-Network-Permission',
        u'LIPA-Permission',
        u'ContextId',
        u'GPRSSubscriptionData',
        u'SGSN-CAMEL-SubscriptionInfo',
        u'GPRS-CSI',
        u'GPRS-CamelTDPDataList',
        u'GPRS-CamelTDPData',
        u'DefaultGPRS-Handling',
        u'GPRS-TriggerDetectionPoint',
        u'APN',
        u'PDP-Type',
        u'Ext-PDP-Type',
        u'PDP-Address',
        u'QoS-Subscribed',
        u'Ext-QoS-Subscribed',
        u'Ext2-QoS-Subscribed',
        u'Ext3-QoS-Subscribed',
        u'Ext4-QoS-Subscribed',
        u'ChargingCharacteristics',
        u'LSAOnlyAccessIndicator',
        u'LSADataList',
        u'LSAData',
        u'LSAInformation',
        u'LSAIdentity',
        u'LSAAttributes',
        u'SubscriberData',
        u'Category',
        u'SubscriberStatus',
        u'BearerServiceList',
        u'TeleserviceList',
        u'ODB-Data',
        u'ODB-GeneralData',
        u'ODB-HPLMN-Data',
        u'Ext-SS-InfoList',
        u'Ext-SS-Info',
        u'Ext-ForwInfo',
        u'Ext-ForwFeatureList',
        u'Ext-ForwFeature',
        u'Ext-ForwOptions',
        u'Ext-NoRepCondTime',
        u'Ext-CallBarInfo',
        u'Ext-CallBarFeatureList',
        u'Ext-CallBarringFeature',
        u'CUG-Info',
        u'CUG-SubscriptionList',
        u'CUG-Subscription',
        u'CUG-Index',
        u'CUG-Interlock',
        u'IntraCUG-Options',
        u'CUG-FeatureList',
        u'Ext-BasicServiceGroupList',
        u'CUG-Feature',
        u'InterCUG-Restrictions',
        u'Ext-SS-Data',
        u'LCS-PrivacyExceptionList',
        u'LCS-PrivacyClass',
        u'ExternalClientList',
        u'PLMNClientList',
        u'Ext-ExternalClientList',
        u'ExternalClient',
        u'GMLC-Restriction',
        u'NotificationToMSUser',
        u'ServiceTypeList',
        u'ServiceType',
        u'MOLR-List',
        u'MOLR-Class',
        u'ZoneCodeList',
        u'ZoneCode',
        u'InsertSubscriberDataRes',
        u'RegionalSubscriptionResponse',
        u'DeleteSubscriberDataArg',
        u'SpecificCSI-Withdraw',
        u'GPRSSubscriptionDataWithdraw',
        u'EPS-SubscriptionDataWithdraw',
        u'ContextIdList',
        u'LSAInformationWithdraw',
        u'LSAIdentityList',
        u'BasicServiceList',
        u'DeleteSubscriberDataRes',
        u'VlrCamelSubscriptionInfo',
        u'MT-smsCAMELTDP-CriteriaList',
        u'MT-smsCAMELTDP-Criteria',
        u'TPDU-TypeCriterion',
        u'MT-SMS-TPDU-Type',
        u'D-CSI',
        u'DP-AnalysedInfoCriteriaList',
        u'DP-AnalysedInfoCriterium',
        u'SS-CSI',
        u'SS-CamelData',
        u'SS-EventList',
        u'O-CSI',
        u'O-BcsmCamelTDPDataList',
        u'O-BcsmCamelTDPData',
        u'ServiceKey',
        u'O-BcsmTriggerDetectionPoint',
        u'O-BcsmCamelTDPCriteriaList',
        u'T-BCSM-CAMEL-TDP-CriteriaList',
        u'O-BcsmCamelTDP-Criteria',
        u'T-BCSM-CAMEL-TDP-Criteria',
        u'DestinationNumberCriteria',
        u'DestinationNumberList',
        u'DestinationNumberLengthList',
        u'BasicServiceCriteria',
        u'CallTypeCriteria',
        u'MatchType',
        u'O-CauseValueCriteria',
        u'T-CauseValueCriteria',
        u'CauseValue',
        u'DefaultCallHandling',
        u'CamelCapabilityHandling',
        u'SupportedCamelPhases',
        u'OfferedCamel4CSIs',
        u'OfferedCamel4Functionalities',
        u'SMS-CSI',
        u'SMS-CAMEL-TDP-DataList',
        u'SMS-CAMEL-TDP-Data',
        u'SMS-TriggerDetectionPoint',
        u'DefaultSMS-Handling',
        u'M-CSI',
        u'MG-CSI',
        u'MobilityTriggers',
        u'MM-Code',
        u'T-CSI',
        u'T-BcsmCamelTDPDataList',
        u'T-BcsmCamelTDPData',
        u'T-BcsmTriggerDetectionPoint',
        u'SendRoutingInfoForGprsArg',
        u'SendRoutingInfoForGprsRes',
        u'FailureReportArg',
        u'FailureReportRes',
        u'NoteMsPresentForGprsArg',
        u'NoteMsPresentForGprsRes',
        u'ResetArg',
        u'SendingNode-Number',
        u'RestoreDataArg',
        u'RestoreDataRes',
        u'VBSDataList',
        u'VGCSDataList',
        u'VoiceGroupCallData',
        u'AdditionalInfo',
        u'AdditionalSubscriptions',
        u'VoiceBroadcastData',
        u'GroupId',
        u'Long-GroupId',
        u'ProvideSubscriberInfoArg',
        u'ProvideSubscriberInfoRes',
        u'SubscriberInfo',
        u'IMS-VoiceOverPS-SessionsInd',
        u'TimeZone',
        u'DaylightSavingTime',
        u'MNPInfoRes',
        u'RouteingNumber',
        u'NumberPortabilityStatus',
        u'MS-Classmark2',
        u'GPRSMSClass',
        u'MSNetworkCapability',
        u'MSRadioAccessCapability',
        u'RequestedInfo',
        u'DomainType',
        u'RequestedNodes',
        u'LocationInformation',
        u'LocationInformationEPS',
        u'LocationInformationGPRS',
        u'LocationInformation5GS',
        u'UserCSGInformation',
        u'GeographicalInformation',
        u'GeodeticInformation',
        u'LocationNumber',
        u'SubscriberState',
        u'PS-SubscriberState',
        u'PDP-ContextInfoList',
        u'PDP-ContextInfo',
        u'NSAPI',
        u'TransactionId',
        u'TEID',
        u'GPRSChargingID',
        u'NotReachableReason',
        u'AnyTimeInterrogationArg',
        u'AnyTimeInterrogationRes',
        u'AnyTimeSubscriptionInterrogationArg',
        u'AnyTimeSubscriptionInterrogationRes',
        u'CallWaitingData',
        u'Ext-CwFeatureList',
        u'Ext-CwFeature',
        u'ClipData',
        u'ClirData',
        u'CallHoldData',
        u'EctData',
        u'RequestedSubscriptionInfo',
        u'MSISDN-BS-List',
        u'MSISDN-BS',
        u'RequestedCAMEL-SubscriptionInfo',
        u'AdditionalRequestedCAMEL-SubscriptionInfo',
        u'CallForwardingData',
        u'CallBarringData',
        u'WrongPasswordAttemptsCounter',
        u'ODB-Info',
        u'CAMEL-SubscriptionInfo',
        u'AnyTimeModificationArg',
        u'ModificationRequestFor-CW-Info',
        u'ModificationRequestFor-CH-Info',
        u'ModificationRequestFor-ECT-Info',
        u'ModificationRequestFor-CLIR-Info',
        u'ModificationRequestFor-CLIP-Info',
        u'ModificationRequestFor-CSG',
        u'RequestedServingNode',
        u'ServingNode',
        u'AnyTimeModificationRes',
        u'ModificationRequestFor-CF-Info',
        u'ModificationRequestFor-CB-Info',
        u'ModificationRequestFor-ODB-data',
        u'ModificationRequestFor-CSI',
        u'ModificationRequestFor-IP-SM-GW-Data',
        u'ModificationInstruction',
        u'NoteSubscriberDataModifiedArg',
        u'NoteSubscriberDataModifiedRes',
        u'NoteMM-EventArg',
        u'NoteMM-EventRes',
        u'Ext-SS-InfoFor-CSE',
        u'Ext-ForwardingInfoFor-CSE',
        u'Ext-CallBarringInfoFor-CSE',
        u'UpdateVcsgLocationArg',
        u'UpdateVcsgLocationRes',
        u'CancelVcsgLocationArg',
        u'CancelVcsgLocationRes',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxPermittedIntegrityProtectionAlgorithmsLength',
        u'maxPermittedEncryptionAlgorithmsLength',
        u'maxNumOfServiceHandovers',
        u'maxNumOfRadioResources',
        u'maxNrOfRABs',
        u'maxNumOfRelocationNumber',
        u'maxNumOfIntegrityInfo',
        u'maxNumOfEncryptionInfo',
        u'maxNumOfLIPAAllowedAPN',
        u'maxNumOfAPN-Configurations',
        u'maxNumOfSpecificAPNInfos',
        u'maxNumOfGMLC',
        u'maxNumOfPDP-Contexts',
        u'maxNumOfLSAs',
        u'maxNumOfBearerServices',
        u'maxNumOfTeleservices',
        u'maxNumOfCUG',
        u'maxNumOfExt-BasicServiceGroups',
        u'maxNumOfPrivacyClass',
        u'maxNumOfExternalClient',
        u'maxNumOfPLMNClient',
        u'maxNumOfExt-ExternalClient',
        u'maxNumOfServiceType',
        u'maxNumOfMOLR-Class',
        u'maxNumOfZoneCodes',
        u'maxNumOfBasicServices',
        u'maxNumOfTPDUTypes',
        u'maxNumOfDP-AnalysedInfoCriteria',
        u'maxNumOfCamelSSEvents',
        u'maxNumOfCamelTDPData',
        u'maxNumOfISDN-AddressDigits',
        u'maxNumOfCamelDestinationNumbers',
        u'maxNumOfCamelDestinationNumberLengths',
        u'maxNumOfCamelBasicServiceCriteria',
        u'maxNumOfCAMEL-O-CauseValueCriteria',
        u'maxNumOfCAMEL-T-CauseValueCriteria',
        u'maxNumOfMobilityTriggers',
        u'maxNumOfVBSGroupIds',
        u'maxNumOfVGCSGroupIds',
        u'maxNumOfMSISDN',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< UpdateLocationArg >-----#
    UpdateLocationArg = SEQ(name=u'UpdateLocationArg', mode=MODE_TYPE)
    _UpdateLocationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateLocationArg_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _UpdateLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationArg_vlr_Capability = SEQ(name=u'vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _UpdateLocationArg_informPreviousNetworkEntity = NULL(name=u'informPreviousNetworkEntity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_cs_LCS_NotSupportedByUE = NULL(name=u'cs-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_v_gmlc_Address = OCT_STR(name=u'v-gmlc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateLocationArg_add_info = SEQ(name=u'add-info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateLocationArg_pagingArea = SEQ_OF(name=u'pagingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _UpdateLocationArg_skipSubscriberDataUpdate = NULL(name=u'skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_restorationIndicator = NULL(name=u'restorationIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_eplmn_List = SEQ_OF(name=u'eplmn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateLocationArg_mme_DiameterAddress = SEQ(name=u'mme-DiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    UpdateLocationArg._cont = ASN1Dict([
        (u'imsi', _UpdateLocationArg_imsi),
        (u'msc-Number', _UpdateLocationArg_msc_Number),
        (u'vlr-Number', _UpdateLocationArg_vlr_Number),
        (u'lmsi', _UpdateLocationArg_lmsi),
        (u'extensionContainer', _UpdateLocationArg_extensionContainer),
        (u'vlr-Capability', _UpdateLocationArg_vlr_Capability),
        (u'informPreviousNetworkEntity', _UpdateLocationArg_informPreviousNetworkEntity),
        (u'cs-LCS-NotSupportedByUE', _UpdateLocationArg_cs_LCS_NotSupportedByUE),
        (u'v-gmlc-Address', _UpdateLocationArg_v_gmlc_Address),
        (u'add-info', _UpdateLocationArg_add_info),
        (u'pagingArea', _UpdateLocationArg_pagingArea),
        (u'skipSubscriberDataUpdate', _UpdateLocationArg_skipSubscriberDataUpdate),
        (u'restorationIndicator', _UpdateLocationArg_restorationIndicator),
        (u'eplmn-List', _UpdateLocationArg_eplmn_List),
        (u'mme-DiameterAddress', _UpdateLocationArg_mme_DiameterAddress),
        ])
    UpdateLocationArg._ext = [u'vlr-Capability', u'informPreviousNetworkEntity', u'cs-LCS-NotSupportedByUE', u'v-gmlc-Address', u'add-info', u'pagingArea', u'skipSubscriberDataUpdate', u'restorationIndicator', u'eplmn-List', u'mme-DiameterAddress']
    
    #-----< VLR-Capability >-----#
    VLR_Capability = SEQ(name=u'VLR-Capability', mode=MODE_TYPE)
    _VLR_Capability_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _VLR_Capability_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VLR_Capability_solsaSupportIndicator = NULL(name=u'solsaSupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_istSupportIndicator = ENUM(name=u'istSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _VLR_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name=u'superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _VLR_Capability_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_supportedLCS_CapabilitySets = BIT_STR(name=u'supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _VLR_Capability_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _VLR_Capability_supportedRAT_TypesIndicator = BIT_STR(name=u'supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _VLR_Capability_longGroupID_Supported = NULL(name=u'longGroupID-Supported', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_mtRoamingForwardingSupported = NULL(name=u'mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_msisdn_lessOperation_Supported = NULL(name=u'msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_reset_ids_Supported = NULL(name=u'reset-ids-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    VLR_Capability._cont = ASN1Dict([
        (u'supportedCamelPhases', _VLR_Capability_supportedCamelPhases),
        (u'extensionContainer', _VLR_Capability_extensionContainer),
        (u'solsaSupportIndicator', _VLR_Capability_solsaSupportIndicator),
        (u'istSupportIndicator', _VLR_Capability_istSupportIndicator),
        (u'superChargerSupportedInServingNetworkEntity', _VLR_Capability_superChargerSupportedInServingNetworkEntity),
        (u'longFTN-Supported', _VLR_Capability_longFTN_Supported),
        (u'supportedLCS-CapabilitySets', _VLR_Capability_supportedLCS_CapabilitySets),
        (u'offeredCamel4CSIs', _VLR_Capability_offeredCamel4CSIs),
        (u'supportedRAT-TypesIndicator', _VLR_Capability_supportedRAT_TypesIndicator),
        (u'longGroupID-Supported', _VLR_Capability_longGroupID_Supported),
        (u'mtRoamingForwardingSupported', _VLR_Capability_mtRoamingForwardingSupported),
        (u'msisdn-lessOperation-Supported', _VLR_Capability_msisdn_lessOperation_Supported),
        (u'reset-ids-Supported', _VLR_Capability_reset_ids_Supported),
        ])
    VLR_Capability._ext = [u'solsaSupportIndicator', u'istSupportIndicator', u'superChargerSupportedInServingNetworkEntity', u'longFTN-Supported', u'supportedLCS-CapabilitySets', u'offeredCamel4CSIs', u'supportedRAT-TypesIndicator', u'longGroupID-Supported', u'mtRoamingForwardingSupported', u'msisdn-lessOperation-Supported', u'reset-ids-Supported']
    
    #-----< SupportedRAT-Types >-----#
    SupportedRAT_Types = BIT_STR(name=u'SupportedRAT-Types', mode=MODE_TYPE)
    SupportedRAT_Types._cont = ASN1Dict([(u'utran', 0), (u'geran', 1), (u'gan', 2), (u'i-hspa-evolution', 3), (u'e-utran', 4), (u'nb-iot', 5)])
    SupportedRAT_Types._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< SuperChargerInfo >-----#
    SuperChargerInfo = CHOICE(name=u'SuperChargerInfo', mode=MODE_TYPE)
    _SuperChargerInfo_sendSubscriberData = NULL(name=u'sendSubscriberData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SuperChargerInfo_subscriberDataStored = OCT_STR(name=u'subscriberDataStored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')))
    SuperChargerInfo._cont = ASN1Dict([
        (u'sendSubscriberData', _SuperChargerInfo_sendSubscriberData),
        (u'subscriberDataStored', _SuperChargerInfo_subscriberDataStored),
        ])
    SuperChargerInfo._ext = None
    
    #-----< AgeIndicator >-----#
    AgeIndicator = OCT_STR(name=u'AgeIndicator', mode=MODE_TYPE)
    AgeIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< IST-SupportIndicator >-----#
    IST_SupportIndicator = ENUM(name=u'IST-SupportIndicator', mode=MODE_TYPE)
    IST_SupportIndicator._cont = ASN1Dict([(u'basicISTSupported', 0), (u'istCommandSupported', 1)])
    IST_SupportIndicator._ext = []
    
    #-----< SupportedLCS-CapabilitySets >-----#
    SupportedLCS_CapabilitySets = BIT_STR(name=u'SupportedLCS-CapabilitySets', mode=MODE_TYPE)
    SupportedLCS_CapabilitySets._cont = ASN1Dict([(u'lcsCapabilitySet1', 0), (u'lcsCapabilitySet2', 1), (u'lcsCapabilitySet3', 2), (u'lcsCapabilitySet4', 3), (u'lcsCapabilitySet5', 4)])
    SupportedLCS_CapabilitySets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< UpdateLocationRes >-----#
    UpdateLocationRes = SEQ(name=u'UpdateLocationRes', mode=MODE_TYPE)
    _UpdateLocationRes_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationRes_add_Capability = NULL(name=u'add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateLocationRes_pagingArea_Capability = NULL(name=u'pagingArea-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateLocationRes._cont = ASN1Dict([
        (u'hlr-Number', _UpdateLocationRes_hlr_Number),
        (u'extensionContainer', _UpdateLocationRes_extensionContainer),
        (u'add-Capability', _UpdateLocationRes_add_Capability),
        (u'pagingArea-Capability', _UpdateLocationRes_pagingArea_Capability),
        ])
    UpdateLocationRes._ext = [u'add-Capability', u'pagingArea-Capability']
    
    #-----< ADD-Info >-----#
    ADD_Info = SEQ(name=u'ADD-Info', mode=MODE_TYPE)
    _ADD_Info_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _ADD_Info_skipSubscriberDataUpdate = NULL(name=u'skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ADD_Info._cont = ASN1Dict([
        (u'imeisv', _ADD_Info_imeisv),
        (u'skipSubscriberDataUpdate', _ADD_Info_skipSubscriberDataUpdate),
        ])
    ADD_Info._ext = []
    
    #-----< PagingArea >-----#
    PagingArea = SEQ_OF(name=u'PagingArea', mode=MODE_TYPE)
    _PagingArea__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationArea')))
    PagingArea._cont = _PagingArea__item_
    PagingArea._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< LocationArea >-----#
    LocationArea = CHOICE(name=u'LocationArea', mode=MODE_TYPE)
    _LocationArea_laiFixedLength = OCT_STR(name=u'laiFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _LocationArea_lac = OCT_STR(name=u'lac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LAC')))
    LocationArea._cont = ASN1Dict([
        (u'laiFixedLength', _LocationArea_laiFixedLength),
        (u'lac', _LocationArea_lac),
        ])
    LocationArea._ext = None
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CancelLocationArg >-----#
    CancelLocationArg = SEQ(name=u'CancelLocationArg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CancelLocationArg_identity = CHOICE(name=u'identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelLocationArg_cancellationType = ENUM(name=u'cancellationType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CancellationType')), opt=True)
    _CancelLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CancelLocationArg_typeOfUpdate = ENUM(name=u'typeOfUpdate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TypeOfUpdate')), opt=True)
    _CancelLocationArg_mtrf_SupportedAndAuthorized = NULL(name=u'mtrf-SupportedAndAuthorized', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_mtrf_SupportedAndNotAuthorized = NULL(name=u'mtrf-SupportedAndNotAuthorized', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_newMSC_Number = OCT_STR(name=u'newMSC-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_newVLR_Number = OCT_STR(name=u'newVLR-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_new_lmsi = OCT_STR(name=u'new-lmsi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _CancelLocationArg_reattach_Required = NULL(name=u'reattach-Required', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CancelLocationArg._cont = ASN1Dict([
        (u'identity', _CancelLocationArg_identity),
        (u'cancellationType', _CancelLocationArg_cancellationType),
        (u'extensionContainer', _CancelLocationArg_extensionContainer),
        (u'typeOfUpdate', _CancelLocationArg_typeOfUpdate),
        (u'mtrf-SupportedAndAuthorized', _CancelLocationArg_mtrf_SupportedAndAuthorized),
        (u'mtrf-SupportedAndNotAuthorized', _CancelLocationArg_mtrf_SupportedAndNotAuthorized),
        (u'newMSC-Number', _CancelLocationArg_newMSC_Number),
        (u'newVLR-Number', _CancelLocationArg_newVLR_Number),
        (u'new-lmsi', _CancelLocationArg_new_lmsi),
        (u'reattach-Required', _CancelLocationArg_reattach_Required),
        ])
    CancelLocationArg._ext = [u'typeOfUpdate', u'mtrf-SupportedAndAuthorized', u'mtrf-SupportedAndNotAuthorized', u'newMSC-Number', u'newVLR-Number', u'new-lmsi', u'reattach-Required']
    
    #-----< TypeOfUpdate >-----#
    TypeOfUpdate = ENUM(name=u'TypeOfUpdate', mode=MODE_TYPE)
    TypeOfUpdate._cont = ASN1Dict([(u'sgsn-change', 0), (u'mme-change', 1)])
    TypeOfUpdate._ext = []
    
    #-----< CancellationType >-----#
    CancellationType = ENUM(name=u'CancellationType', mode=MODE_TYPE)
    CancellationType._cont = ASN1Dict([(u'updateProcedure', 0), (u'subscriptionWithdraw', 1), (u'initialAttachProcedure', 2)])
    CancellationType._ext = [u'initialAttachProcedure']
    
    #-----< CancelLocationRes >-----#
    CancelLocationRes = SEQ(name=u'CancelLocationRes', mode=MODE_TYPE)
    _CancelLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelLocationRes._cont = ASN1Dict([
        (u'extensionContainer', _CancelLocationRes_extensionContainer),
        ])
    CancelLocationRes._ext = []
    
    #-----< PurgeMS-Arg >-----#
    PurgeMS_Arg = SEQ(name=u'PurgeMS-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PurgeMS_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _PurgeMS_Arg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Arg_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _PurgeMS_Arg_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _PurgeMS_Arg_locationInformationEPS = SEQ(name=u'locationInformationEPS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    PurgeMS_Arg._cont = ASN1Dict([
        (u'imsi', _PurgeMS_Arg_imsi),
        (u'vlr-Number', _PurgeMS_Arg_vlr_Number),
        (u'sgsn-Number', _PurgeMS_Arg_sgsn_Number),
        (u'extensionContainer', _PurgeMS_Arg_extensionContainer),
        (u'locationInformation', _PurgeMS_Arg_locationInformation),
        (u'locationInformationGPRS', _PurgeMS_Arg_locationInformationGPRS),
        (u'locationInformationEPS', _PurgeMS_Arg_locationInformationEPS),
        ])
    PurgeMS_Arg._ext = [u'locationInformation', u'locationInformationGPRS', u'locationInformationEPS']
    
    #-----< PurgeMS-Res >-----#
    PurgeMS_Res = SEQ(name=u'PurgeMS-Res', mode=MODE_TYPE)
    _PurgeMS_Res_freezeTMSI = NULL(name=u'freezeTMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_freezeP_TMSI = NULL(name=u'freezeP-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Res_freezeM_TMSI = NULL(name=u'freezeM-TMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PurgeMS_Res._cont = ASN1Dict([
        (u'freezeTMSI', _PurgeMS_Res_freezeTMSI),
        (u'freezeP-TMSI', _PurgeMS_Res_freezeP_TMSI),
        (u'extensionContainer', _PurgeMS_Res_extensionContainer),
        (u'freezeM-TMSI', _PurgeMS_Res_freezeM_TMSI),
        ])
    PurgeMS_Res._ext = [u'freezeM-TMSI']
    
    #-----< SendIdentificationArg >-----#
    SendIdentificationArg = SEQ(name=u'SendIdentificationArg', mode=MODE_TYPE)
    _SendIdentificationArg_tmsi = OCT_STR(name=u'tmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    _SendIdentificationArg_numberOfRequestedVectors = INT(name=u'numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendIdentificationArg_segmentationProhibited = NULL(name=u'segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendIdentificationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationArg_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_previous_LAI = OCT_STR(name=u'previous-LAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')), opt=True)
    _SendIdentificationArg_hopCounter = INT(name=u'hopCounter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'HopCounter')), opt=True)
    _SendIdentificationArg_mtRoamingForwardingSupported = NULL(name=u'mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendIdentificationArg_newVLR_Number = OCT_STR(name=u'newVLR-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_new_lmsi = OCT_STR(name=u'new-lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    SendIdentificationArg._cont = ASN1Dict([
        (u'tmsi', _SendIdentificationArg_tmsi),
        (u'numberOfRequestedVectors', _SendIdentificationArg_numberOfRequestedVectors),
        (u'segmentationProhibited', _SendIdentificationArg_segmentationProhibited),
        (u'extensionContainer', _SendIdentificationArg_extensionContainer),
        (u'msc-Number', _SendIdentificationArg_msc_Number),
        (u'previous-LAI', _SendIdentificationArg_previous_LAI),
        (u'hopCounter', _SendIdentificationArg_hopCounter),
        (u'mtRoamingForwardingSupported', _SendIdentificationArg_mtRoamingForwardingSupported),
        (u'newVLR-Number', _SendIdentificationArg_newVLR_Number),
        (u'new-lmsi', _SendIdentificationArg_new_lmsi),
        ])
    SendIdentificationArg._ext = [u'msc-Number', u'previous-LAI', u'hopCounter', u'mtRoamingForwardingSupported', u'newVLR-Number', u'new-lmsi']
    
    #-----< HopCounter >-----#
    HopCounter = INT(name=u'HopCounter', mode=MODE_TYPE)
    HopCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< SendIdentificationRes >-----#
    SendIdentificationRes = SEQ(name=u'SendIdentificationRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendIdentificationRes_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendIdentificationRes_authenticationSetList = CHOICE(name=u'authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendIdentificationRes_currentSecurityContext = CHOICE(name=u'currentSecurityContext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CurrentSecurityContext')), opt=True)
    _SendIdentificationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationRes_lastUsedLtePLMN_Id = OCT_STR(name=u'lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendIdentificationRes_mtCallPendingFlag = NULL(name=u'mtCallPendingFlag', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendIdentificationRes._cont = ASN1Dict([
        (u'imsi', _SendIdentificationRes_imsi),
        (u'authenticationSetList', _SendIdentificationRes_authenticationSetList),
        (u'currentSecurityContext', _SendIdentificationRes_currentSecurityContext),
        (u'extensionContainer', _SendIdentificationRes_extensionContainer),
        (u'lastUsedLtePLMN-Id', _SendIdentificationRes_lastUsedLtePLMN_Id),
        (u'mtCallPendingFlag', _SendIdentificationRes_mtCallPendingFlag),
        ])
    SendIdentificationRes._ext = [u'lastUsedLtePLMN-Id', u'mtCallPendingFlag']
    
    #-----< AuthenticationSetList >-----#
    AuthenticationSetList = CHOICE(name=u'AuthenticationSetList', mode=MODE_TYPE)
    _AuthenticationSetList_tripletList = SEQ_OF(name=u'tripletList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TripletList')))
    _AuthenticationSetList_quintupletList = SEQ_OF(name=u'quintupletList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QuintupletList')))
    AuthenticationSetList._cont = ASN1Dict([
        (u'tripletList', _AuthenticationSetList_tripletList),
        (u'quintupletList', _AuthenticationSetList_quintupletList),
        ])
    AuthenticationSetList._ext = None
    
    #-----< TripletList >-----#
    TripletList = SEQ_OF(name=u'TripletList', mode=MODE_TYPE)
    _TripletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationTriplet')))
    TripletList._cont = _TripletList__item_
    TripletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< QuintupletList >-----#
    QuintupletList = SEQ_OF(name=u'QuintupletList', mode=MODE_TYPE)
    _QuintupletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationQuintuplet')))
    QuintupletList._cont = _QuintupletList__item_
    QuintupletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AuthenticationTriplet >-----#
    AuthenticationTriplet = SEQ(name=u'AuthenticationTriplet', mode=MODE_TYPE)
    _AuthenticationTriplet_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationTriplet_sres = OCT_STR(name=u'sres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SRES')))
    _AuthenticationTriplet_kc = OCT_STR(name=u'kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    AuthenticationTriplet._cont = ASN1Dict([
        (u'rand', _AuthenticationTriplet_rand),
        (u'sres', _AuthenticationTriplet_sres),
        (u'kc', _AuthenticationTriplet_kc),
        ])
    AuthenticationTriplet._ext = []
    
    #-----< AuthenticationQuintuplet >-----#
    AuthenticationQuintuplet = SEQ(name=u'AuthenticationQuintuplet', mode=MODE_TYPE)
    _AuthenticationQuintuplet_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationQuintuplet_xres = OCT_STR(name=u'xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _AuthenticationQuintuplet_ck = OCT_STR(name=u'ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _AuthenticationQuintuplet_ik = OCT_STR(name=u'ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _AuthenticationQuintuplet_autn = OCT_STR(name=u'autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    AuthenticationQuintuplet._cont = ASN1Dict([
        (u'rand', _AuthenticationQuintuplet_rand),
        (u'xres', _AuthenticationQuintuplet_xres),
        (u'ck', _AuthenticationQuintuplet_ck),
        (u'ik', _AuthenticationQuintuplet_ik),
        (u'autn', _AuthenticationQuintuplet_autn),
        ])
    AuthenticationQuintuplet._ext = []
    
    #-----< CurrentSecurityContext >-----#
    CurrentSecurityContext = CHOICE(name=u'CurrentSecurityContext', mode=MODE_TYPE)
    _CurrentSecurityContext_gsm_SecurityContextData = SEQ(name=u'gsm-SecurityContextData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GSM-SecurityContextData')))
    _CurrentSecurityContext_umts_SecurityContextData = SEQ(name=u'umts-SecurityContextData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UMTS-SecurityContextData')))
    CurrentSecurityContext._cont = ASN1Dict([
        (u'gsm-SecurityContextData', _CurrentSecurityContext_gsm_SecurityContextData),
        (u'umts-SecurityContextData', _CurrentSecurityContext_umts_SecurityContextData),
        ])
    CurrentSecurityContext._ext = None
    
    #-----< GSM-SecurityContextData >-----#
    GSM_SecurityContextData = SEQ(name=u'GSM-SecurityContextData', mode=MODE_TYPE)
    _GSM_SecurityContextData_kc = OCT_STR(name=u'kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    _GSM_SecurityContextData_cksn = OCT_STR(name=u'cksn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Cksn')))
    GSM_SecurityContextData._cont = ASN1Dict([
        (u'kc', _GSM_SecurityContextData_kc),
        (u'cksn', _GSM_SecurityContextData_cksn),
        ])
    GSM_SecurityContextData._ext = []
    
    #-----< UMTS-SecurityContextData >-----#
    UMTS_SecurityContextData = SEQ(name=u'UMTS-SecurityContextData', mode=MODE_TYPE)
    _UMTS_SecurityContextData_ck = OCT_STR(name=u'ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _UMTS_SecurityContextData_ik = OCT_STR(name=u'ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _UMTS_SecurityContextData_ksi = OCT_STR(name=u'ksi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KSI')))
    UMTS_SecurityContextData._cont = ASN1Dict([
        (u'ck', _UMTS_SecurityContextData_ck),
        (u'ik', _UMTS_SecurityContextData_ik),
        (u'ksi', _UMTS_SecurityContextData_ksi),
        ])
    UMTS_SecurityContextData._ext = []
    
    #-----< RAND >-----#
    RAND = OCT_STR(name=u'RAND', mode=MODE_TYPE)
    RAND._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SRES >-----#
    SRES = OCT_STR(name=u'SRES', mode=MODE_TYPE)
    SRES._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< Kc >-----#
    Kc = OCT_STR(name=u'Kc', mode=MODE_TYPE)
    Kc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< XRES >-----#
    XRES = OCT_STR(name=u'XRES', mode=MODE_TYPE)
    XRES._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< CK >-----#
    CK = OCT_STR(name=u'CK', mode=MODE_TYPE)
    CK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IK >-----#
    IK = OCT_STR(name=u'IK', mode=MODE_TYPE)
    IK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTN >-----#
    AUTN = OCT_STR(name=u'AUTN', mode=MODE_TYPE)
    AUTN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTS >-----#
    AUTS = OCT_STR(name=u'AUTS', mode=MODE_TYPE)
    AUTS._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< Cksn >-----#
    Cksn = OCT_STR(name=u'Cksn', mode=MODE_TYPE)
    Cksn._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< KSI >-----#
    KSI = OCT_STR(name=u'KSI', mode=MODE_TYPE)
    KSI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AuthenticationFailureReportArg >-----#
    AuthenticationFailureReportArg = SEQ(name=u'AuthenticationFailureReportArg', mode=MODE_TYPE)
    _AuthenticationFailureReportArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _AuthenticationFailureReportArg_failureCause = ENUM(name=u'failureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'FailureCause')))
    _AuthenticationFailureReportArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AuthenticationFailureReportArg_re_attempt = BOOL(name=u're-attempt', mode=MODE_TYPE, opt=True)
    _AuthenticationFailureReportArg_accessType = ENUM(name=u'accessType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessType')), opt=True)
    _AuthenticationFailureReportArg_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')), opt=True)
    _AuthenticationFailureReportArg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AuthenticationFailureReportArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    AuthenticationFailureReportArg._cont = ASN1Dict([
        (u'imsi', _AuthenticationFailureReportArg_imsi),
        (u'failureCause', _AuthenticationFailureReportArg_failureCause),
        (u'extensionContainer', _AuthenticationFailureReportArg_extensionContainer),
        (u're-attempt', _AuthenticationFailureReportArg_re_attempt),
        (u'accessType', _AuthenticationFailureReportArg_accessType),
        (u'rand', _AuthenticationFailureReportArg_rand),
        (u'vlr-Number', _AuthenticationFailureReportArg_vlr_Number),
        (u'sgsn-Number', _AuthenticationFailureReportArg_sgsn_Number),
        ])
    AuthenticationFailureReportArg._ext = [u're-attempt', u'accessType', u'rand', u'vlr-Number', u'sgsn-Number']
    
    #-----< AccessType >-----#
    AccessType = ENUM(name=u'AccessType', mode=MODE_TYPE)
    AccessType._cont = ASN1Dict([(u'call', 0), (u'emergencyCall', 1), (u'locationUpdating', 2), (u'supplementaryService', 3), (u'shortMessage', 4), (u'gprsAttach', 5), (u'routingAreaUpdating', 6), (u'serviceRequest', 7), (u'pdpContextActivation', 8), (u'pdpContextDeactivation', 9), (u'gprsDetach', 10)])
    AccessType._ext = [u'gprsDetach']
    
    #-----< AuthenticationFailureReportRes >-----#
    AuthenticationFailureReportRes = SEQ(name=u'AuthenticationFailureReportRes', mode=MODE_TYPE)
    _AuthenticationFailureReportRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AuthenticationFailureReportRes._cont = ASN1Dict([
        (u'extensionContainer', _AuthenticationFailureReportRes_extensionContainer),
        ])
    AuthenticationFailureReportRes._ext = []
    
    #-----< FailureCause >-----#
    FailureCause = ENUM(name=u'FailureCause', mode=MODE_TYPE)
    FailureCause._cont = ASN1Dict([(u'wrongUserResponse', 0), (u'wrongNetworkSignature', 1)])
    FailureCause._ext = None
    
    #-----< UpdateGprsLocationArg >-----#
    UpdateGprsLocationArg = SEQ(name=u'UpdateGprsLocationArg', mode=MODE_TYPE)
    _UpdateGprsLocationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateGprsLocationArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationArg_sgsn_Address = OCT_STR(name=u'sgsn-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _UpdateGprsLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationArg_sgsn_Capability = SEQ(name=u'sgsn-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-Capability')), opt=True)
    _UpdateGprsLocationArg_informPreviousNetworkEntity = NULL(name=u'informPreviousNetworkEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE = NULL(name=u'ps-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_v_gmlc_Address = OCT_STR(name=u'v-gmlc-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateGprsLocationArg_add_info = SEQ(name=u'add-info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateGprsLocationArg_eps_info = CHOICE(name=u'eps-info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-Info')), opt=True)
    _UpdateGprsLocationArg_servingNodeTypeIndicator = NULL(name=u'servingNodeTypeIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_skipSubscriberDataUpdate = NULL(name=u'skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_usedRAT_Type = ENUM(name=u'usedRAT-Type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded = NULL(name=u'gprsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_nodeTypeIndicator = NULL(name=u'nodeTypeIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_areaRestricted = NULL(name=u'areaRestricted', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_reachableIndicator = NULL(name=u'ue-reachableIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded = NULL(name=u'epsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_srvcc_Capability = ENUM(name=u'ue-srvcc-Capability', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-SRVCC-Capability')), opt=True)
    _UpdateGprsLocationArg_eplmn_List = SEQ_OF(name=u'eplmn-List', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateGprsLocationArg_mmeNumberforMTSMS = OCT_STR(name=u'mmeNumberforMTSMS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateGprsLocationArg_smsRegisterRequest = ENUM(name=u'smsRegisterRequest', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMSRegisterRequest')), opt=True)
    _UpdateGprsLocationArg_sms_Only = NULL(name=u'sms-Only', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_removalofMMERegistrationforSMS = NULL(name=u'removalofMMERegistrationforSMS', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_sgsn_Name = OCT_STR(name=u'sgsn-Name', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_sgsn_Realm = OCT_STR(name=u'sgsn-Realm', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_lgd_supportIndicator = NULL(name=u'lgd-supportIndicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_adjacentPLMN_List = SEQ_OF(name=u'adjacentPLMN-List', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentPLMN-List')), opt=True)
    UpdateGprsLocationArg._cont = ASN1Dict([
        (u'imsi', _UpdateGprsLocationArg_imsi),
        (u'sgsn-Number', _UpdateGprsLocationArg_sgsn_Number),
        (u'sgsn-Address', _UpdateGprsLocationArg_sgsn_Address),
        (u'extensionContainer', _UpdateGprsLocationArg_extensionContainer),
        (u'sgsn-Capability', _UpdateGprsLocationArg_sgsn_Capability),
        (u'informPreviousNetworkEntity', _UpdateGprsLocationArg_informPreviousNetworkEntity),
        (u'ps-LCS-NotSupportedByUE', _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE),
        (u'v-gmlc-Address', _UpdateGprsLocationArg_v_gmlc_Address),
        (u'add-info', _UpdateGprsLocationArg_add_info),
        (u'eps-info', _UpdateGprsLocationArg_eps_info),
        (u'servingNodeTypeIndicator', _UpdateGprsLocationArg_servingNodeTypeIndicator),
        (u'skipSubscriberDataUpdate', _UpdateGprsLocationArg_skipSubscriberDataUpdate),
        (u'usedRAT-Type', _UpdateGprsLocationArg_usedRAT_Type),
        (u'gprsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded),
        (u'nodeTypeIndicator', _UpdateGprsLocationArg_nodeTypeIndicator),
        (u'areaRestricted', _UpdateGprsLocationArg_areaRestricted),
        (u'ue-reachableIndicator', _UpdateGprsLocationArg_ue_reachableIndicator),
        (u'epsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded),
        (u'ue-srvcc-Capability', _UpdateGprsLocationArg_ue_srvcc_Capability),
        (u'eplmn-List', _UpdateGprsLocationArg_eplmn_List),
        (u'mmeNumberforMTSMS', _UpdateGprsLocationArg_mmeNumberforMTSMS),
        (u'smsRegisterRequest', _UpdateGprsLocationArg_smsRegisterRequest),
        (u'sms-Only', _UpdateGprsLocationArg_sms_Only),
        (u'removalofMMERegistrationforSMS', _UpdateGprsLocationArg_removalofMMERegistrationforSMS),
        (u'sgsn-Name', _UpdateGprsLocationArg_sgsn_Name),
        (u'sgsn-Realm', _UpdateGprsLocationArg_sgsn_Realm),
        (u'lgd-supportIndicator', _UpdateGprsLocationArg_lgd_supportIndicator),
        (u'adjacentPLMN-List', _UpdateGprsLocationArg_adjacentPLMN_List),
        ])
    UpdateGprsLocationArg._ext = [u'sgsn-Capability', u'informPreviousNetworkEntity', u'ps-LCS-NotSupportedByUE', u'v-gmlc-Address', u'add-info', u'eps-info', u'servingNodeTypeIndicator', u'skipSubscriberDataUpdate', u'usedRAT-Type', u'gprsSubscriptionDataNotNeeded', u'nodeTypeIndicator', u'areaRestricted', u'ue-reachableIndicator', u'epsSubscriptionDataNotNeeded', u'ue-srvcc-Capability', u'eplmn-List', u'mmeNumberforMTSMS', u'smsRegisterRequest', u'sms-Only', u'removalofMMERegistrationforSMS', u'sgsn-Name', u'sgsn-Realm', u'lgd-supportIndicator', u'adjacentPLMN-List']
    
    #-----< SMSRegisterRequest >-----#
    SMSRegisterRequest = ENUM(name=u'SMSRegisterRequest', mode=MODE_TYPE)
    SMSRegisterRequest._cont = ASN1Dict([(u'sms-registration-required', 0), (u'sms-registration-not-preferred', 1), (u'no-preference', 2)])
    SMSRegisterRequest._ext = []
    
    #-----< Used-RAT-Type >-----#
    Used_RAT_Type = ENUM(name=u'Used-RAT-Type', mode=MODE_TYPE)
    Used_RAT_Type._cont = ASN1Dict([(u'utran', 0), (u'geran', 1), (u'gan', 2), (u'i-hspa-evolution', 3), (u'e-utran', 4), (u'nb-iot', 5)])
    Used_RAT_Type._ext = [u'nb-iot']
    
    #-----< EPS-Info >-----#
    EPS_Info = CHOICE(name=u'EPS-Info', mode=MODE_TYPE)
    _EPS_Info_pdn_gw_update = SEQ(name=u'pdn-gw-update', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Update')))
    _EPS_Info_isr_Information = BIT_STR(name=u'isr-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ISR-Information')))
    EPS_Info._cont = ASN1Dict([
        (u'pdn-gw-update', _EPS_Info_pdn_gw_update),
        (u'isr-Information', _EPS_Info_isr_Information),
        ])
    EPS_Info._ext = None
    
    #-----< PDN-GW-Update >-----#
    PDN_GW_Update = SEQ(name=u'PDN-GW-Update', mode=MODE_TYPE)
    _PDN_GW_Update_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDN_GW_Update_pdn_gw_Identity = SEQ(name=u'pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _PDN_GW_Update_contextId = INT(name=u'contextId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    _PDN_GW_Update_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Update._cont = ASN1Dict([
        (u'apn', _PDN_GW_Update_apn),
        (u'pdn-gw-Identity', _PDN_GW_Update_pdn_gw_Identity),
        (u'contextId', _PDN_GW_Update_contextId),
        (u'extensionContainer', _PDN_GW_Update_extensionContainer),
        ])
    PDN_GW_Update._ext = []
    
    #-----< ISR-Information >-----#
    ISR_Information = BIT_STR(name=u'ISR-Information', mode=MODE_TYPE)
    ISR_Information._cont = ASN1Dict([(u'updateLocation', 0), (u'cancelSGSN', 1), (u'initialAttachIndicator', 2)])
    ISR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-Capability >-----#
    SGSN_Capability = SEQ(name=u'SGSN-Capability', mode=MODE_TYPE)
    _SGSN_Capability_solsaSupportIndicator = NULL(name=u'solsaSupportIndicator', mode=MODE_TYPE, opt=True)
    _SGSN_Capability_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name=u'superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _SGSN_Capability_gprsEnhancementsSupportIndicator = NULL(name=u'gprsEnhancementsSupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SGSN_Capability_supportedLCS_CapabilitySets = BIT_STR(name=u'supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _SGSN_Capability_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SGSN_Capability_smsCallBarringSupportIndicator = NULL(name=u'smsCallBarringSupportIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedRAT_TypesIndicator = BIT_STR(name=u'supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _SGSN_Capability_supportedFeatures = BIT_STR(name=u'supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _SGSN_Capability_t_adsDataRetrieval = NULL(name=u't-adsDataRetrieval', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions = BOOL(name=u'homogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_cancellationTypeInitialAttach = NULL(name=u'cancellationTypeInitialAttach', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_msisdn_lessOperation_Supported = NULL(name=u'msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions = NULL(name=u'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_reset_ids_Supported = NULL(name=u'reset-ids-Supported', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_ext_SupportedFeatures = BIT_STR(name=u'ext-SupportedFeatures', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    SGSN_Capability._cont = ASN1Dict([
        (u'solsaSupportIndicator', _SGSN_Capability_solsaSupportIndicator),
        (u'extensionContainer', _SGSN_Capability_extensionContainer),
        (u'superChargerSupportedInServingNetworkEntity', _SGSN_Capability_superChargerSupportedInServingNetworkEntity),
        (u'gprsEnhancementsSupportIndicator', _SGSN_Capability_gprsEnhancementsSupportIndicator),
        (u'supportedCamelPhases', _SGSN_Capability_supportedCamelPhases),
        (u'supportedLCS-CapabilitySets', _SGSN_Capability_supportedLCS_CapabilitySets),
        (u'offeredCamel4CSIs', _SGSN_Capability_offeredCamel4CSIs),
        (u'smsCallBarringSupportIndicator', _SGSN_Capability_smsCallBarringSupportIndicator),
        (u'supportedRAT-TypesIndicator', _SGSN_Capability_supportedRAT_TypesIndicator),
        (u'supportedFeatures', _SGSN_Capability_supportedFeatures),
        (u't-adsDataRetrieval', _SGSN_Capability_t_adsDataRetrieval),
        (u'homogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions),
        (u'cancellationTypeInitialAttach', _SGSN_Capability_cancellationTypeInitialAttach),
        (u'msisdn-lessOperation-Supported', _SGSN_Capability_msisdn_lessOperation_Supported),
        (u'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions),
        (u'reset-ids-Supported', _SGSN_Capability_reset_ids_Supported),
        (u'ext-SupportedFeatures', _SGSN_Capability_ext_SupportedFeatures),
        ])
    SGSN_Capability._ext = [u'superChargerSupportedInServingNetworkEntity', u'gprsEnhancementsSupportIndicator', u'supportedCamelPhases', u'supportedLCS-CapabilitySets', u'offeredCamel4CSIs', u'smsCallBarringSupportIndicator', u'supportedRAT-TypesIndicator', u'supportedFeatures', u't-adsDataRetrieval', u'homogeneousSupportOfIMSVoiceOverPSSessions', u'cancellationTypeInitialAttach', u'msisdn-lessOperation-Supported', u'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', u'reset-ids-Supported', u'ext-SupportedFeatures']
    
    #-----< SupportedFeatures >-----#
    SupportedFeatures = BIT_STR(name=u'SupportedFeatures', mode=MODE_TYPE)
    SupportedFeatures._cont = ASN1Dict([(u'odb-all-apn', 0), (u'odb-HPLMN-APN', 1), (u'odb-VPLMN-APN', 2), (u'odb-all-og', 3), (u'odb-all-international-og', 4), (u'odb-all-int-og-not-to-HPLMN-country', 5), (u'odb-all-interzonal-og', 6), (u'odb-all-interzonal-og-not-to-HPLMN-country', 7), (u'odb-all-interzonal-og-and-internat-og-not-to-HPLMN-country', 8), (u'regSub', 9), (u'trace', 10), (u'lcs-all-PrivExcep', 11), (u'lcs-universal', 12), (u'lcs-CallSessionRelated', 13), (u'lcs-CallSessionUnrelated', 14), (u'lcs-PLMN-operator', 15), (u'lcs-ServiceType', 16), (u'lcs-all-MOLR-SS', 17), (u'lcs-basicSelfLocation', 18), (u'lcs-autonomousSelfLocation', 19), (u'lcs-transferToThirdParty', 20), (u'sm-mo-pp', 21), (u'barring-OutgoingCalls', 22), (u'baoc', 23), (u'boic', 24), (u'boicExHC', 25), (u'localTimeZoneRetrieval', 26), (u'additionalMsisdn', 27), (u'smsInMME', 28), (u'smsInSGSN', 29), (u'ue-Reachability-Notification', 30), (u'state-Location-Information-Retrieval', 31), (u'partialPurge', 32), (u'gddInSGSN', 33), (u'sgsnCAMELCapability', 34), (u'pcscf-Restoration', 35), (u'dedicatedCoreNetworks', 36), (u'non-IP-PDN-Type-APNs', 37), (u'non-IP-PDP-Type-APNs', 38), (u'nrAsSecondaryRAT', 39)])
    SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=26, ub=40)], ev=None, er=[])
    
    #-----< Ext-SupportedFeatures >-----#
    Ext_SupportedFeatures = BIT_STR(name=u'Ext-SupportedFeatures', mode=MODE_TYPE)
    Ext_SupportedFeatures._cont = ASN1Dict([(u'unlicensedSpectrumAsSecondaryRAT', 0)])
    Ext_SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< UE-SRVCC-Capability >-----#
    UE_SRVCC_Capability = ENUM(name=u'UE-SRVCC-Capability', mode=MODE_TYPE)
    UE_SRVCC_Capability._cont = ASN1Dict([(u'ue-srvcc-not-supported', 0), (u'ue-srvcc-supported', 1)])
    UE_SRVCC_Capability._ext = []
    
    #-----< UpdateGprsLocationRes >-----#
    UpdateGprsLocationRes = SEQ(name=u'UpdateGprsLocationRes', mode=MODE_TYPE)
    _UpdateGprsLocationRes_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationRes_add_Capability = NULL(name=u'add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateGprsLocationRes_sgsn_mmeSeparationSupported = NULL(name=u'sgsn-mmeSeparationSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationRes_mmeRegisteredforSMS = NULL(name=u'mmeRegisteredforSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateGprsLocationRes._cont = ASN1Dict([
        (u'hlr-Number', _UpdateGprsLocationRes_hlr_Number),
        (u'extensionContainer', _UpdateGprsLocationRes_extensionContainer),
        (u'add-Capability', _UpdateGprsLocationRes_add_Capability),
        (u'sgsn-mmeSeparationSupported', _UpdateGprsLocationRes_sgsn_mmeSeparationSupported),
        (u'mmeRegisteredforSMS', _UpdateGprsLocationRes_mmeRegisteredforSMS),
        ])
    UpdateGprsLocationRes._ext = [u'add-Capability', u'sgsn-mmeSeparationSupported', u'mmeRegisteredforSMS']
    
    #-----< EPLMN-List >-----#
    EPLMN_List = SEQ_OF(name=u'EPLMN-List', mode=MODE_TYPE)
    _EPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    EPLMN_List._cont = _EPLMN_List__item_
    EPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentPLMN-List >-----#
    AdjacentPLMN_List = SEQ_OF(name=u'AdjacentPLMN-List', mode=MODE_TYPE)
    _AdjacentPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    AdjacentPLMN_List._cont = _AdjacentPLMN_List__item_
    AdjacentPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< ForwardAccessSignalling-Arg >-----#
    ForwardAccessSignalling_Arg = SEQ(name=u'ForwardAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ForwardAccessSignalling_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ForwardAccessSignalling_Arg_integrityProtectionInfo = OCT_STR(name=u'integrityProtectionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_encryptionInfo = OCT_STR(name=u'encryptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_keyStatus = ENUM(name=u'keyStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'KeyStatus')), opt=True)
    _ForwardAccessSignalling_Arg_allowedGSM_Algorithms = OCT_STR(name=u'allowedGSM-Algorithms', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms = SEQ(name=u'allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceInformation = OCT_STR(name=u'radioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceList = SEQ_OF(name=u'radioResourceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandover = OCT_STR(name=u'bssmap-ServiceHandover', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_ranap_ServiceHandover = OCT_STR(name=u'ranap-ServiceHandover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList = SEQ_OF(name=u'bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _ForwardAccessSignalling_Arg_currentlyUsedCodec = OCT_STR(name=u'currentlyUsedCodec', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_iuSupportedCodecsList = SEQ(name=u'iuSupportedCodecsList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator = NULL(name=u'rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardAccessSignalling_Arg_iuSelectedCodec = OCT_STR(name=u'iuSelectedCodec', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_alternativeChannelType = OCT_STR(name=u'alternativeChannelType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_tracePropagationList = SEQ(name=u'tracePropagationList', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor = SEQ(name=u'aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name=u'aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ForwardAccessSignalling_Arg_uesbi_Iu = SEQ(name=u'uesbi-Iu', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _ForwardAccessSignalling_Arg_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ForwardAccessSignalling_Arg._cont = ASN1Dict([
        (u'an-APDU', _ForwardAccessSignalling_Arg_an_APDU),
        (u'integrityProtectionInfo', _ForwardAccessSignalling_Arg_integrityProtectionInfo),
        (u'encryptionInfo', _ForwardAccessSignalling_Arg_encryptionInfo),
        (u'keyStatus', _ForwardAccessSignalling_Arg_keyStatus),
        (u'allowedGSM-Algorithms', _ForwardAccessSignalling_Arg_allowedGSM_Algorithms),
        (u'allowedUMTS-Algorithms', _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms),
        (u'radioResourceInformation', _ForwardAccessSignalling_Arg_radioResourceInformation),
        (u'extensionContainer', _ForwardAccessSignalling_Arg_extensionContainer),
        (u'radioResourceList', _ForwardAccessSignalling_Arg_radioResourceList),
        (u'bssmap-ServiceHandover', _ForwardAccessSignalling_Arg_bssmap_ServiceHandover),
        (u'ranap-ServiceHandover', _ForwardAccessSignalling_Arg_ranap_ServiceHandover),
        (u'bssmap-ServiceHandoverList', _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList),
        (u'currentlyUsedCodec', _ForwardAccessSignalling_Arg_currentlyUsedCodec),
        (u'iuSupportedCodecsList', _ForwardAccessSignalling_Arg_iuSupportedCodecsList),
        (u'rab-ConfigurationIndicator', _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator),
        (u'iuSelectedCodec', _ForwardAccessSignalling_Arg_iuSelectedCodec),
        (u'alternativeChannelType', _ForwardAccessSignalling_Arg_alternativeChannelType),
        (u'tracePropagationList', _ForwardAccessSignalling_Arg_tracePropagationList),
        (u'aoipSupportedCodecsListAnchor', _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor),
        (u'aoipSelectedCodecTarget', _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget),
        (u'uesbi-Iu', _ForwardAccessSignalling_Arg_uesbi_Iu),
        (u'imeisv', _ForwardAccessSignalling_Arg_imeisv),
        ])
    ForwardAccessSignalling_Arg._ext = [u'radioResourceList', u'bssmap-ServiceHandover', u'ranap-ServiceHandover', u'bssmap-ServiceHandoverList', u'currentlyUsedCodec', u'iuSupportedCodecsList', u'rab-ConfigurationIndicator', u'iuSelectedCodec', u'alternativeChannelType', u'tracePropagationList', u'aoipSupportedCodecsListAnchor', u'aoipSelectedCodecTarget', u'uesbi-Iu', u'imeisv']
    
    #-----< AllowedGSM-Algorithms >-----#
    AllowedGSM_Algorithms = OCT_STR(name=u'AllowedGSM-Algorithms', mode=MODE_TYPE)
    AllowedGSM_Algorithms._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AllowedUMTS-Algorithms >-----#
    AllowedUMTS_Algorithms = SEQ(name=u'AllowedUMTS-Algorithms', mode=MODE_TYPE)
    _AllowedUMTS_Algorithms_integrityProtectionAlgorithms = OCT_STR(name=u'integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedIntegrityProtectionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_encryptionAlgorithms = OCT_STR(name=u'encryptionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedEncryptionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AllowedUMTS_Algorithms._cont = ASN1Dict([
        (u'integrityProtectionAlgorithms', _AllowedUMTS_Algorithms_integrityProtectionAlgorithms),
        (u'encryptionAlgorithms', _AllowedUMTS_Algorithms_encryptionAlgorithms),
        (u'extensionContainer', _AllowedUMTS_Algorithms_extensionContainer),
        ])
    AllowedUMTS_Algorithms._ext = []
    
    #-----< PermittedIntegrityProtectionAlgorithms >-----#
    PermittedIntegrityProtectionAlgorithms = OCT_STR(name=u'PermittedIntegrityProtectionAlgorithms', mode=MODE_TYPE)
    PermittedIntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedIntegrityProtectionAlgorithmsLength >-----#
    maxPermittedIntegrityProtectionAlgorithmsLength = INT(name=u'maxPermittedIntegrityProtectionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedIntegrityProtectionAlgorithmsLength._val = 9
    
    #-----< PermittedEncryptionAlgorithms >-----#
    PermittedEncryptionAlgorithms = OCT_STR(name=u'PermittedEncryptionAlgorithms', mode=MODE_TYPE)
    PermittedEncryptionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedEncryptionAlgorithmsLength >-----#
    maxPermittedEncryptionAlgorithmsLength = INT(name=u'maxPermittedEncryptionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedEncryptionAlgorithmsLength._val = 9
    
    #-----< KeyStatus >-----#
    KeyStatus = ENUM(name=u'KeyStatus', mode=MODE_TYPE)
    KeyStatus._cont = ASN1Dict([(u'old', 0), (u'new', 1)])
    KeyStatus._ext = []
    
    #-----< PrepareHO-Arg >-----#
    PrepareHO_Arg = SEQ(name=u'PrepareHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Arg_targetCellId = OCT_STR(name=u'targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareHO_Arg_ho_NumberNotRequired = NULL(name=u'ho-NumberNotRequired', mode=MODE_TYPE, opt=True)
    _PrepareHO_Arg_targetRNCId = OCT_STR(name=u'targetRNCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareHO_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Arg_multipleBearerRequested = NULL(name=u'multipleBearerRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PrepareHO_Arg_integrityProtectionInfo = OCT_STR(name=u'integrityProtectionInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _PrepareHO_Arg_encryptionInfo = OCT_STR(name=u'encryptionInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _PrepareHO_Arg_radioResourceInformation = OCT_STR(name=u'radioResourceInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_allowedGSM_Algorithms = OCT_STR(name=u'allowedGSM-Algorithms', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _PrepareHO_Arg_allowedUMTS_Algorithms = SEQ(name=u'allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _PrepareHO_Arg_radioResourceList = SEQ_OF(name=u'radioResourceList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _PrepareHO_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Arg_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandover = OCT_STR(name=u'bssmap-ServiceHandover', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_ranap_ServiceHandover = OCT_STR(name=u'ranap-ServiceHandover', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandoverList = SEQ_OF(name=u'bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _PrepareHO_Arg_asciCallReference = OCT_STR(name=u'asciCallReference', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ASCI-CallReference')), opt=True)
    _PrepareHO_Arg_geran_classmark = OCT_STR(name=u'geran-classmark', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareHO_Arg_iuCurrentlyUsedCodec = OCT_STR(name=u'iuCurrentlyUsedCodec', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Arg_iuSupportedCodecsList = SEQ(name=u'iuSupportedCodecsList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _PrepareHO_Arg_rab_ConfigurationIndicator = NULL(name=u'rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_uesbi_Iu = SEQ(name=u'uesbi-Iu', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _PrepareHO_Arg_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _PrepareHO_Arg_alternativeChannelType = OCT_STR(name=u'alternativeChannelType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_tracePropagationList = SEQ(name=u'tracePropagationList', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _PrepareHO_Arg_aoipSupportedCodecsListAnchor = SEQ(name=u'aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _PrepareHO_Arg_regionalSubscriptionData = SEQ_OF(name=u'regionalSubscriptionData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _PrepareHO_Arg_lclsGlobalCallReference = OCT_STR(name=u'lclsGlobalCallReference', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-GlobalCallReference')), opt=True)
    _PrepareHO_Arg_lcls_Negotiation = BIT_STR(name=u'lcls-Negotiation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-Negotiation')), opt=True)
    _PrepareHO_Arg_lcls_Configuration_Preference = BIT_STR(name=u'lcls-Configuration-Preference', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-ConfigurationPreference')), opt=True)
    _PrepareHO_Arg_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    PrepareHO_Arg._cont = ASN1Dict([
        (u'targetCellId', _PrepareHO_Arg_targetCellId),
        (u'ho-NumberNotRequired', _PrepareHO_Arg_ho_NumberNotRequired),
        (u'targetRNCId', _PrepareHO_Arg_targetRNCId),
        (u'an-APDU', _PrepareHO_Arg_an_APDU),
        (u'multipleBearerRequested', _PrepareHO_Arg_multipleBearerRequested),
        (u'imsi', _PrepareHO_Arg_imsi),
        (u'integrityProtectionInfo', _PrepareHO_Arg_integrityProtectionInfo),
        (u'encryptionInfo', _PrepareHO_Arg_encryptionInfo),
        (u'radioResourceInformation', _PrepareHO_Arg_radioResourceInformation),
        (u'allowedGSM-Algorithms', _PrepareHO_Arg_allowedGSM_Algorithms),
        (u'allowedUMTS-Algorithms', _PrepareHO_Arg_allowedUMTS_Algorithms),
        (u'radioResourceList', _PrepareHO_Arg_radioResourceList),
        (u'extensionContainer', _PrepareHO_Arg_extensionContainer),
        (u'rab-Id', _PrepareHO_Arg_rab_Id),
        (u'bssmap-ServiceHandover', _PrepareHO_Arg_bssmap_ServiceHandover),
        (u'ranap-ServiceHandover', _PrepareHO_Arg_ranap_ServiceHandover),
        (u'bssmap-ServiceHandoverList', _PrepareHO_Arg_bssmap_ServiceHandoverList),
        (u'asciCallReference', _PrepareHO_Arg_asciCallReference),
        (u'geran-classmark', _PrepareHO_Arg_geran_classmark),
        (u'iuCurrentlyUsedCodec', _PrepareHO_Arg_iuCurrentlyUsedCodec),
        (u'iuSupportedCodecsList', _PrepareHO_Arg_iuSupportedCodecsList),
        (u'rab-ConfigurationIndicator', _PrepareHO_Arg_rab_ConfigurationIndicator),
        (u'uesbi-Iu', _PrepareHO_Arg_uesbi_Iu),
        (u'imeisv', _PrepareHO_Arg_imeisv),
        (u'alternativeChannelType', _PrepareHO_Arg_alternativeChannelType),
        (u'tracePropagationList', _PrepareHO_Arg_tracePropagationList),
        (u'aoipSupportedCodecsListAnchor', _PrepareHO_Arg_aoipSupportedCodecsListAnchor),
        (u'regionalSubscriptionData', _PrepareHO_Arg_regionalSubscriptionData),
        (u'lclsGlobalCallReference', _PrepareHO_Arg_lclsGlobalCallReference),
        (u'lcls-Negotiation', _PrepareHO_Arg_lcls_Negotiation),
        (u'lcls-Configuration-Preference', _PrepareHO_Arg_lcls_Configuration_Preference),
        (u'csg-SubscriptionDataList', _PrepareHO_Arg_csg_SubscriptionDataList),
        ])
    PrepareHO_Arg._ext = [u'rab-Id', u'bssmap-ServiceHandover', u'ranap-ServiceHandover', u'bssmap-ServiceHandoverList', u'asciCallReference', u'geran-classmark', u'iuCurrentlyUsedCodec', u'iuSupportedCodecsList', u'rab-ConfigurationIndicator', u'uesbi-Iu', u'imeisv', u'alternativeChannelType', u'tracePropagationList', u'aoipSupportedCodecsListAnchor', u'regionalSubscriptionData', u'lclsGlobalCallReference', u'lcls-Negotiation', u'lcls-Configuration-Preference', u'csg-SubscriptionDataList']
    
    #-----< LCLS-GlobalCallReference >-----#
    LCLS_GlobalCallReference = OCT_STR(name=u'LCLS-GlobalCallReference', mode=MODE_TYPE)
    LCLS_GlobalCallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=13, ub=15)], ev=None, er=[])
    
    #-----< LCLS-Negotiation >-----#
    LCLS_Negotiation = BIT_STR(name=u'LCLS-Negotiation', mode=MODE_TYPE)
    LCLS_Negotiation._cont = ASN1Dict([(u'permission-indicator-not-allowed-bit', 0), (u'permission-indicator-spare-bit', 1)])
    LCLS_Negotiation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< LCLS-ConfigurationPreference >-----#
    LCLS_ConfigurationPreference = BIT_STR(name=u'LCLS-ConfigurationPreference', mode=MODE_TYPE)
    LCLS_ConfigurationPreference._cont = ASN1Dict([(u'forward-data-sending-indicator', 0), (u'backward-data-sending-indicator', 1), (u'forward-data-reception-indicator', 2), (u'backward-data-reception-indicator', 3)])
    LCLS_ConfigurationPreference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverList >-----#
    BSSMAP_ServiceHandoverList = SEQ_OF(name=u'BSSMAP-ServiceHandoverList', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverInfo')))
    BSSMAP_ServiceHandoverList._cont = _BSSMAP_ServiceHandoverList__item_
    BSSMAP_ServiceHandoverList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverInfo >-----#
    BSSMAP_ServiceHandoverInfo = SEQ(name=u'BSSMAP-ServiceHandoverInfo', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover = OCT_STR(name=u'bssmap-ServiceHandover', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')))
    _BSSMAP_ServiceHandoverInfo_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    BSSMAP_ServiceHandoverInfo._cont = ASN1Dict([
        (u'bssmap-ServiceHandover', _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover),
        (u'rab-Id', _BSSMAP_ServiceHandoverInfo_rab_Id),
        ])
    BSSMAP_ServiceHandoverInfo._ext = []
    
    #-----< maxNumOfServiceHandovers >-----#
    maxNumOfServiceHandovers = INT(name=u'maxNumOfServiceHandovers', mode=MODE_VALUE)
    maxNumOfServiceHandovers._val = 7
    
    #-----< BSSMAP-ServiceHandover >-----#
    BSSMAP_ServiceHandover = OCT_STR(name=u'BSSMAP-ServiceHandover', mode=MODE_TYPE)
    BSSMAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RANAP-ServiceHandover >-----#
    RANAP_ServiceHandover = OCT_STR(name=u'RANAP-ServiceHandover', mode=MODE_TYPE)
    RANAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RadioResourceList >-----#
    RadioResourceList = SEQ_OF(name=u'RadioResourceList', mode=MODE_TYPE)
    _RadioResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResource')))
    RadioResourceList._cont = _RadioResourceList__item_
    RadioResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RadioResource >-----#
    RadioResource = SEQ(name=u'RadioResource', mode=MODE_TYPE)
    _RadioResource_radioResourceInformation = OCT_STR(name=u'radioResourceInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')))
    _RadioResource_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RadioResource._cont = ASN1Dict([
        (u'radioResourceInformation', _RadioResource_radioResourceInformation),
        (u'rab-Id', _RadioResource_rab_Id),
        ])
    RadioResource._ext = []
    
    #-----< maxNumOfRadioResources >-----#
    maxNumOfRadioResources = INT(name=u'maxNumOfRadioResources', mode=MODE_VALUE)
    maxNumOfRadioResources._val = 7
    
    #-----< PrepareHO-Res >-----#
    PrepareHO_Res = SEQ(name=u'PrepareHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Res_handoverNumber = OCT_STR(name=u'handoverNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PrepareHO_Res_relocationNumberList = SEQ_OF(name=u'relocationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumberList')), opt=True)
    _PrepareHO_Res_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Res_multicallBearerInfo = INT(name=u'multicallBearerInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MulticallBearerInfo')), opt=True)
    _PrepareHO_Res_multipleBearerNotSupported = NULL(name=u'multipleBearerNotSupported', mode=MODE_TYPE, opt=True)
    _PrepareHO_Res_selectedUMTS_Algorithms = SEQ(name=u'selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _PrepareHO_Res_chosenRadioResourceInformation = SEQ(name=u'chosenRadioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _PrepareHO_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Res_iuSelectedCodec = OCT_STR(name=u'iuSelectedCodec', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Res_iuAvailableCodecsList = SEQ(name=u'iuAvailableCodecsList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _PrepareHO_Res_aoipSelectedCodecTarget = OCT_STR(name=u'aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _PrepareHO_Res_aoipAvailableCodecsListMap = SEQ(name=u'aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    PrepareHO_Res._cont = ASN1Dict([
        (u'handoverNumber', _PrepareHO_Res_handoverNumber),
        (u'relocationNumberList', _PrepareHO_Res_relocationNumberList),
        (u'an-APDU', _PrepareHO_Res_an_APDU),
        (u'multicallBearerInfo', _PrepareHO_Res_multicallBearerInfo),
        (u'multipleBearerNotSupported', _PrepareHO_Res_multipleBearerNotSupported),
        (u'selectedUMTS-Algorithms', _PrepareHO_Res_selectedUMTS_Algorithms),
        (u'chosenRadioResourceInformation', _PrepareHO_Res_chosenRadioResourceInformation),
        (u'extensionContainer', _PrepareHO_Res_extensionContainer),
        (u'iuSelectedCodec', _PrepareHO_Res_iuSelectedCodec),
        (u'iuAvailableCodecsList', _PrepareHO_Res_iuAvailableCodecsList),
        (u'aoipSelectedCodecTarget', _PrepareHO_Res_aoipSelectedCodecTarget),
        (u'aoipAvailableCodecsListMap', _PrepareHO_Res_aoipAvailableCodecsListMap),
        ])
    PrepareHO_Res._ext = [u'iuSelectedCodec', u'iuAvailableCodecsList', u'aoipSelectedCodecTarget', u'aoipAvailableCodecsListMap']
    
    #-----< SelectedUMTS-Algorithms >-----#
    SelectedUMTS_Algorithms = SEQ(name=u'SelectedUMTS-Algorithms', mode=MODE_TYPE)
    _SelectedUMTS_Algorithms_integrityProtectionAlgorithm = OCT_STR(name=u'integrityProtectionAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenIntegrityProtectionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_encryptionAlgorithm = OCT_STR(name=u'encryptionAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenEncryptionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SelectedUMTS_Algorithms._cont = ASN1Dict([
        (u'integrityProtectionAlgorithm', _SelectedUMTS_Algorithms_integrityProtectionAlgorithm),
        (u'encryptionAlgorithm', _SelectedUMTS_Algorithms_encryptionAlgorithm),
        (u'extensionContainer', _SelectedUMTS_Algorithms_extensionContainer),
        ])
    SelectedUMTS_Algorithms._ext = []
    
    #-----< ChosenIntegrityProtectionAlgorithm >-----#
    ChosenIntegrityProtectionAlgorithm = OCT_STR(name=u'ChosenIntegrityProtectionAlgorithm', mode=MODE_TYPE)
    ChosenIntegrityProtectionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenEncryptionAlgorithm >-----#
    ChosenEncryptionAlgorithm = OCT_STR(name=u'ChosenEncryptionAlgorithm', mode=MODE_TYPE)
    ChosenEncryptionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenRadioResourceInformation >-----#
    ChosenRadioResourceInformation = SEQ(name=u'ChosenRadioResourceInformation', mode=MODE_TYPE)
    _ChosenRadioResourceInformation_chosenChannelInfo = OCT_STR(name=u'chosenChannelInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenChannelInfo')), opt=True)
    _ChosenRadioResourceInformation_chosenSpeechVersion = OCT_STR(name=u'chosenSpeechVersion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenSpeechVersion')), opt=True)
    ChosenRadioResourceInformation._cont = ASN1Dict([
        (u'chosenChannelInfo', _ChosenRadioResourceInformation_chosenChannelInfo),
        (u'chosenSpeechVersion', _ChosenRadioResourceInformation_chosenSpeechVersion),
        ])
    ChosenRadioResourceInformation._ext = []
    
    #-----< ChosenChannelInfo >-----#
    ChosenChannelInfo = OCT_STR(name=u'ChosenChannelInfo', mode=MODE_TYPE)
    ChosenChannelInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenSpeechVersion >-----#
    ChosenSpeechVersion = OCT_STR(name=u'ChosenSpeechVersion', mode=MODE_TYPE)
    ChosenSpeechVersion._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PrepareSubsequentHO-Arg >-----#
    PrepareSubsequentHO_Arg = SEQ(name=u'PrepareSubsequentHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Arg_targetCellId = OCT_STR(name=u'targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareSubsequentHO_Arg_targetMSC_Number = OCT_STR(name=u'targetMSC-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _PrepareSubsequentHO_Arg_targetRNCId = OCT_STR(name=u'targetRNCId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareSubsequentHO_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareSubsequentHO_Arg_selectedRab_Id = INT(name=u'selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareSubsequentHO_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareSubsequentHO_Arg_geran_classmark = OCT_STR(name=u'geran-classmark', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator = NULL(name=u'rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrepareSubsequentHO_Arg._cont = ASN1Dict([
        (u'targetCellId', _PrepareSubsequentHO_Arg_targetCellId),
        (u'targetMSC-Number', _PrepareSubsequentHO_Arg_targetMSC_Number),
        (u'targetRNCId', _PrepareSubsequentHO_Arg_targetRNCId),
        (u'an-APDU', _PrepareSubsequentHO_Arg_an_APDU),
        (u'selectedRab-Id', _PrepareSubsequentHO_Arg_selectedRab_Id),
        (u'extensionContainer', _PrepareSubsequentHO_Arg_extensionContainer),
        (u'geran-classmark', _PrepareSubsequentHO_Arg_geran_classmark),
        (u'rab-ConfigurationIndicator', _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator),
        ])
    PrepareSubsequentHO_Arg._ext = [u'geran-classmark', u'rab-ConfigurationIndicator']
    
    #-----< PrepareSubsequentHO-Res >-----#
    PrepareSubsequentHO_Res = SEQ(name=u'PrepareSubsequentHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Res_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _PrepareSubsequentHO_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PrepareSubsequentHO_Res._cont = ASN1Dict([
        (u'an-APDU', _PrepareSubsequentHO_Res_an_APDU),
        (u'extensionContainer', _PrepareSubsequentHO_Res_extensionContainer),
        ])
    PrepareSubsequentHO_Res._ext = []
    
    #-----< ProcessAccessSignalling-Arg >-----#
    ProcessAccessSignalling_Arg = SEQ(name=u'ProcessAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProcessAccessSignalling_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms = SEQ(name=u'selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _ProcessAccessSignalling_Arg_selectedGSM_Algorithm = OCT_STR(name=u'selectedGSM-Algorithm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedGSM-Algorithm')), opt=True)
    _ProcessAccessSignalling_Arg_chosenRadioResourceInformation = SEQ(name=u'chosenRadioResourceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _ProcessAccessSignalling_Arg_selectedRab_Id = INT(name=u'selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _ProcessAccessSignalling_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProcessAccessSignalling_Arg_iUSelectedCodec = OCT_STR(name=u'iUSelectedCodec', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ProcessAccessSignalling_Arg_iuAvailableCodecsList = SEQ(name=u'iuAvailableCodecsList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name=u'aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap = SEQ(name=u'aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    ProcessAccessSignalling_Arg._cont = ASN1Dict([
        (u'an-APDU', _ProcessAccessSignalling_Arg_an_APDU),
        (u'selectedUMTS-Algorithms', _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms),
        (u'selectedGSM-Algorithm', _ProcessAccessSignalling_Arg_selectedGSM_Algorithm),
        (u'chosenRadioResourceInformation', _ProcessAccessSignalling_Arg_chosenRadioResourceInformation),
        (u'selectedRab-Id', _ProcessAccessSignalling_Arg_selectedRab_Id),
        (u'extensionContainer', _ProcessAccessSignalling_Arg_extensionContainer),
        (u'iUSelectedCodec', _ProcessAccessSignalling_Arg_iUSelectedCodec),
        (u'iuAvailableCodecsList', _ProcessAccessSignalling_Arg_iuAvailableCodecsList),
        (u'aoipSelectedCodecTarget', _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget),
        (u'aoipAvailableCodecsListMap', _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap),
        ])
    ProcessAccessSignalling_Arg._ext = [u'iUSelectedCodec', u'iuAvailableCodecsList', u'aoipSelectedCodecTarget', u'aoipAvailableCodecsListMap']
    
    #-----< AoIPCodecsList >-----#
    AoIPCodecsList = SEQ(name=u'AoIPCodecsList', mode=MODE_TYPE)
    _AoIPCodecsList_codec1 = OCT_STR(name=u'codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')))
    _AoIPCodecsList_codec2 = OCT_STR(name=u'codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec3 = OCT_STR(name=u'codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec4 = OCT_STR(name=u'codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec5 = OCT_STR(name=u'codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec6 = OCT_STR(name=u'codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec7 = OCT_STR(name=u'codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec8 = OCT_STR(name=u'codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AoIPCodecsList._cont = ASN1Dict([
        (u'codec1', _AoIPCodecsList_codec1),
        (u'codec2', _AoIPCodecsList_codec2),
        (u'codec3', _AoIPCodecsList_codec3),
        (u'codec4', _AoIPCodecsList_codec4),
        (u'codec5', _AoIPCodecsList_codec5),
        (u'codec6', _AoIPCodecsList_codec6),
        (u'codec7', _AoIPCodecsList_codec7),
        (u'codec8', _AoIPCodecsList_codec8),
        (u'extensionContainer', _AoIPCodecsList_extensionContainer),
        ])
    AoIPCodecsList._ext = []
    
    #-----< AoIPCodec >-----#
    AoIPCodec = OCT_STR(name=u'AoIPCodec', mode=MODE_TYPE)
    AoIPCodec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SupportedCodecsList >-----#
    SupportedCodecsList = SEQ(name=u'SupportedCodecsList', mode=MODE_TYPE)
    _SupportedCodecsList_utranCodecList = SEQ(name=u'utranCodecList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_geranCodecList = SEQ(name=u'geranCodecList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SupportedCodecsList._cont = ASN1Dict([
        (u'utranCodecList', _SupportedCodecsList_utranCodecList),
        (u'geranCodecList', _SupportedCodecsList_geranCodecList),
        (u'extensionContainer', _SupportedCodecsList_extensionContainer),
        ])
    SupportedCodecsList._ext = []
    
    #-----< CodecList >-----#
    CodecList = SEQ(name=u'CodecList', mode=MODE_TYPE)
    _CodecList_codec1 = OCT_STR(name=u'codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')))
    _CodecList_codec2 = OCT_STR(name=u'codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec3 = OCT_STR(name=u'codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec4 = OCT_STR(name=u'codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec5 = OCT_STR(name=u'codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec6 = OCT_STR(name=u'codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec7 = OCT_STR(name=u'codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec8 = OCT_STR(name=u'codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CodecList._cont = ASN1Dict([
        (u'codec1', _CodecList_codec1),
        (u'codec2', _CodecList_codec2),
        (u'codec3', _CodecList_codec3),
        (u'codec4', _CodecList_codec4),
        (u'codec5', _CodecList_codec5),
        (u'codec6', _CodecList_codec6),
        (u'codec7', _CodecList_codec7),
        (u'codec8', _CodecList_codec8),
        (u'extensionContainer', _CodecList_extensionContainer),
        ])
    CodecList._ext = []
    
    #-----< Codec >-----#
    Codec = OCT_STR(name=u'Codec', mode=MODE_TYPE)
    Codec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name=u'GERAN-Classmark', mode=MODE_TYPE)
    GERAN_Classmark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=87)], ev=None, er=[])
    
    #-----< SelectedGSM-Algorithm >-----#
    SelectedGSM_Algorithm = OCT_STR(name=u'SelectedGSM-Algorithm', mode=MODE_TYPE)
    SelectedGSM_Algorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendEndSignal-Arg >-----#
    SendEndSignal_Arg = SEQ(name=u'SendEndSignal-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendEndSignal_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _SendEndSignal_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Arg._cont = ASN1Dict([
        (u'an-APDU', _SendEndSignal_Arg_an_APDU),
        (u'extensionContainer', _SendEndSignal_Arg_extensionContainer),
        ])
    SendEndSignal_Arg._ext = []
    
    #-----< SendEndSignal-Res >-----#
    SendEndSignal_Res = SEQ(name=u'SendEndSignal-Res', mode=MODE_TYPE)
    _SendEndSignal_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Res._cont = ASN1Dict([
        (u'extensionContainer', _SendEndSignal_Res_extensionContainer),
        ])
    SendEndSignal_Res._ext = []
    
    #-----< RNCId >-----#
    RNCId = OCT_STR(name=u'RNCId', mode=MODE_TYPE)
    RNCId._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< RelocationNumberList >-----#
    RelocationNumberList = SEQ_OF(name=u'RelocationNumberList', mode=MODE_TYPE)
    _RelocationNumberList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumber')))
    RelocationNumberList._cont = _RelocationNumberList__item_
    RelocationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MulticallBearerInfo >-----#
    MulticallBearerInfo = INT(name=u'MulticallBearerInfo', mode=MODE_TYPE)
    MulticallBearerInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RelocationNumber >-----#
    RelocationNumber = SEQ(name=u'RelocationNumber', mode=MODE_TYPE)
    _RelocationNumber_handoverNumber = OCT_STR(name=u'handoverNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RelocationNumber_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RelocationNumber._cont = ASN1Dict([
        (u'handoverNumber', _RelocationNumber_handoverNumber),
        (u'rab-Id', _RelocationNumber_rab_Id),
        ])
    RelocationNumber._ext = []
    
    #-----< RAB-Id >-----#
    RAB_Id = INT(name=u'RAB-Id', mode=MODE_TYPE)
    RAB_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< maxNrOfRABs >-----#
    maxNrOfRABs = INT(name=u'maxNrOfRABs', mode=MODE_VALUE)
    maxNrOfRABs._val = 255
    
    #-----< maxNumOfRelocationNumber >-----#
    maxNumOfRelocationNumber = INT(name=u'maxNumOfRelocationNumber', mode=MODE_VALUE)
    maxNumOfRelocationNumber._val = 7
    
    #-----< RadioResourceInformation >-----#
    RadioResourceInformation = OCT_STR(name=u'RadioResourceInformation', mode=MODE_TYPE)
    RadioResourceInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=13)], ev=None, er=[])
    
    #-----< IntegrityProtectionInformation >-----#
    IntegrityProtectionInformation = OCT_STR(name=u'IntegrityProtectionInformation', mode=MODE_TYPE)
    IntegrityProtectionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfIntegrityInfo >-----#
    maxNumOfIntegrityInfo = INT(name=u'maxNumOfIntegrityInfo', mode=MODE_VALUE)
    maxNumOfIntegrityInfo._val = 100
    
    #-----< EncryptionInformation >-----#
    EncryptionInformation = OCT_STR(name=u'EncryptionInformation', mode=MODE_TYPE)
    EncryptionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfEncryptionInfo >-----#
    maxNumOfEncryptionInfo = INT(name=u'maxNumOfEncryptionInfo', mode=MODE_VALUE)
    maxNumOfEncryptionInfo._val = 100
    
    #-----< SendAuthenticationInfoArg >-----#
    SendAuthenticationInfoArg = SEQ(name=u'SendAuthenticationInfoArg', mode=MODE_TYPE)
    _SendAuthenticationInfoArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendAuthenticationInfoArg_numberOfRequestedVectors = INT(name=u'numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')))
    _SendAuthenticationInfoArg_segmentationProhibited = NULL(name=u'segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendAuthenticationInfoArg_immediateResponsePreferred = NULL(name=u'immediateResponsePreferred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_re_synchronisationInfo = SEQ(name=u're-synchronisationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Re-synchronisationInfo')), opt=True)
    _SendAuthenticationInfoArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoArg_requestingNodeType = ENUM(name=u'requestingNodeType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestingNodeType')), opt=True)
    _SendAuthenticationInfoArg_requestingPLMN_Id = OCT_STR(name=u'requestingPLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors = INT(name=u'numberOfRequestedAdditional-Vectors', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendAuthenticationInfoArg_additionalVectorsAreForEPS = NULL(name=u'additionalVectorsAreForEPS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_ueUsageTypeRequestIndication = NULL(name=u'ueUsageTypeRequestIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendAuthenticationInfoArg._cont = ASN1Dict([
        (u'imsi', _SendAuthenticationInfoArg_imsi),
        (u'numberOfRequestedVectors', _SendAuthenticationInfoArg_numberOfRequestedVectors),
        (u'segmentationProhibited', _SendAuthenticationInfoArg_segmentationProhibited),
        (u'immediateResponsePreferred', _SendAuthenticationInfoArg_immediateResponsePreferred),
        (u're-synchronisationInfo', _SendAuthenticationInfoArg_re_synchronisationInfo),
        (u'extensionContainer', _SendAuthenticationInfoArg_extensionContainer),
        (u'requestingNodeType', _SendAuthenticationInfoArg_requestingNodeType),
        (u'requestingPLMN-Id', _SendAuthenticationInfoArg_requestingPLMN_Id),
        (u'numberOfRequestedAdditional-Vectors', _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors),
        (u'additionalVectorsAreForEPS', _SendAuthenticationInfoArg_additionalVectorsAreForEPS),
        (u'ueUsageTypeRequestIndication', _SendAuthenticationInfoArg_ueUsageTypeRequestIndication),
        ])
    SendAuthenticationInfoArg._ext = [u'requestingNodeType', u'requestingPLMN-Id', u'numberOfRequestedAdditional-Vectors', u'additionalVectorsAreForEPS', u'ueUsageTypeRequestIndication']
    
    #-----< NumberOfRequestedVectors >-----#
    NumberOfRequestedVectors = INT(name=u'NumberOfRequestedVectors', mode=MODE_TYPE)
    NumberOfRequestedVectors._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Re-synchronisationInfo >-----#
    Re_synchronisationInfo = SEQ(name=u'Re-synchronisationInfo', mode=MODE_TYPE)
    _Re_synchronisationInfo_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _Re_synchronisationInfo_auts = OCT_STR(name=u'auts', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTS')))
    Re_synchronisationInfo._cont = ASN1Dict([
        (u'rand', _Re_synchronisationInfo_rand),
        (u'auts', _Re_synchronisationInfo_auts),
        ])
    Re_synchronisationInfo._ext = []
    
    #-----< SendAuthenticationInfoRes >-----#
    SendAuthenticationInfoRes = SEQ(name=u'SendAuthenticationInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendAuthenticationInfoRes_authenticationSetList = CHOICE(name=u'authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoRes_eps_AuthenticationSetList = SEQ_OF(name=u'eps-AuthenticationSetList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_ueUsageType = OCT_STR(name=u'ueUsageType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    SendAuthenticationInfoRes._cont = ASN1Dict([
        (u'authenticationSetList', _SendAuthenticationInfoRes_authenticationSetList),
        (u'extensionContainer', _SendAuthenticationInfoRes_extensionContainer),
        (u'eps-AuthenticationSetList', _SendAuthenticationInfoRes_eps_AuthenticationSetList),
        (u'ueUsageType', _SendAuthenticationInfoRes_ueUsageType),
        ])
    SendAuthenticationInfoRes._ext = [u'eps-AuthenticationSetList', u'ueUsageType']
    
    #-----< EPS-AuthenticationSetList >-----#
    EPS_AuthenticationSetList = SEQ_OF(name=u'EPS-AuthenticationSetList', mode=MODE_TYPE)
    _EPS_AuthenticationSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPC-AV')))
    EPS_AuthenticationSetList._cont = _EPS_AuthenticationSetList__item_
    EPS_AuthenticationSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< UE-UsageType >-----#
    UE_UsageType = OCT_STR(name=u'UE-UsageType', mode=MODE_TYPE)
    UE_UsageType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< EPC-AV >-----#
    EPC_AV = SEQ(name=u'EPC-AV', mode=MODE_TYPE)
    _EPC_AV_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _EPC_AV_xres = OCT_STR(name=u'xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _EPC_AV_autn = OCT_STR(name=u'autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    _EPC_AV_kasme = OCT_STR(name=u'kasme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KASME')))
    _EPC_AV_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPC_AV._cont = ASN1Dict([
        (u'rand', _EPC_AV_rand),
        (u'xres', _EPC_AV_xres),
        (u'autn', _EPC_AV_autn),
        (u'kasme', _EPC_AV_kasme),
        (u'extensionContainer', _EPC_AV_extensionContainer),
        ])
    EPC_AV._ext = []
    
    #-----< KASME >-----#
    KASME = OCT_STR(name=u'KASME', mode=MODE_TYPE)
    KASME._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< RequestingNodeType >-----#
    RequestingNodeType = ENUM(name=u'RequestingNodeType', mode=MODE_TYPE)
    RequestingNodeType._cont = ASN1Dict([(u'vlr', 0), (u'sgsn', 1), (u's-cscf', 2), (u'bsf', 3), (u'gan-aaa-server', 4), (u'wlan-aaa-server', 5), (u'mme', 16), (u'mme-sgsn', 17)])
    RequestingNodeType._ext = [u's-cscf', u'bsf', u'gan-aaa-server', u'wlan-aaa-server', u'mme', u'mme-sgsn']
    
    #-----< CheckIMEI-Arg >-----#
    CheckIMEI_Arg = SEQ(name=u'CheckIMEI-Arg', mode=MODE_TYPE)
    _CheckIMEI_Arg_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _CheckIMEI_Arg_requestedEquipmentInfo = BIT_STR(name=u'requestedEquipmentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedEquipmentInfo')))
    _CheckIMEI_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Arg._cont = ASN1Dict([
        (u'imei', _CheckIMEI_Arg_imei),
        (u'requestedEquipmentInfo', _CheckIMEI_Arg_requestedEquipmentInfo),
        (u'extensionContainer', _CheckIMEI_Arg_extensionContainer),
        ])
    CheckIMEI_Arg._ext = []
    
    #-----< CheckIMEI-Res >-----#
    CheckIMEI_Res = SEQ(name=u'CheckIMEI-Res', mode=MODE_TYPE)
    _CheckIMEI_Res_equipmentStatus = ENUM(name=u'equipmentStatus', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EquipmentStatus')), opt=True)
    _CheckIMEI_Res_bmuef = SEQ(name=u'bmuef', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _CheckIMEI_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Res._cont = ASN1Dict([
        (u'equipmentStatus', _CheckIMEI_Res_equipmentStatus),
        (u'bmuef', _CheckIMEI_Res_bmuef),
        (u'extensionContainer', _CheckIMEI_Res_extensionContainer),
        ])
    CheckIMEI_Res._ext = []
    
    #-----< RequestedEquipmentInfo >-----#
    RequestedEquipmentInfo = BIT_STR(name=u'RequestedEquipmentInfo', mode=MODE_TYPE)
    RequestedEquipmentInfo._cont = ASN1Dict([(u'equipmentStatus', 0), (u'bmuef', 1)])
    RequestedEquipmentInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UESBI-Iu >-----#
    UESBI_Iu = SEQ(name=u'UESBI-Iu', mode=MODE_TYPE)
    _UESBI_Iu_uesbi_IuA = BIT_STR(name=u'uesbi-IuA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuA')), opt=True)
    _UESBI_Iu_uesbi_IuB = BIT_STR(name=u'uesbi-IuB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuB')), opt=True)
    UESBI_Iu._cont = ASN1Dict([
        (u'uesbi-IuA', _UESBI_Iu_uesbi_IuA),
        (u'uesbi-IuB', _UESBI_Iu_uesbi_IuB),
        ])
    UESBI_Iu._ext = []
    
    #-----< UESBI-IuA >-----#
    UESBI_IuA = BIT_STR(name=u'UESBI-IuA', mode=MODE_TYPE)
    UESBI_IuA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UESBI-IuB >-----#
    UESBI_IuB = BIT_STR(name=u'UESBI-IuB', mode=MODE_TYPE)
    UESBI_IuB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< EquipmentStatus >-----#
    EquipmentStatus = ENUM(name=u'EquipmentStatus', mode=MODE_TYPE)
    EquipmentStatus._cont = ASN1Dict([(u'whiteListed', 0), (u'blackListed', 1), (u'greyListed', 2)])
    EquipmentStatus._ext = None
    
    #-----< InsertSubscriberDataArg >-----#
    InsertSubscriberDataArg = SEQ(name=u'InsertSubscriberDataArg', mode=MODE_TYPE)
    _InsertSubscriberDataArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _InsertSubscriberDataArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_category = OCT_STR(name=u'category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _InsertSubscriberDataArg_subscriberStatus = ENUM(name=u'subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _InsertSubscriberDataArg_bearerServiceList = SEQ_OF(name=u'bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataArg_teleserviceList = SEQ_OF(name=u'teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataArg_provisionedSS = SEQ_OF(name=u'provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _InsertSubscriberDataArg_odb_Data = SEQ(name=u'odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name=u'roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_regionalSubscriptionData = SEQ_OF(name=u'regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _InsertSubscriberDataArg_vbsSubscriptionData = SEQ_OF(name=u'vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _InsertSubscriberDataArg_vgcsSubscriptionData = SEQ_OF(name=u'vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _InsertSubscriberDataArg_vlrCamelSubscriptionInfo = SEQ(name=u'vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataArg_naea_PreferredCI = SEQ(name=u'naea-PreferredCI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _InsertSubscriberDataArg_gprsSubscriptionData = SEQ(name=u'gprsSubscriptionData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionData')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature = NULL(name=u'roamingRestrictedInSgsnDueToUnsupportedFeature', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_networkAccessMode = ENUM(name=u'networkAccessMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NetworkAccessMode')), opt=True)
    _InsertSubscriberDataArg_lsaInformation = SEQ(name=u'lsaInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformation')), opt=True)
    _InsertSubscriberDataArg_lmu_Indicator = NULL(name=u'lmu-Indicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_lcsInformation = SEQ(name=u'lcsInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCSInformation')), opt=True)
    _InsertSubscriberDataArg_istAlertTimer = INT(name=u'istAlertTimer', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _InsertSubscriberDataArg_superChargerSupportedInHLR = OCT_STR(name=u'superChargerSupportedInHLR', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')), opt=True)
    _InsertSubscriberDataArg_mc_SS_Info = SEQ(name=u'mc-SS-Info', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-SS-Info')), opt=True)
    _InsertSubscriberDataArg_cs_AllocationRetentionPriority = OCT_STR(name=u'cs-AllocationRetentionPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CS-AllocationRetentionPriority')), opt=True)
    _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo = SEQ(name=u'sgsn-CAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-CAMEL-SubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _InsertSubscriberDataArg_accessRestrictionData = BIT_STR(name=u'accessRestrictionData', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_ics_Indicator = BOOL(name=u'ics-Indicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_eps_SubscriptionData = SEQ(name=u'eps-SubscriptionData', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionData')), opt=True)
    _InsertSubscriberDataArg_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator = NULL(name=u'ue-ReachabilityRequestIndicator', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_mme_Name = OCT_STR(name=u'mme-Name', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer = INT(name=u'subscribedPeriodicRAUTAUtimer', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicRAUTAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmnLIPAAllowed = NULL(name=u'vplmnLIPAAllowed', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_mdtUserConsent = BOOL(name=u'mdtUserConsent', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicLAUtimer = INT(name=u'subscribedPeriodicLAUtimer', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicLAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList = SEQ_OF(name=u'vplmn-Csg-SubscriptionDataList', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VPLMN-CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_additionalMSISDN = OCT_STR(name=u'additionalMSISDN', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision = NULL(name=u'psAndSMS-OnlyServiceProvision', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_smsInSGSNAllowed = NULL(name=u'smsInSGSNAllowed', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator = NULL(name=u'cs-to-ps-SRVCC-Allowed-Indicator', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_pcscf_Restoration_Request = NULL(name=u'pcscf-Restoration-Request', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_adjacentAccessRestrictionDataList = SEQ_OF(name=u'adjacentAccessRestrictionDataList', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionDataList')), opt=True)
    _InsertSubscriberDataArg_imsi_Group_Id_List = SEQ_OF(name=u'imsi-Group-Id-List', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupIdList')), opt=True)
    _InsertSubscriberDataArg_ueUsageType = OCT_STR(name=u'ueUsageType', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator = NULL(name=u'userPlaneIntegrityProtectionIndicator', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count = INT(name=u'dl-Buffering-Suggested-Packet-Count', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DL-Buffering-Suggested-Packet-Count')), opt=True)
    _InsertSubscriberDataArg_reset_Id_List = SEQ_OF(name=u'reset-Id-List', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _InsertSubscriberDataArg_eDRX_Cycle_Length_List = SEQ_OF(name=u'eDRX-Cycle-Length-List', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-List')), opt=True)
    _InsertSubscriberDataArg_ext_AccessRestrictionData = BIT_STR(name=u'ext-AccessRestrictionData', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator = NULL(name=u'iab-Operation-Allowed-Indicator', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    InsertSubscriberDataArg._cont = ASN1Dict([
        (u'imsi', _InsertSubscriberDataArg_imsi),
        (u'msisdn', _InsertSubscriberDataArg_msisdn),
        (u'category', _InsertSubscriberDataArg_category),
        (u'subscriberStatus', _InsertSubscriberDataArg_subscriberStatus),
        (u'bearerServiceList', _InsertSubscriberDataArg_bearerServiceList),
        (u'teleserviceList', _InsertSubscriberDataArg_teleserviceList),
        (u'provisionedSS', _InsertSubscriberDataArg_provisionedSS),
        (u'odb-Data', _InsertSubscriberDataArg_odb_Data),
        (u'roamingRestrictionDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        (u'regionalSubscriptionData', _InsertSubscriberDataArg_regionalSubscriptionData),
        (u'vbsSubscriptionData', _InsertSubscriberDataArg_vbsSubscriptionData),
        (u'vgcsSubscriptionData', _InsertSubscriberDataArg_vgcsSubscriptionData),
        (u'vlrCamelSubscriptionInfo', _InsertSubscriberDataArg_vlrCamelSubscriptionInfo),
        (u'extensionContainer', _InsertSubscriberDataArg_extensionContainer),
        (u'naea-PreferredCI', _InsertSubscriberDataArg_naea_PreferredCI),
        (u'gprsSubscriptionData', _InsertSubscriberDataArg_gprsSubscriptionData),
        (u'roamingRestrictedInSgsnDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature),
        (u'networkAccessMode', _InsertSubscriberDataArg_networkAccessMode),
        (u'lsaInformation', _InsertSubscriberDataArg_lsaInformation),
        (u'lmu-Indicator', _InsertSubscriberDataArg_lmu_Indicator),
        (u'lcsInformation', _InsertSubscriberDataArg_lcsInformation),
        (u'istAlertTimer', _InsertSubscriberDataArg_istAlertTimer),
        (u'superChargerSupportedInHLR', _InsertSubscriberDataArg_superChargerSupportedInHLR),
        (u'mc-SS-Info', _InsertSubscriberDataArg_mc_SS_Info),
        (u'cs-AllocationRetentionPriority', _InsertSubscriberDataArg_cs_AllocationRetentionPriority),
        (u'sgsn-CAMEL-SubscriptionInfo', _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo),
        (u'chargingCharacteristics', _InsertSubscriberDataArg_chargingCharacteristics),
        (u'accessRestrictionData', _InsertSubscriberDataArg_accessRestrictionData),
        (u'ics-Indicator', _InsertSubscriberDataArg_ics_Indicator),
        (u'eps-SubscriptionData', _InsertSubscriberDataArg_eps_SubscriptionData),
        (u'csg-SubscriptionDataList', _InsertSubscriberDataArg_csg_SubscriptionDataList),
        (u'ue-ReachabilityRequestIndicator', _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator),
        (u'sgsn-Number', _InsertSubscriberDataArg_sgsn_Number),
        (u'mme-Name', _InsertSubscriberDataArg_mme_Name),
        (u'subscribedPeriodicRAUTAUtimer', _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer),
        (u'vplmnLIPAAllowed', _InsertSubscriberDataArg_vplmnLIPAAllowed),
        (u'mdtUserConsent', _InsertSubscriberDataArg_mdtUserConsent),
        (u'subscribedPeriodicLAUtimer', _InsertSubscriberDataArg_subscribedPeriodicLAUtimer),
        (u'vplmn-Csg-SubscriptionDataList', _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList),
        (u'additionalMSISDN', _InsertSubscriberDataArg_additionalMSISDN),
        (u'psAndSMS-OnlyServiceProvision', _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision),
        (u'smsInSGSNAllowed', _InsertSubscriberDataArg_smsInSGSNAllowed),
        (u'cs-to-ps-SRVCC-Allowed-Indicator', _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator),
        (u'pcscf-Restoration-Request', _InsertSubscriberDataArg_pcscf_Restoration_Request),
        (u'adjacentAccessRestrictionDataList', _InsertSubscriberDataArg_adjacentAccessRestrictionDataList),
        (u'imsi-Group-Id-List', _InsertSubscriberDataArg_imsi_Group_Id_List),
        (u'ueUsageType', _InsertSubscriberDataArg_ueUsageType),
        (u'userPlaneIntegrityProtectionIndicator', _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator),
        (u'dl-Buffering-Suggested-Packet-Count', _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count),
        (u'reset-Id-List', _InsertSubscriberDataArg_reset_Id_List),
        (u'eDRX-Cycle-Length-List', _InsertSubscriberDataArg_eDRX_Cycle_Length_List),
        (u'ext-AccessRestrictionData', _InsertSubscriberDataArg_ext_AccessRestrictionData),
        (u'iab-Operation-Allowed-Indicator', _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator),
        ])
    InsertSubscriberDataArg._ext = [u'naea-PreferredCI', u'gprsSubscriptionData', u'roamingRestrictedInSgsnDueToUnsupportedFeature', u'networkAccessMode', u'lsaInformation', u'lmu-Indicator', u'lcsInformation', u'istAlertTimer', u'superChargerSupportedInHLR', u'mc-SS-Info', u'cs-AllocationRetentionPriority', u'sgsn-CAMEL-SubscriptionInfo', u'chargingCharacteristics', u'accessRestrictionData', u'ics-Indicator', u'eps-SubscriptionData', u'csg-SubscriptionDataList', u'ue-ReachabilityRequestIndicator', u'sgsn-Number', u'mme-Name', u'subscribedPeriodicRAUTAUtimer', u'vplmnLIPAAllowed', u'mdtUserConsent', u'subscribedPeriodicLAUtimer', u'vplmn-Csg-SubscriptionDataList', u'additionalMSISDN', u'psAndSMS-OnlyServiceProvision', u'smsInSGSNAllowed', u'cs-to-ps-SRVCC-Allowed-Indicator', u'pcscf-Restoration-Request', u'adjacentAccessRestrictionDataList', u'imsi-Group-Id-List', u'ueUsageType', u'userPlaneIntegrityProtectionIndicator', u'dl-Buffering-Suggested-Packet-Count', u'reset-Id-List', u'eDRX-Cycle-Length-List', u'ext-AccessRestrictionData', u'iab-Operation-Allowed-Indicator']
    
    #-----< EDRX-Cycle-Length-List >-----#
    EDRX_Cycle_Length_List = SEQ_OF(name=u'EDRX-Cycle-Length-List', mode=MODE_TYPE)
    _EDRX_Cycle_Length_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length')))
    EDRX_Cycle_Length_List._cont = _EDRX_Cycle_Length_List__item_
    EDRX_Cycle_Length_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDRX-Cycle-Length >-----#
    EDRX_Cycle_Length = SEQ(name=u'EDRX-Cycle-Length', mode=MODE_TYPE)
    _EDRX_Cycle_Length_rat_Type = ENUM(name=u'rat-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')))
    _EDRX_Cycle_Length_eDRX_Cycle_Length_Value = OCT_STR(name=u'eDRX-Cycle-Length-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-Value')))
    EDRX_Cycle_Length._cont = ASN1Dict([
        (u'rat-Type', _EDRX_Cycle_Length_rat_Type),
        (u'eDRX-Cycle-Length-Value', _EDRX_Cycle_Length_eDRX_Cycle_Length_Value),
        ])
    EDRX_Cycle_Length._ext = []
    
    #-----< EDRX-Cycle-Length-Value >-----#
    EDRX_Cycle_Length_Value = OCT_STR(name=u'EDRX-Cycle-Length-Value', mode=MODE_TYPE)
    EDRX_Cycle_Length_Value._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Reset-Id-List >-----#
    Reset_Id_List = SEQ_OF(name=u'Reset-Id-List', mode=MODE_TYPE)
    _Reset_Id_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id')))
    Reset_Id_List._cont = _Reset_Id_List__item_
    Reset_Id_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< Reset-Id >-----#
    Reset_Id = OCT_STR(name=u'Reset-Id', mode=MODE_TYPE)
    Reset_Id._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DL-Buffering-Suggested-Packet-Count >-----#
    DL_Buffering_Suggested_Packet_Count = INT(name=u'DL-Buffering-Suggested-Packet-Count', mode=MODE_TYPE)
    DL_Buffering_Suggested_Packet_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=2147483647)], ev=None, er=[])
    
    #-----< Group-Service-ID >-----#
    Group_Service_ID = INT(name=u'Group-Service-ID', mode=MODE_TYPE)
    Group_Service_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< Local-GroupID >-----#
    Local_GroupID = OCT_STR(name=u'Local-GroupID', mode=MODE_TYPE)
    Local_GroupID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< IMSI-GroupIdList >-----#
    IMSI_GroupIdList = SEQ_OF(name=u'IMSI-GroupIdList', mode=MODE_TYPE)
    _IMSI_GroupIdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupId')))
    IMSI_GroupIdList._cont = _IMSI_GroupIdList__item_
    IMSI_GroupIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< IMSI-GroupId >-----#
    IMSI_GroupId = SEQ(name=u'IMSI-GroupId', mode=MODE_TYPE)
    _IMSI_GroupId_group_Service_Id = INT(name=u'group-Service-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Group-Service-ID')))
    _IMSI_GroupId_plmnId = OCT_STR(name=u'plmnId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _IMSI_GroupId_local_Group_ID = OCT_STR(name=u'local-Group-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Local-GroupID')))
    IMSI_GroupId._cont = ASN1Dict([
        (u'group-Service-Id', _IMSI_GroupId_group_Service_Id),
        (u'plmnId', _IMSI_GroupId_plmnId),
        (u'local-Group-ID', _IMSI_GroupId_local_Group_ID),
        ])
    IMSI_GroupId._ext = []
    
    #-----< SubscribedPeriodicRAUTAUtimer >-----#
    SubscribedPeriodicRAUTAUtimer = INT(name=u'SubscribedPeriodicRAUTAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicRAUTAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SubscribedPeriodicLAUtimer >-----#
    SubscribedPeriodicLAUtimer = INT(name=u'SubscribedPeriodicLAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicLAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< CSG-SubscriptionDataList >-----#
    CSG_SubscriptionDataList = SEQ_OF(name=u'CSG-SubscriptionDataList', mode=MODE_TYPE)
    _CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    CSG_SubscriptionDataList._cont = _CSG_SubscriptionDataList__item_
    CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-SubscriptionData >-----#
    CSG_SubscriptionData = SEQ(name=u'CSG-SubscriptionData', mode=MODE_TYPE)
    _CSG_SubscriptionData_csg_Id = BIT_STR(name=u'csg-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _CSG_SubscriptionData_expirationDate = OCT_STR(name=u'expirationDate', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _CSG_SubscriptionData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CSG_SubscriptionData_lipa_AllowedAPNList = SEQ_OF(name=u'lipa-AllowedAPNList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-AllowedAPNList')), opt=True)
    _CSG_SubscriptionData_plmn_Id = OCT_STR(name=u'plmn-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    CSG_SubscriptionData._cont = ASN1Dict([
        (u'csg-Id', _CSG_SubscriptionData_csg_Id),
        (u'expirationDate', _CSG_SubscriptionData_expirationDate),
        (u'extensionContainer', _CSG_SubscriptionData_extensionContainer),
        (u'lipa-AllowedAPNList', _CSG_SubscriptionData_lipa_AllowedAPNList),
        (u'plmn-Id', _CSG_SubscriptionData_plmn_Id),
        ])
    CSG_SubscriptionData._ext = [u'lipa-AllowedAPNList', u'plmn-Id']
    
    #-----< VPLMN-CSG-SubscriptionDataList >-----#
    VPLMN_CSG_SubscriptionDataList = SEQ_OF(name=u'VPLMN-CSG-SubscriptionDataList', mode=MODE_TYPE)
    _VPLMN_CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    VPLMN_CSG_SubscriptionDataList._cont = _VPLMN_CSG_SubscriptionDataList__item_
    VPLMN_CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name=u'CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< LIPA-AllowedAPNList >-----#
    LIPA_AllowedAPNList = SEQ_OF(name=u'LIPA-AllowedAPNList', mode=MODE_TYPE)
    _LIPA_AllowedAPNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    LIPA_AllowedAPNList._cont = _LIPA_AllowedAPNList__item_
    LIPA_AllowedAPNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfLIPAAllowedAPN >-----#
    maxNumOfLIPAAllowedAPN = INT(name=u'maxNumOfLIPAAllowedAPN', mode=MODE_VALUE)
    maxNumOfLIPAAllowedAPN._val = 50
    
    #-----< EPS-SubscriptionData >-----#
    EPS_SubscriptionData = SEQ(name=u'EPS-SubscriptionData', mode=MODE_TYPE)
    _EPS_SubscriptionData_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _EPS_SubscriptionData_rfsp_id = INT(name=u'rfsp-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RFSP-ID')), opt=True)
    _EPS_SubscriptionData_ambr = SEQ(name=u'ambr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _EPS_SubscriptionData_apn_ConfigurationProfile = SEQ(name=u'apn-ConfigurationProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-ConfigurationProfile')), opt=True)
    _EPS_SubscriptionData_stn_sr = OCT_STR(name=u'stn-sr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _EPS_SubscriptionData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _EPS_SubscriptionData_mps_CSPriority = NULL(name=u'mps-CSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_mps_EPSPriority = NULL(name=u'mps-EPSPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_subscribed_vsrvcc = NULL(name=u'subscribed-vsrvcc', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPS_SubscriptionData._cont = ASN1Dict([
        (u'apn-oi-Replacement', _EPS_SubscriptionData_apn_oi_Replacement),
        (u'rfsp-id', _EPS_SubscriptionData_rfsp_id),
        (u'ambr', _EPS_SubscriptionData_ambr),
        (u'apn-ConfigurationProfile', _EPS_SubscriptionData_apn_ConfigurationProfile),
        (u'stn-sr', _EPS_SubscriptionData_stn_sr),
        (u'extensionContainer', _EPS_SubscriptionData_extensionContainer),
        (u'mps-CSPriority', _EPS_SubscriptionData_mps_CSPriority),
        (u'mps-EPSPriority', _EPS_SubscriptionData_mps_EPSPriority),
        (u'subscribed-vsrvcc', _EPS_SubscriptionData_subscribed_vsrvcc),
        ])
    EPS_SubscriptionData._ext = [u'mps-CSPriority', u'mps-EPSPriority', u'subscribed-vsrvcc']
    
    #-----< APN-OI-Replacement >-----#
    APN_OI_Replacement = OCT_STR(name=u'APN-OI-Replacement', mode=MODE_TYPE)
    APN_OI_Replacement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=100)], ev=None, er=[])
    
    #-----< RFSP-ID >-----#
    RFSP_ID = INT(name=u'RFSP-ID', mode=MODE_TYPE)
    RFSP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< APN-ConfigurationProfile >-----#
    APN_ConfigurationProfile = SEQ(name=u'APN-ConfigurationProfile', mode=MODE_TYPE)
    _APN_ConfigurationProfile_defaultContext = INT(name=u'defaultContext', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_ConfigurationProfile_completeDataListIncluded = NULL(name=u'completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _APN_ConfigurationProfile_epsDataList = SEQ_OF(name=u'epsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-DataList')))
    _APN_ConfigurationProfile_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_ConfigurationProfile_additionalDefaultContext = INT(name=u'additionalDefaultContext', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    APN_ConfigurationProfile._cont = ASN1Dict([
        (u'defaultContext', _APN_ConfigurationProfile_defaultContext),
        (u'completeDataListIncluded', _APN_ConfigurationProfile_completeDataListIncluded),
        (u'epsDataList', _APN_ConfigurationProfile_epsDataList),
        (u'extensionContainer', _APN_ConfigurationProfile_extensionContainer),
        (u'additionalDefaultContext', _APN_ConfigurationProfile_additionalDefaultContext),
        ])
    APN_ConfigurationProfile._ext = [u'additionalDefaultContext']
    
    #-----< EPS-DataList >-----#
    EPS_DataList = SEQ_OF(name=u'EPS-DataList', mode=MODE_TYPE)
    _EPS_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-Configuration')))
    EPS_DataList._cont = _EPS_DataList__item_
    EPS_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfAPN-Configurations >-----#
    maxNumOfAPN_Configurations = INT(name=u'maxNumOfAPN-Configurations', mode=MODE_VALUE)
    maxNumOfAPN_Configurations._val = 50
    
    #-----< APN-Configuration >-----#
    APN_Configuration = SEQ(name=u'APN-Configuration', mode=MODE_TYPE)
    _APN_Configuration_contextId = INT(name=u'contextId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_Configuration_pdn_Type = OCT_STR(name=u'pdn-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-Type')))
    _APN_Configuration_servedPartyIP_IPv4_Address = OCT_STR(name=u'servedPartyIP-IPv4-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _APN_Configuration_eps_qos_Subscribed = SEQ(name=u'eps-qos-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-QoS-Subscribed')))
    _APN_Configuration_pdn_gw_Identity = SEQ(name=u'pdn-gw-Identity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _APN_Configuration_pdn_gw_AllocationType = ENUM(name=u'pdn-gw-AllocationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-AllocationType')), opt=True)
    _APN_Configuration_vplmnAddressAllowed = NULL(name=u'vplmnAddressAllowed', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _APN_Configuration_ambr = SEQ(name=u'ambr', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _APN_Configuration_specificAPNInfoList = SEQ_OF(name=u'specificAPNInfoList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfoList')), opt=True)
    _APN_Configuration_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_Configuration_servedPartyIP_IPv6_Address = OCT_STR(name=u'servedPartyIP-IPv6-Address', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _APN_Configuration_sipto_Permission = ENUM(name=u'sipto-Permission', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _APN_Configuration_lipa_Permission = ENUM(name=u'lipa-Permission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _APN_Configuration_restoration_Priority = OCT_STR(name=u'restoration-Priority', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _APN_Configuration_sipto_local_network_Permission = ENUM(name=u'sipto-local-network-Permission', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _APN_Configuration_wlan_offloadability = SEQ(name=u'wlan-offloadability', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability')), opt=True)
    _APN_Configuration_non_IP_PDN_Type_Indicator = NULL(name=u'non-IP-PDN-Type-Indicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_nIDD_Mechanism = ENUM(name=u'nIDD-Mechanism', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _APN_Configuration_sCEF_ID = OCT_STR(name=u'sCEF-ID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _APN_Configuration_pdn_ConnectionContinuity = ENUM(name=u'pdn-ConnectionContinuity', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-ConnectionContinuity')), opt=True)
    APN_Configuration._cont = ASN1Dict([
        (u'contextId', _APN_Configuration_contextId),
        (u'pdn-Type', _APN_Configuration_pdn_Type),
        (u'servedPartyIP-IPv4-Address', _APN_Configuration_servedPartyIP_IPv4_Address),
        (u'apn', _APN_Configuration_apn),
        (u'eps-qos-Subscribed', _APN_Configuration_eps_qos_Subscribed),
        (u'pdn-gw-Identity', _APN_Configuration_pdn_gw_Identity),
        (u'pdn-gw-AllocationType', _APN_Configuration_pdn_gw_AllocationType),
        (u'vplmnAddressAllowed', _APN_Configuration_vplmnAddressAllowed),
        (u'chargingCharacteristics', _APN_Configuration_chargingCharacteristics),
        (u'ambr', _APN_Configuration_ambr),
        (u'specificAPNInfoList', _APN_Configuration_specificAPNInfoList),
        (u'extensionContainer', _APN_Configuration_extensionContainer),
        (u'servedPartyIP-IPv6-Address', _APN_Configuration_servedPartyIP_IPv6_Address),
        (u'apn-oi-Replacement', _APN_Configuration_apn_oi_Replacement),
        (u'sipto-Permission', _APN_Configuration_sipto_Permission),
        (u'lipa-Permission', _APN_Configuration_lipa_Permission),
        (u'restoration-Priority', _APN_Configuration_restoration_Priority),
        (u'sipto-local-network-Permission', _APN_Configuration_sipto_local_network_Permission),
        (u'wlan-offloadability', _APN_Configuration_wlan_offloadability),
        (u'non-IP-PDN-Type-Indicator', _APN_Configuration_non_IP_PDN_Type_Indicator),
        (u'nIDD-Mechanism', _APN_Configuration_nIDD_Mechanism),
        (u'sCEF-ID', _APN_Configuration_sCEF_ID),
        (u'pdn-ConnectionContinuity', _APN_Configuration_pdn_ConnectionContinuity),
        ])
    APN_Configuration._ext = [u'apn-oi-Replacement', u'sipto-Permission', u'lipa-Permission', u'restoration-Priority', u'sipto-local-network-Permission', u'wlan-offloadability', u'non-IP-PDN-Type-Indicator', u'nIDD-Mechanism', u'sCEF-ID', u'pdn-ConnectionContinuity']
    
    #-----< PDN-ConnectionContinuity >-----#
    PDN_ConnectionContinuity = ENUM(name=u'PDN-ConnectionContinuity', mode=MODE_TYPE)
    PDN_ConnectionContinuity._cont = ASN1Dict([(u'maintainPDN-Connection', 0), (u'disconnectPDN-ConnectionWithReactivationRequest', 1), (u'disconnectPDN-ConnectionWithoutReactivationRequest', 2)])
    PDN_ConnectionContinuity._ext = None
    
    #-----< NIDD-Mechanism >-----#
    NIDD_Mechanism = ENUM(name=u'NIDD-Mechanism', mode=MODE_TYPE)
    NIDD_Mechanism._cont = ASN1Dict([(u'sGi-based-data-delivery', 0), (u'sCEF-based-data-delivery', 1)])
    NIDD_Mechanism._ext = None
    
    #-----< PDN-Type >-----#
    PDN_Type = OCT_STR(name=u'PDN-Type', mode=MODE_TYPE)
    PDN_Type._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EPS-QoS-Subscribed >-----#
    EPS_QoS_Subscribed = SEQ(name=u'EPS-QoS-Subscribed', mode=MODE_TYPE)
    _EPS_QoS_Subscribed_qos_Class_Identifier = INT(name=u'qos-Class-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Class-Identifier')))
    _EPS_QoS_Subscribed_allocation_Retention_Priority = SEQ(name=u'allocation-Retention-Priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Allocation-Retention-Priority')))
    _EPS_QoS_Subscribed_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPS_QoS_Subscribed._cont = ASN1Dict([
        (u'qos-Class-Identifier', _EPS_QoS_Subscribed_qos_Class_Identifier),
        (u'allocation-Retention-Priority', _EPS_QoS_Subscribed_allocation_Retention_Priority),
        (u'extensionContainer', _EPS_QoS_Subscribed_extensionContainer),
        ])
    EPS_QoS_Subscribed._ext = []
    
    #-----< AMBR >-----#
    AMBR = SEQ(name=u'AMBR', mode=MODE_TYPE)
    _AMBR_max_RequestedBandwidth_UL = INT(name=u'max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_max_RequestedBandwidth_DL = INT(name=u'max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_UL = INT(name=u'extended-Max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_DL = INT(name=u'extended-Max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    AMBR._cont = ASN1Dict([
        (u'max-RequestedBandwidth-UL', _AMBR_max_RequestedBandwidth_UL),
        (u'max-RequestedBandwidth-DL', _AMBR_max_RequestedBandwidth_DL),
        (u'extensionContainer', _AMBR_extensionContainer),
        (u'extended-Max-RequestedBandwidth-UL', _AMBR_extended_Max_RequestedBandwidth_UL),
        (u'extended-Max-RequestedBandwidth-DL', _AMBR_extended_Max_RequestedBandwidth_DL),
        ])
    AMBR._ext = [u'extended-Max-RequestedBandwidth-UL', u'extended-Max-RequestedBandwidth-DL']
    
    #-----< SpecificAPNInfoList >-----#
    SpecificAPNInfoList = SEQ_OF(name=u'SpecificAPNInfoList', mode=MODE_TYPE)
    _SpecificAPNInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfo')))
    SpecificAPNInfoList._cont = _SpecificAPNInfoList__item_
    SpecificAPNInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfSpecificAPNInfos >-----#
    maxNumOfSpecificAPNInfos = INT(name=u'maxNumOfSpecificAPNInfos', mode=MODE_VALUE)
    maxNumOfSpecificAPNInfos._val = 50
    
    #-----< SpecificAPNInfo >-----#
    SpecificAPNInfo = SEQ(name=u'SpecificAPNInfo', mode=MODE_TYPE)
    _SpecificAPNInfo_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _SpecificAPNInfo_pdn_gw_Identity = SEQ(name=u'pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')))
    _SpecificAPNInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SpecificAPNInfo._cont = ASN1Dict([
        (u'apn', _SpecificAPNInfo_apn),
        (u'pdn-gw-Identity', _SpecificAPNInfo_pdn_gw_Identity),
        (u'extensionContainer', _SpecificAPNInfo_extensionContainer),
        ])
    SpecificAPNInfo._ext = []
    
    #-----< Bandwidth >-----#
    Bandwidth = INT(name=u'Bandwidth', mode=MODE_TYPE)
    
    #-----< BandwidthExt >-----#
    BandwidthExt = INT(name=u'BandwidthExt', mode=MODE_TYPE)
    
    #-----< QoS-Class-Identifier >-----#
    QoS_Class_Identifier = INT(name=u'QoS-Class-Identifier', mode=MODE_TYPE)
    QoS_Class_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Allocation-Retention-Priority >-----#
    Allocation_Retention_Priority = SEQ(name=u'Allocation-Retention-Priority', mode=MODE_TYPE)
    _Allocation_Retention_Priority_priority_level = INT(name=u'priority-level', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Allocation_Retention_Priority_pre_emption_capability = BOOL(name=u'pre-emption-capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_pre_emption_vulnerability = BOOL(name=u'pre-emption-vulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Allocation_Retention_Priority._cont = ASN1Dict([
        (u'priority-level', _Allocation_Retention_Priority_priority_level),
        (u'pre-emption-capability', _Allocation_Retention_Priority_pre_emption_capability),
        (u'pre-emption-vulnerability', _Allocation_Retention_Priority_pre_emption_vulnerability),
        (u'extensionContainer', _Allocation_Retention_Priority_extensionContainer),
        ])
    Allocation_Retention_Priority._ext = []
    
    #-----< PDN-GW-Identity >-----#
    PDN_GW_Identity = SEQ(name=u'PDN-GW-Identity', mode=MODE_TYPE)
    _PDN_GW_Identity_pdn_gw_ipv4_Address = OCT_STR(name=u'pdn-gw-ipv4-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_ipv6_Address = OCT_STR(name=u'pdn-gw-ipv6-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_name = OCT_STR(name=u'pdn-gw-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _PDN_GW_Identity_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Identity._cont = ASN1Dict([
        (u'pdn-gw-ipv4-Address', _PDN_GW_Identity_pdn_gw_ipv4_Address),
        (u'pdn-gw-ipv6-Address', _PDN_GW_Identity_pdn_gw_ipv6_Address),
        (u'pdn-gw-name', _PDN_GW_Identity_pdn_gw_name),
        (u'extensionContainer', _PDN_GW_Identity_extensionContainer),
        ])
    PDN_GW_Identity._ext = []
    
    #-----< FQDN >-----#
    FQDN = OCT_STR(name=u'FQDN', mode=MODE_TYPE)
    FQDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< PDN-GW-AllocationType >-----#
    PDN_GW_AllocationType = ENUM(name=u'PDN-GW-AllocationType', mode=MODE_TYPE)
    PDN_GW_AllocationType._cont = ASN1Dict([(u'static', 0), (u'dynamic', 1)])
    PDN_GW_AllocationType._ext = None
    
    #-----< WLAN-Offloadability >-----#
    WLAN_Offloadability = SEQ(name=u'WLAN-Offloadability', mode=MODE_TYPE)
    _WLAN_Offloadability_wlan_offloadability_EUTRAN = ENUM(name=u'wlan-offloadability-EUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_wlan_offloadability_UTRAN = ENUM(name=u'wlan-offloadability-UTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    WLAN_Offloadability._cont = ASN1Dict([
        (u'wlan-offloadability-EUTRAN', _WLAN_Offloadability_wlan_offloadability_EUTRAN),
        (u'wlan-offloadability-UTRAN', _WLAN_Offloadability_wlan_offloadability_UTRAN),
        (u'extensionContainer', _WLAN_Offloadability_extensionContainer),
        ])
    WLAN_Offloadability._ext = []
    
    #-----< WLAN-Offloadability-Indication >-----#
    WLAN_Offloadability_Indication = ENUM(name=u'WLAN-Offloadability-Indication', mode=MODE_TYPE)
    WLAN_Offloadability_Indication._cont = ASN1Dict([(u'notAllowed', 0), (u'allowed', 1)])
    WLAN_Offloadability_Indication._ext = None
    
    #-----< AccessRestrictionData >-----#
    AccessRestrictionData = BIT_STR(name=u'AccessRestrictionData', mode=MODE_TYPE)
    AccessRestrictionData._cont = ASN1Dict([(u'utranNotAllowed', 0), (u'geranNotAllowed', 1), (u'ganNotAllowed', 2), (u'i-hspa-evolutionNotAllowed', 3), (u'wb-e-utranNotAllowed', 4), (u'ho-toNon3GPP-AccessNotAllowed', 5), (u'nb-iotNotAllowed', 6), (u'enhancedCoverageNotAllowed', 7)])
    AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< Ext-AccessRestrictionData >-----#
    Ext_AccessRestrictionData = BIT_STR(name=u'Ext-AccessRestrictionData', mode=MODE_TYPE)
    Ext_AccessRestrictionData._cont = ASN1Dict([(u'nrAsSecondaryRATNotAllowed', 0), (u'unlicensedSpectrumAsSecondaryRATNotAllowed', 1)])
    Ext_AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionDataList >-----#
    AdjacentAccessRestrictionDataList = SEQ_OF(name=u'AdjacentAccessRestrictionDataList', mode=MODE_TYPE)
    _AdjacentAccessRestrictionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionData')))
    AdjacentAccessRestrictionDataList._cont = _AdjacentAccessRestrictionDataList__item_
    AdjacentAccessRestrictionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionData >-----#
    AdjacentAccessRestrictionData = SEQ(name=u'AdjacentAccessRestrictionData', mode=MODE_TYPE)
    _AdjacentAccessRestrictionData_plmnId = OCT_STR(name=u'plmnId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _AdjacentAccessRestrictionData_accessRestrictionData = BIT_STR(name=u'accessRestrictionData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')))
    _AdjacentAccessRestrictionData_ext_AccessRestrictionData = BIT_STR(name=u'ext-AccessRestrictionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    AdjacentAccessRestrictionData._cont = ASN1Dict([
        (u'plmnId', _AdjacentAccessRestrictionData_plmnId),
        (u'accessRestrictionData', _AdjacentAccessRestrictionData_accessRestrictionData),
        (u'ext-AccessRestrictionData', _AdjacentAccessRestrictionData_ext_AccessRestrictionData),
        ])
    AdjacentAccessRestrictionData._ext = [u'ext-AccessRestrictionData']
    
    #-----< CS-AllocationRetentionPriority >-----#
    CS_AllocationRetentionPriority = OCT_STR(name=u'CS-AllocationRetentionPriority', mode=MODE_TYPE)
    CS_AllocationRetentionPriority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< IST-AlertTimerValue >-----#
    IST_AlertTimerValue = INT(name=u'IST-AlertTimerValue', mode=MODE_TYPE)
    IST_AlertTimerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=255)], ev=None, er=[])
    
    #-----< LCSInformation >-----#
    LCSInformation = SEQ(name=u'LCSInformation', mode=MODE_TYPE)
    _LCSInformation_gmlc_List = SEQ_OF(name=u'gmlc-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-List')), opt=True)
    _LCSInformation_lcs_PrivacyExceptionList = SEQ_OF(name=u'lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    _LCSInformation_molr_List = SEQ_OF(name=u'molr-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-List')), opt=True)
    _LCSInformation_add_lcs_PrivacyExceptionList = SEQ_OF(name=u'add-lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    LCSInformation._cont = ASN1Dict([
        (u'gmlc-List', _LCSInformation_gmlc_List),
        (u'lcs-PrivacyExceptionList', _LCSInformation_lcs_PrivacyExceptionList),
        (u'molr-List', _LCSInformation_molr_List),
        (u'add-lcs-PrivacyExceptionList', _LCSInformation_add_lcs_PrivacyExceptionList),
        ])
    LCSInformation._ext = [u'add-lcs-PrivacyExceptionList']
    
    #-----< GMLC-List >-----#
    GMLC_List = SEQ_OF(name=u'GMLC-List', mode=MODE_TYPE)
    _GMLC_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    GMLC_List._cont = _GMLC_List__item_
    GMLC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfGMLC >-----#
    maxNumOfGMLC = INT(name=u'maxNumOfGMLC', mode=MODE_VALUE)
    maxNumOfGMLC._val = 5
    
    #-----< NetworkAccessMode >-----#
    NetworkAccessMode = ENUM(name=u'NetworkAccessMode', mode=MODE_TYPE)
    NetworkAccessMode._cont = ASN1Dict([(u'packetAndCircuit', 0), (u'onlyCircuit', 1), (u'onlyPacket', 2)])
    NetworkAccessMode._ext = []
    
    #-----< GPRSDataList >-----#
    GPRSDataList = SEQ_OF(name=u'GPRSDataList', mode=MODE_TYPE)
    _GPRSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Context')))
    GPRSDataList._cont = _GPRSDataList__item_
    GPRSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfPDP-Contexts >-----#
    maxNumOfPDP_Contexts = INT(name=u'maxNumOfPDP-Contexts', mode=MODE_VALUE)
    maxNumOfPDP_Contexts._val = 50
    
    #-----< PDP-Context >-----#
    PDP_Context = SEQ(name=u'PDP-Context', mode=MODE_TYPE)
    _PDP_Context_pdp_ContextId = INT(name=u'pdp-ContextId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_Context_pdp_Type = OCT_STR(name=u'pdp-Type', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_Context_pdp_Address = OCT_STR(name=u'pdp-Address', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_qos_Subscribed = OCT_STR(name=u'qos-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _PDP_Context_vplmnAddressAllowed = NULL(name=u'vplmnAddressAllowed', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_Context_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _PDP_Context_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_Context_ext_QoS_Subscribed = OCT_STR(name=u'ext-QoS-Subscribed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_Context_pdp_ChargingCharacteristics = OCT_STR(name=u'pdp-ChargingCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_Context_ext2_QoS_Subscribed = OCT_STR(name=u'ext2-QoS-Subscribed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_Context_ext3_QoS_Subscribed = OCT_STR(name=u'ext3-QoS-Subscribed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_Context_ext4_QoS_Subscribed = OCT_STR(name=u'ext4-QoS-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_Context_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _PDP_Context_ext_pdp_Type = OCT_STR(name=u'ext-pdp-Type', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_Context_ext_pdp_Address = OCT_STR(name=u'ext-pdp-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_ambr = SEQ(name=u'ambr', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _PDP_Context_sipto_Permission = ENUM(name=u'sipto-Permission', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _PDP_Context_lipa_Permission = ENUM(name=u'lipa-Permission', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _PDP_Context_restoration_Priority = OCT_STR(name=u'restoration-Priority', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _PDP_Context_sipto_local_network_Permission = ENUM(name=u'sipto-local-network-Permission', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _PDP_Context_nIDD_Mechanism = ENUM(name=u'nIDD-Mechanism', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _PDP_Context_sCEF_ID = OCT_STR(name=u'sCEF-ID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    PDP_Context._cont = ASN1Dict([
        (u'pdp-ContextId', _PDP_Context_pdp_ContextId),
        (u'pdp-Type', _PDP_Context_pdp_Type),
        (u'pdp-Address', _PDP_Context_pdp_Address),
        (u'qos-Subscribed', _PDP_Context_qos_Subscribed),
        (u'vplmnAddressAllowed', _PDP_Context_vplmnAddressAllowed),
        (u'apn', _PDP_Context_apn),
        (u'extensionContainer', _PDP_Context_extensionContainer),
        (u'ext-QoS-Subscribed', _PDP_Context_ext_QoS_Subscribed),
        (u'pdp-ChargingCharacteristics', _PDP_Context_pdp_ChargingCharacteristics),
        (u'ext2-QoS-Subscribed', _PDP_Context_ext2_QoS_Subscribed),
        (u'ext3-QoS-Subscribed', _PDP_Context_ext3_QoS_Subscribed),
        (u'ext4-QoS-Subscribed', _PDP_Context_ext4_QoS_Subscribed),
        (u'apn-oi-Replacement', _PDP_Context_apn_oi_Replacement),
        (u'ext-pdp-Type', _PDP_Context_ext_pdp_Type),
        (u'ext-pdp-Address', _PDP_Context_ext_pdp_Address),
        (u'ambr', _PDP_Context_ambr),
        (u'sipto-Permission', _PDP_Context_sipto_Permission),
        (u'lipa-Permission', _PDP_Context_lipa_Permission),
        (u'restoration-Priority', _PDP_Context_restoration_Priority),
        (u'sipto-local-network-Permission', _PDP_Context_sipto_local_network_Permission),
        (u'nIDD-Mechanism', _PDP_Context_nIDD_Mechanism),
        (u'sCEF-ID', _PDP_Context_sCEF_ID),
        ])
    PDP_Context._ext = [u'ext-QoS-Subscribed', u'pdp-ChargingCharacteristics', u'ext2-QoS-Subscribed', u'ext3-QoS-Subscribed', u'ext4-QoS-Subscribed', u'apn-oi-Replacement', u'ext-pdp-Type', u'ext-pdp-Address', u'ambr', u'sipto-Permission', u'lipa-Permission', u'restoration-Priority', u'sipto-local-network-Permission', u'nIDD-Mechanism', u'sCEF-ID']
    
    #-----< Restoration-Priority >-----#
    Restoration_Priority = OCT_STR(name=u'Restoration-Priority', mode=MODE_TYPE)
    Restoration_Priority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SIPTO-Permission >-----#
    SIPTO_Permission = ENUM(name=u'SIPTO-Permission', mode=MODE_TYPE)
    SIPTO_Permission._cont = ASN1Dict([(u'siptoAboveRanAllowed', 0), (u'siptoAboveRanNotAllowed', 1)])
    SIPTO_Permission._ext = None
    
    #-----< SIPTO-Local-Network-Permission >-----#
    SIPTO_Local_Network_Permission = ENUM(name=u'SIPTO-Local-Network-Permission', mode=MODE_TYPE)
    SIPTO_Local_Network_Permission._cont = ASN1Dict([(u'siptoAtLocalNetworkAllowed', 0), (u'siptoAtLocalNetworkNotAllowed', 1)])
    SIPTO_Local_Network_Permission._ext = None
    
    #-----< LIPA-Permission >-----#
    LIPA_Permission = ENUM(name=u'LIPA-Permission', mode=MODE_TYPE)
    LIPA_Permission._cont = ASN1Dict([(u'lipaProhibited', 0), (u'lipaOnly', 1), (u'lipaConditional', 2)])
    LIPA_Permission._ext = None
    
    #-----< ContextId >-----#
    ContextId = INT(name=u'ContextId', mode=MODE_TYPE)
    ContextId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< GPRSSubscriptionData >-----#
    GPRSSubscriptionData = SEQ(name=u'GPRSSubscriptionData', mode=MODE_TYPE)
    _GPRSSubscriptionData_completeDataListIncluded = NULL(name=u'completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _GPRSSubscriptionData_gprsDataList = SEQ_OF(name=u'gprsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSDataList')))
    _GPRSSubscriptionData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRSSubscriptionData_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    GPRSSubscriptionData._cont = ASN1Dict([
        (u'completeDataListIncluded', _GPRSSubscriptionData_completeDataListIncluded),
        (u'gprsDataList', _GPRSSubscriptionData_gprsDataList),
        (u'extensionContainer', _GPRSSubscriptionData_extensionContainer),
        (u'apn-oi-Replacement', _GPRSSubscriptionData_apn_oi_Replacement),
        ])
    GPRSSubscriptionData._ext = [u'apn-oi-Replacement']
    
    #-----< SGSN-CAMEL-SubscriptionInfo >-----#
    SGSN_CAMEL_SubscriptionInfo = SEQ(name=u'SGSN-CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _SGSN_CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name=u'gprs-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name=u'mo-sms-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name=u'mt-sms-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mg_csi = SEQ(name=u'mg-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    SGSN_CAMEL_SubscriptionInfo._cont = ASN1Dict([
        (u'gprs-CSI', _SGSN_CAMEL_SubscriptionInfo_gprs_CSI),
        (u'mo-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI),
        (u'extensionContainer', _SGSN_CAMEL_SubscriptionInfo_extensionContainer),
        (u'mt-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI),
        (u'mt-smsCAMELTDP-CriteriaList', _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        (u'mg-csi', _SGSN_CAMEL_SubscriptionInfo_mg_csi),
        ])
    SGSN_CAMEL_SubscriptionInfo._ext = [u'mt-sms-CSI', u'mt-smsCAMELTDP-CriteriaList', u'mg-csi']
    
    #-----< GPRS-CSI >-----#
    GPRS_CSI = SEQ(name=u'GPRS-CSI', mode=MODE_TYPE)
    _GPRS_CSI_gprs_CamelTDPDataList = SEQ_OF(name=u'gprs-CamelTDPDataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPDataList')), opt=True)
    _GPRS_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _GPRS_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRS_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GPRS_CSI._cont = ASN1Dict([
        (u'gprs-CamelTDPDataList', _GPRS_CSI_gprs_CamelTDPDataList),
        (u'camelCapabilityHandling', _GPRS_CSI_camelCapabilityHandling),
        (u'extensionContainer', _GPRS_CSI_extensionContainer),
        (u'notificationToCSE', _GPRS_CSI_notificationToCSE),
        (u'csi-Active', _GPRS_CSI_csi_Active),
        ])
    GPRS_CSI._ext = []
    
    #-----< GPRS-CamelTDPDataList >-----#
    GPRS_CamelTDPDataList = SEQ_OF(name=u'GPRS-CamelTDPDataList', mode=MODE_TYPE)
    _GPRS_CamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPData')))
    GPRS_CamelTDPDataList._cont = _GPRS_CamelTDPDataList__item_
    GPRS_CamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< GPRS-CamelTDPData >-----#
    GPRS_CamelTDPData = SEQ(name=u'GPRS-CamelTDPData', mode=MODE_TYPE)
    _GPRS_CamelTDPData_gprs_TriggerDetectionPoint = ENUM(name=u'gprs-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-TriggerDetectionPoint')))
    _GPRS_CamelTDPData_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _GPRS_CamelTDPData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _GPRS_CamelTDPData_defaultSessionHandling = ENUM(name=u'defaultSessionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')))
    _GPRS_CamelTDPData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    GPRS_CamelTDPData._cont = ASN1Dict([
        (u'gprs-TriggerDetectionPoint', _GPRS_CamelTDPData_gprs_TriggerDetectionPoint),
        (u'serviceKey', _GPRS_CamelTDPData_serviceKey),
        (u'gsmSCF-Address', _GPRS_CamelTDPData_gsmSCF_Address),
        (u'defaultSessionHandling', _GPRS_CamelTDPData_defaultSessionHandling),
        (u'extensionContainer', _GPRS_CamelTDPData_extensionContainer),
        ])
    GPRS_CamelTDPData._ext = []
    
    #-----< DefaultGPRS-Handling >-----#
    DefaultGPRS_Handling = ENUM(name=u'DefaultGPRS-Handling', mode=MODE_TYPE)
    DefaultGPRS_Handling._cont = ASN1Dict([(u'continueTransaction', 0), (u'releaseTransaction', 1)])
    DefaultGPRS_Handling._ext = []
    
    #-----< GPRS-TriggerDetectionPoint >-----#
    GPRS_TriggerDetectionPoint = ENUM(name=u'GPRS-TriggerDetectionPoint', mode=MODE_TYPE)
    GPRS_TriggerDetectionPoint._cont = ASN1Dict([(u'attach', 1), (u'attachChangeOfPosition', 2), (u'pdp-ContextEstablishment', 11), (u'pdp-ContextEstablishmentAcknowledgement', 12), (u'pdp-ContextChangeOfPosition', 14)])
    GPRS_TriggerDetectionPoint._ext = []
    
    #-----< APN >-----#
    APN = OCT_STR(name=u'APN', mode=MODE_TYPE)
    APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=63)], ev=None, er=[])
    
    #-----< PDP-Type >-----#
    PDP_Type = OCT_STR(name=u'PDP-Type', mode=MODE_TYPE)
    PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Ext-PDP-Type >-----#
    Ext_PDP_Type = OCT_STR(name=u'Ext-PDP-Type', mode=MODE_TYPE)
    Ext_PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PDP-Address >-----#
    PDP_Address = OCT_STR(name=u'PDP-Address', mode=MODE_TYPE)
    PDP_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< QoS-Subscribed >-----#
    QoS_Subscribed = OCT_STR(name=u'QoS-Subscribed', mode=MODE_TYPE)
    QoS_Subscribed._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Ext-QoS-Subscribed >-----#
    Ext_QoS_Subscribed = OCT_STR(name=u'Ext-QoS-Subscribed', mode=MODE_TYPE)
    Ext_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Ext2-QoS-Subscribed >-----#
    Ext2_QoS_Subscribed = OCT_STR(name=u'Ext2-QoS-Subscribed', mode=MODE_TYPE)
    Ext2_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Ext3-QoS-Subscribed >-----#
    Ext3_QoS_Subscribed = OCT_STR(name=u'Ext3-QoS-Subscribed', mode=MODE_TYPE)
    Ext3_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ext4-QoS-Subscribed >-----#
    Ext4_QoS_Subscribed = OCT_STR(name=u'Ext4-QoS-Subscribed', mode=MODE_TYPE)
    Ext4_QoS_Subscribed._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = OCT_STR(name=u'ChargingCharacteristics', mode=MODE_TYPE)
    ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LSAOnlyAccessIndicator >-----#
    LSAOnlyAccessIndicator = ENUM(name=u'LSAOnlyAccessIndicator', mode=MODE_TYPE)
    LSAOnlyAccessIndicator._cont = ASN1Dict([(u'accessOutsideLSAsAllowed', 0), (u'accessOutsideLSAsRestricted', 1)])
    LSAOnlyAccessIndicator._ext = None
    
    #-----< LSADataList >-----#
    LSADataList = SEQ_OF(name=u'LSADataList', mode=MODE_TYPE)
    _LSADataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAData')))
    LSADataList._cont = _LSADataList__item_
    LSADataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfLSAs >-----#
    maxNumOfLSAs = INT(name=u'maxNumOfLSAs', mode=MODE_VALUE)
    maxNumOfLSAs._val = 20
    
    #-----< LSAData >-----#
    LSAData = SEQ(name=u'LSAData', mode=MODE_TYPE)
    _LSAData_lsaIdentity = OCT_STR(name=u'lsaIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    _LSAData_lsaAttributes = OCT_STR(name=u'lsaAttributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAAttributes')))
    _LSAData_lsaActiveModeIndicator = NULL(name=u'lsaActiveModeIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LSAData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAData._cont = ASN1Dict([
        (u'lsaIdentity', _LSAData_lsaIdentity),
        (u'lsaAttributes', _LSAData_lsaAttributes),
        (u'lsaActiveModeIndicator', _LSAData_lsaActiveModeIndicator),
        (u'extensionContainer', _LSAData_extensionContainer),
        ])
    LSAData._ext = []
    
    #-----< LSAInformation >-----#
    LSAInformation = SEQ(name=u'LSAInformation', mode=MODE_TYPE)
    _LSAInformation_completeDataListIncluded = NULL(name=u'completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _LSAInformation_lsaOnlyAccessIndicator = ENUM(name=u'lsaOnlyAccessIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAOnlyAccessIndicator')), opt=True)
    _LSAInformation_lsaDataList = SEQ_OF(name=u'lsaDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSADataList')), opt=True)
    _LSAInformation_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAInformation._cont = ASN1Dict([
        (u'completeDataListIncluded', _LSAInformation_completeDataListIncluded),
        (u'lsaOnlyAccessIndicator', _LSAInformation_lsaOnlyAccessIndicator),
        (u'lsaDataList', _LSAInformation_lsaDataList),
        (u'extensionContainer', _LSAInformation_extensionContainer),
        ])
    LSAInformation._ext = []
    
    #-----< LSAIdentity >-----#
    LSAIdentity = OCT_STR(name=u'LSAIdentity', mode=MODE_TYPE)
    LSAIdentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< LSAAttributes >-----#
    LSAAttributes = OCT_STR(name=u'LSAAttributes', mode=MODE_TYPE)
    LSAAttributes._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberData >-----#
    SubscriberData = SEQ(name=u'SubscriberData', mode=MODE_TYPE)
    _SubscriberData_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberData_category = OCT_STR(name=u'category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _SubscriberData_subscriberStatus = ENUM(name=u'subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _SubscriberData_bearerServiceList = SEQ_OF(name=u'bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _SubscriberData_teleserviceList = SEQ_OF(name=u'teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _SubscriberData_provisionedSS = SEQ_OF(name=u'provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _SubscriberData_odb_Data = SEQ(name=u'odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _SubscriberData_roamingRestrictionDueToUnsupportedFeature = NULL(name=u'roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberData_regionalSubscriptionData = SEQ_OF(name=u'regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _SubscriberData_vbsSubscriptionData = SEQ_OF(name=u'vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _SubscriberData_vgcsSubscriptionData = SEQ_OF(name=u'vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _SubscriberData_vlrCamelSubscriptionInfo = SEQ(name=u'vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    SubscriberData._cont = ASN1Dict([
        (u'msisdn', _SubscriberData_msisdn),
        (u'category', _SubscriberData_category),
        (u'subscriberStatus', _SubscriberData_subscriberStatus),
        (u'bearerServiceList', _SubscriberData_bearerServiceList),
        (u'teleserviceList', _SubscriberData_teleserviceList),
        (u'provisionedSS', _SubscriberData_provisionedSS),
        (u'odb-Data', _SubscriberData_odb_Data),
        (u'roamingRestrictionDueToUnsupportedFeature', _SubscriberData_roamingRestrictionDueToUnsupportedFeature),
        (u'regionalSubscriptionData', _SubscriberData_regionalSubscriptionData),
        (u'vbsSubscriptionData', _SubscriberData_vbsSubscriptionData),
        (u'vgcsSubscriptionData', _SubscriberData_vgcsSubscriptionData),
        (u'vlrCamelSubscriptionInfo', _SubscriberData_vlrCamelSubscriptionInfo),
        ])
    SubscriberData._ext = None
    
    #-----< Category >-----#
    Category = OCT_STR(name=u'Category', mode=MODE_TYPE)
    Category._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberStatus >-----#
    SubscriberStatus = ENUM(name=u'SubscriberStatus', mode=MODE_TYPE)
    SubscriberStatus._cont = ASN1Dict([(u'serviceGranted', 0), (u'operatorDeterminedBarring', 1)])
    SubscriberStatus._ext = None
    
    #-----< BearerServiceList >-----#
    BearerServiceList = SEQ_OF(name=u'BearerServiceList', mode=MODE_TYPE)
    _BearerServiceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    BearerServiceList._cont = _BearerServiceList__item_
    BearerServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfBearerServices >-----#
    maxNumOfBearerServices = INT(name=u'maxNumOfBearerServices', mode=MODE_VALUE)
    maxNumOfBearerServices._val = 50
    
    #-----< TeleserviceList >-----#
    TeleserviceList = SEQ_OF(name=u'TeleserviceList', mode=MODE_TYPE)
    _TeleserviceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    TeleserviceList._cont = _TeleserviceList__item_
    TeleserviceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfTeleservices >-----#
    maxNumOfTeleservices = INT(name=u'maxNumOfTeleservices', mode=MODE_VALUE)
    maxNumOfTeleservices._val = 20
    
    #-----< ODB-Data >-----#
    ODB_Data = SEQ(name=u'ODB-Data', mode=MODE_TYPE)
    _ODB_Data_odb_GeneralData = BIT_STR(name=u'odb-GeneralData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')))
    _ODB_Data_odb_HPLMN_Data = BIT_STR(name=u'odb-HPLMN-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-HPLMN-Data')), opt=True)
    _ODB_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Data._cont = ASN1Dict([
        (u'odb-GeneralData', _ODB_Data_odb_GeneralData),
        (u'odb-HPLMN-Data', _ODB_Data_odb_HPLMN_Data),
        (u'extensionContainer', _ODB_Data_extensionContainer),
        ])
    ODB_Data._ext = []
    
    #-----< ODB-GeneralData >-----#
    ODB_GeneralData = BIT_STR(name=u'ODB-GeneralData', mode=MODE_TYPE)
    ODB_GeneralData._cont = ASN1Dict([(u'allOG-CallsBarred', 0), (u'internationalOGCallsBarred', 1), (u'internationalOGCallsNotToHPLMN-CountryBarred', 2), (u'interzonalOGCallsBarred', 6), (u'interzonalOGCallsNotToHPLMN-CountryBarred', 7), (u'interzonalOGCallsAndInternationalOGCallsNotToHPLMN-CountryBarred', 8), (u'premiumRateInformationOGCallsBarred', 3), (u'premiumRateEntertainementOGCallsBarred', 4), (u'ss-AccessBarred', 5), (u'allECT-Barred', 9), (u'chargeableECT-Barred', 10), (u'internationalECT-Barred', 11), (u'interzonalECT-Barred', 12), (u'doublyChargeableECT-Barred', 13), (u'multipleECT-Barred', 14), (u'allPacketOrientedServicesBarred', 15), (u'roamerAccessToHPLMN-AP-Barred', 16), (u'roamerAccessToVPLMN-AP-Barred', 17), (u'roamingOutsidePLMNOG-CallsBarred', 18), (u'allIC-CallsBarred', 19), (u'roamingOutsidePLMNIC-CallsBarred', 20), (u'roamingOutsidePLMNICountryIC-CallsBarred', 21), (u'roamingOutsidePLMN-Barred', 22), (u'roamingOutsidePLMN-CountryBarred', 23), (u'registrationAllCF-Barred', 24), (u'registrationCFNotToHPLMN-Barred', 25), (u'registrationInterzonalCF-Barred', 26), (u'registrationInterzonalCFNotToHPLMN-Barred', 27), (u'registrationInternationalCF-Barred', 28)])
    ODB_GeneralData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=32)], ev=None, er=[])
    
    #-----< ODB-HPLMN-Data >-----#
    ODB_HPLMN_Data = BIT_STR(name=u'ODB-HPLMN-Data', mode=MODE_TYPE)
    ODB_HPLMN_Data._cont = ASN1Dict([(u'plmn-SpecificBarringType1', 0), (u'plmn-SpecificBarringType2', 1), (u'plmn-SpecificBarringType3', 2), (u'plmn-SpecificBarringType4', 3)])
    ODB_HPLMN_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=32)], ev=None, er=[])
    
    #-----< Ext-SS-InfoList >-----#
    Ext_SS_InfoList = SEQ_OF(name=u'Ext-SS-InfoList', mode=MODE_TYPE)
    _Ext_SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Info')))
    Ext_SS_InfoList._cont = _Ext_SS_InfoList__item_
    Ext_SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< Ext-SS-Info >-----#
    Ext_SS_Info = CHOICE(name=u'Ext-SS-Info', mode=MODE_TYPE)
    _Ext_SS_Info_forwardingInfo = SEQ(name=u'forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwInfo')))
    _Ext_SS_Info_callBarringInfo = SEQ(name=u'callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarInfo')))
    _Ext_SS_Info_cug_Info = SEQ(name=u'cug-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Info')))
    _Ext_SS_Info_ss_Data = SEQ(name=u'ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Data')))
    _Ext_SS_Info_emlpp_Info = SEQ(name=u'emlpp-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Info')))
    Ext_SS_Info._cont = ASN1Dict([
        (u'forwardingInfo', _Ext_SS_Info_forwardingInfo),
        (u'callBarringInfo', _Ext_SS_Info_callBarringInfo),
        (u'cug-Info', _Ext_SS_Info_cug_Info),
        (u'ss-Data', _Ext_SS_Info_ss_Data),
        (u'emlpp-Info', _Ext_SS_Info_emlpp_Info),
        ])
    Ext_SS_Info._ext = None
    
    #-----< Ext-ForwInfo >-----#
    Ext_ForwInfo = SEQ(name=u'Ext-ForwInfo', mode=MODE_TYPE)
    _Ext_ForwInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwInfo_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwInfo._cont = ASN1Dict([
        (u'ss-Code', _Ext_ForwInfo_ss_Code),
        (u'forwardingFeatureList', _Ext_ForwInfo_forwardingFeatureList),
        (u'extensionContainer', _Ext_ForwInfo_extensionContainer),
        ])
    Ext_ForwInfo._ext = []
    
    #-----< Ext-ForwFeatureList >-----#
    Ext_ForwFeatureList = SEQ_OF(name=u'Ext-ForwFeatureList', mode=MODE_TYPE)
    _Ext_ForwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeature')))
    Ext_ForwFeatureList._cont = _Ext_ForwFeatureList__item_
    Ext_ForwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-ForwFeature >-----#
    Ext_ForwFeature = SEQ(name=u'Ext-ForwFeature', mode=MODE_TYPE)
    _Ext_ForwFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_ForwFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_ForwFeature_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _Ext_ForwFeature_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _Ext_ForwFeature_forwardingOptions = OCT_STR(name=u'forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwOptions')), opt=True)
    _Ext_ForwFeature_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _Ext_ForwFeature_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _Ext_ForwFeature_longForwardedToNumber = OCT_STR(name=u'longForwardedToNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    Ext_ForwFeature._cont = ASN1Dict([
        (u'basicService', _Ext_ForwFeature_basicService),
        (u'ss-Status', _Ext_ForwFeature_ss_Status),
        (u'forwardedToNumber', _Ext_ForwFeature_forwardedToNumber),
        (u'forwardedToSubaddress', _Ext_ForwFeature_forwardedToSubaddress),
        (u'forwardingOptions', _Ext_ForwFeature_forwardingOptions),
        (u'noReplyConditionTime', _Ext_ForwFeature_noReplyConditionTime),
        (u'extensionContainer', _Ext_ForwFeature_extensionContainer),
        (u'longForwardedToNumber', _Ext_ForwFeature_longForwardedToNumber),
        ])
    Ext_ForwFeature._ext = [u'longForwardedToNumber']
    
    #-----< Ext-ForwOptions >-----#
    Ext_ForwOptions = OCT_STR(name=u'Ext-ForwOptions', mode=MODE_TYPE)
    Ext_ForwOptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Ext-NoRepCondTime >-----#
    Ext_NoRepCondTime = INT(name=u'Ext-NoRepCondTime', mode=MODE_TYPE)
    Ext_NoRepCondTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< Ext-CallBarInfo >-----#
    Ext_CallBarInfo = SEQ(name=u'Ext-CallBarInfo', mode=MODE_TYPE)
    _Ext_CallBarInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarInfo_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarInfo._cont = ASN1Dict([
        (u'ss-Code', _Ext_CallBarInfo_ss_Code),
        (u'callBarringFeatureList', _Ext_CallBarInfo_callBarringFeatureList),
        (u'extensionContainer', _Ext_CallBarInfo_extensionContainer),
        ])
    Ext_CallBarInfo._ext = []
    
    #-----< Ext-CallBarFeatureList >-----#
    Ext_CallBarFeatureList = SEQ_OF(name=u'Ext-CallBarFeatureList', mode=MODE_TYPE)
    _Ext_CallBarFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringFeature')))
    Ext_CallBarFeatureList._cont = _Ext_CallBarFeatureList__item_
    Ext_CallBarFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CallBarringFeature >-----#
    Ext_CallBarringFeature = SEQ(name=u'Ext-CallBarringFeature', mode=MODE_TYPE)
    _Ext_CallBarringFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_CallBarringFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_CallBarringFeature_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringFeature._cont = ASN1Dict([
        (u'basicService', _Ext_CallBarringFeature_basicService),
        (u'ss-Status', _Ext_CallBarringFeature_ss_Status),
        (u'extensionContainer', _Ext_CallBarringFeature_extensionContainer),
        ])
    Ext_CallBarringFeature._ext = []
    
    #-----< CUG-Info >-----#
    CUG_Info = SEQ(name=u'CUG-Info', mode=MODE_TYPE)
    _CUG_Info_cug_SubscriptionList = SEQ_OF(name=u'cug-SubscriptionList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-SubscriptionList')))
    _CUG_Info_cug_FeatureList = SEQ_OF(name=u'cug-FeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-FeatureList')), opt=True)
    _CUG_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Info._cont = ASN1Dict([
        (u'cug-SubscriptionList', _CUG_Info_cug_SubscriptionList),
        (u'cug-FeatureList', _CUG_Info_cug_FeatureList),
        (u'extensionContainer', _CUG_Info_extensionContainer),
        ])
    CUG_Info._ext = []
    
    #-----< CUG-SubscriptionList >-----#
    CUG_SubscriptionList = SEQ_OF(name=u'CUG-SubscriptionList', mode=MODE_TYPE)
    _CUG_SubscriptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Subscription')))
    CUG_SubscriptionList._cont = _CUG_SubscriptionList__item_
    CUG_SubscriptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CUG-Subscription >-----#
    CUG_Subscription = SEQ(name=u'CUG-Subscription', mode=MODE_TYPE)
    _CUG_Subscription_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')))
    _CUG_Subscription_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_Subscription_intraCUG_Options = ENUM(name=u'intraCUG-Options', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntraCUG-Options')))
    _CUG_Subscription_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _CUG_Subscription_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Subscription._cont = ASN1Dict([
        (u'cug-Index', _CUG_Subscription_cug_Index),
        (u'cug-Interlock', _CUG_Subscription_cug_Interlock),
        (u'intraCUG-Options', _CUG_Subscription_intraCUG_Options),
        (u'basicServiceGroupList', _CUG_Subscription_basicServiceGroupList),
        (u'extensionContainer', _CUG_Subscription_extensionContainer),
        ])
    CUG_Subscription._ext = []
    
    #-----< CUG-Index >-----#
    CUG_Index = INT(name=u'CUG-Index', mode=MODE_TYPE)
    CUG_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< CUG-Interlock >-----#
    CUG_Interlock = OCT_STR(name=u'CUG-Interlock', mode=MODE_TYPE)
    CUG_Interlock._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IntraCUG-Options >-----#
    IntraCUG_Options = ENUM(name=u'IntraCUG-Options', mode=MODE_TYPE)
    IntraCUG_Options._cont = ASN1Dict([(u'noCUG-Restrictions', 0), (u'cugIC-CallBarred', 1), (u'cugOG-CallBarred', 2)])
    IntraCUG_Options._ext = None
    
    #-----< maxNumOfCUG >-----#
    maxNumOfCUG = INT(name=u'maxNumOfCUG', mode=MODE_VALUE)
    maxNumOfCUG._val = 10
    
    #-----< CUG-FeatureList >-----#
    CUG_FeatureList = SEQ_OF(name=u'CUG-FeatureList', mode=MODE_TYPE)
    _CUG_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Feature')))
    CUG_FeatureList._cont = _CUG_FeatureList__item_
    CUG_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-BasicServiceGroupList >-----#
    Ext_BasicServiceGroupList = SEQ_OF(name=u'Ext-BasicServiceGroupList', mode=MODE_TYPE)
    _Ext_BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    Ext_BasicServiceGroupList._cont = _Ext_BasicServiceGroupList__item_
    Ext_BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfExt-BasicServiceGroups >-----#
    maxNumOfExt_BasicServiceGroups = INT(name=u'maxNumOfExt-BasicServiceGroups', mode=MODE_VALUE)
    maxNumOfExt_BasicServiceGroups._val = 32
    
    #-----< CUG-Feature >-----#
    CUG_Feature = SEQ(name=u'CUG-Feature', mode=MODE_TYPE)
    _CUG_Feature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _CUG_Feature_preferentialCUG_Indicator = INT(name=u'preferentialCUG-Indicator', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _CUG_Feature_interCUG_Restrictions = OCT_STR(name=u'interCUG-Restrictions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'InterCUG-Restrictions')))
    _CUG_Feature_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Feature._cont = ASN1Dict([
        (u'basicService', _CUG_Feature_basicService),
        (u'preferentialCUG-Indicator', _CUG_Feature_preferentialCUG_Indicator),
        (u'interCUG-Restrictions', _CUG_Feature_interCUG_Restrictions),
        (u'extensionContainer', _CUG_Feature_extensionContainer),
        ])
    CUG_Feature._ext = []
    
    #-----< InterCUG-Restrictions >-----#
    InterCUG_Restrictions = OCT_STR(name=u'InterCUG-Restrictions', mode=MODE_TYPE)
    InterCUG_Restrictions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-SS-Data >-----#
    Ext_SS_Data = SEQ(name=u'Ext-SS-Data', mode=MODE_TYPE)
    _Ext_SS_Data_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_SS_Data_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_SS_Data_ss_SubscriptionOption = CHOICE(name=u'ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _Ext_SS_Data_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _Ext_SS_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_SS_Data._cont = ASN1Dict([
        (u'ss-Code', _Ext_SS_Data_ss_Code),
        (u'ss-Status', _Ext_SS_Data_ss_Status),
        (u'ss-SubscriptionOption', _Ext_SS_Data_ss_SubscriptionOption),
        (u'basicServiceGroupList', _Ext_SS_Data_basicServiceGroupList),
        (u'extensionContainer', _Ext_SS_Data_extensionContainer),
        ])
    Ext_SS_Data._ext = []
    
    #-----< LCS-PrivacyExceptionList >-----#
    LCS_PrivacyExceptionList = SEQ_OF(name=u'LCS-PrivacyExceptionList', mode=MODE_TYPE)
    _LCS_PrivacyExceptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyClass')))
    LCS_PrivacyExceptionList._cont = _LCS_PrivacyExceptionList__item_
    LCS_PrivacyExceptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< maxNumOfPrivacyClass >-----#
    maxNumOfPrivacyClass = INT(name=u'maxNumOfPrivacyClass', mode=MODE_VALUE)
    maxNumOfPrivacyClass._val = 4
    
    #-----< LCS-PrivacyClass >-----#
    LCS_PrivacyClass = SEQ(name=u'LCS-PrivacyClass', mode=MODE_TYPE)
    _LCS_PrivacyClass_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _LCS_PrivacyClass_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _LCS_PrivacyClass_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _LCS_PrivacyClass_externalClientList = SEQ_OF(name=u'externalClientList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClientList')), opt=True)
    _LCS_PrivacyClass_plmnClientList = SEQ_OF(name=u'plmnClientList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PLMNClientList')), opt=True)
    _LCS_PrivacyClass_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCS_PrivacyClass_ext_externalClientList = SEQ_OF(name=u'ext-externalClientList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ExternalClientList')), opt=True)
    _LCS_PrivacyClass_serviceTypeList = SEQ_OF(name=u'serviceTypeList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceTypeList')), opt=True)
    LCS_PrivacyClass._cont = ASN1Dict([
        (u'ss-Code', _LCS_PrivacyClass_ss_Code),
        (u'ss-Status', _LCS_PrivacyClass_ss_Status),
        (u'notificationToMSUser', _LCS_PrivacyClass_notificationToMSUser),
        (u'externalClientList', _LCS_PrivacyClass_externalClientList),
        (u'plmnClientList', _LCS_PrivacyClass_plmnClientList),
        (u'extensionContainer', _LCS_PrivacyClass_extensionContainer),
        (u'ext-externalClientList', _LCS_PrivacyClass_ext_externalClientList),
        (u'serviceTypeList', _LCS_PrivacyClass_serviceTypeList),
        ])
    LCS_PrivacyClass._ext = [u'ext-externalClientList', u'serviceTypeList']
    
    #-----< ExternalClientList >-----#
    ExternalClientList = SEQ_OF(name=u'ExternalClientList', mode=MODE_TYPE)
    _ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    ExternalClientList._cont = _ExternalClientList__item_
    ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfExternalClient >-----#
    maxNumOfExternalClient = INT(name=u'maxNumOfExternalClient', mode=MODE_VALUE)
    maxNumOfExternalClient._val = 5
    
    #-----< PLMNClientList >-----#
    PLMNClientList = SEQ_OF(name=u'PLMNClientList', mode=MODE_TYPE)
    _PLMNClientList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')))
    PLMNClientList._cont = _PLMNClientList__item_
    PLMNClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfPLMNClient >-----#
    maxNumOfPLMNClient = INT(name=u'maxNumOfPLMNClient', mode=MODE_VALUE)
    maxNumOfPLMNClient._val = 5
    
    #-----< Ext-ExternalClientList >-----#
    Ext_ExternalClientList = SEQ_OF(name=u'Ext-ExternalClientList', mode=MODE_TYPE)
    _Ext_ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    Ext_ExternalClientList._cont = _Ext_ExternalClientList__item_
    Ext_ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=35)], ev=None, er=[])
    
    #-----< maxNumOfExt-ExternalClient >-----#
    maxNumOfExt_ExternalClient = INT(name=u'maxNumOfExt-ExternalClient', mode=MODE_VALUE)
    maxNumOfExt_ExternalClient._val = 35
    
    #-----< ExternalClient >-----#
    ExternalClient = SEQ(name=u'ExternalClient', mode=MODE_TYPE)
    _ExternalClient_clientIdentity = SEQ(name=u'clientIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')))
    _ExternalClient_gmlc_Restriction = ENUM(name=u'gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ExternalClient_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ExternalClient_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalClient._cont = ASN1Dict([
        (u'clientIdentity', _ExternalClient_clientIdentity),
        (u'gmlc-Restriction', _ExternalClient_gmlc_Restriction),
        (u'notificationToMSUser', _ExternalClient_notificationToMSUser),
        (u'extensionContainer', _ExternalClient_extensionContainer),
        ])
    ExternalClient._ext = []
    
    #-----< GMLC-Restriction >-----#
    GMLC_Restriction = ENUM(name=u'GMLC-Restriction', mode=MODE_TYPE)
    GMLC_Restriction._cont = ASN1Dict([(u'gmlc-List', 0), (u'home-Country', 1)])
    GMLC_Restriction._ext = []
    
    #-----< NotificationToMSUser >-----#
    NotificationToMSUser = ENUM(name=u'NotificationToMSUser', mode=MODE_TYPE)
    NotificationToMSUser._cont = ASN1Dict([(u'notifyLocationAllowed', 0), (u'notifyAndVerify-LocationAllowedIfNoResponse', 1), (u'notifyAndVerify-LocationNotAllowedIfNoResponse', 2), (u'locationNotAllowed', 3)])
    NotificationToMSUser._ext = [u'locationNotAllowed']
    
    #-----< ServiceTypeList >-----#
    ServiceTypeList = SEQ_OF(name=u'ServiceTypeList', mode=MODE_TYPE)
    _ServiceTypeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceType')))
    ServiceTypeList._cont = _ServiceTypeList__item_
    ServiceTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfServiceType >-----#
    maxNumOfServiceType = INT(name=u'maxNumOfServiceType', mode=MODE_VALUE)
    maxNumOfServiceType._val = 32
    
    #-----< ServiceType >-----#
    ServiceType = SEQ(name=u'ServiceType', mode=MODE_TYPE)
    _ServiceType_serviceTypeIdentity = INT(name=u'serviceTypeIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    _ServiceType_gmlc_Restriction = ENUM(name=u'gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ServiceType_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ServiceType_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ServiceType._cont = ASN1Dict([
        (u'serviceTypeIdentity', _ServiceType_serviceTypeIdentity),
        (u'gmlc-Restriction', _ServiceType_gmlc_Restriction),
        (u'notificationToMSUser', _ServiceType_notificationToMSUser),
        (u'extensionContainer', _ServiceType_extensionContainer),
        ])
    ServiceType._ext = []
    
    #-----< MOLR-List >-----#
    MOLR_List = SEQ_OF(name=u'MOLR-List', mode=MODE_TYPE)
    _MOLR_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-Class')))
    MOLR_List._cont = _MOLR_List__item_
    MOLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< maxNumOfMOLR-Class >-----#
    maxNumOfMOLR_Class = INT(name=u'maxNumOfMOLR-Class', mode=MODE_VALUE)
    maxNumOfMOLR_Class._val = 3
    
    #-----< MOLR-Class >-----#
    MOLR_Class = SEQ(name=u'MOLR-Class', mode=MODE_TYPE)
    _MOLR_Class_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MOLR_Class_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MOLR_Class_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MOLR_Class._cont = ASN1Dict([
        (u'ss-Code', _MOLR_Class_ss_Code),
        (u'ss-Status', _MOLR_Class_ss_Status),
        (u'extensionContainer', _MOLR_Class_extensionContainer),
        ])
    MOLR_Class._ext = []
    
    #-----< ZoneCodeList >-----#
    ZoneCodeList = SEQ_OF(name=u'ZoneCodeList', mode=MODE_TYPE)
    _ZoneCodeList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')))
    ZoneCodeList._cont = _ZoneCodeList__item_
    ZoneCodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< ZoneCode >-----#
    ZoneCode = OCT_STR(name=u'ZoneCode', mode=MODE_TYPE)
    ZoneCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< maxNumOfZoneCodes >-----#
    maxNumOfZoneCodes = INT(name=u'maxNumOfZoneCodes', mode=MODE_VALUE)
    maxNumOfZoneCodes._val = 10
    
    #-----< InsertSubscriberDataRes >-----#
    InsertSubscriberDataRes = SEQ(name=u'InsertSubscriberDataRes', mode=MODE_TYPE)
    _InsertSubscriberDataRes_teleserviceList = SEQ_OF(name=u'teleserviceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataRes_bearerServiceList = SEQ_OF(name=u'bearerServiceList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataRes_ss_List = SEQ_OF(name=u'ss-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _InsertSubscriberDataRes_odb_GeneralData = BIT_STR(name=u'odb-GeneralData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')), opt=True)
    _InsertSubscriberDataRes_regionalSubscriptionResponse = ENUM(name=u'regionalSubscriptionResponse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _InsertSubscriberDataRes_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _InsertSubscriberDataRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataRes_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _InsertSubscriberDataRes_supportedFeatures = BIT_STR(name=u'supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _InsertSubscriberDataRes_ext_SupportedFeatures = BIT_STR(name=u'ext-SupportedFeatures', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    InsertSubscriberDataRes._cont = ASN1Dict([
        (u'teleserviceList', _InsertSubscriberDataRes_teleserviceList),
        (u'bearerServiceList', _InsertSubscriberDataRes_bearerServiceList),
        (u'ss-List', _InsertSubscriberDataRes_ss_List),
        (u'odb-GeneralData', _InsertSubscriberDataRes_odb_GeneralData),
        (u'regionalSubscriptionResponse', _InsertSubscriberDataRes_regionalSubscriptionResponse),
        (u'supportedCamelPhases', _InsertSubscriberDataRes_supportedCamelPhases),
        (u'extensionContainer', _InsertSubscriberDataRes_extensionContainer),
        (u'offeredCamel4CSIs', _InsertSubscriberDataRes_offeredCamel4CSIs),
        (u'supportedFeatures', _InsertSubscriberDataRes_supportedFeatures),
        (u'ext-SupportedFeatures', _InsertSubscriberDataRes_ext_SupportedFeatures),
        ])
    InsertSubscriberDataRes._ext = [u'offeredCamel4CSIs', u'supportedFeatures', u'ext-SupportedFeatures']
    
    #-----< RegionalSubscriptionResponse >-----#
    RegionalSubscriptionResponse = ENUM(name=u'RegionalSubscriptionResponse', mode=MODE_TYPE)
    RegionalSubscriptionResponse._cont = ASN1Dict([(u'networkNode-AreaRestricted', 0), (u'tooManyZoneCodes', 1), (u'zoneCodesConflict', 2), (u'regionalSubscNotSupported', 3)])
    RegionalSubscriptionResponse._ext = None
    
    #-----< DeleteSubscriberDataArg >-----#
    DeleteSubscriberDataArg = SEQ(name=u'DeleteSubscriberDataArg', mode=MODE_TYPE)
    _DeleteSubscriberDataArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _DeleteSubscriberDataArg_basicServiceList = SEQ_OF(name=u'basicServiceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _DeleteSubscriberDataArg_ss_List = SEQ_OF(name=u'ss-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name=u'roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_regionalSubscriptionIdentifier = OCT_STR(name=u'regionalSubscriptionIdentifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')), opt=True)
    _DeleteSubscriberDataArg_vbsGroupIndication = NULL(name=u'vbsGroupIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vgcsGroupIndication = NULL(name=u'vgcsGroupIndication', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw = NULL(name=u'camelSubscriptionInfoWithdraw', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw = CHOICE(name=u'gprsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature = NULL(name=u'roamingRestrictedInSgsnDueToUnsuppportedFeature', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_lsaInformationWithdraw = CHOICE(name=u'lsaInformationWithdraw', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformationWithdraw')), opt=True)
    _DeleteSubscriberDataArg_gmlc_ListWithdraw = NULL(name=u'gmlc-ListWithdraw', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_istInformationWithdraw = NULL(name=u'istInformationWithdraw', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_specificCSI_Withdraw = BIT_STR(name=u'specificCSI-Withdraw', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw = NULL(name=u'chargingCharacteristicsWithdraw', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_stn_srWithdraw = NULL(name=u'stn-srWithdraw', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw = CHOICE(name=u'epsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_apn_oi_replacementWithdraw = NULL(name=u'apn-oi-replacementWithdraw', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_csg_SubscriptionDeleted = NULL(name=u'csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw = NULL(name=u'subscribedPeriodicTAU-RAU-TimerWithdraw', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw = NULL(name=u'subscribedPeriodicLAU-TimerWithdraw', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw = NULL(name=u'subscribed-vsrvccWithdraw', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted = NULL(name=u'vplmn-Csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_additionalMSISDN_Withdraw = NULL(name=u'additionalMSISDN-Withdraw', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw = NULL(name=u'cs-to-ps-SRVCC-Withdraw', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw = NULL(name=u'imsiGroupIdList-Withdraw', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw = NULL(name=u'userPlaneIntegrityProtectionWithdraw', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw = NULL(name=u'dl-Buffering-Suggested-Packet-Count-Withdraw', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_ue_UsageTypeWithdraw = NULL(name=u'ue-UsageTypeWithdraw', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_reset_idsWithdraw = NULL(name=u'reset-idsWithdraw', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_iab_OperationWithdraw = NULL(name=u'iab-OperationWithdraw', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    DeleteSubscriberDataArg._cont = ASN1Dict([
        (u'imsi', _DeleteSubscriberDataArg_imsi),
        (u'basicServiceList', _DeleteSubscriberDataArg_basicServiceList),
        (u'ss-List', _DeleteSubscriberDataArg_ss_List),
        (u'roamingRestrictionDueToUnsupportedFeature', _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        (u'regionalSubscriptionIdentifier', _DeleteSubscriberDataArg_regionalSubscriptionIdentifier),
        (u'vbsGroupIndication', _DeleteSubscriberDataArg_vbsGroupIndication),
        (u'vgcsGroupIndication', _DeleteSubscriberDataArg_vgcsGroupIndication),
        (u'camelSubscriptionInfoWithdraw', _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw),
        (u'extensionContainer', _DeleteSubscriberDataArg_extensionContainer),
        (u'gprsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw),
        (u'roamingRestrictedInSgsnDueToUnsuppportedFeature', _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature),
        (u'lsaInformationWithdraw', _DeleteSubscriberDataArg_lsaInformationWithdraw),
        (u'gmlc-ListWithdraw', _DeleteSubscriberDataArg_gmlc_ListWithdraw),
        (u'istInformationWithdraw', _DeleteSubscriberDataArg_istInformationWithdraw),
        (u'specificCSI-Withdraw', _DeleteSubscriberDataArg_specificCSI_Withdraw),
        (u'chargingCharacteristicsWithdraw', _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw),
        (u'stn-srWithdraw', _DeleteSubscriberDataArg_stn_srWithdraw),
        (u'epsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw),
        (u'apn-oi-replacementWithdraw', _DeleteSubscriberDataArg_apn_oi_replacementWithdraw),
        (u'csg-SubscriptionDeleted', _DeleteSubscriberDataArg_csg_SubscriptionDeleted),
        (u'subscribedPeriodicTAU-RAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw),
        (u'subscribedPeriodicLAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw),
        (u'subscribed-vsrvccWithdraw', _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw),
        (u'vplmn-Csg-SubscriptionDeleted', _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted),
        (u'additionalMSISDN-Withdraw', _DeleteSubscriberDataArg_additionalMSISDN_Withdraw),
        (u'cs-to-ps-SRVCC-Withdraw', _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw),
        (u'imsiGroupIdList-Withdraw', _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw),
        (u'userPlaneIntegrityProtectionWithdraw', _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw),
        (u'dl-Buffering-Suggested-Packet-Count-Withdraw', _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw),
        (u'ue-UsageTypeWithdraw', _DeleteSubscriberDataArg_ue_UsageTypeWithdraw),
        (u'reset-idsWithdraw', _DeleteSubscriberDataArg_reset_idsWithdraw),
        (u'iab-OperationWithdraw', _DeleteSubscriberDataArg_iab_OperationWithdraw),
        ])
    DeleteSubscriberDataArg._ext = [u'gprsSubscriptionDataWithdraw', u'roamingRestrictedInSgsnDueToUnsuppportedFeature', u'lsaInformationWithdraw', u'gmlc-ListWithdraw', u'istInformationWithdraw', u'specificCSI-Withdraw', u'chargingCharacteristicsWithdraw', u'stn-srWithdraw', u'epsSubscriptionDataWithdraw', u'apn-oi-replacementWithdraw', u'csg-SubscriptionDeleted', u'subscribedPeriodicTAU-RAU-TimerWithdraw', u'subscribedPeriodicLAU-TimerWithdraw', u'subscribed-vsrvccWithdraw', u'vplmn-Csg-SubscriptionDeleted', u'additionalMSISDN-Withdraw', u'cs-to-ps-SRVCC-Withdraw', u'imsiGroupIdList-Withdraw', u'userPlaneIntegrityProtectionWithdraw', u'dl-Buffering-Suggested-Packet-Count-Withdraw', u'ue-UsageTypeWithdraw', u'reset-idsWithdraw', u'iab-OperationWithdraw']
    
    #-----< SpecificCSI-Withdraw >-----#
    SpecificCSI_Withdraw = BIT_STR(name=u'SpecificCSI-Withdraw', mode=MODE_TYPE)
    SpecificCSI_Withdraw._cont = ASN1Dict([(u'o-csi', 0), (u'ss-csi', 1), (u'tif-csi', 2), (u'd-csi', 3), (u'vt-csi', 4), (u'mo-sms-csi', 5), (u'm-csi', 6), (u'gprs-csi', 7), (u't-csi', 8), (u'mt-sms-csi', 9), (u'mg-csi', 10), (u'o-IM-CSI', 11), (u'd-IM-CSI', 12), (u'vt-IM-CSI', 13)])
    SpecificCSI_Withdraw._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=32)], ev=None, er=[])
    
    #-----< GPRSSubscriptionDataWithdraw >-----#
    GPRSSubscriptionDataWithdraw = CHOICE(name=u'GPRSSubscriptionDataWithdraw', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_allGPRSData = NULL(name=u'allGPRSData', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_contextIdList = SEQ_OF(name=u'contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    GPRSSubscriptionDataWithdraw._cont = ASN1Dict([
        (u'allGPRSData', _GPRSSubscriptionDataWithdraw_allGPRSData),
        (u'contextIdList', _GPRSSubscriptionDataWithdraw_contextIdList),
        ])
    GPRSSubscriptionDataWithdraw._ext = None
    
    #-----< EPS-SubscriptionDataWithdraw >-----#
    EPS_SubscriptionDataWithdraw = CHOICE(name=u'EPS-SubscriptionDataWithdraw', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_allEPS_Data = NULL(name=u'allEPS-Data', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_contextIdList = SEQ_OF(name=u'contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    EPS_SubscriptionDataWithdraw._cont = ASN1Dict([
        (u'allEPS-Data', _EPS_SubscriptionDataWithdraw_allEPS_Data),
        (u'contextIdList', _EPS_SubscriptionDataWithdraw_contextIdList),
        ])
    EPS_SubscriptionDataWithdraw._ext = None
    
    #-----< ContextIdList >-----#
    ContextIdList = SEQ_OF(name=u'ContextIdList', mode=MODE_TYPE)
    _ContextIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    ContextIdList._cont = _ContextIdList__item_
    ContextIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< LSAInformationWithdraw >-----#
    LSAInformationWithdraw = CHOICE(name=u'LSAInformationWithdraw', mode=MODE_TYPE)
    _LSAInformationWithdraw_allLSAData = NULL(name=u'allLSAData', mode=MODE_TYPE)
    _LSAInformationWithdraw_lsaIdentityList = SEQ_OF(name=u'lsaIdentityList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentityList')))
    LSAInformationWithdraw._cont = ASN1Dict([
        (u'allLSAData', _LSAInformationWithdraw_allLSAData),
        (u'lsaIdentityList', _LSAInformationWithdraw_lsaIdentityList),
        ])
    LSAInformationWithdraw._ext = None
    
    #-----< LSAIdentityList >-----#
    LSAIdentityList = SEQ_OF(name=u'LSAIdentityList', mode=MODE_TYPE)
    _LSAIdentityList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    LSAIdentityList._cont = _LSAIdentityList__item_
    LSAIdentityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< BasicServiceList >-----#
    BasicServiceList = SEQ_OF(name=u'BasicServiceList', mode=MODE_TYPE)
    _BasicServiceList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceList._cont = _BasicServiceList__item_
    BasicServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=None, er=[])
    
    #-----< maxNumOfBasicServices >-----#
    maxNumOfBasicServices = INT(name=u'maxNumOfBasicServices', mode=MODE_VALUE)
    maxNumOfBasicServices._val = 70
    
    #-----< DeleteSubscriberDataRes >-----#
    DeleteSubscriberDataRes = SEQ(name=u'DeleteSubscriberDataRes', mode=MODE_TYPE)
    _DeleteSubscriberDataRes_regionalSubscriptionResponse = ENUM(name=u'regionalSubscriptionResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _DeleteSubscriberDataRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeleteSubscriberDataRes._cont = ASN1Dict([
        (u'regionalSubscriptionResponse', _DeleteSubscriberDataRes_regionalSubscriptionResponse),
        (u'extensionContainer', _DeleteSubscriberDataRes_extensionContainer),
        ])
    DeleteSubscriberDataRes._ext = []
    
    #-----< VlrCamelSubscriptionInfo >-----#
    VlrCamelSubscriptionInfo = SEQ(name=u'VlrCamelSubscriptionInfo', mode=MODE_TYPE)
    _VlrCamelSubscriptionInfo_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VlrCamelSubscriptionInfo_ss_CSI = SEQ(name=u'ss-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_tif_CSI = NULL(name=u'tif-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VlrCamelSubscriptionInfo_m_CSI = SEQ(name=u'm-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mo_sms_CSI = SEQ(name=u'mo-sms-CSI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_vt_CSI = SEQ(name=u'vt-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u't-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_d_CSI = SEQ(name=u'd-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_sms_CSI = SEQ(name=u'mt-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    VlrCamelSubscriptionInfo._cont = ASN1Dict([
        (u'o-CSI', _VlrCamelSubscriptionInfo_o_CSI),
        (u'extensionContainer', _VlrCamelSubscriptionInfo_extensionContainer),
        (u'ss-CSI', _VlrCamelSubscriptionInfo_ss_CSI),
        (u'o-BcsmCamelTDP-CriteriaList', _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        (u'tif-CSI', _VlrCamelSubscriptionInfo_tif_CSI),
        (u'm-CSI', _VlrCamelSubscriptionInfo_m_CSI),
        (u'mo-sms-CSI', _VlrCamelSubscriptionInfo_mo_sms_CSI),
        (u'vt-CSI', _VlrCamelSubscriptionInfo_vt_CSI),
        (u't-BCSM-CAMEL-TDP-CriteriaList', _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        (u'd-CSI', _VlrCamelSubscriptionInfo_d_CSI),
        (u'mt-sms-CSI', _VlrCamelSubscriptionInfo_mt_sms_CSI),
        (u'mt-smsCAMELTDP-CriteriaList', _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ])
    VlrCamelSubscriptionInfo._ext = [u'ss-CSI', u'o-BcsmCamelTDP-CriteriaList', u'tif-CSI', u'm-CSI', u'mo-sms-CSI', u'vt-CSI', u't-BCSM-CAMEL-TDP-CriteriaList', u'd-CSI', u'mt-sms-CSI', u'mt-smsCAMELTDP-CriteriaList']
    
    #-----< MT-smsCAMELTDP-CriteriaList >-----#
    MT_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'MT-smsCAMELTDP-CriteriaList', mode=MODE_TYPE)
    _MT_smsCAMELTDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-Criteria')))
    MT_smsCAMELTDP_CriteriaList._cont = _MT_smsCAMELTDP_CriteriaList__item_
    MT_smsCAMELTDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< MT-smsCAMELTDP-Criteria >-----#
    MT_smsCAMELTDP_Criteria = SEQ(name=u'MT-smsCAMELTDP-Criteria', mode=MODE_TYPE)
    _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint = ENUM(name=u'sms-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion = SEQ_OF(name=u'tpdu-TypeCriterion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TPDU-TypeCriterion')), opt=True)
    MT_smsCAMELTDP_Criteria._cont = ASN1Dict([
        (u'sms-TriggerDetectionPoint', _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint),
        (u'tpdu-TypeCriterion', _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion),
        ])
    MT_smsCAMELTDP_Criteria._ext = []
    
    #-----< TPDU-TypeCriterion >-----#
    TPDU_TypeCriterion = SEQ_OF(name=u'TPDU-TypeCriterion', mode=MODE_TYPE)
    _TPDU_TypeCriterion__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-SMS-TPDU-Type')))
    TPDU_TypeCriterion._cont = _TPDU_TypeCriterion__item_
    TPDU_TypeCriterion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfTPDUTypes >-----#
    maxNumOfTPDUTypes = INT(name=u'maxNumOfTPDUTypes', mode=MODE_VALUE)
    maxNumOfTPDUTypes._val = 5
    
    #-----< MT-SMS-TPDU-Type >-----#
    MT_SMS_TPDU_Type = ENUM(name=u'MT-SMS-TPDU-Type', mode=MODE_TYPE)
    MT_SMS_TPDU_Type._cont = ASN1Dict([(u'sms-DELIVER', 0), (u'sms-SUBMIT-REPORT', 1), (u'sms-STATUS-REPORT', 2)])
    MT_SMS_TPDU_Type._ext = []
    
    #-----< D-CSI >-----#
    D_CSI = SEQ(name=u'D-CSI', mode=MODE_TYPE)
    _D_CSI_dp_AnalysedInfoCriteriaList = SEQ_OF(name=u'dp-AnalysedInfoCriteriaList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriteriaList')), opt=True)
    _D_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _D_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _D_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _D_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    D_CSI._cont = ASN1Dict([
        (u'dp-AnalysedInfoCriteriaList', _D_CSI_dp_AnalysedInfoCriteriaList),
        (u'camelCapabilityHandling', _D_CSI_camelCapabilityHandling),
        (u'extensionContainer', _D_CSI_extensionContainer),
        (u'notificationToCSE', _D_CSI_notificationToCSE),
        (u'csi-Active', _D_CSI_csi_Active),
        ])
    D_CSI._ext = []
    
    #-----< DP-AnalysedInfoCriteriaList >-----#
    DP_AnalysedInfoCriteriaList = SEQ_OF(name=u'DP-AnalysedInfoCriteriaList', mode=MODE_TYPE)
    _DP_AnalysedInfoCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriterium')))
    DP_AnalysedInfoCriteriaList._cont = _DP_AnalysedInfoCriteriaList__item_
    DP_AnalysedInfoCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfDP-AnalysedInfoCriteria >-----#
    maxNumOfDP_AnalysedInfoCriteria = INT(name=u'maxNumOfDP-AnalysedInfoCriteria', mode=MODE_VALUE)
    maxNumOfDP_AnalysedInfoCriteria._val = 10
    
    #-----< DP-AnalysedInfoCriterium >-----#
    DP_AnalysedInfoCriterium = SEQ(name=u'DP-AnalysedInfoCriterium', mode=MODE_TYPE)
    _DP_AnalysedInfoCriterium_dialledNumber = OCT_STR(name=u'dialledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _DP_AnalysedInfoCriterium_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _DP_AnalysedInfoCriterium_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DP_AnalysedInfoCriterium._cont = ASN1Dict([
        (u'dialledNumber', _DP_AnalysedInfoCriterium_dialledNumber),
        (u'serviceKey', _DP_AnalysedInfoCriterium_serviceKey),
        (u'gsmSCF-Address', _DP_AnalysedInfoCriterium_gsmSCF_Address),
        (u'defaultCallHandling', _DP_AnalysedInfoCriterium_defaultCallHandling),
        (u'extensionContainer', _DP_AnalysedInfoCriterium_extensionContainer),
        ])
    DP_AnalysedInfoCriterium._ext = []
    
    #-----< SS-CSI >-----#
    SS_CSI = SEQ(name=u'SS-CSI', mode=MODE_TYPE)
    _SS_CSI_ss_CamelData = SEQ(name=u'ss-CamelData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CamelData')))
    _SS_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SS_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_CSI._cont = ASN1Dict([
        (u'ss-CamelData', _SS_CSI_ss_CamelData),
        (u'extensionContainer', _SS_CSI_extensionContainer),
        (u'notificationToCSE', _SS_CSI_notificationToCSE),
        (u'csi-Active', _SS_CSI_csi_Active),
        ])
    SS_CSI._ext = [u'notificationToCSE', u'csi-Active']
    
    #-----< SS-CamelData >-----#
    SS_CamelData = SEQ(name=u'SS-CamelData', mode=MODE_TYPE)
    _SS_CamelData_ss_EventList = SEQ_OF(name=u'ss-EventList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-EventList')))
    _SS_CamelData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_CamelData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_CamelData._cont = ASN1Dict([
        (u'ss-EventList', _SS_CamelData_ss_EventList),
        (u'gsmSCF-Address', _SS_CamelData_gsmSCF_Address),
        (u'extensionContainer', _SS_CamelData_extensionContainer),
        ])
    SS_CamelData._ext = []
    
    #-----< SS-EventList >-----#
    SS_EventList = SEQ_OF(name=u'SS-EventList', mode=MODE_TYPE)
    _SS_EventList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_EventList._cont = _SS_EventList__item_
    SS_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelSSEvents >-----#
    maxNumOfCamelSSEvents = INT(name=u'maxNumOfCamelSSEvents', mode=MODE_VALUE)
    maxNumOfCamelSSEvents._val = 10
    
    #-----< O-CSI >-----#
    O_CSI = SEQ(name=u'O-CSI', mode=MODE_TYPE)
    _O_CSI_o_BcsmCamelTDPDataList = SEQ_OF(name=u'o-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPDataList')))
    _O_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _O_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _O_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _O_CSI_csiActive = NULL(name=u'csiActive', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    O_CSI._cont = ASN1Dict([
        (u'o-BcsmCamelTDPDataList', _O_CSI_o_BcsmCamelTDPDataList),
        (u'extensionContainer', _O_CSI_extensionContainer),
        (u'camelCapabilityHandling', _O_CSI_camelCapabilityHandling),
        (u'notificationToCSE', _O_CSI_notificationToCSE),
        (u'csiActive', _O_CSI_csiActive),
        ])
    O_CSI._ext = [u'camelCapabilityHandling', u'notificationToCSE', u'csiActive']
    
    #-----< O-BcsmCamelTDPDataList >-----#
    O_BcsmCamelTDPDataList = SEQ_OF(name=u'O-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _O_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPData')))
    O_BcsmCamelTDPDataList._cont = _O_BcsmCamelTDPDataList__item_
    O_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelTDPData >-----#
    maxNumOfCamelTDPData = INT(name=u'maxNumOfCamelTDPData', mode=MODE_VALUE)
    maxNumOfCamelTDPData._val = 10
    
    #-----< O-BcsmCamelTDPData >-----#
    O_BcsmCamelTDPData = SEQ(name=u'O-BcsmCamelTDPData', mode=MODE_TYPE)
    _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint = ENUM(name=u'o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDPData_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _O_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _O_BcsmCamelTDPData_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _O_BcsmCamelTDPData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDPData._cont = ASN1Dict([
        (u'o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint),
        (u'serviceKey', _O_BcsmCamelTDPData_serviceKey),
        (u'gsmSCF-Address', _O_BcsmCamelTDPData_gsmSCF_Address),
        (u'defaultCallHandling', _O_BcsmCamelTDPData_defaultCallHandling),
        (u'extensionContainer', _O_BcsmCamelTDPData_extensionContainer),
        ])
    O_BcsmCamelTDPData._ext = []
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name=u'ServiceKey', mode=MODE_TYPE)
    ServiceKey._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< O-BcsmTriggerDetectionPoint >-----#
    O_BcsmTriggerDetectionPoint = ENUM(name=u'O-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    O_BcsmTriggerDetectionPoint._cont = ASN1Dict([(u'collectedInfo', 2), (u'routeSelectFailure', 4)])
    O_BcsmTriggerDetectionPoint._ext = [u'routeSelectFailure']
    
    #-----< O-BcsmCamelTDPCriteriaList >-----#
    O_BcsmCamelTDPCriteriaList = SEQ_OF(name=u'O-BcsmCamelTDPCriteriaList', mode=MODE_TYPE)
    _O_BcsmCamelTDPCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDP-Criteria')))
    O_BcsmCamelTDPCriteriaList._cont = _O_BcsmCamelTDPCriteriaList__item_
    O_BcsmCamelTDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BCSM-CAMEL-TDP-CriteriaList >-----#
    T_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u'T-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-Criteria')))
    T_BCSM_CAMEL_TDP_CriteriaList._cont = _T_BCSM_CAMEL_TDP_CriteriaList__item_
    T_BCSM_CAMEL_TDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< O-BcsmCamelTDP-Criteria >-----#
    O_BcsmCamelTDP_Criteria = SEQ(name=u'O-BcsmCamelTDP-Criteria', mode=MODE_TYPE)
    _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint = ENUM(name=u'o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDP_Criteria_destinationNumberCriteria = SEQ(name=u'destinationNumberCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_basicServiceCriteria = SEQ_OF(name=u'basicServiceCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_callTypeCriteria = ENUM(name=u'callTypeCriteria', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallTypeCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria = SEQ_OF(name=u'o-CauseValueCriteria', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CauseValueCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDP_Criteria._cont = ASN1Dict([
        (u'o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint),
        (u'destinationNumberCriteria', _O_BcsmCamelTDP_Criteria_destinationNumberCriteria),
        (u'basicServiceCriteria', _O_BcsmCamelTDP_Criteria_basicServiceCriteria),
        (u'callTypeCriteria', _O_BcsmCamelTDP_Criteria_callTypeCriteria),
        (u'o-CauseValueCriteria', _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria),
        (u'extensionContainer', _O_BcsmCamelTDP_Criteria_extensionContainer),
        ])
    O_BcsmCamelTDP_Criteria._ext = [u'o-CauseValueCriteria', u'extensionContainer']
    
    #-----< T-BCSM-CAMEL-TDP-Criteria >-----#
    T_BCSM_CAMEL_TDP_Criteria = SEQ(name=u'T-BCSM-CAMEL-TDP-Criteria', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint = ENUM(name=u't-BCSM-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria = SEQ_OF(name=u'basicServiceCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria = SEQ_OF(name=u't-CauseValueCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CauseValueCriteria')), opt=True)
    T_BCSM_CAMEL_TDP_Criteria._cont = ASN1Dict([
        (u't-BCSM-TriggerDetectionPoint', _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint),
        (u'basicServiceCriteria', _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria),
        (u't-CauseValueCriteria', _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria),
        ])
    T_BCSM_CAMEL_TDP_Criteria._ext = []
    
    #-----< DestinationNumberCriteria >-----#
    DestinationNumberCriteria = SEQ(name=u'DestinationNumberCriteria', mode=MODE_TYPE)
    _DestinationNumberCriteria_matchType = ENUM(name=u'matchType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MatchType')))
    _DestinationNumberCriteria_destinationNumberList = SEQ_OF(name=u'destinationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberList')), opt=True)
    _DestinationNumberCriteria_destinationNumberLengthList = SEQ_OF(name=u'destinationNumberLengthList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberLengthList')), opt=True)
    DestinationNumberCriteria._cont = ASN1Dict([
        (u'matchType', _DestinationNumberCriteria_matchType),
        (u'destinationNumberList', _DestinationNumberCriteria_destinationNumberList),
        (u'destinationNumberLengthList', _DestinationNumberCriteria_destinationNumberLengthList),
        ])
    DestinationNumberCriteria._ext = []
    
    #-----< DestinationNumberList >-----#
    DestinationNumberList = SEQ_OF(name=u'DestinationNumberList', mode=MODE_TYPE)
    _DestinationNumberList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    DestinationNumberList._cont = _DestinationNumberList__item_
    DestinationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< DestinationNumberLengthList >-----#
    DestinationNumberLengthList = SEQ_OF(name=u'DestinationNumberLengthList', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_ = INT(name='_item_', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    DestinationNumberLengthList._cont = _DestinationNumberLengthList__item_
    DestinationNumberLengthList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< BasicServiceCriteria >-----#
    BasicServiceCriteria = SEQ_OF(name=u'BasicServiceCriteria', mode=MODE_TYPE)
    _BasicServiceCriteria__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceCriteria._cont = _BasicServiceCriteria__item_
    BasicServiceCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfISDN-AddressDigits >-----#
    maxNumOfISDN_AddressDigits = INT(name=u'maxNumOfISDN-AddressDigits', mode=MODE_VALUE)
    maxNumOfISDN_AddressDigits._val = 15
    
    #-----< maxNumOfCamelDestinationNumbers >-----#
    maxNumOfCamelDestinationNumbers = INT(name=u'maxNumOfCamelDestinationNumbers', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumbers._val = 10
    
    #-----< maxNumOfCamelDestinationNumberLengths >-----#
    maxNumOfCamelDestinationNumberLengths = INT(name=u'maxNumOfCamelDestinationNumberLengths', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumberLengths._val = 3
    
    #-----< maxNumOfCamelBasicServiceCriteria >-----#
    maxNumOfCamelBasicServiceCriteria = INT(name=u'maxNumOfCamelBasicServiceCriteria', mode=MODE_VALUE)
    maxNumOfCamelBasicServiceCriteria._val = 5
    
    #-----< CallTypeCriteria >-----#
    CallTypeCriteria = ENUM(name=u'CallTypeCriteria', mode=MODE_TYPE)
    CallTypeCriteria._cont = ASN1Dict([(u'forwarded', 0), (u'notForwarded', 1)])
    CallTypeCriteria._ext = None
    
    #-----< MatchType >-----#
    MatchType = ENUM(name=u'MatchType', mode=MODE_TYPE)
    MatchType._cont = ASN1Dict([(u'inhibiting', 0), (u'enabling', 1)])
    MatchType._ext = None
    
    #-----< O-CauseValueCriteria >-----#
    O_CauseValueCriteria = SEQ_OF(name=u'O-CauseValueCriteria', mode=MODE_TYPE)
    _O_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    O_CauseValueCriteria._cont = _O_CauseValueCriteria__item_
    O_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< T-CauseValueCriteria >-----#
    T_CauseValueCriteria = SEQ_OF(name=u'T-CauseValueCriteria', mode=MODE_TYPE)
    _T_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    T_CauseValueCriteria._cont = _T_CauseValueCriteria__item_
    T_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCAMEL-O-CauseValueCriteria >-----#
    maxNumOfCAMEL_O_CauseValueCriteria = INT(name=u'maxNumOfCAMEL-O-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_O_CauseValueCriteria._val = 5
    
    #-----< maxNumOfCAMEL-T-CauseValueCriteria >-----#
    maxNumOfCAMEL_T_CauseValueCriteria = INT(name=u'maxNumOfCAMEL-T-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_T_CauseValueCriteria._val = 5
    
    #-----< CauseValue >-----#
    CauseValue = OCT_STR(name=u'CauseValue', mode=MODE_TYPE)
    CauseValue._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< DefaultCallHandling >-----#
    DefaultCallHandling = ENUM(name=u'DefaultCallHandling', mode=MODE_TYPE)
    DefaultCallHandling._cont = ASN1Dict([(u'continueCall', 0), (u'releaseCall', 1)])
    DefaultCallHandling._ext = []
    
    #-----< CamelCapabilityHandling >-----#
    CamelCapabilityHandling = INT(name=u'CamelCapabilityHandling', mode=MODE_TYPE)
    CamelCapabilityHandling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SupportedCamelPhases >-----#
    SupportedCamelPhases = BIT_STR(name=u'SupportedCamelPhases', mode=MODE_TYPE)
    SupportedCamelPhases._cont = ASN1Dict([(u'phase1', 0), (u'phase2', 1), (u'phase3', 2), (u'phase4', 3)])
    SupportedCamelPhases._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4CSIs >-----#
    OfferedCamel4CSIs = BIT_STR(name=u'OfferedCamel4CSIs', mode=MODE_TYPE)
    OfferedCamel4CSIs._cont = ASN1Dict([(u'o-csi', 0), (u'd-csi', 1), (u'vt-csi', 2), (u't-csi', 3), (u'mt-sms-csi', 4), (u'mg-csi', 5), (u'psi-enhancements', 6)])
    OfferedCamel4CSIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4Functionalities >-----#
    OfferedCamel4Functionalities = BIT_STR(name=u'OfferedCamel4Functionalities', mode=MODE_TYPE)
    OfferedCamel4Functionalities._cont = ASN1Dict([(u'initiateCallAttempt', 0), (u'splitLeg', 1), (u'moveLeg', 2), (u'disconnectLeg', 3), (u'entityReleased', 4), (u'dfc-WithArgument', 5), (u'playTone', 6), (u'dtmf-MidCall', 7), (u'chargingIndicator', 8), (u'alertingDP', 9), (u'locationAtAlerting', 10), (u'changeOfPositionDP', 11), (u'or-Interactions', 12), (u'warningToneEnhancements', 13), (u'cf-Enhancements', 14), (u'subscribedEnhancedDialledServices', 15), (u'servingNetworkEnhancedDialledServices', 16), (u'criteriaForChangeOfPositionDP', 17), (u'serviceChangeDP', 18), (u'collectInformation', 19)])
    OfferedCamel4Functionalities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=64)], ev=None, er=[])
    
    #-----< SMS-CSI >-----#
    SMS_CSI = SEQ(name=u'SMS-CSI', mode=MODE_TYPE)
    _SMS_CSI_sms_CAMEL_TDP_DataList = SEQ_OF(name=u'sms-CAMEL-TDP-DataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-DataList')), opt=True)
    _SMS_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _SMS_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SMS_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMS_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SMS_CSI._cont = ASN1Dict([
        (u'sms-CAMEL-TDP-DataList', _SMS_CSI_sms_CAMEL_TDP_DataList),
        (u'camelCapabilityHandling', _SMS_CSI_camelCapabilityHandling),
        (u'extensionContainer', _SMS_CSI_extensionContainer),
        (u'notificationToCSE', _SMS_CSI_notificationToCSE),
        (u'csi-Active', _SMS_CSI_csi_Active),
        ])
    SMS_CSI._ext = []
    
    #-----< SMS-CAMEL-TDP-DataList >-----#
    SMS_CAMEL_TDP_DataList = SEQ_OF(name=u'SMS-CAMEL-TDP-DataList', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-Data')))
    SMS_CAMEL_TDP_DataList._cont = _SMS_CAMEL_TDP_DataList__item_
    SMS_CAMEL_TDP_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SMS-CAMEL-TDP-Data >-----#
    SMS_CAMEL_TDP_Data = SEQ(name=u'SMS-CAMEL-TDP-Data', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint = ENUM(name=u'sms-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _SMS_CAMEL_TDP_Data_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _SMS_CAMEL_TDP_Data_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SMS_CAMEL_TDP_Data_defaultSMS_Handling = ENUM(name=u'defaultSMS-Handling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')))
    _SMS_CAMEL_TDP_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SMS_CAMEL_TDP_Data._cont = ASN1Dict([
        (u'sms-TriggerDetectionPoint', _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint),
        (u'serviceKey', _SMS_CAMEL_TDP_Data_serviceKey),
        (u'gsmSCF-Address', _SMS_CAMEL_TDP_Data_gsmSCF_Address),
        (u'defaultSMS-Handling', _SMS_CAMEL_TDP_Data_defaultSMS_Handling),
        (u'extensionContainer', _SMS_CAMEL_TDP_Data_extensionContainer),
        ])
    SMS_CAMEL_TDP_Data._ext = []
    
    #-----< SMS-TriggerDetectionPoint >-----#
    SMS_TriggerDetectionPoint = ENUM(name=u'SMS-TriggerDetectionPoint', mode=MODE_TYPE)
    SMS_TriggerDetectionPoint._cont = ASN1Dict([(u'sms-CollectedInfo', 1), (u'sms-DeliveryRequest', 2)])
    SMS_TriggerDetectionPoint._ext = [u'sms-DeliveryRequest']
    
    #-----< DefaultSMS-Handling >-----#
    DefaultSMS_Handling = ENUM(name=u'DefaultSMS-Handling', mode=MODE_TYPE)
    DefaultSMS_Handling._cont = ASN1Dict([(u'continueTransaction', 0), (u'releaseTransaction', 1)])
    DefaultSMS_Handling._ext = []
    
    #-----< M-CSI >-----#
    M_CSI = SEQ(name=u'M-CSI', mode=MODE_TYPE)
    _M_CSI_mobilityTriggers = SEQ_OF(name=u'mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _M_CSI_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _M_CSI_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _M_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _M_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _M_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    M_CSI._cont = ASN1Dict([
        (u'mobilityTriggers', _M_CSI_mobilityTriggers),
        (u'serviceKey', _M_CSI_serviceKey),
        (u'gsmSCF-Address', _M_CSI_gsmSCF_Address),
        (u'extensionContainer', _M_CSI_extensionContainer),
        (u'notificationToCSE', _M_CSI_notificationToCSE),
        (u'csi-Active', _M_CSI_csi_Active),
        ])
    M_CSI._ext = []
    
    #-----< MG-CSI >-----#
    MG_CSI = SEQ(name=u'MG-CSI', mode=MODE_TYPE)
    _MG_CSI_mobilityTriggers = SEQ_OF(name=u'mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _MG_CSI_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _MG_CSI_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MG_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MG_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MG_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MG_CSI._cont = ASN1Dict([
        (u'mobilityTriggers', _MG_CSI_mobilityTriggers),
        (u'serviceKey', _MG_CSI_serviceKey),
        (u'gsmSCF-Address', _MG_CSI_gsmSCF_Address),
        (u'extensionContainer', _MG_CSI_extensionContainer),
        (u'notificationToCSE', _MG_CSI_notificationToCSE),
        (u'csi-Active', _MG_CSI_csi_Active),
        ])
    MG_CSI._ext = []
    
    #-----< MobilityTriggers >-----#
    MobilityTriggers = SEQ_OF(name=u'MobilityTriggers', mode=MODE_TYPE)
    _MobilityTriggers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    MobilityTriggers._cont = _MobilityTriggers__item_
    MobilityTriggers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfMobilityTriggers >-----#
    maxNumOfMobilityTriggers = INT(name=u'maxNumOfMobilityTriggers', mode=MODE_VALUE)
    maxNumOfMobilityTriggers._val = 10
    
    #-----< MM-Code >-----#
    MM_Code = OCT_STR(name=u'MM-Code', mode=MODE_TYPE)
    MM_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< T-CSI >-----#
    T_CSI = SEQ(name=u'T-CSI', mode=MODE_TYPE)
    _T_CSI_t_BcsmCamelTDPDataList = SEQ_OF(name=u't-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPDataList')))
    _T_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _T_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _T_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _T_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    T_CSI._cont = ASN1Dict([
        (u't-BcsmCamelTDPDataList', _T_CSI_t_BcsmCamelTDPDataList),
        (u'extensionContainer', _T_CSI_extensionContainer),
        (u'camelCapabilityHandling', _T_CSI_camelCapabilityHandling),
        (u'notificationToCSE', _T_CSI_notificationToCSE),
        (u'csi-Active', _T_CSI_csi_Active),
        ])
    T_CSI._ext = [u'camelCapabilityHandling', u'notificationToCSE', u'csi-Active']
    
    #-----< T-BcsmCamelTDPDataList >-----#
    T_BcsmCamelTDPDataList = SEQ_OF(name=u'T-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _T_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPData')))
    T_BcsmCamelTDPDataList._cont = _T_BcsmCamelTDPDataList__item_
    T_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BcsmCamelTDPData >-----#
    T_BcsmCamelTDPData = SEQ(name=u'T-BcsmCamelTDPData', mode=MODE_TYPE)
    _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint = ENUM(name=u't-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BcsmCamelTDPData_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _T_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _T_BcsmCamelTDPData_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _T_BcsmCamelTDPData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    T_BcsmCamelTDPData._cont = ASN1Dict([
        (u't-BcsmTriggerDetectionPoint', _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint),
        (u'serviceKey', _T_BcsmCamelTDPData_serviceKey),
        (u'gsmSCF-Address', _T_BcsmCamelTDPData_gsmSCF_Address),
        (u'defaultCallHandling', _T_BcsmCamelTDPData_defaultCallHandling),
        (u'extensionContainer', _T_BcsmCamelTDPData_extensionContainer),
        ])
    T_BcsmCamelTDPData._ext = []
    
    #-----< T-BcsmTriggerDetectionPoint >-----#
    T_BcsmTriggerDetectionPoint = ENUM(name=u'T-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    T_BcsmTriggerDetectionPoint._cont = ASN1Dict([(u'termAttemptAuthorized', 12), (u'tBusy', 13), (u'tNoAnswer', 14)])
    T_BcsmTriggerDetectionPoint._ext = [u'tBusy', u'tNoAnswer']
    
    #-----< SendRoutingInfoForGprsArg >-----#
    SendRoutingInfoForGprsArg = SEQ(name=u'SendRoutingInfoForGprsArg', mode=MODE_TYPE)
    _SendRoutingInfoForGprsArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendRoutingInfoForGprsArg_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsArg_ggsn_Number = OCT_STR(name=u'ggsn-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoForGprsArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsArg._cont = ASN1Dict([
        (u'imsi', _SendRoutingInfoForGprsArg_imsi),
        (u'ggsn-Address', _SendRoutingInfoForGprsArg_ggsn_Address),
        (u'ggsn-Number', _SendRoutingInfoForGprsArg_ggsn_Number),
        (u'extensionContainer', _SendRoutingInfoForGprsArg_extensionContainer),
        ])
    SendRoutingInfoForGprsArg._ext = []
    
    #-----< SendRoutingInfoForGprsRes >-----#
    SendRoutingInfoForGprsRes = SEQ(name=u'SendRoutingInfoForGprsRes', mode=MODE_TYPE)
    _SendRoutingInfoForGprsRes_sgsn_Address = OCT_STR(name=u'sgsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _SendRoutingInfoForGprsRes_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsRes_mobileNotReachableReason = INT(name=u'mobileNotReachableReason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _SendRoutingInfoForGprsRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsRes._cont = ASN1Dict([
        (u'sgsn-Address', _SendRoutingInfoForGprsRes_sgsn_Address),
        (u'ggsn-Address', _SendRoutingInfoForGprsRes_ggsn_Address),
        (u'mobileNotReachableReason', _SendRoutingInfoForGprsRes_mobileNotReachableReason),
        (u'extensionContainer', _SendRoutingInfoForGprsRes_extensionContainer),
        ])
    SendRoutingInfoForGprsRes._ext = []
    
    #-----< FailureReportArg >-----#
    FailureReportArg = SEQ(name=u'FailureReportArg', mode=MODE_TYPE)
    _FailureReportArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _FailureReportArg_ggsn_Number = OCT_STR(name=u'ggsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _FailureReportArg_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportArg._cont = ASN1Dict([
        (u'imsi', _FailureReportArg_imsi),
        (u'ggsn-Number', _FailureReportArg_ggsn_Number),
        (u'ggsn-Address', _FailureReportArg_ggsn_Address),
        (u'extensionContainer', _FailureReportArg_extensionContainer),
        ])
    FailureReportArg._ext = []
    
    #-----< FailureReportRes >-----#
    FailureReportRes = SEQ(name=u'FailureReportRes', mode=MODE_TYPE)
    _FailureReportRes_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportRes._cont = ASN1Dict([
        (u'ggsn-Address', _FailureReportRes_ggsn_Address),
        (u'extensionContainer', _FailureReportRes_extensionContainer),
        ])
    FailureReportRes._ext = []
    
    #-----< NoteMsPresentForGprsArg >-----#
    NoteMsPresentForGprsArg = SEQ(name=u'NoteMsPresentForGprsArg', mode=MODE_TYPE)
    _NoteMsPresentForGprsArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMsPresentForGprsArg_sgsn_Address = OCT_STR(name=u'sgsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _NoteMsPresentForGprsArg_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _NoteMsPresentForGprsArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsArg._cont = ASN1Dict([
        (u'imsi', _NoteMsPresentForGprsArg_imsi),
        (u'sgsn-Address', _NoteMsPresentForGprsArg_sgsn_Address),
        (u'ggsn-Address', _NoteMsPresentForGprsArg_ggsn_Address),
        (u'extensionContainer', _NoteMsPresentForGprsArg_extensionContainer),
        ])
    NoteMsPresentForGprsArg._ext = []
    
    #-----< NoteMsPresentForGprsRes >-----#
    NoteMsPresentForGprsRes = SEQ(name=u'NoteMsPresentForGprsRes', mode=MODE_TYPE)
    _NoteMsPresentForGprsRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsRes._cont = ASN1Dict([
        (u'extensionContainer', _NoteMsPresentForGprsRes_extensionContainer),
        ])
    NoteMsPresentForGprsRes._ext = []
    
    #-----< ResetArg >-----#
    ResetArg = SEQ(name=u'ResetArg', mode=MODE_TYPE)
    _ResetArg_sendingNodenumber = CHOICE(name=u'sendingNodenumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SendingNode-Number')))
    _ResetArg_hlr_List = SEQ_OF(name=u'hlr-List', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-List')), opt=True)
    _ResetArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResetArg_reset_Id_List = SEQ_OF(name=u'reset-Id-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _ResetArg_subscriptionData = SEQ(name=u'subscriptionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'InsertSubscriberDataArg')), opt=True)
    _ResetArg_subscriptionDataDeletion = SEQ(name=u'subscriptionDataDeletion', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DeleteSubscriberDataArg')), opt=True)
    ResetArg._cont = ASN1Dict([
        (u'sendingNodenumber', _ResetArg_sendingNodenumber),
        (u'hlr-List', _ResetArg_hlr_List),
        (u'extensionContainer', _ResetArg_extensionContainer),
        (u'reset-Id-List', _ResetArg_reset_Id_List),
        (u'subscriptionData', _ResetArg_subscriptionData),
        (u'subscriptionDataDeletion', _ResetArg_subscriptionDataDeletion),
        ])
    ResetArg._ext = [u'reset-Id-List', u'subscriptionData', u'subscriptionDataDeletion']
    
    #-----< SendingNode-Number >-----#
    SendingNode_Number = CHOICE(name=u'SendingNode-Number', mode=MODE_TYPE)
    _SendingNode_Number_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendingNode_Number_css_Number = OCT_STR(name=u'css-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SendingNode_Number._cont = ASN1Dict([
        (u'hlr-Number', _SendingNode_Number_hlr_Number),
        (u'css-Number', _SendingNode_Number_css_Number),
        ])
    SendingNode_Number._ext = None
    
    #-----< RestoreDataArg >-----#
    RestoreDataArg = SEQ(name=u'RestoreDataArg', mode=MODE_TYPE)
    _RestoreDataArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RestoreDataArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _RestoreDataArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RestoreDataArg_vlr_Capability = SEQ(name=u'vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _RestoreDataArg_restorationIndicator = NULL(name=u'restorationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RestoreDataArg._cont = ASN1Dict([
        (u'imsi', _RestoreDataArg_imsi),
        (u'lmsi', _RestoreDataArg_lmsi),
        (u'extensionContainer', _RestoreDataArg_extensionContainer),
        (u'vlr-Capability', _RestoreDataArg_vlr_Capability),
        (u'restorationIndicator', _RestoreDataArg_restorationIndicator),
        ])
    RestoreDataArg._ext = [u'vlr-Capability', u'restorationIndicator']
    
    #-----< RestoreDataRes >-----#
    RestoreDataRes = SEQ(name=u'RestoreDataRes', mode=MODE_TYPE)
    _RestoreDataRes_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RestoreDataRes_msNotReachable = NULL(name=u'msNotReachable', mode=MODE_TYPE, opt=True)
    _RestoreDataRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RestoreDataRes._cont = ASN1Dict([
        (u'hlr-Number', _RestoreDataRes_hlr_Number),
        (u'msNotReachable', _RestoreDataRes_msNotReachable),
        (u'extensionContainer', _RestoreDataRes_extensionContainer),
        ])
    RestoreDataRes._ext = []
    
    #-----< VBSDataList >-----#
    VBSDataList = SEQ_OF(name=u'VBSDataList', mode=MODE_TYPE)
    _VBSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceBroadcastData')))
    VBSDataList._cont = _VBSDataList__item_
    VBSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< VGCSDataList >-----#
    VGCSDataList = SEQ_OF(name=u'VGCSDataList', mode=MODE_TYPE)
    _VGCSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceGroupCallData')))
    VGCSDataList._cont = _VGCSDataList__item_
    VGCSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfVBSGroupIds >-----#
    maxNumOfVBSGroupIds = INT(name=u'maxNumOfVBSGroupIds', mode=MODE_VALUE)
    maxNumOfVBSGroupIds._val = 50
    
    #-----< maxNumOfVGCSGroupIds >-----#
    maxNumOfVGCSGroupIds = INT(name=u'maxNumOfVGCSGroupIds', mode=MODE_VALUE)
    maxNumOfVGCSGroupIds._val = 50
    
    #-----< VoiceGroupCallData >-----#
    VoiceGroupCallData = SEQ(name=u'VoiceGroupCallData', mode=MODE_TYPE)
    _VoiceGroupCallData_groupId = OCT_STR(name=u'groupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceGroupCallData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceGroupCallData_additionalSubscriptions = BIT_STR(name=u'additionalSubscriptions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalSubscriptions')), opt=True)
    _VoiceGroupCallData_additionalInfo = BIT_STR(name=u'additionalInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalInfo')), opt=True)
    _VoiceGroupCallData_longGroupId = OCT_STR(name=u'longGroupId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceGroupCallData._cont = ASN1Dict([
        (u'groupId', _VoiceGroupCallData_groupId),
        (u'extensionContainer', _VoiceGroupCallData_extensionContainer),
        (u'additionalSubscriptions', _VoiceGroupCallData_additionalSubscriptions),
        (u'additionalInfo', _VoiceGroupCallData_additionalInfo),
        (u'longGroupId', _VoiceGroupCallData_longGroupId),
        ])
    VoiceGroupCallData._ext = [u'additionalSubscriptions', u'additionalInfo', u'longGroupId']
    
    #-----< AdditionalInfo >-----#
    AdditionalInfo = BIT_STR(name=u'AdditionalInfo', mode=MODE_TYPE)
    AdditionalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=136)], ev=None, er=[])
    
    #-----< AdditionalSubscriptions >-----#
    AdditionalSubscriptions = BIT_STR(name=u'AdditionalSubscriptions', mode=MODE_TYPE)
    AdditionalSubscriptions._cont = ASN1Dict([(u'privilegedUplinkRequest', 0), (u'emergencyUplinkRequest', 1), (u'emergencyReset', 2)])
    AdditionalSubscriptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< VoiceBroadcastData >-----#
    VoiceBroadcastData = SEQ(name=u'VoiceBroadcastData', mode=MODE_TYPE)
    _VoiceBroadcastData_groupid = OCT_STR(name=u'groupid', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceBroadcastData_broadcastInitEntitlement = NULL(name=u'broadcastInitEntitlement', mode=MODE_TYPE, opt=True)
    _VoiceBroadcastData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceBroadcastData_longGroupId = OCT_STR(name=u'longGroupId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceBroadcastData._cont = ASN1Dict([
        (u'groupid', _VoiceBroadcastData_groupid),
        (u'broadcastInitEntitlement', _VoiceBroadcastData_broadcastInitEntitlement),
        (u'extensionContainer', _VoiceBroadcastData_extensionContainer),
        (u'longGroupId', _VoiceBroadcastData_longGroupId),
        ])
    VoiceBroadcastData._ext = [u'longGroupId']
    
    #-----< GroupId >-----#
    GroupId = OCT_STR(name=u'GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    GroupId._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Long-GroupId >-----#
    Long_GroupId = OCT_STR(name=u'Long-GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    Long_GroupId._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ProvideSubscriberInfoArg >-----#
    ProvideSubscriberInfoArg = SEQ(name=u'ProvideSubscriberInfoArg', mode=MODE_TYPE)
    _ProvideSubscriberInfoArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideSubscriberInfoArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideSubscriberInfoArg_requestedInfo = SEQ(name=u'requestedInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _ProvideSubscriberInfoArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberInfoArg_callPriority = INT(name=u'callPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    ProvideSubscriberInfoArg._cont = ASN1Dict([
        (u'imsi', _ProvideSubscriberInfoArg_imsi),
        (u'lmsi', _ProvideSubscriberInfoArg_lmsi),
        (u'requestedInfo', _ProvideSubscriberInfoArg_requestedInfo),
        (u'extensionContainer', _ProvideSubscriberInfoArg_extensionContainer),
        (u'callPriority', _ProvideSubscriberInfoArg_callPriority),
        ])
    ProvideSubscriberInfoArg._ext = [u'callPriority']
    
    #-----< ProvideSubscriberInfoRes >-----#
    ProvideSubscriberInfoRes = SEQ(name=u'ProvideSubscriberInfoRes', mode=MODE_TYPE)
    _ProvideSubscriberInfoRes_subscriberInfo = SEQ(name=u'subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _ProvideSubscriberInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ProvideSubscriberInfoRes._cont = ASN1Dict([
        (u'subscriberInfo', _ProvideSubscriberInfoRes_subscriberInfo),
        (u'extensionContainer', _ProvideSubscriberInfoRes_extensionContainer),
        ])
    ProvideSubscriberInfoRes._ext = []
    
    #-----< SubscriberInfo >-----#
    SubscriberInfo = SEQ(name=u'SubscriberInfo', mode=MODE_TYPE)
    _SubscriberInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _SubscriberInfo_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _SubscriberInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubscriberInfo_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _SubscriberInfo_ps_SubscriberState = CHOICE(name=u'ps-SubscriberState', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SubscriberInfo_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _SubscriberInfo_gprs_MS_Class = SEQ(name=u'gprs-MS-Class', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _SubscriberInfo_mnpInfoRes = SEQ(name=u'mnpInfoRes', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MNPInfoRes')), opt=True)
    _SubscriberInfo_imsVoiceOverPS_SessionsIndication = ENUM(name=u'imsVoiceOverPS-SessionsIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMS-VoiceOverPS-SessionsInd')), opt=True)
    _SubscriberInfo_lastUE_ActivityTime = OCT_STR(name=u'lastUE-ActivityTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _SubscriberInfo_lastRAT_Type = ENUM(name=u'lastRAT-Type', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _SubscriberInfo_eps_SubscriberState = CHOICE(name=u'eps-SubscriberState', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_locationInformationEPS = SEQ(name=u'locationInformationEPS', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _SubscriberInfo_timeZone = OCT_STR(name=u'timeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _SubscriberInfo_daylightSavingTime = ENUM(name=u'daylightSavingTime', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DaylightSavingTime')), opt=True)
    _SubscriberInfo_locationInformation5GS = SEQ(name=u'locationInformation5GS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation5GS')), opt=True)
    SubscriberInfo._cont = ASN1Dict([
        (u'locationInformation', _SubscriberInfo_locationInformation),
        (u'subscriberState', _SubscriberInfo_subscriberState),
        (u'extensionContainer', _SubscriberInfo_extensionContainer),
        (u'locationInformationGPRS', _SubscriberInfo_locationInformationGPRS),
        (u'ps-SubscriberState', _SubscriberInfo_ps_SubscriberState),
        (u'imei', _SubscriberInfo_imei),
        (u'ms-Classmark2', _SubscriberInfo_ms_Classmark2),
        (u'gprs-MS-Class', _SubscriberInfo_gprs_MS_Class),
        (u'mnpInfoRes', _SubscriberInfo_mnpInfoRes),
        (u'imsVoiceOverPS-SessionsIndication', _SubscriberInfo_imsVoiceOverPS_SessionsIndication),
        (u'lastUE-ActivityTime', _SubscriberInfo_lastUE_ActivityTime),
        (u'lastRAT-Type', _SubscriberInfo_lastRAT_Type),
        (u'eps-SubscriberState', _SubscriberInfo_eps_SubscriberState),
        (u'locationInformationEPS', _SubscriberInfo_locationInformationEPS),
        (u'timeZone', _SubscriberInfo_timeZone),
        (u'daylightSavingTime', _SubscriberInfo_daylightSavingTime),
        (u'locationInformation5GS', _SubscriberInfo_locationInformation5GS),
        ])
    SubscriberInfo._ext = [u'locationInformationGPRS', u'ps-SubscriberState', u'imei', u'ms-Classmark2', u'gprs-MS-Class', u'mnpInfoRes', u'imsVoiceOverPS-SessionsIndication', u'lastUE-ActivityTime', u'lastRAT-Type', u'eps-SubscriberState', u'locationInformationEPS', u'timeZone', u'daylightSavingTime', u'locationInformation5GS']
    
    #-----< IMS-VoiceOverPS-SessionsInd >-----#
    IMS_VoiceOverPS_SessionsInd = ENUM(name=u'IMS-VoiceOverPS-SessionsInd', mode=MODE_TYPE)
    IMS_VoiceOverPS_SessionsInd._cont = ASN1Dict([(u'imsVoiceOverPS-SessionsNotSupported', 0), (u'imsVoiceOverPS-SessionsSupported', 1), (u'unknown', 2)])
    IMS_VoiceOverPS_SessionsInd._ext = None
    
    #-----< TimeZone >-----#
    TimeZone = OCT_STR(name=u'TimeZone', mode=MODE_TYPE)
    TimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< DaylightSavingTime >-----#
    DaylightSavingTime = ENUM(name=u'DaylightSavingTime', mode=MODE_TYPE)
    DaylightSavingTime._cont = ASN1Dict([(u'noAdjustment', 0), (u'plusOneHourAdjustment', 1), (u'plusTwoHoursAdjustment', 2)])
    DaylightSavingTime._ext = None
    
    #-----< MNPInfoRes >-----#
    MNPInfoRes = SEQ(name=u'MNPInfoRes', mode=MODE_TYPE)
    _MNPInfoRes_routeingNumber = OCT_STR(name=u'routeingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RouteingNumber')), opt=True)
    _MNPInfoRes_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MNPInfoRes_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MNPInfoRes_numberPortabilityStatus = ENUM(name=u'numberPortabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _MNPInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MNPInfoRes._cont = ASN1Dict([
        (u'routeingNumber', _MNPInfoRes_routeingNumber),
        (u'imsi', _MNPInfoRes_imsi),
        (u'msisdn', _MNPInfoRes_msisdn),
        (u'numberPortabilityStatus', _MNPInfoRes_numberPortabilityStatus),
        (u'extensionContainer', _MNPInfoRes_extensionContainer),
        ])
    MNPInfoRes._ext = []
    
    #-----< RouteingNumber >-----#
    RouteingNumber = OCT_STR(name=u'RouteingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    RouteingNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NumberPortabilityStatus >-----#
    NumberPortabilityStatus = ENUM(name=u'NumberPortabilityStatus', mode=MODE_TYPE)
    NumberPortabilityStatus._cont = ASN1Dict([(u'notKnownToBePorted', 0), (u'ownNumberPortedOut', 1), (u'foreignNumberPortedToForeignNetwork', 2), (u'ownNumberNotPortedOut', 4), (u'foreignNumberPortedIn', 5)])
    NumberPortabilityStatus._ext = [u'ownNumberNotPortedOut', u'foreignNumberPortedIn']
    
    #-----< MS-Classmark2 >-----#
    MS_Classmark2 = OCT_STR(name=u'MS-Classmark2', mode=MODE_TYPE)
    MS_Classmark2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< GPRSMSClass >-----#
    GPRSMSClass = SEQ(name=u'GPRSMSClass', mode=MODE_TYPE)
    _GPRSMSClass_mSNetworkCapability = OCT_STR(name=u'mSNetworkCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSNetworkCapability')))
    _GPRSMSClass_mSRadioAccessCapability = OCT_STR(name=u'mSRadioAccessCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSRadioAccessCapability')), opt=True)
    GPRSMSClass._cont = ASN1Dict([
        (u'mSNetworkCapability', _GPRSMSClass_mSNetworkCapability),
        (u'mSRadioAccessCapability', _GPRSMSClass_mSRadioAccessCapability),
        ])
    GPRSMSClass._ext = None
    
    #-----< MSNetworkCapability >-----#
    MSNetworkCapability = OCT_STR(name=u'MSNetworkCapability', mode=MODE_TYPE)
    MSNetworkCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MSRadioAccessCapability >-----#
    MSRadioAccessCapability = OCT_STR(name=u'MSRadioAccessCapability', mode=MODE_TYPE)
    MSRadioAccessCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< RequestedInfo >-----#
    RequestedInfo = SEQ(name=u'RequestedInfo', mode=MODE_TYPE)
    _RequestedInfo_locationInformation = NULL(name=u'locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_subscriberState = NULL(name=u'subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedInfo_currentLocation = NULL(name=u'currentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedDomain = ENUM(name=u'requestedDomain', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DomainType')), opt=True)
    _RequestedInfo_imei = NULL(name=u'imei', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_ms_classmark = NULL(name=u'ms-classmark', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_mnpRequestedInfo = NULL(name=u'mnpRequestedInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_locationInformationEPS_Supported = NULL(name=u'locationInformationEPS-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_t_adsData = NULL(name=u't-adsData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedNodes = BIT_STR(name=u'requestedNodes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedNodes')), opt=True)
    _RequestedInfo_servingNodeIndication = NULL(name=u'servingNodeIndication', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_localTimeZoneRequest = NULL(name=u'localTimeZoneRequest', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedInfo._cont = ASN1Dict([
        (u'locationInformation', _RequestedInfo_locationInformation),
        (u'subscriberState', _RequestedInfo_subscriberState),
        (u'extensionContainer', _RequestedInfo_extensionContainer),
        (u'currentLocation', _RequestedInfo_currentLocation),
        (u'requestedDomain', _RequestedInfo_requestedDomain),
        (u'imei', _RequestedInfo_imei),
        (u'ms-classmark', _RequestedInfo_ms_classmark),
        (u'mnpRequestedInfo', _RequestedInfo_mnpRequestedInfo),
        (u'locationInformationEPS-Supported', _RequestedInfo_locationInformationEPS_Supported),
        (u't-adsData', _RequestedInfo_t_adsData),
        (u'requestedNodes', _RequestedInfo_requestedNodes),
        (u'servingNodeIndication', _RequestedInfo_servingNodeIndication),
        (u'localTimeZoneRequest', _RequestedInfo_localTimeZoneRequest),
        ])
    RequestedInfo._ext = [u'currentLocation', u'requestedDomain', u'imei', u'ms-classmark', u'mnpRequestedInfo', u'locationInformationEPS-Supported', u't-adsData', u'requestedNodes', u'servingNodeIndication', u'localTimeZoneRequest']
    
    #-----< DomainType >-----#
    DomainType = ENUM(name=u'DomainType', mode=MODE_TYPE)
    DomainType._cont = ASN1Dict([(u'cs-Domain', 0), (u'ps-Domain', 1)])
    DomainType._ext = []
    
    #-----< RequestedNodes >-----#
    RequestedNodes = BIT_STR(name=u'RequestedNodes', mode=MODE_TYPE)
    RequestedNodes._cont = ASN1Dict([(u'mme', 0), (u'sgsn', 1)])
    RequestedNodes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationInformation >-----#
    LocationInformation = SEQ(name=u'LocationInformation', mode=MODE_TYPE)
    _LocationInformation_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation_vlr_number = OCT_STR(name=u'vlr-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationNumber')), opt=True)
    _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name=u'cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformation_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation_selectedLSA_Id = OCT_STR(name=u'selectedLSA-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformation_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_locationInformationEPS = SEQ(name=u'locationInformationEPS', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _LocationInformation_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformation._cont = ASN1Dict([
        (u'ageOfLocationInformation', _LocationInformation_ageOfLocationInformation),
        (u'geographicalInformation', _LocationInformation_geographicalInformation),
        (u'vlr-number', _LocationInformation_vlr_number),
        (u'locationNumber', _LocationInformation_locationNumber),
        (u'cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI),
        (u'extensionContainer', _LocationInformation_extensionContainer),
        (u'selectedLSA-Id', _LocationInformation_selectedLSA_Id),
        (u'msc-Number', _LocationInformation_msc_Number),
        (u'geodeticInformation', _LocationInformation_geodeticInformation),
        (u'currentLocationRetrieved', _LocationInformation_currentLocationRetrieved),
        (u'sai-Present', _LocationInformation_sai_Present),
        (u'locationInformationEPS', _LocationInformation_locationInformationEPS),
        (u'userCSGInformation', _LocationInformation_userCSGInformation),
        ])
    LocationInformation._ext = [u'selectedLSA-Id', u'msc-Number', u'geodeticInformation', u'currentLocationRetrieved', u'sai-Present', u'locationInformationEPS', u'userCSGInformation']
    
    #-----< LocationInformationEPS >-----#
    LocationInformationEPS = SEQ(name=u'LocationInformationEPS', mode=MODE_TYPE)
    _LocationInformationEPS_e_utranCellGlobalIdentity = OCT_STR(name=u'e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformationEPS_trackingAreaIdentity = OCT_STR(name=u'trackingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformationEPS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationEPS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationEPS_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationEPS_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationEPS_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationEPS_mme_Name = OCT_STR(name=u'mme-Name', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    LocationInformationEPS._cont = ASN1Dict([
        (u'e-utranCellGlobalIdentity', _LocationInformationEPS_e_utranCellGlobalIdentity),
        (u'trackingAreaIdentity', _LocationInformationEPS_trackingAreaIdentity),
        (u'extensionContainer', _LocationInformationEPS_extensionContainer),
        (u'geographicalInformation', _LocationInformationEPS_geographicalInformation),
        (u'geodeticInformation', _LocationInformationEPS_geodeticInformation),
        (u'currentLocationRetrieved', _LocationInformationEPS_currentLocationRetrieved),
        (u'ageOfLocationInformation', _LocationInformationEPS_ageOfLocationInformation),
        (u'mme-Name', _LocationInformationEPS_mme_Name),
        ])
    LocationInformationEPS._ext = [u'mme-Name']
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name=u'LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name=u'cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name=u'selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationGPRS_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        (u'cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        (u'routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        (u'geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        (u'sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        (u'selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        (u'extensionContainer', _LocationInformationGPRS_extensionContainer),
        (u'sai-Present', _LocationInformationGPRS_sai_Present),
        (u'geodeticInformation', _LocationInformationGPRS_geodeticInformation),
        (u'currentLocationRetrieved', _LocationInformationGPRS_currentLocationRetrieved),
        (u'ageOfLocationInformation', _LocationInformationGPRS_ageOfLocationInformation),
        (u'userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = [u'sai-Present', u'geodeticInformation', u'currentLocationRetrieved', u'ageOfLocationInformation', u'userCSGInformation']
    
    #-----< LocationInformation5GS >-----#
    LocationInformation5GS = SEQ(name=u'LocationInformation5GS', mode=MODE_TYPE)
    _LocationInformation5GS_nrCellGlobalIdentity = OCT_STR(name=u'nrCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-CGI')), opt=True)
    _LocationInformation5GS_e_utranCellGlobalIdentity = OCT_STR(name=u'e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformation5GS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation5GS_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation5GS_amf_address = OCT_STR(name=u'amf-address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _LocationInformation5GS_trackingAreaIdentity = OCT_STR(name=u'trackingAreaIdentity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformation5GS_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation5GS_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation5GS_vplmnId = OCT_STR(name=u'vplmnId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _LocationInformation5GS_localtimeZone = OCT_STR(name=u'localtimeZone', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _LocationInformation5GS_rat_Type = ENUM(name=u'rat-Type', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _LocationInformation5GS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation5GS_nrTrackingAreaIdentity = OCT_STR(name=u'nrTrackingAreaIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-TA-Id')), opt=True)
    LocationInformation5GS._cont = ASN1Dict([
        (u'nrCellGlobalIdentity', _LocationInformation5GS_nrCellGlobalIdentity),
        (u'e-utranCellGlobalIdentity', _LocationInformation5GS_e_utranCellGlobalIdentity),
        (u'geographicalInformation', _LocationInformation5GS_geographicalInformation),
        (u'geodeticInformation', _LocationInformation5GS_geodeticInformation),
        (u'amf-address', _LocationInformation5GS_amf_address),
        (u'trackingAreaIdentity', _LocationInformation5GS_trackingAreaIdentity),
        (u'currentLocationRetrieved', _LocationInformation5GS_currentLocationRetrieved),
        (u'ageOfLocationInformation', _LocationInformation5GS_ageOfLocationInformation),
        (u'vplmnId', _LocationInformation5GS_vplmnId),
        (u'localtimeZone', _LocationInformation5GS_localtimeZone),
        (u'rat-Type', _LocationInformation5GS_rat_Type),
        (u'extensionContainer', _LocationInformation5GS_extensionContainer),
        (u'nrTrackingAreaIdentity', _LocationInformation5GS_nrTrackingAreaIdentity),
        ])
    LocationInformation5GS._ext = [u'nrTrackingAreaIdentity']
    
    #-----< UserCSGInformation >-----#
    UserCSGInformation = SEQ(name=u'UserCSGInformation', mode=MODE_TYPE)
    _UserCSGInformation_csg_Id = BIT_STR(name=u'csg-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _UserCSGInformation_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UserCSGInformation_accessMode = OCT_STR(name=u'accessMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_accessMode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _UserCSGInformation_cmi = OCT_STR(name=u'cmi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_cmi._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    UserCSGInformation._cont = ASN1Dict([
        (u'csg-Id', _UserCSGInformation_csg_Id),
        (u'extensionContainer', _UserCSGInformation_extensionContainer),
        (u'accessMode', _UserCSGInformation_accessMode),
        (u'cmi', _UserCSGInformation_cmi),
        ])
    UserCSGInformation._ext = [u'accessMode', u'cmi']
    
    #-----< GeographicalInformation >-----#
    GeographicalInformation = OCT_STR(name=u'GeographicalInformation', mode=MODE_TYPE)
    GeographicalInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GeodeticInformation >-----#
    GeodeticInformation = OCT_STR(name=u'GeodeticInformation', mode=MODE_TYPE)
    GeodeticInformation._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name=u'LocationNumber', mode=MODE_TYPE)
    LocationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< SubscriberState >-----#
    SubscriberState = CHOICE(name=u'SubscriberState', mode=MODE_TYPE)
    _SubscriberState_assumedIdle = NULL(name=u'assumedIdle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_camelBusy = NULL(name=u'camelBusy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_netDetNotReachable = ENUM(name=u'netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    _SubscriberState_notProvidedFromVLR = NULL(name=u'notProvidedFromVLR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriberState._cont = ASN1Dict([
        (u'assumedIdle', _SubscriberState_assumedIdle),
        (u'camelBusy', _SubscriberState_camelBusy),
        (u'netDetNotReachable', _SubscriberState_netDetNotReachable),
        (u'notProvidedFromVLR', _SubscriberState_notProvidedFromVLR),
        ])
    SubscriberState._ext = None
    
    #-----< PS-SubscriberState >-----#
    PS_SubscriberState = CHOICE(name=u'PS-SubscriberState', mode=MODE_TYPE)
    _PS_SubscriberState_notProvidedFromSGSNorMME = NULL(name=u'notProvidedFromSGSNorMME', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_Detached = NULL(name=u'ps-Detached', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedNotReachableForPaging = NULL(name=u'ps-AttachedNotReachableForPaging', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedReachableForPaging = NULL(name=u'ps-AttachedReachableForPaging', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging = SEQ_OF(name=u'ps-PDP-ActiveNotReachableForPaging', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_ps_PDP_ActiveReachableForPaging = SEQ_OF(name=u'ps-PDP-ActiveReachableForPaging', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_netDetNotReachable = ENUM(name=u'netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    PS_SubscriberState._cont = ASN1Dict([
        (u'notProvidedFromSGSNorMME', _PS_SubscriberState_notProvidedFromSGSNorMME),
        (u'ps-Detached', _PS_SubscriberState_ps_Detached),
        (u'ps-AttachedNotReachableForPaging', _PS_SubscriberState_ps_AttachedNotReachableForPaging),
        (u'ps-AttachedReachableForPaging', _PS_SubscriberState_ps_AttachedReachableForPaging),
        (u'ps-PDP-ActiveNotReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging),
        (u'ps-PDP-ActiveReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveReachableForPaging),
        (u'netDetNotReachable', _PS_SubscriberState_netDetNotReachable),
        ])
    PS_SubscriberState._ext = None
    
    #-----< PDP-ContextInfoList >-----#
    PDP_ContextInfoList = SEQ_OF(name=u'PDP-ContextInfoList', mode=MODE_TYPE)
    _PDP_ContextInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfo')))
    PDP_ContextInfoList._cont = _PDP_ContextInfoList__item_
    PDP_ContextInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< PDP-ContextInfo >-----#
    PDP_ContextInfo = SEQ(name=u'PDP-ContextInfo', mode=MODE_TYPE)
    _PDP_ContextInfo_pdp_ContextIdentifier = INT(name=u'pdp-ContextIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_ContextInfo_pdp_ContextActive = NULL(name=u'pdp-ContextActive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_ContextInfo_pdp_Type = OCT_STR(name=u'pdp-Type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_ContextInfo_pdp_Address = OCT_STR(name=u'pdp-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_ContextInfo_apn_Subscribed = OCT_STR(name=u'apn-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_apn_InUse = OCT_STR(name=u'apn-InUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_nsapi = INT(name=u'nsapi', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NSAPI')), opt=True)
    _PDP_ContextInfo_transactionId = OCT_STR(name=u'transactionId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TransactionId')), opt=True)
    _PDP_ContextInfo_teid_ForGnAndGp = OCT_STR(name=u'teid-ForGnAndGp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_teid_ForIu = OCT_STR(name=u'teid-ForIu', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_qos_Subscribed = OCT_STR(name=u'qos-Subscribed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Requested = OCT_STR(name=u'qos-Requested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Negotiated = OCT_STR(name=u'qos-Negotiated', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_chargingId = OCT_STR(name=u'chargingId', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _PDP_ContextInfo_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_ContextInfo_rnc_Address = OCT_STR(name=u'rnc-Address', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_ContextInfo_qos2_Subscribed = OCT_STR(name=u'qos2-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Requested = OCT_STR(name=u'qos2-Requested', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Negotiated = OCT_STR(name=u'qos2-Negotiated', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Subscribed = OCT_STR(name=u'qos3-Subscribed', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Requested = OCT_STR(name=u'qos3-Requested', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Negotiated = OCT_STR(name=u'qos3-Negotiated', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Subscribed = OCT_STR(name=u'qos4-Subscribed', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Requested = OCT_STR(name=u'qos4-Requested', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Negotiated = OCT_STR(name=u'qos4-Negotiated', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_ext_pdp_Type = OCT_STR(name=u'ext-pdp-Type', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_ContextInfo_ext_pdp_Address = OCT_STR(name=u'ext-pdp-Address', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    PDP_ContextInfo._cont = ASN1Dict([
        (u'pdp-ContextIdentifier', _PDP_ContextInfo_pdp_ContextIdentifier),
        (u'pdp-ContextActive', _PDP_ContextInfo_pdp_ContextActive),
        (u'pdp-Type', _PDP_ContextInfo_pdp_Type),
        (u'pdp-Address', _PDP_ContextInfo_pdp_Address),
        (u'apn-Subscribed', _PDP_ContextInfo_apn_Subscribed),
        (u'apn-InUse', _PDP_ContextInfo_apn_InUse),
        (u'nsapi', _PDP_ContextInfo_nsapi),
        (u'transactionId', _PDP_ContextInfo_transactionId),
        (u'teid-ForGnAndGp', _PDP_ContextInfo_teid_ForGnAndGp),
        (u'teid-ForIu', _PDP_ContextInfo_teid_ForIu),
        (u'ggsn-Address', _PDP_ContextInfo_ggsn_Address),
        (u'qos-Subscribed', _PDP_ContextInfo_qos_Subscribed),
        (u'qos-Requested', _PDP_ContextInfo_qos_Requested),
        (u'qos-Negotiated', _PDP_ContextInfo_qos_Negotiated),
        (u'chargingId', _PDP_ContextInfo_chargingId),
        (u'chargingCharacteristics', _PDP_ContextInfo_chargingCharacteristics),
        (u'rnc-Address', _PDP_ContextInfo_rnc_Address),
        (u'extensionContainer', _PDP_ContextInfo_extensionContainer),
        (u'qos2-Subscribed', _PDP_ContextInfo_qos2_Subscribed),
        (u'qos2-Requested', _PDP_ContextInfo_qos2_Requested),
        (u'qos2-Negotiated', _PDP_ContextInfo_qos2_Negotiated),
        (u'qos3-Subscribed', _PDP_ContextInfo_qos3_Subscribed),
        (u'qos3-Requested', _PDP_ContextInfo_qos3_Requested),
        (u'qos3-Negotiated', _PDP_ContextInfo_qos3_Negotiated),
        (u'qos4-Subscribed', _PDP_ContextInfo_qos4_Subscribed),
        (u'qos4-Requested', _PDP_ContextInfo_qos4_Requested),
        (u'qos4-Negotiated', _PDP_ContextInfo_qos4_Negotiated),
        (u'ext-pdp-Type', _PDP_ContextInfo_ext_pdp_Type),
        (u'ext-pdp-Address', _PDP_ContextInfo_ext_pdp_Address),
        ])
    PDP_ContextInfo._ext = [u'qos2-Subscribed', u'qos2-Requested', u'qos2-Negotiated', u'qos3-Subscribed', u'qos3-Requested', u'qos3-Negotiated', u'qos4-Subscribed', u'qos4-Requested', u'qos4-Negotiated', u'ext-pdp-Type', u'ext-pdp-Address']
    
    #-----< NSAPI >-----#
    NSAPI = INT(name=u'NSAPI', mode=MODE_TYPE)
    NSAPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< TransactionId >-----#
    TransactionId = OCT_STR(name=u'TransactionId', mode=MODE_TYPE)
    TransactionId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TEID >-----#
    TEID = OCT_STR(name=u'TEID', mode=MODE_TYPE)
    TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GPRSChargingID >-----#
    GPRSChargingID = OCT_STR(name=u'GPRSChargingID', mode=MODE_TYPE)
    GPRSChargingID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< NotReachableReason >-----#
    NotReachableReason = ENUM(name=u'NotReachableReason', mode=MODE_TYPE)
    NotReachableReason._cont = ASN1Dict([(u'msPurged', 0), (u'imsiDetached', 1), (u'restrictedArea', 2), (u'notRegistered', 3)])
    NotReachableReason._ext = None
    
    #-----< AnyTimeInterrogationArg >-----#
    AnyTimeInterrogationArg = SEQ(name=u'AnyTimeInterrogationArg', mode=MODE_TYPE)
    _AnyTimeInterrogationArg_subscriberIdentity = CHOICE(name=u'subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeInterrogationArg_requestedInfo = SEQ(name=u'requestedInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _AnyTimeInterrogationArg_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeInterrogationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationArg._cont = ASN1Dict([
        (u'subscriberIdentity', _AnyTimeInterrogationArg_subscriberIdentity),
        (u'requestedInfo', _AnyTimeInterrogationArg_requestedInfo),
        (u'gsmSCF-Address', _AnyTimeInterrogationArg_gsmSCF_Address),
        (u'extensionContainer', _AnyTimeInterrogationArg_extensionContainer),
        ])
    AnyTimeInterrogationArg._ext = []
    
    #-----< AnyTimeInterrogationRes >-----#
    AnyTimeInterrogationRes = SEQ(name=u'AnyTimeInterrogationRes', mode=MODE_TYPE)
    _AnyTimeInterrogationRes_subscriberInfo = SEQ(name=u'subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _AnyTimeInterrogationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationRes._cont = ASN1Dict([
        (u'subscriberInfo', _AnyTimeInterrogationRes_subscriberInfo),
        (u'extensionContainer', _AnyTimeInterrogationRes_extensionContainer),
        ])
    AnyTimeInterrogationRes._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationArg >-----#
    AnyTimeSubscriptionInterrogationArg = SEQ(name=u'AnyTimeSubscriptionInterrogationArg', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationArg_subscriberIdentity = CHOICE(name=u'subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo = SEQ(name=u'requestedSubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedSubscriptionInfo')))
    _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeSubscriptionInterrogationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AnyTimeSubscriptionInterrogationArg._cont = ASN1Dict([
        (u'subscriberIdentity', _AnyTimeSubscriptionInterrogationArg_subscriberIdentity),
        (u'requestedSubscriptionInfo', _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo),
        (u'gsmSCF-Address', _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address),
        (u'extensionContainer', _AnyTimeSubscriptionInterrogationArg_extensionContainer),
        (u'longFTN-Supported', _AnyTimeSubscriptionInterrogationArg_longFTN_Supported),
        ])
    AnyTimeSubscriptionInterrogationArg._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationRes >-----#
    AnyTimeSubscriptionInterrogationRes = SEQ(name=u'AnyTimeSubscriptionInterrogationRes', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationRes_callForwardingData = SEQ(name=u'callForwardingData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallForwardingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_callBarringData = SEQ(name=u'callBarringData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallBarringData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_odb_Info = SEQ(name=u'odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo = SEQ(name=u'camel-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases = BIT_STR(name=u'supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases = BIT_STR(name=u'supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR = BIT_STR(name=u'offeredCamel4CSIsInVLR', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN = BIT_STR(name=u'offeredCamel4CSIsInSGSN', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List = SEQ_OF(name=u'msisdn-BS-List', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS-List')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_cw_Data = SEQ(name=u'cw-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ch_Data = SEQ(name=u'ch-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clip_Data = SEQ(name=u'clip-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clir_Data = SEQ(name=u'clir-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ect_data = SEQ(name=u'ect-data', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    AnyTimeSubscriptionInterrogationRes._cont = ASN1Dict([
        (u'callForwardingData', _AnyTimeSubscriptionInterrogationRes_callForwardingData),
        (u'callBarringData', _AnyTimeSubscriptionInterrogationRes_callBarringData),
        (u'odb-Info', _AnyTimeSubscriptionInterrogationRes_odb_Info),
        (u'camel-SubscriptionInfo', _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo),
        (u'supportedVLR-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases),
        (u'supportedSGSN-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases),
        (u'extensionContainer', _AnyTimeSubscriptionInterrogationRes_extensionContainer),
        (u'offeredCamel4CSIsInVLR', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR),
        (u'offeredCamel4CSIsInSGSN', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN),
        (u'msisdn-BS-List', _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List),
        (u'csg-SubscriptionDataList', _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList),
        (u'cw-Data', _AnyTimeSubscriptionInterrogationRes_cw_Data),
        (u'ch-Data', _AnyTimeSubscriptionInterrogationRes_ch_Data),
        (u'clip-Data', _AnyTimeSubscriptionInterrogationRes_clip_Data),
        (u'clir-Data', _AnyTimeSubscriptionInterrogationRes_clir_Data),
        (u'ect-data', _AnyTimeSubscriptionInterrogationRes_ect_data),
        ])
    AnyTimeSubscriptionInterrogationRes._ext = [u'offeredCamel4CSIsInVLR', u'offeredCamel4CSIsInSGSN', u'msisdn-BS-List', u'csg-SubscriptionDataList', u'cw-Data', u'ch-Data', u'clip-Data', u'clir-Data', u'ect-data']
    
    #-----< CallWaitingData >-----#
    CallWaitingData = SEQ(name=u'CallWaitingData', mode=MODE_TYPE)
    _CallWaitingData_cwFeatureList = SEQ_OF(name=u'cwFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeatureList')))
    _CallWaitingData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallWaitingData._cont = ASN1Dict([
        (u'cwFeatureList', _CallWaitingData_cwFeatureList),
        (u'notificationToCSE', _CallWaitingData_notificationToCSE),
        ])
    CallWaitingData._ext = []
    
    #-----< Ext-CwFeatureList >-----#
    Ext_CwFeatureList = SEQ_OF(name=u'Ext-CwFeatureList', mode=MODE_TYPE)
    _Ext_CwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeature')))
    Ext_CwFeatureList._cont = _Ext_CwFeatureList__item_
    Ext_CwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CwFeature >-----#
    Ext_CwFeature = SEQ(name=u'Ext-CwFeature', mode=MODE_TYPE)
    _Ext_CwFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    _Ext_CwFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    Ext_CwFeature._cont = ASN1Dict([
        (u'basicService', _Ext_CwFeature_basicService),
        (u'ss-Status', _Ext_CwFeature_ss_Status),
        ])
    Ext_CwFeature._ext = []
    
    #-----< ClipData >-----#
    ClipData = SEQ(name=u'ClipData', mode=MODE_TYPE)
    _ClipData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClipData_overrideCategory = ENUM(name=u'overrideCategory', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    _ClipData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClipData._cont = ASN1Dict([
        (u'ss-Status', _ClipData_ss_Status),
        (u'overrideCategory', _ClipData_overrideCategory),
        (u'notificationToCSE', _ClipData_notificationToCSE),
        ])
    ClipData._ext = []
    
    #-----< ClirData >-----#
    ClirData = SEQ(name=u'ClirData', mode=MODE_TYPE)
    _ClirData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClirData_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ClirData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClirData._cont = ASN1Dict([
        (u'ss-Status', _ClirData_ss_Status),
        (u'cliRestrictionOption', _ClirData_cliRestrictionOption),
        (u'notificationToCSE', _ClirData_notificationToCSE),
        ])
    ClirData._ext = []
    
    #-----< CallHoldData >-----#
    CallHoldData = SEQ(name=u'CallHoldData', mode=MODE_TYPE)
    _CallHoldData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _CallHoldData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallHoldData._cont = ASN1Dict([
        (u'ss-Status', _CallHoldData_ss_Status),
        (u'notificationToCSE', _CallHoldData_notificationToCSE),
        ])
    CallHoldData._ext = []
    
    #-----< EctData >-----#
    EctData = SEQ(name=u'EctData', mode=MODE_TYPE)
    _EctData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _EctData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EctData._cont = ASN1Dict([
        (u'ss-Status', _EctData_ss_Status),
        (u'notificationToCSE', _EctData_notificationToCSE),
        ])
    EctData._ext = []
    
    #-----< RequestedSubscriptionInfo >-----#
    RequestedSubscriptionInfo = SEQ(name=u'RequestedSubscriptionInfo', mode=MODE_TYPE)
    _RequestedSubscriptionInfo_requestedSS_Info = SEQ(name=u'requestedSS-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-ForBS-Code')), opt=True)
    _RequestedSubscriptionInfo_odb = NULL(name=u'odb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo = ENUM(name=u'requestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases = NULL(name=u'supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases = NULL(name=u'supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name=u'additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_msisdn_BS_List = NULL(name=u'msisdn-BS-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_csg_SubscriptionDataRequested = NULL(name=u'csg-SubscriptionDataRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_cw_Info = NULL(name=u'cw-Info', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clip_Info = NULL(name=u'clip-Info', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clir_Info = NULL(name=u'clir-Info', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_hold_Info = NULL(name=u'hold-Info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_ect_Info = NULL(name=u'ect-Info', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedSubscriptionInfo._cont = ASN1Dict([
        (u'requestedSS-Info', _RequestedSubscriptionInfo_requestedSS_Info),
        (u'odb', _RequestedSubscriptionInfo_odb),
        (u'requestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo),
        (u'supportedVLR-CAMEL-Phases', _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases),
        (u'supportedSGSN-CAMEL-Phases', _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases),
        (u'extensionContainer', _RequestedSubscriptionInfo_extensionContainer),
        (u'additionalRequestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo),
        (u'msisdn-BS-List', _RequestedSubscriptionInfo_msisdn_BS_List),
        (u'csg-SubscriptionDataRequested', _RequestedSubscriptionInfo_csg_SubscriptionDataRequested),
        (u'cw-Info', _RequestedSubscriptionInfo_cw_Info),
        (u'clip-Info', _RequestedSubscriptionInfo_clip_Info),
        (u'clir-Info', _RequestedSubscriptionInfo_clir_Info),
        (u'hold-Info', _RequestedSubscriptionInfo_hold_Info),
        (u'ect-Info', _RequestedSubscriptionInfo_ect_Info),
        ])
    RequestedSubscriptionInfo._ext = [u'additionalRequestedCAMEL-SubscriptionInfo', u'msisdn-BS-List', u'csg-SubscriptionDataRequested', u'cw-Info', u'clip-Info', u'clir-Info', u'hold-Info', u'ect-Info']
    
    #-----< MSISDN-BS-List >-----#
    MSISDN_BS_List = SEQ_OF(name=u'MSISDN-BS-List', mode=MODE_TYPE)
    _MSISDN_BS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS')))
    MSISDN_BS_List._cont = _MSISDN_BS_List__item_
    MSISDN_BS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfMSISDN >-----#
    maxNumOfMSISDN = INT(name=u'maxNumOfMSISDN', mode=MODE_VALUE)
    maxNumOfMSISDN._val = 50
    
    #-----< MSISDN-BS >-----#
    MSISDN_BS = SEQ(name=u'MSISDN-BS', mode=MODE_TYPE)
    _MSISDN_BS_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MSISDN_BS_basicServiceList = SEQ_OF(name=u'basicServiceList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _MSISDN_BS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MSISDN_BS._cont = ASN1Dict([
        (u'msisdn', _MSISDN_BS_msisdn),
        (u'basicServiceList', _MSISDN_BS_basicServiceList),
        (u'extensionContainer', _MSISDN_BS_extensionContainer),
        ])
    MSISDN_BS._ext = []
    
    #-----< RequestedCAMEL-SubscriptionInfo >-----#
    RequestedCAMEL_SubscriptionInfo = ENUM(name=u'RequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    RequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([(u'o-CSI', 0), (u't-CSI', 1), (u'vt-CSI', 2), (u'tif-CSI', 3), (u'gprs-CSI', 4), (u'mo-sms-CSI', 5), (u'ss-CSI', 6), (u'm-CSI', 7), (u'd-csi', 8)])
    RequestedCAMEL_SubscriptionInfo._ext = None
    
    #-----< AdditionalRequestedCAMEL-SubscriptionInfo >-----#
    AdditionalRequestedCAMEL_SubscriptionInfo = ENUM(name=u'AdditionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    AdditionalRequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([(u'mt-sms-CSI', 0), (u'mg-csi', 1), (u'o-IM-CSI', 2), (u'd-IM-CSI', 3), (u'vt-IM-CSI', 4)])
    AdditionalRequestedCAMEL_SubscriptionInfo._ext = []
    
    #-----< CallForwardingData >-----#
    CallForwardingData = SEQ(name=u'CallForwardingData', mode=MODE_TYPE)
    _CallForwardingData_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _CallForwardingData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallForwardingData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallForwardingData._cont = ASN1Dict([
        (u'forwardingFeatureList', _CallForwardingData_forwardingFeatureList),
        (u'notificationToCSE', _CallForwardingData_notificationToCSE),
        (u'extensionContainer', _CallForwardingData_extensionContainer),
        ])
    CallForwardingData._ext = []
    
    #-----< CallBarringData >-----#
    CallBarringData = SEQ(name=u'CallBarringData', mode=MODE_TYPE)
    _CallBarringData_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _CallBarringData_password = STR_NUM(name=u'password', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _CallBarringData_password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    _CallBarringData_wrongPasswordAttemptsCounter = INT(name=u'wrongPasswordAttemptsCounter', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _CallBarringData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallBarringData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallBarringData._cont = ASN1Dict([
        (u'callBarringFeatureList', _CallBarringData_callBarringFeatureList),
        (u'password', _CallBarringData_password),
        (u'wrongPasswordAttemptsCounter', _CallBarringData_wrongPasswordAttemptsCounter),
        (u'notificationToCSE', _CallBarringData_notificationToCSE),
        (u'extensionContainer', _CallBarringData_extensionContainer),
        ])
    CallBarringData._ext = []
    
    #-----< WrongPasswordAttemptsCounter >-----#
    WrongPasswordAttemptsCounter = INT(name=u'WrongPasswordAttemptsCounter', mode=MODE_TYPE)
    WrongPasswordAttemptsCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< ODB-Info >-----#
    ODB_Info = SEQ(name=u'ODB-Info', mode=MODE_TYPE)
    _ODB_Info_odb_Data = SEQ(name=u'odb-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')))
    _ODB_Info_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, opt=True)
    _ODB_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Info._cont = ASN1Dict([
        (u'odb-Data', _ODB_Info_odb_Data),
        (u'notificationToCSE', _ODB_Info_notificationToCSE),
        (u'extensionContainer', _ODB_Info_extensionContainer),
        ])
    ODB_Info._ext = []
    
    #-----< CAMEL-SubscriptionInfo >-----#
    CAMEL_SubscriptionInfo = SEQ(name=u'CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _CAMEL_SubscriptionInfo_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_CSI = SEQ(name=u'd-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_CSI = SEQ(name=u't-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u't-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_vt_CSI = SEQ(name=u'vt-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u'vt-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI = NULL(name=u'tif-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE = NULL(name=u'tif-CSI-NotificationToCSE', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name=u'gprs-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name=u'mo-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_ss_CSI = SEQ(name=u'ss-CSI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_m_CSI = SEQ(name=u'm-CSI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CAMEL_SubscriptionInfo_specificCSIDeletedList = BIT_STR(name=u'specificCSIDeletedList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name=u'mt-sms-CSI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_mg_csi = SEQ(name=u'mg-csi', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_CSI = SEQ(name=u'o-IM-CSI', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-IM-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_IM_CSI = SEQ(name=u'd-IM-CSI', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_CSI = SEQ(name=u'vt-IM-CSI', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u'vt-IM-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    CAMEL_SubscriptionInfo._cont = ASN1Dict([
        (u'o-CSI', _CAMEL_SubscriptionInfo_o_CSI),
        (u'o-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        (u'd-CSI', _CAMEL_SubscriptionInfo_d_CSI),
        (u't-CSI', _CAMEL_SubscriptionInfo_t_CSI),
        (u't-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        (u'vt-CSI', _CAMEL_SubscriptionInfo_vt_CSI),
        (u'vt-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList),
        (u'tif-CSI', _CAMEL_SubscriptionInfo_tif_CSI),
        (u'tif-CSI-NotificationToCSE', _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE),
        (u'gprs-CSI', _CAMEL_SubscriptionInfo_gprs_CSI),
        (u'mo-sms-CSI', _CAMEL_SubscriptionInfo_mo_sms_CSI),
        (u'ss-CSI', _CAMEL_SubscriptionInfo_ss_CSI),
        (u'm-CSI', _CAMEL_SubscriptionInfo_m_CSI),
        (u'extensionContainer', _CAMEL_SubscriptionInfo_extensionContainer),
        (u'specificCSIDeletedList', _CAMEL_SubscriptionInfo_specificCSIDeletedList),
        (u'mt-sms-CSI', _CAMEL_SubscriptionInfo_mt_sms_CSI),
        (u'mt-smsCAMELTDP-CriteriaList', _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        (u'mg-csi', _CAMEL_SubscriptionInfo_mg_csi),
        (u'o-IM-CSI', _CAMEL_SubscriptionInfo_o_IM_CSI),
        (u'o-IM-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList),
        (u'd-IM-CSI', _CAMEL_SubscriptionInfo_d_IM_CSI),
        (u'vt-IM-CSI', _CAMEL_SubscriptionInfo_vt_IM_CSI),
        (u'vt-IM-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList),
        ])
    CAMEL_SubscriptionInfo._ext = [u'specificCSIDeletedList', u'mt-sms-CSI', u'mt-smsCAMELTDP-CriteriaList', u'mg-csi', u'o-IM-CSI', u'o-IM-BcsmCamelTDP-CriteriaList', u'd-IM-CSI', u'vt-IM-CSI', u'vt-IM-BCSM-CAMEL-TDP-CriteriaList']
    
    #-----< AnyTimeModificationArg >-----#
    AnyTimeModificationArg = SEQ(name=u'AnyTimeModificationArg', mode=MODE_TYPE)
    _AnyTimeModificationArg_subscriberIdentity = CHOICE(name=u'subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeModificationArg_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeModificationArg_modificationRequestFor_CF_Info = SEQ(name=u'modificationRequestFor-CF-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CF-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CB_Info = SEQ(name=u'modificationRequestFor-CB-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CB-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSI = SEQ(name=u'modificationRequestFor-CSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSI')), opt=True)
    _AnyTimeModificationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ODB_data = SEQ(name=u'modificationRequestFor-ODB-data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ODB-data')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data = SEQ(name=u'modificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-IP-SM-GW-Data')), opt=True)
    _AnyTimeModificationArg_activationRequestForUE_reachability = BIT_STR(name=u'activationRequestForUE-reachability', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedServingNode')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSG = SEQ(name=u'modificationRequestFor-CSG', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSG')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CW_Data = SEQ(name=u'modificationRequestFor-CW-Data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CW-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIP_Data = SEQ(name=u'modificationRequestFor-CLIP-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIP-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIR_Data = SEQ(name=u'modificationRequestFor-CLIR-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIR-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_HOLD_Data = SEQ(name=u'modificationRequestFor-HOLD-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CH-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ECT_Data = SEQ(name=u'modificationRequestFor-ECT-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ECT-Info')), opt=True)
    AnyTimeModificationArg._cont = ASN1Dict([
        (u'subscriberIdentity', _AnyTimeModificationArg_subscriberIdentity),
        (u'gsmSCF-Address', _AnyTimeModificationArg_gsmSCF_Address),
        (u'modificationRequestFor-CF-Info', _AnyTimeModificationArg_modificationRequestFor_CF_Info),
        (u'modificationRequestFor-CB-Info', _AnyTimeModificationArg_modificationRequestFor_CB_Info),
        (u'modificationRequestFor-CSI', _AnyTimeModificationArg_modificationRequestFor_CSI),
        (u'extensionContainer', _AnyTimeModificationArg_extensionContainer),
        (u'longFTN-Supported', _AnyTimeModificationArg_longFTN_Supported),
        (u'modificationRequestFor-ODB-data', _AnyTimeModificationArg_modificationRequestFor_ODB_data),
        (u'modificationRequestFor-IP-SM-GW-Data', _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data),
        (u'activationRequestForUE-reachability', _AnyTimeModificationArg_activationRequestForUE_reachability),
        (u'modificationRequestFor-CSG', _AnyTimeModificationArg_modificationRequestFor_CSG),
        (u'modificationRequestFor-CW-Data', _AnyTimeModificationArg_modificationRequestFor_CW_Data),
        (u'modificationRequestFor-CLIP-Data', _AnyTimeModificationArg_modificationRequestFor_CLIP_Data),
        (u'modificationRequestFor-CLIR-Data', _AnyTimeModificationArg_modificationRequestFor_CLIR_Data),
        (u'modificationRequestFor-HOLD-Data', _AnyTimeModificationArg_modificationRequestFor_HOLD_Data),
        (u'modificationRequestFor-ECT-Data', _AnyTimeModificationArg_modificationRequestFor_ECT_Data),
        ])
    AnyTimeModificationArg._ext = [u'modificationRequestFor-ODB-data', u'modificationRequestFor-IP-SM-GW-Data', u'activationRequestForUE-reachability', u'modificationRequestFor-CSG', u'modificationRequestFor-CW-Data', u'modificationRequestFor-CLIP-Data', u'modificationRequestFor-CLIR-Data', u'modificationRequestFor-HOLD-Data', u'modificationRequestFor-ECT-Data']
    
    #-----< ModificationRequestFor-CW-Info >-----#
    ModificationRequestFor_CW_Info = SEQ(name=u'ModificationRequestFor-CW-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CW_Info_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CW_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CW_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CW_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CW_Info._cont = ASN1Dict([
        (u'basicService', _ModificationRequestFor_CW_Info_basicService),
        (u'ss-Status', _ModificationRequestFor_CW_Info_ss_Status),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CW_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CW_Info_extensionContainer),
        ])
    ModificationRequestFor_CW_Info._ext = []
    
    #-----< ModificationRequestFor-CH-Info >-----#
    ModificationRequestFor_CH_Info = SEQ(name=u'ModificationRequestFor-CH-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CH_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CH_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CH_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CH_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_CH_Info_ss_Status),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CH_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CH_Info_extensionContainer),
        ])
    ModificationRequestFor_CH_Info._ext = []
    
    #-----< ModificationRequestFor-ECT-Info >-----#
    ModificationRequestFor_ECT_Info = SEQ(name=u'ModificationRequestFor-ECT-Info', mode=MODE_TYPE)
    _ModificationRequestFor_ECT_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_ECT_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ECT_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ECT_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_ECT_Info_ss_Status),
        (u'modifyNotificationToCSE', _ModificationRequestFor_ECT_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_ECT_Info_extensionContainer),
        ])
    ModificationRequestFor_ECT_Info._ext = []
    
    #-----< ModificationRequestFor-CLIR-Info >-----#
    ModificationRequestFor_CLIR_Info = SEQ(name=u'ModificationRequestFor-CLIR-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIR_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIR_Info_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIR_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIR_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_CLIR_Info_ss_Status),
        (u'cliRestrictionOption', _ModificationRequestFor_CLIR_Info_cliRestrictionOption),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CLIR_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIR_Info._ext = []
    
    #-----< ModificationRequestFor-CLIP-Info >-----#
    ModificationRequestFor_CLIP_Info = SEQ(name=u'ModificationRequestFor-CLIP-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIP_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIP_Info_overrideCategory = ENUM(name=u'overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')), opt=True)
    _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIP_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIP_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_CLIP_Info_ss_Status),
        (u'overrideCategory', _ModificationRequestFor_CLIP_Info_overrideCategory),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CLIP_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIP_Info._ext = []
    
    #-----< ModificationRequestFor-CSG >-----#
    ModificationRequestFor_CSG = SEQ(name=u'ModificationRequestFor-CSG', mode=MODE_TYPE)
    _ModificationRequestFor_CSG_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSG_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CSG._cont = ASN1Dict([
        (u'modifyNotificationToCSE', _ModificationRequestFor_CSG_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CSG_extensionContainer),
        ])
    ModificationRequestFor_CSG._ext = []
    
    #-----< RequestedServingNode >-----#
    RequestedServingNode = BIT_STR(name=u'RequestedServingNode', mode=MODE_TYPE)
    RequestedServingNode._cont = ASN1Dict([(u'mmeAndSgsn', 0)])
    RequestedServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServingNode >-----#
    ServingNode = BIT_STR(name=u'ServingNode', mode=MODE_TYPE)
    ServingNode._cont = ASN1Dict([(u'mme', 0), (u'sgsn', 1)])
    ServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< AnyTimeModificationRes >-----#
    AnyTimeModificationRes = SEQ(name=u'AnyTimeModificationRes', mode=MODE_TYPE)
    _AnyTimeModificationRes_ss_InfoFor_CSE = CHOICE(name=u'ss-InfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoFor-CSE')), opt=True)
    _AnyTimeModificationRes_camel_SubscriptionInfo = SEQ(name=u'camel-SubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeModificationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationRes_odb_Info = SEQ(name=u'odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeModificationRes_cw_Data = SEQ(name=u'cw-Data', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeModificationRes_ch_Data = SEQ(name=u'ch-Data', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeModificationRes_clip_Data = SEQ(name=u'clip-Data', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeModificationRes_clir_Data = SEQ(name=u'clir-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeModificationRes_ect_data = SEQ(name=u'ect-data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    _AnyTimeModificationRes_serviceCentreAddress = OCT_STR(name=u'serviceCentreAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    AnyTimeModificationRes._cont = ASN1Dict([
        (u'ss-InfoFor-CSE', _AnyTimeModificationRes_ss_InfoFor_CSE),
        (u'camel-SubscriptionInfo', _AnyTimeModificationRes_camel_SubscriptionInfo),
        (u'extensionContainer', _AnyTimeModificationRes_extensionContainer),
        (u'odb-Info', _AnyTimeModificationRes_odb_Info),
        (u'cw-Data', _AnyTimeModificationRes_cw_Data),
        (u'ch-Data', _AnyTimeModificationRes_ch_Data),
        (u'clip-Data', _AnyTimeModificationRes_clip_Data),
        (u'clir-Data', _AnyTimeModificationRes_clir_Data),
        (u'ect-data', _AnyTimeModificationRes_ect_data),
        (u'serviceCentreAddress', _AnyTimeModificationRes_serviceCentreAddress),
        ])
    AnyTimeModificationRes._ext = [u'odb-Info', u'cw-Data', u'ch-Data', u'clip-Data', u'clir-Data', u'ect-data', u'serviceCentreAddress']
    
    #-----< ModificationRequestFor-CF-Info >-----#
    ModificationRequestFor_CF_Info = SEQ(name=u'ModificationRequestFor-CF-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CF_Info_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CF_Info_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CF_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ModificationRequestFor_CF_Info_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _ModificationRequestFor_CF_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CF_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CF_Info._cont = ASN1Dict([
        (u'ss-Code', _ModificationRequestFor_CF_Info_ss_Code),
        (u'basicService', _ModificationRequestFor_CF_Info_basicService),
        (u'ss-Status', _ModificationRequestFor_CF_Info_ss_Status),
        (u'forwardedToNumber', _ModificationRequestFor_CF_Info_forwardedToNumber),
        (u'forwardedToSubaddress', _ModificationRequestFor_CF_Info_forwardedToSubaddress),
        (u'noReplyConditionTime', _ModificationRequestFor_CF_Info_noReplyConditionTime),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CF_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CF_Info_extensionContainer),
        ])
    ModificationRequestFor_CF_Info._ext = []
    
    #-----< ModificationRequestFor-CB-Info >-----#
    ModificationRequestFor_CB_Info = SEQ(name=u'ModificationRequestFor-CB-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CB_Info_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CB_Info_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CB_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CB_Info_password = STR_NUM(name=u'password', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _ModificationRequestFor_CB_Info_password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter = INT(name=u'wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _ModificationRequestFor_CB_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CB_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CB_Info._cont = ASN1Dict([
        (u'ss-Code', _ModificationRequestFor_CB_Info_ss_Code),
        (u'basicService', _ModificationRequestFor_CB_Info_basicService),
        (u'ss-Status', _ModificationRequestFor_CB_Info_ss_Status),
        (u'password', _ModificationRequestFor_CB_Info_password),
        (u'wrongPasswordAttemptsCounter', _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CB_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CB_Info_extensionContainer),
        ])
    ModificationRequestFor_CB_Info._ext = []
    
    #-----< ModificationRequestFor-ODB-data >-----#
    ModificationRequestFor_ODB_data = SEQ(name=u'ModificationRequestFor-ODB-data', mode=MODE_TYPE)
    _ModificationRequestFor_ODB_data_odb_data = SEQ(name=u'odb-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _ModificationRequestFor_ODB_data_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ODB_data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ODB_data._cont = ASN1Dict([
        (u'odb-data', _ModificationRequestFor_ODB_data_odb_data),
        (u'modifyNotificationToCSE', _ModificationRequestFor_ODB_data_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_ODB_data_extensionContainer),
        ])
    ModificationRequestFor_ODB_data._ext = []
    
    #-----< ModificationRequestFor-CSI >-----#
    ModificationRequestFor_CSI = SEQ(name=u'ModificationRequestFor-CSI', mode=MODE_TYPE)
    _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo = ENUM(name=u'requestedCamel-SubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')))
    _ModificationRequestFor_CSI_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_modifyCSI_State = ENUM(name=u'modifyCSI-State', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name=u'additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    ModificationRequestFor_CSI._cont = ASN1Dict([
        (u'requestedCamel-SubscriptionInfo', _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CSI_modifyNotificationToCSE),
        (u'modifyCSI-State', _ModificationRequestFor_CSI_modifyCSI_State),
        (u'extensionContainer', _ModificationRequestFor_CSI_extensionContainer),
        (u'additionalRequestedCAMEL-SubscriptionInfo', _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo),
        ])
    ModificationRequestFor_CSI._ext = [u'additionalRequestedCAMEL-SubscriptionInfo']
    
    #-----< ModificationRequestFor-IP-SM-GW-Data >-----#
    ModificationRequestFor_IP_SM_GW_Data = SEQ(name=u'ModificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE)
    _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus = ENUM(name=u'modifyRegistrationStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress = SEQ(name=u'ip-sm-gw-DiameterAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    ModificationRequestFor_IP_SM_GW_Data._cont = ASN1Dict([
        (u'modifyRegistrationStatus', _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus),
        (u'extensionContainer', _ModificationRequestFor_IP_SM_GW_Data_extensionContainer),
        (u'ip-sm-gw-DiameterAddress', _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress),
        ])
    ModificationRequestFor_IP_SM_GW_Data._ext = [u'ip-sm-gw-DiameterAddress']
    
    #-----< ModificationInstruction >-----#
    ModificationInstruction = ENUM(name=u'ModificationInstruction', mode=MODE_TYPE)
    ModificationInstruction._cont = ASN1Dict([(u'deactivate', 0), (u'activate', 1)])
    ModificationInstruction._ext = None
    
    #-----< NoteSubscriberDataModifiedArg >-----#
    NoteSubscriberDataModifiedArg = SEQ(name=u'NoteSubscriberDataModifiedArg', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteSubscriberDataModifiedArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE = SEQ(name=u'forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE = SEQ(name=u'callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_odb_Info = SEQ(name=u'odb-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo = SEQ(name=u'camel-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _NoteSubscriberDataModifiedArg_allInformationSent = NULL(name=u'allInformationSent', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NoteSubscriberDataModifiedArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteSubscriberDataModifiedArg_ue_reachable = BIT_STR(name=u'ue-reachable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServingNode')), opt=True)
    _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _NoteSubscriberDataModifiedArg_cw_Data = SEQ(name=u'cw-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _NoteSubscriberDataModifiedArg_ch_Data = SEQ(name=u'ch-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _NoteSubscriberDataModifiedArg_clip_Data = SEQ(name=u'clip-Data', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _NoteSubscriberDataModifiedArg_clir_Data = SEQ(name=u'clir-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _NoteSubscriberDataModifiedArg_ect_data = SEQ(name=u'ect-data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    NoteSubscriberDataModifiedArg._cont = ASN1Dict([
        (u'imsi', _NoteSubscriberDataModifiedArg_imsi),
        (u'msisdn', _NoteSubscriberDataModifiedArg_msisdn),
        (u'forwardingInfoFor-CSE', _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE),
        (u'callBarringInfoFor-CSE', _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE),
        (u'odb-Info', _NoteSubscriberDataModifiedArg_odb_Info),
        (u'camel-SubscriptionInfo', _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo),
        (u'allInformationSent', _NoteSubscriberDataModifiedArg_allInformationSent),
        (u'extensionContainer', _NoteSubscriberDataModifiedArg_extensionContainer),
        (u'ue-reachable', _NoteSubscriberDataModifiedArg_ue_reachable),
        (u'csg-SubscriptionDataList', _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList),
        (u'cw-Data', _NoteSubscriberDataModifiedArg_cw_Data),
        (u'ch-Data', _NoteSubscriberDataModifiedArg_ch_Data),
        (u'clip-Data', _NoteSubscriberDataModifiedArg_clip_Data),
        (u'clir-Data', _NoteSubscriberDataModifiedArg_clir_Data),
        (u'ect-data', _NoteSubscriberDataModifiedArg_ect_data),
        ])
    NoteSubscriberDataModifiedArg._ext = [u'ue-reachable', u'csg-SubscriptionDataList', u'cw-Data', u'ch-Data', u'clip-Data', u'clir-Data', u'ect-data']
    
    #-----< NoteSubscriberDataModifiedRes >-----#
    NoteSubscriberDataModifiedRes = SEQ(name=u'NoteSubscriberDataModifiedRes', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteSubscriberDataModifiedRes._cont = ASN1Dict([
        (u'extensionContainer', _NoteSubscriberDataModifiedRes_extensionContainer),
        ])
    NoteSubscriberDataModifiedRes._ext = []
    
    #-----< NoteMM-EventArg >-----#
    NoteMM_EventArg = SEQ(name=u'NoteMM-EventArg', mode=MODE_TYPE)
    _NoteMM_EventArg_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _NoteMM_EventArg_eventMet = OCT_STR(name=u'eventMet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    _NoteMM_EventArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMM_EventArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteMM_EventArg_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _NoteMM_EventArg_supportedCAMELPhases = BIT_STR(name=u'supportedCAMELPhases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _NoteMM_EventArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteMM_EventArg_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _NoteMM_EventArg_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    NoteMM_EventArg._cont = ASN1Dict([
        (u'serviceKey', _NoteMM_EventArg_serviceKey),
        (u'eventMet', _NoteMM_EventArg_eventMet),
        (u'imsi', _NoteMM_EventArg_imsi),
        (u'msisdn', _NoteMM_EventArg_msisdn),
        (u'locationInformation', _NoteMM_EventArg_locationInformation),
        (u'supportedCAMELPhases', _NoteMM_EventArg_supportedCAMELPhases),
        (u'extensionContainer', _NoteMM_EventArg_extensionContainer),
        (u'locationInformationGPRS', _NoteMM_EventArg_locationInformationGPRS),
        (u'offeredCamel4Functionalities', _NoteMM_EventArg_offeredCamel4Functionalities),
        ])
    NoteMM_EventArg._ext = [u'locationInformationGPRS', u'offeredCamel4Functionalities']
    
    #-----< NoteMM-EventRes >-----#
    NoteMM_EventRes = SEQ(name=u'NoteMM-EventRes', mode=MODE_TYPE)
    _NoteMM_EventRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMM_EventRes._cont = ASN1Dict([
        (u'extensionContainer', _NoteMM_EventRes_extensionContainer),
        ])
    NoteMM_EventRes._ext = []
    
    #-----< Ext-SS-InfoFor-CSE >-----#
    Ext_SS_InfoFor_CSE = CHOICE(name=u'Ext-SS-InfoFor-CSE', mode=MODE_TYPE)
    _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE = SEQ(name=u'forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')))
    _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE = SEQ(name=u'callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')))
    Ext_SS_InfoFor_CSE._cont = ASN1Dict([
        (u'forwardingInfoFor-CSE', _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE),
        (u'callBarringInfoFor-CSE', _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE),
        ])
    Ext_SS_InfoFor_CSE._ext = None
    
    #-----< Ext-ForwardingInfoFor-CSE >-----#
    Ext_ForwardingInfoFor_CSE = SEQ(name=u'Ext-ForwardingInfoFor-CSE', mode=MODE_TYPE)
    _Ext_ForwardingInfoFor_CSE_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwardingInfoFor_CSE_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwardingInfoFor_CSE_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_ForwardingInfoFor_CSE_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwardingInfoFor_CSE._cont = ASN1Dict([
        (u'ss-Code', _Ext_ForwardingInfoFor_CSE_ss_Code),
        (u'forwardingFeatureList', _Ext_ForwardingInfoFor_CSE_forwardingFeatureList),
        (u'notificationToCSE', _Ext_ForwardingInfoFor_CSE_notificationToCSE),
        (u'extensionContainer', _Ext_ForwardingInfoFor_CSE_extensionContainer),
        ])
    Ext_ForwardingInfoFor_CSE._ext = []
    
    #-----< Ext-CallBarringInfoFor-CSE >-----#
    Ext_CallBarringInfoFor_CSE = SEQ(name=u'Ext-CallBarringInfoFor-CSE', mode=MODE_TYPE)
    _Ext_CallBarringInfoFor_CSE_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarringInfoFor_CSE_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarringInfoFor_CSE_password = STR_NUM(name=u'password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _Ext_CallBarringInfoFor_CSE_password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter = INT(name=u'wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _Ext_CallBarringInfoFor_CSE_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_CallBarringInfoFor_CSE_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringInfoFor_CSE._cont = ASN1Dict([
        (u'ss-Code', _Ext_CallBarringInfoFor_CSE_ss_Code),
        (u'callBarringFeatureList', _Ext_CallBarringInfoFor_CSE_callBarringFeatureList),
        (u'password', _Ext_CallBarringInfoFor_CSE_password),
        (u'wrongPasswordAttemptsCounter', _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter),
        (u'notificationToCSE', _Ext_CallBarringInfoFor_CSE_notificationToCSE),
        (u'extensionContainer', _Ext_CallBarringInfoFor_CSE_extensionContainer),
        ])
    Ext_CallBarringInfoFor_CSE._ext = []
    
    #-----< UpdateVcsgLocationArg >-----#
    UpdateVcsgLocationArg = SEQ(name=u'UpdateVcsgLocationArg', mode=MODE_TYPE)
    _UpdateVcsgLocationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateVcsgLocationArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationArg._cont = ASN1Dict([
        (u'imsi', _UpdateVcsgLocationArg_imsi),
        (u'msisdn', _UpdateVcsgLocationArg_msisdn),
        (u'vlr-Number', _UpdateVcsgLocationArg_vlr_Number),
        (u'sgsn-Number', _UpdateVcsgLocationArg_sgsn_Number),
        (u'extensionContainer', _UpdateVcsgLocationArg_extensionContainer),
        ])
    UpdateVcsgLocationArg._ext = []
    
    #-----< UpdateVcsgLocationRes >-----#
    UpdateVcsgLocationRes = SEQ(name=u'UpdateVcsgLocationRes', mode=MODE_TYPE)
    _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator = NULL(name=u'temporaryEmptySubscriptiondataIndicator', mode=MODE_TYPE, opt=True)
    _UpdateVcsgLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationRes._cont = ASN1Dict([
        (u'temporaryEmptySubscriptiondataIndicator', _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator),
        (u'extensionContainer', _UpdateVcsgLocationRes_extensionContainer),
        ])
    UpdateVcsgLocationRes._ext = []
    
    #-----< CancelVcsgLocationArg >-----#
    CancelVcsgLocationArg = SEQ(name=u'CancelVcsgLocationArg', mode=MODE_TYPE)
    _CancelVcsgLocationArg_identity = CHOICE(name=u'identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelVcsgLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationArg._cont = ASN1Dict([
        (u'identity', _CancelVcsgLocationArg_identity),
        (u'extensionContainer', _CancelVcsgLocationArg_extensionContainer),
        ])
    CancelVcsgLocationArg._ext = []
    
    #-----< CancelVcsgLocationRes >-----#
    CancelVcsgLocationRes = SEQ(name=u'CancelVcsgLocationRes', mode=MODE_TYPE)
    _CancelVcsgLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationRes._cont = ASN1Dict([
        (u'extensionContainer', _CancelVcsgLocationRes_extensionContainer),
        ])
    CancelVcsgLocationRes._ext = []
    
    _all_ = [
        _UpdateLocationArg_imsi,
        _UpdateLocationArg_msc_Number,
        _UpdateLocationArg_vlr_Number,
        _UpdateLocationArg_lmsi,
        _UpdateLocationArg_extensionContainer,
        _UpdateLocationArg_vlr_Capability,
        _UpdateLocationArg_informPreviousNetworkEntity,
        _UpdateLocationArg_cs_LCS_NotSupportedByUE,
        _UpdateLocationArg_v_gmlc_Address,
        _UpdateLocationArg_add_info,
        _UpdateLocationArg_pagingArea,
        _UpdateLocationArg_skipSubscriberDataUpdate,
        _UpdateLocationArg_restorationIndicator,
        _UpdateLocationArg_eplmn_List,
        _UpdateLocationArg_mme_DiameterAddress,
        UpdateLocationArg,
        _VLR_Capability_supportedCamelPhases,
        _VLR_Capability_extensionContainer,
        _VLR_Capability_solsaSupportIndicator,
        _VLR_Capability_istSupportIndicator,
        _VLR_Capability_superChargerSupportedInServingNetworkEntity,
        _VLR_Capability_longFTN_Supported,
        _VLR_Capability_supportedLCS_CapabilitySets,
        _VLR_Capability_offeredCamel4CSIs,
        _VLR_Capability_supportedRAT_TypesIndicator,
        _VLR_Capability_longGroupID_Supported,
        _VLR_Capability_mtRoamingForwardingSupported,
        _VLR_Capability_msisdn_lessOperation_Supported,
        _VLR_Capability_reset_ids_Supported,
        VLR_Capability,
        SupportedRAT_Types,
        _SuperChargerInfo_sendSubscriberData,
        _SuperChargerInfo_subscriberDataStored,
        SuperChargerInfo,
        AgeIndicator,
        IST_SupportIndicator,
        SupportedLCS_CapabilitySets,
        _UpdateLocationRes_hlr_Number,
        _UpdateLocationRes_extensionContainer,
        _UpdateLocationRes_add_Capability,
        _UpdateLocationRes_pagingArea_Capability,
        UpdateLocationRes,
        _ADD_Info_imeisv,
        _ADD_Info_skipSubscriberDataUpdate,
        ADD_Info,
        _PagingArea__item_,
        PagingArea,
        _LocationArea_laiFixedLength,
        _LocationArea_lac,
        LocationArea,
        LAC,
        _CancelLocationArg_identity,
        _CancelLocationArg_cancellationType,
        _CancelLocationArg_extensionContainer,
        _CancelLocationArg_typeOfUpdate,
        _CancelLocationArg_mtrf_SupportedAndAuthorized,
        _CancelLocationArg_mtrf_SupportedAndNotAuthorized,
        _CancelLocationArg_newMSC_Number,
        _CancelLocationArg_newVLR_Number,
        _CancelLocationArg_new_lmsi,
        _CancelLocationArg_reattach_Required,
        CancelLocationArg,
        TypeOfUpdate,
        CancellationType,
        _CancelLocationRes_extensionContainer,
        CancelLocationRes,
        _PurgeMS_Arg_imsi,
        _PurgeMS_Arg_vlr_Number,
        _PurgeMS_Arg_sgsn_Number,
        _PurgeMS_Arg_extensionContainer,
        _PurgeMS_Arg_locationInformation,
        _PurgeMS_Arg_locationInformationGPRS,
        _PurgeMS_Arg_locationInformationEPS,
        PurgeMS_Arg,
        _PurgeMS_Res_freezeTMSI,
        _PurgeMS_Res_freezeP_TMSI,
        _PurgeMS_Res_extensionContainer,
        _PurgeMS_Res_freezeM_TMSI,
        PurgeMS_Res,
        _SendIdentificationArg_tmsi,
        _SendIdentificationArg_numberOfRequestedVectors,
        _SendIdentificationArg_segmentationProhibited,
        _SendIdentificationArg_extensionContainer,
        _SendIdentificationArg_msc_Number,
        _SendIdentificationArg_previous_LAI,
        _SendIdentificationArg_hopCounter,
        _SendIdentificationArg_mtRoamingForwardingSupported,
        _SendIdentificationArg_newVLR_Number,
        _SendIdentificationArg_new_lmsi,
        SendIdentificationArg,
        HopCounter,
        _SendIdentificationRes_imsi,
        _SendIdentificationRes_authenticationSetList,
        _SendIdentificationRes_currentSecurityContext,
        _SendIdentificationRes_extensionContainer,
        _SendIdentificationRes_lastUsedLtePLMN_Id,
        _SendIdentificationRes_mtCallPendingFlag,
        SendIdentificationRes,
        _AuthenticationSetList_tripletList,
        _AuthenticationSetList_quintupletList,
        AuthenticationSetList,
        _TripletList__item_,
        TripletList,
        _QuintupletList__item_,
        QuintupletList,
        _AuthenticationTriplet_rand,
        _AuthenticationTriplet_sres,
        _AuthenticationTriplet_kc,
        AuthenticationTriplet,
        _AuthenticationQuintuplet_rand,
        _AuthenticationQuintuplet_xres,
        _AuthenticationQuintuplet_ck,
        _AuthenticationQuintuplet_ik,
        _AuthenticationQuintuplet_autn,
        AuthenticationQuintuplet,
        _CurrentSecurityContext_gsm_SecurityContextData,
        _CurrentSecurityContext_umts_SecurityContextData,
        CurrentSecurityContext,
        _GSM_SecurityContextData_kc,
        _GSM_SecurityContextData_cksn,
        GSM_SecurityContextData,
        _UMTS_SecurityContextData_ck,
        _UMTS_SecurityContextData_ik,
        _UMTS_SecurityContextData_ksi,
        UMTS_SecurityContextData,
        RAND,
        SRES,
        Kc,
        XRES,
        CK,
        IK,
        AUTN,
        AUTS,
        Cksn,
        KSI,
        _AuthenticationFailureReportArg_imsi,
        _AuthenticationFailureReportArg_failureCause,
        _AuthenticationFailureReportArg_extensionContainer,
        _AuthenticationFailureReportArg_re_attempt,
        _AuthenticationFailureReportArg_accessType,
        _AuthenticationFailureReportArg_rand,
        _AuthenticationFailureReportArg_vlr_Number,
        _AuthenticationFailureReportArg_sgsn_Number,
        AuthenticationFailureReportArg,
        AccessType,
        _AuthenticationFailureReportRes_extensionContainer,
        AuthenticationFailureReportRes,
        FailureCause,
        _UpdateGprsLocationArg_imsi,
        _UpdateGprsLocationArg_sgsn_Number,
        _UpdateGprsLocationArg_sgsn_Address,
        _UpdateGprsLocationArg_extensionContainer,
        _UpdateGprsLocationArg_sgsn_Capability,
        _UpdateGprsLocationArg_informPreviousNetworkEntity,
        _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE,
        _UpdateGprsLocationArg_v_gmlc_Address,
        _UpdateGprsLocationArg_add_info,
        _UpdateGprsLocationArg_eps_info,
        _UpdateGprsLocationArg_servingNodeTypeIndicator,
        _UpdateGprsLocationArg_skipSubscriberDataUpdate,
        _UpdateGprsLocationArg_usedRAT_Type,
        _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_nodeTypeIndicator,
        _UpdateGprsLocationArg_areaRestricted,
        _UpdateGprsLocationArg_ue_reachableIndicator,
        _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_ue_srvcc_Capability,
        _UpdateGprsLocationArg_eplmn_List,
        _UpdateGprsLocationArg_mmeNumberforMTSMS,
        _UpdateGprsLocationArg_smsRegisterRequest,
        _UpdateGprsLocationArg_sms_Only,
        _UpdateGprsLocationArg_removalofMMERegistrationforSMS,
        _UpdateGprsLocationArg_sgsn_Name,
        _UpdateGprsLocationArg_sgsn_Realm,
        _UpdateGprsLocationArg_lgd_supportIndicator,
        _UpdateGprsLocationArg_adjacentPLMN_List,
        UpdateGprsLocationArg,
        SMSRegisterRequest,
        Used_RAT_Type,
        _EPS_Info_pdn_gw_update,
        _EPS_Info_isr_Information,
        EPS_Info,
        _PDN_GW_Update_apn,
        _PDN_GW_Update_pdn_gw_Identity,
        _PDN_GW_Update_contextId,
        _PDN_GW_Update_extensionContainer,
        PDN_GW_Update,
        ISR_Information,
        _SGSN_Capability_solsaSupportIndicator,
        _SGSN_Capability_extensionContainer,
        _SGSN_Capability_superChargerSupportedInServingNetworkEntity,
        _SGSN_Capability_gprsEnhancementsSupportIndicator,
        _SGSN_Capability_supportedCamelPhases,
        _SGSN_Capability_supportedLCS_CapabilitySets,
        _SGSN_Capability_offeredCamel4CSIs,
        _SGSN_Capability_smsCallBarringSupportIndicator,
        _SGSN_Capability_supportedRAT_TypesIndicator,
        _SGSN_Capability_supportedFeatures,
        _SGSN_Capability_t_adsDataRetrieval,
        _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_cancellationTypeInitialAttach,
        _SGSN_Capability_msisdn_lessOperation_Supported,
        _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_reset_ids_Supported,
        _SGSN_Capability_ext_SupportedFeatures,
        SGSN_Capability,
        SupportedFeatures,
        Ext_SupportedFeatures,
        UE_SRVCC_Capability,
        _UpdateGprsLocationRes_hlr_Number,
        _UpdateGprsLocationRes_extensionContainer,
        _UpdateGprsLocationRes_add_Capability,
        _UpdateGprsLocationRes_sgsn_mmeSeparationSupported,
        _UpdateGprsLocationRes_mmeRegisteredforSMS,
        UpdateGprsLocationRes,
        _EPLMN_List__item_,
        EPLMN_List,
        _AdjacentPLMN_List__item_,
        AdjacentPLMN_List,
        _ForwardAccessSignalling_Arg_an_APDU,
        _ForwardAccessSignalling_Arg_integrityProtectionInfo,
        _ForwardAccessSignalling_Arg_encryptionInfo,
        _ForwardAccessSignalling_Arg_keyStatus,
        _ForwardAccessSignalling_Arg_allowedGSM_Algorithms,
        _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms,
        _ForwardAccessSignalling_Arg_radioResourceInformation,
        _ForwardAccessSignalling_Arg_extensionContainer,
        _ForwardAccessSignalling_Arg_radioResourceList,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandover,
        _ForwardAccessSignalling_Arg_ranap_ServiceHandover,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList,
        _ForwardAccessSignalling_Arg_currentlyUsedCodec,
        _ForwardAccessSignalling_Arg_iuSupportedCodecsList,
        _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator,
        _ForwardAccessSignalling_Arg_iuSelectedCodec,
        _ForwardAccessSignalling_Arg_alternativeChannelType,
        _ForwardAccessSignalling_Arg_tracePropagationList,
        _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor,
        _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ForwardAccessSignalling_Arg_uesbi_Iu,
        _ForwardAccessSignalling_Arg_imeisv,
        ForwardAccessSignalling_Arg,
        AllowedGSM_Algorithms,
        _AllowedUMTS_Algorithms_integrityProtectionAlgorithms,
        _AllowedUMTS_Algorithms_encryptionAlgorithms,
        _AllowedUMTS_Algorithms_extensionContainer,
        AllowedUMTS_Algorithms,
        PermittedIntegrityProtectionAlgorithms,
        maxPermittedIntegrityProtectionAlgorithmsLength,
        PermittedEncryptionAlgorithms,
        maxPermittedEncryptionAlgorithmsLength,
        KeyStatus,
        _PrepareHO_Arg_targetCellId,
        _PrepareHO_Arg_ho_NumberNotRequired,
        _PrepareHO_Arg_targetRNCId,
        _PrepareHO_Arg_an_APDU,
        _PrepareHO_Arg_multipleBearerRequested,
        _PrepareHO_Arg_imsi,
        _PrepareHO_Arg_integrityProtectionInfo,
        _PrepareHO_Arg_encryptionInfo,
        _PrepareHO_Arg_radioResourceInformation,
        _PrepareHO_Arg_allowedGSM_Algorithms,
        _PrepareHO_Arg_allowedUMTS_Algorithms,
        _PrepareHO_Arg_radioResourceList,
        _PrepareHO_Arg_extensionContainer,
        _PrepareHO_Arg_rab_Id,
        _PrepareHO_Arg_bssmap_ServiceHandover,
        _PrepareHO_Arg_ranap_ServiceHandover,
        _PrepareHO_Arg_bssmap_ServiceHandoverList,
        _PrepareHO_Arg_asciCallReference,
        _PrepareHO_Arg_geran_classmark,
        _PrepareHO_Arg_iuCurrentlyUsedCodec,
        _PrepareHO_Arg_iuSupportedCodecsList,
        _PrepareHO_Arg_rab_ConfigurationIndicator,
        _PrepareHO_Arg_uesbi_Iu,
        _PrepareHO_Arg_imeisv,
        _PrepareHO_Arg_alternativeChannelType,
        _PrepareHO_Arg_tracePropagationList,
        _PrepareHO_Arg_aoipSupportedCodecsListAnchor,
        _PrepareHO_Arg_regionalSubscriptionData,
        _PrepareHO_Arg_lclsGlobalCallReference,
        _PrepareHO_Arg_lcls_Negotiation,
        _PrepareHO_Arg_lcls_Configuration_Preference,
        _PrepareHO_Arg_csg_SubscriptionDataList,
        PrepareHO_Arg,
        LCLS_GlobalCallReference,
        LCLS_Negotiation,
        LCLS_ConfigurationPreference,
        _BSSMAP_ServiceHandoverList__item_,
        BSSMAP_ServiceHandoverList,
        _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover,
        _BSSMAP_ServiceHandoverInfo_rab_Id,
        BSSMAP_ServiceHandoverInfo,
        maxNumOfServiceHandovers,
        BSSMAP_ServiceHandover,
        RANAP_ServiceHandover,
        _RadioResourceList__item_,
        RadioResourceList,
        _RadioResource_radioResourceInformation,
        _RadioResource_rab_Id,
        RadioResource,
        maxNumOfRadioResources,
        _PrepareHO_Res_handoverNumber,
        _PrepareHO_Res_relocationNumberList,
        _PrepareHO_Res_an_APDU,
        _PrepareHO_Res_multicallBearerInfo,
        _PrepareHO_Res_multipleBearerNotSupported,
        _PrepareHO_Res_selectedUMTS_Algorithms,
        _PrepareHO_Res_chosenRadioResourceInformation,
        _PrepareHO_Res_extensionContainer,
        _PrepareHO_Res_iuSelectedCodec,
        _PrepareHO_Res_iuAvailableCodecsList,
        _PrepareHO_Res_aoipSelectedCodecTarget,
        _PrepareHO_Res_aoipAvailableCodecsListMap,
        PrepareHO_Res,
        _SelectedUMTS_Algorithms_integrityProtectionAlgorithm,
        _SelectedUMTS_Algorithms_encryptionAlgorithm,
        _SelectedUMTS_Algorithms_extensionContainer,
        SelectedUMTS_Algorithms,
        ChosenIntegrityProtectionAlgorithm,
        ChosenEncryptionAlgorithm,
        _ChosenRadioResourceInformation_chosenChannelInfo,
        _ChosenRadioResourceInformation_chosenSpeechVersion,
        ChosenRadioResourceInformation,
        ChosenChannelInfo,
        ChosenSpeechVersion,
        _PrepareSubsequentHO_Arg_targetCellId,
        _PrepareSubsequentHO_Arg_targetMSC_Number,
        _PrepareSubsequentHO_Arg_targetRNCId,
        _PrepareSubsequentHO_Arg_an_APDU,
        _PrepareSubsequentHO_Arg_selectedRab_Id,
        _PrepareSubsequentHO_Arg_extensionContainer,
        _PrepareSubsequentHO_Arg_geran_classmark,
        _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator,
        PrepareSubsequentHO_Arg,
        _PrepareSubsequentHO_Res_an_APDU,
        _PrepareSubsequentHO_Res_extensionContainer,
        PrepareSubsequentHO_Res,
        _ProcessAccessSignalling_Arg_an_APDU,
        _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms,
        _ProcessAccessSignalling_Arg_selectedGSM_Algorithm,
        _ProcessAccessSignalling_Arg_chosenRadioResourceInformation,
        _ProcessAccessSignalling_Arg_selectedRab_Id,
        _ProcessAccessSignalling_Arg_extensionContainer,
        _ProcessAccessSignalling_Arg_iUSelectedCodec,
        _ProcessAccessSignalling_Arg_iuAvailableCodecsList,
        _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap,
        ProcessAccessSignalling_Arg,
        _AoIPCodecsList_codec1,
        _AoIPCodecsList_codec2,
        _AoIPCodecsList_codec3,
        _AoIPCodecsList_codec4,
        _AoIPCodecsList_codec5,
        _AoIPCodecsList_codec6,
        _AoIPCodecsList_codec7,
        _AoIPCodecsList_codec8,
        _AoIPCodecsList_extensionContainer,
        AoIPCodecsList,
        AoIPCodec,
        _SupportedCodecsList_utranCodecList,
        _SupportedCodecsList_geranCodecList,
        _SupportedCodecsList_extensionContainer,
        SupportedCodecsList,
        _CodecList_codec1,
        _CodecList_codec2,
        _CodecList_codec3,
        _CodecList_codec4,
        _CodecList_codec5,
        _CodecList_codec6,
        _CodecList_codec7,
        _CodecList_codec8,
        _CodecList_extensionContainer,
        CodecList,
        Codec,
        GERAN_Classmark,
        SelectedGSM_Algorithm,
        _SendEndSignal_Arg_an_APDU,
        _SendEndSignal_Arg_extensionContainer,
        SendEndSignal_Arg,
        _SendEndSignal_Res_extensionContainer,
        SendEndSignal_Res,
        RNCId,
        _RelocationNumberList__item_,
        RelocationNumberList,
        MulticallBearerInfo,
        _RelocationNumber_handoverNumber,
        _RelocationNumber_rab_Id,
        RelocationNumber,
        RAB_Id,
        maxNrOfRABs,
        maxNumOfRelocationNumber,
        RadioResourceInformation,
        IntegrityProtectionInformation,
        maxNumOfIntegrityInfo,
        EncryptionInformation,
        maxNumOfEncryptionInfo,
        _SendAuthenticationInfoArg_imsi,
        _SendAuthenticationInfoArg_numberOfRequestedVectors,
        _SendAuthenticationInfoArg_segmentationProhibited,
        _SendAuthenticationInfoArg_immediateResponsePreferred,
        _SendAuthenticationInfoArg_re_synchronisationInfo,
        _SendAuthenticationInfoArg_extensionContainer,
        _SendAuthenticationInfoArg_requestingNodeType,
        _SendAuthenticationInfoArg_requestingPLMN_Id,
        _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors,
        _SendAuthenticationInfoArg_additionalVectorsAreForEPS,
        _SendAuthenticationInfoArg_ueUsageTypeRequestIndication,
        SendAuthenticationInfoArg,
        NumberOfRequestedVectors,
        _Re_synchronisationInfo_rand,
        _Re_synchronisationInfo_auts,
        Re_synchronisationInfo,
        _SendAuthenticationInfoRes_authenticationSetList,
        _SendAuthenticationInfoRes_extensionContainer,
        _SendAuthenticationInfoRes_eps_AuthenticationSetList,
        _SendAuthenticationInfoRes_ueUsageType,
        SendAuthenticationInfoRes,
        _EPS_AuthenticationSetList__item_,
        EPS_AuthenticationSetList,
        UE_UsageType,
        _EPC_AV_rand,
        _EPC_AV_xres,
        _EPC_AV_autn,
        _EPC_AV_kasme,
        _EPC_AV_extensionContainer,
        EPC_AV,
        KASME,
        RequestingNodeType,
        _CheckIMEI_Arg_imei,
        _CheckIMEI_Arg_requestedEquipmentInfo,
        _CheckIMEI_Arg_extensionContainer,
        CheckIMEI_Arg,
        _CheckIMEI_Res_equipmentStatus,
        _CheckIMEI_Res_bmuef,
        _CheckIMEI_Res_extensionContainer,
        CheckIMEI_Res,
        RequestedEquipmentInfo,
        _UESBI_Iu_uesbi_IuA,
        _UESBI_Iu_uesbi_IuB,
        UESBI_Iu,
        UESBI_IuA,
        UESBI_IuB,
        EquipmentStatus,
        _InsertSubscriberDataArg_imsi,
        _InsertSubscriberDataArg_msisdn,
        _InsertSubscriberDataArg_category,
        _InsertSubscriberDataArg_subscriberStatus,
        _InsertSubscriberDataArg_bearerServiceList,
        _InsertSubscriberDataArg_teleserviceList,
        _InsertSubscriberDataArg_provisionedSS,
        _InsertSubscriberDataArg_odb_Data,
        _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _InsertSubscriberDataArg_regionalSubscriptionData,
        _InsertSubscriberDataArg_vbsSubscriptionData,
        _InsertSubscriberDataArg_vgcsSubscriptionData,
        _InsertSubscriberDataArg_vlrCamelSubscriptionInfo,
        _InsertSubscriberDataArg_extensionContainer,
        _InsertSubscriberDataArg_naea_PreferredCI,
        _InsertSubscriberDataArg_gprsSubscriptionData,
        _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature,
        _InsertSubscriberDataArg_networkAccessMode,
        _InsertSubscriberDataArg_lsaInformation,
        _InsertSubscriberDataArg_lmu_Indicator,
        _InsertSubscriberDataArg_lcsInformation,
        _InsertSubscriberDataArg_istAlertTimer,
        _InsertSubscriberDataArg_superChargerSupportedInHLR,
        _InsertSubscriberDataArg_mc_SS_Info,
        _InsertSubscriberDataArg_cs_AllocationRetentionPriority,
        _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo,
        _InsertSubscriberDataArg_chargingCharacteristics,
        _InsertSubscriberDataArg_accessRestrictionData,
        _InsertSubscriberDataArg_ics_Indicator,
        _InsertSubscriberDataArg_eps_SubscriptionData,
        _InsertSubscriberDataArg_csg_SubscriptionDataList,
        _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator,
        _InsertSubscriberDataArg_sgsn_Number,
        _InsertSubscriberDataArg_mme_Name,
        _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer,
        _InsertSubscriberDataArg_vplmnLIPAAllowed,
        _InsertSubscriberDataArg_mdtUserConsent,
        _InsertSubscriberDataArg_subscribedPeriodicLAUtimer,
        _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList,
        _InsertSubscriberDataArg_additionalMSISDN,
        _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision,
        _InsertSubscriberDataArg_smsInSGSNAllowed,
        _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator,
        _InsertSubscriberDataArg_pcscf_Restoration_Request,
        _InsertSubscriberDataArg_adjacentAccessRestrictionDataList,
        _InsertSubscriberDataArg_imsi_Group_Id_List,
        _InsertSubscriberDataArg_ueUsageType,
        _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator,
        _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count,
        _InsertSubscriberDataArg_reset_Id_List,
        _InsertSubscriberDataArg_eDRX_Cycle_Length_List,
        _InsertSubscriberDataArg_ext_AccessRestrictionData,
        _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator,
        InsertSubscriberDataArg,
        _EDRX_Cycle_Length_List__item_,
        EDRX_Cycle_Length_List,
        _EDRX_Cycle_Length_rat_Type,
        _EDRX_Cycle_Length_eDRX_Cycle_Length_Value,
        EDRX_Cycle_Length,
        EDRX_Cycle_Length_Value,
        _Reset_Id_List__item_,
        Reset_Id_List,
        Reset_Id,
        DL_Buffering_Suggested_Packet_Count,
        Group_Service_ID,
        Local_GroupID,
        _IMSI_GroupIdList__item_,
        IMSI_GroupIdList,
        _IMSI_GroupId_group_Service_Id,
        _IMSI_GroupId_plmnId,
        _IMSI_GroupId_local_Group_ID,
        IMSI_GroupId,
        SubscribedPeriodicRAUTAUtimer,
        SubscribedPeriodicLAUtimer,
        _CSG_SubscriptionDataList__item_,
        CSG_SubscriptionDataList,
        _CSG_SubscriptionData_csg_Id,
        _CSG_SubscriptionData_expirationDate,
        _CSG_SubscriptionData_extensionContainer,
        _CSG_SubscriptionData_lipa_AllowedAPNList,
        _CSG_SubscriptionData_plmn_Id,
        CSG_SubscriptionData,
        _VPLMN_CSG_SubscriptionDataList__item_,
        VPLMN_CSG_SubscriptionDataList,
        CSG_Id,
        _LIPA_AllowedAPNList__item_,
        LIPA_AllowedAPNList,
        maxNumOfLIPAAllowedAPN,
        _EPS_SubscriptionData_apn_oi_Replacement,
        _EPS_SubscriptionData_rfsp_id,
        _EPS_SubscriptionData_ambr,
        _EPS_SubscriptionData_apn_ConfigurationProfile,
        _EPS_SubscriptionData_stn_sr,
        _EPS_SubscriptionData_extensionContainer,
        _EPS_SubscriptionData_mps_CSPriority,
        _EPS_SubscriptionData_mps_EPSPriority,
        _EPS_SubscriptionData_subscribed_vsrvcc,
        EPS_SubscriptionData,
        APN_OI_Replacement,
        RFSP_ID,
        _APN_ConfigurationProfile_defaultContext,
        _APN_ConfigurationProfile_completeDataListIncluded,
        _APN_ConfigurationProfile_epsDataList,
        _APN_ConfigurationProfile_extensionContainer,
        _APN_ConfigurationProfile_additionalDefaultContext,
        APN_ConfigurationProfile,
        _EPS_DataList__item_,
        EPS_DataList,
        maxNumOfAPN_Configurations,
        _APN_Configuration_contextId,
        _APN_Configuration_pdn_Type,
        _APN_Configuration_servedPartyIP_IPv4_Address,
        _APN_Configuration_apn,
        _APN_Configuration_eps_qos_Subscribed,
        _APN_Configuration_pdn_gw_Identity,
        _APN_Configuration_pdn_gw_AllocationType,
        _APN_Configuration_vplmnAddressAllowed,
        _APN_Configuration_chargingCharacteristics,
        _APN_Configuration_ambr,
        _APN_Configuration_specificAPNInfoList,
        _APN_Configuration_extensionContainer,
        _APN_Configuration_servedPartyIP_IPv6_Address,
        _APN_Configuration_apn_oi_Replacement,
        _APN_Configuration_sipto_Permission,
        _APN_Configuration_lipa_Permission,
        _APN_Configuration_restoration_Priority,
        _APN_Configuration_sipto_local_network_Permission,
        _APN_Configuration_wlan_offloadability,
        _APN_Configuration_non_IP_PDN_Type_Indicator,
        _APN_Configuration_nIDD_Mechanism,
        _APN_Configuration_sCEF_ID,
        _APN_Configuration_pdn_ConnectionContinuity,
        APN_Configuration,
        PDN_ConnectionContinuity,
        NIDD_Mechanism,
        PDN_Type,
        _EPS_QoS_Subscribed_qos_Class_Identifier,
        _EPS_QoS_Subscribed_allocation_Retention_Priority,
        _EPS_QoS_Subscribed_extensionContainer,
        EPS_QoS_Subscribed,
        _AMBR_max_RequestedBandwidth_UL,
        _AMBR_max_RequestedBandwidth_DL,
        _AMBR_extensionContainer,
        _AMBR_extended_Max_RequestedBandwidth_UL,
        _AMBR_extended_Max_RequestedBandwidth_DL,
        AMBR,
        _SpecificAPNInfoList__item_,
        SpecificAPNInfoList,
        maxNumOfSpecificAPNInfos,
        _SpecificAPNInfo_apn,
        _SpecificAPNInfo_pdn_gw_Identity,
        _SpecificAPNInfo_extensionContainer,
        SpecificAPNInfo,
        Bandwidth,
        BandwidthExt,
        QoS_Class_Identifier,
        _Allocation_Retention_Priority_priority_level,
        _Allocation_Retention_Priority_pre_emption_capability,
        _Allocation_Retention_Priority_pre_emption_vulnerability,
        _Allocation_Retention_Priority_extensionContainer,
        Allocation_Retention_Priority,
        _PDN_GW_Identity_pdn_gw_ipv4_Address,
        _PDN_GW_Identity_pdn_gw_ipv6_Address,
        _PDN_GW_Identity_pdn_gw_name,
        _PDN_GW_Identity_extensionContainer,
        PDN_GW_Identity,
        FQDN,
        PDN_GW_AllocationType,
        _WLAN_Offloadability_wlan_offloadability_EUTRAN,
        _WLAN_Offloadability_wlan_offloadability_UTRAN,
        _WLAN_Offloadability_extensionContainer,
        WLAN_Offloadability,
        WLAN_Offloadability_Indication,
        AccessRestrictionData,
        Ext_AccessRestrictionData,
        _AdjacentAccessRestrictionDataList__item_,
        AdjacentAccessRestrictionDataList,
        _AdjacentAccessRestrictionData_plmnId,
        _AdjacentAccessRestrictionData_accessRestrictionData,
        _AdjacentAccessRestrictionData_ext_AccessRestrictionData,
        AdjacentAccessRestrictionData,
        CS_AllocationRetentionPriority,
        IST_AlertTimerValue,
        _LCSInformation_gmlc_List,
        _LCSInformation_lcs_PrivacyExceptionList,
        _LCSInformation_molr_List,
        _LCSInformation_add_lcs_PrivacyExceptionList,
        LCSInformation,
        _GMLC_List__item_,
        GMLC_List,
        maxNumOfGMLC,
        NetworkAccessMode,
        _GPRSDataList__item_,
        GPRSDataList,
        maxNumOfPDP_Contexts,
        _PDP_Context_pdp_ContextId,
        _PDP_Context_pdp_Type,
        _PDP_Context_pdp_Address,
        _PDP_Context_qos_Subscribed,
        _PDP_Context_vplmnAddressAllowed,
        _PDP_Context_apn,
        _PDP_Context_extensionContainer,
        _PDP_Context_ext_QoS_Subscribed,
        _PDP_Context_pdp_ChargingCharacteristics,
        _PDP_Context_ext2_QoS_Subscribed,
        _PDP_Context_ext3_QoS_Subscribed,
        _PDP_Context_ext4_QoS_Subscribed,
        _PDP_Context_apn_oi_Replacement,
        _PDP_Context_ext_pdp_Type,
        _PDP_Context_ext_pdp_Address,
        _PDP_Context_ambr,
        _PDP_Context_sipto_Permission,
        _PDP_Context_lipa_Permission,
        _PDP_Context_restoration_Priority,
        _PDP_Context_sipto_local_network_Permission,
        _PDP_Context_nIDD_Mechanism,
        _PDP_Context_sCEF_ID,
        PDP_Context,
        Restoration_Priority,
        SIPTO_Permission,
        SIPTO_Local_Network_Permission,
        LIPA_Permission,
        ContextId,
        _GPRSSubscriptionData_completeDataListIncluded,
        _GPRSSubscriptionData_gprsDataList,
        _GPRSSubscriptionData_extensionContainer,
        _GPRSSubscriptionData_apn_oi_Replacement,
        GPRSSubscriptionData,
        _SGSN_CAMEL_SubscriptionInfo_gprs_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_extensionContainer,
        _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _SGSN_CAMEL_SubscriptionInfo_mg_csi,
        SGSN_CAMEL_SubscriptionInfo,
        _GPRS_CSI_gprs_CamelTDPDataList,
        _GPRS_CSI_camelCapabilityHandling,
        _GPRS_CSI_extensionContainer,
        _GPRS_CSI_notificationToCSE,
        _GPRS_CSI_csi_Active,
        GPRS_CSI,
        _GPRS_CamelTDPDataList__item_,
        GPRS_CamelTDPDataList,
        _GPRS_CamelTDPData_gprs_TriggerDetectionPoint,
        _GPRS_CamelTDPData_serviceKey,
        _GPRS_CamelTDPData_gsmSCF_Address,
        _GPRS_CamelTDPData_defaultSessionHandling,
        _GPRS_CamelTDPData_extensionContainer,
        GPRS_CamelTDPData,
        DefaultGPRS_Handling,
        GPRS_TriggerDetectionPoint,
        APN,
        PDP_Type,
        Ext_PDP_Type,
        PDP_Address,
        QoS_Subscribed,
        Ext_QoS_Subscribed,
        Ext2_QoS_Subscribed,
        Ext3_QoS_Subscribed,
        Ext4_QoS_Subscribed,
        ChargingCharacteristics,
        LSAOnlyAccessIndicator,
        _LSADataList__item_,
        LSADataList,
        maxNumOfLSAs,
        _LSAData_lsaIdentity,
        _LSAData_lsaAttributes,
        _LSAData_lsaActiveModeIndicator,
        _LSAData_extensionContainer,
        LSAData,
        _LSAInformation_completeDataListIncluded,
        _LSAInformation_lsaOnlyAccessIndicator,
        _LSAInformation_lsaDataList,
        _LSAInformation_extensionContainer,
        LSAInformation,
        LSAIdentity,
        LSAAttributes,
        _SubscriberData_msisdn,
        _SubscriberData_category,
        _SubscriberData_subscriberStatus,
        _SubscriberData_bearerServiceList,
        _SubscriberData_teleserviceList,
        _SubscriberData_provisionedSS,
        _SubscriberData_odb_Data,
        _SubscriberData_roamingRestrictionDueToUnsupportedFeature,
        _SubscriberData_regionalSubscriptionData,
        _SubscriberData_vbsSubscriptionData,
        _SubscriberData_vgcsSubscriptionData,
        _SubscriberData_vlrCamelSubscriptionInfo,
        SubscriberData,
        Category,
        SubscriberStatus,
        _BearerServiceList__item_,
        BearerServiceList,
        maxNumOfBearerServices,
        _TeleserviceList__item_,
        TeleserviceList,
        maxNumOfTeleservices,
        _ODB_Data_odb_GeneralData,
        _ODB_Data_odb_HPLMN_Data,
        _ODB_Data_extensionContainer,
        ODB_Data,
        ODB_GeneralData,
        ODB_HPLMN_Data,
        _Ext_SS_InfoList__item_,
        Ext_SS_InfoList,
        _Ext_SS_Info_forwardingInfo,
        _Ext_SS_Info_callBarringInfo,
        _Ext_SS_Info_cug_Info,
        _Ext_SS_Info_ss_Data,
        _Ext_SS_Info_emlpp_Info,
        Ext_SS_Info,
        _Ext_ForwInfo_ss_Code,
        _Ext_ForwInfo_forwardingFeatureList,
        _Ext_ForwInfo_extensionContainer,
        Ext_ForwInfo,
        _Ext_ForwFeatureList__item_,
        Ext_ForwFeatureList,
        _Ext_ForwFeature_basicService,
        _Ext_ForwFeature_ss_Status,
        _Ext_ForwFeature_forwardedToNumber,
        _Ext_ForwFeature_forwardedToSubaddress,
        _Ext_ForwFeature_forwardingOptions,
        _Ext_ForwFeature_noReplyConditionTime,
        _Ext_ForwFeature_extensionContainer,
        _Ext_ForwFeature_longForwardedToNumber,
        Ext_ForwFeature,
        Ext_ForwOptions,
        Ext_NoRepCondTime,
        _Ext_CallBarInfo_ss_Code,
        _Ext_CallBarInfo_callBarringFeatureList,
        _Ext_CallBarInfo_extensionContainer,
        Ext_CallBarInfo,
        _Ext_CallBarFeatureList__item_,
        Ext_CallBarFeatureList,
        _Ext_CallBarringFeature_basicService,
        _Ext_CallBarringFeature_ss_Status,
        _Ext_CallBarringFeature_extensionContainer,
        Ext_CallBarringFeature,
        _CUG_Info_cug_SubscriptionList,
        _CUG_Info_cug_FeatureList,
        _CUG_Info_extensionContainer,
        CUG_Info,
        _CUG_SubscriptionList__item_,
        CUG_SubscriptionList,
        _CUG_Subscription_cug_Index,
        _CUG_Subscription_cug_Interlock,
        _CUG_Subscription_intraCUG_Options,
        _CUG_Subscription_basicServiceGroupList,
        _CUG_Subscription_extensionContainer,
        CUG_Subscription,
        CUG_Index,
        CUG_Interlock,
        IntraCUG_Options,
        maxNumOfCUG,
        _CUG_FeatureList__item_,
        CUG_FeatureList,
        _Ext_BasicServiceGroupList__item_,
        Ext_BasicServiceGroupList,
        maxNumOfExt_BasicServiceGroups,
        _CUG_Feature_basicService,
        _CUG_Feature_preferentialCUG_Indicator,
        _CUG_Feature_interCUG_Restrictions,
        _CUG_Feature_extensionContainer,
        CUG_Feature,
        InterCUG_Restrictions,
        _Ext_SS_Data_ss_Code,
        _Ext_SS_Data_ss_Status,
        _Ext_SS_Data_ss_SubscriptionOption,
        _Ext_SS_Data_basicServiceGroupList,
        _Ext_SS_Data_extensionContainer,
        Ext_SS_Data,
        _LCS_PrivacyExceptionList__item_,
        LCS_PrivacyExceptionList,
        maxNumOfPrivacyClass,
        _LCS_PrivacyClass_ss_Code,
        _LCS_PrivacyClass_ss_Status,
        _LCS_PrivacyClass_notificationToMSUser,
        _LCS_PrivacyClass_externalClientList,
        _LCS_PrivacyClass_plmnClientList,
        _LCS_PrivacyClass_extensionContainer,
        _LCS_PrivacyClass_ext_externalClientList,
        _LCS_PrivacyClass_serviceTypeList,
        LCS_PrivacyClass,
        _ExternalClientList__item_,
        ExternalClientList,
        maxNumOfExternalClient,
        _PLMNClientList__item_,
        PLMNClientList,
        maxNumOfPLMNClient,
        _Ext_ExternalClientList__item_,
        Ext_ExternalClientList,
        maxNumOfExt_ExternalClient,
        _ExternalClient_clientIdentity,
        _ExternalClient_gmlc_Restriction,
        _ExternalClient_notificationToMSUser,
        _ExternalClient_extensionContainer,
        ExternalClient,
        GMLC_Restriction,
        NotificationToMSUser,
        _ServiceTypeList__item_,
        ServiceTypeList,
        maxNumOfServiceType,
        _ServiceType_serviceTypeIdentity,
        _ServiceType_gmlc_Restriction,
        _ServiceType_notificationToMSUser,
        _ServiceType_extensionContainer,
        ServiceType,
        _MOLR_List__item_,
        MOLR_List,
        maxNumOfMOLR_Class,
        _MOLR_Class_ss_Code,
        _MOLR_Class_ss_Status,
        _MOLR_Class_extensionContainer,
        MOLR_Class,
        _ZoneCodeList__item_,
        ZoneCodeList,
        ZoneCode,
        maxNumOfZoneCodes,
        _InsertSubscriberDataRes_teleserviceList,
        _InsertSubscriberDataRes_bearerServiceList,
        _InsertSubscriberDataRes_ss_List,
        _InsertSubscriberDataRes_odb_GeneralData,
        _InsertSubscriberDataRes_regionalSubscriptionResponse,
        _InsertSubscriberDataRes_supportedCamelPhases,
        _InsertSubscriberDataRes_extensionContainer,
        _InsertSubscriberDataRes_offeredCamel4CSIs,
        _InsertSubscriberDataRes_supportedFeatures,
        _InsertSubscriberDataRes_ext_SupportedFeatures,
        InsertSubscriberDataRes,
        RegionalSubscriptionResponse,
        _DeleteSubscriberDataArg_imsi,
        _DeleteSubscriberDataArg_basicServiceList,
        _DeleteSubscriberDataArg_ss_List,
        _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _DeleteSubscriberDataArg_regionalSubscriptionIdentifier,
        _DeleteSubscriberDataArg_vbsGroupIndication,
        _DeleteSubscriberDataArg_vgcsGroupIndication,
        _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw,
        _DeleteSubscriberDataArg_extensionContainer,
        _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature,
        _DeleteSubscriberDataArg_lsaInformationWithdraw,
        _DeleteSubscriberDataArg_gmlc_ListWithdraw,
        _DeleteSubscriberDataArg_istInformationWithdraw,
        _DeleteSubscriberDataArg_specificCSI_Withdraw,
        _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw,
        _DeleteSubscriberDataArg_stn_srWithdraw,
        _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_apn_oi_replacementWithdraw,
        _DeleteSubscriberDataArg_csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw,
        _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_additionalMSISDN_Withdraw,
        _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw,
        _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw,
        _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw,
        _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw,
        _DeleteSubscriberDataArg_ue_UsageTypeWithdraw,
        _DeleteSubscriberDataArg_reset_idsWithdraw,
        _DeleteSubscriberDataArg_iab_OperationWithdraw,
        DeleteSubscriberDataArg,
        SpecificCSI_Withdraw,
        _GPRSSubscriptionDataWithdraw_allGPRSData,
        _GPRSSubscriptionDataWithdraw_contextIdList,
        GPRSSubscriptionDataWithdraw,
        _EPS_SubscriptionDataWithdraw_allEPS_Data,
        _EPS_SubscriptionDataWithdraw_contextIdList,
        EPS_SubscriptionDataWithdraw,
        _ContextIdList__item_,
        ContextIdList,
        _LSAInformationWithdraw_allLSAData,
        _LSAInformationWithdraw_lsaIdentityList,
        LSAInformationWithdraw,
        _LSAIdentityList__item_,
        LSAIdentityList,
        _BasicServiceList__item_,
        BasicServiceList,
        maxNumOfBasicServices,
        _DeleteSubscriberDataRes_regionalSubscriptionResponse,
        _DeleteSubscriberDataRes_extensionContainer,
        DeleteSubscriberDataRes,
        _VlrCamelSubscriptionInfo_o_CSI,
        _VlrCamelSubscriptionInfo_extensionContainer,
        _VlrCamelSubscriptionInfo_ss_CSI,
        _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _VlrCamelSubscriptionInfo_tif_CSI,
        _VlrCamelSubscriptionInfo_m_CSI,
        _VlrCamelSubscriptionInfo_mo_sms_CSI,
        _VlrCamelSubscriptionInfo_vt_CSI,
        _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _VlrCamelSubscriptionInfo_d_CSI,
        _VlrCamelSubscriptionInfo_mt_sms_CSI,
        _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        VlrCamelSubscriptionInfo,
        _MT_smsCAMELTDP_CriteriaList__item_,
        MT_smsCAMELTDP_CriteriaList,
        _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint,
        _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion,
        MT_smsCAMELTDP_Criteria,
        _TPDU_TypeCriterion__item_,
        TPDU_TypeCriterion,
        maxNumOfTPDUTypes,
        MT_SMS_TPDU_Type,
        _D_CSI_dp_AnalysedInfoCriteriaList,
        _D_CSI_camelCapabilityHandling,
        _D_CSI_extensionContainer,
        _D_CSI_notificationToCSE,
        _D_CSI_csi_Active,
        D_CSI,
        _DP_AnalysedInfoCriteriaList__item_,
        DP_AnalysedInfoCriteriaList,
        maxNumOfDP_AnalysedInfoCriteria,
        _DP_AnalysedInfoCriterium_dialledNumber,
        _DP_AnalysedInfoCriterium_serviceKey,
        _DP_AnalysedInfoCriterium_gsmSCF_Address,
        _DP_AnalysedInfoCriterium_defaultCallHandling,
        _DP_AnalysedInfoCriterium_extensionContainer,
        DP_AnalysedInfoCriterium,
        _SS_CSI_ss_CamelData,
        _SS_CSI_extensionContainer,
        _SS_CSI_notificationToCSE,
        _SS_CSI_csi_Active,
        SS_CSI,
        _SS_CamelData_ss_EventList,
        _SS_CamelData_gsmSCF_Address,
        _SS_CamelData_extensionContainer,
        SS_CamelData,
        _SS_EventList__item_,
        SS_EventList,
        maxNumOfCamelSSEvents,
        _O_CSI_o_BcsmCamelTDPDataList,
        _O_CSI_extensionContainer,
        _O_CSI_camelCapabilityHandling,
        _O_CSI_notificationToCSE,
        _O_CSI_csiActive,
        O_CSI,
        _O_BcsmCamelTDPDataList__item_,
        O_BcsmCamelTDPDataList,
        maxNumOfCamelTDPData,
        _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPData_serviceKey,
        _O_BcsmCamelTDPData_gsmSCF_Address,
        _O_BcsmCamelTDPData_defaultCallHandling,
        _O_BcsmCamelTDPData_extensionContainer,
        O_BcsmCamelTDPData,
        ServiceKey,
        O_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPCriteriaList__item_,
        O_BcsmCamelTDPCriteriaList,
        _T_BCSM_CAMEL_TDP_CriteriaList__item_,
        T_BCSM_CAMEL_TDP_CriteriaList,
        _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDP_Criteria_destinationNumberCriteria,
        _O_BcsmCamelTDP_Criteria_basicServiceCriteria,
        _O_BcsmCamelTDP_Criteria_callTypeCriteria,
        _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria,
        _O_BcsmCamelTDP_Criteria_extensionContainer,
        O_BcsmCamelTDP_Criteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint,
        _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria,
        T_BCSM_CAMEL_TDP_Criteria,
        _DestinationNumberCriteria_matchType,
        _DestinationNumberCriteria_destinationNumberList,
        _DestinationNumberCriteria_destinationNumberLengthList,
        DestinationNumberCriteria,
        _DestinationNumberList__item_,
        DestinationNumberList,
        _DestinationNumberLengthList__item_,
        DestinationNumberLengthList,
        _BasicServiceCriteria__item_,
        BasicServiceCriteria,
        maxNumOfISDN_AddressDigits,
        maxNumOfCamelDestinationNumbers,
        maxNumOfCamelDestinationNumberLengths,
        maxNumOfCamelBasicServiceCriteria,
        CallTypeCriteria,
        MatchType,
        _O_CauseValueCriteria__item_,
        O_CauseValueCriteria,
        _T_CauseValueCriteria__item_,
        T_CauseValueCriteria,
        maxNumOfCAMEL_O_CauseValueCriteria,
        maxNumOfCAMEL_T_CauseValueCriteria,
        CauseValue,
        DefaultCallHandling,
        CamelCapabilityHandling,
        SupportedCamelPhases,
        OfferedCamel4CSIs,
        OfferedCamel4Functionalities,
        _SMS_CSI_sms_CAMEL_TDP_DataList,
        _SMS_CSI_camelCapabilityHandling,
        _SMS_CSI_extensionContainer,
        _SMS_CSI_notificationToCSE,
        _SMS_CSI_csi_Active,
        SMS_CSI,
        _SMS_CAMEL_TDP_DataList__item_,
        SMS_CAMEL_TDP_DataList,
        _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint,
        _SMS_CAMEL_TDP_Data_serviceKey,
        _SMS_CAMEL_TDP_Data_gsmSCF_Address,
        _SMS_CAMEL_TDP_Data_defaultSMS_Handling,
        _SMS_CAMEL_TDP_Data_extensionContainer,
        SMS_CAMEL_TDP_Data,
        SMS_TriggerDetectionPoint,
        DefaultSMS_Handling,
        _M_CSI_mobilityTriggers,
        _M_CSI_serviceKey,
        _M_CSI_gsmSCF_Address,
        _M_CSI_extensionContainer,
        _M_CSI_notificationToCSE,
        _M_CSI_csi_Active,
        M_CSI,
        _MG_CSI_mobilityTriggers,
        _MG_CSI_serviceKey,
        _MG_CSI_gsmSCF_Address,
        _MG_CSI_extensionContainer,
        _MG_CSI_notificationToCSE,
        _MG_CSI_csi_Active,
        MG_CSI,
        _MobilityTriggers__item_,
        MobilityTriggers,
        maxNumOfMobilityTriggers,
        MM_Code,
        _T_CSI_t_BcsmCamelTDPDataList,
        _T_CSI_extensionContainer,
        _T_CSI_camelCapabilityHandling,
        _T_CSI_notificationToCSE,
        _T_CSI_csi_Active,
        T_CSI,
        _T_BcsmCamelTDPDataList__item_,
        T_BcsmCamelTDPDataList,
        _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint,
        _T_BcsmCamelTDPData_serviceKey,
        _T_BcsmCamelTDPData_gsmSCF_Address,
        _T_BcsmCamelTDPData_defaultCallHandling,
        _T_BcsmCamelTDPData_extensionContainer,
        T_BcsmCamelTDPData,
        T_BcsmTriggerDetectionPoint,
        _SendRoutingInfoForGprsArg_imsi,
        _SendRoutingInfoForGprsArg_ggsn_Address,
        _SendRoutingInfoForGprsArg_ggsn_Number,
        _SendRoutingInfoForGprsArg_extensionContainer,
        SendRoutingInfoForGprsArg,
        _SendRoutingInfoForGprsRes_sgsn_Address,
        _SendRoutingInfoForGprsRes_ggsn_Address,
        _SendRoutingInfoForGprsRes_mobileNotReachableReason,
        _SendRoutingInfoForGprsRes_extensionContainer,
        SendRoutingInfoForGprsRes,
        _FailureReportArg_imsi,
        _FailureReportArg_ggsn_Number,
        _FailureReportArg_ggsn_Address,
        _FailureReportArg_extensionContainer,
        FailureReportArg,
        _FailureReportRes_ggsn_Address,
        _FailureReportRes_extensionContainer,
        FailureReportRes,
        _NoteMsPresentForGprsArg_imsi,
        _NoteMsPresentForGprsArg_sgsn_Address,
        _NoteMsPresentForGprsArg_ggsn_Address,
        _NoteMsPresentForGprsArg_extensionContainer,
        NoteMsPresentForGprsArg,
        _NoteMsPresentForGprsRes_extensionContainer,
        NoteMsPresentForGprsRes,
        _ResetArg_sendingNodenumber,
        _ResetArg_hlr_List,
        _ResetArg_extensionContainer,
        _ResetArg_reset_Id_List,
        _ResetArg_subscriptionData,
        _ResetArg_subscriptionDataDeletion,
        ResetArg,
        _SendingNode_Number_hlr_Number,
        _SendingNode_Number_css_Number,
        SendingNode_Number,
        _RestoreDataArg_imsi,
        _RestoreDataArg_lmsi,
        _RestoreDataArg_extensionContainer,
        _RestoreDataArg_vlr_Capability,
        _RestoreDataArg_restorationIndicator,
        RestoreDataArg,
        _RestoreDataRes_hlr_Number,
        _RestoreDataRes_msNotReachable,
        _RestoreDataRes_extensionContainer,
        RestoreDataRes,
        _VBSDataList__item_,
        VBSDataList,
        _VGCSDataList__item_,
        VGCSDataList,
        maxNumOfVBSGroupIds,
        maxNumOfVGCSGroupIds,
        _VoiceGroupCallData_groupId,
        _VoiceGroupCallData_extensionContainer,
        _VoiceGroupCallData_additionalSubscriptions,
        _VoiceGroupCallData_additionalInfo,
        _VoiceGroupCallData_longGroupId,
        VoiceGroupCallData,
        AdditionalInfo,
        AdditionalSubscriptions,
        _VoiceBroadcastData_groupid,
        _VoiceBroadcastData_broadcastInitEntitlement,
        _VoiceBroadcastData_extensionContainer,
        _VoiceBroadcastData_longGroupId,
        VoiceBroadcastData,
        GroupId,
        Long_GroupId,
        _ProvideSubscriberInfoArg_imsi,
        _ProvideSubscriberInfoArg_lmsi,
        _ProvideSubscriberInfoArg_requestedInfo,
        _ProvideSubscriberInfoArg_extensionContainer,
        _ProvideSubscriberInfoArg_callPriority,
        ProvideSubscriberInfoArg,
        _ProvideSubscriberInfoRes_subscriberInfo,
        _ProvideSubscriberInfoRes_extensionContainer,
        ProvideSubscriberInfoRes,
        _SubscriberInfo_locationInformation,
        _SubscriberInfo_subscriberState,
        _SubscriberInfo_extensionContainer,
        _SubscriberInfo_locationInformationGPRS,
        _SubscriberInfo_ps_SubscriberState,
        _SubscriberInfo_imei,
        _SubscriberInfo_ms_Classmark2,
        _SubscriberInfo_gprs_MS_Class,
        _SubscriberInfo_mnpInfoRes,
        _SubscriberInfo_imsVoiceOverPS_SessionsIndication,
        _SubscriberInfo_lastUE_ActivityTime,
        _SubscriberInfo_lastRAT_Type,
        _SubscriberInfo_eps_SubscriberState,
        _SubscriberInfo_locationInformationEPS,
        _SubscriberInfo_timeZone,
        _SubscriberInfo_daylightSavingTime,
        _SubscriberInfo_locationInformation5GS,
        SubscriberInfo,
        IMS_VoiceOverPS_SessionsInd,
        TimeZone,
        DaylightSavingTime,
        _MNPInfoRes_routeingNumber,
        _MNPInfoRes_imsi,
        _MNPInfoRes_msisdn,
        _MNPInfoRes_numberPortabilityStatus,
        _MNPInfoRes_extensionContainer,
        MNPInfoRes,
        RouteingNumber,
        NumberPortabilityStatus,
        MS_Classmark2,
        _GPRSMSClass_mSNetworkCapability,
        _GPRSMSClass_mSRadioAccessCapability,
        GPRSMSClass,
        MSNetworkCapability,
        MSRadioAccessCapability,
        _RequestedInfo_locationInformation,
        _RequestedInfo_subscriberState,
        _RequestedInfo_extensionContainer,
        _RequestedInfo_currentLocation,
        _RequestedInfo_requestedDomain,
        _RequestedInfo_imei,
        _RequestedInfo_ms_classmark,
        _RequestedInfo_mnpRequestedInfo,
        _RequestedInfo_locationInformationEPS_Supported,
        _RequestedInfo_t_adsData,
        _RequestedInfo_requestedNodes,
        _RequestedInfo_servingNodeIndication,
        _RequestedInfo_localTimeZoneRequest,
        RequestedInfo,
        DomainType,
        RequestedNodes,
        _LocationInformation_ageOfLocationInformation,
        _LocationInformation_geographicalInformation,
        _LocationInformation_vlr_number,
        _LocationInformation_locationNumber,
        _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformation_extensionContainer,
        _LocationInformation_selectedLSA_Id,
        _LocationInformation_msc_Number,
        _LocationInformation_geodeticInformation,
        _LocationInformation_currentLocationRetrieved,
        _LocationInformation_sai_Present,
        _LocationInformation_locationInformationEPS,
        _LocationInformation_userCSGInformation,
        LocationInformation,
        _LocationInformationEPS_e_utranCellGlobalIdentity,
        _LocationInformationEPS_trackingAreaIdentity,
        _LocationInformationEPS_extensionContainer,
        _LocationInformationEPS_geographicalInformation,
        _LocationInformationEPS_geodeticInformation,
        _LocationInformationEPS_currentLocationRetrieved,
        _LocationInformationEPS_ageOfLocationInformation,
        _LocationInformationEPS_mme_Name,
        LocationInformationEPS,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_geodeticInformation,
        _LocationInformationGPRS_currentLocationRetrieved,
        _LocationInformationGPRS_ageOfLocationInformation,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _LocationInformation5GS_nrCellGlobalIdentity,
        _LocationInformation5GS_e_utranCellGlobalIdentity,
        _LocationInformation5GS_geographicalInformation,
        _LocationInformation5GS_geodeticInformation,
        _LocationInformation5GS_amf_address,
        _LocationInformation5GS_trackingAreaIdentity,
        _LocationInformation5GS_currentLocationRetrieved,
        _LocationInformation5GS_ageOfLocationInformation,
        _LocationInformation5GS_vplmnId,
        _LocationInformation5GS_localtimeZone,
        _LocationInformation5GS_rat_Type,
        _LocationInformation5GS_extensionContainer,
        _LocationInformation5GS_nrTrackingAreaIdentity,
        LocationInformation5GS,
        _UserCSGInformation_csg_Id,
        _UserCSGInformation_extensionContainer,
        _UserCSGInformation_accessMode,
        _UserCSGInformation_cmi,
        UserCSGInformation,
        GeographicalInformation,
        GeodeticInformation,
        LocationNumber,
        _SubscriberState_assumedIdle,
        _SubscriberState_camelBusy,
        _SubscriberState_netDetNotReachable,
        _SubscriberState_notProvidedFromVLR,
        SubscriberState,
        _PS_SubscriberState_notProvidedFromSGSNorMME,
        _PS_SubscriberState_ps_Detached,
        _PS_SubscriberState_ps_AttachedNotReachableForPaging,
        _PS_SubscriberState_ps_AttachedReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveReachableForPaging,
        _PS_SubscriberState_netDetNotReachable,
        PS_SubscriberState,
        _PDP_ContextInfoList__item_,
        PDP_ContextInfoList,
        _PDP_ContextInfo_pdp_ContextIdentifier,
        _PDP_ContextInfo_pdp_ContextActive,
        _PDP_ContextInfo_pdp_Type,
        _PDP_ContextInfo_pdp_Address,
        _PDP_ContextInfo_apn_Subscribed,
        _PDP_ContextInfo_apn_InUse,
        _PDP_ContextInfo_nsapi,
        _PDP_ContextInfo_transactionId,
        _PDP_ContextInfo_teid_ForGnAndGp,
        _PDP_ContextInfo_teid_ForIu,
        _PDP_ContextInfo_ggsn_Address,
        _PDP_ContextInfo_qos_Subscribed,
        _PDP_ContextInfo_qos_Requested,
        _PDP_ContextInfo_qos_Negotiated,
        _PDP_ContextInfo_chargingId,
        _PDP_ContextInfo_chargingCharacteristics,
        _PDP_ContextInfo_rnc_Address,
        _PDP_ContextInfo_extensionContainer,
        _PDP_ContextInfo_qos2_Subscribed,
        _PDP_ContextInfo_qos2_Requested,
        _PDP_ContextInfo_qos2_Negotiated,
        _PDP_ContextInfo_qos3_Subscribed,
        _PDP_ContextInfo_qos3_Requested,
        _PDP_ContextInfo_qos3_Negotiated,
        _PDP_ContextInfo_qos4_Subscribed,
        _PDP_ContextInfo_qos4_Requested,
        _PDP_ContextInfo_qos4_Negotiated,
        _PDP_ContextInfo_ext_pdp_Type,
        _PDP_ContextInfo_ext_pdp_Address,
        PDP_ContextInfo,
        NSAPI,
        TransactionId,
        TEID,
        GPRSChargingID,
        NotReachableReason,
        _AnyTimeInterrogationArg_subscriberIdentity,
        _AnyTimeInterrogationArg_requestedInfo,
        _AnyTimeInterrogationArg_gsmSCF_Address,
        _AnyTimeInterrogationArg_extensionContainer,
        AnyTimeInterrogationArg,
        _AnyTimeInterrogationRes_subscriberInfo,
        _AnyTimeInterrogationRes_extensionContainer,
        AnyTimeInterrogationRes,
        _AnyTimeSubscriptionInterrogationArg_subscriberIdentity,
        _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo,
        _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address,
        _AnyTimeSubscriptionInterrogationArg_extensionContainer,
        _AnyTimeSubscriptionInterrogationArg_longFTN_Supported,
        AnyTimeSubscriptionInterrogationArg,
        _AnyTimeSubscriptionInterrogationRes_callForwardingData,
        _AnyTimeSubscriptionInterrogationRes_callBarringData,
        _AnyTimeSubscriptionInterrogationRes_odb_Info,
        _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo,
        _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_extensionContainer,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN,
        _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List,
        _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList,
        _AnyTimeSubscriptionInterrogationRes_cw_Data,
        _AnyTimeSubscriptionInterrogationRes_ch_Data,
        _AnyTimeSubscriptionInterrogationRes_clip_Data,
        _AnyTimeSubscriptionInterrogationRes_clir_Data,
        _AnyTimeSubscriptionInterrogationRes_ect_data,
        AnyTimeSubscriptionInterrogationRes,
        _CallWaitingData_cwFeatureList,
        _CallWaitingData_notificationToCSE,
        CallWaitingData,
        _Ext_CwFeatureList__item_,
        Ext_CwFeatureList,
        _Ext_CwFeature_basicService,
        _Ext_CwFeature_ss_Status,
        Ext_CwFeature,
        _ClipData_ss_Status,
        _ClipData_overrideCategory,
        _ClipData_notificationToCSE,
        ClipData,
        _ClirData_ss_Status,
        _ClirData_cliRestrictionOption,
        _ClirData_notificationToCSE,
        ClirData,
        _CallHoldData_ss_Status,
        _CallHoldData_notificationToCSE,
        CallHoldData,
        _EctData_ss_Status,
        _EctData_notificationToCSE,
        EctData,
        _RequestedSubscriptionInfo_requestedSS_Info,
        _RequestedSubscriptionInfo_odb,
        _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases,
        _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases,
        _RequestedSubscriptionInfo_extensionContainer,
        _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_msisdn_BS_List,
        _RequestedSubscriptionInfo_csg_SubscriptionDataRequested,
        _RequestedSubscriptionInfo_cw_Info,
        _RequestedSubscriptionInfo_clip_Info,
        _RequestedSubscriptionInfo_clir_Info,
        _RequestedSubscriptionInfo_hold_Info,
        _RequestedSubscriptionInfo_ect_Info,
        RequestedSubscriptionInfo,
        _MSISDN_BS_List__item_,
        MSISDN_BS_List,
        maxNumOfMSISDN,
        _MSISDN_BS_msisdn,
        _MSISDN_BS_basicServiceList,
        _MSISDN_BS_extensionContainer,
        MSISDN_BS,
        RequestedCAMEL_SubscriptionInfo,
        AdditionalRequestedCAMEL_SubscriptionInfo,
        _CallForwardingData_forwardingFeatureList,
        _CallForwardingData_notificationToCSE,
        _CallForwardingData_extensionContainer,
        CallForwardingData,
        _CallBarringData_callBarringFeatureList,
        _CallBarringData_password,
        _CallBarringData_wrongPasswordAttemptsCounter,
        _CallBarringData_notificationToCSE,
        _CallBarringData_extensionContainer,
        CallBarringData,
        WrongPasswordAttemptsCounter,
        _ODB_Info_odb_Data,
        _ODB_Info_notificationToCSE,
        _ODB_Info_extensionContainer,
        ODB_Info,
        _CAMEL_SubscriptionInfo_o_CSI,
        _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_CSI,
        _CAMEL_SubscriptionInfo_t_CSI,
        _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_vt_CSI,
        _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_tif_CSI,
        _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE,
        _CAMEL_SubscriptionInfo_gprs_CSI,
        _CAMEL_SubscriptionInfo_mo_sms_CSI,
        _CAMEL_SubscriptionInfo_ss_CSI,
        _CAMEL_SubscriptionInfo_m_CSI,
        _CAMEL_SubscriptionInfo_extensionContainer,
        _CAMEL_SubscriptionInfo_specificCSIDeletedList,
        _CAMEL_SubscriptionInfo_mt_sms_CSI,
        _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_mg_csi,
        _CAMEL_SubscriptionInfo_o_IM_CSI,
        _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList,
        CAMEL_SubscriptionInfo,
        _AnyTimeModificationArg_subscriberIdentity,
        _AnyTimeModificationArg_gsmSCF_Address,
        _AnyTimeModificationArg_modificationRequestFor_CF_Info,
        _AnyTimeModificationArg_modificationRequestFor_CB_Info,
        _AnyTimeModificationArg_modificationRequestFor_CSI,
        _AnyTimeModificationArg_extensionContainer,
        _AnyTimeModificationArg_longFTN_Supported,
        _AnyTimeModificationArg_modificationRequestFor_ODB_data,
        _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data,
        _AnyTimeModificationArg_activationRequestForUE_reachability,
        _AnyTimeModificationArg_modificationRequestFor_CSG,
        _AnyTimeModificationArg_modificationRequestFor_CW_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIP_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIR_Data,
        _AnyTimeModificationArg_modificationRequestFor_HOLD_Data,
        _AnyTimeModificationArg_modificationRequestFor_ECT_Data,
        AnyTimeModificationArg,
        _ModificationRequestFor_CW_Info_basicService,
        _ModificationRequestFor_CW_Info_ss_Status,
        _ModificationRequestFor_CW_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CW_Info_extensionContainer,
        ModificationRequestFor_CW_Info,
        _ModificationRequestFor_CH_Info_ss_Status,
        _ModificationRequestFor_CH_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CH_Info_extensionContainer,
        ModificationRequestFor_CH_Info,
        _ModificationRequestFor_ECT_Info_ss_Status,
        _ModificationRequestFor_ECT_Info_modifyNotificationToCSE,
        _ModificationRequestFor_ECT_Info_extensionContainer,
        ModificationRequestFor_ECT_Info,
        _ModificationRequestFor_CLIR_Info_ss_Status,
        _ModificationRequestFor_CLIR_Info_cliRestrictionOption,
        _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIR_Info_extensionContainer,
        ModificationRequestFor_CLIR_Info,
        _ModificationRequestFor_CLIP_Info_ss_Status,
        _ModificationRequestFor_CLIP_Info_overrideCategory,
        _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIP_Info_extensionContainer,
        ModificationRequestFor_CLIP_Info,
        _ModificationRequestFor_CSG_modifyNotificationToCSE,
        _ModificationRequestFor_CSG_extensionContainer,
        ModificationRequestFor_CSG,
        RequestedServingNode,
        ServingNode,
        _AnyTimeModificationRes_ss_InfoFor_CSE,
        _AnyTimeModificationRes_camel_SubscriptionInfo,
        _AnyTimeModificationRes_extensionContainer,
        _AnyTimeModificationRes_odb_Info,
        _AnyTimeModificationRes_cw_Data,
        _AnyTimeModificationRes_ch_Data,
        _AnyTimeModificationRes_clip_Data,
        _AnyTimeModificationRes_clir_Data,
        _AnyTimeModificationRes_ect_data,
        _AnyTimeModificationRes_serviceCentreAddress,
        AnyTimeModificationRes,
        _ModificationRequestFor_CF_Info_ss_Code,
        _ModificationRequestFor_CF_Info_basicService,
        _ModificationRequestFor_CF_Info_ss_Status,
        _ModificationRequestFor_CF_Info_forwardedToNumber,
        _ModificationRequestFor_CF_Info_forwardedToSubaddress,
        _ModificationRequestFor_CF_Info_noReplyConditionTime,
        _ModificationRequestFor_CF_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CF_Info_extensionContainer,
        ModificationRequestFor_CF_Info,
        _ModificationRequestFor_CB_Info_ss_Code,
        _ModificationRequestFor_CB_Info_basicService,
        _ModificationRequestFor_CB_Info_ss_Status,
        _ModificationRequestFor_CB_Info_password,
        _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter,
        _ModificationRequestFor_CB_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CB_Info_extensionContainer,
        ModificationRequestFor_CB_Info,
        _ModificationRequestFor_ODB_data_odb_data,
        _ModificationRequestFor_ODB_data_modifyNotificationToCSE,
        _ModificationRequestFor_ODB_data_extensionContainer,
        ModificationRequestFor_ODB_data,
        _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo,
        _ModificationRequestFor_CSI_modifyNotificationToCSE,
        _ModificationRequestFor_CSI_modifyCSI_State,
        _ModificationRequestFor_CSI_extensionContainer,
        _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo,
        ModificationRequestFor_CSI,
        _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus,
        _ModificationRequestFor_IP_SM_GW_Data_extensionContainer,
        _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress,
        ModificationRequestFor_IP_SM_GW_Data,
        ModificationInstruction,
        _NoteSubscriberDataModifiedArg_imsi,
        _NoteSubscriberDataModifiedArg_msisdn,
        _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_odb_Info,
        _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo,
        _NoteSubscriberDataModifiedArg_allInformationSent,
        _NoteSubscriberDataModifiedArg_extensionContainer,
        _NoteSubscriberDataModifiedArg_ue_reachable,
        _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList,
        _NoteSubscriberDataModifiedArg_cw_Data,
        _NoteSubscriberDataModifiedArg_ch_Data,
        _NoteSubscriberDataModifiedArg_clip_Data,
        _NoteSubscriberDataModifiedArg_clir_Data,
        _NoteSubscriberDataModifiedArg_ect_data,
        NoteSubscriberDataModifiedArg,
        _NoteSubscriberDataModifiedRes_extensionContainer,
        NoteSubscriberDataModifiedRes,
        _NoteMM_EventArg_serviceKey,
        _NoteMM_EventArg_eventMet,
        _NoteMM_EventArg_imsi,
        _NoteMM_EventArg_msisdn,
        _NoteMM_EventArg_locationInformation,
        _NoteMM_EventArg_supportedCAMELPhases,
        _NoteMM_EventArg_extensionContainer,
        _NoteMM_EventArg_locationInformationGPRS,
        _NoteMM_EventArg_offeredCamel4Functionalities,
        NoteMM_EventArg,
        _NoteMM_EventRes_extensionContainer,
        NoteMM_EventRes,
        _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE,
        _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE,
        Ext_SS_InfoFor_CSE,
        _Ext_ForwardingInfoFor_CSE_ss_Code,
        _Ext_ForwardingInfoFor_CSE_forwardingFeatureList,
        _Ext_ForwardingInfoFor_CSE_notificationToCSE,
        _Ext_ForwardingInfoFor_CSE_extensionContainer,
        Ext_ForwardingInfoFor_CSE,
        _Ext_CallBarringInfoFor_CSE_ss_Code,
        _Ext_CallBarringInfoFor_CSE_callBarringFeatureList,
        _Ext_CallBarringInfoFor_CSE_password,
        _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter,
        _Ext_CallBarringInfoFor_CSE_notificationToCSE,
        _Ext_CallBarringInfoFor_CSE_extensionContainer,
        Ext_CallBarringInfoFor_CSE,
        _UpdateVcsgLocationArg_imsi,
        _UpdateVcsgLocationArg_msisdn,
        _UpdateVcsgLocationArg_vlr_Number,
        _UpdateVcsgLocationArg_sgsn_Number,
        _UpdateVcsgLocationArg_extensionContainer,
        UpdateVcsgLocationArg,
        _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator,
        _UpdateVcsgLocationRes_extensionContainer,
        UpdateVcsgLocationRes,
        _CancelVcsgLocationArg_identity,
        _CancelVcsgLocationArg_extensionContainer,
        CancelVcsgLocationArg,
        _CancelVcsgLocationRes_extensionContainer,
        CancelVcsgLocationRes,
    ]

class MAP_OM_DataTypes:

    _name_  = u'MAP-OM-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 12, 19]
    
    _obj_ = [
        u'ActivateTraceModeArg',
        u'MDT-Configuration',
        u'MDT-Allowed-PLMNId-List',
        u'PeriodUMTS',
        u'PeriodLTE',
        u'PositioningMethod',
        u'MeasurementQuantity',
        u'EventThreshold1F',
        u'EventThreshold1I',
        u'JobType',
        u'AreaScope',
        u'CGI-List',
        u'E-UTRAN-CGI-List',
        u'RoutingAreaId-List',
        u'LocationAreaId-List',
        u'TrackingAreaId-List',
        u'ListOfMeasurements',
        u'ReportingTrigger',
        u'ReportInterval',
        u'ReportAmount',
        u'EventThresholdRSRP',
        u'EventThresholdRSRQ',
        u'LoggingInterval',
        u'LoggingDuration',
        u'TraceReference',
        u'TraceReference2',
        u'TraceRecordingSessionReference',
        u'TraceType',
        u'TraceDepthList',
        u'TraceDepth',
        u'TraceDepthExtension',
        u'TraceNE-TypeList',
        u'TraceInterfaceList',
        u'MSC-S-InterfaceList',
        u'MGW-InterfaceList',
        u'SGSN-InterfaceList',
        u'GGSN-InterfaceList',
        u'RNC-InterfaceList',
        u'BMSC-InterfaceList',
        u'MME-InterfaceList',
        u'SGW-InterfaceList',
        u'PGW-InterfaceList',
        u'ENB-InterfaceList',
        u'TraceEventList',
        u'MSC-S-EventList',
        u'MGW-EventList',
        u'SGSN-EventList',
        u'GGSN-EventList',
        u'BMSC-EventList',
        u'MME-EventList',
        u'SGW-EventList',
        u'PGW-EventList',
        u'TracePropagationList',
        u'ActivateTraceModeRes',
        u'DeactivateTraceModeArg',
        u'DeactivateTraceModeRes',
        ]
    _type_ = [
        u'ActivateTraceModeArg',
        u'MDT-Configuration',
        u'MDT-Allowed-PLMNId-List',
        u'PeriodUMTS',
        u'PeriodLTE',
        u'PositioningMethod',
        u'MeasurementQuantity',
        u'EventThreshold1F',
        u'EventThreshold1I',
        u'JobType',
        u'AreaScope',
        u'CGI-List',
        u'E-UTRAN-CGI-List',
        u'RoutingAreaId-List',
        u'LocationAreaId-List',
        u'TrackingAreaId-List',
        u'ListOfMeasurements',
        u'ReportingTrigger',
        u'ReportInterval',
        u'ReportAmount',
        u'EventThresholdRSRP',
        u'EventThresholdRSRQ',
        u'LoggingInterval',
        u'LoggingDuration',
        u'TraceReference',
        u'TraceReference2',
        u'TraceRecordingSessionReference',
        u'TraceType',
        u'TraceDepthList',
        u'TraceDepth',
        u'TraceDepthExtension',
        u'TraceNE-TypeList',
        u'TraceInterfaceList',
        u'MSC-S-InterfaceList',
        u'MGW-InterfaceList',
        u'SGSN-InterfaceList',
        u'GGSN-InterfaceList',
        u'RNC-InterfaceList',
        u'BMSC-InterfaceList',
        u'MME-InterfaceList',
        u'SGW-InterfaceList',
        u'PGW-InterfaceList',
        u'ENB-InterfaceList',
        u'TraceEventList',
        u'MSC-S-EventList',
        u'MGW-EventList',
        u'SGSN-EventList',
        u'GGSN-EventList',
        u'BMSC-EventList',
        u'MME-EventList',
        u'SGW-EventList',
        u'PGW-EventList',
        u'TracePropagationList',
        u'ActivateTraceModeRes',
        u'DeactivateTraceModeArg',
        u'DeactivateTraceModeRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ActivateTraceModeArg >-----#
    ActivateTraceModeArg = SEQ(name=u'ActivateTraceModeArg', mode=MODE_TYPE)
    _ActivateTraceModeArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ActivateTraceModeArg_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _ActivateTraceModeArg_traceType = INT(name=u'traceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')))
    _ActivateTraceModeArg_omc_Id = OCT_STR(name=u'omc-Id', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ActivateTraceModeArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeArg_traceReference2 = OCT_STR(name=u'traceReference2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _ActivateTraceModeArg_traceDepthList = SEQ(name=u'traceDepthList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthList')), opt=True)
    _ActivateTraceModeArg_traceNE_TypeList = BIT_STR(name=u'traceNE-TypeList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceNE-TypeList')), opt=True)
    _ActivateTraceModeArg_traceInterfaceList = SEQ(name=u'traceInterfaceList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceInterfaceList')), opt=True)
    _ActivateTraceModeArg_traceEventList = SEQ(name=u'traceEventList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceEventList')), opt=True)
    _ActivateTraceModeArg_traceCollectionEntity = OCT_STR(name=u'traceCollectionEntity', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _ActivateTraceModeArg_mdt_Configuration = SEQ(name=u'mdt-Configuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Configuration')), opt=True)
    ActivateTraceModeArg._cont = ASN1Dict([
        (u'imsi', _ActivateTraceModeArg_imsi),
        (u'traceReference', _ActivateTraceModeArg_traceReference),
        (u'traceType', _ActivateTraceModeArg_traceType),
        (u'omc-Id', _ActivateTraceModeArg_omc_Id),
        (u'extensionContainer', _ActivateTraceModeArg_extensionContainer),
        (u'traceReference2', _ActivateTraceModeArg_traceReference2),
        (u'traceDepthList', _ActivateTraceModeArg_traceDepthList),
        (u'traceNE-TypeList', _ActivateTraceModeArg_traceNE_TypeList),
        (u'traceInterfaceList', _ActivateTraceModeArg_traceInterfaceList),
        (u'traceEventList', _ActivateTraceModeArg_traceEventList),
        (u'traceCollectionEntity', _ActivateTraceModeArg_traceCollectionEntity),
        (u'mdt-Configuration', _ActivateTraceModeArg_mdt_Configuration),
        ])
    ActivateTraceModeArg._ext = [u'traceReference2', u'traceDepthList', u'traceNE-TypeList', u'traceInterfaceList', u'traceEventList', u'traceCollectionEntity', u'mdt-Configuration']
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_jobType = ENUM(name=u'jobType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'JobType')))
    _MDT_Configuration_areaScope = SEQ(name=u'areaScope', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'AreaScope')), opt=True)
    _MDT_Configuration_listOfMeasurements = OCT_STR(name=u'listOfMeasurements', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ListOfMeasurements')), opt=True)
    _MDT_Configuration_reportingTrigger = OCT_STR(name=u'reportingTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportingTrigger')), opt=True)
    _MDT_Configuration_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportInterval')), opt=True)
    _MDT_Configuration_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportAmount')), opt=True)
    _MDT_Configuration_eventThresholdRSRP = INT(name=u'eventThresholdRSRP', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRP')), opt=True)
    _MDT_Configuration_eventThresholdRSRQ = INT(name=u'eventThresholdRSRQ', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRQ')), opt=True)
    _MDT_Configuration_loggingInterval = ENUM(name=u'loggingInterval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingInterval')), opt=True)
    _MDT_Configuration_loggingDuration = ENUM(name=u'loggingDuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingDuration')), opt=True)
    _MDT_Configuration_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MDT_Configuration_measurementPeriodUMTS = ENUM(name=u'measurementPeriodUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_measurementPeriodLTE = ENUM(name=u'measurementPeriodLTE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_UMTS = ENUM(name=u'collectionPeriodRRM-UMTS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_LTE = ENUM(name=u'collectionPeriodRRM-LTE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_positioningMethod = OCT_STR(name=u'positioningMethod', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PositioningMethod')), opt=True)
    _MDT_Configuration_measurementQuantity = OCT_STR(name=u'measurementQuantity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MeasurementQuantity')), opt=True)
    _MDT_Configuration_eventThreshold1F = INT(name=u'eventThreshold1F', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1F')), opt=True)
    _MDT_Configuration_eventThreshold1I = INT(name=u'eventThreshold1I', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1I')), opt=True)
    _MDT_Configuration_mdt_Allowed_PLMN_List = SEQ_OF(name=u'mdt-Allowed-PLMN-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Allowed-PLMNId-List')), opt=True)
    MDT_Configuration._cont = ASN1Dict([
        (u'jobType', _MDT_Configuration_jobType),
        (u'areaScope', _MDT_Configuration_areaScope),
        (u'listOfMeasurements', _MDT_Configuration_listOfMeasurements),
        (u'reportingTrigger', _MDT_Configuration_reportingTrigger),
        (u'reportInterval', _MDT_Configuration_reportInterval),
        (u'reportAmount', _MDT_Configuration_reportAmount),
        (u'eventThresholdRSRP', _MDT_Configuration_eventThresholdRSRP),
        (u'eventThresholdRSRQ', _MDT_Configuration_eventThresholdRSRQ),
        (u'loggingInterval', _MDT_Configuration_loggingInterval),
        (u'loggingDuration', _MDT_Configuration_loggingDuration),
        (u'extensionContainer', _MDT_Configuration_extensionContainer),
        (u'measurementPeriodUMTS', _MDT_Configuration_measurementPeriodUMTS),
        (u'measurementPeriodLTE', _MDT_Configuration_measurementPeriodLTE),
        (u'collectionPeriodRRM-UMTS', _MDT_Configuration_collectionPeriodRRM_UMTS),
        (u'collectionPeriodRRM-LTE', _MDT_Configuration_collectionPeriodRRM_LTE),
        (u'positioningMethod', _MDT_Configuration_positioningMethod),
        (u'measurementQuantity', _MDT_Configuration_measurementQuantity),
        (u'eventThreshold1F', _MDT_Configuration_eventThreshold1F),
        (u'eventThreshold1I', _MDT_Configuration_eventThreshold1I),
        (u'mdt-Allowed-PLMN-List', _MDT_Configuration_mdt_Allowed_PLMN_List),
        ])
    MDT_Configuration._ext = [u'measurementPeriodUMTS', u'measurementPeriodLTE', u'collectionPeriodRRM-UMTS', u'collectionPeriodRRM-LTE', u'positioningMethod', u'measurementQuantity', u'eventThreshold1F', u'eventThreshold1I', u'mdt-Allowed-PLMN-List']
    
    #-----< MDT-Allowed-PLMNId-List >-----#
    MDT_Allowed_PLMNId_List = SEQ_OF(name=u'MDT-Allowed-PLMNId-List', mode=MODE_TYPE)
    _MDT_Allowed_PLMNId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    MDT_Allowed_PLMNId_List._cont = _MDT_Allowed_PLMNId_List__item_
    MDT_Allowed_PLMNId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodUMTS >-----#
    PeriodUMTS = ENUM(name=u'PeriodUMTS', mode=MODE_TYPE)
    PeriodUMTS._cont = ASN1Dict([(u'd250ms', 0), (u'd500ms', 1), (u'd1000ms', 2), (u'd2000ms', 3), (u'd3000ms', 4), (u'd4000ms', 5), (u'd6000ms', 6), (u'd8000ms', 7), (u'd12000ms', 8), (u'd16000ms', 9), (u'd20000ms', 10), (u'd24000ms', 11), (u'd28000ms', 12), (u'd32000ms', 13), (u'd64000ms', 14)])
    PeriodUMTS._ext = None
    
    #-----< PeriodLTE >-----#
    PeriodLTE = ENUM(name=u'PeriodLTE', mode=MODE_TYPE)
    PeriodLTE._cont = ASN1Dict([(u'd1024ms', 0), (u'd1280ms', 1), (u'd2048ms', 2), (u'd2560ms', 3), (u'd5120ms', 4), (u'd10240ms', 5), (u'd1min', 6)])
    PeriodLTE._ext = None
    
    #-----< PositioningMethod >-----#
    PositioningMethod = OCT_STR(name=u'PositioningMethod', mode=MODE_TYPE)
    PositioningMethod._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = OCT_STR(name=u'MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EventThreshold1F >-----#
    EventThreshold1F = INT(name=u'EventThreshold1F', mode=MODE_TYPE)
    EventThreshold1F._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    
    #-----< EventThreshold1I >-----#
    EventThreshold1I = INT(name=u'EventThreshold1I', mode=MODE_TYPE)
    EventThreshold1I._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    
    #-----< JobType >-----#
    JobType = ENUM(name=u'JobType', mode=MODE_TYPE)
    JobType._cont = ASN1Dict([(u'immediate-MDT-only', 0), (u'logged-MDT-only', 1), (u'trace-only', 2), (u'immediate-MDT-and-trace', 3)])
    JobType._ext = None
    
    #-----< AreaScope >-----#
    AreaScope = SEQ(name=u'AreaScope', mode=MODE_TYPE)
    _AreaScope_cgi_List = SEQ_OF(name=u'cgi-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'CGI-List')), opt=True)
    _AreaScope_e_utran_cgi_List = SEQ_OF(name=u'e-utran-cgi-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'E-UTRAN-CGI-List')), opt=True)
    _AreaScope_routingAreaId_List = SEQ_OF(name=u'routingAreaId-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RoutingAreaId-List')), opt=True)
    _AreaScope_locationAreaId_List = SEQ_OF(name=u'locationAreaId-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LocationAreaId-List')), opt=True)
    _AreaScope_trackingAreaId_List = SEQ_OF(name=u'trackingAreaId-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TrackingAreaId-List')), opt=True)
    _AreaScope_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AreaScope._cont = ASN1Dict([
        (u'cgi-List', _AreaScope_cgi_List),
        (u'e-utran-cgi-List', _AreaScope_e_utran_cgi_List),
        (u'routingAreaId-List', _AreaScope_routingAreaId_List),
        (u'locationAreaId-List', _AreaScope_locationAreaId_List),
        (u'trackingAreaId-List', _AreaScope_trackingAreaId_List),
        (u'extensionContainer', _AreaScope_extensionContainer),
        ])
    AreaScope._ext = []
    
    #-----< CGI-List >-----#
    CGI_List = SEQ_OF(name=u'CGI-List', mode=MODE_TYPE)
    _CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')))
    CGI_List._cont = _CGI_List__item_
    CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-UTRAN-CGI-List >-----#
    E_UTRAN_CGI_List = SEQ_OF(name=u'E-UTRAN-CGI-List', mode=MODE_TYPE)
    _E_UTRAN_CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')))
    E_UTRAN_CGI_List._cont = _E_UTRAN_CGI_List__item_
    E_UTRAN_CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< RoutingAreaId-List >-----#
    RoutingAreaId_List = SEQ_OF(name=u'RoutingAreaId-List', mode=MODE_TYPE)
    _RoutingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')))
    RoutingAreaId_List._cont = _RoutingAreaId_List__item_
    RoutingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationAreaId-List >-----#
    LocationAreaId_List = SEQ_OF(name=u'LocationAreaId-List', mode=MODE_TYPE)
    _LocationAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    LocationAreaId_List._cont = _LocationAreaId_List__item_
    LocationAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TrackingAreaId-List >-----#
    TrackingAreaId_List = SEQ_OF(name=u'TrackingAreaId-List', mode=MODE_TYPE)
    _TrackingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')))
    TrackingAreaId_List._cont = _TrackingAreaId_List__item_
    TrackingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ListOfMeasurements >-----#
    ListOfMeasurements = OCT_STR(name=u'ListOfMeasurements', mode=MODE_TYPE)
    ListOfMeasurements._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ReportingTrigger >-----#
    ReportingTrigger = OCT_STR(name=u'ReportingTrigger', mode=MODE_TYPE)
    ReportingTrigger._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name=u'ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([(u'umts250ms', 0), (u'umts500ms', 1), (u'umts1000ms', 2), (u'umts2000ms', 3), (u'umts3000ms', 4), (u'umts4000ms', 5), (u'umts6000ms', 6), (u'umts8000ms', 7), (u'umts12000ms', 8), (u'umts16000ms', 9), (u'umts20000ms', 10), (u'umts24000ms', 11), (u'umts28000ms', 12), (u'umts32000ms', 13), (u'umts64000ms', 14), (u'lte120ms', 15), (u'lte240ms', 16), (u'lte480ms', 17), (u'lte640ms', 18), (u'lte1024ms', 19), (u'lte2048ms', 20), (u'lte5120ms', 21), (u'lte10240ms', 22), (u'lte1min', 23), (u'lte6min', 24), (u'lte12min', 25), (u'lte30min', 26), (u'lte60min', 27)])
    ReportInterval._ext = None
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name=u'ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([(u'd1', 0), (u'd2', 1), (u'd4', 2), (u'd8', 3), (u'd16', 4), (u'd32', 5), (u'd64', 6), (u'infinity', 7)])
    ReportAmount._ext = None
    
    #-----< EventThresholdRSRP >-----#
    EventThresholdRSRP = INT(name=u'EventThresholdRSRP', mode=MODE_TYPE)
    EventThresholdRSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< EventThresholdRSRQ >-----#
    EventThresholdRSRQ = INT(name=u'EventThresholdRSRQ', mode=MODE_TYPE)
    EventThresholdRSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name=u'LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([(u'd1dot28', 0), (u'd2dot56', 1), (u'd5dot12', 2), (u'd10dot24', 3), (u'd20dot48', 4), (u'd30dot72', 5), (u'd40dot96', 6), (u'd61dot44', 7)])
    LoggingInterval._ext = None
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name=u'LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([(u'd600sec', 0), (u'd1200sec', 1), (u'd2400sec', 2), (u'd3600sec', 3), (u'd5400sec', 4), (u'd7200sec', 5)])
    LoggingDuration._ext = None
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name=u'TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TraceReference2 >-----#
    TraceReference2 = OCT_STR(name=u'TraceReference2', mode=MODE_TYPE)
    TraceReference2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = OCT_STR(name=u'TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TraceType >-----#
    TraceType = INT(name=u'TraceType', mode=MODE_TYPE)
    TraceType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TraceDepthList >-----#
    TraceDepthList = SEQ(name=u'TraceDepthList', mode=MODE_TYPE)
    _TraceDepthList_msc_s_TraceDepth = ENUM(name=u'msc-s-TraceDepth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mgw_TraceDepth = ENUM(name=u'mgw-TraceDepth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgsn_TraceDepth = ENUM(name=u'sgsn-TraceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_ggsn_TraceDepth = ENUM(name=u'ggsn-TraceDepth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_rnc_TraceDepth = ENUM(name=u'rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_bmsc_TraceDepth = ENUM(name=u'bmsc-TraceDepth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mme_TraceDepth = ENUM(name=u'mme-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgw_TraceDepth = ENUM(name=u'sgw-TraceDepth', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_pgw_TraceDepth = ENUM(name=u'pgw-TraceDepth', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_eNB_TraceDepth = ENUM(name=u'eNB-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_msc_s_TraceDepthExtension = ENUM(name=u'msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mgw_TraceDepthExtension = ENUM(name=u'mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgsn_TraceDepthExtension = ENUM(name=u'sgsn-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_ggsn_TraceDepthExtension = ENUM(name=u'ggsn-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_rnc_TraceDepthExtension = ENUM(name=u'rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_bmsc_TraceDepthExtension = ENUM(name=u'bmsc-TraceDepthExtension', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mme_TraceDepthExtension = ENUM(name=u'mme-TraceDepthExtension', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgw_TraceDepthExtension = ENUM(name=u'sgw-TraceDepthExtension', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_pgw_TraceDepthExtension = ENUM(name=u'pgw-TraceDepthExtension', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_eNB_TraceDepthExtension = ENUM(name=u'eNB-TraceDepthExtension', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TraceDepthList._cont = ASN1Dict([
        (u'msc-s-TraceDepth', _TraceDepthList_msc_s_TraceDepth),
        (u'mgw-TraceDepth', _TraceDepthList_mgw_TraceDepth),
        (u'sgsn-TraceDepth', _TraceDepthList_sgsn_TraceDepth),
        (u'ggsn-TraceDepth', _TraceDepthList_ggsn_TraceDepth),
        (u'rnc-TraceDepth', _TraceDepthList_rnc_TraceDepth),
        (u'bmsc-TraceDepth', _TraceDepthList_bmsc_TraceDepth),
        (u'mme-TraceDepth', _TraceDepthList_mme_TraceDepth),
        (u'sgw-TraceDepth', _TraceDepthList_sgw_TraceDepth),
        (u'pgw-TraceDepth', _TraceDepthList_pgw_TraceDepth),
        (u'eNB-TraceDepth', _TraceDepthList_eNB_TraceDepth),
        (u'msc-s-TraceDepthExtension', _TraceDepthList_msc_s_TraceDepthExtension),
        (u'mgw-TraceDepthExtension', _TraceDepthList_mgw_TraceDepthExtension),
        (u'sgsn-TraceDepthExtension', _TraceDepthList_sgsn_TraceDepthExtension),
        (u'ggsn-TraceDepthExtension', _TraceDepthList_ggsn_TraceDepthExtension),
        (u'rnc-TraceDepthExtension', _TraceDepthList_rnc_TraceDepthExtension),
        (u'bmsc-TraceDepthExtension', _TraceDepthList_bmsc_TraceDepthExtension),
        (u'mme-TraceDepthExtension', _TraceDepthList_mme_TraceDepthExtension),
        (u'sgw-TraceDepthExtension', _TraceDepthList_sgw_TraceDepthExtension),
        (u'pgw-TraceDepthExtension', _TraceDepthList_pgw_TraceDepthExtension),
        (u'eNB-TraceDepthExtension', _TraceDepthList_eNB_TraceDepthExtension),
        ])
    TraceDepthList._ext = [u'mme-TraceDepth', u'sgw-TraceDepth', u'pgw-TraceDepth', u'eNB-TraceDepth', u'msc-s-TraceDepthExtension', u'mgw-TraceDepthExtension', u'sgsn-TraceDepthExtension', u'ggsn-TraceDepthExtension', u'rnc-TraceDepthExtension', u'bmsc-TraceDepthExtension', u'mme-TraceDepthExtension', u'sgw-TraceDepthExtension', u'pgw-TraceDepthExtension', u'eNB-TraceDepthExtension']
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceDepthExtension >-----#
    TraceDepthExtension = ENUM(name=u'TraceDepthExtension', mode=MODE_TYPE)
    TraceDepthExtension._cont = ASN1Dict([(u'minimumWithoutVendorSpecificExtension', 0), (u'mediumWithoutVendorSpecificExtension', 1), (u'maximumWithoutVendorSpecificExtension', 2)])
    TraceDepthExtension._ext = []
    
    #-----< TraceNE-TypeList >-----#
    TraceNE_TypeList = BIT_STR(name=u'TraceNE-TypeList', mode=MODE_TYPE)
    TraceNE_TypeList._cont = ASN1Dict([(u'msc-s', 0), (u'mgw', 1), (u'sgsn', 2), (u'ggsn', 3), (u'rnc', 4), (u'bm-sc', 5), (u'mme', 6), (u'sgw', 7), (u'pgw', 8), (u'eNB', 9)])
    TraceNE_TypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=16)], ev=None, er=[])
    
    #-----< TraceInterfaceList >-----#
    TraceInterfaceList = SEQ(name=u'TraceInterfaceList', mode=MODE_TYPE)
    _TraceInterfaceList_msc_s_List = BIT_STR(name=u'msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TraceInterfaceList_mgw_List = BIT_STR(name=u'mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TraceInterfaceList_sgsn_List = BIT_STR(name=u'sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_ggsn_List = BIT_STR(name=u'ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_rnc_List = BIT_STR(name=u'rnc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TraceInterfaceList_bmsc_List = BIT_STR(name=u'bmsc-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-InterfaceList')), opt=True)
    _TraceInterfaceList_mme_List = BIT_STR(name=u'mme-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-InterfaceList')), opt=True)
    _TraceInterfaceList_sgw_List = BIT_STR(name=u'sgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-InterfaceList')), opt=True)
    _TraceInterfaceList_pgw_List = BIT_STR(name=u'pgw-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-InterfaceList')), opt=True)
    _TraceInterfaceList_eNB_List = BIT_STR(name=u'eNB-List', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ENB-InterfaceList')), opt=True)
    TraceInterfaceList._cont = ASN1Dict([
        (u'msc-s-List', _TraceInterfaceList_msc_s_List),
        (u'mgw-List', _TraceInterfaceList_mgw_List),
        (u'sgsn-List', _TraceInterfaceList_sgsn_List),
        (u'ggsn-List', _TraceInterfaceList_ggsn_List),
        (u'rnc-List', _TraceInterfaceList_rnc_List),
        (u'bmsc-List', _TraceInterfaceList_bmsc_List),
        (u'mme-List', _TraceInterfaceList_mme_List),
        (u'sgw-List', _TraceInterfaceList_sgw_List),
        (u'pgw-List', _TraceInterfaceList_pgw_List),
        (u'eNB-List', _TraceInterfaceList_eNB_List),
        ])
    TraceInterfaceList._ext = [u'mme-List', u'sgw-List', u'pgw-List', u'eNB-List']
    
    #-----< MSC-S-InterfaceList >-----#
    MSC_S_InterfaceList = BIT_STR(name=u'MSC-S-InterfaceList', mode=MODE_TYPE)
    MSC_S_InterfaceList._cont = ASN1Dict([(u'a', 0), (u'iu', 1), (u'mc', 2), (u'map-g', 3), (u'map-b', 4), (u'map-e', 5), (u'map-f', 6), (u'cap', 7), (u'map-d', 8), (u'map-c', 9)])
    MSC_S_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=16)], ev=None, er=[])
    
    #-----< MGW-InterfaceList >-----#
    MGW_InterfaceList = BIT_STR(name=u'MGW-InterfaceList', mode=MODE_TYPE)
    MGW_InterfaceList._cont = ASN1Dict([(u'mc', 0), (u'nb-up', 1), (u'iu-up', 2)])
    MGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-InterfaceList >-----#
    SGSN_InterfaceList = BIT_STR(name=u'SGSN-InterfaceList', mode=MODE_TYPE)
    SGSN_InterfaceList._cont = ASN1Dict([(u'gb', 0), (u'iu', 1), (u'gn', 2), (u'map-gr', 3), (u'map-gd', 4), (u'map-gf', 5), (u'gs', 6), (u'ge', 7), (u's3', 8), (u's4', 9), (u's6d', 10)])
    SGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< GGSN-InterfaceList >-----#
    GGSN_InterfaceList = BIT_STR(name=u'GGSN-InterfaceList', mode=MODE_TYPE)
    GGSN_InterfaceList._cont = ASN1Dict([(u'gn', 0), (u'gi', 1), (u'gmb', 2)])
    GGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< RNC-InterfaceList >-----#
    RNC_InterfaceList = BIT_STR(name=u'RNC-InterfaceList', mode=MODE_TYPE)
    RNC_InterfaceList._cont = ASN1Dict([(u'iu', 0), (u'iur', 1), (u'iub', 2), (u'uu', 3)])
    RNC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BMSC-InterfaceList >-----#
    BMSC_InterfaceList = BIT_STR(name=u'BMSC-InterfaceList', mode=MODE_TYPE)
    BMSC_InterfaceList._cont = ASN1Dict([(u'gmb', 0)])
    BMSC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-InterfaceList >-----#
    MME_InterfaceList = BIT_STR(name=u'MME-InterfaceList', mode=MODE_TYPE)
    MME_InterfaceList._cont = ASN1Dict([(u's1-mme', 0), (u's3', 1), (u's6a', 2), (u's10', 3), (u's11', 4)])
    MME_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< SGW-InterfaceList >-----#
    SGW_InterfaceList = BIT_STR(name=u'SGW-InterfaceList', mode=MODE_TYPE)
    SGW_InterfaceList._cont = ASN1Dict([(u's4', 0), (u's5', 1), (u's8b', 2), (u's11', 3), (u'gxc', 4)])
    SGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< PGW-InterfaceList >-----#
    PGW_InterfaceList = BIT_STR(name=u'PGW-InterfaceList', mode=MODE_TYPE)
    PGW_InterfaceList._cont = ASN1Dict([(u's2a', 0), (u's2b', 1), (u's2c', 2), (u's5', 3), (u's6b', 4), (u'gx', 5), (u's8b', 6), (u'sgi', 7)])
    PGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< ENB-InterfaceList >-----#
    ENB_InterfaceList = BIT_STR(name=u'ENB-InterfaceList', mode=MODE_TYPE)
    ENB_InterfaceList._cont = ASN1Dict([(u's1-mme', 0), (u'x2', 1), (u'uu', 2)])
    ENB_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TraceEventList >-----#
    TraceEventList = SEQ(name=u'TraceEventList', mode=MODE_TYPE)
    _TraceEventList_msc_s_List = BIT_STR(name=u'msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TraceEventList_mgw_List = BIT_STR(name=u'mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TraceEventList_sgsn_List = BIT_STR(name=u'sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-EventList')), opt=True)
    _TraceEventList_ggsn_List = BIT_STR(name=u'ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-EventList')), opt=True)
    _TraceEventList_bmsc_List = BIT_STR(name=u'bmsc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-EventList')), opt=True)
    _TraceEventList_mme_List = BIT_STR(name=u'mme-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-EventList')), opt=True)
    _TraceEventList_sgw_List = BIT_STR(name=u'sgw-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-EventList')), opt=True)
    _TraceEventList_pgw_List = BIT_STR(name=u'pgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-EventList')), opt=True)
    TraceEventList._cont = ASN1Dict([
        (u'msc-s-List', _TraceEventList_msc_s_List),
        (u'mgw-List', _TraceEventList_mgw_List),
        (u'sgsn-List', _TraceEventList_sgsn_List),
        (u'ggsn-List', _TraceEventList_ggsn_List),
        (u'bmsc-List', _TraceEventList_bmsc_List),
        (u'mme-List', _TraceEventList_mme_List),
        (u'sgw-List', _TraceEventList_sgw_List),
        (u'pgw-List', _TraceEventList_pgw_List),
        ])
    TraceEventList._ext = [u'mme-List', u'sgw-List', u'pgw-List']
    
    #-----< MSC-S-EventList >-----#
    MSC_S_EventList = BIT_STR(name=u'MSC-S-EventList', mode=MODE_TYPE)
    MSC_S_EventList._cont = ASN1Dict([(u'mo-mtCall', 0), (u'mo-mt-sms', 1), (u'lu-imsiAttach-imsiDetach', 2), (u'handovers', 3), (u'ss', 4)])
    MSC_S_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=16)], ev=None, er=[])
    
    #-----< MGW-EventList >-----#
    MGW_EventList = BIT_STR(name=u'MGW-EventList', mode=MODE_TYPE)
    MGW_EventList._cont = ASN1Dict([(u'context', 0)])
    MGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SGSN-EventList >-----#
    SGSN_EventList = BIT_STR(name=u'SGSN-EventList', mode=MODE_TYPE)
    SGSN_EventList._cont = ASN1Dict([(u'pdpContext', 0), (u'mo-mt-sms', 1), (u'rau-gprsAttach-gprsDetach', 2), (u'mbmsContext', 3)])
    SGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< GGSN-EventList >-----#
    GGSN_EventList = BIT_STR(name=u'GGSN-EventList', mode=MODE_TYPE)
    GGSN_EventList._cont = ASN1Dict([(u'pdpContext', 0), (u'mbmsContext', 1)])
    GGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< BMSC-EventList >-----#
    BMSC_EventList = BIT_STR(name=u'BMSC-EventList', mode=MODE_TYPE)
    BMSC_EventList._cont = ASN1Dict([(u'mbmsMulticastServiceActivation', 0)])
    BMSC_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-EventList >-----#
    MME_EventList = BIT_STR(name=u'MME-EventList', mode=MODE_TYPE)
    MME_EventList._cont = ASN1Dict([(u'ue-initiatedPDNconectivityRequest', 0), (u'serviceRequestts', 1), (u'initialAttachTrackingAreaUpdateDetach', 2), (u'ue-initiatedPDNdisconnection', 3), (u'bearerActivationModificationDeletion', 4), (u'handover', 5)])
    MME_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=8)], ev=None, er=[])
    
    #-----< SGW-EventList >-----#
    SGW_EventList = BIT_STR(name=u'SGW-EventList', mode=MODE_TYPE)
    SGW_EventList._cont = ASN1Dict([(u'pdn-connectionCreation', 0), (u'pdn-connectionTermination', 1), (u'bearerActivationModificationDeletion', 2)])
    SGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< PGW-EventList >-----#
    PGW_EventList = BIT_STR(name=u'PGW-EventList', mode=MODE_TYPE)
    PGW_EventList._cont = ASN1Dict([(u'pdn-connectionCreation', 0), (u'pdn-connectionTermination', 1), (u'bearerActivationModificationDeletion', 2)])
    PGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TracePropagationList >-----#
    TracePropagationList = SEQ(name=u'TracePropagationList', mode=MODE_TYPE)
    _TracePropagationList_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')), opt=True)
    _TracePropagationList_traceType = INT(name=u'traceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')), opt=True)
    _TracePropagationList_traceReference2 = OCT_STR(name=u'traceReference2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _TracePropagationList_traceRecordingSessionReference = OCT_STR(name=u'traceRecordingSessionReference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceRecordingSessionReference')), opt=True)
    _TracePropagationList_rnc_TraceDepth = ENUM(name=u'rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_rnc_InterfaceList = BIT_STR(name=u'rnc-InterfaceList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_TraceDepth = ENUM(name=u'msc-s-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_msc_s_InterfaceList = BIT_STR(name=u'msc-s-InterfaceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_EventList = BIT_STR(name=u'msc-s-EventList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TracePropagationList_mgw_TraceDepth = ENUM(name=u'mgw-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_mgw_InterfaceList = BIT_STR(name=u'mgw-InterfaceList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TracePropagationList_mgw_EventList = BIT_STR(name=u'mgw-EventList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TracePropagationList_rnc_TraceDepthExtension = ENUM(name=u'rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_msc_s_TraceDepthExtension = ENUM(name=u'msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_mgw_TraceDepthExtension = ENUM(name=u'mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TracePropagationList._cont = ASN1Dict([
        (u'traceReference', _TracePropagationList_traceReference),
        (u'traceType', _TracePropagationList_traceType),
        (u'traceReference2', _TracePropagationList_traceReference2),
        (u'traceRecordingSessionReference', _TracePropagationList_traceRecordingSessionReference),
        (u'rnc-TraceDepth', _TracePropagationList_rnc_TraceDepth),
        (u'rnc-InterfaceList', _TracePropagationList_rnc_InterfaceList),
        (u'msc-s-TraceDepth', _TracePropagationList_msc_s_TraceDepth),
        (u'msc-s-InterfaceList', _TracePropagationList_msc_s_InterfaceList),
        (u'msc-s-EventList', _TracePropagationList_msc_s_EventList),
        (u'mgw-TraceDepth', _TracePropagationList_mgw_TraceDepth),
        (u'mgw-InterfaceList', _TracePropagationList_mgw_InterfaceList),
        (u'mgw-EventList', _TracePropagationList_mgw_EventList),
        (u'rnc-TraceDepthExtension', _TracePropagationList_rnc_TraceDepthExtension),
        (u'msc-s-TraceDepthExtension', _TracePropagationList_msc_s_TraceDepthExtension),
        (u'mgw-TraceDepthExtension', _TracePropagationList_mgw_TraceDepthExtension),
        ])
    TracePropagationList._ext = [u'rnc-TraceDepthExtension', u'msc-s-TraceDepthExtension', u'mgw-TraceDepthExtension']
    
    #-----< ActivateTraceModeRes >-----#
    ActivateTraceModeRes = SEQ(name=u'ActivateTraceModeRes', mode=MODE_TYPE)
    _ActivateTraceModeRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeRes_traceSupportIndicator = NULL(name=u'traceSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ActivateTraceModeRes._cont = ASN1Dict([
        (u'extensionContainer', _ActivateTraceModeRes_extensionContainer),
        (u'traceSupportIndicator', _ActivateTraceModeRes_traceSupportIndicator),
        ])
    ActivateTraceModeRes._ext = [u'traceSupportIndicator']
    
    #-----< DeactivateTraceModeArg >-----#
    DeactivateTraceModeArg = SEQ(name=u'DeactivateTraceModeArg', mode=MODE_TYPE)
    _DeactivateTraceModeArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _DeactivateTraceModeArg_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _DeactivateTraceModeArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeactivateTraceModeArg_traceReference2 = OCT_STR(name=u'traceReference2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    DeactivateTraceModeArg._cont = ASN1Dict([
        (u'imsi', _DeactivateTraceModeArg_imsi),
        (u'traceReference', _DeactivateTraceModeArg_traceReference),
        (u'extensionContainer', _DeactivateTraceModeArg_extensionContainer),
        (u'traceReference2', _DeactivateTraceModeArg_traceReference2),
        ])
    DeactivateTraceModeArg._ext = [u'traceReference2']
    
    #-----< DeactivateTraceModeRes >-----#
    DeactivateTraceModeRes = SEQ(name=u'DeactivateTraceModeRes', mode=MODE_TYPE)
    _DeactivateTraceModeRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeactivateTraceModeRes._cont = ASN1Dict([
        (u'extensionContainer', _DeactivateTraceModeRes_extensionContainer),
        ])
    DeactivateTraceModeRes._ext = []
    
    _all_ = [
        _ActivateTraceModeArg_imsi,
        _ActivateTraceModeArg_traceReference,
        _ActivateTraceModeArg_traceType,
        _ActivateTraceModeArg_omc_Id,
        _ActivateTraceModeArg_extensionContainer,
        _ActivateTraceModeArg_traceReference2,
        _ActivateTraceModeArg_traceDepthList,
        _ActivateTraceModeArg_traceNE_TypeList,
        _ActivateTraceModeArg_traceInterfaceList,
        _ActivateTraceModeArg_traceEventList,
        _ActivateTraceModeArg_traceCollectionEntity,
        _ActivateTraceModeArg_mdt_Configuration,
        ActivateTraceModeArg,
        _MDT_Configuration_jobType,
        _MDT_Configuration_areaScope,
        _MDT_Configuration_listOfMeasurements,
        _MDT_Configuration_reportingTrigger,
        _MDT_Configuration_reportInterval,
        _MDT_Configuration_reportAmount,
        _MDT_Configuration_eventThresholdRSRP,
        _MDT_Configuration_eventThresholdRSRQ,
        _MDT_Configuration_loggingInterval,
        _MDT_Configuration_loggingDuration,
        _MDT_Configuration_extensionContainer,
        _MDT_Configuration_measurementPeriodUMTS,
        _MDT_Configuration_measurementPeriodLTE,
        _MDT_Configuration_collectionPeriodRRM_UMTS,
        _MDT_Configuration_collectionPeriodRRM_LTE,
        _MDT_Configuration_positioningMethod,
        _MDT_Configuration_measurementQuantity,
        _MDT_Configuration_eventThreshold1F,
        _MDT_Configuration_eventThreshold1I,
        _MDT_Configuration_mdt_Allowed_PLMN_List,
        MDT_Configuration,
        _MDT_Allowed_PLMNId_List__item_,
        MDT_Allowed_PLMNId_List,
        PeriodUMTS,
        PeriodLTE,
        PositioningMethod,
        MeasurementQuantity,
        EventThreshold1F,
        EventThreshold1I,
        JobType,
        _AreaScope_cgi_List,
        _AreaScope_e_utran_cgi_List,
        _AreaScope_routingAreaId_List,
        _AreaScope_locationAreaId_List,
        _AreaScope_trackingAreaId_List,
        _AreaScope_extensionContainer,
        AreaScope,
        _CGI_List__item_,
        CGI_List,
        _E_UTRAN_CGI_List__item_,
        E_UTRAN_CGI_List,
        _RoutingAreaId_List__item_,
        RoutingAreaId_List,
        _LocationAreaId_List__item_,
        LocationAreaId_List,
        _TrackingAreaId_List__item_,
        TrackingAreaId_List,
        ListOfMeasurements,
        ReportingTrigger,
        ReportInterval,
        ReportAmount,
        EventThresholdRSRP,
        EventThresholdRSRQ,
        LoggingInterval,
        LoggingDuration,
        TraceReference,
        TraceReference2,
        TraceRecordingSessionReference,
        TraceType,
        _TraceDepthList_msc_s_TraceDepth,
        _TraceDepthList_mgw_TraceDepth,
        _TraceDepthList_sgsn_TraceDepth,
        _TraceDepthList_ggsn_TraceDepth,
        _TraceDepthList_rnc_TraceDepth,
        _TraceDepthList_bmsc_TraceDepth,
        _TraceDepthList_mme_TraceDepth,
        _TraceDepthList_sgw_TraceDepth,
        _TraceDepthList_pgw_TraceDepth,
        _TraceDepthList_eNB_TraceDepth,
        _TraceDepthList_msc_s_TraceDepthExtension,
        _TraceDepthList_mgw_TraceDepthExtension,
        _TraceDepthList_sgsn_TraceDepthExtension,
        _TraceDepthList_ggsn_TraceDepthExtension,
        _TraceDepthList_rnc_TraceDepthExtension,
        _TraceDepthList_bmsc_TraceDepthExtension,
        _TraceDepthList_mme_TraceDepthExtension,
        _TraceDepthList_sgw_TraceDepthExtension,
        _TraceDepthList_pgw_TraceDepthExtension,
        _TraceDepthList_eNB_TraceDepthExtension,
        TraceDepthList,
        TraceDepth,
        TraceDepthExtension,
        TraceNE_TypeList,
        _TraceInterfaceList_msc_s_List,
        _TraceInterfaceList_mgw_List,
        _TraceInterfaceList_sgsn_List,
        _TraceInterfaceList_ggsn_List,
        _TraceInterfaceList_rnc_List,
        _TraceInterfaceList_bmsc_List,
        _TraceInterfaceList_mme_List,
        _TraceInterfaceList_sgw_List,
        _TraceInterfaceList_pgw_List,
        _TraceInterfaceList_eNB_List,
        TraceInterfaceList,
        MSC_S_InterfaceList,
        MGW_InterfaceList,
        SGSN_InterfaceList,
        GGSN_InterfaceList,
        RNC_InterfaceList,
        BMSC_InterfaceList,
        MME_InterfaceList,
        SGW_InterfaceList,
        PGW_InterfaceList,
        ENB_InterfaceList,
        _TraceEventList_msc_s_List,
        _TraceEventList_mgw_List,
        _TraceEventList_sgsn_List,
        _TraceEventList_ggsn_List,
        _TraceEventList_bmsc_List,
        _TraceEventList_mme_List,
        _TraceEventList_sgw_List,
        _TraceEventList_pgw_List,
        TraceEventList,
        MSC_S_EventList,
        MGW_EventList,
        SGSN_EventList,
        GGSN_EventList,
        BMSC_EventList,
        MME_EventList,
        SGW_EventList,
        PGW_EventList,
        _TracePropagationList_traceReference,
        _TracePropagationList_traceType,
        _TracePropagationList_traceReference2,
        _TracePropagationList_traceRecordingSessionReference,
        _TracePropagationList_rnc_TraceDepth,
        _TracePropagationList_rnc_InterfaceList,
        _TracePropagationList_msc_s_TraceDepth,
        _TracePropagationList_msc_s_InterfaceList,
        _TracePropagationList_msc_s_EventList,
        _TracePropagationList_mgw_TraceDepth,
        _TracePropagationList_mgw_InterfaceList,
        _TracePropagationList_mgw_EventList,
        _TracePropagationList_rnc_TraceDepthExtension,
        _TracePropagationList_msc_s_TraceDepthExtension,
        _TracePropagationList_mgw_TraceDepthExtension,
        TracePropagationList,
        _ActivateTraceModeRes_extensionContainer,
        _ActivateTraceModeRes_traceSupportIndicator,
        ActivateTraceModeRes,
        _DeactivateTraceModeArg_imsi,
        _DeactivateTraceModeArg_traceReference,
        _DeactivateTraceModeArg_extensionContainer,
        _DeactivateTraceModeArg_traceReference2,
        DeactivateTraceModeArg,
        _DeactivateTraceModeRes_extensionContainer,
        DeactivateTraceModeRes,
    ]

class MAP_SS_Code:

    _name_  = u'MAP-SS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 15, 19]
    
    _obj_ = [
        u'SS-Code',
        u'allSS',
        u'allLineIdentificationSS',
        u'clip',
        u'clir',
        u'colp',
        u'colr',
        u'mci',
        u'allNameIdentificationSS',
        u'cnap',
        u'allForwardingSS',
        u'cfu',
        u'allCondForwardingSS',
        u'cfb',
        u'cfnry',
        u'cfnrc',
        u'cd',
        u'allCallOfferingSS',
        u'ect',
        u'mah',
        u'allCallCompletionSS',
        u'cw',
        u'hold',
        u'ccbs-A',
        u'ccbs-B',
        u'mc',
        u'allMultiPartySS',
        u'multiPTY',
        u'allCommunityOfInterest-SS',
        u'cug',
        u'allChargingSS',
        u'aoci',
        u'aocc',
        u'allAdditionalInfoTransferSS',
        u'uus1',
        u'uus2',
        u'uus3',
        u'allBarringSS',
        u'barringOfOutgoingCalls',
        u'baoc',
        u'boic',
        u'boicExHC',
        u'barringOfIncomingCalls',
        u'baic',
        u'bicRoam',
        u'allPLMN-specificSS',
        u'plmn-specificSS-1',
        u'plmn-specificSS-2',
        u'plmn-specificSS-3',
        u'plmn-specificSS-4',
        u'plmn-specificSS-5',
        u'plmn-specificSS-6',
        u'plmn-specificSS-7',
        u'plmn-specificSS-8',
        u'plmn-specificSS-9',
        u'plmn-specificSS-A',
        u'plmn-specificSS-B',
        u'plmn-specificSS-C',
        u'plmn-specificSS-D',
        u'plmn-specificSS-E',
        u'plmn-specificSS-F',
        u'allCallPrioritySS',
        u'emlpp',
        u'allLCSPrivacyException',
        u'universal',
        u'callSessionRelated',
        u'callSessionUnrelated',
        u'plmnoperator',
        u'serviceType',
        u'allMOLR-SS',
        u'basicSelfLocation',
        u'autonomousSelfLocation',
        u'transferToThirdParty',
        ]
    _type_ = [
        u'SS-Code',
        ]
    _set_ = [
        ]
    _val_ = [
        u'allSS',
        u'allLineIdentificationSS',
        u'clip',
        u'clir',
        u'colp',
        u'colr',
        u'mci',
        u'allNameIdentificationSS',
        u'cnap',
        u'allForwardingSS',
        u'cfu',
        u'allCondForwardingSS',
        u'cfb',
        u'cfnry',
        u'cfnrc',
        u'cd',
        u'allCallOfferingSS',
        u'ect',
        u'mah',
        u'allCallCompletionSS',
        u'cw',
        u'hold',
        u'ccbs-A',
        u'ccbs-B',
        u'mc',
        u'allMultiPartySS',
        u'multiPTY',
        u'allCommunityOfInterest-SS',
        u'cug',
        u'allChargingSS',
        u'aoci',
        u'aocc',
        u'allAdditionalInfoTransferSS',
        u'uus1',
        u'uus2',
        u'uus3',
        u'allBarringSS',
        u'barringOfOutgoingCalls',
        u'baoc',
        u'boic',
        u'boicExHC',
        u'barringOfIncomingCalls',
        u'baic',
        u'bicRoam',
        u'allPLMN-specificSS',
        u'plmn-specificSS-1',
        u'plmn-specificSS-2',
        u'plmn-specificSS-3',
        u'plmn-specificSS-4',
        u'plmn-specificSS-5',
        u'plmn-specificSS-6',
        u'plmn-specificSS-7',
        u'plmn-specificSS-8',
        u'plmn-specificSS-9',
        u'plmn-specificSS-A',
        u'plmn-specificSS-B',
        u'plmn-specificSS-C',
        u'plmn-specificSS-D',
        u'plmn-specificSS-E',
        u'plmn-specificSS-F',
        u'allCallPrioritySS',
        u'emlpp',
        u'allLCSPrivacyException',
        u'universal',
        u'callSessionRelated',
        u'callSessionUnrelated',
        u'plmnoperator',
        u'serviceType',
        u'allMOLR-SS',
        u'basicSelfLocation',
        u'autonomousSelfLocation',
        u'transferToThirdParty',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SS-Code >-----#
    SS_Code = OCT_STR(name=u'SS-Code', mode=MODE_TYPE)
    SS_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< allSS >-----#
    allSS = OCT_STR(name=u'allSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allSS._val = b'\x00'
    
    #-----< allLineIdentificationSS >-----#
    allLineIdentificationSS = OCT_STR(name=u'allLineIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLineIdentificationSS._val = b'\x10'
    
    #-----< clip >-----#
    clip = OCT_STR(name=u'clip', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clip._val = b'\x11'
    
    #-----< clir >-----#
    clir = OCT_STR(name=u'clir', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clir._val = b'\x12'
    
    #-----< colp >-----#
    colp = OCT_STR(name=u'colp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colp._val = b'\x13'
    
    #-----< colr >-----#
    colr = OCT_STR(name=u'colr', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colr._val = b'\x14'
    
    #-----< mci >-----#
    mci = OCT_STR(name=u'mci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mci._val = b'\x15'
    
    #-----< allNameIdentificationSS >-----#
    allNameIdentificationSS = OCT_STR(name=u'allNameIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allNameIdentificationSS._val = b'\x18'
    
    #-----< cnap >-----#
    cnap = OCT_STR(name=u'cnap', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cnap._val = b'\x19'
    
    #-----< allForwardingSS >-----#
    allForwardingSS = OCT_STR(name=u'allForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allForwardingSS._val = b' '
    
    #-----< cfu >-----#
    cfu = OCT_STR(name=u'cfu', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfu._val = b'!'
    
    #-----< allCondForwardingSS >-----#
    allCondForwardingSS = OCT_STR(name=u'allCondForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCondForwardingSS._val = b'('
    
    #-----< cfb >-----#
    cfb = OCT_STR(name=u'cfb', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfb._val = b')'
    
    #-----< cfnry >-----#
    cfnry = OCT_STR(name=u'cfnry', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnry._val = b'*'
    
    #-----< cfnrc >-----#
    cfnrc = OCT_STR(name=u'cfnrc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnrc._val = b'+'
    
    #-----< cd >-----#
    cd = OCT_STR(name=u'cd', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cd._val = b'$'
    
    #-----< allCallOfferingSS >-----#
    allCallOfferingSS = OCT_STR(name=u'allCallOfferingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallOfferingSS._val = b'0'
    
    #-----< ect >-----#
    ect = OCT_STR(name=u'ect', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ect._val = b'1'
    
    #-----< mah >-----#
    mah = OCT_STR(name=u'mah', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mah._val = b'2'
    
    #-----< allCallCompletionSS >-----#
    allCallCompletionSS = OCT_STR(name=u'allCallCompletionSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallCompletionSS._val = b'@'
    
    #-----< cw >-----#
    cw = OCT_STR(name=u'cw', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cw._val = b'A'
    
    #-----< hold >-----#
    hold = OCT_STR(name=u'hold', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    hold._val = b'B'
    
    #-----< ccbs-A >-----#
    ccbs_A = OCT_STR(name=u'ccbs-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_A._val = b'C'
    
    #-----< ccbs-B >-----#
    ccbs_B = OCT_STR(name=u'ccbs-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_B._val = b'D'
    
    #-----< mc >-----#
    mc = OCT_STR(name=u'mc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mc._val = b'E'
    
    #-----< allMultiPartySS >-----#
    allMultiPartySS = OCT_STR(name=u'allMultiPartySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMultiPartySS._val = b'P'
    
    #-----< multiPTY >-----#
    multiPTY = OCT_STR(name=u'multiPTY', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    multiPTY._val = b'Q'
    
    #-----< allCommunityOfInterest-SS >-----#
    allCommunityOfInterest_SS = OCT_STR(name=u'allCommunityOfInterest-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCommunityOfInterest_SS._val = b'`'
    
    #-----< cug >-----#
    cug = OCT_STR(name=u'cug', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cug._val = b'a'
    
    #-----< allChargingSS >-----#
    allChargingSS = OCT_STR(name=u'allChargingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allChargingSS._val = b'p'
    
    #-----< aoci >-----#
    aoci = OCT_STR(name=u'aoci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aoci._val = b'q'
    
    #-----< aocc >-----#
    aocc = OCT_STR(name=u'aocc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aocc._val = b'r'
    
    #-----< allAdditionalInfoTransferSS >-----#
    allAdditionalInfoTransferSS = OCT_STR(name=u'allAdditionalInfoTransferSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allAdditionalInfoTransferSS._val = b'\x80'
    
    #-----< uus1 >-----#
    uus1 = OCT_STR(name=u'uus1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus1._val = b'\x81'
    
    #-----< uus2 >-----#
    uus2 = OCT_STR(name=u'uus2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus2._val = b'\x82'
    
    #-----< uus3 >-----#
    uus3 = OCT_STR(name=u'uus3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus3._val = b'\x83'
    
    #-----< allBarringSS >-----#
    allBarringSS = OCT_STR(name=u'allBarringSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allBarringSS._val = b'\x90'
    
    #-----< barringOfOutgoingCalls >-----#
    barringOfOutgoingCalls = OCT_STR(name=u'barringOfOutgoingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfOutgoingCalls._val = b'\x91'
    
    #-----< baoc >-----#
    baoc = OCT_STR(name=u'baoc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baoc._val = b'\x92'
    
    #-----< boic >-----#
    boic = OCT_STR(name=u'boic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boic._val = b'\x93'
    
    #-----< boicExHC >-----#
    boicExHC = OCT_STR(name=u'boicExHC', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boicExHC._val = b'\x94'
    
    #-----< barringOfIncomingCalls >-----#
    barringOfIncomingCalls = OCT_STR(name=u'barringOfIncomingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfIncomingCalls._val = b'\x99'
    
    #-----< baic >-----#
    baic = OCT_STR(name=u'baic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baic._val = b'\x9a'
    
    #-----< bicRoam >-----#
    bicRoam = OCT_STR(name=u'bicRoam', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    bicRoam._val = b'\x9b'
    
    #-----< allPLMN-specificSS >-----#
    allPLMN_specificSS = OCT_STR(name=u'allPLMN-specificSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allPLMN_specificSS._val = b'\xf0'
    
    #-----< plmn-specificSS-1 >-----#
    plmn_specificSS_1 = OCT_STR(name=u'plmn-specificSS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_1._val = b'\xf1'
    
    #-----< plmn-specificSS-2 >-----#
    plmn_specificSS_2 = OCT_STR(name=u'plmn-specificSS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_2._val = b'\xf2'
    
    #-----< plmn-specificSS-3 >-----#
    plmn_specificSS_3 = OCT_STR(name=u'plmn-specificSS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_3._val = b'\xf3'
    
    #-----< plmn-specificSS-4 >-----#
    plmn_specificSS_4 = OCT_STR(name=u'plmn-specificSS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_4._val = b'\xf4'
    
    #-----< plmn-specificSS-5 >-----#
    plmn_specificSS_5 = OCT_STR(name=u'plmn-specificSS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_5._val = b'\xf5'
    
    #-----< plmn-specificSS-6 >-----#
    plmn_specificSS_6 = OCT_STR(name=u'plmn-specificSS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_6._val = b'\xf6'
    
    #-----< plmn-specificSS-7 >-----#
    plmn_specificSS_7 = OCT_STR(name=u'plmn-specificSS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_7._val = b'\xf7'
    
    #-----< plmn-specificSS-8 >-----#
    plmn_specificSS_8 = OCT_STR(name=u'plmn-specificSS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_8._val = b'\xf8'
    
    #-----< plmn-specificSS-9 >-----#
    plmn_specificSS_9 = OCT_STR(name=u'plmn-specificSS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_9._val = b'\xf9'
    
    #-----< plmn-specificSS-A >-----#
    plmn_specificSS_A = OCT_STR(name=u'plmn-specificSS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_A._val = b'\xfa'
    
    #-----< plmn-specificSS-B >-----#
    plmn_specificSS_B = OCT_STR(name=u'plmn-specificSS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_B._val = b'\xfb'
    
    #-----< plmn-specificSS-C >-----#
    plmn_specificSS_C = OCT_STR(name=u'plmn-specificSS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_C._val = b'\xfc'
    
    #-----< plmn-specificSS-D >-----#
    plmn_specificSS_D = OCT_STR(name=u'plmn-specificSS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_D._val = b'\xfd'
    
    #-----< plmn-specificSS-E >-----#
    plmn_specificSS_E = OCT_STR(name=u'plmn-specificSS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_E._val = b'\xfe'
    
    #-----< plmn-specificSS-F >-----#
    plmn_specificSS_F = OCT_STR(name=u'plmn-specificSS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_F._val = b'\xff'
    
    #-----< allCallPrioritySS >-----#
    allCallPrioritySS = OCT_STR(name=u'allCallPrioritySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallPrioritySS._val = b'\xa0'
    
    #-----< emlpp >-----#
    emlpp = OCT_STR(name=u'emlpp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    emlpp._val = b'\xa1'
    
    #-----< allLCSPrivacyException >-----#
    allLCSPrivacyException = OCT_STR(name=u'allLCSPrivacyException', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLCSPrivacyException._val = b'\xb0'
    
    #-----< universal >-----#
    universal = OCT_STR(name=u'universal', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    universal._val = b'\xb1'
    
    #-----< callSessionRelated >-----#
    callSessionRelated = OCT_STR(name=u'callSessionRelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionRelated._val = b'\xb2'
    
    #-----< callSessionUnrelated >-----#
    callSessionUnrelated = OCT_STR(name=u'callSessionUnrelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionUnrelated._val = b'\xb3'
    
    #-----< plmnoperator >-----#
    plmnoperator = OCT_STR(name=u'plmnoperator', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmnoperator._val = b'\xb4'
    
    #-----< serviceType >-----#
    serviceType = OCT_STR(name=u'serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    serviceType._val = b'\xb5'
    
    #-----< allMOLR-SS >-----#
    allMOLR_SS = OCT_STR(name=u'allMOLR-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMOLR_SS._val = b'\xc0'
    
    #-----< basicSelfLocation >-----#
    basicSelfLocation = OCT_STR(name=u'basicSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    basicSelfLocation._val = b'\xc1'
    
    #-----< autonomousSelfLocation >-----#
    autonomousSelfLocation = OCT_STR(name=u'autonomousSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    autonomousSelfLocation._val = b'\xc2'
    
    #-----< transferToThirdParty >-----#
    transferToThirdParty = OCT_STR(name=u'transferToThirdParty', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    transferToThirdParty._val = b'\xc3'
    
    _all_ = [
        SS_Code,
        allSS,
        allLineIdentificationSS,
        clip,
        clir,
        colp,
        colr,
        mci,
        allNameIdentificationSS,
        cnap,
        allForwardingSS,
        cfu,
        allCondForwardingSS,
        cfb,
        cfnry,
        cfnrc,
        cd,
        allCallOfferingSS,
        ect,
        mah,
        allCallCompletionSS,
        cw,
        hold,
        ccbs_A,
        ccbs_B,
        mc,
        allMultiPartySS,
        multiPTY,
        allCommunityOfInterest_SS,
        cug,
        allChargingSS,
        aoci,
        aocc,
        allAdditionalInfoTransferSS,
        uus1,
        uus2,
        uus3,
        allBarringSS,
        barringOfOutgoingCalls,
        baoc,
        boic,
        boicExHC,
        barringOfIncomingCalls,
        baic,
        bicRoam,
        allPLMN_specificSS,
        plmn_specificSS_1,
        plmn_specificSS_2,
        plmn_specificSS_3,
        plmn_specificSS_4,
        plmn_specificSS_5,
        plmn_specificSS_6,
        plmn_specificSS_7,
        plmn_specificSS_8,
        plmn_specificSS_9,
        plmn_specificSS_A,
        plmn_specificSS_B,
        plmn_specificSS_C,
        plmn_specificSS_D,
        plmn_specificSS_E,
        plmn_specificSS_F,
        allCallPrioritySS,
        emlpp,
        allLCSPrivacyException,
        universal,
        callSessionRelated,
        callSessionUnrelated,
        plmnoperator,
        serviceType,
        allMOLR_SS,
        basicSelfLocation,
        autonomousSelfLocation,
        transferToThirdParty,
    ]

class MAP_SS_DataTypes:

    _name_  = u'MAP-SS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 14, 19]
    
    _obj_ = [
        u'RegisterSS-Arg',
        u'NoReplyConditionTime',
        u'SS-Info',
        u'ForwardingInfo',
        u'ForwardingFeatureList',
        u'ForwardingFeature',
        u'SS-Status',
        u'ForwardingOptions',
        u'CallBarringInfo',
        u'CallBarringFeatureList',
        u'CallBarringFeature',
        u'SS-Data',
        u'SS-SubscriptionOption',
        u'CliRestrictionOption',
        u'OverrideCategory',
        u'SS-ForBS-Code',
        u'GenericServiceInfo',
        u'CCBS-FeatureList',
        u'maxNumOfCCBS-Requests',
        u'CCBS-Feature',
        u'CCBS-Index',
        u'InterrogateSS-Res',
        u'USSD-Arg',
        u'USSD-Res',
        u'USSD-DataCodingScheme',
        u'USSD-String',
        u'maxUSSD-StringLength',
        u'Password',
        u'GuidanceInfo',
        u'SS-List',
        u'maxNumOfSS',
        u'SS-InfoList',
        u'BasicServiceGroupList',
        u'maxNumOfBasicServiceGroups',
        u'SS-InvocationNotificationArg',
        u'CCBS-RequestState',
        u'SS-InvocationNotificationRes',
        u'SS-EventSpecification',
        u'maxEventSpecification',
        u'RegisterCC-EntryArg',
        u'CCBS-Data',
        u'ServiceIndicator',
        u'RegisterCC-EntryRes',
        u'EraseCC-EntryArg',
        u'EraseCC-EntryRes',
        ]
    _type_ = [
        u'RegisterSS-Arg',
        u'NoReplyConditionTime',
        u'SS-Info',
        u'ForwardingInfo',
        u'ForwardingFeatureList',
        u'ForwardingFeature',
        u'SS-Status',
        u'ForwardingOptions',
        u'CallBarringInfo',
        u'CallBarringFeatureList',
        u'CallBarringFeature',
        u'SS-Data',
        u'SS-SubscriptionOption',
        u'CliRestrictionOption',
        u'OverrideCategory',
        u'SS-ForBS-Code',
        u'GenericServiceInfo',
        u'CCBS-FeatureList',
        u'CCBS-Feature',
        u'CCBS-Index',
        u'InterrogateSS-Res',
        u'USSD-Arg',
        u'USSD-Res',
        u'USSD-DataCodingScheme',
        u'USSD-String',
        u'Password',
        u'GuidanceInfo',
        u'SS-List',
        u'SS-InfoList',
        u'BasicServiceGroupList',
        u'SS-InvocationNotificationArg',
        u'CCBS-RequestState',
        u'SS-InvocationNotificationRes',
        u'SS-EventSpecification',
        u'RegisterCC-EntryArg',
        u'CCBS-Data',
        u'ServiceIndicator',
        u'RegisterCC-EntryRes',
        u'EraseCC-EntryArg',
        u'EraseCC-EntryRes',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxNumOfCCBS-Requests',
        u'maxUSSD-StringLength',
        u'maxNumOfSS',
        u'maxNumOfBasicServiceGroups',
        u'maxEventSpecification',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RegisterSS-Arg >-----#
    RegisterSS_Arg = SEQ(name=u'RegisterSS-Arg', mode=MODE_TYPE)
    _RegisterSS_Arg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterSS_Arg_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _RegisterSS_Arg_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _RegisterSS_Arg_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _RegisterSS_Arg_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _RegisterSS_Arg_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _RegisterSS_Arg_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _RegisterSS_Arg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RegisterSS_Arg._cont = ASN1Dict([
        (u'ss-Code', _RegisterSS_Arg_ss_Code),
        (u'basicService', _RegisterSS_Arg_basicService),
        (u'forwardedToNumber', _RegisterSS_Arg_forwardedToNumber),
        (u'forwardedToSubaddress', _RegisterSS_Arg_forwardedToSubaddress),
        (u'noReplyConditionTime', _RegisterSS_Arg_noReplyConditionTime),
        (u'defaultPriority', _RegisterSS_Arg_defaultPriority),
        (u'nbrUser', _RegisterSS_Arg_nbrUser),
        (u'longFTN-Supported', _RegisterSS_Arg_longFTN_Supported),
        ])
    RegisterSS_Arg._ext = [u'defaultPriority', u'nbrUser', u'longFTN-Supported']
    
    #-----< NoReplyConditionTime >-----#
    NoReplyConditionTime = INT(name=u'NoReplyConditionTime', mode=MODE_TYPE)
    NoReplyConditionTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=30)], ev=None, er=[])
    
    #-----< SS-Info >-----#
    SS_Info = CHOICE(name=u'SS-Info', mode=MODE_TYPE)
    _SS_Info_forwardingInfo = SEQ(name=u'forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingInfo')))
    _SS_Info_callBarringInfo = SEQ(name=u'callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringInfo')))
    _SS_Info_ss_Data = SEQ(name=u'ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Data')))
    SS_Info._cont = ASN1Dict([
        (u'forwardingInfo', _SS_Info_forwardingInfo),
        (u'callBarringInfo', _SS_Info_callBarringInfo),
        (u'ss-Data', _SS_Info_ss_Data),
        ])
    SS_Info._ext = None
    
    #-----< ForwardingInfo >-----#
    ForwardingInfo = SEQ(name=u'ForwardingInfo', mode=MODE_TYPE)
    _ForwardingInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _ForwardingInfo_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    ForwardingInfo._cont = ASN1Dict([
        (u'ss-Code', _ForwardingInfo_ss_Code),
        (u'forwardingFeatureList', _ForwardingInfo_forwardingFeatureList),
        ])
    ForwardingInfo._ext = []
    
    #-----< ForwardingFeatureList >-----#
    ForwardingFeatureList = SEQ_OF(name=u'ForwardingFeatureList', mode=MODE_TYPE)
    _ForwardingFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeature')))
    ForwardingFeatureList._cont = _ForwardingFeatureList__item_
    ForwardingFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< ForwardingFeature >-----#
    ForwardingFeature = SEQ(name=u'ForwardingFeature', mode=MODE_TYPE)
    _ForwardingFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _ForwardingFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _ForwardingFeature_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingFeature_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingFeature_forwardingOptions = OCT_STR(name=u'forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingFeature_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _ForwardingFeature_longForwardedToNumber = OCT_STR(name=u'longForwardedToNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingFeature._cont = ASN1Dict([
        (u'basicService', _ForwardingFeature_basicService),
        (u'ss-Status', _ForwardingFeature_ss_Status),
        (u'forwardedToNumber', _ForwardingFeature_forwardedToNumber),
        (u'forwardedToSubaddress', _ForwardingFeature_forwardedToSubaddress),
        (u'forwardingOptions', _ForwardingFeature_forwardingOptions),
        (u'noReplyConditionTime', _ForwardingFeature_noReplyConditionTime),
        (u'longForwardedToNumber', _ForwardingFeature_longForwardedToNumber),
        ])
    ForwardingFeature._ext = [u'longForwardedToNumber']
    
    #-----< SS-Status >-----#
    SS_Status = OCT_STR(name=u'SS-Status', mode=MODE_TYPE)
    SS_Status._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ForwardingOptions >-----#
    ForwardingOptions = OCT_STR(name=u'ForwardingOptions', mode=MODE_TYPE)
    ForwardingOptions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< CallBarringInfo >-----#
    CallBarringInfo = SEQ(name=u'CallBarringInfo', mode=MODE_TYPE)
    _CallBarringInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _CallBarringInfo_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeatureList')))
    CallBarringInfo._cont = ASN1Dict([
        (u'ss-Code', _CallBarringInfo_ss_Code),
        (u'callBarringFeatureList', _CallBarringInfo_callBarringFeatureList),
        ])
    CallBarringInfo._ext = []
    
    #-----< CallBarringFeatureList >-----#
    CallBarringFeatureList = SEQ_OF(name=u'CallBarringFeatureList', mode=MODE_TYPE)
    _CallBarringFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeature')))
    CallBarringFeatureList._cont = _CallBarringFeatureList__item_
    CallBarringFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< CallBarringFeature >-----#
    CallBarringFeature = SEQ(name=u'CallBarringFeature', mode=MODE_TYPE)
    _CallBarringFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _CallBarringFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    CallBarringFeature._cont = ASN1Dict([
        (u'basicService', _CallBarringFeature_basicService),
        (u'ss-Status', _CallBarringFeature_ss_Status),
        ])
    CallBarringFeature._ext = []
    
    #-----< SS-Data >-----#
    SS_Data = SEQ(name=u'SS-Data', mode=MODE_TYPE)
    _SS_Data_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_Data_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _SS_Data_ss_SubscriptionOption = CHOICE(name=u'ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _SS_Data_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')), opt=True)
    _SS_Data_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _SS_Data_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    SS_Data._cont = ASN1Dict([
        (u'ss-Code', _SS_Data_ss_Code),
        (u'ss-Status', _SS_Data_ss_Status),
        (u'ss-SubscriptionOption', _SS_Data_ss_SubscriptionOption),
        (u'basicServiceGroupList', _SS_Data_basicServiceGroupList),
        (u'defaultPriority', _SS_Data_defaultPriority),
        (u'nbrUser', _SS_Data_nbrUser),
        ])
    SS_Data._ext = [u'defaultPriority', u'nbrUser']
    
    #-----< SS-SubscriptionOption >-----#
    SS_SubscriptionOption = CHOICE(name=u'SS-SubscriptionOption', mode=MODE_TYPE)
    _SS_SubscriptionOption_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')))
    _SS_SubscriptionOption_overrideCategory = ENUM(name=u'overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    SS_SubscriptionOption._cont = ASN1Dict([
        (u'cliRestrictionOption', _SS_SubscriptionOption_cliRestrictionOption),
        (u'overrideCategory', _SS_SubscriptionOption_overrideCategory),
        ])
    SS_SubscriptionOption._ext = None
    
    #-----< CliRestrictionOption >-----#
    CliRestrictionOption = ENUM(name=u'CliRestrictionOption', mode=MODE_TYPE)
    CliRestrictionOption._cont = ASN1Dict([(u'permanent', 0), (u'temporaryDefaultRestricted', 1), (u'temporaryDefaultAllowed', 2)])
    CliRestrictionOption._ext = None
    
    #-----< OverrideCategory >-----#
    OverrideCategory = ENUM(name=u'OverrideCategory', mode=MODE_TYPE)
    OverrideCategory._cont = ASN1Dict([(u'overrideEnabled', 0), (u'overrideDisabled', 1)])
    OverrideCategory._ext = None
    
    #-----< SS-ForBS-Code >-----#
    SS_ForBS_Code = SEQ(name=u'SS-ForBS-Code', mode=MODE_TYPE)
    _SS_ForBS_Code_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_ForBS_Code_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_ForBS_Code_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_ForBS_Code._cont = ASN1Dict([
        (u'ss-Code', _SS_ForBS_Code_ss_Code),
        (u'basicService', _SS_ForBS_Code_basicService),
        (u'longFTN-Supported', _SS_ForBS_Code_longFTN_Supported),
        ])
    SS_ForBS_Code._ext = [u'longFTN-Supported']
    
    #-----< GenericServiceInfo >-----#
    GenericServiceInfo = SEQ(name=u'GenericServiceInfo', mode=MODE_TYPE)
    _GenericServiceInfo_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _GenericServiceInfo_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _GenericServiceInfo_maximumEntitledPriority = INT(name=u'maximumEntitledPriority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_ccbs_FeatureList = SEQ_OF(name=u'ccbs-FeatureList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-FeatureList')), opt=True)
    _GenericServiceInfo_nbrSB = INT(name=u'nbrSB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')), opt=True)
    _GenericServiceInfo_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _GenericServiceInfo_nbrSN = INT(name=u'nbrSN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    GenericServiceInfo._cont = ASN1Dict([
        (u'ss-Status', _GenericServiceInfo_ss_Status),
        (u'cliRestrictionOption', _GenericServiceInfo_cliRestrictionOption),
        (u'maximumEntitledPriority', _GenericServiceInfo_maximumEntitledPriority),
        (u'defaultPriority', _GenericServiceInfo_defaultPriority),
        (u'ccbs-FeatureList', _GenericServiceInfo_ccbs_FeatureList),
        (u'nbrSB', _GenericServiceInfo_nbrSB),
        (u'nbrUser', _GenericServiceInfo_nbrUser),
        (u'nbrSN', _GenericServiceInfo_nbrSN),
        ])
    GenericServiceInfo._ext = [u'maximumEntitledPriority', u'defaultPriority', u'ccbs-FeatureList', u'nbrSB', u'nbrUser', u'nbrSN']
    
    #-----< CCBS-FeatureList >-----#
    CCBS_FeatureList = SEQ_OF(name=u'CCBS-FeatureList', mode=MODE_TYPE)
    _CCBS_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    CCBS_FeatureList._cont = _CCBS_FeatureList__item_
    CCBS_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCCBS-Requests >-----#
    maxNumOfCCBS_Requests = INT(name=u'maxNumOfCCBS-Requests', mode=MODE_VALUE)
    maxNumOfCCBS_Requests._val = 5
    
    #-----< CCBS-Feature >-----#
    CCBS_Feature = SEQ(name=u'CCBS-Feature', mode=MODE_TYPE)
    _CCBS_Feature_ccbs_Index = INT(name=u'ccbs-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    _CCBS_Feature_b_subscriberNumber = OCT_STR(name=u'b-subscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CCBS_Feature_b_subscriberSubaddress = OCT_STR(name=u'b-subscriberSubaddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _CCBS_Feature_basicServiceGroup = CHOICE(name=u'basicServiceGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    CCBS_Feature._cont = ASN1Dict([
        (u'ccbs-Index', _CCBS_Feature_ccbs_Index),
        (u'b-subscriberNumber', _CCBS_Feature_b_subscriberNumber),
        (u'b-subscriberSubaddress', _CCBS_Feature_b_subscriberSubaddress),
        (u'basicServiceGroup', _CCBS_Feature_basicServiceGroup),
        ])
    CCBS_Feature._ext = []
    
    #-----< CCBS-Index >-----#
    CCBS_Index = INT(name=u'CCBS-Index', mode=MODE_TYPE)
    CCBS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< InterrogateSS-Res >-----#
    InterrogateSS_Res = CHOICE(name=u'InterrogateSS-Res', mode=MODE_TYPE)
    _InterrogateSS_Res_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _InterrogateSS_Res_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')))
    _InterrogateSS_Res_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    _InterrogateSS_Res_genericServiceInfo = SEQ(name=u'genericServiceInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'GenericServiceInfo')))
    InterrogateSS_Res._cont = ASN1Dict([
        (u'ss-Status', _InterrogateSS_Res_ss_Status),
        (u'basicServiceGroupList', _InterrogateSS_Res_basicServiceGroupList),
        (u'forwardingFeatureList', _InterrogateSS_Res_forwardingFeatureList),
        (u'genericServiceInfo', _InterrogateSS_Res_genericServiceInfo),
        ])
    InterrogateSS_Res._ext = None
    
    #-----< USSD-Arg >-----#
    USSD_Arg = SEQ(name=u'USSD-Arg', mode=MODE_TYPE)
    _USSD_Arg_ussd_DataCodingScheme = OCT_STR(name=u'ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Arg_ussd_String = OCT_STR(name=u'ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    _USSD_Arg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _USSD_Arg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    USSD_Arg._cont = ASN1Dict([
        (u'ussd-DataCodingScheme', _USSD_Arg_ussd_DataCodingScheme),
        (u'ussd-String', _USSD_Arg_ussd_String),
        (u'alertingPattern', _USSD_Arg_alertingPattern),
        (u'msisdn', _USSD_Arg_msisdn),
        ])
    USSD_Arg._ext = [u'alertingPattern', u'msisdn']
    
    #-----< USSD-Res >-----#
    USSD_Res = SEQ(name=u'USSD-Res', mode=MODE_TYPE)
    _USSD_Res_ussd_DataCodingScheme = OCT_STR(name=u'ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Res_ussd_String = OCT_STR(name=u'ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    USSD_Res._cont = ASN1Dict([
        (u'ussd-DataCodingScheme', _USSD_Res_ussd_DataCodingScheme),
        (u'ussd-String', _USSD_Res_ussd_String),
        ])
    USSD_Res._ext = []
    
    #-----< USSD-DataCodingScheme >-----#
    USSD_DataCodingScheme = OCT_STR(name=u'USSD-DataCodingScheme', mode=MODE_TYPE)
    USSD_DataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< USSD-String >-----#
    USSD_String = OCT_STR(name=u'USSD-String', mode=MODE_TYPE)
    USSD_String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< maxUSSD-StringLength >-----#
    maxUSSD_StringLength = INT(name=u'maxUSSD-StringLength', mode=MODE_VALUE)
    maxUSSD_StringLength._val = 160
    
    #-----< Password >-----#
    Password = STR_NUM(name=u'Password', mode=MODE_TYPE)
    Password._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    Password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    
    #-----< GuidanceInfo >-----#
    GuidanceInfo = ENUM(name=u'GuidanceInfo', mode=MODE_TYPE)
    GuidanceInfo._cont = ASN1Dict([(u'enterPW', 0), (u'enterNewPW', 1), (u'enterNewPW-Again', 2)])
    GuidanceInfo._ext = None
    
    #-----< SS-List >-----#
    SS_List = SEQ_OF(name=u'SS-List', mode=MODE_TYPE)
    _SS_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_List._cont = _SS_List__item_
    SS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< maxNumOfSS >-----#
    maxNumOfSS = INT(name=u'maxNumOfSS', mode=MODE_VALUE)
    maxNumOfSS._val = 30
    
    #-----< SS-InfoList >-----#
    SS_InfoList = SEQ_OF(name=u'SS-InfoList', mode=MODE_TYPE)
    _SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Info')))
    SS_InfoList._cont = _SS_InfoList__item_
    SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< BasicServiceGroupList >-----#
    BasicServiceGroupList = SEQ_OF(name=u'BasicServiceGroupList', mode=MODE_TYPE)
    _BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    BasicServiceGroupList._cont = _BasicServiceGroupList__item_
    BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< maxNumOfBasicServiceGroups >-----#
    maxNumOfBasicServiceGroups = INT(name=u'maxNumOfBasicServiceGroups', mode=MODE_VALUE)
    maxNumOfBasicServiceGroups._val = 13
    
    #-----< SS-InvocationNotificationArg >-----#
    SS_InvocationNotificationArg = SEQ(name=u'SS-InvocationNotificationArg', mode=MODE_TYPE)
    _SS_InvocationNotificationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SS_InvocationNotificationArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_InvocationNotificationArg_ss_Event = OCT_STR(name=u'ss-Event', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_InvocationNotificationArg_ss_EventSpecification = SEQ_OF(name=u'ss-EventSpecification', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-EventSpecification')), opt=True)
    _SS_InvocationNotificationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_InvocationNotificationArg_b_subscriberNumber = OCT_STR(name=u'b-subscriberNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SS_InvocationNotificationArg_ccbs_RequestState = ENUM(name=u'ccbs-RequestState', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-RequestState')), opt=True)
    SS_InvocationNotificationArg._cont = ASN1Dict([
        (u'imsi', _SS_InvocationNotificationArg_imsi),
        (u'msisdn', _SS_InvocationNotificationArg_msisdn),
        (u'ss-Event', _SS_InvocationNotificationArg_ss_Event),
        (u'ss-EventSpecification', _SS_InvocationNotificationArg_ss_EventSpecification),
        (u'extensionContainer', _SS_InvocationNotificationArg_extensionContainer),
        (u'b-subscriberNumber', _SS_InvocationNotificationArg_b_subscriberNumber),
        (u'ccbs-RequestState', _SS_InvocationNotificationArg_ccbs_RequestState),
        ])
    SS_InvocationNotificationArg._ext = [u'b-subscriberNumber', u'ccbs-RequestState']
    
    #-----< CCBS-RequestState >-----#
    CCBS_RequestState = ENUM(name=u'CCBS-RequestState', mode=MODE_TYPE)
    CCBS_RequestState._cont = ASN1Dict([(u'request', 0), (u'recall', 1), (u'active', 2), (u'completed', 3), (u'suspended', 4), (u'frozen', 5), (u'deleted', 6)])
    CCBS_RequestState._ext = None
    
    #-----< SS-InvocationNotificationRes >-----#
    SS_InvocationNotificationRes = SEQ(name=u'SS-InvocationNotificationRes', mode=MODE_TYPE)
    _SS_InvocationNotificationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_InvocationNotificationRes._cont = ASN1Dict([
        (u'extensionContainer', _SS_InvocationNotificationRes_extensionContainer),
        ])
    SS_InvocationNotificationRes._ext = []
    
    #-----< SS-EventSpecification >-----#
    SS_EventSpecification = SEQ_OF(name=u'SS-EventSpecification', mode=MODE_TYPE)
    _SS_EventSpecification__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SS_EventSpecification._cont = _SS_EventSpecification__item_
    SS_EventSpecification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< maxEventSpecification >-----#
    maxEventSpecification = INT(name=u'maxEventSpecification', mode=MODE_VALUE)
    maxEventSpecification._val = 2
    
    #-----< RegisterCC-EntryArg >-----#
    RegisterCC_EntryArg = SEQ(name=u'RegisterCC-EntryArg', mode=MODE_TYPE)
    _RegisterCC_EntryArg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterCC_EntryArg_ccbs_Data = SEQ(name=u'ccbs-Data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Data')), opt=True)
    RegisterCC_EntryArg._cont = ASN1Dict([
        (u'ss-Code', _RegisterCC_EntryArg_ss_Code),
        (u'ccbs-Data', _RegisterCC_EntryArg_ccbs_Data),
        ])
    RegisterCC_EntryArg._ext = []
    
    #-----< CCBS-Data >-----#
    CCBS_Data = SEQ(name=u'CCBS-Data', mode=MODE_TYPE)
    _CCBS_Data_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _CCBS_Data_translatedB_Number = OCT_STR(name=u'translatedB-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _CCBS_Data_serviceIndicator = BIT_STR(name=u'serviceIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ServiceIndicator')), opt=True)
    _CCBS_Data_callInfo = SEQ(name=u'callInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _CCBS_Data_networkSignalInfo = SEQ(name=u'networkSignalInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    CCBS_Data._cont = ASN1Dict([
        (u'ccbs-Feature', _CCBS_Data_ccbs_Feature),
        (u'translatedB-Number', _CCBS_Data_translatedB_Number),
        (u'serviceIndicator', _CCBS_Data_serviceIndicator),
        (u'callInfo', _CCBS_Data_callInfo),
        (u'networkSignalInfo', _CCBS_Data_networkSignalInfo),
        ])
    CCBS_Data._ext = []
    
    #-----< ServiceIndicator >-----#
    ServiceIndicator = BIT_STR(name=u'ServiceIndicator', mode=MODE_TYPE)
    ServiceIndicator._cont = ASN1Dict([(u'clir-invoked', 0), (u'camel-invoked', 1)])
    ServiceIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    
    #-----< RegisterCC-EntryRes >-----#
    RegisterCC_EntryRes = SEQ(name=u'RegisterCC-EntryRes', mode=MODE_TYPE)
    _RegisterCC_EntryRes_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')), opt=True)
    RegisterCC_EntryRes._cont = ASN1Dict([
        (u'ccbs-Feature', _RegisterCC_EntryRes_ccbs_Feature),
        ])
    RegisterCC_EntryRes._ext = []
    
    #-----< EraseCC-EntryArg >-----#
    EraseCC_EntryArg = SEQ(name=u'EraseCC-EntryArg', mode=MODE_TYPE)
    _EraseCC_EntryArg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryArg_ccbs_Index = INT(name=u'ccbs-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    EraseCC_EntryArg._cont = ASN1Dict([
        (u'ss-Code', _EraseCC_EntryArg_ss_Code),
        (u'ccbs-Index', _EraseCC_EntryArg_ccbs_Index),
        ])
    EraseCC_EntryArg._ext = []
    
    #-----< EraseCC-EntryRes >-----#
    EraseCC_EntryRes = SEQ(name=u'EraseCC-EntryRes', mode=MODE_TYPE)
    _EraseCC_EntryRes_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryRes_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    EraseCC_EntryRes._cont = ASN1Dict([
        (u'ss-Code', _EraseCC_EntryRes_ss_Code),
        (u'ss-Status', _EraseCC_EntryRes_ss_Status),
        ])
    EraseCC_EntryRes._ext = []
    
    _all_ = [
        _RegisterSS_Arg_ss_Code,
        _RegisterSS_Arg_basicService,
        _RegisterSS_Arg_forwardedToNumber,
        _RegisterSS_Arg_forwardedToSubaddress,
        _RegisterSS_Arg_noReplyConditionTime,
        _RegisterSS_Arg_defaultPriority,
        _RegisterSS_Arg_nbrUser,
        _RegisterSS_Arg_longFTN_Supported,
        RegisterSS_Arg,
        NoReplyConditionTime,
        _SS_Info_forwardingInfo,
        _SS_Info_callBarringInfo,
        _SS_Info_ss_Data,
        SS_Info,
        _ForwardingInfo_ss_Code,
        _ForwardingInfo_forwardingFeatureList,
        ForwardingInfo,
        _ForwardingFeatureList__item_,
        ForwardingFeatureList,
        _ForwardingFeature_basicService,
        _ForwardingFeature_ss_Status,
        _ForwardingFeature_forwardedToNumber,
        _ForwardingFeature_forwardedToSubaddress,
        _ForwardingFeature_forwardingOptions,
        _ForwardingFeature_noReplyConditionTime,
        _ForwardingFeature_longForwardedToNumber,
        ForwardingFeature,
        SS_Status,
        ForwardingOptions,
        _CallBarringInfo_ss_Code,
        _CallBarringInfo_callBarringFeatureList,
        CallBarringInfo,
        _CallBarringFeatureList__item_,
        CallBarringFeatureList,
        _CallBarringFeature_basicService,
        _CallBarringFeature_ss_Status,
        CallBarringFeature,
        _SS_Data_ss_Code,
        _SS_Data_ss_Status,
        _SS_Data_ss_SubscriptionOption,
        _SS_Data_basicServiceGroupList,
        _SS_Data_defaultPriority,
        _SS_Data_nbrUser,
        SS_Data,
        _SS_SubscriptionOption_cliRestrictionOption,
        _SS_SubscriptionOption_overrideCategory,
        SS_SubscriptionOption,
        CliRestrictionOption,
        OverrideCategory,
        _SS_ForBS_Code_ss_Code,
        _SS_ForBS_Code_basicService,
        _SS_ForBS_Code_longFTN_Supported,
        SS_ForBS_Code,
        _GenericServiceInfo_ss_Status,
        _GenericServiceInfo_cliRestrictionOption,
        _GenericServiceInfo_maximumEntitledPriority,
        _GenericServiceInfo_defaultPriority,
        _GenericServiceInfo_ccbs_FeatureList,
        _GenericServiceInfo_nbrSB,
        _GenericServiceInfo_nbrUser,
        _GenericServiceInfo_nbrSN,
        GenericServiceInfo,
        _CCBS_FeatureList__item_,
        CCBS_FeatureList,
        maxNumOfCCBS_Requests,
        _CCBS_Feature_ccbs_Index,
        _CCBS_Feature_b_subscriberNumber,
        _CCBS_Feature_b_subscriberSubaddress,
        _CCBS_Feature_basicServiceGroup,
        CCBS_Feature,
        CCBS_Index,
        _InterrogateSS_Res_ss_Status,
        _InterrogateSS_Res_basicServiceGroupList,
        _InterrogateSS_Res_forwardingFeatureList,
        _InterrogateSS_Res_genericServiceInfo,
        InterrogateSS_Res,
        _USSD_Arg_ussd_DataCodingScheme,
        _USSD_Arg_ussd_String,
        _USSD_Arg_alertingPattern,
        _USSD_Arg_msisdn,
        USSD_Arg,
        _USSD_Res_ussd_DataCodingScheme,
        _USSD_Res_ussd_String,
        USSD_Res,
        USSD_DataCodingScheme,
        USSD_String,
        maxUSSD_StringLength,
        Password,
        GuidanceInfo,
        _SS_List__item_,
        SS_List,
        maxNumOfSS,
        _SS_InfoList__item_,
        SS_InfoList,
        _BasicServiceGroupList__item_,
        BasicServiceGroupList,
        maxNumOfBasicServiceGroups,
        _SS_InvocationNotificationArg_imsi,
        _SS_InvocationNotificationArg_msisdn,
        _SS_InvocationNotificationArg_ss_Event,
        _SS_InvocationNotificationArg_ss_EventSpecification,
        _SS_InvocationNotificationArg_extensionContainer,
        _SS_InvocationNotificationArg_b_subscriberNumber,
        _SS_InvocationNotificationArg_ccbs_RequestState,
        SS_InvocationNotificationArg,
        CCBS_RequestState,
        _SS_InvocationNotificationRes_extensionContainer,
        SS_InvocationNotificationRes,
        _SS_EventSpecification__item_,
        SS_EventSpecification,
        maxEventSpecification,
        _RegisterCC_EntryArg_ss_Code,
        _RegisterCC_EntryArg_ccbs_Data,
        RegisterCC_EntryArg,
        _CCBS_Data_ccbs_Feature,
        _CCBS_Data_translatedB_Number,
        _CCBS_Data_serviceIndicator,
        _CCBS_Data_callInfo,
        _CCBS_Data_networkSignalInfo,
        CCBS_Data,
        ServiceIndicator,
        _RegisterCC_EntryRes_ccbs_Feature,
        RegisterCC_EntryRes,
        _EraseCC_EntryArg_ss_Code,
        _EraseCC_EntryArg_ccbs_Index,
        EraseCC_EntryArg,
        _EraseCC_EntryRes_ss_Code,
        _EraseCC_EntryRes_ss_Status,
        EraseCC_EntryRes,
    ]

class MAP_TS_Code:

    _name_  = u'MAP-TS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 19, 19]
    
    _obj_ = [
        u'TeleserviceCode',
        u'Ext-TeleserviceCode',
        u'allTeleservices',
        u'allSpeechTransmissionServices',
        u'telephony',
        u'emergencyCalls',
        u'allShortMessageServices',
        u'shortMessageMT-PP',
        u'shortMessageMO-PP',
        u'allFacsimileTransmissionServices',
        u'facsimileGroup3AndAlterSpeech',
        u'automaticFacsimileGroup3',
        u'facsimileGroup4',
        u'allDataTeleservices',
        u'allTeleservices-ExeptSMS',
        u'allVoiceGroupCallServices',
        u'voiceGroupCall',
        u'voiceBroadcastCall',
        u'allPLMN-specificTS',
        u'plmn-specificTS-1',
        u'plmn-specificTS-2',
        u'plmn-specificTS-3',
        u'plmn-specificTS-4',
        u'plmn-specificTS-5',
        u'plmn-specificTS-6',
        u'plmn-specificTS-7',
        u'plmn-specificTS-8',
        u'plmn-specificTS-9',
        u'plmn-specificTS-A',
        u'plmn-specificTS-B',
        u'plmn-specificTS-C',
        u'plmn-specificTS-D',
        u'plmn-specificTS-E',
        u'plmn-specificTS-F',
        ]
    _type_ = [
        u'TeleserviceCode',
        u'Ext-TeleserviceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        u'allTeleservices',
        u'allSpeechTransmissionServices',
        u'telephony',
        u'emergencyCalls',
        u'allShortMessageServices',
        u'shortMessageMT-PP',
        u'shortMessageMO-PP',
        u'allFacsimileTransmissionServices',
        u'facsimileGroup3AndAlterSpeech',
        u'automaticFacsimileGroup3',
        u'facsimileGroup4',
        u'allDataTeleservices',
        u'allTeleservices-ExeptSMS',
        u'allVoiceGroupCallServices',
        u'voiceGroupCall',
        u'voiceBroadcastCall',
        u'allPLMN-specificTS',
        u'plmn-specificTS-1',
        u'plmn-specificTS-2',
        u'plmn-specificTS-3',
        u'plmn-specificTS-4',
        u'plmn-specificTS-5',
        u'plmn-specificTS-6',
        u'plmn-specificTS-7',
        u'plmn-specificTS-8',
        u'plmn-specificTS-9',
        u'plmn-specificTS-A',
        u'plmn-specificTS-B',
        u'plmn-specificTS-C',
        u'plmn-specificTS-D',
        u'plmn-specificTS-E',
        u'plmn-specificTS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TeleserviceCode >-----#
    TeleserviceCode = OCT_STR(name=u'TeleserviceCode', mode=MODE_TYPE)
    TeleserviceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-TeleserviceCode >-----#
    Ext_TeleserviceCode = OCT_STR(name=u'Ext-TeleserviceCode', mode=MODE_TYPE)
    Ext_TeleserviceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allTeleservices >-----#
    allTeleservices = OCT_STR(name=u'allTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices._val = b'\x00'
    
    #-----< allSpeechTransmissionServices >-----#
    allSpeechTransmissionServices = OCT_STR(name=u'allSpeechTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allSpeechTransmissionServices._val = b'\x10'
    
    #-----< telephony >-----#
    telephony = OCT_STR(name=u'telephony', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    telephony._val = b'\x11'
    
    #-----< emergencyCalls >-----#
    emergencyCalls = OCT_STR(name=u'emergencyCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    emergencyCalls._val = b'\x12'
    
    #-----< allShortMessageServices >-----#
    allShortMessageServices = OCT_STR(name=u'allShortMessageServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allShortMessageServices._val = b' '
    
    #-----< shortMessageMT-PP >-----#
    shortMessageMT_PP = OCT_STR(name=u'shortMessageMT-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMT_PP._val = b'!'
    
    #-----< shortMessageMO-PP >-----#
    shortMessageMO_PP = OCT_STR(name=u'shortMessageMO-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMO_PP._val = b'"'
    
    #-----< allFacsimileTransmissionServices >-----#
    allFacsimileTransmissionServices = OCT_STR(name=u'allFacsimileTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allFacsimileTransmissionServices._val = b'`'
    
    #-----< facsimileGroup3AndAlterSpeech >-----#
    facsimileGroup3AndAlterSpeech = OCT_STR(name=u'facsimileGroup3AndAlterSpeech', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup3AndAlterSpeech._val = b'a'
    
    #-----< automaticFacsimileGroup3 >-----#
    automaticFacsimileGroup3 = OCT_STR(name=u'automaticFacsimileGroup3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    automaticFacsimileGroup3._val = b'b'
    
    #-----< facsimileGroup4 >-----#
    facsimileGroup4 = OCT_STR(name=u'facsimileGroup4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup4._val = b'c'
    
    #-----< allDataTeleservices >-----#
    allDataTeleservices = OCT_STR(name=u'allDataTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allDataTeleservices._val = b'p'
    
    #-----< allTeleservices-ExeptSMS >-----#
    allTeleservices_ExeptSMS = OCT_STR(name=u'allTeleservices-ExeptSMS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices_ExeptSMS._val = b'\x80'
    
    #-----< allVoiceGroupCallServices >-----#
    allVoiceGroupCallServices = OCT_STR(name=u'allVoiceGroupCallServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allVoiceGroupCallServices._val = b'\x90'
    
    #-----< voiceGroupCall >-----#
    voiceGroupCall = OCT_STR(name=u'voiceGroupCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceGroupCall._val = b'\x91'
    
    #-----< voiceBroadcastCall >-----#
    voiceBroadcastCall = OCT_STR(name=u'voiceBroadcastCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceBroadcastCall._val = b'\x92'
    
    #-----< allPLMN-specificTS >-----#
    allPLMN_specificTS = OCT_STR(name=u'allPLMN-specificTS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allPLMN_specificTS._val = b'\xd0'
    
    #-----< plmn-specificTS-1 >-----#
    plmn_specificTS_1 = OCT_STR(name=u'plmn-specificTS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_1._val = b'\xd1'
    
    #-----< plmn-specificTS-2 >-----#
    plmn_specificTS_2 = OCT_STR(name=u'plmn-specificTS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_2._val = b'\xd2'
    
    #-----< plmn-specificTS-3 >-----#
    plmn_specificTS_3 = OCT_STR(name=u'plmn-specificTS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_3._val = b'\xd3'
    
    #-----< plmn-specificTS-4 >-----#
    plmn_specificTS_4 = OCT_STR(name=u'plmn-specificTS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_4._val = b'\xd4'
    
    #-----< plmn-specificTS-5 >-----#
    plmn_specificTS_5 = OCT_STR(name=u'plmn-specificTS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_5._val = b'\xd5'
    
    #-----< plmn-specificTS-6 >-----#
    plmn_specificTS_6 = OCT_STR(name=u'plmn-specificTS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_6._val = b'\xd6'
    
    #-----< plmn-specificTS-7 >-----#
    plmn_specificTS_7 = OCT_STR(name=u'plmn-specificTS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_7._val = b'\xd7'
    
    #-----< plmn-specificTS-8 >-----#
    plmn_specificTS_8 = OCT_STR(name=u'plmn-specificTS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_8._val = b'\xd8'
    
    #-----< plmn-specificTS-9 >-----#
    plmn_specificTS_9 = OCT_STR(name=u'plmn-specificTS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_9._val = b'\xd9'
    
    #-----< plmn-specificTS-A >-----#
    plmn_specificTS_A = OCT_STR(name=u'plmn-specificTS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_A._val = b'\xda'
    
    #-----< plmn-specificTS-B >-----#
    plmn_specificTS_B = OCT_STR(name=u'plmn-specificTS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_B._val = b'\xdb'
    
    #-----< plmn-specificTS-C >-----#
    plmn_specificTS_C = OCT_STR(name=u'plmn-specificTS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_C._val = b'\xdc'
    
    #-----< plmn-specificTS-D >-----#
    plmn_specificTS_D = OCT_STR(name=u'plmn-specificTS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_D._val = b'\xdd'
    
    #-----< plmn-specificTS-E >-----#
    plmn_specificTS_E = OCT_STR(name=u'plmn-specificTS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_E._val = b'\xde'
    
    #-----< plmn-specificTS-F >-----#
    plmn_specificTS_F = OCT_STR(name=u'plmn-specificTS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_F._val = b'\xdf'
    
    _all_ = [
        TeleserviceCode,
        Ext_TeleserviceCode,
        allTeleservices,
        allSpeechTransmissionServices,
        telephony,
        emergencyCalls,
        allShortMessageServices,
        shortMessageMT_PP,
        shortMessageMO_PP,
        allFacsimileTransmissionServices,
        facsimileGroup3AndAlterSpeech,
        automaticFacsimileGroup3,
        facsimileGroup4,
        allDataTeleservices,
        allTeleservices_ExeptSMS,
        allVoiceGroupCallServices,
        voiceGroupCall,
        voiceBroadcastCall,
        allPLMN_specificTS,
        plmn_specificTS_1,
        plmn_specificTS_2,
        plmn_specificTS_3,
        plmn_specificTS_4,
        plmn_specificTS_5,
        plmn_specificTS_6,
        plmn_specificTS_7,
        plmn_specificTS_8,
        plmn_specificTS_9,
        plmn_specificTS_A,
        plmn_specificTS_B,
        plmn_specificTS_C,
        plmn_specificTS_D,
        plmn_specificTS_E,
        plmn_specificTS_F,
    ]

class CS1_DataTypes:

    _name_  = u'CS1-DataTypes'
    _oid_   = []
    
    _obj_ = [
        u'Duration',
        u'Integer4',
        u'Interval',
        u'LegID',
        u'LegType',
        u'ServiceKey',
        u'CallingPartysCategory',
        u'HighLayerCompatibility',
        u'highLayerCompatibilityLength',
        u'RedirectionInformation',
        ]
    _type_ = [
        u'Duration',
        u'Integer4',
        u'Interval',
        u'LegID',
        u'LegType',
        u'ServiceKey',
        u'CallingPartysCategory',
        u'HighLayerCompatibility',
        u'RedirectionInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        u'highLayerCompatibilityLength',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Duration >-----#
    Duration = INT(name=u'Duration', mode=MODE_TYPE)
    Duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2, ub=86400)], ev=None, er=[])
    
    #-----< Integer4 >-----#
    Integer4 = INT(name=u'Integer4', mode=MODE_TYPE)
    Integer4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< Interval >-----#
    Interval = INT(name=u'Interval', mode=MODE_TYPE)
    Interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=60000)], ev=None, er=[])
    
    #-----< LegID >-----#
    LegID = CHOICE(name=u'LegID', mode=MODE_TYPE)
    _LegID_sendingSideID = OCT_STR(name=u'sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    _LegID_receivingSideID = OCT_STR(name=u'receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    LegID._cont = ASN1Dict([
        (u'sendingSideID', _LegID_sendingSideID),
        (u'receivingSideID', _LegID_receivingSideID),
        ])
    LegID._ext = None
    
    #-----< LegType >-----#
    LegType = OCT_STR(name=u'LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name=u'ServiceKey', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< CallingPartysCategory >-----#
    CallingPartysCategory = OCT_STR(name=u'CallingPartysCategory', mode=MODE_TYPE)
    CallingPartysCategory._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< HighLayerCompatibility >-----#
    HighLayerCompatibility = OCT_STR(name=u'HighLayerCompatibility', mode=MODE_TYPE)
    HighLayerCompatibility._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< highLayerCompatibilityLength >-----#
    highLayerCompatibilityLength = INT(name=u'highLayerCompatibilityLength', mode=MODE_VALUE)
    highLayerCompatibilityLength._val = 2
    
    #-----< RedirectionInformation >-----#
    RedirectionInformation = OCT_STR(name=u'RedirectionInformation', mode=MODE_TYPE)
    RedirectionInformation._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    _all_ = [
        Duration,
        Integer4,
        Interval,
        _LegID_sendingSideID,
        _LegID_receivingSideID,
        LegID,
        LegType,
        ServiceKey,
        CallingPartysCategory,
        HighLayerCompatibility,
        highLayerCompatibilityLength,
        RedirectionInformation,
    ]

class CS2_datatypes:

    _name_  = u'CS2-datatypes'
    _oid_   = []
    
    _obj_ = [
        u'CriticalityType',
        u'BothwayThroughConnectionInd',
        u'MiscCallInfo',
        ]
    _type_ = [
        u'CriticalityType',
        u'BothwayThroughConnectionInd',
        u'MiscCallInfo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CriticalityType >-----#
    CriticalityType = ENUM(name=u'CriticalityType', mode=MODE_TYPE)
    CriticalityType._cont = ASN1Dict([(u'ignore', 0), (u'abort', 1)])
    CriticalityType._ext = None
    
    #-----< BothwayThroughConnectionInd >-----#
    BothwayThroughConnectionInd = ENUM(name=u'BothwayThroughConnectionInd', mode=MODE_TYPE)
    BothwayThroughConnectionInd._cont = ASN1Dict([(u'bothwayPathRequired', 0), (u'bothwayPathNotRequired', 1)])
    BothwayThroughConnectionInd._ext = None
    
    #-----< MiscCallInfo >-----#
    MiscCallInfo = SEQ(name=u'MiscCallInfo', mode=MODE_TYPE)
    _MiscCallInfo_messageType = ENUM(name=u'messageType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MiscCallInfo_messageType._cont = ASN1Dict([(u'request', 0), (u'notification', 1)])
    _MiscCallInfo_messageType._ext = None
    _MiscCallInfo_dpAssignment = ENUM(name=u'dpAssignment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MiscCallInfo_dpAssignment._cont = ASN1Dict([(u'individualLine', 0), (u'groupBased', 1), (u'officeBased', 2)])
    _MiscCallInfo_dpAssignment._ext = None
    MiscCallInfo._cont = ASN1Dict([
        (u'messageType', _MiscCallInfo_messageType),
        (u'dpAssignment', _MiscCallInfo_dpAssignment),
        ])
    MiscCallInfo._ext = None
    
    _all_ = [
        CriticalityType,
        BothwayThroughConnectionInd,
        _MiscCallInfo_messageType,
        _MiscCallInfo_dpAssignment,
        MiscCallInfo,
    ]

class CAP_classes:

    _name_  = u'CAP-classes'
    _oid_   = [0, 4, 0, 0, 1, 3, 54, 7]
    
    _obj_ = [
        u'gsmSSF',
        u'gsmSRF',
        u'smsSSF-V3',
        u'smsSSF-V4',
        u'gprsSSF',
        u'EXTENSION',
        u'firstExtension',
        u'SupportedExtensions',
        u'PARAMETERS-BOUND',
        u'cAPSpecificBoundSet',
        ]
    _type_ = [
        u'EXTENSION',
        u'PARAMETERS-BOUND',
        ]
    _set_ = [
        u'SupportedExtensions',
        ]
    _val_ = [
        u'gsmSSF',
        u'gsmSRF',
        u'smsSSF-V3',
        u'smsSSF-V4',
        u'gprsSSF',
        u'firstExtension',
        u'cAPSpecificBoundSet',
        ]
    _class_ = [
        u'gsmSSF',
        u'gsmSRF',
        u'smsSSF-V3',
        u'smsSSF-V4',
        u'gprsSSF',
        u'EXTENSION',
        u'firstExtension',
        u'SupportedExtensions',
        u'PARAMETERS-BOUND',
        u'cAPSpecificBoundSet',
        ]
    _param_ = [
        ]
    
    #-----< gsmSSF >-----#
    gsmSSF = CLASS(name=u'gsmSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure),
        (u'bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey),
        (u'calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        (u'cGEncountered', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered),
        (u'iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        (u'locationNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        (u'highLayerCompatibility', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        (u'additionalCallingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        (u'bearerCapability', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability),
        (u'eventTypeBCSM', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        (u'redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        (u'redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation),
        (u'cause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier),
        (u'cug-Index', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI),
        (u'subscriberState', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState),
        (u'locationInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation),
        (u'ext-basicServiceCode', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        (u'callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        (u'mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress),
        (u'calledPartyBCDNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        (u'timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        (u'callForwardingSS-Pending', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        (u'initialDPArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID),
        (u'scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments),
        (u'allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions),
        (u'legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        (u'operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        (u'srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        (u'partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions),
        (u'aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._ext = []
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_7 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_8 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_8._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_8._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        (u'redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        (u'redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber),
        (u'legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        (u'oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        (u'suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._ext = [u'suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        (u'legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased),
        (u'releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._ext = []
    __OPERATION_Errors_val_ParameterType_1_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        (u'legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        (u'legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._ext = []
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        (u'none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        (u'bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        (u'partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._ext = []
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        (u'tone', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        (u'releaseCause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        (u'gapCriteria', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria),
        (u'gapIndicators', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators),
        (u'controlType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType),
        (u'gapTreatment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions),
        (u'legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        (u'callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        (u'gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        (u'suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._cont = ASN1Dict([
        (u'supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions),
        (u'releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._ext = [u'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID),
        (u'iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        (u'none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        (u'resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID),
        (u'scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        (u'bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        (u'allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        (u'allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        (u'requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions),
        (u'legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        (u'srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        (u'partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions),
        (u'aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        (u'redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        (u'redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        (u'legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        (u'oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        (u'suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._ext = [u'suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        (u'legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased),
        (u'releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        (u'legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        (u'legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        (u'none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        (u'resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        (u'legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        (u'bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions),
        (u'legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        (u'callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        (u'gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        (u'suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        (u'supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions),
        (u'releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._ext = [u'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        (u'callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        (u'bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._ext = None
    gsmSSF._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 3))]), dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 5))])], rr=[], ev=None, er=[])), (u'Responds', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 6))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 5))])
    
    #-----< gsmSRF >-----#
    gsmSRF = CLASS(name=u'gsmSRF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39._cont = ASN1Dict([
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID),
        (u'iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_2._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_2._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41._ext = None
    gsmSRF._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_2), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 13))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 6))])
    
    #-----< smsSSF-V3 >-----#
    smsSSF_V3 = CLASS(name=u'smsSSF-V3', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_serviceKey),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber),
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMSI),
        (u'locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC),
        (u'locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress),
        (u'timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier),
        (u'tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme),
        (u'tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions),
        (u'smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber),
        (u'mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_mscAddress),
        (u'sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number),
        (u'ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2),
        (u'gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass),
        (u'iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMEI),
        (u'calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43._cont = ASN1Dict([
        (u'callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45._cont = ASN1Dict([
        (u'sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventTypeSMS),
        (u'eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V3._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 20, 26, 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 8))])
    
    #-----< smsSSF-V4 >-----#
    smsSSF_V4 = CLASS(name=u'smsSSF-V4', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_serviceKey),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber),
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMSI),
        (u'locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC),
        (u'locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress),
        (u'timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier),
        (u'tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme),
        (u'tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions),
        (u'smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber),
        (u'mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_mscAddress),
        (u'sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number),
        (u'ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2),
        (u'gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass),
        (u'iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMEI),
        (u'calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49._cont = ASN1Dict([
        (u'callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50._cont = ASN1Dict([
        (u'sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventTypeSMS),
        (u'eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V4._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 9))])
    
    #-----< gprsSSF >-----#
    gprsSSF = CLASS(name=u'gprsSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_serviceKey),
        (u'gPRSEventType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType),
        (u'mSISDN', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_mSISDN),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMSI),
        (u'timeAndTimeZone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone),
        (u'gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass),
        (u'endUserAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress),
        (u'qualityOfService', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService),
        (u'accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName),
        (u'routeingAreaIdentity', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity),
        (u'chargingID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_chargingID),
        (u'sGSNCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities),
        (u'locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS),
        (u'pDPInitiationType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions),
        (u'gGSNAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress),
        (u'secondaryPDP-context', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context),
        (u'iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMEI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54._cont = ASN1Dict([
        (u'gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventType),
        (u'miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation),
        (u'pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56._cont = ASN1Dict([
        (u'gPRSCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57._cont = ASN1Dict([
        (u'accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName),
        (u'pdpID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_pdpID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________58 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59._cont = ASN1Dict([
        (u'gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60._cont = ASN1Dict([
        (u'gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventType),
        (u'miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation),
        (u'pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________________61 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65._cont = ASN1Dict([
        (u'gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66._cont = ASN1Dict([
        (u'gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventType),
        (u'miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation),
        (u'pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68._ext = []
    gprsSSF._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________58), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________________61), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 14))])], rr=[], ev=None, er=[])), (u'Responds', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 15))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 7))])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name=u'EXTENSION', mode=MODE_TYPE)
    _EXTENSION_ExtensionType = OPEN(name=u'ExtensionType', mode=MODE_TYPE)
    _EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default=u'ignore')
    _EXTENSION_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    EXTENSION._cont = ASN1Dict([
        (u'ExtensionType', _EXTENSION_ExtensionType),
        (u'criticality', _EXTENSION_criticality),
        (u'id', _EXTENSION_id),
        ])
    
    #-----< firstExtension >-----#
    firstExtension = CLASS(name=u'firstExtension', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _firstExtension_val_ExtensionType = NULL(name=u'ExtensionType', mode=MODE_TYPE)
    firstExtension._val = dict([(u'ExtensionType', _firstExtension_val_ExtensionType), (u'criticality', u'ignore'), (u'id', (u'global', (0, 4, 0, 1, 2)))])
    
    #-----< SupportedExtensions >-----#
    SupportedExtensions = CLASS(name=u'SupportedExtensions', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _SupportedExtensions_val_ExtensionType_0 = NULL(name=u'ExtensionType', mode=MODE_TYPE)
    SupportedExtensions._val = ASN1Set(rv=[dict([(u'ExtensionType', _SupportedExtensions_val_ExtensionType_0), (u'criticality', u'ignore'), (u'id', (u'global', (0, 4, 0, 1, 2)))])], rr=[], ev=[], er=[])
    
    #-----< PARAMETERS-BOUND >-----#
    PARAMETERS_BOUND = CLASS(name=u'PARAMETERS-BOUND', mode=MODE_TYPE)
    _PARAMETERS_BOUND_minAccessPointNameLength = INT(name=u'minAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAccessPointNameLength = INT(name=u'maxAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAChBillingChargingLength = INT(name=u'minAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAChBillingChargingLength = INT(name=u'maxAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAttributesLength = INT(name=u'minAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAttributesLength = INT(name=u'maxAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxBearerCapabilityLength = INT(name=u'maxBearerCapabilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyBCDNumberLength = INT(name=u'minCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength = INT(name=u'maxCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyNumberLength = INT(name=u'minCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyNumberLength = INT(name=u'maxCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallingPartyNumberLength = INT(name=u'minCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallingPartyNumberLength = INT(name=u'maxCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallResultLength = INT(name=u'minCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallResultLength = INT(name=u'maxCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCarrierLength = INT(name=u'minCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCarrierLength = INT(name=u'maxCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCauseLength = INT(name=u'minCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCauseLength = INT(name=u'maxCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minDigitsLength = INT(name=u'minDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxDigitsLength = INT(name=u'maxDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingDataLength = INT(name=u'minFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingDataLength = INT(name=u'maxFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingLength = INT(name=u'minFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingLength = INT(name=u'maxFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGenericNumberLength = INT(name=u'minGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGenericNumberLength = INT(name=u'maxGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGPRSCauseLength = INT(name=u'minGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGPRSCauseLength = INT(name=u'maxGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minIPSSPCapabilitiesLength = INT(name=u'minIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength = INT(name=u'maxIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLocationNumberLength = INT(name=u'minLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLocationNumberLength = INT(name=u'maxLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLowLayerCompatibilityLength = INT(name=u'minLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLowLayerCompatibilityLength = INT(name=u'maxLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minMessageContentLength = INT(name=u'minMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxMessageContentLength = INT(name=u'maxMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minOriginalCalledPartyIDLength = INT(name=u'minOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength = INT(name=u'maxOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minPDPAddressLength = INT(name=u'minPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxPDPAddressLength = INT(name=u'maxPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minRedirectingPartyIDLength = INT(name=u'minRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxRedirectingPartyIDLength = INT(name=u'maxRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minScfIDLength = INT(name=u'minScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxScfIDLength = INT(name=u'maxScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minSCIBillingChargingLength = INT(name=u'minSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxSCIBillingChargingLength = INT(name=u'maxSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minTimeAndTimezoneLength = INT(name=u'minTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxTimeAndTimezoneLength = INT(name=u'maxTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfBCSMEvents = INT(name=u'numOfBCSMEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo = INT(name=u'numOfChangeOfPositionControlInfo', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfCSs = INT(name=u'numOfCSs', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfSMSEvents = INT(name=u'numOfSMSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGPRSEvents = INT(name=u'numOfGPRSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfExtensions = INT(name=u'numOfExtensions', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGenericNumbers = INT(name=u'numOfGenericNumbers', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfMessageIDs = INT(name=u'numOfMessageIDs', mode=MODE_VALUE)
    PARAMETERS_BOUND._cont = ASN1Dict([
        (u'minAccessPointNameLength', _PARAMETERS_BOUND_minAccessPointNameLength),
        (u'maxAccessPointNameLength', _PARAMETERS_BOUND_maxAccessPointNameLength),
        (u'minAChBillingChargingLength', _PARAMETERS_BOUND_minAChBillingChargingLength),
        (u'maxAChBillingChargingLength', _PARAMETERS_BOUND_maxAChBillingChargingLength),
        (u'minAttributesLength', _PARAMETERS_BOUND_minAttributesLength),
        (u'maxAttributesLength', _PARAMETERS_BOUND_maxAttributesLength),
        (u'maxBearerCapabilityLength', _PARAMETERS_BOUND_maxBearerCapabilityLength),
        (u'minCalledPartyBCDNumberLength', _PARAMETERS_BOUND_minCalledPartyBCDNumberLength),
        (u'maxCalledPartyBCDNumberLength', _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength),
        (u'minCalledPartyNumberLength', _PARAMETERS_BOUND_minCalledPartyNumberLength),
        (u'maxCalledPartyNumberLength', _PARAMETERS_BOUND_maxCalledPartyNumberLength),
        (u'minCallingPartyNumberLength', _PARAMETERS_BOUND_minCallingPartyNumberLength),
        (u'maxCallingPartyNumberLength', _PARAMETERS_BOUND_maxCallingPartyNumberLength),
        (u'minCallResultLength', _PARAMETERS_BOUND_minCallResultLength),
        (u'maxCallResultLength', _PARAMETERS_BOUND_maxCallResultLength),
        (u'minCarrierLength', _PARAMETERS_BOUND_minCarrierLength),
        (u'maxCarrierLength', _PARAMETERS_BOUND_maxCarrierLength),
        (u'minCauseLength', _PARAMETERS_BOUND_minCauseLength),
        (u'maxCauseLength', _PARAMETERS_BOUND_maxCauseLength),
        (u'minDigitsLength', _PARAMETERS_BOUND_minDigitsLength),
        (u'maxDigitsLength', _PARAMETERS_BOUND_maxDigitsLength),
        (u'minFCIBillingChargingDataLength', _PARAMETERS_BOUND_minFCIBillingChargingDataLength),
        (u'maxFCIBillingChargingDataLength', _PARAMETERS_BOUND_maxFCIBillingChargingDataLength),
        (u'minFCIBillingChargingLength', _PARAMETERS_BOUND_minFCIBillingChargingLength),
        (u'maxFCIBillingChargingLength', _PARAMETERS_BOUND_maxFCIBillingChargingLength),
        (u'minGenericNumberLength', _PARAMETERS_BOUND_minGenericNumberLength),
        (u'maxGenericNumberLength', _PARAMETERS_BOUND_maxGenericNumberLength),
        (u'minGPRSCauseLength', _PARAMETERS_BOUND_minGPRSCauseLength),
        (u'maxGPRSCauseLength', _PARAMETERS_BOUND_maxGPRSCauseLength),
        (u'minIPSSPCapabilitiesLength', _PARAMETERS_BOUND_minIPSSPCapabilitiesLength),
        (u'maxIPSSPCapabilitiesLength', _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength),
        (u'minLocationNumberLength', _PARAMETERS_BOUND_minLocationNumberLength),
        (u'maxLocationNumberLength', _PARAMETERS_BOUND_maxLocationNumberLength),
        (u'minLowLayerCompatibilityLength', _PARAMETERS_BOUND_minLowLayerCompatibilityLength),
        (u'maxLowLayerCompatibilityLength', _PARAMETERS_BOUND_maxLowLayerCompatibilityLength),
        (u'minMessageContentLength', _PARAMETERS_BOUND_minMessageContentLength),
        (u'maxMessageContentLength', _PARAMETERS_BOUND_maxMessageContentLength),
        (u'minOriginalCalledPartyIDLength', _PARAMETERS_BOUND_minOriginalCalledPartyIDLength),
        (u'maxOriginalCalledPartyIDLength', _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength),
        (u'minPDPAddressLength', _PARAMETERS_BOUND_minPDPAddressLength),
        (u'maxPDPAddressLength', _PARAMETERS_BOUND_maxPDPAddressLength),
        (u'minRedirectingPartyIDLength', _PARAMETERS_BOUND_minRedirectingPartyIDLength),
        (u'maxRedirectingPartyIDLength', _PARAMETERS_BOUND_maxRedirectingPartyIDLength),
        (u'minScfIDLength', _PARAMETERS_BOUND_minScfIDLength),
        (u'maxScfIDLength', _PARAMETERS_BOUND_maxScfIDLength),
        (u'minSCIBillingChargingLength', _PARAMETERS_BOUND_minSCIBillingChargingLength),
        (u'maxSCIBillingChargingLength', _PARAMETERS_BOUND_maxSCIBillingChargingLength),
        (u'minTimeAndTimezoneLength', _PARAMETERS_BOUND_minTimeAndTimezoneLength),
        (u'maxTimeAndTimezoneLength', _PARAMETERS_BOUND_maxTimeAndTimezoneLength),
        (u'numOfBCSMEvents', _PARAMETERS_BOUND_numOfBCSMEvents),
        (u'numOfChangeOfPositionControlInfo', _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo),
        (u'numOfCSs', _PARAMETERS_BOUND_numOfCSs),
        (u'numOfSMSEvents', _PARAMETERS_BOUND_numOfSMSEvents),
        (u'numOfGPRSEvents', _PARAMETERS_BOUND_numOfGPRSEvents),
        (u'numOfExtensions', _PARAMETERS_BOUND_numOfExtensions),
        (u'numOfGenericNumbers', _PARAMETERS_BOUND_numOfGenericNumbers),
        (u'numOfMessageIDs', _PARAMETERS_BOUND_numOfMessageIDs),
        ])
    
    #-----< cAPSpecificBoundSet >-----#
    cAPSpecificBoundSet = CLASS(name=u'cAPSpecificBoundSet', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'PARAMETERS-BOUND')))
    cAPSpecificBoundSet._val = dict([(u'minAccessPointNameLength', 1), (u'maxAccessPointNameLength', 100), (u'minAChBillingChargingLength', 5), (u'maxAChBillingChargingLength', 177), (u'minAttributesLength', 2), (u'maxAttributesLength', 10), (u'maxBearerCapabilityLength', 11), (u'minCalledPartyBCDNumberLength', 1), (u'maxCalledPartyBCDNumberLength', 41), (u'minCalledPartyNumberLength', 2), (u'maxCalledPartyNumberLength', 18), (u'minCallingPartyNumberLength', 2), (u'maxCallingPartyNumberLength', 10), (u'minCallResultLength', 12), (u'maxCallResultLength', 193), (u'minCarrierLength', 4), (u'maxCarrierLength', 4), (u'minCauseLength', 2), (u'maxCauseLength', 32), (u'minDigitsLength', 2), (u'maxDigitsLength', 16), (u'minFCIBillingChargingDataLength', 1), (u'maxFCIBillingChargingDataLength', 160), (u'minFCIBillingChargingLength', 5), (u'maxFCIBillingChargingLength', 225), (u'minGenericNumberLength', 3), (u'maxGenericNumberLength', 11), (u'minGPRSCauseLength', 1), (u'maxGPRSCauseLength', 1), (u'minIPSSPCapabilitiesLength', 1), (u'maxIPSSPCapabilitiesLength', 4), (u'minLocationNumberLength', 2), (u'maxLocationNumberLength', 10), (u'minLowLayerCompatibilityLength', 1), (u'maxLowLayerCompatibilityLength', 16), (u'minMessageContentLength', 1), (u'maxMessageContentLength', 127), (u'minOriginalCalledPartyIDLength', 2), (u'maxOriginalCalledPartyIDLength', 10), (u'minPDPAddressLength', 1), (u'maxPDPAddressLength', 63), (u'minRedirectingPartyIDLength', 2), (u'maxRedirectingPartyIDLength', 10), (u'minScfIDLength', 2), (u'maxScfIDLength', 25), (u'minSCIBillingChargingLength', 4), (u'maxSCIBillingChargingLength', 225), (u'minTimeAndTimezoneLength', 8), (u'maxTimeAndTimezoneLength', 8), (u'numOfBCSMEvents', 30), (u'numOfChangeOfPositionControlInfo', 10), (u'numOfCSs', 127), (u'numOfSMSEvents', 10), (u'numOfGPRSEvents', 10), (u'numOfExtensions', 10), (u'numOfGenericNumbers', 5), (u'numOfMessageIDs', 16)])
    
    _all_ = [
        gsmSSF,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        __OPERATION_Errors_val_ParameterType_2_0,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_7,
        __OPERATION_Errors_val_ParameterType_8,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13,
        __OPERATION_Linked_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0_0,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_1,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38,
        gsmSRF,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________39,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________40,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_9,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_2_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________41,
        smsSSF_V3,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________42,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________43,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________44,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________45,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_6,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________46,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________47,
        smsSSF_V4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________48,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________49,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________50,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_7,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________51,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________52,
        gprsSSF,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_mSISDN,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_chargingID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53_iMEI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________53,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________54,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_8,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________55,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________56,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57_pdpID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________57,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________58,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________59,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________60,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_10,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________________________________61,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________________________________62,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________________________________________63,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________________________________________64,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________________________________________65,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________________________________________66,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0__11,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________________________________________67,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________________________________________68,
        _EXTENSION_ExtensionType,
        _EXTENSION_criticality,
        _EXTENSION_id,
        EXTENSION,
        firstExtension,
        _firstExtension_val_ExtensionType,
        SupportedExtensions,
        _SupportedExtensions_val_ExtensionType_0,
        _PARAMETERS_BOUND_minAccessPointNameLength,
        _PARAMETERS_BOUND_maxAccessPointNameLength,
        _PARAMETERS_BOUND_minAChBillingChargingLength,
        _PARAMETERS_BOUND_maxAChBillingChargingLength,
        _PARAMETERS_BOUND_minAttributesLength,
        _PARAMETERS_BOUND_maxAttributesLength,
        _PARAMETERS_BOUND_maxBearerCapabilityLength,
        _PARAMETERS_BOUND_minCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_minCalledPartyNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyNumberLength,
        _PARAMETERS_BOUND_minCallingPartyNumberLength,
        _PARAMETERS_BOUND_maxCallingPartyNumberLength,
        _PARAMETERS_BOUND_minCallResultLength,
        _PARAMETERS_BOUND_maxCallResultLength,
        _PARAMETERS_BOUND_minCarrierLength,
        _PARAMETERS_BOUND_maxCarrierLength,
        _PARAMETERS_BOUND_minCauseLength,
        _PARAMETERS_BOUND_maxCauseLength,
        _PARAMETERS_BOUND_minDigitsLength,
        _PARAMETERS_BOUND_maxDigitsLength,
        _PARAMETERS_BOUND_minFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_minFCIBillingChargingLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingLength,
        _PARAMETERS_BOUND_minGenericNumberLength,
        _PARAMETERS_BOUND_maxGenericNumberLength,
        _PARAMETERS_BOUND_minGPRSCauseLength,
        _PARAMETERS_BOUND_maxGPRSCauseLength,
        _PARAMETERS_BOUND_minIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_minLocationNumberLength,
        _PARAMETERS_BOUND_maxLocationNumberLength,
        _PARAMETERS_BOUND_minLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_maxLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_minMessageContentLength,
        _PARAMETERS_BOUND_maxMessageContentLength,
        _PARAMETERS_BOUND_minOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_minPDPAddressLength,
        _PARAMETERS_BOUND_maxPDPAddressLength,
        _PARAMETERS_BOUND_minRedirectingPartyIDLength,
        _PARAMETERS_BOUND_maxRedirectingPartyIDLength,
        _PARAMETERS_BOUND_minScfIDLength,
        _PARAMETERS_BOUND_maxScfIDLength,
        _PARAMETERS_BOUND_minSCIBillingChargingLength,
        _PARAMETERS_BOUND_maxSCIBillingChargingLength,
        _PARAMETERS_BOUND_minTimeAndTimezoneLength,
        _PARAMETERS_BOUND_maxTimeAndTimezoneLength,
        _PARAMETERS_BOUND_numOfBCSMEvents,
        _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo,
        _PARAMETERS_BOUND_numOfCSs,
        _PARAMETERS_BOUND_numOfSMSEvents,
        _PARAMETERS_BOUND_numOfGPRSEvents,
        _PARAMETERS_BOUND_numOfExtensions,
        _PARAMETERS_BOUND_numOfGenericNumbers,
        _PARAMETERS_BOUND_numOfMessageIDs,
        PARAMETERS_BOUND,
        cAPSpecificBoundSet,
    ]

class CAP_datatypes:

    _name_  = u'CAP-datatypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 52, 7]
    
    _obj_ = [
        u'AccessPointName',
        u'AChBillingChargingCharacteristics',
        u'AChChargingAddress',
        u'AdditionalCallingPartyNumber',
        u'AlertingPattern',
        u'AOCBeforeAnswer',
        u'AOCGPRS',
        u'AOCSubsequent',
        u'AppendFreeFormatData',
        u'ApplicationTimer',
        u'AssistingSSPIPRoutingAddress',
        u'AudibleIndicator',
        u'BackwardServiceInteractionInd',
        u'BasicGapCriteria',
        u'BCSMEvent',
        u'BCSM-Failure',
        u'BearerCapability',
        u'Burst',
        u'BurstList',
        u'CAI-GSM0224',
        u'CalledPartyBCDNumber',
        u'CalledPartyNumber',
        u'CallingPartyNumber',
        u'CallResult',
        u'CallSegmentFailure',
        u'CallSegmentID',
        u'CallSegmentToCancel',
        u'CAMEL-AChBillingChargingCharacteristics',
        u'CAMEL-CallResult',
        u'CAMEL-FCIBillingChargingCharacteristics',
        u'CAMEL-FCIGPRSBillingChargingCharacteristics',
        u'CAMEL-FCISMSBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristicsAlt',
        u'CAMEL-SCIGPRSBillingChargingCharacteristics',
        u'Carrier',
        u'Cause',
        u'CGEncountered',
        u'ChangeOfPositionControlInfo',
        u'ChangeOfLocation',
        u'ChangeOfLocationAlt',
        u'ChargeIndicator',
        u'ChargeNumber',
        u'ChargingCharacteristics',
        u'ChargingResult',
        u'ChargingRollOver',
        u'CollectedDigits',
        u'CollectedInfo',
        u'ConnectedNumberTreatmentInd',
        u'ControlType',
        u'CompoundCriteria',
        u'CorrelationID',
        u'DateAndTime',
        u'DestinationRoutingAddress',
        u'Digits',
        u'DpSpecificCriteria',
        u'DpSpecificCriteriaAlt',
        u'DpSpecificInfoAlt',
        u'ElapsedTime',
        u'ElapsedTimeRollOver',
        u'EndUserAddress',
        u'ErrorTreatment',
        u'EventSpecificInformationBCSM',
        u'EventSpecificInformationSMS',
        u'EventTypeBCSM',
        u'EventTypeSMS',
        u'Extensions',
        u'ExtensionField',
        u'FCIBillingChargingCharacteristics',
        u'FCIGPRSBillingChargingCharacteristics',
        u'FCISMSBillingChargingCharacteristics',
        u'ForwardServiceInteractionInd',
        u'GapCriteria',
        u'GapIndicators',
        u'GapOnService',
        u'GapTreatment',
        u'GenericNumber',
        u'GenericNumbers',
        u'GPRS-QoS',
        u'GPRS-QoS-Extension',
        u'GPRSCause',
        u'GPRSEvent',
        u'GPRSEventSpecificInformation',
        u'GPRSEventType',
        u'InbandInfo',
        u'InformationToSend',
        u'InitiatingEntity',
        u'InitiatorOfServiceChange',
        u'InvokeID',
        u'IPRoutingAddress',
        u'IPSSPCapabilities',
        u'LegOrCallSegment',
        u'LegType',
        u'leg1',
        u'leg2',
        u'LocationInformationGPRS',
        u'LocationNumber',
        u'LowLayerCompatibility',
        u'MessageID',
        u'MetDPCriteriaList',
        u'MetDPCriterion',
        u'MetDPCriterionAlt',
        u'MidCallControlInfo',
        u'MonitorMode',
        u'MO-SMSCause',
        u'MT-SMSCause',
        u'NAOliInfo',
        u'NatureOfServiceChange',
        u'NumberOfDigits',
        u'OCSIApplicable',
        u'OriginalCalledPartyID',
        u'PDPID',
        u'PDPInitiationType',
        u'QualityOfService',
        u'ReceivingSideID',
        u'RedirectingPartyID',
        u'RequestedInformationList',
        u'RequestedInformationTypeList',
        u'RequestedInformation',
        u'RequestedInformationType',
        u'RequestedInformationValue',
        u'RPCause',
        u'ScfID',
        u'SCIBillingChargingCharacteristics',
        u'SCIGPRSBillingChargingCharacteristics',
        u'SendingSideID',
        u'ServiceInteractionIndicatorsTwo',
        u'SGSNCapabilities',
        u'SMS-AddressString',
        u'maxSMS-AddressStringLength',
        u'SMSEvent',
        u'TariffSwitchInterval',
        u'TimeAndTimezone',
        u'TimeIfNoTariffSwitch',
        u'TimeIfTariffSwitch',
        u'TimeInformation',
        u'TimerID',
        u'TimerValue',
        u'Tone',
        u'TPDataCodingScheme',
        u'TPProtocolIdentifier',
        u'TPShortMessageSpecificInfo',
        u'TPValidityPeriod',
        u'TransferredVolume',
        u'TransferredVolumeRollOver',
        u'UnavailableNetworkResource',
        u'VariablePart',
        u'numOfInfoItems',
        ]
    _type_ = [
        u'AccessPointName',
        u'AChBillingChargingCharacteristics',
        u'AChChargingAddress',
        u'AdditionalCallingPartyNumber',
        u'AlertingPattern',
        u'AOCBeforeAnswer',
        u'AOCGPRS',
        u'AOCSubsequent',
        u'AppendFreeFormatData',
        u'ApplicationTimer',
        u'AssistingSSPIPRoutingAddress',
        u'AudibleIndicator',
        u'BackwardServiceInteractionInd',
        u'BasicGapCriteria',
        u'BCSMEvent',
        u'BCSM-Failure',
        u'BearerCapability',
        u'Burst',
        u'BurstList',
        u'CAI-GSM0224',
        u'CalledPartyBCDNumber',
        u'CalledPartyNumber',
        u'CallingPartyNumber',
        u'CallResult',
        u'CallSegmentFailure',
        u'CallSegmentID',
        u'CallSegmentToCancel',
        u'CAMEL-AChBillingChargingCharacteristics',
        u'CAMEL-CallResult',
        u'CAMEL-FCIBillingChargingCharacteristics',
        u'CAMEL-FCIGPRSBillingChargingCharacteristics',
        u'CAMEL-FCISMSBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristicsAlt',
        u'CAMEL-SCIGPRSBillingChargingCharacteristics',
        u'Carrier',
        u'Cause',
        u'CGEncountered',
        u'ChangeOfPositionControlInfo',
        u'ChangeOfLocation',
        u'ChangeOfLocationAlt',
        u'ChargeIndicator',
        u'ChargeNumber',
        u'ChargingCharacteristics',
        u'ChargingResult',
        u'ChargingRollOver',
        u'CollectedDigits',
        u'CollectedInfo',
        u'ConnectedNumberTreatmentInd',
        u'ControlType',
        u'CompoundCriteria',
        u'CorrelationID',
        u'DateAndTime',
        u'DestinationRoutingAddress',
        u'Digits',
        u'DpSpecificCriteria',
        u'DpSpecificCriteriaAlt',
        u'DpSpecificInfoAlt',
        u'ElapsedTime',
        u'ElapsedTimeRollOver',
        u'EndUserAddress',
        u'ErrorTreatment',
        u'EventSpecificInformationBCSM',
        u'EventSpecificInformationSMS',
        u'EventTypeBCSM',
        u'EventTypeSMS',
        u'Extensions',
        u'ExtensionField',
        u'FCIBillingChargingCharacteristics',
        u'FCIGPRSBillingChargingCharacteristics',
        u'FCISMSBillingChargingCharacteristics',
        u'ForwardServiceInteractionInd',
        u'GapCriteria',
        u'GapIndicators',
        u'GapOnService',
        u'GapTreatment',
        u'GenericNumber',
        u'GenericNumbers',
        u'GPRS-QoS',
        u'GPRS-QoS-Extension',
        u'GPRSCause',
        u'GPRSEvent',
        u'GPRSEventSpecificInformation',
        u'GPRSEventType',
        u'InbandInfo',
        u'InformationToSend',
        u'InitiatingEntity',
        u'InitiatorOfServiceChange',
        u'InvokeID',
        u'IPRoutingAddress',
        u'IPSSPCapabilities',
        u'LegOrCallSegment',
        u'LegType',
        u'LocationInformationGPRS',
        u'LocationNumber',
        u'LowLayerCompatibility',
        u'MessageID',
        u'MetDPCriteriaList',
        u'MetDPCriterion',
        u'MetDPCriterionAlt',
        u'MidCallControlInfo',
        u'MonitorMode',
        u'MO-SMSCause',
        u'MT-SMSCause',
        u'NAOliInfo',
        u'NatureOfServiceChange',
        u'NumberOfDigits',
        u'OCSIApplicable',
        u'OriginalCalledPartyID',
        u'PDPID',
        u'PDPInitiationType',
        u'QualityOfService',
        u'ReceivingSideID',
        u'RedirectingPartyID',
        u'RequestedInformationList',
        u'RequestedInformationTypeList',
        u'RequestedInformation',
        u'RequestedInformationType',
        u'RequestedInformationValue',
        u'RPCause',
        u'ScfID',
        u'SCIBillingChargingCharacteristics',
        u'SCIGPRSBillingChargingCharacteristics',
        u'SendingSideID',
        u'ServiceInteractionIndicatorsTwo',
        u'SGSNCapabilities',
        u'SMS-AddressString',
        u'SMSEvent',
        u'TariffSwitchInterval',
        u'TimeAndTimezone',
        u'TimeIfNoTariffSwitch',
        u'TimeIfTariffSwitch',
        u'TimeInformation',
        u'TimerID',
        u'TimerValue',
        u'Tone',
        u'TPDataCodingScheme',
        u'TPProtocolIdentifier',
        u'TPShortMessageSpecificInfo',
        u'TPValidityPeriod',
        u'TransferredVolume',
        u'TransferredVolumeRollOver',
        u'UnavailableNetworkResource',
        u'VariablePart',
        ]
    _set_ = [
        ]
    _val_ = [
        u'leg1',
        u'leg2',
        u'maxSMS-AddressStringLength',
        u'numOfInfoItems',
        ]
    _class_ = [
        ]
    _param_ = [
        u'AccessPointName',
        u'AChBillingChargingCharacteristics',
        u'AChChargingAddress',
        u'AdditionalCallingPartyNumber',
        u'AssistingSSPIPRoutingAddress',
        u'BasicGapCriteria',
        u'BCSMEvent',
        u'BCSM-Failure',
        u'BearerCapability',
        u'CalledPartyBCDNumber',
        u'CalledPartyNumber',
        u'CallingPartyNumber',
        u'CallResult',
        u'CallSegmentFailure',
        u'CallSegmentID',
        u'CallSegmentToCancel',
        u'CAMEL-AChBillingChargingCharacteristics',
        u'CAMEL-CallResult',
        u'CAMEL-FCIBillingChargingCharacteristics',
        u'CAMEL-FCIGPRSBillingChargingCharacteristics',
        u'CAMEL-FCISMSBillingChargingCharacteristics',
        u'Carrier',
        u'Cause',
        u'ChangeOfPositionControlInfo',
        u'ChangeOfLocation',
        u'ChangeOfLocationAlt',
        u'ChargeNumber',
        u'CompoundCriteria',
        u'CorrelationID',
        u'DestinationRoutingAddress',
        u'Digits',
        u'DpSpecificCriteria',
        u'DpSpecificCriteriaAlt',
        u'DpSpecificInfoAlt',
        u'EndUserAddress',
        u'EventSpecificInformationBCSM',
        u'Extensions',
        u'FCIBillingChargingCharacteristics',
        u'FCIGPRSBillingChargingCharacteristics',
        u'FCISMSBillingChargingCharacteristics',
        u'GapCriteria',
        u'GapTreatment',
        u'GenericNumber',
        u'GenericNumbers',
        u'GPRSCause',
        u'GPRSEventSpecificInformation',
        u'InbandInfo',
        u'InformationToSend',
        u'IPRoutingAddress',
        u'IPSSPCapabilities',
        u'LegOrCallSegment',
        u'LocationNumber',
        u'LowLayerCompatibility',
        u'MessageID',
        u'MetDPCriteriaList',
        u'MetDPCriterion',
        u'MetDPCriterionAlt',
        u'OriginalCalledPartyID',
        u'RedirectingPartyID',
        u'RequestedInformationList',
        u'RequestedInformation',
        u'RequestedInformationValue',
        u'ScfID',
        u'SCIBillingChargingCharacteristics',
        u'SCIGPRSBillingChargingCharacteristics',
        u'TimeAndTimezone',
        u'VariablePart',
        ]
    
    #-----< AccessPointName >-----#
    AccessPointName = OCT_STR(name=u'AccessPointName', mode=MODE_TYPE, param=True)
    
    #-----< AChBillingChargingCharacteristics >-----#
    AChBillingChargingCharacteristics = OCT_STR(name=u'AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< AChChargingAddress >-----#
    AChChargingAddress = CHOICE(name=u'AChChargingAddress', mode=MODE_TYPE, param=True)
    
    #-----< AdditionalCallingPartyNumber >-----#
    AdditionalCallingPartyNumber = OCT_STR(name=u'AdditionalCallingPartyNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name=u'AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< AOCBeforeAnswer >-----#
    AOCBeforeAnswer = SEQ(name=u'AOCBeforeAnswer', mode=MODE_TYPE)
    _AOCBeforeAnswer_aOCInitial = SEQ(name=u'aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCBeforeAnswer_aOCSubsequent = SEQ(name=u'aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCBeforeAnswer._cont = ASN1Dict([
        (u'aOCInitial', _AOCBeforeAnswer_aOCInitial),
        (u'aOCSubsequent', _AOCBeforeAnswer_aOCSubsequent),
        ])
    AOCBeforeAnswer._ext = None
    
    #-----< AOCGPRS >-----#
    AOCGPRS = SEQ(name=u'AOCGPRS', mode=MODE_TYPE)
    _AOCGPRS_aOCInitial = SEQ(name=u'aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCGPRS_aOCSubsequent = SEQ(name=u'aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCGPRS._cont = ASN1Dict([
        (u'aOCInitial', _AOCGPRS_aOCInitial),
        (u'aOCSubsequent', _AOCGPRS_aOCSubsequent),
        ])
    AOCGPRS._ext = None
    
    #-----< AOCSubsequent >-----#
    AOCSubsequent = SEQ(name=u'AOCSubsequent', mode=MODE_TYPE)
    _AOCSubsequent_cAI_GSM0224 = SEQ(name=u'cAI-GSM0224', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCSubsequent_tariffSwitchInterval = INT(name=u'tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AOCSubsequent_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    AOCSubsequent._cont = ASN1Dict([
        (u'cAI-GSM0224', _AOCSubsequent_cAI_GSM0224),
        (u'tariffSwitchInterval', _AOCSubsequent_tariffSwitchInterval),
        ])
    AOCSubsequent._ext = None
    
    #-----< AppendFreeFormatData >-----#
    AppendFreeFormatData = ENUM(name=u'AppendFreeFormatData', mode=MODE_TYPE)
    AppendFreeFormatData._cont = ASN1Dict([(u'overwrite', 0), (u'append', 1)])
    AppendFreeFormatData._ext = None
    
    #-----< ApplicationTimer >-----#
    ApplicationTimer = INT(name=u'ApplicationTimer', mode=MODE_TYPE)
    ApplicationTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< AssistingSSPIPRoutingAddress >-----#
    AssistingSSPIPRoutingAddress = OCT_STR(name=u'AssistingSSPIPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AudibleIndicator >-----#
    AudibleIndicator = CHOICE(name=u'AudibleIndicator', mode=MODE_TYPE)
    _AudibleIndicator_tone = BOOL(name=u'tone', mode=MODE_TYPE)
    _AudibleIndicator_burstList = SEQ(name=u'burstList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BurstList')))
    AudibleIndicator._cont = ASN1Dict([
        (u'tone', _AudibleIndicator_tone),
        (u'burstList', _AudibleIndicator_burstList),
        ])
    AudibleIndicator._ext = None
    
    #-----< BackwardServiceInteractionInd >-----#
    BackwardServiceInteractionInd = SEQ(name=u'BackwardServiceInteractionInd', mode=MODE_TYPE)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name=u'conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator = OCT_STR(name=u'callCompletionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    BackwardServiceInteractionInd._cont = ASN1Dict([
        (u'conferenceTreatmentIndicator', _BackwardServiceInteractionInd_conferenceTreatmentIndicator),
        (u'callCompletionTreatmentIndicator', _BackwardServiceInteractionInd_callCompletionTreatmentIndicator),
        ])
    BackwardServiceInteractionInd._ext = []
    
    #-----< BasicGapCriteria >-----#
    BasicGapCriteria = CHOICE(name=u'BasicGapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< BCSMEvent >-----#
    BCSMEvent = SEQ(name=u'BCSMEvent', mode=MODE_TYPE, param=True)
    
    #-----< BCSM-Failure >-----#
    BCSM_Failure = SEQ(name=u'BCSM-Failure', mode=MODE_TYPE, param=True)
    
    #-----< BearerCapability >-----#
    BearerCapability = CHOICE(name=u'BearerCapability', mode=MODE_TYPE, param=True)
    
    #-----< Burst >-----#
    Burst = SEQ(name=u'Burst', mode=MODE_TYPE)
    _Burst_numberOfBursts = INT(name=u'numberOfBursts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _Burst_numberOfBursts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_burstInterval = INT(name=u'burstInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_burstInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _Burst_numberOfTonesInBurst = INT(name=u'numberOfTonesInBurst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=3)
    _Burst_numberOfTonesInBurst._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_toneDuration = INT(name=u'toneDuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _Burst_toneInterval = INT(name=u'toneInterval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    Burst._cont = ASN1Dict([
        (u'numberOfBursts', _Burst_numberOfBursts),
        (u'burstInterval', _Burst_burstInterval),
        (u'numberOfTonesInBurst', _Burst_numberOfTonesInBurst),
        (u'toneDuration', _Burst_toneDuration),
        (u'toneInterval', _Burst_toneInterval),
        ])
    Burst._ext = []
    
    #-----< BurstList >-----#
    BurstList = SEQ(name=u'BurstList', mode=MODE_TYPE)
    _BurstList_warningPeriod = INT(name=u'warningPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _BurstList_warningPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _BurstList_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    BurstList._cont = ASN1Dict([
        (u'warningPeriod', _BurstList_warningPeriod),
        (u'bursts', _BurstList_bursts),
        ])
    BurstList._ext = []
    
    #-----< CAI-GSM0224 >-----#
    CAI_GSM0224 = SEQ(name=u'CAI-GSM0224', mode=MODE_TYPE)
    _CAI_GSM0224_e1 = INT(name=u'e1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e2 = INT(name=u'e2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e3 = INT(name=u'e3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e4 = INT(name=u'e4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e5 = INT(name=u'e5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e6 = INT(name=u'e6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e6._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e7 = INT(name=u'e7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    CAI_GSM0224._cont = ASN1Dict([
        (u'e1', _CAI_GSM0224_e1),
        (u'e2', _CAI_GSM0224_e2),
        (u'e3', _CAI_GSM0224_e3),
        (u'e4', _CAI_GSM0224_e4),
        (u'e5', _CAI_GSM0224_e5),
        (u'e6', _CAI_GSM0224_e6),
        (u'e7', _CAI_GSM0224_e7),
        ])
    CAI_GSM0224._ext = None
    
    #-----< CalledPartyBCDNumber >-----#
    CalledPartyBCDNumber = OCT_STR(name=u'CalledPartyBCDNumber', mode=MODE_TYPE, param=True)
    
    #-----< CalledPartyNumber >-----#
    CalledPartyNumber = OCT_STR(name=u'CalledPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallingPartyNumber >-----#
    CallingPartyNumber = OCT_STR(name=u'CallingPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallResult >-----#
    CallResult = OCT_STR(name=u'CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentFailure >-----#
    CallSegmentFailure = SEQ(name=u'CallSegmentFailure', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentID >-----#
    CallSegmentID = INT(name=u'CallSegmentID', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentToCancel >-----#
    CallSegmentToCancel = SEQ(name=u'CallSegmentToCancel', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-AChBillingChargingCharacteristics >-----#
    CAMEL_AChBillingChargingCharacteristics = CHOICE(name=u'CAMEL-AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-CallResult >-----#
    CAMEL_CallResult = CHOICE(name=u'CAMEL-CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIBillingChargingCharacteristics >-----#
    CAMEL_FCIBillingChargingCharacteristics = CHOICE(name=u'CAMEL-FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_FCIGPRSBillingChargingCharacteristics = SEQ(name=u'CAMEL-FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCISMSBillingChargingCharacteristics >-----#
    CAMEL_FCISMSBillingChargingCharacteristics = CHOICE(name=u'CAMEL-FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-SCIBillingChargingCharacteristics >-----#
    CAMEL_SCIBillingChargingCharacteristics = CHOICE(name=u'CAMEL-SCIBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer = SEQ(name=u'aOCBeforeAnswer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCBeforeAnswer')))
    _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer = SEQ(name=u'aOCAfterAnswer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')))
    _CAMEL_SCIBillingChargingCharacteristics_aOC_extension = SEQ(name=u'aOC-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAMEL-SCIBillingChargingCharacteristicsAlt')))
    CAMEL_SCIBillingChargingCharacteristics._cont = ASN1Dict([
        (u'aOCBeforeAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer),
        (u'aOCAfterAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer),
        (u'aOC-extension', _CAMEL_SCIBillingChargingCharacteristics_aOC_extension),
        ])
    CAMEL_SCIBillingChargingCharacteristics._ext = None
    
    #-----< CAMEL-SCIBillingChargingCharacteristicsAlt >-----#
    CAMEL_SCIBillingChargingCharacteristicsAlt = SEQ(name=u'CAMEL-SCIBillingChargingCharacteristicsAlt', mode=MODE_TYPE)
    CAMEL_SCIBillingChargingCharacteristicsAlt._cont = ASN1Dict([
        ])
    CAMEL_SCIBillingChargingCharacteristicsAlt._ext = []
    
    #-----< CAMEL-SCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_SCIGPRSBillingChargingCharacteristics = SEQ(name=u'CAMEL-SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS = SEQ(name=u'aOCGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCGPRS')))
    _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CAMEL_SCIGPRSBillingChargingCharacteristics._cont = ASN1Dict([
        (u'aOCGPRS', _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS),
        (u'pDPID', _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID),
        ])
    CAMEL_SCIGPRSBillingChargingCharacteristics._ext = []
    
    #-----< Carrier >-----#
    Carrier = OCT_STR(name=u'Carrier', mode=MODE_TYPE, param=True)
    
    #-----< Cause >-----#
    Cause = OCT_STR(name=u'Cause', mode=MODE_TYPE, param=True)
    
    #-----< CGEncountered >-----#
    CGEncountered = ENUM(name=u'CGEncountered', mode=MODE_TYPE)
    CGEncountered._cont = ASN1Dict([(u'noCGencountered', 0), (u'manualCGencountered', 1), (u'scpOverload', 2)])
    CGEncountered._ext = None
    
    #-----< ChangeOfPositionControlInfo >-----#
    ChangeOfPositionControlInfo = SEQ_OF(name=u'ChangeOfPositionControlInfo', mode=MODE_TYPE, param=True)
    
    #-----< ChangeOfLocation >-----#
    ChangeOfLocation = CHOICE(name=u'ChangeOfLocation', mode=MODE_TYPE)
    _ChangeOfLocation_cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _ChangeOfLocation_inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _ChangeOfLocation_changeOfLocationAlt._cont = ASN1Dict([
        ])
    _ChangeOfLocation_changeOfLocationAlt._ext = []
    ChangeOfLocation._cont = ASN1Dict([
        (u'cellGlobalId', _ChangeOfLocation_cellGlobalId),
        (u'serviceAreaId', _ChangeOfLocation_serviceAreaId),
        (u'locationAreaId', _ChangeOfLocation_locationAreaId),
        (u'inter-SystemHandOver', _ChangeOfLocation_inter_SystemHandOver),
        (u'inter-PLMNHandOver', _ChangeOfLocation_inter_PLMNHandOver),
        (u'inter-MSCHandOver', _ChangeOfLocation_inter_MSCHandOver),
        (u'changeOfLocationAlt', _ChangeOfLocation_changeOfLocationAlt),
        ])
    ChangeOfLocation._ext = None
    
    #-----< ChangeOfLocationAlt >-----#
    ChangeOfLocationAlt = SEQ(name=u'ChangeOfLocationAlt', mode=MODE_TYPE)
    ChangeOfLocationAlt._cont = ASN1Dict([
        ])
    ChangeOfLocationAlt._ext = []
    
    #-----< ChargeIndicator >-----#
    ChargeIndicator = OCT_STR(name=u'ChargeIndicator', mode=MODE_TYPE)
    ChargeIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargeNumber >-----#
    ChargeNumber = OCT_STR(name=u'ChargeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), param=True)
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = CHOICE(name=u'ChargingCharacteristics', mode=MODE_TYPE)
    _ChargingCharacteristics_maxTransferredVolume = INT(name=u'maxTransferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxTransferredVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _ChargingCharacteristics_maxElapsedTime = INT(name=u'maxElapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxElapsedTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    ChargingCharacteristics._cont = ASN1Dict([
        (u'maxTransferredVolume', _ChargingCharacteristics_maxTransferredVolume),
        (u'maxElapsedTime', _ChargingCharacteristics_maxElapsedTime),
        ])
    ChargingCharacteristics._ext = None
    
    #-----< ChargingResult >-----#
    ChargingResult = CHOICE(name=u'ChargingResult', mode=MODE_TYPE)
    _ChargingResult_transferredVolume = CHOICE(name=u'transferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolume')))
    _ChargingResult_elapsedTime = CHOICE(name=u'elapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTime')))
    ChargingResult._cont = ASN1Dict([
        (u'transferredVolume', _ChargingResult_transferredVolume),
        (u'elapsedTime', _ChargingResult_elapsedTime),
        ])
    ChargingResult._ext = None
    
    #-----< ChargingRollOver >-----#
    ChargingRollOver = CHOICE(name=u'ChargingRollOver', mode=MODE_TYPE)
    _ChargingRollOver_transferredVolumeRollOver = CHOICE(name=u'transferredVolumeRollOver', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolumeRollOver')))
    _ChargingRollOver_elapsedTimeRollOver = CHOICE(name=u'elapsedTimeRollOver', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTimeRollOver')))
    ChargingRollOver._cont = ASN1Dict([
        (u'transferredVolumeRollOver', _ChargingRollOver_transferredVolumeRollOver),
        (u'elapsedTimeRollOver', _ChargingRollOver_elapsedTimeRollOver),
        ])
    ChargingRollOver._ext = None
    
    #-----< CollectedDigits >-----#
    CollectedDigits = SEQ(name=u'CollectedDigits', mode=MODE_TYPE)
    _CollectedDigits_minimumNbOfDigits = INT(name=u'minimumNbOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _CollectedDigits_minimumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_maximumNbOfDigits = INT(name=u'maximumNbOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CollectedDigits_maximumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_endOfReplyDigit = OCT_STR(name=u'endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_cancelDigit = OCT_STR(name=u'cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_startDigit = OCT_STR(name=u'startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_firstDigitTimeOut = INT(name=u'firstDigitTimeOut', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_firstDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_interDigitTimeOut = INT(name=u'interDigitTimeOut', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_interDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_errorTreatment = ENUM(name=u'errorTreatment', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ErrorTreatment')), default=u'stdErrorAndInfo')
    _CollectedDigits_interruptableAnnInd = BOOL(name=u'interruptableAnnInd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _CollectedDigits_voiceInformation = BOOL(name=u'voiceInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _CollectedDigits_voiceBack = BOOL(name=u'voiceBack', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    CollectedDigits._cont = ASN1Dict([
        (u'minimumNbOfDigits', _CollectedDigits_minimumNbOfDigits),
        (u'maximumNbOfDigits', _CollectedDigits_maximumNbOfDigits),
        (u'endOfReplyDigit', _CollectedDigits_endOfReplyDigit),
        (u'cancelDigit', _CollectedDigits_cancelDigit),
        (u'startDigit', _CollectedDigits_startDigit),
        (u'firstDigitTimeOut', _CollectedDigits_firstDigitTimeOut),
        (u'interDigitTimeOut', _CollectedDigits_interDigitTimeOut),
        (u'errorTreatment', _CollectedDigits_errorTreatment),
        (u'interruptableAnnInd', _CollectedDigits_interruptableAnnInd),
        (u'voiceInformation', _CollectedDigits_voiceInformation),
        (u'voiceBack', _CollectedDigits_voiceBack),
        ])
    CollectedDigits._ext = None
    
    #-----< CollectedInfo >-----#
    CollectedInfo = CHOICE(name=u'CollectedInfo', mode=MODE_TYPE)
    _CollectedInfo_collectedDigits = SEQ(name=u'collectedDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedDigits')))
    CollectedInfo._cont = ASN1Dict([
        (u'collectedDigits', _CollectedInfo_collectedDigits),
        ])
    CollectedInfo._ext = None
    
    #-----< ConnectedNumberTreatmentInd >-----#
    ConnectedNumberTreatmentInd = ENUM(name=u'ConnectedNumberTreatmentInd', mode=MODE_TYPE)
    ConnectedNumberTreatmentInd._cont = ASN1Dict([(u'noINImpact', 0), (u'presentationRestricted', 1), (u'presentCalledINNumber', 2), (u'presentCallINNumberRestricted', 3)])
    ConnectedNumberTreatmentInd._ext = None
    
    #-----< ControlType >-----#
    ControlType = ENUM(name=u'ControlType', mode=MODE_TYPE)
    ControlType._cont = ASN1Dict([(u'sCPOverloaded', 0), (u'manuallyInitiated', 1)])
    ControlType._ext = None
    
    #-----< CompoundCriteria >-----#
    CompoundCriteria = SEQ(name=u'CompoundCriteria', mode=MODE_TYPE, param=True)
    
    #-----< CorrelationID >-----#
    CorrelationID = OCT_STR(name=u'CorrelationID', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< DateAndTime >-----#
    DateAndTime = OCT_STR(name=u'DateAndTime', mode=MODE_TYPE)
    DateAndTime._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< DestinationRoutingAddress >-----#
    DestinationRoutingAddress = SEQ_OF(name=u'DestinationRoutingAddress', mode=MODE_TYPE, param=True)
    
    #-----< Digits >-----#
    Digits = OCT_STR(name=u'Digits', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteria >-----#
    DpSpecificCriteria = CHOICE(name=u'DpSpecificCriteria', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteriaAlt >-----#
    DpSpecificCriteriaAlt = SEQ(name=u'DpSpecificCriteriaAlt', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificInfoAlt >-----#
    DpSpecificInfoAlt = SEQ(name=u'DpSpecificInfoAlt', mode=MODE_TYPE, param=True)
    
    #-----< ElapsedTime >-----#
    ElapsedTime = CHOICE(name=u'ElapsedTime', mode=MODE_TYPE)
    _ElapsedTime_timeGPRSIfNoTariffSwitch = INT(name=u'timeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTime_timeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch = SEQ(name=u'timeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch = INT(name=u'timeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval = INT(name=u'timeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch._cont = ASN1Dict([
        (u'timeGPRSSinceLastTariffSwitch', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch),
        (u'timeGPRSTariffSwitchInterval', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval),
        ])
    _ElapsedTime_timeGPRSIfTariffSwitch._ext = None
    ElapsedTime._cont = ASN1Dict([
        (u'timeGPRSIfNoTariffSwitch', _ElapsedTime_timeGPRSIfNoTariffSwitch),
        (u'timeGPRSIfTariffSwitch', _ElapsedTime_timeGPRSIfTariffSwitch),
        ])
    ElapsedTime._ext = None
    
    #-----< ElapsedTimeRollOver >-----#
    ElapsedTimeRollOver = CHOICE(name=u'ElapsedTimeRollOver', mode=MODE_TYPE)
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch = INT(name=u'rO-TimeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch = SEQ(name=u'rO-TimeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch = INT(name=u'rO-TimeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval = INT(name=u'rO-TimeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._cont = ASN1Dict([
        (u'rO-TimeGPRSSinceLastTariffSwitch', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch),
        (u'rO-TimeGPRSTariffSwitchInterval', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval),
        ])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._ext = None
    ElapsedTimeRollOver._cont = ASN1Dict([
        (u'rO-TimeGPRSIfNoTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch),
        (u'rO-TimeGPRSIfTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch),
        ])
    ElapsedTimeRollOver._ext = None
    
    #-----< EndUserAddress >-----#
    EndUserAddress = SEQ(name=u'EndUserAddress', mode=MODE_TYPE, param=True)
    
    #-----< ErrorTreatment >-----#
    ErrorTreatment = ENUM(name=u'ErrorTreatment', mode=MODE_TYPE)
    ErrorTreatment._cont = ASN1Dict([(u'stdErrorAndInfo', 0), (u'help', 1), (u'repeatPrompt', 2)])
    ErrorTreatment._ext = None
    
    #-----< EventSpecificInformationBCSM >-----#
    EventSpecificInformationBCSM = CHOICE(name=u'EventSpecificInformationBCSM', mode=MODE_TYPE, param=True)
    
    #-----< EventSpecificInformationSMS >-----#
    EventSpecificInformationSMS = CHOICE(name=u'EventSpecificInformationSMS', mode=MODE_TYPE)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo = SEQ(name=u'o-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause = ENUM(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MO-SMSCause')), opt=True)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo = SEQ(name=u'o-smsSubmissionSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo = SEQ(name=u't-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MT-SMSCause')), opt=True)
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo = SEQ(name=u't-smsDeliverySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._ext = []
    EventSpecificInformationSMS._cont = ASN1Dict([
        (u'o-smsFailureSpecificInfo', _EventSpecificInformationSMS_o_smsFailureSpecificInfo),
        (u'o-smsSubmissionSpecificInfo', _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo),
        (u't-smsFailureSpecificInfo', _EventSpecificInformationSMS_t_smsFailureSpecificInfo),
        (u't-smsDeliverySpecificInfo', _EventSpecificInformationSMS_t_smsDeliverySpecificInfo),
        ])
    EventSpecificInformationSMS._ext = None
    
    #-----< EventTypeBCSM >-----#
    EventTypeBCSM = ENUM(name=u'EventTypeBCSM', mode=MODE_TYPE)
    EventTypeBCSM._cont = ASN1Dict([(u'collectedInfo', 2), (u'analyzedInformation', 3), (u'routeSelectFailure', 4), (u'oCalledPartyBusy', 5), (u'oNoAnswer', 6), (u'oAnswer', 7), (u'oMidCall', 8), (u'oDisconnect', 9), (u'oAbandon', 10), (u'termAttemptAuthorized', 12), (u'tBusy', 13), (u'tNoAnswer', 14), (u'tAnswer', 15), (u'tMidCall', 16), (u'tDisconnect', 17), (u'tAbandon', 18), (u'oTermSeized', 19), (u'callAccepted', 27), (u'oChangeOfPosition', 50), (u'tChangeOfPosition', 51), (u'oServiceChange', 52), (u'tServiceChange', 53)])
    EventTypeBCSM._ext = [u'oServiceChange', u'tServiceChange']
    
    #-----< EventTypeSMS >-----#
    EventTypeSMS = ENUM(name=u'EventTypeSMS', mode=MODE_TYPE)
    EventTypeSMS._cont = ASN1Dict([(u'sms-CollectedInfo', 1), (u'o-smsFailure', 2), (u'o-smsSubmission', 3), (u'sms-DeliveryRequested', 11), (u't-smsFailure', 12), (u't-smsDelivery', 13)])
    EventTypeSMS._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name=u'Extensions', mode=MODE_TYPE, param=True)
    
    #-----< ExtensionField >-----#
    ExtensionField = SEQ(name=u'ExtensionField', mode=MODE_TYPE)
    _ExtensionField_type = CHOICE(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), [u'id']))
    __ExtensionField_type_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    ___ExtensionField_type_tab_val_ExtensionType_0 = NULL(name=u'ExtensionType', mode=MODE_TYPE)
    __ExtensionField_type_tab._val = ASN1Set(rv=[dict([(u'ExtensionType', ___ExtensionField_type_tab_val_ExtensionType_0), (u'criticality', u'ignore'), (u'id', (u'global', (0, 4, 0, 1, 2)))])], rr=[], ev=None, er=[])
    _ExtensionField_type._const_tab = __ExtensionField_type_tab
    _ExtensionField_type._const_tab_at = None
    _ExtensionField_type._const_tab_id = u'id'
    _ExtensionField_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default=u'ignore')
    _ExtensionField_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), [u'ExtensionType']))
    _ExtensionField_value._const_tab = __ExtensionField_type_tab
    _ExtensionField_value._const_tab_at = ('..', u'type')
    _ExtensionField_value._const_tab_id = u'ExtensionType'
    ExtensionField._cont = ASN1Dict([
        (u'type', _ExtensionField_type),
        (u'criticality', _ExtensionField_criticality),
        (u'value', _ExtensionField_value),
        ])
    ExtensionField._ext = []
    
    #-----< FCIBillingChargingCharacteristics >-----#
    FCIBillingChargingCharacteristics = OCT_STR(name=u'FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCIGPRSBillingChargingCharacteristics >-----#
    FCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCISMSBillingChargingCharacteristics >-----#
    FCISMSBillingChargingCharacteristics = OCT_STR(name=u'FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< ForwardServiceInteractionInd >-----#
    ForwardServiceInteractionInd = SEQ(name=u'ForwardServiceInteractionInd', mode=MODE_TYPE)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name=u'conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator = OCT_STR(name=u'callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator = OCT_STR(name=u'callingPartyRestrictionIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ForwardServiceInteractionInd._cont = ASN1Dict([
        (u'conferenceTreatmentIndicator', _ForwardServiceInteractionInd_conferenceTreatmentIndicator),
        (u'callDiversionTreatmentIndicator', _ForwardServiceInteractionInd_callDiversionTreatmentIndicator),
        (u'callingPartyRestrictionIndicator', _ForwardServiceInteractionInd_callingPartyRestrictionIndicator),
        ])
    ForwardServiceInteractionInd._ext = []
    
    #-----< GapCriteria >-----#
    GapCriteria = CHOICE(name=u'GapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< GapIndicators >-----#
    GapIndicators = SEQ(name=u'GapIndicators', mode=MODE_TYPE)
    _GapIndicators_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Duration')))
    _GapIndicators_gapInterval = INT(name=u'gapInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Interval')))
    GapIndicators._cont = ASN1Dict([
        (u'duration', _GapIndicators_duration),
        (u'gapInterval', _GapIndicators_gapInterval),
        ])
    GapIndicators._ext = []
    
    #-----< GapOnService >-----#
    GapOnService = SEQ(name=u'GapOnService', mode=MODE_TYPE)
    _GapOnService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    GapOnService._cont = ASN1Dict([
        (u'serviceKey', _GapOnService_serviceKey),
        ])
    GapOnService._ext = []
    
    #-----< GapTreatment >-----#
    GapTreatment = CHOICE(name=u'GapTreatment', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumber >-----#
    GenericNumber = OCT_STR(name=u'GenericNumber', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumbers >-----#
    GenericNumbers = SET_OF(name=u'GenericNumbers', mode=MODE_TYPE, param=True)
    
    #-----< GPRS-QoS >-----#
    GPRS_QoS = CHOICE(name=u'GPRS-QoS', mode=MODE_TYPE)
    _GPRS_QoS_short_QoS_format = OCT_STR(name=u'short-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _GPRS_QoS_long_QoS_format = OCT_STR(name=u'long-QoS-format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')))
    GPRS_QoS._cont = ASN1Dict([
        (u'short-QoS-format', _GPRS_QoS_short_QoS_format),
        (u'long-QoS-format', _GPRS_QoS_long_QoS_format),
        ])
    GPRS_QoS._ext = None
    
    #-----< GPRS-QoS-Extension >-----#
    GPRS_QoS_Extension = SEQ(name=u'GPRS-QoS-Extension', mode=MODE_TYPE)
    _GPRS_QoS_Extension_supplement_to_long_QoS_format = OCT_STR(name=u'supplement-to-long-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')))
    _GPRS_QoS_Extension_additionalSupplement = OCT_STR(name=u'additionalSupplement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    GPRS_QoS_Extension._cont = ASN1Dict([
        (u'supplement-to-long-QoS-format', _GPRS_QoS_Extension_supplement_to_long_QoS_format),
        (u'additionalSupplement', _GPRS_QoS_Extension_additionalSupplement),
        ])
    GPRS_QoS_Extension._ext = [u'additionalSupplement']
    
    #-----< GPRSCause >-----#
    GPRSCause = OCT_STR(name=u'GPRSCause', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEvent >-----#
    GPRSEvent = SEQ(name=u'GPRSEvent', mode=MODE_TYPE)
    _GPRSEvent_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _GPRSEvent_monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    GPRSEvent._cont = ASN1Dict([
        (u'gPRSEventType', _GPRSEvent_gPRSEventType),
        (u'monitorMode', _GPRSEvent_monitorMode),
        ])
    GPRSEvent._ext = None
    
    #-----< GPRSEventSpecificInformation >-----#
    GPRSEventSpecificInformation = CHOICE(name=u'GPRSEventSpecificInformation', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEventType >-----#
    GPRSEventType = ENUM(name=u'GPRSEventType', mode=MODE_TYPE)
    GPRSEventType._cont = ASN1Dict([(u'attach', 1), (u'attachChangeOfPosition', 2), (u'detached', 3), (u'pdp-ContextEstablishment', 11), (u'pdp-ContextEstablishmentAcknowledgement', 12), (u'disonnect', 13), (u'pdp-ContextChangeOfPosition', 14)])
    GPRSEventType._ext = None
    
    #-----< InbandInfo >-----#
    InbandInfo = SEQ(name=u'InbandInfo', mode=MODE_TYPE, param=True)
    
    #-----< InformationToSend >-----#
    InformationToSend = CHOICE(name=u'InformationToSend', mode=MODE_TYPE, param=True)
    
    #-----< InitiatingEntity >-----#
    InitiatingEntity = ENUM(name=u'InitiatingEntity', mode=MODE_TYPE)
    InitiatingEntity._cont = ASN1Dict([(u'mobileStation', 0), (u'sgsn', 1), (u'hlr', 2), (u'ggsn', 3)])
    InitiatingEntity._ext = None
    
    #-----< InitiatorOfServiceChange >-----#
    InitiatorOfServiceChange = ENUM(name=u'InitiatorOfServiceChange', mode=MODE_TYPE)
    InitiatorOfServiceChange._cont = ASN1Dict([(u'a-side', 0), (u'b-side', 1)])
    InitiatorOfServiceChange._ext = None
    
    #-----< InvokeID >-----#
    InvokeID = INT(name=u'InvokeID', mode=MODE_TYPE)
    InvokeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< IPRoutingAddress >-----#
    IPRoutingAddress = OCT_STR(name=u'IPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), param=True)
    
    #-----< IPSSPCapabilities >-----#
    IPSSPCapabilities = OCT_STR(name=u'IPSSPCapabilities', mode=MODE_TYPE, param=True)
    
    #-----< LegOrCallSegment >-----#
    LegOrCallSegment = CHOICE(name=u'LegOrCallSegment', mode=MODE_TYPE, param=True)
    
    #-----< LegType >-----#
    LegType = OCT_STR(name=u'LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< leg1 >-----#
    leg1 = OCT_STR(name=u'leg1', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg1._val = b'\x01'
    
    #-----< leg2 >-----#
    leg2 = OCT_STR(name=u'leg2', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg2._val = b'\x02'
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name=u'LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = OCT_STR(name=u'cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name=u'selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        (u'cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        (u'routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        (u'geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        (u'sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        (u'selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        (u'extensionContainer', _LocationInformationGPRS_extensionContainer),
        (u'sai-Present', _LocationInformationGPRS_sai_Present),
        (u'userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = [u'sai-Present', u'userCSGInformation']
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name=u'LocationNumber', mode=MODE_TYPE, param=True)
    
    #-----< LowLayerCompatibility >-----#
    LowLayerCompatibility = OCT_STR(name=u'LowLayerCompatibility', mode=MODE_TYPE, param=True)
    
    #-----< MessageID >-----#
    MessageID = CHOICE(name=u'MessageID', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriteriaList >-----#
    MetDPCriteriaList = SEQ_OF(name=u'MetDPCriteriaList', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriterion >-----#
    MetDPCriterion = CHOICE(name=u'MetDPCriterion', mode=MODE_TYPE)
    _MetDPCriterion_enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _MetDPCriterion_metDPCriterionAlt._cont = ASN1Dict([
        ])
    _MetDPCriterion_metDPCriterionAlt._ext = []
    MetDPCriterion._cont = ASN1Dict([
        (u'enteringCellGlobalId', _MetDPCriterion_enteringCellGlobalId),
        (u'leavingCellGlobalId', _MetDPCriterion_leavingCellGlobalId),
        (u'enteringServiceAreaId', _MetDPCriterion_enteringServiceAreaId),
        (u'leavingServiceAreaId', _MetDPCriterion_leavingServiceAreaId),
        (u'enteringLocationAreaId', _MetDPCriterion_enteringLocationAreaId),
        (u'leavingLocationAreaId', _MetDPCriterion_leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _MetDPCriterion_inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _MetDPCriterion_inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _MetDPCriterion_inter_PLMNHandOver),
        (u'inter-MSCHandOver', _MetDPCriterion_inter_MSCHandOver),
        (u'metDPCriterionAlt', _MetDPCriterion_metDPCriterionAlt),
        ])
    MetDPCriterion._ext = None
    
    #-----< MetDPCriterionAlt >-----#
    MetDPCriterionAlt = SEQ(name=u'MetDPCriterionAlt', mode=MODE_TYPE)
    MetDPCriterionAlt._cont = ASN1Dict([
        ])
    MetDPCriterionAlt._ext = []
    
    #-----< MidCallControlInfo >-----#
    MidCallControlInfo = SEQ(name=u'MidCallControlInfo', mode=MODE_TYPE)
    _MidCallControlInfo_minimumNumberOfDigits = INT(name=u'minimumNumberOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _MidCallControlInfo_minimumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_maximumNumberOfDigits = INT(name=u'maximumNumberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _MidCallControlInfo_maximumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_endOfReplyDigit = OCT_STR(name=u'endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_cancelDigit = OCT_STR(name=u'cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_startDigit = OCT_STR(name=u'startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=10)
    _MidCallControlInfo_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    MidCallControlInfo._cont = ASN1Dict([
        (u'minimumNumberOfDigits', _MidCallControlInfo_minimumNumberOfDigits),
        (u'maximumNumberOfDigits', _MidCallControlInfo_maximumNumberOfDigits),
        (u'endOfReplyDigit', _MidCallControlInfo_endOfReplyDigit),
        (u'cancelDigit', _MidCallControlInfo_cancelDigit),
        (u'startDigit', _MidCallControlInfo_startDigit),
        (u'interDigitTimeout', _MidCallControlInfo_interDigitTimeout),
        ])
    MidCallControlInfo._ext = []
    
    #-----< MonitorMode >-----#
    MonitorMode = ENUM(name=u'MonitorMode', mode=MODE_TYPE)
    MonitorMode._cont = ASN1Dict([(u'interrupted', 0), (u'notifyAndContinue', 1), (u'transparent', 2)])
    MonitorMode._ext = None
    
    #-----< MO-SMSCause >-----#
    MO_SMSCause = ENUM(name=u'MO-SMSCause', mode=MODE_TYPE)
    MO_SMSCause._cont = ASN1Dict([(u'systemFailure', 0), (u'unexpectedDataValue', 1), (u'facilityNotSupported', 2), (u'sM-DeliveryFailure', 3), (u'releaseFromRadioInterface', 4)])
    MO_SMSCause._ext = None
    
    #-----< MT-SMSCause >-----#
    MT_SMSCause = OCT_STR(name=u'MT-SMSCause', mode=MODE_TYPE)
    MT_SMSCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NAOliInfo >-----#
    NAOliInfo = OCT_STR(name=u'NAOliInfo', mode=MODE_TYPE)
    NAOliInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NatureOfServiceChange >-----#
    NatureOfServiceChange = ENUM(name=u'NatureOfServiceChange', mode=MODE_TYPE)
    NatureOfServiceChange._cont = ASN1Dict([(u'userInitiated', 0), (u'networkInitiated', 1)])
    NatureOfServiceChange._ext = None
    
    #-----< NumberOfDigits >-----#
    NumberOfDigits = INT(name=u'NumberOfDigits', mode=MODE_TYPE)
    NumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< OCSIApplicable >-----#
    OCSIApplicable = NULL(name=u'OCSIApplicable', mode=MODE_TYPE)
    
    #-----< OriginalCalledPartyID >-----#
    OriginalCalledPartyID = OCT_STR(name=u'OriginalCalledPartyID', mode=MODE_TYPE, param=True)
    
    #-----< PDPID >-----#
    PDPID = OCT_STR(name=u'PDPID', mode=MODE_TYPE)
    PDPID._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PDPInitiationType >-----#
    PDPInitiationType = ENUM(name=u'PDPInitiationType', mode=MODE_TYPE)
    PDPInitiationType._cont = ASN1Dict([(u'mSInitiated', 0), (u'networkInitiated', 1)])
    PDPInitiationType._ext = None
    
    #-----< QualityOfService >-----#
    QualityOfService = SEQ(name=u'QualityOfService', mode=MODE_TYPE)
    _QualityOfService_requested_QoS = CHOICE(name=u'requested-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_subscribed_QoS = CHOICE(name=u'subscribed-QoS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_negotiated_QoS = CHOICE(name=u'negotiated-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_requested_QoS_Extension = SEQ(name=u'requested-QoS-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_subscribed_QoS_Extension = SEQ(name=u'subscribed-QoS-Extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_negotiated_QoS_Extension = SEQ(name=u'negotiated-QoS-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    QualityOfService._cont = ASN1Dict([
        (u'requested-QoS', _QualityOfService_requested_QoS),
        (u'subscribed-QoS', _QualityOfService_subscribed_QoS),
        (u'negotiated-QoS', _QualityOfService_negotiated_QoS),
        (u'requested-QoS-Extension', _QualityOfService_requested_QoS_Extension),
        (u'subscribed-QoS-Extension', _QualityOfService_subscribed_QoS_Extension),
        (u'negotiated-QoS-Extension', _QualityOfService_negotiated_QoS_Extension),
        ])
    QualityOfService._ext = [u'requested-QoS-Extension', u'subscribed-QoS-Extension', u'negotiated-QoS-Extension']
    
    #-----< ReceivingSideID >-----#
    ReceivingSideID = CHOICE(name=u'ReceivingSideID', mode=MODE_TYPE)
    _ReceivingSideID_receivingSideID = OCT_STR(name=u'receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    ReceivingSideID._cont = ASN1Dict([
        (u'receivingSideID', _ReceivingSideID_receivingSideID),
        ])
    ReceivingSideID._ext = None
    
    #-----< RedirectingPartyID >-----#
    RedirectingPartyID = OCT_STR(name=u'RedirectingPartyID', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationList >-----#
    RequestedInformationList = SEQ_OF(name=u'RequestedInformationList', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationTypeList >-----#
    RequestedInformationTypeList = SEQ_OF(name=u'RequestedInformationTypeList', mode=MODE_TYPE)
    _RequestedInformationTypeList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    RequestedInformationTypeList._cont = _RequestedInformationTypeList__item_
    RequestedInformationTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< RequestedInformation >-----#
    RequestedInformation = SEQ(name=u'RequestedInformation', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationType >-----#
    RequestedInformationType = ENUM(name=u'RequestedInformationType', mode=MODE_TYPE)
    RequestedInformationType._cont = ASN1Dict([(u'callAttemptElapsedTime', 0), (u'callStopTime', 1), (u'callConnectedElapsedTime', 2), (u'releaseCause', 30)])
    RequestedInformationType._ext = None
    
    #-----< RequestedInformationValue >-----#
    RequestedInformationValue = CHOICE(name=u'RequestedInformationValue', mode=MODE_TYPE, param=True)
    
    #-----< RPCause >-----#
    RPCause = OCT_STR(name=u'RPCause', mode=MODE_TYPE)
    RPCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ScfID >-----#
    ScfID = OCT_STR(name=u'ScfID', mode=MODE_TYPE, param=True)
    
    #-----< SCIBillingChargingCharacteristics >-----#
    SCIBillingChargingCharacteristics = OCT_STR(name=u'SCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SCIGPRSBillingChargingCharacteristics >-----#
    SCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SendingSideID >-----#
    SendingSideID = CHOICE(name=u'SendingSideID', mode=MODE_TYPE)
    _SendingSideID_sendingSideID = OCT_STR(name=u'sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    SendingSideID._cont = ASN1Dict([
        (u'sendingSideID', _SendingSideID_sendingSideID),
        ])
    SendingSideID._ext = None
    
    #-----< ServiceInteractionIndicatorsTwo >-----#
    ServiceInteractionIndicatorsTwo = SEQ(name=u'ServiceInteractionIndicatorsTwo', mode=MODE_TYPE)
    _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd = SEQ(name=u'forwardServiceInteractionInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ForwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd = SEQ(name=u'backwardServiceInteractionInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BackwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd = ENUM(name=u'bothwayThroughConnectionInd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'BothwayThroughConnectionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd = ENUM(name=u'connectedNumberTreatmentInd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ConnectedNumberTreatmentInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_nonCUGCall = NULL(name=u'nonCUGCall', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator = OCT_STR(name=u'holdTreatmentIndicator', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator = OCT_STR(name=u'cwTreatmentIndicator', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator = OCT_STR(name=u'ectTreatmentIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ServiceInteractionIndicatorsTwo._cont = ASN1Dict([
        (u'forwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd),
        (u'backwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd),
        (u'bothwayThroughConnectionInd', _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd),
        (u'connectedNumberTreatmentInd', _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd),
        (u'nonCUGCall', _ServiceInteractionIndicatorsTwo_nonCUGCall),
        (u'holdTreatmentIndicator', _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator),
        (u'cwTreatmentIndicator', _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator),
        (u'ectTreatmentIndicator', _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator),
        ])
    ServiceInteractionIndicatorsTwo._ext = []
    
    #-----< SGSNCapabilities >-----#
    SGSNCapabilities = OCT_STR(name=u'SGSNCapabilities', mode=MODE_TYPE)
    SGSNCapabilities._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SMS-AddressString >-----#
    SMS_AddressString = OCT_STR(name=u'SMS-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SMS_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< maxSMS-AddressStringLength >-----#
    maxSMS_AddressStringLength = INT(name=u'maxSMS-AddressStringLength', mode=MODE_VALUE)
    maxSMS_AddressStringLength._val = 11
    
    #-----< SMSEvent >-----#
    SMSEvent = SEQ(name=u'SMSEvent', mode=MODE_TYPE)
    _SMSEvent_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _SMSEvent_monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    SMSEvent._cont = ASN1Dict([
        (u'eventTypeSMS', _SMSEvent_eventTypeSMS),
        (u'monitorMode', _SMSEvent_monitorMode),
        ])
    SMSEvent._ext = None
    
    #-----< TariffSwitchInterval >-----#
    TariffSwitchInterval = INT(name=u'TariffSwitchInterval', mode=MODE_TYPE)
    TariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    
    #-----< TimeAndTimezone >-----#
    TimeAndTimezone = OCT_STR(name=u'TimeAndTimezone', mode=MODE_TYPE, param=True)
    
    #-----< TimeIfNoTariffSwitch >-----#
    TimeIfNoTariffSwitch = INT(name=u'TimeIfNoTariffSwitch', mode=MODE_TYPE)
    TimeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    
    #-----< TimeIfTariffSwitch >-----#
    TimeIfTariffSwitch = SEQ(name=u'TimeIfTariffSwitch', mode=MODE_TYPE)
    _TimeIfTariffSwitch_timeSinceTariffSwitch = INT(name=u'timeSinceTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeIfTariffSwitch_timeSinceTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    _TimeIfTariffSwitch_tariffSwitchInterval = INT(name=u'tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TimeIfTariffSwitch_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=864000)], ev=None, er=[])
    TimeIfTariffSwitch._cont = ASN1Dict([
        (u'timeSinceTariffSwitch', _TimeIfTariffSwitch_timeSinceTariffSwitch),
        (u'tariffSwitchInterval', _TimeIfTariffSwitch_tariffSwitchInterval),
        ])
    TimeIfTariffSwitch._ext = None
    
    #-----< TimeInformation >-----#
    TimeInformation = CHOICE(name=u'TimeInformation', mode=MODE_TYPE)
    _TimeInformation_timeIfNoTariffSwitch = INT(name=u'timeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfNoTariffSwitch')))
    _TimeInformation_timeIfTariffSwitch = SEQ(name=u'timeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfTariffSwitch')))
    TimeInformation._cont = ASN1Dict([
        (u'timeIfNoTariffSwitch', _TimeInformation_timeIfNoTariffSwitch),
        (u'timeIfTariffSwitch', _TimeInformation_timeIfTariffSwitch),
        ])
    TimeInformation._ext = None
    
    #-----< TimerID >-----#
    TimerID = ENUM(name=u'TimerID', mode=MODE_TYPE)
    TimerID._cont = ASN1Dict([(u'tssf', 0)])
    TimerID._ext = None
    
    #-----< TimerValue >-----#
    TimerValue = INT(name=u'TimerValue', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< Tone >-----#
    Tone = SEQ(name=u'Tone', mode=MODE_TYPE)
    _Tone_toneID = INT(name=u'toneID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _Tone_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    Tone._cont = ASN1Dict([
        (u'toneID', _Tone_toneID),
        (u'duration', _Tone_duration),
        ])
    Tone._ext = []
    
    #-----< TPDataCodingScheme >-----#
    TPDataCodingScheme = OCT_STR(name=u'TPDataCodingScheme', mode=MODE_TYPE)
    TPDataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPProtocolIdentifier >-----#
    TPProtocolIdentifier = OCT_STR(name=u'TPProtocolIdentifier', mode=MODE_TYPE)
    TPProtocolIdentifier._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPShortMessageSpecificInfo >-----#
    TPShortMessageSpecificInfo = OCT_STR(name=u'TPShortMessageSpecificInfo', mode=MODE_TYPE)
    TPShortMessageSpecificInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPValidityPeriod >-----#
    TPValidityPeriod = OCT_STR(name=u'TPValidityPeriod', mode=MODE_TYPE)
    TPValidityPeriod._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TransferredVolume >-----#
    TransferredVolume = CHOICE(name=u'TransferredVolume', mode=MODE_TYPE)
    _TransferredVolume_volumeIfNoTariffSwitch = INT(name=u'volumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolume_volumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch = SEQ(name=u'volumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch = INT(name=u'volumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval = INT(name=u'volumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch._cont = ASN1Dict([
        (u'volumeSinceLastTariffSwitch', __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch),
        (u'volumeTariffSwitchInterval', __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval),
        ])
    _TransferredVolume_volumeIfTariffSwitch._ext = None
    TransferredVolume._cont = ASN1Dict([
        (u'volumeIfNoTariffSwitch', _TransferredVolume_volumeIfNoTariffSwitch),
        (u'volumeIfTariffSwitch', _TransferredVolume_volumeIfTariffSwitch),
        ])
    TransferredVolume._ext = None
    
    #-----< TransferredVolumeRollOver >-----#
    TransferredVolumeRollOver = CHOICE(name=u'TransferredVolumeRollOver', mode=MODE_TYPE)
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch = INT(name=u'rO-VolumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch = SEQ(name=u'rO-VolumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch = INT(name=u'rO-VolumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval = INT(name=u'rO-VolumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._cont = ASN1Dict([
        (u'rO-VolumeSinceLastTariffSwitch', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch),
        (u'rO-VolumeTariffSwitchInterval', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval),
        ])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._ext = None
    TransferredVolumeRollOver._cont = ASN1Dict([
        (u'rO-VolumeIfNoTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch),
        (u'rO-VolumeIfTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch),
        ])
    TransferredVolumeRollOver._ext = None
    
    #-----< UnavailableNetworkResource >-----#
    UnavailableNetworkResource = ENUM(name=u'UnavailableNetworkResource', mode=MODE_TYPE)
    UnavailableNetworkResource._cont = ASN1Dict([(u'unavailableResources', 0), (u'componentFailure', 1), (u'basicCallProcessingException', 2), (u'resourceStatusFailure', 3), (u'endUserFailure', 4)])
    UnavailableNetworkResource._ext = None
    
    #-----< VariablePart >-----#
    VariablePart = CHOICE(name=u'VariablePart', mode=MODE_TYPE, param=True)
    
    #-----< numOfInfoItems >-----#
    numOfInfoItems = INT(name=u'numOfInfoItems', mode=MODE_VALUE)
    numOfInfoItems._val = 4
    
    _all_ = [
        AlertingPattern,
        _AOCBeforeAnswer_aOCInitial,
        _AOCBeforeAnswer_aOCSubsequent,
        AOCBeforeAnswer,
        _AOCGPRS_aOCInitial,
        _AOCGPRS_aOCSubsequent,
        AOCGPRS,
        _AOCSubsequent_cAI_GSM0224,
        _AOCSubsequent_tariffSwitchInterval,
        AOCSubsequent,
        AppendFreeFormatData,
        ApplicationTimer,
        _AudibleIndicator_tone,
        _AudibleIndicator_burstList,
        AudibleIndicator,
        _BackwardServiceInteractionInd_conferenceTreatmentIndicator,
        _BackwardServiceInteractionInd_callCompletionTreatmentIndicator,
        BackwardServiceInteractionInd,
        _Burst_numberOfBursts,
        _Burst_burstInterval,
        _Burst_numberOfTonesInBurst,
        _Burst_toneDuration,
        _Burst_toneInterval,
        Burst,
        _BurstList_warningPeriod,
        _BurstList_bursts,
        BurstList,
        _CAI_GSM0224_e1,
        _CAI_GSM0224_e2,
        _CAI_GSM0224_e3,
        _CAI_GSM0224_e4,
        _CAI_GSM0224_e5,
        _CAI_GSM0224_e6,
        _CAI_GSM0224_e7,
        CAI_GSM0224,
        _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOC_extension,
        CAMEL_SCIBillingChargingCharacteristics,
        CAMEL_SCIBillingChargingCharacteristicsAlt,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID,
        CAMEL_SCIGPRSBillingChargingCharacteristics,
        CGEncountered,
        _ChangeOfLocation_cellGlobalId,
        _ChangeOfLocation_serviceAreaId,
        _ChangeOfLocation_locationAreaId,
        _ChangeOfLocation_inter_SystemHandOver,
        _ChangeOfLocation_inter_PLMNHandOver,
        _ChangeOfLocation_inter_MSCHandOver,
        _ChangeOfLocation_changeOfLocationAlt,
        ChangeOfLocation,
        ChangeOfLocationAlt,
        ChargeIndicator,
        _ChargingCharacteristics_maxTransferredVolume,
        _ChargingCharacteristics_maxElapsedTime,
        ChargingCharacteristics,
        _ChargingResult_transferredVolume,
        _ChargingResult_elapsedTime,
        ChargingResult,
        _ChargingRollOver_transferredVolumeRollOver,
        _ChargingRollOver_elapsedTimeRollOver,
        ChargingRollOver,
        _CollectedDigits_minimumNbOfDigits,
        _CollectedDigits_maximumNbOfDigits,
        _CollectedDigits_endOfReplyDigit,
        _CollectedDigits_cancelDigit,
        _CollectedDigits_startDigit,
        _CollectedDigits_firstDigitTimeOut,
        _CollectedDigits_interDigitTimeOut,
        _CollectedDigits_errorTreatment,
        _CollectedDigits_interruptableAnnInd,
        _CollectedDigits_voiceInformation,
        _CollectedDigits_voiceBack,
        CollectedDigits,
        _CollectedInfo_collectedDigits,
        CollectedInfo,
        ConnectedNumberTreatmentInd,
        ControlType,
        DateAndTime,
        _ElapsedTime_timeGPRSIfNoTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval,
        _ElapsedTime_timeGPRSIfTariffSwitch,
        ElapsedTime,
        _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval,
        _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch,
        ElapsedTimeRollOver,
        ErrorTreatment,
        __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_o_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo,
        __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_t_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_t_smsDeliverySpecificInfo,
        EventSpecificInformationSMS,
        EventTypeBCSM,
        EventTypeSMS,
        __ExtensionField_type_tab,
        ___ExtensionField_type_tab_val_ExtensionType_0,
        _ExtensionField_type,
        _ExtensionField_criticality,
        _ExtensionField_value,
        ExtensionField,
        _ForwardServiceInteractionInd_conferenceTreatmentIndicator,
        _ForwardServiceInteractionInd_callDiversionTreatmentIndicator,
        _ForwardServiceInteractionInd_callingPartyRestrictionIndicator,
        ForwardServiceInteractionInd,
        _GapIndicators_duration,
        _GapIndicators_gapInterval,
        GapIndicators,
        _GapOnService_serviceKey,
        GapOnService,
        _GPRS_QoS_short_QoS_format,
        _GPRS_QoS_long_QoS_format,
        GPRS_QoS,
        _GPRS_QoS_Extension_supplement_to_long_QoS_format,
        _GPRS_QoS_Extension_additionalSupplement,
        GPRS_QoS_Extension,
        _GPRSEvent_gPRSEventType,
        _GPRSEvent_monitorMode,
        GPRSEvent,
        GPRSEventType,
        InitiatingEntity,
        InitiatorOfServiceChange,
        InvokeID,
        LegType,
        leg1,
        leg2,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _MetDPCriterion_enteringCellGlobalId,
        _MetDPCriterion_leavingCellGlobalId,
        _MetDPCriterion_enteringServiceAreaId,
        _MetDPCriterion_leavingServiceAreaId,
        _MetDPCriterion_enteringLocationAreaId,
        _MetDPCriterion_leavingLocationAreaId,
        _MetDPCriterion_inter_SystemHandOverToUMTS,
        _MetDPCriterion_inter_SystemHandOverToGSM,
        _MetDPCriterion_inter_PLMNHandOver,
        _MetDPCriterion_inter_MSCHandOver,
        _MetDPCriterion_metDPCriterionAlt,
        MetDPCriterion,
        MetDPCriterionAlt,
        _MidCallControlInfo_minimumNumberOfDigits,
        _MidCallControlInfo_maximumNumberOfDigits,
        _MidCallControlInfo_endOfReplyDigit,
        _MidCallControlInfo_cancelDigit,
        _MidCallControlInfo_startDigit,
        _MidCallControlInfo_interDigitTimeout,
        MidCallControlInfo,
        MonitorMode,
        MO_SMSCause,
        MT_SMSCause,
        NAOliInfo,
        NatureOfServiceChange,
        NumberOfDigits,
        OCSIApplicable,
        PDPID,
        PDPInitiationType,
        _QualityOfService_requested_QoS,
        _QualityOfService_subscribed_QoS,
        _QualityOfService_negotiated_QoS,
        _QualityOfService_requested_QoS_Extension,
        _QualityOfService_subscribed_QoS_Extension,
        _QualityOfService_negotiated_QoS_Extension,
        QualityOfService,
        _ReceivingSideID_receivingSideID,
        ReceivingSideID,
        _RequestedInformationTypeList__item_,
        RequestedInformationTypeList,
        RequestedInformationType,
        RPCause,
        _SendingSideID_sendingSideID,
        SendingSideID,
        _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd,
        _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd,
        _ServiceInteractionIndicatorsTwo_nonCUGCall,
        _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator,
        ServiceInteractionIndicatorsTwo,
        SGSNCapabilities,
        SMS_AddressString,
        maxSMS_AddressStringLength,
        _SMSEvent_eventTypeSMS,
        _SMSEvent_monitorMode,
        SMSEvent,
        TariffSwitchInterval,
        TimeIfNoTariffSwitch,
        _TimeIfTariffSwitch_timeSinceTariffSwitch,
        _TimeIfTariffSwitch_tariffSwitchInterval,
        TimeIfTariffSwitch,
        _TimeInformation_timeIfNoTariffSwitch,
        _TimeInformation_timeIfTariffSwitch,
        TimeInformation,
        TimerID,
        TimerValue,
        _Tone_toneID,
        _Tone_duration,
        Tone,
        TPDataCodingScheme,
        TPProtocolIdentifier,
        TPShortMessageSpecificInfo,
        TPValidityPeriod,
        _TransferredVolume_volumeIfNoTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval,
        _TransferredVolume_volumeIfTariffSwitch,
        TransferredVolume,
        _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval,
        _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch,
        TransferredVolumeRollOver,
        UnavailableNetworkResource,
        numOfInfoItems,
    ]

class CAP_errorcodes:

    _name_  = u'CAP-errorcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 57, 7]
    
    _obj_ = [
        u'errcode-canceled',
        u'errcode-cancelFailed',
        u'errcode-eTCFailed',
        u'errcode-improperCallerResponse',
        u'errcode-missingCustomerRecord',
        u'errcode-missingParameter',
        u'errcode-parameterOutOfRange',
        u'errcode-requestedInfoError',
        u'errcode-systemFailure',
        u'errcode-taskRefused',
        u'errcode-unavailableResource',
        u'errcode-unexpectedComponentSequence',
        u'errcode-unexpectedDataValue',
        u'errcode-unexpectedParameter',
        u'errcode-unknownLegID',
        u'errcode-unknownPDPID',
        u'errcode-unknownCSID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'errcode-canceled',
        u'errcode-cancelFailed',
        u'errcode-eTCFailed',
        u'errcode-improperCallerResponse',
        u'errcode-missingCustomerRecord',
        u'errcode-missingParameter',
        u'errcode-parameterOutOfRange',
        u'errcode-requestedInfoError',
        u'errcode-systemFailure',
        u'errcode-taskRefused',
        u'errcode-unavailableResource',
        u'errcode-unexpectedComponentSequence',
        u'errcode-unexpectedDataValue',
        u'errcode-unexpectedParameter',
        u'errcode-unknownLegID',
        u'errcode-unknownPDPID',
        u'errcode-unknownCSID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< errcode-canceled >-----#
    errcode_canceled = CHOICE(name=u'errcode-canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_canceled._val = (u'local', 0)
    
    #-----< errcode-cancelFailed >-----#
    errcode_cancelFailed = CHOICE(name=u'errcode-cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_cancelFailed._val = (u'local', 1)
    
    #-----< errcode-eTCFailed >-----#
    errcode_eTCFailed = CHOICE(name=u'errcode-eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_eTCFailed._val = (u'local', 3)
    
    #-----< errcode-improperCallerResponse >-----#
    errcode_improperCallerResponse = CHOICE(name=u'errcode-improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_improperCallerResponse._val = (u'local', 4)
    
    #-----< errcode-missingCustomerRecord >-----#
    errcode_missingCustomerRecord = CHOICE(name=u'errcode-missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingCustomerRecord._val = (u'local', 6)
    
    #-----< errcode-missingParameter >-----#
    errcode_missingParameter = CHOICE(name=u'errcode-missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingParameter._val = (u'local', 7)
    
    #-----< errcode-parameterOutOfRange >-----#
    errcode_parameterOutOfRange = CHOICE(name=u'errcode-parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_parameterOutOfRange._val = (u'local', 8)
    
    #-----< errcode-requestedInfoError >-----#
    errcode_requestedInfoError = CHOICE(name=u'errcode-requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_requestedInfoError._val = (u'local', 10)
    
    #-----< errcode-systemFailure >-----#
    errcode_systemFailure = CHOICE(name=u'errcode-systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_systemFailure._val = (u'local', 11)
    
    #-----< errcode-taskRefused >-----#
    errcode_taskRefused = CHOICE(name=u'errcode-taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_taskRefused._val = (u'local', 12)
    
    #-----< errcode-unavailableResource >-----#
    errcode_unavailableResource = CHOICE(name=u'errcode-unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unavailableResource._val = (u'local', 13)
    
    #-----< errcode-unexpectedComponentSequence >-----#
    errcode_unexpectedComponentSequence = CHOICE(name=u'errcode-unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedComponentSequence._val = (u'local', 14)
    
    #-----< errcode-unexpectedDataValue >-----#
    errcode_unexpectedDataValue = CHOICE(name=u'errcode-unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedDataValue._val = (u'local', 15)
    
    #-----< errcode-unexpectedParameter >-----#
    errcode_unexpectedParameter = CHOICE(name=u'errcode-unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedParameter._val = (u'local', 16)
    
    #-----< errcode-unknownLegID >-----#
    errcode_unknownLegID = CHOICE(name=u'errcode-unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownLegID._val = (u'local', 17)
    
    #-----< errcode-unknownPDPID >-----#
    errcode_unknownPDPID = CHOICE(name=u'errcode-unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownPDPID._val = (u'local', 50)
    
    #-----< errcode-unknownCSID >-----#
    errcode_unknownCSID = CHOICE(name=u'errcode-unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownCSID._val = (u'local', 51)
    
    _all_ = [
        errcode_canceled,
        errcode_cancelFailed,
        errcode_eTCFailed,
        errcode_improperCallerResponse,
        errcode_missingCustomerRecord,
        errcode_missingParameter,
        errcode_parameterOutOfRange,
        errcode_requestedInfoError,
        errcode_systemFailure,
        errcode_taskRefused,
        errcode_unavailableResource,
        errcode_unexpectedComponentSequence,
        errcode_unexpectedDataValue,
        errcode_unexpectedParameter,
        errcode_unknownLegID,
        errcode_unknownPDPID,
        errcode_unknownCSID,
    ]

class CAP_errortypes:

    _name_  = u'CAP-errortypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 51, 7]
    
    _obj_ = [
        u'canceled',
        u'cancelFailed',
        u'eTCFailed',
        u'improperCallerResponse',
        u'missingCustomerRecord',
        u'missingParameter',
        u'parameterOutOfRange',
        u'requestedInfoError',
        u'systemFailure',
        u'taskRefused',
        u'unavailableResource',
        u'unexpectedComponentSequence',
        u'unexpectedDataValue',
        u'unexpectedParameter',
        u'unknownLegID',
        u'unknownCSID',
        u'unknownPDPID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'canceled',
        u'cancelFailed',
        u'eTCFailed',
        u'improperCallerResponse',
        u'missingCustomerRecord',
        u'missingParameter',
        u'parameterOutOfRange',
        u'requestedInfoError',
        u'systemFailure',
        u'taskRefused',
        u'unavailableResource',
        u'unexpectedComponentSequence',
        u'unexpectedDataValue',
        u'unexpectedParameter',
        u'unknownLegID',
        u'unknownCSID',
        u'unknownPDPID',
        ]
    _class_ = [
        u'canceled',
        u'cancelFailed',
        u'eTCFailed',
        u'improperCallerResponse',
        u'missingCustomerRecord',
        u'missingParameter',
        u'parameterOutOfRange',
        u'requestedInfoError',
        u'systemFailure',
        u'taskRefused',
        u'unavailableResource',
        u'unexpectedComponentSequence',
        u'unexpectedDataValue',
        u'unexpectedParameter',
        u'unknownLegID',
        u'unknownCSID',
        u'unknownPDPID',
        ]
    _param_ = [
        ]
    
    #-----< canceled >-----#
    canceled = CLASS(name=u'canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    canceled._val = dict([(u'errorCode', (u'local', 0))])
    
    #-----< cancelFailed >-----#
    cancelFailed = CLASS(name=u'cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _cancelFailed_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    __cancelFailed_val_ParameterType_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __cancelFailed_val_ParameterType_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    __cancelFailed_val_ParameterType_problem._ext = None
    __cancelFailed_val_ParameterType_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _cancelFailed_val_ParameterType._cont = ASN1Dict([
        (u'problem', __cancelFailed_val_ParameterType_problem),
        (u'operation', __cancelFailed_val_ParameterType_operation),
        ])
    _cancelFailed_val_ParameterType._ext = []
    cancelFailed._val = dict([(u'ParameterType', _cancelFailed_val_ParameterType), (u'errorCode', (u'local', 1))])
    
    #-----< eTCFailed >-----#
    eTCFailed = CLASS(name=u'eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    eTCFailed._val = dict([(u'errorCode', (u'local', 3))])
    
    #-----< improperCallerResponse >-----#
    improperCallerResponse = CLASS(name=u'improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    improperCallerResponse._val = dict([(u'errorCode', (u'local', 4))])
    
    #-----< missingCustomerRecord >-----#
    missingCustomerRecord = CLASS(name=u'missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingCustomerRecord._val = dict([(u'errorCode', (u'local', 6))])
    
    #-----< missingParameter >-----#
    missingParameter = CLASS(name=u'missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingParameter._val = dict([(u'errorCode', (u'local', 7))])
    
    #-----< parameterOutOfRange >-----#
    parameterOutOfRange = CLASS(name=u'parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    parameterOutOfRange._val = dict([(u'errorCode', (u'local', 8))])
    
    #-----< requestedInfoError >-----#
    requestedInfoError = CLASS(name=u'requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _requestedInfoError_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _requestedInfoError_val_ParameterType._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    _requestedInfoError_val_ParameterType._ext = None
    requestedInfoError._val = dict([(u'ParameterType', _requestedInfoError_val_ParameterType), (u'errorCode', (u'local', 10))])
    
    #-----< systemFailure >-----#
    systemFailure = CLASS(name=u'systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _systemFailure_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    systemFailure._val = dict([(u'ParameterType', _systemFailure_val_ParameterType), (u'errorCode', (u'local', 11))])
    
    #-----< taskRefused >-----#
    taskRefused = CLASS(name=u'taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _taskRefused_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _taskRefused_val_ParameterType._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _taskRefused_val_ParameterType._ext = None
    taskRefused._val = dict([(u'ParameterType', _taskRefused_val_ParameterType), (u'errorCode', (u'local', 12))])
    
    #-----< unavailableResource >-----#
    unavailableResource = CLASS(name=u'unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unavailableResource._val = dict([(u'errorCode', (u'local', 13))])
    
    #-----< unexpectedComponentSequence >-----#
    unexpectedComponentSequence = CLASS(name=u'unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedComponentSequence._val = dict([(u'errorCode', (u'local', 14))])
    
    #-----< unexpectedDataValue >-----#
    unexpectedDataValue = CLASS(name=u'unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedDataValue._val = dict([(u'errorCode', (u'local', 15))])
    
    #-----< unexpectedParameter >-----#
    unexpectedParameter = CLASS(name=u'unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedParameter._val = dict([(u'errorCode', (u'local', 16))])
    
    #-----< unknownLegID >-----#
    unknownLegID = CLASS(name=u'unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownLegID._val = dict([(u'errorCode', (u'local', 17))])
    
    #-----< unknownCSID >-----#
    unknownCSID = CLASS(name=u'unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownCSID._val = dict([(u'errorCode', (u'local', 51))])
    
    #-----< unknownPDPID >-----#
    unknownPDPID = CLASS(name=u'unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownPDPID._val = dict([(u'errorCode', (u'local', 50))])
    
    _all_ = [
        canceled,
        cancelFailed,
        __cancelFailed_val_ParameterType_problem,
        __cancelFailed_val_ParameterType_operation,
        _cancelFailed_val_ParameterType,
        eTCFailed,
        improperCallerResponse,
        missingCustomerRecord,
        missingParameter,
        parameterOutOfRange,
        requestedInfoError,
        _requestedInfoError_val_ParameterType,
        systemFailure,
        _systemFailure_val_ParameterType,
        taskRefused,
        _taskRefused_val_ParameterType,
        unavailableResource,
        unexpectedComponentSequence,
        unexpectedDataValue,
        unexpectedParameter,
        unknownLegID,
        unknownCSID,
        unknownPDPID,
    ]

class CAP_GPRS_ReferenceNumber:

    _name_  = u'CAP-GPRS-ReferenceNumber'
    _oid_   = [0, 4, 0, 0, 1, 3, 111, 7]
    
    _obj_ = [
        u'id-CAP-GPRS-ReferenceNumber',
        u'cAP-GPRS-ReferenceNumber-Abstract-Syntax',
        u'CAP-GPRS-ReferenceNumber',
        ]
    _type_ = [
        u'CAP-GPRS-ReferenceNumber',
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-CAP-GPRS-ReferenceNumber',
        u'cAP-GPRS-ReferenceNumber-Abstract-Syntax',
        ]
    _class_ = [
        u'cAP-GPRS-ReferenceNumber-Abstract-Syntax',
        ]
    _param_ = [
        ]
    
    #-----< id-CAP-GPRS-ReferenceNumber >-----#
    id_CAP_GPRS_ReferenceNumber = OID(name=u'id-CAP-GPRS-ReferenceNumber', mode=MODE_VALUE)
    id_CAP_GPRS_ReferenceNumber._val = (0, 4, 0, 0, 1, 1, 5, 2)
    
    #-----< cAP-GPRS-ReferenceNumber-Abstract-Syntax >-----#
    cAP_GPRS_ReferenceNumber_Abstract_Syntax = CLASS(name=u'cAP-GPRS-ReferenceNumber-Abstract-Syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _cAP_GPRS_ReferenceNumber_Abstract_Syntax_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-GPRS-ReferenceNumber', 'CAP-GPRS-ReferenceNumber')))
    cAP_GPRS_ReferenceNumber_Abstract_Syntax._val = dict([('Type', _cAP_GPRS_ReferenceNumber_Abstract_Syntax_val_Type), ('id', (0, 4, 0, 0, 1, 1, 5, 2))])
    
    #-----< CAP-GPRS-ReferenceNumber >-----#
    CAP_GPRS_ReferenceNumber = SEQ(name=u'CAP-GPRS-ReferenceNumber', mode=MODE_TYPE)
    _CAP_GPRS_ReferenceNumber_destinationReference = INT(name=u'destinationReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    _CAP_GPRS_ReferenceNumber_originationReference = INT(name=u'originationReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    CAP_GPRS_ReferenceNumber._cont = ASN1Dict([
        (u'destinationReference', _CAP_GPRS_ReferenceNumber_destinationReference),
        (u'originationReference', _CAP_GPRS_ReferenceNumber_originationReference),
        ])
    CAP_GPRS_ReferenceNumber._ext = None
    
    _all_ = [
        id_CAP_GPRS_ReferenceNumber,
        cAP_GPRS_ReferenceNumber_Abstract_Syntax,
        _cAP_GPRS_ReferenceNumber_Abstract_Syntax_val_Type,
        _CAP_GPRS_ReferenceNumber_destinationReference,
        _CAP_GPRS_ReferenceNumber_originationReference,
        CAP_GPRS_ReferenceNumber,
    ]

class CAP_gprsSSF_gsmSCF_ops_args:

    _name_  = u'CAP-gprsSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 107, 7]
    
    _obj_ = [
        u'activityTestGPRS',
        u'applyChargingGPRS',
        u'ApplyChargingGPRSArg',
        u'applyChargingReportGPRS',
        u'ApplyChargingReportGPRSArg',
        u'cancelGPRS',
        u'CancelGPRSArg',
        u'connectGPRS',
        u'ConnectGPRSArg',
        u'continueGPRS',
        u'ContinueGPRSArg',
        u'entityReleasedGPRS',
        u'EntityReleasedGPRSArg',
        u'eventReportGPRS',
        u'EventReportGPRSArg',
        u'furnishChargingInformationGPRS',
        u'FurnishChargingInformationGPRSArg',
        u'initialDPGPRS',
        u'InitialDPGPRSArg',
        u'releaseGPRS',
        u'ReleaseGPRSArg',
        u'requestReportGPRSEvent',
        u'RequestReportGPRSEventArg',
        u'resetTimerGPRS',
        u'ResetTimerGPRSArg',
        u'sendChargingInformationGPRS',
        u'SendChargingInformationGPRSArg',
        ]
    _type_ = [
        u'ApplyChargingGPRSArg',
        u'ApplyChargingReportGPRSArg',
        u'CancelGPRSArg',
        u'ConnectGPRSArg',
        u'ContinueGPRSArg',
        u'EntityReleasedGPRSArg',
        u'EventReportGPRSArg',
        u'FurnishChargingInformationGPRSArg',
        u'InitialDPGPRSArg',
        u'ReleaseGPRSArg',
        u'RequestReportGPRSEventArg',
        u'ResetTimerGPRSArg',
        u'SendChargingInformationGPRSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'activityTestGPRS',
        u'applyChargingGPRS',
        u'applyChargingReportGPRS',
        u'cancelGPRS',
        u'connectGPRS',
        u'continueGPRS',
        u'entityReleasedGPRS',
        u'eventReportGPRS',
        u'furnishChargingInformationGPRS',
        u'initialDPGPRS',
        u'releaseGPRS',
        u'requestReportGPRSEvent',
        u'resetTimerGPRS',
        u'sendChargingInformationGPRS',
        ]
    _class_ = [
        u'activityTestGPRS',
        u'applyChargingGPRS',
        u'applyChargingReportGPRS',
        u'cancelGPRS',
        u'connectGPRS',
        u'continueGPRS',
        u'entityReleasedGPRS',
        u'eventReportGPRS',
        u'furnishChargingInformationGPRS',
        u'initialDPGPRS',
        u'releaseGPRS',
        u'requestReportGPRSEvent',
        u'resetTimerGPRS',
        u'sendChargingInformationGPRS',
        ]
    _param_ = [
        u'connectGPRS',
        u'ConnectGPRSArg',
        u'entityReleasedGPRS',
        u'EntityReleasedGPRSArg',
        u'eventReportGPRS',
        u'EventReportGPRSArg',
        u'furnishChargingInformationGPRS',
        u'FurnishChargingInformationGPRSArg',
        u'initialDPGPRS',
        u'InitialDPGPRSArg',
        u'releaseGPRS',
        u'ReleaseGPRSArg',
        u'requestReportGPRSEvent',
        u'RequestReportGPRSEventArg',
        u'sendChargingInformationGPRS',
        u'SendChargingInformationGPRSArg',
        ]
    
    #-----< activityTestGPRS >-----#
    activityTestGPRS = CLASS(name=u'activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTestGPRS._val = dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])
    
    #-----< applyChargingGPRS >-----#
    applyChargingGPRS = CLASS(name=u'applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    applyChargingGPRS._val = dict([(u'ArgumentType', _applyChargingGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])
    
    #-----< ApplyChargingGPRSArg >-----#
    ApplyChargingGPRSArg = SEQ(name=u'ApplyChargingGPRSArg', mode=MODE_TYPE)
    _ApplyChargingGPRSArg_chargingCharacteristics = CHOICE(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingCharacteristics')))
    _ApplyChargingGPRSArg_tariffSwitchInterval = INT(name=u'tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ApplyChargingGPRSArg_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    _ApplyChargingGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ApplyChargingGPRSArg._cont = ASN1Dict([
        (u'chargingCharacteristics', _ApplyChargingGPRSArg_chargingCharacteristics),
        (u'tariffSwitchInterval', _ApplyChargingGPRSArg_tariffSwitchInterval),
        (u'pDPID', _ApplyChargingGPRSArg_pDPID),
        ])
    ApplyChargingGPRSArg._ext = []
    
    #-----< applyChargingReportGPRS >-----#
    applyChargingReportGPRS = CLASS(name=u'applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingReportGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    applyChargingReportGPRS._val = dict([(u'ArgumentType', _applyChargingReportGPRS_val_ArgumentType), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])
    
    #-----< ApplyChargingReportGPRSArg >-----#
    ApplyChargingReportGPRSArg = SEQ(name=u'ApplyChargingReportGPRSArg', mode=MODE_TYPE)
    _ApplyChargingReportGPRSArg_chargingResult = CHOICE(name=u'chargingResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingResult')))
    _ApplyChargingReportGPRSArg_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _ApplyChargingReportGPRSArg_active = BOOL(name=u'active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _ApplyChargingReportGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _ApplyChargingReportGPRSArg_chargingRollOver = CHOICE(name=u'chargingRollOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingRollOver')), opt=True)
    ApplyChargingReportGPRSArg._cont = ASN1Dict([
        (u'chargingResult', _ApplyChargingReportGPRSArg_chargingResult),
        (u'qualityOfService', _ApplyChargingReportGPRSArg_qualityOfService),
        (u'active', _ApplyChargingReportGPRSArg_active),
        (u'pDPID', _ApplyChargingReportGPRSArg_pDPID),
        (u'chargingRollOver', _ApplyChargingReportGPRSArg_chargingRollOver),
        ])
    ApplyChargingReportGPRSArg._ext = [u'chargingRollOver']
    
    #-----< cancelGPRS >-----#
    cancelGPRS = CLASS(name=u'cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _cancelGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    cancelGPRS._val = dict([(u'ArgumentType', _cancelGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])
    
    #-----< CancelGPRSArg >-----#
    CancelGPRSArg = SEQ(name=u'CancelGPRSArg', mode=MODE_TYPE)
    _CancelGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CancelGPRSArg._cont = ASN1Dict([
        (u'pDPID', _CancelGPRSArg_pDPID),
        ])
    CancelGPRSArg._ext = []
    
    #-----< connectGPRS >-----#
    connectGPRS = CLASS(name=u'connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectGPRSArg >-----#
    ConnectGPRSArg = SEQ(name=u'ConnectGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueGPRS >-----#
    continueGPRS = CLASS(name=u'continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _continueGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    continueGPRS._val = dict([(u'ArgumentType', _continueGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])
    
    #-----< ContinueGPRSArg >-----#
    ContinueGPRSArg = SEQ(name=u'ContinueGPRSArg', mode=MODE_TYPE)
    _ContinueGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ContinueGPRSArg._cont = ASN1Dict([
        (u'pDPID', _ContinueGPRSArg_pDPID),
        ])
    ContinueGPRSArg._ext = []
    
    #-----< entityReleasedGPRS >-----#
    entityReleasedGPRS = CLASS(name=u'entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedGPRSArg >-----#
    EntityReleasedGPRSArg = SEQ(name=u'EntityReleasedGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportGPRS >-----#
    eventReportGPRS = CLASS(name=u'eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportGPRSArg >-----#
    EventReportGPRSArg = SEQ(name=u'EventReportGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationGPRS >-----#
    furnishChargingInformationGPRS = CLASS(name=u'furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationGPRSArg >-----#
    FurnishChargingInformationGPRSArg = OCT_STR(name=u'FurnishChargingInformationGPRSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIGPRSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPGPRS >-----#
    initialDPGPRS = CLASS(name=u'initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPGPRSArg >-----#
    InitialDPGPRSArg = SEQ(name=u'InitialDPGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseGPRS >-----#
    releaseGPRS = CLASS(name=u'releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseGPRSArg >-----#
    ReleaseGPRSArg = SEQ(name=u'ReleaseGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< requestReportGPRSEvent >-----#
    requestReportGPRSEvent = CLASS(name=u'requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportGPRSEventArg >-----#
    RequestReportGPRSEventArg = SEQ(name=u'RequestReportGPRSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerGPRS >-----#
    resetTimerGPRS = CLASS(name=u'resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _resetTimerGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    resetTimerGPRS._val = dict([(u'ArgumentType', _resetTimerGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])
    
    #-----< ResetTimerGPRSArg >-----#
    ResetTimerGPRSArg = SEQ(name=u'ResetTimerGPRSArg', mode=MODE_TYPE)
    _ResetTimerGPRSArg_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _ResetTimerGPRSArg_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ResetTimerGPRSArg._cont = ASN1Dict([
        (u'timerID', _ResetTimerGPRSArg_timerID),
        (u'timervalue', _ResetTimerGPRSArg_timervalue),
        ])
    ResetTimerGPRSArg._ext = []
    
    #-----< sendChargingInformationGPRS >-----#
    sendChargingInformationGPRS = CLASS(name=u'sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationGPRSArg >-----#
    SendChargingInformationGPRSArg = SEQ(name=u'SendChargingInformationGPRSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTestGPRS,
        applyChargingGPRS,
        _applyChargingGPRS_val_ArgumentType,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        _ApplyChargingGPRSArg_chargingCharacteristics,
        _ApplyChargingGPRSArg_tariffSwitchInterval,
        _ApplyChargingGPRSArg_pDPID,
        ApplyChargingGPRSArg,
        applyChargingReportGPRS,
        _applyChargingReportGPRS_val_ArgumentType,
        _ApplyChargingReportGPRSArg_chargingResult,
        _ApplyChargingReportGPRSArg_qualityOfService,
        _ApplyChargingReportGPRSArg_active,
        _ApplyChargingReportGPRSArg_pDPID,
        _ApplyChargingReportGPRSArg_chargingRollOver,
        ApplyChargingReportGPRSArg,
        cancelGPRS,
        _cancelGPRS_val_ArgumentType,
        __OPERATION_Errors_val_ParameterType_1,
        _CancelGPRSArg_pDPID,
        CancelGPRSArg,
        continueGPRS,
        _continueGPRS_val_ArgumentType,
        _ContinueGPRSArg_pDPID,
        ContinueGPRSArg,
        resetTimerGPRS,
        _resetTimerGPRS_val_ArgumentType,
        __OPERATION_Errors_val_ParameterType_2,
        _ResetTimerGPRSArg_timerID,
        _ResetTimerGPRSArg_timervalue,
        ResetTimerGPRSArg,
    ]

class CAP_gprsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = u'CAP-gprsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 108, 7]
    
    _obj_ = [
        u'cap-gprssf-scfAC',
        u'cap-gsmscf-gprsssfAC',
        u'capGprsSsfToScf',
        u'capGsmScfToGprsSsf',
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsProcessingPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsTimerPackage',
        u'gprsBillingPackage',
        u'gprsChargingPackage',
        u'gprsChargeAdvicePackage',
        u'gprsActivityTestPackage',
        u'gprsCancelPackage',
        u'gprsSSF-gsmSCFAbstractSyntax',
        u'GenericGprsSSF-gsmSCF-PDUs',
        u'GprsSsfToGsmScfInvokable',
        u'GprsSsfToGsmScfReturnable',
        u'gsmSCF-gprsSSFAbstractSyntax',
        u'GenericGsmSCF-gprsSSF-PDUs',
        u'GsmScfToGprsSsfInvokable',
        u'GsmScfToGprsSsfReturnable',
        ]
    _type_ = [
        u'GenericGprsSSF-gsmSCF-PDUs',
        u'GenericGsmSCF-gprsSSF-PDUs',
        ]
    _set_ = [
        u'GprsSsfToGsmScfInvokable',
        u'GprsSsfToGsmScfReturnable',
        u'GsmScfToGprsSsfInvokable',
        u'GsmScfToGprsSsfReturnable',
        ]
    _val_ = [
        u'cap-gprssf-scfAC',
        u'cap-gsmscf-gprsssfAC',
        u'capGprsSsfToScf',
        u'capGsmScfToGprsSsf',
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsProcessingPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsTimerPackage',
        u'gprsBillingPackage',
        u'gprsChargingPackage',
        u'gprsChargeAdvicePackage',
        u'gprsActivityTestPackage',
        u'gprsCancelPackage',
        u'gprsSSF-gsmSCFAbstractSyntax',
        u'gsmSCF-gprsSSFAbstractSyntax',
        ]
    _class_ = [
        u'cap-gprssf-scfAC',
        u'cap-gsmscf-gprsssfAC',
        u'capGprsSsfToScf',
        u'capGsmScfToGprsSsf',
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsProcessingPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsTimerPackage',
        u'gprsBillingPackage',
        u'gprsChargingPackage',
        u'gprsChargeAdvicePackage',
        u'gprsActivityTestPackage',
        u'gprsCancelPackage',
        u'gprsSSF-gsmSCFAbstractSyntax',
        u'GprsSsfToGsmScfInvokable',
        u'GprsSsfToGsmScfReturnable',
        u'gsmSCF-gprsSSFAbstractSyntax',
        u'GsmScfToGprsSsfInvokable',
        u'GsmScfToGprsSsfReturnable',
        ]
    _param_ = [
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsBillingPackage',
        u'gprsChargeAdvicePackage',
        ]
    
    #-----< cap-gprssf-scfAC >-----#
    cap_gprssf_scfAC = CLASS(name=u'cap-gprssf-scfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey),
        (u'gPRSEventType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSEventType),
        (u'mSISDN', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mSISDN),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI),
        (u'timeAndTimeZone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone),
        (u'gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass),
        (u'endUserAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress),
        (u'qualityOfService', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_qualityOfService),
        (u'accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName),
        (u'routeingAreaIdentity', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_routeingAreaIdentity),
        (u'chargingID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_chargingID),
        (u'sGSNCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sGSNCapabilities),
        (u'locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS),
        (u'pDPInitiationType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_pDPInitiationType),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions),
        (u'gGSNAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gGSNAddress),
        (u'secondaryPDP-context', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_secondaryPDP_context),
        (u'iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventType),
        (u'miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation),
        (u'pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'gPRSCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'accessPointName', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName),
        (u'pdpID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_pdpID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventType),
        (u'miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation),
        (u'pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._ext = []
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    cap_gprssf_scfAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 14))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 21, 3, 50))])
    
    #-----< cap-gsmscf-gprsssfAC >-----#
    cap_gsmscf_gprsssfAC = CLASS(name=u'cap-gsmscf-gprsssfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'gprsCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        (u'gPRSEvent', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent),
        (u'pDPID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_pDPID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'gPRSEventType', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventType),
        (u'miscGPRSInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation),
        (u'pDPID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_pDPID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._ext = []
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    cap_gsmscf_gprsssfAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 15))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 21, 3, 51))])
    
    #-----< capGprsSsfToScf >-----#
    capGprsSsfToScf = CLASS(name=u'capGprsSsfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGprsSsfToScf._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 14))])
    
    #-----< capGsmScfToGprsSsf >-----#
    capGsmScfToGprsSsf = CLASS(name=u'capGsmScfToGprsSsf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGsmScfToGprsSsf._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 15))])
    
    #-----< gprsScfActivationPackage >-----#
    gprsScfActivationPackage = CLASS(name=u'gprsScfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsConnectPackage >-----#
    gprsConnectPackage = CLASS(name=u'gprsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsProcessingPackage >-----#
    gprsProcessingPackage = CLASS(name=u'gprsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsProcessingPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))])
    
    #-----< gprsReleasePackage >-----#
    gprsReleasePackage = CLASS(name=u'gprsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsEventHandlingPackage >-----#
    gprsEventHandlingPackage = CLASS(name=u'gprsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsExceptionInformationPackage >-----#
    gprsExceptionInformationPackage = CLASS(name=u'gprsExceptionInformationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsTimerPackage >-----#
    gprsTimerPackage = CLASS(name=u'gprsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsTimerPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))])
    
    #-----< gprsBillingPackage >-----#
    gprsBillingPackage = CLASS(name=u'gprsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsChargingPackage >-----#
    gprsChargingPackage = CLASS(name=u'gprsChargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsChargingPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))])
    
    #-----< gprsChargeAdvicePackage >-----#
    gprsChargeAdvicePackage = CLASS(name=u'gprsChargeAdvicePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsActivityTestPackage >-----#
    gprsActivityTestPackage = CLASS(name=u'gprsActivityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsActivityTestPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))])
    
    #-----< gprsCancelPackage >-----#
    gprsCancelPackage = CLASS(name=u'gprsCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsCancelPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))])
    
    #-----< gprsSSF-gsmSCFAbstractSyntax >-----#
    gprsSSF_gsmSCFAbstractSyntax = CLASS(name=u'gprsSSF-gsmSCFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gprsSSF_gsmSCFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    gprsSSF_gsmSCFAbstractSyntax._val = dict([('Type', _gprsSSF_gsmSCFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])
    
    #-----< GenericGprsSSF-gsmSCF-PDUs >-----#
    GenericGprsSSF_gsmSCF_PDUs = CHOICE(name=u'GenericGprsSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName),
        (u'pdpID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType),
        (u'miscGPRSInfo', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN),
        (u'iMSI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        (u'gGSNAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName),
        (u'pdpID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause),
        (u'pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN),
        (u'iMSI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        (u'gGSNAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause),
        (u'pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericGprsSSF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_begin._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_end_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericGprsSSF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_end._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._cont = ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericGprsSSF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __GenericGprsSSF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGprsSSF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericGprsSSF_gsmSCF_PDUs_unidirectional),
        (u'begin', _GenericGprsSSF_gsmSCF_PDUs_begin),
        (u'end', _GenericGprsSSF_gsmSCF_PDUs_end),
        (u'continue', _GenericGprsSSF_gsmSCF_PDUs_continue_),
        (u'abort', _GenericGprsSSF_gsmSCF_PDUs_abort),
        ])
    GenericGprsSSF_gsmSCF_PDUs._ext = None
    
    #-----< GprsSsfToGsmScfInvokable >-----#
    GprsSsfToGsmScfInvokable = CLASS(name=u'GprsSsfToGsmScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName),
        (u'pdpID', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType),
        (u'miscGPRSInfo', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN),
        (u'iMSI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions),
        (u'gGSNAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GprsSsfToGsmScfReturnable >-----#
    GprsSsfToGsmScfReturnable = CLASS(name=u'GprsSsfToGsmScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName),
        (u'pdpID', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause),
        (u'pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN),
        (u'iMSI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions),
        (u'gGSNAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause),
        (u'pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    #-----< gsmSCF-gprsSSFAbstractSyntax >-----#
    gsmSCF_gprsSSFAbstractSyntax = CLASS(name=u'gsmSCF-gprsSSFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gsmSCF_gprsSSFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    gsmSCF_gprsSSFAbstractSyntax._val = dict([('Type', _gsmSCF_gprsSSFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])
    
    #-----< GenericGsmSCF-gprsSSF-PDUs >-----#
    GenericGsmSCF_gprsSSF_PDUs = CHOICE(name=u'GenericGsmSCF-gprsSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause),
        (u'pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause),
        (u'pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericGsmSCF_gprsSSF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_begin_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_begin._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_end_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericGsmSCF_gprsSSF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_end_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_end._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._cont = ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericGsmSCF_gprsSSF_PDUs_continue__otid),
        (u'dtid', __GenericGsmSCF_gprsSSF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_continue__components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGsmSCF_gprsSSF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericGsmSCF_gprsSSF_PDUs_unidirectional),
        (u'begin', _GenericGsmSCF_gprsSSF_PDUs_begin),
        (u'end', _GenericGsmSCF_gprsSSF_PDUs_end),
        (u'continue', _GenericGsmSCF_gprsSSF_PDUs_continue_),
        (u'abort', _GenericGsmSCF_gprsSSF_PDUs_abort),
        ])
    GenericGsmSCF_gprsSSF_PDUs._ext = None
    
    #-----< GsmScfToGprsSsfInvokable >-----#
    GsmScfToGprsSsfInvokable = CLASS(name=u'GsmScfToGprsSsfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause),
        (u'pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GsmScfToGprsSsfReturnable >-----#
    GsmScfToGprsSsfReturnable = CLASS(name=u'GsmScfToGprsSsfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause),
        (u'pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap_gprssf_scfAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSEventType,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mSISDN,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimeZone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_endUserAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_qualityOfService,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_routeingAreaIdentity,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_chargingID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sGSNCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_pDPInitiationType,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gGSNAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_secondaryPDP_context,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_gPRSCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_accessPointName,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_pdpID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        __OPERATION_Errors_val_ParameterType_2_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        cap_gsmscf_gprsssfAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_gprsCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_gPRSEvent,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_pDPID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventType,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_miscGPRSInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2_pDPID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0,
        capGprsSsfToScf,
        capGsmScfToGprsSsf,
        gprsProcessingPackage,
        gprsTimerPackage,
        gprsChargingPackage,
        gprsActivityTestPackage,
        gprsCancelPackage,
        gprsSSF_gsmSCFAbstractSyntax,
        _gprsSSF_gsmSCFAbstractSyntax_val_Type,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericGprsSSF_gsmSCF_PDUs_unidirectional,
        __GenericGprsSSF_gsmSCF_PDUs_begin_otid,
        __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_begin_components,
        _GenericGprsSSF_gsmSCF_PDUs_begin,
        __GenericGprsSSF_gsmSCF_PDUs_end_dtid,
        __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_end_components,
        _GenericGprsSSF_gsmSCF_PDUs_end,
        __GenericGprsSSF_gsmSCF_PDUs_continue__otid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dtid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_continue__components,
        _GenericGprsSSF_gsmSCF_PDUs_continue_,
        _GenericGprsSSF_gsmSCF_PDUs_abort,
        GenericGprsSSF_gsmSCF_PDUs,
        GprsSsfToGsmScfInvokable,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_1,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_2,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_3,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_4,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_5,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_6,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_7,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_8,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_9,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_10,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_11,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_12,
        GprsSsfToGsmScfReturnable,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_1,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_2,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_3,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_4,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_5,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_6,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_7,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_8,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_9,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_10,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_11,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_12,
        gsmSCF_gprsSSFAbstractSyntax,
        _gsmSCF_gprsSSFAbstractSyntax_val_Type,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components,
        _GenericGsmSCF_gprsSSF_PDUs_unidirectional,
        __GenericGsmSCF_gprsSSF_PDUs_begin_otid,
        __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_begin_components,
        _GenericGsmSCF_gprsSSF_PDUs_begin,
        __GenericGsmSCF_gprsSSF_PDUs_end_dtid,
        __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_end_components,
        _GenericGsmSCF_gprsSSF_PDUs_end,
        __GenericGsmSCF_gprsSSF_PDUs_continue__otid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dtid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_continue__components,
        _GenericGsmSCF_gprsSSF_PDUs_continue_,
        _GenericGsmSCF_gprsSSF_PDUs_abort,
        GenericGsmSCF_gprsSSF_PDUs,
        GsmScfToGprsSsfInvokable,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_1,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_2,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_3,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_4,
        ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_5,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_6,
        GsmScfToGprsSsfReturnable,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_1,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_2,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_3,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_4,
        ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_5,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_6,
    ]

class CAP_gsmSCF_gsmSRF_ops_args:

    _name_  = u'CAP-gsmSCF-gsmSRF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 103, 7]
    
    _obj_ = [
        u'playAnnouncement',
        u'PlayAnnouncementArg',
        u'promptAndCollectUserInformation',
        u'PromptAndCollectUserInformationArg',
        u'ReceivedInformationArg',
        u'specializedResourceReport',
        u'SpecializedResourceReportArg',
        ]
    _type_ = [
        u'PlayAnnouncementArg',
        u'PromptAndCollectUserInformationArg',
        u'ReceivedInformationArg',
        u'SpecializedResourceReportArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'playAnnouncement',
        u'promptAndCollectUserInformation',
        u'specializedResourceReport',
        ]
    _class_ = [
        u'playAnnouncement',
        u'promptAndCollectUserInformation',
        u'specializedResourceReport',
        ]
    _param_ = [
        u'playAnnouncement',
        u'PlayAnnouncementArg',
        u'promptAndCollectUserInformation',
        u'PromptAndCollectUserInformationArg',
        u'ReceivedInformationArg',
        ]
    
    #-----< playAnnouncement >-----#
    playAnnouncement = CLASS(name=u'playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayAnnouncementArg >-----#
    PlayAnnouncementArg = SEQ(name=u'PlayAnnouncementArg', mode=MODE_TYPE, param=True)
    
    #-----< promptAndCollectUserInformation >-----#
    promptAndCollectUserInformation = CLASS(name=u'promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PromptAndCollectUserInformationArg >-----#
    PromptAndCollectUserInformationArg = SEQ(name=u'PromptAndCollectUserInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< ReceivedInformationArg >-----#
    ReceivedInformationArg = CHOICE(name=u'ReceivedInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< specializedResourceReport >-----#
    specializedResourceReport = CLASS(name=u'specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _specializedResourceReport_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    specializedResourceReport._val = dict([(u'ArgumentType', _specializedResourceReport_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])
    
    #-----< SpecializedResourceReportArg >-----#
    SpecializedResourceReportArg = CHOICE(name=u'SpecializedResourceReportArg', mode=MODE_TYPE)
    _SpecializedResourceReportArg_allAnnouncementsComplete = NULL(name=u'allAnnouncementsComplete', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SpecializedResourceReportArg_firstAnnouncementStarted = NULL(name=u'firstAnnouncementStarted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SpecializedResourceReportArg._cont = ASN1Dict([
        (u'allAnnouncementsComplete', _SpecializedResourceReportArg_allAnnouncementsComplete),
        (u'firstAnnouncementStarted', _SpecializedResourceReportArg_firstAnnouncementStarted),
        ])
    SpecializedResourceReportArg._ext = None
    
    _all_ = [
        specializedResourceReport,
        _specializedResourceReport_val_ArgumentType,
        _SpecializedResourceReportArg_allAnnouncementsComplete,
        _SpecializedResourceReportArg_firstAnnouncementStarted,
        SpecializedResourceReportArg,
    ]

class CAP_gsmSCF_gsmSRF_pkgs_contracts_acs:

    _name_  = u'CAP-gsmSCF-gsmSRF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 104, 7]
    
    _obj_ = [
        u'gsmSRF-gsmSCF-ac',
        u'gsmSRF-gsmSCF-contract',
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        u'activityTestPackage',
        u'gsmSRF-gsmSCF-abstract-syntax',
        u'BASIC-gsmSRF-gsmSCF-PDUs',
        u'GsmSRFgsmSCFInvokable',
        u'GsmSRFgsmSCFReturnable',
        ]
    _type_ = [
        u'BASIC-gsmSRF-gsmSCF-PDUs',
        ]
    _set_ = [
        u'GsmSRFgsmSCFInvokable',
        u'GsmSRFgsmSCFReturnable',
        ]
    _val_ = [
        u'gsmSRF-gsmSCF-ac',
        u'gsmSRF-gsmSCF-contract',
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        u'activityTestPackage',
        u'gsmSRF-gsmSCF-abstract-syntax',
        ]
    _class_ = [
        u'gsmSRF-gsmSCF-ac',
        u'gsmSRF-gsmSCF-contract',
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        u'activityTestPackage',
        u'gsmSRF-gsmSCF-abstract-syntax',
        u'GsmSRFgsmSCFInvokable',
        u'GsmSRFgsmSCFReturnable',
        ]
    _param_ = [
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        ]
    
    #-----< gsmSRF-gsmSCF-ac >-----#
    gsmSRF_gsmSCF_ac = CLASS(name=u'gsmSRF-gsmSCF-ac', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID),
        (u'iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        (u'operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_ac._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 13))])), (u'dialogueMode', u'structured'), (u'termination', u'basic'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 22, 3, 14))])
    
    #-----< gsmSRF-gsmSCF-contract >-----#
    gsmSRF_gsmSCF_contract = CLASS(name=u'gsmSRF-gsmSCF-contract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    gsmSRF_gsmSCF_contract._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 13))])
    
    #-----< specializedResourceControlPackage >-----#
    specializedResourceControlPackage = CLASS(name=u'specializedResourceControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfCancelPackage >-----#
    gsmSRF_scfCancelPackage = CLASS(name=u'gsmSRF-scfCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name=u'activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< gsmSRF-gsmSCF-abstract-syntax >-----#
    gsmSRF_gsmSCF_abstract_syntax = CLASS(name=u'gsmSRF-gsmSCF-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gsmSRF_gsmSCF_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_abstract_syntax._val = dict([('Type', _gsmSRF_gsmSCF_abstract_syntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])
    
    #-----< BASIC-gsmSRF-gsmSCF-PDUs >-----#
    BASIC_gsmSRF_gsmSCF_PDUs = CHOICE(name=u'BASIC-gsmSRF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend),
        (u'extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        (u'callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'ResultType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend),
        (u'extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        (u'callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'ResultType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        (u'problem', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        (u'operation', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_begin_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_end_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_continue__components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    BASIC_gsmSRF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional),
        (u'begin', _BASIC_gsmSRF_gsmSCF_PDUs_begin),
        (u'end', _BASIC_gsmSRF_gsmSCF_PDUs_end),
        (u'continue', _BASIC_gsmSRF_gsmSCF_PDUs_continue_),
        (u'abort', _BASIC_gsmSRF_gsmSCF_PDUs_abort),
        ])
    BASIC_gsmSRF_gsmSCF_PDUs._ext = None
    
    #-----< GsmSRFgsmSCFInvokable >-----#
    GsmSRFgsmSCFInvokable = CLASS(name=u'GsmSRFgsmSCFInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID),
        (u'allRequests', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend),
        (u'extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFInvokable_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    GsmSRFgsmSCFInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_4), (u'ResultType', _GsmSRFgsmSCFInvokable_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_5), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    #-----< GsmSRFgsmSCFReturnable >-----#
    GsmSRFgsmSCFReturnable = CLASS(name=u'GsmSRFgsmSCFReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID),
        (u'allRequests', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend),
        (u'extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFReturnable_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._ext = None
    GsmSRFgsmSCFReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_4), (u'ResultType', _GsmSRFgsmSCFReturnable_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    
    _all_ = [
        gsmSRF_gsmSCF_ac,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_3_0,
        __OPERATION_Errors_val_ParameterType_4,
        __OPERATION_Linked_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        gsmSRF_gsmSCF_contract,
        activityTestPackage,
        gsmSRF_gsmSCF_abstract_syntax,
        _gsmSRF_gsmSCF_abstract_syntax_val_Type,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_begin,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_end,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__components,
        _BASIC_gsmSRF_gsmSCF_PDUs_continue_,
        _BASIC_gsmSRF_gsmSCF_PDUs_abort,
        BASIC_gsmSRF_gsmSCF_PDUs,
        GsmSRFgsmSCFInvokable,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_1,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_2,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_3,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_4,
        __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFInvokable_val_ResultType_4,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_5,
        GsmSRFgsmSCFReturnable,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_1,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_2,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_3,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_4,
        __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFReturnable_val_ResultType_4,
    ]

class CAP_gsmSSF_gsmSCF_ops_args:

    _name_  = u'CAP-gsmSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 101, 7]
    
    _obj_ = [
        u'activityTest',
        u'applyCharging',
        u'ApplyChargingArg',
        u'applyChargingReport',
        u'ApplyChargingReportArg',
        u'assistRequestInstructions',
        u'AssistRequestInstructionsArg',
        u'callGap',
        u'CallGapArg',
        u'callInformationReport',
        u'CallInformationReportArg',
        u'callInformationRequest',
        u'CallInformationRequestArg',
        u'cancel',
        u'CancelArg',
        u'collectInformation',
        u'CollectInformationArg',
        u'connect',
        u'ConnectArg',
        u'connectToResource',
        u'ConnectToResourceArg',
        u'continue',
        u'continueWithArgument',
        u'ContinueWithArgumentArg',
        u'ContinueWithArgumentArgExtension',
        u'disconnectForwardConnection',
        u'disconnectForwardConnectionWithArgument',
        u'DisconnectForwardConnectionWithArgumentArg',
        u'disconnectLeg',
        u'DisconnectLegArg',
        u'entityReleased',
        u'EntityReleasedArg',
        u'establishTemporaryConnection',
        u'EstablishTemporaryConnectionArg',
        u'eventReportBCSM',
        u'EventReportBCSMArg',
        u'furnishChargingInformation',
        u'FurnishChargingInformationArg',
        u'initialDP',
        u'InitialDPArg',
        u'InitialDPArgExtension',
        u'initiateCallAttempt',
        u'InitiateCallAttemptArg',
        u'InitiateCallAttemptRes',
        u'moveLeg',
        u'MoveLegArg',
        u'playTone',
        u'PlayToneArg',
        u'releaseCall',
        u'ReleaseCallArg',
        u'AllCallSegments',
        u'AllCallSegmentsWithExtension',
        u'requestReportBCSMEvent',
        u'RequestReportBCSMEventArg',
        u'resetTimer',
        u'ResetTimerArg',
        u'sendChargingInformation',
        u'SendChargingInformationArg',
        u'splitLeg',
        u'SplitLegArg',
        ]
    _type_ = [
        u'ApplyChargingArg',
        u'ApplyChargingReportArg',
        u'AssistRequestInstructionsArg',
        u'CallGapArg',
        u'CallInformationReportArg',
        u'CallInformationRequestArg',
        u'CancelArg',
        u'CollectInformationArg',
        u'ConnectArg',
        u'ConnectToResourceArg',
        u'ContinueWithArgumentArg',
        u'ContinueWithArgumentArgExtension',
        u'DisconnectForwardConnectionWithArgumentArg',
        u'DisconnectLegArg',
        u'EntityReleasedArg',
        u'EstablishTemporaryConnectionArg',
        u'EventReportBCSMArg',
        u'FurnishChargingInformationArg',
        u'InitialDPArg',
        u'InitialDPArgExtension',
        u'InitiateCallAttemptArg',
        u'InitiateCallAttemptRes',
        u'MoveLegArg',
        u'PlayToneArg',
        u'ReleaseCallArg',
        u'AllCallSegments',
        u'AllCallSegmentsWithExtension',
        u'RequestReportBCSMEventArg',
        u'ResetTimerArg',
        u'SendChargingInformationArg',
        u'SplitLegArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'activityTest',
        u'applyCharging',
        u'applyChargingReport',
        u'assistRequestInstructions',
        u'callGap',
        u'callInformationReport',
        u'callInformationRequest',
        u'cancel',
        u'collectInformation',
        u'connect',
        u'connectToResource',
        u'continue',
        u'continueWithArgument',
        u'disconnectForwardConnection',
        u'disconnectForwardConnectionWithArgument',
        u'disconnectLeg',
        u'entityReleased',
        u'establishTemporaryConnection',
        u'eventReportBCSM',
        u'furnishChargingInformation',
        u'initialDP',
        u'initiateCallAttempt',
        u'moveLeg',
        u'playTone',
        u'releaseCall',
        u'requestReportBCSMEvent',
        u'resetTimer',
        u'sendChargingInformation',
        u'splitLeg',
        ]
    _class_ = [
        u'activityTest',
        u'applyCharging',
        u'applyChargingReport',
        u'assistRequestInstructions',
        u'callGap',
        u'callInformationReport',
        u'callInformationRequest',
        u'cancel',
        u'collectInformation',
        u'connect',
        u'connectToResource',
        u'continue',
        u'continueWithArgument',
        u'disconnectForwardConnection',
        u'disconnectForwardConnectionWithArgument',
        u'disconnectLeg',
        u'entityReleased',
        u'establishTemporaryConnection',
        u'eventReportBCSM',
        u'furnishChargingInformation',
        u'initialDP',
        u'initiateCallAttempt',
        u'moveLeg',
        u'playTone',
        u'releaseCall',
        u'requestReportBCSMEvent',
        u'resetTimer',
        u'sendChargingInformation',
        u'splitLeg',
        ]
    _param_ = [
        u'applyCharging',
        u'ApplyChargingArg',
        u'applyChargingReport',
        u'ApplyChargingReportArg',
        u'assistRequestInstructions',
        u'AssistRequestInstructionsArg',
        u'callGap',
        u'CallGapArg',
        u'callInformationReport',
        u'CallInformationReportArg',
        u'callInformationRequest',
        u'CallInformationRequestArg',
        u'cancel',
        u'CancelArg',
        u'collectInformation',
        u'CollectInformationArg',
        u'connect',
        u'ConnectArg',
        u'connectToResource',
        u'ConnectToResourceArg',
        u'continueWithArgument',
        u'ContinueWithArgumentArg',
        u'ContinueWithArgumentArgExtension',
        u'disconnectForwardConnectionWithArgument',
        u'DisconnectForwardConnectionWithArgumentArg',
        u'disconnectLeg',
        u'DisconnectLegArg',
        u'entityReleased',
        u'EntityReleasedArg',
        u'establishTemporaryConnection',
        u'EstablishTemporaryConnectionArg',
        u'eventReportBCSM',
        u'EventReportBCSMArg',
        u'furnishChargingInformation',
        u'FurnishChargingInformationArg',
        u'initialDP',
        u'InitialDPArg',
        u'InitialDPArgExtension',
        u'initiateCallAttempt',
        u'InitiateCallAttemptArg',
        u'InitiateCallAttemptRes',
        u'moveLeg',
        u'MoveLegArg',
        u'playTone',
        u'PlayToneArg',
        u'releaseCall',
        u'ReleaseCallArg',
        u'AllCallSegments',
        u'AllCallSegmentsWithExtension',
        u'requestReportBCSMEvent',
        u'RequestReportBCSMEventArg',
        u'resetTimer',
        u'ResetTimerArg',
        u'sendChargingInformation',
        u'SendChargingInformationArg',
        u'splitLeg',
        u'SplitLegArg',
        ]
    
    #-----< activityTest >-----#
    activityTest = CLASS(name=u'activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTest._val = dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])
    
    #-----< applyCharging >-----#
    applyCharging = CLASS(name=u'applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingArg >-----#
    ApplyChargingArg = SEQ(name=u'ApplyChargingArg', mode=MODE_TYPE, param=True)
    
    #-----< applyChargingReport >-----#
    applyChargingReport = CLASS(name=u'applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingReportArg >-----#
    ApplyChargingReportArg = OCT_STR(name=u'ApplyChargingReportArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CallResult')), param=True)
    
    #-----< assistRequestInstructions >-----#
    assistRequestInstructions = CLASS(name=u'assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AssistRequestInstructionsArg >-----#
    AssistRequestInstructionsArg = SEQ(name=u'AssistRequestInstructionsArg', mode=MODE_TYPE, param=True)
    
    #-----< callGap >-----#
    callGap = CLASS(name=u'callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallGapArg >-----#
    CallGapArg = SEQ(name=u'CallGapArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationReport >-----#
    callInformationReport = CLASS(name=u'callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationReportArg >-----#
    CallInformationReportArg = SEQ(name=u'CallInformationReportArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationRequest >-----#
    callInformationRequest = CLASS(name=u'callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationRequestArg >-----#
    CallInformationRequestArg = SEQ(name=u'CallInformationRequestArg', mode=MODE_TYPE, param=True)
    
    #-----< cancel >-----#
    cancel = CLASS(name=u'cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CancelArg >-----#
    CancelArg = CHOICE(name=u'CancelArg', mode=MODE_TYPE, param=True)
    
    #-----< collectInformation >-----#
    collectInformation = CLASS(name=u'collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CollectInformationArg >-----#
    CollectInformationArg = SEQ(name=u'CollectInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< connect >-----#
    connect = CLASS(name=u'connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectArg >-----#
    ConnectArg = SEQ(name=u'ConnectArg', mode=MODE_TYPE, param=True)
    
    #-----< connectToResource >-----#
    connectToResource = CLASS(name=u'connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectToResourceArg >-----#
    ConnectToResourceArg = SEQ(name=u'ConnectToResourceArg', mode=MODE_TYPE, param=True)
    
    #-----< continue >-----#
    continue_ = CLASS(name=u'continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continue_._val = dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])
    
    #-----< continueWithArgument >-----#
    continueWithArgument = CLASS(name=u'continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ContinueWithArgumentArg >-----#
    ContinueWithArgumentArg = SEQ(name=u'ContinueWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< ContinueWithArgumentArgExtension >-----#
    ContinueWithArgumentArgExtension = SEQ(name=u'ContinueWithArgumentArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< disconnectForwardConnection >-----#
    disconnectForwardConnection = CLASS(name=u'disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    __OPERATION_Errors_val_ParameterType_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    disconnectForwardConnection._val = dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))])
    
    #-----< disconnectForwardConnectionWithArgument >-----#
    disconnectForwardConnectionWithArgument = CLASS(name=u'disconnectForwardConnectionWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectForwardConnectionWithArgumentArg >-----#
    DisconnectForwardConnectionWithArgumentArg = SEQ(name=u'DisconnectForwardConnectionWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< disconnectLeg >-----#
    disconnectLeg = CLASS(name=u'disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectLegArg >-----#
    DisconnectLegArg = SEQ(name=u'DisconnectLegArg', mode=MODE_TYPE, param=True)
    
    #-----< entityReleased >-----#
    entityReleased = CLASS(name=u'entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedArg >-----#
    EntityReleasedArg = CHOICE(name=u'EntityReleasedArg', mode=MODE_TYPE, param=True)
    
    #-----< establishTemporaryConnection >-----#
    establishTemporaryConnection = CLASS(name=u'establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EstablishTemporaryConnectionArg >-----#
    EstablishTemporaryConnectionArg = SEQ(name=u'EstablishTemporaryConnectionArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportBCSM >-----#
    eventReportBCSM = CLASS(name=u'eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportBCSMArg >-----#
    EventReportBCSMArg = SEQ(name=u'EventReportBCSMArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformation >-----#
    furnishChargingInformation = CLASS(name=u'furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationArg >-----#
    FurnishChargingInformationArg = OCT_STR(name=u'FurnishChargingInformationArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIBillingChargingCharacteristics')), param=True)
    
    #-----< initialDP >-----#
    initialDP = CLASS(name=u'initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPArg >-----#
    InitialDPArg = SEQ(name=u'InitialDPArg', mode=MODE_TYPE, param=True)
    
    #-----< InitialDPArgExtension >-----#
    InitialDPArgExtension = SEQ(name=u'InitialDPArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< initiateCallAttempt >-----#
    initiateCallAttempt = CLASS(name=u'initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitiateCallAttemptArg >-----#
    InitiateCallAttemptArg = SEQ(name=u'InitiateCallAttemptArg', mode=MODE_TYPE, param=True)
    
    #-----< InitiateCallAttemptRes >-----#
    InitiateCallAttemptRes = SEQ(name=u'InitiateCallAttemptRes', mode=MODE_TYPE, param=True)
    
    #-----< moveLeg >-----#
    moveLeg = CLASS(name=u'moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< MoveLegArg >-----#
    MoveLegArg = SEQ(name=u'MoveLegArg', mode=MODE_TYPE, param=True)
    
    #-----< playTone >-----#
    playTone = CLASS(name=u'playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayToneArg >-----#
    PlayToneArg = SEQ(name=u'PlayToneArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseCall >-----#
    releaseCall = CLASS(name=u'releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseCallArg >-----#
    ReleaseCallArg = CHOICE(name=u'ReleaseCallArg', mode=MODE_TYPE, param=True)
    
    #-----< AllCallSegments >-----#
    AllCallSegments = OCT_STR(name=u'AllCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Cause')), param=True)
    
    #-----< AllCallSegmentsWithExtension >-----#
    AllCallSegmentsWithExtension = SEQ(name=u'AllCallSegmentsWithExtension', mode=MODE_TYPE, param=True)
    
    #-----< requestReportBCSMEvent >-----#
    requestReportBCSMEvent = CLASS(name=u'requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportBCSMEventArg >-----#
    RequestReportBCSMEventArg = SEQ(name=u'RequestReportBCSMEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimer >-----#
    resetTimer = CLASS(name=u'resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerArg >-----#
    ResetTimerArg = SEQ(name=u'ResetTimerArg', mode=MODE_TYPE, param=True)
    
    #-----< sendChargingInformation >-----#
    sendChargingInformation = CLASS(name=u'sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationArg >-----#
    SendChargingInformationArg = SEQ(name=u'SendChargingInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< splitLeg >-----#
    splitLeg = CLASS(name=u'splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SplitLegArg >-----#
    SplitLegArg = SEQ(name=u'SplitLegArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTest,
        continue_,
        disconnectForwardConnection,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_1,
    ]

class CAP_gsmSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = u'CAP-gsmSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 102, 7]
    
    _obj_ = [
        u'capssf-scfGenericAC',
        u'capssf-scfAssistHandoffAC',
        u'capscf-ssfGenericAC',
        u'capSsfToScfGeneric',
        u'capAssistHandoffssfToScf',
        u'capScfToSsfGeneric',
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'activityTestPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        u'gsmSSF-scfGenericAbstractSyntax',
        u'GenericSSF-gsmSCF-PDUs',
        u'SsfToScfGenericInvokable',
        u'SsfToScfGenericReturnable',
        u'assistHandoff-gsmSSF-scfAbstractSyntax',
        u'AssistHandoffsSF-gsmSCF-PDUs',
        u'AssistHandoffssfToScfInvokable',
        u'AssistHandoffssfToScfReturnable',
        u'scf-gsmSSFGenericAbstractSyntax',
        u'GenericSCF-gsmSSF-PDUs',
        u'ScfToSsfGenericInvokable',
        u'ScfToSsfGenericReturnable',
        ]
    _type_ = [
        u'GenericSSF-gsmSCF-PDUs',
        u'AssistHandoffsSF-gsmSCF-PDUs',
        u'GenericSCF-gsmSSF-PDUs',
        ]
    _set_ = [
        u'SsfToScfGenericInvokable',
        u'SsfToScfGenericReturnable',
        u'AssistHandoffssfToScfInvokable',
        u'AssistHandoffssfToScfReturnable',
        u'ScfToSsfGenericInvokable',
        u'ScfToSsfGenericReturnable',
        ]
    _val_ = [
        u'capssf-scfGenericAC',
        u'capssf-scfAssistHandoffAC',
        u'capscf-ssfGenericAC',
        u'capSsfToScfGeneric',
        u'capAssistHandoffssfToScf',
        u'capScfToSsfGeneric',
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'activityTestPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        u'gsmSSF-scfGenericAbstractSyntax',
        u'assistHandoff-gsmSSF-scfAbstractSyntax',
        u'scf-gsmSSFGenericAbstractSyntax',
        ]
    _class_ = [
        u'capssf-scfGenericAC',
        u'capssf-scfAssistHandoffAC',
        u'capscf-ssfGenericAC',
        u'capSsfToScfGeneric',
        u'capAssistHandoffssfToScf',
        u'capScfToSsfGeneric',
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'activityTestPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        u'gsmSSF-scfGenericAbstractSyntax',
        u'SsfToScfGenericInvokable',
        u'SsfToScfGenericReturnable',
        u'assistHandoff-gsmSSF-scfAbstractSyntax',
        u'AssistHandoffssfToScfInvokable',
        u'AssistHandoffssfToScfReturnable',
        u'scf-gsmSSFGenericAbstractSyntax',
        u'ScfToSsfGenericInvokable',
        u'ScfToSsfGenericReturnable',
        ]
    _param_ = [
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        ]
    
    #-----< capssf-scfGenericAC >-----#
    capssf_scfGenericAC = CLASS(name=u'capssf-scfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure),
        (u'bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey),
        (u'calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        (u'cGEncountered', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered),
        (u'iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        (u'locationNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        (u'highLayerCompatibility', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        (u'additionalCallingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        (u'bearerCapability', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability),
        (u'eventTypeBCSM', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        (u'redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        (u'redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation),
        (u'cause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier),
        (u'cug-Index', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI),
        (u'subscriberState', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState),
        (u'locationInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation),
        (u'ext-basicServiceCode', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        (u'callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        (u'mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress),
        (u'calledPartyBCDNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        (u'timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        (u'callForwardingSS-Pending', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        (u'initialDPArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID),
        (u'scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments),
        (u'allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions),
        (u'legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        (u'operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        (u'srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        (u'partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions),
        (u'aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._ext = []
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_7 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_8 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_8._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_8._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        (u'redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        (u'redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber),
        (u'legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        (u'oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        (u'suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._ext = [u'suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        (u'legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased),
        (u'releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1._ext = []
    __OPERATION_Errors_val_ParameterType_1_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        (u'legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        (u'legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3._ext = []
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        (u'none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        (u'bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        (u'partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13._ext = []
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1._ext = None
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        (u'tone', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        (u'releaseCause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        (u'gapCriteria', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria),
        (u'gapIndicators', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators),
        (u'controlType', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType),
        (u'gapTreatment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions),
        (u'legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        (u'callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        (u'gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        (u'suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._cont = ASN1Dict([
        (u'supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions),
        (u'releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0._ext = [u'releaseCallArgExtensionAllowed']
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    capssf_scfGenericAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 3))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 4))])
    
    #-----< capssf-scfAssistHandoffAC >-----#
    capssf_scfAssistHandoffAC = CLASS(name=u'capssf-scfAssistHandoffAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID),
        (u'iPSSPCapabilities', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        (u'none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        (u'resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22._ext = []
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    capssf_scfAssistHandoffAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 5))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 6))])
    
    #-----< capscf-ssfGenericAC >-----#
    capscf_ssfGenericAC = CLASS(name=u'capscf-ssfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        (u'correlationID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID),
        (u'scfID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        (u'bcsmEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'eventTypeBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        (u'allCallSegments', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        (u'allCallSegmentsWithExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        (u'requestedInformationTypeList', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions),
        (u'legID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'requestedInformationList', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions),
        (u'legID', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        (u'invokeID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID),
        (u'allRequests', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests),
        (u'callSegmentToCancel', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        (u'srfConnection', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        (u'partyToCharge', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions),
        (u'aChChargingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        (u'originalCalledPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        (u'redirectingPartyID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        (u'redirectionInformation', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        (u'legToBeConnected', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        (u'oCSIApplicable', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        (u'suppress-N-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30._ext = [u'suppress-N-CSI']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        (u'legToBeReleased', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased),
        (u'releaseCause', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        (u'legIDToMove', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        (u'legToBeSplit', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        (u'none', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        (u'resourceAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        (u'legOrCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        (u'bursts', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        (u'destinationRoutingAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions),
        (u'legToBeCreated', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        (u'newCallSegment', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        (u'callReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        (u'gsmSCFAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        (u'suppress-T-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        (u'supportedCamelPhases', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions),
        (u'releaseCallArgExtensionAllowed', ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_0_0._ext = [u'releaseCallArgExtensionAllowed']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        (u'interval', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        (u'tone', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        (u'collectedInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo),
        (u'disconnectFromIPForbidden', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        (u'informationToSend', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID),
        (u'requestAnnouncementStartedNotification', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7._ext = []
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        (u'digitsResponse', ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    __OPERATION_PACKAGE_Supplier_val_ResultType_1_1._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        (u'alertingPattern', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions),
        (u'serviceInteractionIndicatorsTwo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        (u'genericNumbers', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers),
        (u'cug-Interlock', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock),
        (u'cug-OutgoingAccess', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        (u'chargeNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber),
        (u'carrier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier),
        (u'suppressionOfAnnouncement', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        (u'naOliInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo),
        (u'bor-InterrogationRequested', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        (u'suppress-O-CSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions),
        (u'callSegmentID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        (u'cause', ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        (u'callSegmentFailure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        (u'bCSM-Failure', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    capscf_ssfGenericAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 6))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 8))])
    
    #-----< capSsfToScfGeneric >-----#
    capSsfToScfGeneric = CLASS(name=u'capSsfToScfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capSsfToScfGeneric._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 3))])
    
    #-----< capAssistHandoffssfToScf >-----#
    capAssistHandoffssfToScf = CLASS(name=u'capAssistHandoffssfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capAssistHandoffssfToScf._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 5))])
    
    #-----< capScfToSsfGeneric >-----#
    capScfToSsfGeneric = CLASS(name=u'capScfToSsfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capScfToSsfGeneric._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7), (u'ResultType', __OPERATION_PACKAGE_Supplier_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 6))])
    
    #-----< scfActivationPackage >-----#
    scfActivationPackage = CLASS(name=u'scfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfActivationOfAssistPackage >-----#
    gsmSRF_scfActivationOfAssistPackage = CLASS(name=u'gsmSRF-scfActivationOfAssistPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< assistConnectionEstablishmentPackage >-----#
    assistConnectionEstablishmentPackage = CLASS(name=u'assistConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< genericDisconnectResourcePackage >-----#
    genericDisconnectResourcePackage = CLASS(name=u'genericDisconnectResourcePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< nonAssistedConnectionEstablishmentPackage >-----#
    nonAssistedConnectionEstablishmentPackage = CLASS(name=u'nonAssistedConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< connectPackage >-----#
    connectPackage = CLASS(name=u'connectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callHandlingPackage >-----#
    callHandlingPackage = CLASS(name=u'callHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< bcsmEventHandlingPackage >-----#
    bcsmEventHandlingPackage = CLASS(name=u'bcsmEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ssfCallProcessingPackage >-----#
    ssfCallProcessingPackage = CLASS(name=u'ssfCallProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< scfCallInitiationPackage >-----#
    scfCallInitiationPackage = CLASS(name=u'scfCallInitiationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< timerPackage >-----#
    timerPackage = CLASS(name=u'timerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< billingPackage >-----#
    billingPackage = CLASS(name=u'billingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< chargingPackage >-----#
    chargingPackage = CLASS(name=u'chargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< trafficManagementPackage >-----#
    trafficManagementPackage = CLASS(name=u'trafficManagementPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callReportPackage >-----#
    callReportPackage = CLASS(name=u'callReportPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< signallingControlPackage >-----#
    signallingControlPackage = CLASS(name=u'signallingControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name=u'activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< cancelPackage >-----#
    cancelPackage = CLASS(name=u'cancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< cphResponsePackage >-----#
    cphResponsePackage = CLASS(name=u'cphResponsePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< exceptionInformPackage >-----#
    exceptionInformPackage = CLASS(name=u'exceptionInformPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< playTonePackage >-----#
    playTonePackage = CLASS(name=u'playTonePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSSF-scfGenericAbstractSyntax >-----#
    gsmSSF_scfGenericAbstractSyntax = CLASS(name=u'gsmSSF-scfGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gsmSSF_scfGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    gsmSSF_scfGenericAbstractSyntax._val = dict([('Type', _gsmSSF_scfGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])
    
    #-----< GenericSSF-gsmSCF-PDUs >-----#
    GenericSSF_gsmSCF_PDUs = CHOICE(name=u'GenericSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSSF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        (u'legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID),
        (u'allRequests', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory),
        (u'genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers),
        (u'cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess),
        (u'chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier),
        (u'suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement),
        (u'naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested),
        (u'suppress-O-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        (u'none', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'resourceAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        (u'cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID),
        (u'cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'callSegmentFailure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure),
        (u'bCSM-Failure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        (u'correlationID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID),
        (u'scfID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID),
        (u'naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo),
        (u'chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber),
        (u'originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID),
        (u'callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM),
        (u'legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID),
        (u'miscCallInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation),
        (u'cause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier),
        (u'cug-Index', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI),
        (u'subscriberState', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState),
        (u'locationInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions),
        (u'legToBeCreated', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID),
        (u'timervalue', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), (u'ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27), (u'ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        (u'tone', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend),
        (u'releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'gapCriteria', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria),
        (u'gapIndicators', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators),
        (u'controlType', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType),
        (u'gapTreatment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        (u'allRequests', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory),
        (u'genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers),
        (u'cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess),
        (u'chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier),
        (u'suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement),
        (u'naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo),
        (u'bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested),
        (u'suppress-O-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'legToBeReleased', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased),
        (u'releaseCause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        (u'cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID),
        (u'cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        (u'callSegmentFailure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure),
        (u'bCSM-Failure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        (u'correlationID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID),
        (u'scfID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID),
        (u'naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo),
        (u'chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber),
        (u'originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID),
        (u'callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation),
        (u'cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier),
        (u'cug-Index', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI),
        (u'subscriberState', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState),
        (u'locationInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        (u'legToBeCreated', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID),
        (u'timervalue', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), (u'ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27), (u'ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        (u'problem', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        (u'operation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericSSF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_begin_components._cont = ___GenericSSF_gsmSCF_PDUs_begin_components__item_
    __GenericSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericSSF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericSSF_gsmSCF_PDUs_begin._ext = None
    _GenericSSF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_end_components._cont = ___GenericSSF_gsmSCF_PDUs_end_components__item_
    __GenericSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericSSF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericSSF_gsmSCF_PDUs_end._ext = None
    _GenericSSF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_continue__components._cont = ___GenericSSF_gsmSCF_PDUs_continue__components__item_
    __GenericSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericSSF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __GenericSSF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericSSF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSSF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericSSF_gsmSCF_PDUs_unidirectional),
        (u'begin', _GenericSSF_gsmSCF_PDUs_begin),
        (u'end', _GenericSSF_gsmSCF_PDUs_end),
        (u'continue', _GenericSSF_gsmSCF_PDUs_continue_),
        (u'abort', _GenericSSF_gsmSCF_PDUs_abort),
        ])
    GenericSSF_gsmSCF_PDUs._ext = None
    
    #-----< SsfToScfGenericInvokable >-----#
    SsfToScfGenericInvokable = CLASS(name=u'SsfToScfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_1._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_3_extensions),
        (u'legID', __SsfToScfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_3._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_4_extensions),
        (u'legID', __SsfToScfGenericInvokable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_4._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID),
        (u'allRequests', __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_5._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_6_extensions),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _SsfToScfGenericInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory),
        (u'genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers),
        (u'cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess),
        (u'chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_7_carrier),
        (u'suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement),
        (u'naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested),
        (u'suppress-O-CSI', __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_7._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        (u'none', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_8._cont = ASN1Dict([
        (u'resourceAddress', __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_8_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_8._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_9_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_9._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_11._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_12._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        (u'cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID),
        (u'cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        (u'callSegmentFailure', __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure),
        (u'bCSM-Failure', __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_13._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_14._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        (u'correlationID', __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID),
        (u'scfID', __SsfToScfGenericInvokable_val_ArgumentType_14_scfID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_14_extensions),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_14_carrier),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID),
        (u'naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo),
        (u'chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber),
        (u'originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID),
        (u'callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_14._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _SsfToScfGenericInvokable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_15_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        (u'eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM),
        (u'legID', __SsfToScfGenericInvokable_val_ArgumentType_15_legID),
        (u'miscCallInfo', __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_15_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_15._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation),
        (u'cause', __SsfToScfGenericInvokable_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_17_carrier),
        (u'cug-Index', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI),
        (u'subscriberState', __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState),
        (u'locationInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_17._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_18_extensions),
        (u'legToBeCreated', __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_18._ext = []
    _SsfToScfGenericInvokable_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', __SsfToScfGenericInvokable_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericInvokable_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_19._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_20._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_21._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', __SsfToScfGenericInvokable_val_ArgumentType_22_timerID),
        (u'timervalue', __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_22_extensions),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_22._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_23._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_24._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_25_extensions),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_25._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', __SsfToScfGenericInvokable_val_ArgumentType_26_bursts),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_26._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_27_extensions),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_27._ext = []
    _SsfToScfGenericInvokable_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericInvokable_val_ResultType_27._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    SsfToScfGenericInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_15), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_18), (u'ResultType', _SsfToScfGenericInvokable_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_27), (u'ResultType', _SsfToScfGenericInvokable_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_28), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    #-----< SsfToScfGenericReturnable >-----#
    SsfToScfGenericReturnable = CLASS(name=u'SsfToScfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_1._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        (u'tone', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend),
        (u'releaseCause', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'gapCriteria', __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria),
        (u'gapIndicators', __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators),
        (u'controlType', __SsfToScfGenericReturnable_val_ArgumentType_3_controlType),
        (u'gapTreatment', __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_3_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_3._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _SsfToScfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_4_extensions),
        (u'legID', __SsfToScfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_4._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID),
        (u'allRequests', __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_5._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_6_extensions),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _SsfToScfGenericReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_7._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_8._cont = ASN1Dict([
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_8_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_8._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_10_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory),
        (u'genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers),
        (u'cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess),
        (u'chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_10_carrier),
        (u'suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement),
        (u'naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested),
        (u'suppress-O-CSI', __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_10._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_12._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        (u'legToBeReleased', __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased),
        (u'releaseCause', __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_13._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        (u'cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID),
        (u'cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14._cont = ASN1Dict([
        (u'callSegmentFailure', __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure),
        (u'bCSM-Failure', __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_14._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        (u'correlationID', __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID),
        (u'scfID', __SsfToScfGenericReturnable_val_ArgumentType_15_scfID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_15_extensions),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_15_carrier),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID),
        (u'naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo),
        (u'chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber),
        (u'originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID),
        (u'callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_15._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _SsfToScfGenericReturnable_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation),
        (u'cause', __SsfToScfGenericReturnable_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_17_carrier),
        (u'cug-Index', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI),
        (u'subscriberState', __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState),
        (u'locationInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_17._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_18_extensions),
        (u'legToBeCreated', __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_18._ext = []
    _SsfToScfGenericReturnable_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', __SsfToScfGenericReturnable_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericReturnable_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_19._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_20._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_21._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', __SsfToScfGenericReturnable_val_ArgumentType_22_timerID),
        (u'timervalue', __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_22_extensions),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_22._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_23._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_24._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_25_extensions),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_25._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', __SsfToScfGenericReturnable_val_ArgumentType_26_bursts),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_26._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_27_extensions),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_27._ext = []
    _SsfToScfGenericReturnable_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericReturnable_val_ResultType_27._ext = None
    SsfToScfGenericReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_13), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_14), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_18), (u'ResultType', _SsfToScfGenericReturnable_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_27), (u'ResultType', _SsfToScfGenericReturnable_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    
    #-----< assistHandoff-gsmSSF-scfAbstractSyntax >-----#
    assistHandoff_gsmSSF_scfAbstractSyntax = CLASS(name=u'assistHandoff-gsmSSF-scfAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    assistHandoff_gsmSSF_scfAbstractSyntax._val = dict([('Type', _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])
    
    #-----< AssistHandoffsSF-gsmSCF-PDUs >-----#
    AssistHandoffsSF_gsmSCF_PDUs = CHOICE(name=u'AssistHandoffsSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID),
        (u'timervalue', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'ResultType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID),
        (u'timervalue', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'ResultType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        (u'problem', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        (u'operation', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __AssistHandoffsSF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_begin_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __AssistHandoffsSF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_end_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_end._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __AssistHandoffsSF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_continue__components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    AssistHandoffsSF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _AssistHandoffsSF_gsmSCF_PDUs_unidirectional),
        (u'begin', _AssistHandoffsSF_gsmSCF_PDUs_begin),
        (u'end', _AssistHandoffsSF_gsmSCF_PDUs_end),
        (u'continue', _AssistHandoffsSF_gsmSCF_PDUs_continue_),
        (u'abort', _AssistHandoffsSF_gsmSCF_PDUs_abort),
        ])
    AssistHandoffsSF_gsmSCF_PDUs._ext = None
    
    #-----< AssistHandoffssfToScfInvokable >-----#
    AssistHandoffssfToScfInvokable = CLASS(name=u'AssistHandoffssfToScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID),
        (u'allRequests', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfInvokable_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID),
        (u'timervalue', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    AssistHandoffssfToScfInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_6), (u'ResultType', _AssistHandoffssfToScfInvokable_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_8), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    #-----< AssistHandoffssfToScfReturnable >-----#
    AssistHandoffssfToScfReturnable = CLASS(name=u'AssistHandoffssfToScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID),
        (u'allRequests', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfReturnable_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID),
        (u'timervalue', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._ext = []
    AssistHandoffssfToScfReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_6), (u'ResultType', _AssistHandoffssfToScfReturnable_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])
    
    #-----< scf-gsmSSFGenericAbstractSyntax >-----#
    scf_gsmSSFGenericAbstractSyntax = CLASS(name=u'scf-gsmSSFGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _scf_gsmSSFGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    scf_gsmSSFGenericAbstractSyntax._val = dict([('Type', _scf_gsmSSFGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])
    
    #-----< GenericSCF-gsmSSF-PDUs >-----#
    GenericSCF_gsmSSF_PDUs = CHOICE(name=u'GenericSCF-gsmSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSCF_gsmSSF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationTypeList', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'legID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'invokeID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID),
        (u'allRequests', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests),
        (u'callSegmentToCancel', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory),
        (u'genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers),
        (u'cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess),
        (u'chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber),
        (u'carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier),
        (u'suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement),
        (u'naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        (u'correlationID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID),
        (u'scfID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions),
        (u'carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID),
        (u'naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo),
        (u'chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber),
        (u'originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID),
        (u'callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        (u'legToBeCreated', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'legOrCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment),
        (u'bursts', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'allCallSegments', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments),
        (u'allCallSegmentsWithExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'bcsmEvents', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'timerID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID),
        (u'timervalue', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'legToBeSplit', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit),
        (u'newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend),
        (u'disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo),
        (u'tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'collectedInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo),
        (u'disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden),
        (u'informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._cont = ASN1Dict([
        (u'digitsResponse', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._ext = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), (u'ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), (u'ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        (u'allRequests', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'legToBeReleased', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased),
        (u'releaseCause', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        (u'cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID),
        (u'cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentFailure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure),
        (u'bCSM-Failure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        (u'correlationID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID),
        (u'scfID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        (u'carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier),
        (u'serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        (u'naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo),
        (u'chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber),
        (u'originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID),
        (u'callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'eventTypeBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID),
        (u'miscCallInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        (u'legToBeCreated', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        (u'legID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'bcsmEvents', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'timerID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID),
        (u'timervalue', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'legToBeSplit', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit),
        (u'newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo),
        (u'tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend),
        (u'disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment),
        (u'bursts', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'collectedInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo),
        (u'disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._cont = ASN1Dict([
        (u'digitsResponse', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), (u'ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), (u'ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        (u'problem', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        (u'operation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._cont = ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_unidirectional_components),
        ])
    _GenericSCF_gsmSSF_PDUs_unidirectional._ext = None
    _GenericSCF_gsmSSF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSCF_gsmSSF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_begin_components._cont = ___GenericSCF_gsmSSF_PDUs_begin_components__item_
    __GenericSCF_gsmSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericSCF_gsmSSF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_begin_components),
        ])
    _GenericSCF_gsmSSF_PDUs_begin._ext = None
    _GenericSCF_gsmSSF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSCF_gsmSSF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_end_components._cont = ___GenericSCF_gsmSSF_PDUs_end_components__item_
    __GenericSCF_gsmSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericSCF_gsmSSF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_end_dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_end_components),
        ])
    _GenericSCF_gsmSSF_PDUs_end._ext = None
    _GenericSCF_gsmSSF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSCF_gsmSSF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_continue__components._cont = ___GenericSCF_gsmSSF_PDUs_continue__components__item_
    __GenericSCF_gsmSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericSCF_gsmSSF_PDUs_continue__otid),
        (u'dtid', __GenericSCF_gsmSSF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_continue__components),
        ])
    _GenericSCF_gsmSSF_PDUs_continue_._ext = None
    _GenericSCF_gsmSSF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSCF_gsmSSF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericSCF_gsmSSF_PDUs_unidirectional),
        (u'begin', _GenericSCF_gsmSSF_PDUs_begin),
        (u'end', _GenericSCF_gsmSSF_PDUs_end),
        (u'continue', _GenericSCF_gsmSSF_PDUs_continue_),
        (u'abort', _GenericSCF_gsmSSF_PDUs_abort),
        ])
    GenericSCF_gsmSSF_PDUs._ext = None
    
    #-----< ScfToSsfGenericInvokable >-----#
    ScfToSsfGenericInvokable = CLASS(name=u'ScfToSsfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _ScfToSsfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationTypeList', __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions),
        (u'legID', __ScfToSsfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'invokeID', __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID),
        (u'allRequests', __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests),
        (u'callSegmentToCancel', __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_4._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions),
        (u'carrier', __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _ScfToSsfGenericInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory),
        (u'genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers),
        (u'cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock),
        (u'cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess),
        (u'chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber),
        (u'carrier', __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier),
        (u'suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement),
        (u'naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo),
        (u'bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        (u'correlationID', __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID),
        (u'scfID', __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions),
        (u'carrier', __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID),
        (u'naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo),
        (u'chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber),
        (u'originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID),
        (u'callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _ScfToSsfGenericInvokable_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions),
        (u'legToBeCreated', __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', __ScfToSsfGenericInvokable_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    _ScfToSsfGenericInvokable_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        (u'legID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        (u'legOrCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment),
        (u'bursts', __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_18 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        (u'allCallSegments', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments),
        (u'allCallSegmentsWithExtension', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_18._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        (u'legID', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._ext = []
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        (u'bcsmEvents', __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        (u'timerID', __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID),
        (u'timervalue', __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        (u'legToBeSplit', __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit),
        (u'newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        (u'informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        (u'collectedInfo', __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden),
        (u'informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_24._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_24 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ResultType_24._cont = ASN1Dict([
        (u'digitsResponse', __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_24._ext = None
    ScfToSsfGenericInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_15), (u'ResultType', _ScfToSsfGenericInvokable_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_18), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_22), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_24), (u'ResultType', _ScfToSsfGenericInvokable_val_ResultType_24), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    
    #-----< ScfToSsfGenericReturnable >-----#
    ScfToSsfGenericReturnable = CLASS(name=u'ScfToSsfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions),
        (u'legID', __ScfToSsfGenericReturnable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions),
        (u'legID', __ScfToSsfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_4._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID),
        (u'allRequests', __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_5._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions),
        (u'carrier', __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _ScfToSsfGenericReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._cont = ASN1Dict([
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'legToBeReleased', __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased),
        (u'releaseCause', __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        (u'cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID),
        (u'cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentFailure', __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure),
        (u'bCSM-Failure', __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_11._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        (u'correlationID', __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID),
        (u'scfID', __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions),
        (u'carrier', __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID),
        (u'naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo),
        (u'chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber),
        (u'originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID),
        (u'callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _ScfToSsfGenericReturnable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_13_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        (u'eventTypeBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM),
        (u'legID', __ScfToSsfGenericReturnable_val_ArgumentType_13_legID),
        (u'miscCallInfo', __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions),
        (u'legToBeCreated', __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', __ScfToSsfGenericReturnable_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    _ScfToSsfGenericReturnable_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        (u'legID', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        (u'bcsmEvents', __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        (u'timerID', __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID),
        (u'timervalue', __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        (u'legToBeSplit', __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit),
        (u'newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        (u'informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        (u'legID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        (u'legOrCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment),
        (u'bursts', __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        (u'collectedInfo', __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_23 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ResultType_23._cont = ASN1Dict([
        (u'digitsResponse', __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_23._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_24 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ScfToSsfGenericReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_10), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_11), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_15), (u'ResultType', _ScfToSsfGenericReturnable_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_20), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_23), (u'ResultType', _ScfToSsfGenericReturnable_val_ResultType_23), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    _all_ = [
        capssf_scfGenericAC,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cGEncountered,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_bearerCapability,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_redirectionInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Index,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_subscriberState,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_locationInformation,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        __OPERATION_Errors_val_ParameterType_2_0,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_1,
        __OPERATION_Errors_val_ParameterType_7,
        __OPERATION_Errors_val_ParameterType_8,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_0,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_10,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__11,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___12,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____13,
        __OPERATION_Linked_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_1,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_2,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____14,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______15,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapCriteria,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapIndicators,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_controlType,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        __________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______16,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________17,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        capssf_scfAssistHandoffAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________18,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________19,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_3,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________20,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________21,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_4,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_0_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________22,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0,
        capscf_ssfGenericAC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_correlationID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_scfID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________23,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________24,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_legID,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_3,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________25,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________26,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27_legID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________27,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ______OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_extensions,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4_legID,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_invokeID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_allRequests,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________28,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_extensions,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________29,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_5,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________30,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0______________________31,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_legToBeReleased,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_releaseCause,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_5,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_legIDToMove,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_2_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_legToBeSplit,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_newCallSegment,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_3_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_6,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_______________________32,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_bursts,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0________________________33,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_________________________34,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_supportedCamelPhases,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ____OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        __OPERATION_PACKAGE_Supplier_val_ResultType_0_0,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0__________________________35,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_collectedInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_informationToSend,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_callSegmentID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_7,
        ___OPERATION_PACKAGE_Supplier_val_ResultType_1_1_digitsResponse,
        __OPERATION_PACKAGE_Supplier_val_ResultType_1_1,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0___________________________36,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_alertingPattern,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_genericNumbers,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_Interlock,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_chargeNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_carrier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_naOliInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_1_8,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0____________________________37,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_____________________________38,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1,
        capSsfToScfGeneric,
        capAssistHandoffssfToScf,
        capScfToSsfGeneric,
        activityTestPackage,
        gsmSSF_scfGenericAbstractSyntax,
        _gsmSSF_scfGenericAbstractSyntax_val_Type,
        __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericSSF_gsmSCF_PDUs_unidirectional,
        __GenericSSF_gsmSCF_PDUs_begin_otid,
        __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericSSF_gsmSCF_PDUs_begin_components,
        _GenericSSF_gsmSCF_PDUs_begin,
        __GenericSSF_gsmSCF_PDUs_end_dtid,
        __GenericSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_end_components__item_,
        __GenericSSF_gsmSCF_PDUs_end_components,
        _GenericSSF_gsmSCF_PDUs_end,
        __GenericSSF_gsmSCF_PDUs_continue__otid,
        __GenericSSF_gsmSCF_PDUs_continue__dtid,
        __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericSSF_gsmSCF_PDUs_continue__components,
        _GenericSSF_gsmSCF_PDUs_continue_,
        _GenericSSF_gsmSCF_PDUs_abort,
        GenericSSF_gsmSCF_PDUs,
        SsfToScfGenericInvokable,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericInvokable_val_ArgumentType_1,
        _SsfToScfGenericInvokable_val_ArgumentType_2,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_3_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_3,
        __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_4_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_4_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_4,
        __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericInvokable_val_ArgumentType_5,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_6_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_6,
        __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_7_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_7,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none,
        __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_8_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_8,
        ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_9_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_9,
        __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_11_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_11,
        __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_12_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_12,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure,
        _SsfToScfGenericInvokable_val_ArgumentType_13,
        __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_scfID,
        ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_14_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_14_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber,
        _SsfToScfGenericInvokable_val_ArgumentType_14,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_15_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_15_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_15,
        _SsfToScfGenericInvokable_val_ArgumentType_16,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_17_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_17_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_17,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_18,
        __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ResultType_18_extensions,
        __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericInvokable_val_ResultType_18,
        __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_19_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_19,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_20,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_21,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timerID,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_22_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_22,
        __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_23_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_23,
        __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_24_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_24,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_25_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_25,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_26_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_26,
        __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_27_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_27,
        __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericInvokable_val_ResultType_27,
        _SsfToScfGenericInvokable_val_ArgumentType_28,
        SsfToScfGenericReturnable,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericReturnable_val_ArgumentType_1,
        _SsfToScfGenericReturnable_val_ArgumentType_2,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators,
        __SsfToScfGenericReturnable_val_ArgumentType_3_controlType,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_3_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_3,
        __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_4_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_4_legID,
        _SsfToScfGenericReturnable_val_ArgumentType_4,
        __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericReturnable_val_ArgumentType_5,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_6_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_6,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_7_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_7,
        ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_8_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_8,
        __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_10_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_10,
        __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_12_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_12,
        __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased,
        __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause,
        ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_13_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_13,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure,
        _SsfToScfGenericReturnable_val_ArgumentType_14,
        __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_15_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_15_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        _SsfToScfGenericReturnable_val_ArgumentType_15,
        _SsfToScfGenericReturnable_val_ArgumentType_16,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_17_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_17_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_17,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_18,
        __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ResultType_18_extensions,
        __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericReturnable_val_ResultType_18,
        __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_19_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_19,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_20,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_21,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timerID,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_22_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_22,
        __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_23_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_23,
        __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_24_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_24,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_25_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_25,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_26_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_26,
        __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_27_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_27,
        __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericReturnable_val_ResultType_27,
        assistHandoff_gsmSSF_scfAbstractSyntax,
        _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components,
        _AssistHandoffsSF_gsmSCF_PDUs_unidirectional,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_otid,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_components,
        _AssistHandoffsSF_gsmSCF_PDUs_begin,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_end_components,
        _AssistHandoffsSF_gsmSCF_PDUs_end,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__otid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__components,
        _AssistHandoffsSF_gsmSCF_PDUs_continue_,
        _AssistHandoffsSF_gsmSCF_PDUs_abort,
        AssistHandoffsSF_gsmSCF_PDUs,
        AssistHandoffssfToScfInvokable,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_1,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_2,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_3,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_5,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_6,
        __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfInvokable_val_ResultType_6,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_7,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_8,
        AssistHandoffssfToScfReturnable,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_1,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_2,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_3,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_5,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_6,
        __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfReturnable_val_ResultType_6,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_7,
        scf_gsmSSFGenericAbstractSyntax,
        _scf_gsmSSFGenericAbstractSyntax_val_Type,
        __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_,
        __GenericSCF_gsmSSF_PDUs_unidirectional_components,
        _GenericSCF_gsmSSF_PDUs_unidirectional,
        __GenericSCF_gsmSSF_PDUs_begin_otid,
        __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_begin_components__item_,
        __GenericSCF_gsmSSF_PDUs_begin_components,
        _GenericSCF_gsmSSF_PDUs_begin,
        __GenericSCF_gsmSSF_PDUs_end_dtid,
        __GenericSCF_gsmSSF_PDUs_end_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_end_components__item_,
        __GenericSCF_gsmSSF_PDUs_end_components,
        _GenericSCF_gsmSSF_PDUs_end,
        __GenericSCF_gsmSSF_PDUs_continue__otid,
        __GenericSCF_gsmSSF_PDUs_continue__dtid,
        __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_continue__components__item_,
        __GenericSCF_gsmSSF_PDUs_continue__components,
        _GenericSCF_gsmSSF_PDUs_continue_,
        _GenericSCF_gsmSSF_PDUs_abort,
        GenericSCF_gsmSSF_PDUs,
        ScfToSsfGenericInvokable,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericInvokable_val_ArgumentType_1,
        _ScfToSsfGenericInvokable_val_ArgumentType_2,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList,
        ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_legID,
        _ScfToSsfGenericInvokable_val_ArgumentType_3,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel,
        _ScfToSsfGenericInvokable_val_ArgumentType_4,
        ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_5,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_6,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_7,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_9,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_11,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_12,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber,
        _ScfToSsfGenericInvokable_val_ArgumentType_13,
        _ScfToSsfGenericInvokable_val_ArgumentType_14,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_15,
        __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ResultType_15_extensions,
        __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericInvokable_val_ResultType_15,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_16,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_17,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_18,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_19,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue,
        ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_20,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_21,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment,
        ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_22,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_23,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_24,
        __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse,
        _ScfToSsfGenericInvokable_val_ResultType_24,
        ScfToSsfGenericReturnable,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericReturnable_val_ArgumentType_1,
        _ScfToSsfGenericReturnable_val_ArgumentType_2,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_3,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_4,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _ScfToSsfGenericReturnable_val_ArgumentType_5,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_6,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_7,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_9,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_10,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure,
        _ScfToSsfGenericReturnable_val_ArgumentType_11,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber,
        _ScfToSsfGenericReturnable_val_ArgumentType_12,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_13,
        _ScfToSsfGenericReturnable_val_ArgumentType_14,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_15,
        __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ResultType_15_extensions,
        __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericReturnable_val_ResultType_15,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_16,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_17,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_18,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_19,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment,
        ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_20,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_21,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_22,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_23,
        __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse,
        _ScfToSsfGenericReturnable_val_ResultType_23,
        _ScfToSsfGenericReturnable_val_ArgumentType_24,
    ]

class CAP_object_identifiers:

    _name_  = u'CAP-object-identifiers'
    _oid_   = [0, 4, 0, 0, 1, 3, 100, 7]
    
    _obj_ = [
        u'tc-Messages',
        u'tc-NotationExtensions',
        u'ros-InformationObjects',
        u'datatypes',
        u'errortypes',
        u'operationcodes',
        u'errorcodes',
        u'classes',
        u'gsmSSF-gsmSCF-Operations',
        u'gsmSSF-gsmSCF-Protocol',
        u'gsmSCF-gsmSRF-Operations',
        u'gsmSCF-gsmSRF-Protocol',
        u'sms-Operations',
        u'smsSSF-gsmSCF-Protocol',
        u'gprsSSF-gsmSCF-Operations',
        u'gprsSSF-gsmSCF-Protocol',
        u'id-CAP',
        u'id-CAP3',
        u'id-CAPOE',
        u'id-CAP3OE',
        u'id-ac',
        u'id-acE',
        u'id-ac3E',
        u'id-as',
        u'id-asE',
        u'id-rosObject',
        u'id-contract',
        u'id-contract3',
        u'id-contractE',
        u'id-package',
        u'id-packageE',
        u'id-rosObject-gsmSCF',
        u'id-rosObject-gsmSSF',
        u'id-rosObject-gsmSRF',
        u'id-rosObject-gprsSSF',
        u'id-rosObject-smsSSF-V3',
        u'id-rosObject-smsSSF-V4',
        u'id-ac-CAP-gsmSSF-scfGenericAC',
        u'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        u'id-ac-CAP-scf-gsmSSFGenericAC',
        u'id-ac-gsmSRF-gsmSCF',
        u'id-ac-CAP-gprsSSF-gsmSCF-AC',
        u'id-ac-CAP-gsmSCF-gprsSSF-AC',
        u'id-ac-cap3-sms-AC',
        u'id-ac-cap4-sms-AC',
        u'id-CAPSsfToScfGeneric',
        u'id-CAPAssistHandoffssfToScf',
        u'id-CAPScfToSsfGeneric',
        u'id-contract-gsmSRF-gsmSCF',
        u'id-capGprsSsfTogsmScf',
        u'id-capGsmScfToGprsSsf',
        u'id-cap3SmsSsfTogsmScf',
        u'id-cap4SmsSsfTogsmScf',
        u'id-package-scfActivation',
        u'id-package-gsmSRF-scfActivationOfAssist',
        u'id-package-assistConnectionEstablishment',
        u'id-package-genericDisconnectResource',
        u'id-package-nonAssistedConnectionEstablishment',
        u'id-package-connect',
        u'id-package-callHandling',
        u'id-package-bcsmEventHandling',
        u'id-package-ssfCallProcessing',
        u'id-package-scfCallInitiation',
        u'id-package-timer',
        u'id-package-billing',
        u'id-package-charging',
        u'id-package-trafficManagement',
        u'id-package-callReport',
        u'id-package-signallingControl',
        u'id-package-activityTest',
        u'id-package-cancel',
        u'id-package-cphResponse',
        u'id-package-exceptionInform',
        u'id-package-playTone',
        u'id-package-specializedResourceControl',
        u'id-package-gsmSRF-scfCancel',
        u'id-package-gprsContinue',
        u'id-package-gprsExceptionInformation',
        u'id-package-gprsScfActivation',
        u'id-package-gprsConnect',
        u'id-package-gprsRelease',
        u'id-package-gprsEventHandling',
        u'id-package-gprsTimer',
        u'id-package-gprsBilling',
        u'id-package-gprsCharging',
        u'id-package-gprsActivityTest',
        u'id-package-gprsCancel',
        u'id-package-gprsChargeAdvice',
        u'id-package-smsActivation',
        u'id-package-smsConnect',
        u'id-package-smsContinue',
        u'id-package-smsRelease',
        u'id-package-smsEventHandling',
        u'id-package-smsBilling',
        u'id-package-smsTimer',
        u'id-as-gsmSSF-scfGenericAS',
        u'id-as-assistHandoff-gsmSSF-scfAS',
        u'id-as-scf-gsmSSFGenericAS',
        u'id-as-basic-gsmSRF-gsmSCF',
        u'id-as-gprsSSF-gsmSCF-AS',
        u'id-as-gsmSCF-gprsSSF-AS',
        u'id-as-smsSSF-gsmSCF-AS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'tc-Messages',
        u'tc-NotationExtensions',
        u'ros-InformationObjects',
        u'datatypes',
        u'errortypes',
        u'operationcodes',
        u'errorcodes',
        u'classes',
        u'gsmSSF-gsmSCF-Operations',
        u'gsmSSF-gsmSCF-Protocol',
        u'gsmSCF-gsmSRF-Operations',
        u'gsmSCF-gsmSRF-Protocol',
        u'sms-Operations',
        u'smsSSF-gsmSCF-Protocol',
        u'gprsSSF-gsmSCF-Operations',
        u'gprsSSF-gsmSCF-Protocol',
        u'id-CAP',
        u'id-CAP3',
        u'id-CAPOE',
        u'id-CAP3OE',
        u'id-ac',
        u'id-acE',
        u'id-ac3E',
        u'id-as',
        u'id-asE',
        u'id-rosObject',
        u'id-contract',
        u'id-contract3',
        u'id-contractE',
        u'id-package',
        u'id-packageE',
        u'id-rosObject-gsmSCF',
        u'id-rosObject-gsmSSF',
        u'id-rosObject-gsmSRF',
        u'id-rosObject-gprsSSF',
        u'id-rosObject-smsSSF-V3',
        u'id-rosObject-smsSSF-V4',
        u'id-ac-CAP-gsmSSF-scfGenericAC',
        u'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        u'id-ac-CAP-scf-gsmSSFGenericAC',
        u'id-ac-gsmSRF-gsmSCF',
        u'id-ac-CAP-gprsSSF-gsmSCF-AC',
        u'id-ac-CAP-gsmSCF-gprsSSF-AC',
        u'id-ac-cap3-sms-AC',
        u'id-ac-cap4-sms-AC',
        u'id-CAPSsfToScfGeneric',
        u'id-CAPAssistHandoffssfToScf',
        u'id-CAPScfToSsfGeneric',
        u'id-contract-gsmSRF-gsmSCF',
        u'id-capGprsSsfTogsmScf',
        u'id-capGsmScfToGprsSsf',
        u'id-cap3SmsSsfTogsmScf',
        u'id-cap4SmsSsfTogsmScf',
        u'id-package-scfActivation',
        u'id-package-gsmSRF-scfActivationOfAssist',
        u'id-package-assistConnectionEstablishment',
        u'id-package-genericDisconnectResource',
        u'id-package-nonAssistedConnectionEstablishment',
        u'id-package-connect',
        u'id-package-callHandling',
        u'id-package-bcsmEventHandling',
        u'id-package-ssfCallProcessing',
        u'id-package-scfCallInitiation',
        u'id-package-timer',
        u'id-package-billing',
        u'id-package-charging',
        u'id-package-trafficManagement',
        u'id-package-callReport',
        u'id-package-signallingControl',
        u'id-package-activityTest',
        u'id-package-cancel',
        u'id-package-cphResponse',
        u'id-package-exceptionInform',
        u'id-package-playTone',
        u'id-package-specializedResourceControl',
        u'id-package-gsmSRF-scfCancel',
        u'id-package-gprsContinue',
        u'id-package-gprsExceptionInformation',
        u'id-package-gprsScfActivation',
        u'id-package-gprsConnect',
        u'id-package-gprsRelease',
        u'id-package-gprsEventHandling',
        u'id-package-gprsTimer',
        u'id-package-gprsBilling',
        u'id-package-gprsCharging',
        u'id-package-gprsActivityTest',
        u'id-package-gprsCancel',
        u'id-package-gprsChargeAdvice',
        u'id-package-smsActivation',
        u'id-package-smsConnect',
        u'id-package-smsContinue',
        u'id-package-smsRelease',
        u'id-package-smsEventHandling',
        u'id-package-smsBilling',
        u'id-package-smsTimer',
        u'id-as-gsmSSF-scfGenericAS',
        u'id-as-assistHandoff-gsmSSF-scfAS',
        u'id-as-scf-gsmSSFGenericAS',
        u'id-as-basic-gsmSRF-gsmSCF',
        u'id-as-gprsSSF-gsmSCF-AS',
        u'id-as-gsmSCF-gprsSSF-AS',
        u'id-as-smsSSF-gsmSCF-AS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< tc-Messages >-----#
    tc_Messages = OID(name=u'tc-Messages', mode=MODE_VALUE)
    tc_Messages._val = (0, 0, 17, 773, 2, 1, 3)
    
    #-----< tc-NotationExtensions >-----#
    tc_NotationExtensions = OID(name=u'tc-NotationExtensions', mode=MODE_VALUE)
    tc_NotationExtensions._val = (0, 0, 17, 775, 2, 4, 1)
    
    #-----< ros-InformationObjects >-----#
    ros_InformationObjects = OID(name=u'ros-InformationObjects', mode=MODE_VALUE)
    ros_InformationObjects._val = (2, 4, 5, 0)
    
    #-----< datatypes >-----#
    datatypes = OID(name=u'datatypes', mode=MODE_VALUE)
    datatypes._val = (0, 4, 0, 0, 1, 3, 52, 7)
    
    #-----< errortypes >-----#
    errortypes = OID(name=u'errortypes', mode=MODE_VALUE)
    errortypes._val = (0, 4, 0, 0, 1, 3, 51, 7)
    
    #-----< operationcodes >-----#
    operationcodes = OID(name=u'operationcodes', mode=MODE_VALUE)
    operationcodes._val = (0, 4, 0, 0, 1, 3, 53, 7)
    
    #-----< errorcodes >-----#
    errorcodes = OID(name=u'errorcodes', mode=MODE_VALUE)
    errorcodes._val = (0, 4, 0, 0, 1, 3, 57, 7)
    
    #-----< classes >-----#
    classes = OID(name=u'classes', mode=MODE_VALUE)
    classes._val = (0, 4, 0, 0, 1, 3, 54, 7)
    
    #-----< gsmSSF-gsmSCF-Operations >-----#
    gsmSSF_gsmSCF_Operations = OID(name=u'gsmSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 101, 7)
    
    #-----< gsmSSF-gsmSCF-Protocol >-----#
    gsmSSF_gsmSCF_Protocol = OID(name=u'gsmSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 102, 7)
    
    #-----< gsmSCF-gsmSRF-Operations >-----#
    gsmSCF_gsmSRF_Operations = OID(name=u'gsmSCF-gsmSRF-Operations', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Operations._val = (0, 4, 0, 0, 1, 3, 103, 7)
    
    #-----< gsmSCF-gsmSRF-Protocol >-----#
    gsmSCF_gsmSRF_Protocol = OID(name=u'gsmSCF-gsmSRF-Protocol', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Protocol._val = (0, 4, 0, 0, 1, 3, 104, 7)
    
    #-----< sms-Operations >-----#
    sms_Operations = OID(name=u'sms-Operations', mode=MODE_VALUE)
    sms_Operations._val = (0, 4, 0, 0, 1, 3, 105, 7)
    
    #-----< smsSSF-gsmSCF-Protocol >-----#
    smsSSF_gsmSCF_Protocol = OID(name=u'smsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    smsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 106, 7)
    
    #-----< gprsSSF-gsmSCF-Operations >-----#
    gprsSSF_gsmSCF_Operations = OID(name=u'gprsSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 107, 7)
    
    #-----< gprsSSF-gsmSCF-Protocol >-----#
    gprsSSF_gsmSCF_Protocol = OID(name=u'gprsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 108, 7)
    
    #-----< id-CAP >-----#
    id_CAP = OID(name=u'id-CAP', mode=MODE_VALUE)
    id_CAP._val = (0, 4, 0, 0, 1, 22)
    
    #-----< id-CAP3 >-----#
    id_CAP3 = OID(name=u'id-CAP3', mode=MODE_VALUE)
    id_CAP3._val = (0, 4, 0, 0, 1, 20)
    
    #-----< id-CAPOE >-----#
    id_CAPOE = OID(name=u'id-CAPOE', mode=MODE_VALUE)
    id_CAPOE._val = (0, 4, 0, 0, 1, 23)
    
    #-----< id-CAP3OE >-----#
    id_CAP3OE = OID(name=u'id-CAP3OE', mode=MODE_VALUE)
    id_CAP3OE._val = (0, 4, 0, 0, 1, 21)
    
    #-----< id-ac >-----#
    id_ac = OID(name=u'id-ac', mode=MODE_VALUE)
    id_ac._val = (0, 4, 0, 0, 1, 22, 3)
    
    #-----< id-acE >-----#
    id_acE = OID(name=u'id-acE', mode=MODE_VALUE)
    id_acE._val = (0, 4, 0, 0, 1, 23, 3)
    
    #-----< id-ac3E >-----#
    id_ac3E = OID(name=u'id-ac3E', mode=MODE_VALUE)
    id_ac3E._val = (0, 4, 0, 0, 1, 21, 3)
    
    #-----< id-as >-----#
    id_as = OID(name=u'id-as', mode=MODE_VALUE)
    id_as._val = (0, 4, 0, 0, 1, 22, 5)
    
    #-----< id-asE >-----#
    id_asE = OID(name=u'id-asE', mode=MODE_VALUE)
    id_asE._val = (0, 4, 0, 0, 1, 23, 5)
    
    #-----< id-rosObject >-----#
    id_rosObject = OID(name=u'id-rosObject', mode=MODE_VALUE)
    id_rosObject._val = (0, 4, 0, 0, 1, 22, 25)
    
    #-----< id-contract >-----#
    id_contract = OID(name=u'id-contract', mode=MODE_VALUE)
    id_contract._val = (0, 4, 0, 0, 1, 22, 26)
    
    #-----< id-contract3 >-----#
    id_contract3 = OID(name=u'id-contract3', mode=MODE_VALUE)
    id_contract3._val = (0, 4, 0, 0, 1, 20, 26)
    
    #-----< id-contractE >-----#
    id_contractE = OID(name=u'id-contractE', mode=MODE_VALUE)
    id_contractE._val = (0, 4, 0, 0, 1, 23, 26)
    
    #-----< id-package >-----#
    id_package = OID(name=u'id-package', mode=MODE_VALUE)
    id_package._val = (0, 4, 0, 0, 1, 22, 27)
    
    #-----< id-packageE >-----#
    id_packageE = OID(name=u'id-packageE', mode=MODE_VALUE)
    id_packageE._val = (0, 4, 0, 0, 1, 23, 27)
    
    #-----< id-rosObject-gsmSCF >-----#
    id_rosObject_gsmSCF = OID(name=u'id-rosObject-gsmSCF', mode=MODE_VALUE)
    id_rosObject_gsmSCF._val = (0, 4, 0, 0, 1, 22, 25, 4)
    
    #-----< id-rosObject-gsmSSF >-----#
    id_rosObject_gsmSSF = OID(name=u'id-rosObject-gsmSSF', mode=MODE_VALUE)
    id_rosObject_gsmSSF._val = (0, 4, 0, 0, 1, 22, 25, 5)
    
    #-----< id-rosObject-gsmSRF >-----#
    id_rosObject_gsmSRF = OID(name=u'id-rosObject-gsmSRF', mode=MODE_VALUE)
    id_rosObject_gsmSRF._val = (0, 4, 0, 0, 1, 22, 25, 6)
    
    #-----< id-rosObject-gprsSSF >-----#
    id_rosObject_gprsSSF = OID(name=u'id-rosObject-gprsSSF', mode=MODE_VALUE)
    id_rosObject_gprsSSF._val = (0, 4, 0, 0, 1, 22, 25, 7)
    
    #-----< id-rosObject-smsSSF-V3 >-----#
    id_rosObject_smsSSF_V3 = OID(name=u'id-rosObject-smsSSF-V3', mode=MODE_VALUE)
    id_rosObject_smsSSF_V3._val = (0, 4, 0, 0, 1, 22, 25, 8)
    
    #-----< id-rosObject-smsSSF-V4 >-----#
    id_rosObject_smsSSF_V4 = OID(name=u'id-rosObject-smsSSF-V4', mode=MODE_VALUE)
    id_rosObject_smsSSF_V4._val = (0, 4, 0, 0, 1, 22, 25, 9)
    
    #-----< id-ac-CAP-gsmSSF-scfGenericAC >-----#
    id_ac_CAP_gsmSSF_scfGenericAC = OID(name=u'id-ac-CAP-gsmSSF-scfGenericAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 4)
    
    #-----< id-ac-CAP-gsmSSF-scfAssistHandoffAC >-----#
    id_ac_CAP_gsmSSF_scfAssistHandoffAC = OID(name=u'id-ac-CAP-gsmSSF-scfAssistHandoffAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfAssistHandoffAC._val = (0, 4, 0, 0, 1, 23, 3, 6)
    
    #-----< id-ac-CAP-scf-gsmSSFGenericAC >-----#
    id_ac_CAP_scf_gsmSSFGenericAC = OID(name=u'id-ac-CAP-scf-gsmSSFGenericAC', mode=MODE_VALUE)
    id_ac_CAP_scf_gsmSSFGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 8)
    
    #-----< id-ac-gsmSRF-gsmSCF >-----#
    id_ac_gsmSRF_gsmSCF = OID(name=u'id-ac-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_ac_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 3, 14)
    
    #-----< id-ac-CAP-gprsSSF-gsmSCF-AC >-----#
    id_ac_CAP_gprsSSF_gsmSCF_AC = OID(name=u'id-ac-CAP-gprsSSF-gsmSCF-AC', mode=MODE_VALUE)
    id_ac_CAP_gprsSSF_gsmSCF_AC._val = (0, 4, 0, 0, 1, 21, 3, 50)
    
    #-----< id-ac-CAP-gsmSCF-gprsSSF-AC >-----#
    id_ac_CAP_gsmSCF_gprsSSF_AC = OID(name=u'id-ac-CAP-gsmSCF-gprsSSF-AC', mode=MODE_VALUE)
    id_ac_CAP_gsmSCF_gprsSSF_AC._val = (0, 4, 0, 0, 1, 21, 3, 51)
    
    #-----< id-ac-cap3-sms-AC >-----#
    id_ac_cap3_sms_AC = OID(name=u'id-ac-cap3-sms-AC', mode=MODE_VALUE)
    id_ac_cap3_sms_AC._val = (0, 4, 0, 0, 1, 21, 3, 61)
    
    #-----< id-ac-cap4-sms-AC >-----#
    id_ac_cap4_sms_AC = OID(name=u'id-ac-cap4-sms-AC', mode=MODE_VALUE)
    id_ac_cap4_sms_AC._val = (0, 4, 0, 0, 1, 23, 3, 61)
    
    #-----< id-CAPSsfToScfGeneric >-----#
    id_CAPSsfToScfGeneric = OID(name=u'id-CAPSsfToScfGeneric', mode=MODE_VALUE)
    id_CAPSsfToScfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 3)
    
    #-----< id-CAPAssistHandoffssfToScf >-----#
    id_CAPAssistHandoffssfToScf = OID(name=u'id-CAPAssistHandoffssfToScf', mode=MODE_VALUE)
    id_CAPAssistHandoffssfToScf._val = (0, 4, 0, 0, 1, 23, 26, 5)
    
    #-----< id-CAPScfToSsfGeneric >-----#
    id_CAPScfToSsfGeneric = OID(name=u'id-CAPScfToSsfGeneric', mode=MODE_VALUE)
    id_CAPScfToSsfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 6)
    
    #-----< id-contract-gsmSRF-gsmSCF >-----#
    id_contract_gsmSRF_gsmSCF = OID(name=u'id-contract-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_contract_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 26, 13)
    
    #-----< id-capGprsSsfTogsmScf >-----#
    id_capGprsSsfTogsmScf = OID(name=u'id-capGprsSsfTogsmScf', mode=MODE_VALUE)
    id_capGprsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 14)
    
    #-----< id-capGsmScfToGprsSsf >-----#
    id_capGsmScfToGprsSsf = OID(name=u'id-capGsmScfToGprsSsf', mode=MODE_VALUE)
    id_capGsmScfToGprsSsf._val = (0, 4, 0, 0, 1, 22, 26, 15)
    
    #-----< id-cap3SmsSsfTogsmScf >-----#
    id_cap3SmsSsfTogsmScf = OID(name=u'id-cap3SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap3SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 20, 26, 16)
    
    #-----< id-cap4SmsSsfTogsmScf >-----#
    id_cap4SmsSsfTogsmScf = OID(name=u'id-cap4SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap4SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 16)
    
    #-----< id-package-scfActivation >-----#
    id_package_scfActivation = OID(name=u'id-package-scfActivation', mode=MODE_VALUE)
    id_package_scfActivation._val = (0, 4, 0, 0, 1, 22, 27, 11)
    
    #-----< id-package-gsmSRF-scfActivationOfAssist >-----#
    id_package_gsmSRF_scfActivationOfAssist = OID(name=u'id-package-gsmSRF-scfActivationOfAssist', mode=MODE_VALUE)
    id_package_gsmSRF_scfActivationOfAssist._val = (0, 4, 0, 0, 1, 22, 27, 15)
    
    #-----< id-package-assistConnectionEstablishment >-----#
    id_package_assistConnectionEstablishment = OID(name=u'id-package-assistConnectionEstablishment', mode=MODE_VALUE)
    id_package_assistConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 16)
    
    #-----< id-package-genericDisconnectResource >-----#
    id_package_genericDisconnectResource = OID(name=u'id-package-genericDisconnectResource', mode=MODE_VALUE)
    id_package_genericDisconnectResource._val = (0, 4, 0, 0, 1, 22, 27, 17)
    
    #-----< id-package-nonAssistedConnectionEstablishment >-----#
    id_package_nonAssistedConnectionEstablishment = OID(name=u'id-package-nonAssistedConnectionEstablishment', mode=MODE_VALUE)
    id_package_nonAssistedConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 18)
    
    #-----< id-package-connect >-----#
    id_package_connect = OID(name=u'id-package-connect', mode=MODE_VALUE)
    id_package_connect._val = (0, 4, 0, 0, 1, 22, 27, 19)
    
    #-----< id-package-callHandling >-----#
    id_package_callHandling = OID(name=u'id-package-callHandling', mode=MODE_VALUE)
    id_package_callHandling._val = (0, 4, 0, 0, 1, 23, 27, 20)
    
    #-----< id-package-bcsmEventHandling >-----#
    id_package_bcsmEventHandling = OID(name=u'id-package-bcsmEventHandling', mode=MODE_VALUE)
    id_package_bcsmEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 21)
    
    #-----< id-package-ssfCallProcessing >-----#
    id_package_ssfCallProcessing = OID(name=u'id-package-ssfCallProcessing', mode=MODE_VALUE)
    id_package_ssfCallProcessing._val = (0, 4, 0, 0, 1, 23, 27, 24)
    
    #-----< id-package-scfCallInitiation >-----#
    id_package_scfCallInitiation = OID(name=u'id-package-scfCallInitiation', mode=MODE_VALUE)
    id_package_scfCallInitiation._val = (0, 4, 0, 0, 1, 22, 27, 25)
    
    #-----< id-package-timer >-----#
    id_package_timer = OID(name=u'id-package-timer', mode=MODE_VALUE)
    id_package_timer._val = (0, 4, 0, 0, 1, 22, 27, 26)
    
    #-----< id-package-billing >-----#
    id_package_billing = OID(name=u'id-package-billing', mode=MODE_VALUE)
    id_package_billing._val = (0, 4, 0, 0, 1, 22, 27, 27)
    
    #-----< id-package-charging >-----#
    id_package_charging = OID(name=u'id-package-charging', mode=MODE_VALUE)
    id_package_charging._val = (0, 4, 0, 0, 1, 22, 27, 28)
    
    #-----< id-package-trafficManagement >-----#
    id_package_trafficManagement = OID(name=u'id-package-trafficManagement', mode=MODE_VALUE)
    id_package_trafficManagement._val = (0, 4, 0, 0, 1, 22, 27, 29)
    
    #-----< id-package-callReport >-----#
    id_package_callReport = OID(name=u'id-package-callReport', mode=MODE_VALUE)
    id_package_callReport._val = (0, 4, 0, 0, 1, 22, 27, 32)
    
    #-----< id-package-signallingControl >-----#
    id_package_signallingControl = OID(name=u'id-package-signallingControl', mode=MODE_VALUE)
    id_package_signallingControl._val = (0, 4, 0, 0, 1, 22, 27, 33)
    
    #-----< id-package-activityTest >-----#
    id_package_activityTest = OID(name=u'id-package-activityTest', mode=MODE_VALUE)
    id_package_activityTest._val = (0, 4, 0, 0, 1, 22, 27, 34)
    
    #-----< id-package-cancel >-----#
    id_package_cancel = OID(name=u'id-package-cancel', mode=MODE_VALUE)
    id_package_cancel._val = (0, 4, 0, 0, 1, 23, 27, 36)
    
    #-----< id-package-cphResponse >-----#
    id_package_cphResponse = OID(name=u'id-package-cphResponse', mode=MODE_VALUE)
    id_package_cphResponse._val = (0, 4, 0, 0, 1, 22, 27, 37)
    
    #-----< id-package-exceptionInform >-----#
    id_package_exceptionInform = OID(name=u'id-package-exceptionInform', mode=MODE_VALUE)
    id_package_exceptionInform._val = (0, 4, 0, 0, 1, 22, 27, 38)
    
    #-----< id-package-playTone >-----#
    id_package_playTone = OID(name=u'id-package-playTone', mode=MODE_VALUE)
    id_package_playTone._val = (0, 4, 0, 0, 1, 22, 27, 39)
    
    #-----< id-package-specializedResourceControl >-----#
    id_package_specializedResourceControl = OID(name=u'id-package-specializedResourceControl', mode=MODE_VALUE)
    id_package_specializedResourceControl._val = (0, 4, 0, 0, 1, 22, 27, 42)
    
    #-----< id-package-gsmSRF-scfCancel >-----#
    id_package_gsmSRF_scfCancel = OID(name=u'id-package-gsmSRF-scfCancel', mode=MODE_VALUE)
    id_package_gsmSRF_scfCancel._val = (0, 4, 0, 0, 1, 22, 27, 43)
    
    #-----< id-package-gprsContinue >-----#
    id_package_gprsContinue = OID(name=u'id-package-gprsContinue', mode=MODE_VALUE)
    id_package_gprsContinue._val = (0, 4, 0, 0, 1, 22, 27, 49)
    
    #-----< id-package-gprsExceptionInformation >-----#
    id_package_gprsExceptionInformation = OID(name=u'id-package-gprsExceptionInformation', mode=MODE_VALUE)
    id_package_gprsExceptionInformation._val = (0, 4, 0, 0, 1, 22, 27, 50)
    
    #-----< id-package-gprsScfActivation >-----#
    id_package_gprsScfActivation = OID(name=u'id-package-gprsScfActivation', mode=MODE_VALUE)
    id_package_gprsScfActivation._val = (0, 4, 0, 0, 1, 22, 27, 51)
    
    #-----< id-package-gprsConnect >-----#
    id_package_gprsConnect = OID(name=u'id-package-gprsConnect', mode=MODE_VALUE)
    id_package_gprsConnect._val = (0, 4, 0, 0, 1, 22, 27, 52)
    
    #-----< id-package-gprsRelease >-----#
    id_package_gprsRelease = OID(name=u'id-package-gprsRelease', mode=MODE_VALUE)
    id_package_gprsRelease._val = (0, 4, 0, 0, 1, 22, 27, 53)
    
    #-----< id-package-gprsEventHandling >-----#
    id_package_gprsEventHandling = OID(name=u'id-package-gprsEventHandling', mode=MODE_VALUE)
    id_package_gprsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 54)
    
    #-----< id-package-gprsTimer >-----#
    id_package_gprsTimer = OID(name=u'id-package-gprsTimer', mode=MODE_VALUE)
    id_package_gprsTimer._val = (0, 4, 0, 0, 1, 22, 27, 55)
    
    #-----< id-package-gprsBilling >-----#
    id_package_gprsBilling = OID(name=u'id-package-gprsBilling', mode=MODE_VALUE)
    id_package_gprsBilling._val = (0, 4, 0, 0, 1, 22, 27, 56)
    
    #-----< id-package-gprsCharging >-----#
    id_package_gprsCharging = OID(name=u'id-package-gprsCharging', mode=MODE_VALUE)
    id_package_gprsCharging._val = (0, 4, 0, 0, 1, 22, 27, 57)
    
    #-----< id-package-gprsActivityTest >-----#
    id_package_gprsActivityTest = OID(name=u'id-package-gprsActivityTest', mode=MODE_VALUE)
    id_package_gprsActivityTest._val = (0, 4, 0, 0, 1, 22, 27, 58)
    
    #-----< id-package-gprsCancel >-----#
    id_package_gprsCancel = OID(name=u'id-package-gprsCancel', mode=MODE_VALUE)
    id_package_gprsCancel._val = (0, 4, 0, 0, 1, 22, 27, 59)
    
    #-----< id-package-gprsChargeAdvice >-----#
    id_package_gprsChargeAdvice = OID(name=u'id-package-gprsChargeAdvice', mode=MODE_VALUE)
    id_package_gprsChargeAdvice._val = (0, 4, 0, 0, 1, 22, 27, 60)
    
    #-----< id-package-smsActivation >-----#
    id_package_smsActivation = OID(name=u'id-package-smsActivation', mode=MODE_VALUE)
    id_package_smsActivation._val = (0, 4, 0, 0, 1, 22, 27, 61)
    
    #-----< id-package-smsConnect >-----#
    id_package_smsConnect = OID(name=u'id-package-smsConnect', mode=MODE_VALUE)
    id_package_smsConnect._val = (0, 4, 0, 0, 1, 22, 27, 62)
    
    #-----< id-package-smsContinue >-----#
    id_package_smsContinue = OID(name=u'id-package-smsContinue', mode=MODE_VALUE)
    id_package_smsContinue._val = (0, 4, 0, 0, 1, 22, 27, 63)
    
    #-----< id-package-smsRelease >-----#
    id_package_smsRelease = OID(name=u'id-package-smsRelease', mode=MODE_VALUE)
    id_package_smsRelease._val = (0, 4, 0, 0, 1, 22, 27, 64)
    
    #-----< id-package-smsEventHandling >-----#
    id_package_smsEventHandling = OID(name=u'id-package-smsEventHandling', mode=MODE_VALUE)
    id_package_smsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 65)
    
    #-----< id-package-smsBilling >-----#
    id_package_smsBilling = OID(name=u'id-package-smsBilling', mode=MODE_VALUE)
    id_package_smsBilling._val = (0, 4, 0, 0, 1, 22, 27, 66)
    
    #-----< id-package-smsTimer >-----#
    id_package_smsTimer = OID(name=u'id-package-smsTimer', mode=MODE_VALUE)
    id_package_smsTimer._val = (0, 4, 0, 0, 1, 22, 27, 67)
    
    #-----< id-as-gsmSSF-scfGenericAS >-----#
    id_as_gsmSSF_scfGenericAS = OID(name=u'id-as-gsmSSF-scfGenericAS', mode=MODE_VALUE)
    id_as_gsmSSF_scfGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 4)
    
    #-----< id-as-assistHandoff-gsmSSF-scfAS >-----#
    id_as_assistHandoff_gsmSSF_scfAS = OID(name=u'id-as-assistHandoff-gsmSSF-scfAS', mode=MODE_VALUE)
    id_as_assistHandoff_gsmSSF_scfAS._val = (0, 4, 0, 0, 1, 23, 5, 6)
    
    #-----< id-as-scf-gsmSSFGenericAS >-----#
    id_as_scf_gsmSSFGenericAS = OID(name=u'id-as-scf-gsmSSFGenericAS', mode=MODE_VALUE)
    id_as_scf_gsmSSFGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 7)
    
    #-----< id-as-basic-gsmSRF-gsmSCF >-----#
    id_as_basic_gsmSRF_gsmSCF = OID(name=u'id-as-basic-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_as_basic_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 5, 14)
    
    #-----< id-as-gprsSSF-gsmSCF-AS >-----#
    id_as_gprsSSF_gsmSCF_AS = OID(name=u'id-as-gprsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_gprsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 50)
    
    #-----< id-as-gsmSCF-gprsSSF-AS >-----#
    id_as_gsmSCF_gprsSSF_AS = OID(name=u'id-as-gsmSCF-gprsSSF-AS', mode=MODE_VALUE)
    id_as_gsmSCF_gprsSSF_AS._val = (0, 4, 0, 0, 1, 22, 5, 51)
    
    #-----< id-as-smsSSF-gsmSCF-AS >-----#
    id_as_smsSSF_gsmSCF_AS = OID(name=u'id-as-smsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_smsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 61)
    
    _all_ = [
        tc_Messages,
        tc_NotationExtensions,
        ros_InformationObjects,
        datatypes,
        errortypes,
        operationcodes,
        errorcodes,
        classes,
        gsmSSF_gsmSCF_Operations,
        gsmSSF_gsmSCF_Protocol,
        gsmSCF_gsmSRF_Operations,
        gsmSCF_gsmSRF_Protocol,
        sms_Operations,
        smsSSF_gsmSCF_Protocol,
        gprsSSF_gsmSCF_Operations,
        gprsSSF_gsmSCF_Protocol,
        id_CAP,
        id_CAP3,
        id_CAPOE,
        id_CAP3OE,
        id_ac,
        id_acE,
        id_ac3E,
        id_as,
        id_asE,
        id_rosObject,
        id_contract,
        id_contract3,
        id_contractE,
        id_package,
        id_packageE,
        id_rosObject_gsmSCF,
        id_rosObject_gsmSSF,
        id_rosObject_gsmSRF,
        id_rosObject_gprsSSF,
        id_rosObject_smsSSF_V3,
        id_rosObject_smsSSF_V4,
        id_ac_CAP_gsmSSF_scfGenericAC,
        id_ac_CAP_gsmSSF_scfAssistHandoffAC,
        id_ac_CAP_scf_gsmSSFGenericAC,
        id_ac_gsmSRF_gsmSCF,
        id_ac_CAP_gprsSSF_gsmSCF_AC,
        id_ac_CAP_gsmSCF_gprsSSF_AC,
        id_ac_cap3_sms_AC,
        id_ac_cap4_sms_AC,
        id_CAPSsfToScfGeneric,
        id_CAPAssistHandoffssfToScf,
        id_CAPScfToSsfGeneric,
        id_contract_gsmSRF_gsmSCF,
        id_capGprsSsfTogsmScf,
        id_capGsmScfToGprsSsf,
        id_cap3SmsSsfTogsmScf,
        id_cap4SmsSsfTogsmScf,
        id_package_scfActivation,
        id_package_gsmSRF_scfActivationOfAssist,
        id_package_assistConnectionEstablishment,
        id_package_genericDisconnectResource,
        id_package_nonAssistedConnectionEstablishment,
        id_package_connect,
        id_package_callHandling,
        id_package_bcsmEventHandling,
        id_package_ssfCallProcessing,
        id_package_scfCallInitiation,
        id_package_timer,
        id_package_billing,
        id_package_charging,
        id_package_trafficManagement,
        id_package_callReport,
        id_package_signallingControl,
        id_package_activityTest,
        id_package_cancel,
        id_package_cphResponse,
        id_package_exceptionInform,
        id_package_playTone,
        id_package_specializedResourceControl,
        id_package_gsmSRF_scfCancel,
        id_package_gprsContinue,
        id_package_gprsExceptionInformation,
        id_package_gprsScfActivation,
        id_package_gprsConnect,
        id_package_gprsRelease,
        id_package_gprsEventHandling,
        id_package_gprsTimer,
        id_package_gprsBilling,
        id_package_gprsCharging,
        id_package_gprsActivityTest,
        id_package_gprsCancel,
        id_package_gprsChargeAdvice,
        id_package_smsActivation,
        id_package_smsConnect,
        id_package_smsContinue,
        id_package_smsRelease,
        id_package_smsEventHandling,
        id_package_smsBilling,
        id_package_smsTimer,
        id_as_gsmSSF_scfGenericAS,
        id_as_assistHandoff_gsmSSF_scfAS,
        id_as_scf_gsmSSFGenericAS,
        id_as_basic_gsmSRF_gsmSCF,
        id_as_gprsSSF_gsmSCF_AS,
        id_as_gsmSCF_gprsSSF_AS,
        id_as_smsSSF_gsmSCF_AS,
    ]

class CAP_operationcodes:

    _name_  = u'CAP-operationcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 53, 7]
    
    _obj_ = [
        u'opcode-initialDP',
        u'opcode-assistRequestInstructions',
        u'opcode-establishTemporaryConnection',
        u'opcode-disconnectForwardConnection',
        u'opcode-dFCWithArgument',
        u'opcode-connectToResource',
        u'opcode-connect',
        u'opcode-releaseCall',
        u'opcode-requestReportBCSMEvent',
        u'opcode-eventReportBCSM',
        u'opcode-collectInformation',
        u'opcode-continue',
        u'opcode-initiateCallAttempt',
        u'opcode-resetTimer',
        u'opcode-furnishChargingInformation',
        u'opcode-applyCharging',
        u'opcode-applyChargingReport',
        u'opcode-callGap',
        u'opcode-callInformationReport',
        u'opcode-callInformationRequest',
        u'opcode-sendChargingInformation',
        u'opcode-playAnnouncement',
        u'opcode-promptAndCollectUserInformation',
        u'opcode-specializedResourceReport',
        u'opcode-cancel',
        u'opcode-activityTest',
        u'opcode-continueWithArgument',
        u'opcode-disconnectLeg',
        u'opcode-moveLeg',
        u'opcode-splitLeg',
        u'opcode-entityReleased',
        u'opcode-playTone',
        u'opcode-initialDPSMS',
        u'opcode-furnishChargingInformationSMS',
        u'opcode-connectSMS',
        u'opcode-requestReportSMSEvent',
        u'opcode-eventReportSMS',
        u'opcode-continueSMS',
        u'opcode-releaseSMS',
        u'opcode-resetTimerSMS',
        u'opcode-activityTestGPRS',
        u'opcode-applyChargingGPRS',
        u'opcode-applyChargingReportGPRS',
        u'opcode-cancelGPRS',
        u'opcode-connectGPRS',
        u'opcode-continueGPRS',
        u'opcode-entityReleasedGPRS',
        u'opcode-furnishChargingInformationGPRS',
        u'opcode-initialDPGPRS',
        u'opcode-releaseGPRS',
        u'opcode-eventReportGPRS',
        u'opcode-requestReportGPRSEvent',
        u'opcode-resetTimerGPRS',
        u'opcode-sendChargingInformationGPRS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'opcode-initialDP',
        u'opcode-assistRequestInstructions',
        u'opcode-establishTemporaryConnection',
        u'opcode-disconnectForwardConnection',
        u'opcode-dFCWithArgument',
        u'opcode-connectToResource',
        u'opcode-connect',
        u'opcode-releaseCall',
        u'opcode-requestReportBCSMEvent',
        u'opcode-eventReportBCSM',
        u'opcode-collectInformation',
        u'opcode-continue',
        u'opcode-initiateCallAttempt',
        u'opcode-resetTimer',
        u'opcode-furnishChargingInformation',
        u'opcode-applyCharging',
        u'opcode-applyChargingReport',
        u'opcode-callGap',
        u'opcode-callInformationReport',
        u'opcode-callInformationRequest',
        u'opcode-sendChargingInformation',
        u'opcode-playAnnouncement',
        u'opcode-promptAndCollectUserInformation',
        u'opcode-specializedResourceReport',
        u'opcode-cancel',
        u'opcode-activityTest',
        u'opcode-continueWithArgument',
        u'opcode-disconnectLeg',
        u'opcode-moveLeg',
        u'opcode-splitLeg',
        u'opcode-entityReleased',
        u'opcode-playTone',
        u'opcode-initialDPSMS',
        u'opcode-furnishChargingInformationSMS',
        u'opcode-connectSMS',
        u'opcode-requestReportSMSEvent',
        u'opcode-eventReportSMS',
        u'opcode-continueSMS',
        u'opcode-releaseSMS',
        u'opcode-resetTimerSMS',
        u'opcode-activityTestGPRS',
        u'opcode-applyChargingGPRS',
        u'opcode-applyChargingReportGPRS',
        u'opcode-cancelGPRS',
        u'opcode-connectGPRS',
        u'opcode-continueGPRS',
        u'opcode-entityReleasedGPRS',
        u'opcode-furnishChargingInformationGPRS',
        u'opcode-initialDPGPRS',
        u'opcode-releaseGPRS',
        u'opcode-eventReportGPRS',
        u'opcode-requestReportGPRSEvent',
        u'opcode-resetTimerGPRS',
        u'opcode-sendChargingInformationGPRS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< opcode-initialDP >-----#
    opcode_initialDP = CHOICE(name=u'opcode-initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDP._val = (u'local', 0)
    
    #-----< opcode-assistRequestInstructions >-----#
    opcode_assistRequestInstructions = CHOICE(name=u'opcode-assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_assistRequestInstructions._val = (u'local', 16)
    
    #-----< opcode-establishTemporaryConnection >-----#
    opcode_establishTemporaryConnection = CHOICE(name=u'opcode-establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_establishTemporaryConnection._val = (u'local', 17)
    
    #-----< opcode-disconnectForwardConnection >-----#
    opcode_disconnectForwardConnection = CHOICE(name=u'opcode-disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectForwardConnection._val = (u'local', 18)
    
    #-----< opcode-dFCWithArgument >-----#
    opcode_dFCWithArgument = CHOICE(name=u'opcode-dFCWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_dFCWithArgument._val = (u'local', 86)
    
    #-----< opcode-connectToResource >-----#
    opcode_connectToResource = CHOICE(name=u'opcode-connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectToResource._val = (u'local', 19)
    
    #-----< opcode-connect >-----#
    opcode_connect = CHOICE(name=u'opcode-connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connect._val = (u'local', 20)
    
    #-----< opcode-releaseCall >-----#
    opcode_releaseCall = CHOICE(name=u'opcode-releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseCall._val = (u'local', 22)
    
    #-----< opcode-requestReportBCSMEvent >-----#
    opcode_requestReportBCSMEvent = CHOICE(name=u'opcode-requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportBCSMEvent._val = (u'local', 23)
    
    #-----< opcode-eventReportBCSM >-----#
    opcode_eventReportBCSM = CHOICE(name=u'opcode-eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportBCSM._val = (u'local', 24)
    
    #-----< opcode-collectInformation >-----#
    opcode_collectInformation = CHOICE(name=u'opcode-collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_collectInformation._val = (u'local', 27)
    
    #-----< opcode-continue >-----#
    opcode_continue = CHOICE(name=u'opcode-continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continue._val = (u'local', 31)
    
    #-----< opcode-initiateCallAttempt >-----#
    opcode_initiateCallAttempt = CHOICE(name=u'opcode-initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initiateCallAttempt._val = (u'local', 32)
    
    #-----< opcode-resetTimer >-----#
    opcode_resetTimer = CHOICE(name=u'opcode-resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimer._val = (u'local', 33)
    
    #-----< opcode-furnishChargingInformation >-----#
    opcode_furnishChargingInformation = CHOICE(name=u'opcode-furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformation._val = (u'local', 34)
    
    #-----< opcode-applyCharging >-----#
    opcode_applyCharging = CHOICE(name=u'opcode-applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyCharging._val = (u'local', 35)
    
    #-----< opcode-applyChargingReport >-----#
    opcode_applyChargingReport = CHOICE(name=u'opcode-applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReport._val = (u'local', 36)
    
    #-----< opcode-callGap >-----#
    opcode_callGap = CHOICE(name=u'opcode-callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callGap._val = (u'local', 41)
    
    #-----< opcode-callInformationReport >-----#
    opcode_callInformationReport = CHOICE(name=u'opcode-callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationReport._val = (u'local', 44)
    
    #-----< opcode-callInformationRequest >-----#
    opcode_callInformationRequest = CHOICE(name=u'opcode-callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationRequest._val = (u'local', 45)
    
    #-----< opcode-sendChargingInformation >-----#
    opcode_sendChargingInformation = CHOICE(name=u'opcode-sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformation._val = (u'local', 46)
    
    #-----< opcode-playAnnouncement >-----#
    opcode_playAnnouncement = CHOICE(name=u'opcode-playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playAnnouncement._val = (u'local', 47)
    
    #-----< opcode-promptAndCollectUserInformation >-----#
    opcode_promptAndCollectUserInformation = CHOICE(name=u'opcode-promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_promptAndCollectUserInformation._val = (u'local', 48)
    
    #-----< opcode-specializedResourceReport >-----#
    opcode_specializedResourceReport = CHOICE(name=u'opcode-specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_specializedResourceReport._val = (u'local', 49)
    
    #-----< opcode-cancel >-----#
    opcode_cancel = CHOICE(name=u'opcode-cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancel._val = (u'local', 53)
    
    #-----< opcode-activityTest >-----#
    opcode_activityTest = CHOICE(name=u'opcode-activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTest._val = (u'local', 55)
    
    #-----< opcode-continueWithArgument >-----#
    opcode_continueWithArgument = CHOICE(name=u'opcode-continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueWithArgument._val = (u'local', 88)
    
    #-----< opcode-disconnectLeg >-----#
    opcode_disconnectLeg = CHOICE(name=u'opcode-disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectLeg._val = (u'local', 90)
    
    #-----< opcode-moveLeg >-----#
    opcode_moveLeg = CHOICE(name=u'opcode-moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_moveLeg._val = (u'local', 93)
    
    #-----< opcode-splitLeg >-----#
    opcode_splitLeg = CHOICE(name=u'opcode-splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_splitLeg._val = (u'local', 95)
    
    #-----< opcode-entityReleased >-----#
    opcode_entityReleased = CHOICE(name=u'opcode-entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleased._val = (u'local', 96)
    
    #-----< opcode-playTone >-----#
    opcode_playTone = CHOICE(name=u'opcode-playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playTone._val = (u'local', 97)
    
    #-----< opcode-initialDPSMS >-----#
    opcode_initialDPSMS = CHOICE(name=u'opcode-initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPSMS._val = (u'local', 60)
    
    #-----< opcode-furnishChargingInformationSMS >-----#
    opcode_furnishChargingInformationSMS = CHOICE(name=u'opcode-furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationSMS._val = (u'local', 61)
    
    #-----< opcode-connectSMS >-----#
    opcode_connectSMS = CHOICE(name=u'opcode-connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectSMS._val = (u'local', 62)
    
    #-----< opcode-requestReportSMSEvent >-----#
    opcode_requestReportSMSEvent = CHOICE(name=u'opcode-requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportSMSEvent._val = (u'local', 63)
    
    #-----< opcode-eventReportSMS >-----#
    opcode_eventReportSMS = CHOICE(name=u'opcode-eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportSMS._val = (u'local', 64)
    
    #-----< opcode-continueSMS >-----#
    opcode_continueSMS = CHOICE(name=u'opcode-continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueSMS._val = (u'local', 65)
    
    #-----< opcode-releaseSMS >-----#
    opcode_releaseSMS = CHOICE(name=u'opcode-releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseSMS._val = (u'local', 66)
    
    #-----< opcode-resetTimerSMS >-----#
    opcode_resetTimerSMS = CHOICE(name=u'opcode-resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerSMS._val = (u'local', 67)
    
    #-----< opcode-activityTestGPRS >-----#
    opcode_activityTestGPRS = CHOICE(name=u'opcode-activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTestGPRS._val = (u'local', 70)
    
    #-----< opcode-applyChargingGPRS >-----#
    opcode_applyChargingGPRS = CHOICE(name=u'opcode-applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingGPRS._val = (u'local', 71)
    
    #-----< opcode-applyChargingReportGPRS >-----#
    opcode_applyChargingReportGPRS = CHOICE(name=u'opcode-applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReportGPRS._val = (u'local', 72)
    
    #-----< opcode-cancelGPRS >-----#
    opcode_cancelGPRS = CHOICE(name=u'opcode-cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancelGPRS._val = (u'local', 73)
    
    #-----< opcode-connectGPRS >-----#
    opcode_connectGPRS = CHOICE(name=u'opcode-connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectGPRS._val = (u'local', 74)
    
    #-----< opcode-continueGPRS >-----#
    opcode_continueGPRS = CHOICE(name=u'opcode-continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueGPRS._val = (u'local', 75)
    
    #-----< opcode-entityReleasedGPRS >-----#
    opcode_entityReleasedGPRS = CHOICE(name=u'opcode-entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleasedGPRS._val = (u'local', 76)
    
    #-----< opcode-furnishChargingInformationGPRS >-----#
    opcode_furnishChargingInformationGPRS = CHOICE(name=u'opcode-furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationGPRS._val = (u'local', 77)
    
    #-----< opcode-initialDPGPRS >-----#
    opcode_initialDPGPRS = CHOICE(name=u'opcode-initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPGPRS._val = (u'local', 78)
    
    #-----< opcode-releaseGPRS >-----#
    opcode_releaseGPRS = CHOICE(name=u'opcode-releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseGPRS._val = (u'local', 79)
    
    #-----< opcode-eventReportGPRS >-----#
    opcode_eventReportGPRS = CHOICE(name=u'opcode-eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportGPRS._val = (u'local', 80)
    
    #-----< opcode-requestReportGPRSEvent >-----#
    opcode_requestReportGPRSEvent = CHOICE(name=u'opcode-requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportGPRSEvent._val = (u'local', 81)
    
    #-----< opcode-resetTimerGPRS >-----#
    opcode_resetTimerGPRS = CHOICE(name=u'opcode-resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerGPRS._val = (u'local', 82)
    
    #-----< opcode-sendChargingInformationGPRS >-----#
    opcode_sendChargingInformationGPRS = CHOICE(name=u'opcode-sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformationGPRS._val = (u'local', 83)
    
    _all_ = [
        opcode_initialDP,
        opcode_assistRequestInstructions,
        opcode_establishTemporaryConnection,
        opcode_disconnectForwardConnection,
        opcode_dFCWithArgument,
        opcode_connectToResource,
        opcode_connect,
        opcode_releaseCall,
        opcode_requestReportBCSMEvent,
        opcode_eventReportBCSM,
        opcode_collectInformation,
        opcode_continue,
        opcode_initiateCallAttempt,
        opcode_resetTimer,
        opcode_furnishChargingInformation,
        opcode_applyCharging,
        opcode_applyChargingReport,
        opcode_callGap,
        opcode_callInformationReport,
        opcode_callInformationRequest,
        opcode_sendChargingInformation,
        opcode_playAnnouncement,
        opcode_promptAndCollectUserInformation,
        opcode_specializedResourceReport,
        opcode_cancel,
        opcode_activityTest,
        opcode_continueWithArgument,
        opcode_disconnectLeg,
        opcode_moveLeg,
        opcode_splitLeg,
        opcode_entityReleased,
        opcode_playTone,
        opcode_initialDPSMS,
        opcode_furnishChargingInformationSMS,
        opcode_connectSMS,
        opcode_requestReportSMSEvent,
        opcode_eventReportSMS,
        opcode_continueSMS,
        opcode_releaseSMS,
        opcode_resetTimerSMS,
        opcode_activityTestGPRS,
        opcode_applyChargingGPRS,
        opcode_applyChargingReportGPRS,
        opcode_cancelGPRS,
        opcode_connectGPRS,
        opcode_continueGPRS,
        opcode_entityReleasedGPRS,
        opcode_furnishChargingInformationGPRS,
        opcode_initialDPGPRS,
        opcode_releaseGPRS,
        opcode_eventReportGPRS,
        opcode_requestReportGPRSEvent,
        opcode_resetTimerGPRS,
        opcode_sendChargingInformationGPRS,
    ]

class CAP_SMS_ops_args:

    _name_  = u'CAP-SMS-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 105, 7]
    
    _obj_ = [
        u'connectSMS',
        u'ConnectSMSArg',
        u'continueSMS',
        u'eventReportSMS',
        u'EventReportSMSArg',
        u'furnishChargingInformationSMS',
        u'FurnishChargingInformationSMSArg',
        u'initialDPSMS',
        u'InitialDPSMSArg',
        u'releaseSMS',
        u'ReleaseSMSArg',
        u'requestReportSMSEvent',
        u'RequestReportSMSEventArg',
        u'resetTimerSMS',
        u'ResetTimerSMSArg',
        ]
    _type_ = [
        u'ConnectSMSArg',
        u'EventReportSMSArg',
        u'FurnishChargingInformationSMSArg',
        u'InitialDPSMSArg',
        u'ReleaseSMSArg',
        u'RequestReportSMSEventArg',
        u'ResetTimerSMSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'connectSMS',
        u'continueSMS',
        u'eventReportSMS',
        u'furnishChargingInformationSMS',
        u'initialDPSMS',
        u'releaseSMS',
        u'requestReportSMSEvent',
        u'resetTimerSMS',
        ]
    _class_ = [
        u'connectSMS',
        u'continueSMS',
        u'eventReportSMS',
        u'furnishChargingInformationSMS',
        u'initialDPSMS',
        u'releaseSMS',
        u'requestReportSMSEvent',
        u'resetTimerSMS',
        ]
    _param_ = [
        u'connectSMS',
        u'ConnectSMSArg',
        u'eventReportSMS',
        u'EventReportSMSArg',
        u'furnishChargingInformationSMS',
        u'FurnishChargingInformationSMSArg',
        u'initialDPSMS',
        u'InitialDPSMSArg',
        u'requestReportSMSEvent',
        u'RequestReportSMSEventArg',
        u'resetTimerSMS',
        u'ResetTimerSMSArg',
        ]
    
    #-----< connectSMS >-----#
    connectSMS = CLASS(name=u'connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectSMSArg >-----#
    ConnectSMSArg = SEQ(name=u'ConnectSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueSMS >-----#
    continueSMS = CLASS(name=u'continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continueSMS._val = dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])
    
    #-----< eventReportSMS >-----#
    eventReportSMS = CLASS(name=u'eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportSMSArg >-----#
    EventReportSMSArg = SEQ(name=u'EventReportSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationSMS >-----#
    furnishChargingInformationSMS = CLASS(name=u'furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationSMSArg >-----#
    FurnishChargingInformationSMSArg = OCT_STR(name=u'FurnishChargingInformationSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCISMSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPSMS >-----#
    initialDPSMS = CLASS(name=u'initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPSMSArg >-----#
    InitialDPSMSArg = SEQ(name=u'InitialDPSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseSMS >-----#
    releaseSMS = CLASS(name=u'releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _releaseSMS_val_ArgumentType = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    releaseSMS._val = dict([(u'ArgumentType', _releaseSMS_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])
    
    #-----< ReleaseSMSArg >-----#
    ReleaseSMSArg = OCT_STR(name=u'ReleaseSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RPCause')))
    
    #-----< requestReportSMSEvent >-----#
    requestReportSMSEvent = CLASS(name=u'requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportSMSEventArg >-----#
    RequestReportSMSEventArg = SEQ(name=u'RequestReportSMSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerSMS >-----#
    resetTimerSMS = CLASS(name=u'resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerSMSArg >-----#
    ResetTimerSMSArg = SEQ(name=u'ResetTimerSMSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        continueSMS,
        releaseSMS,
        _releaseSMS_val_ArgumentType,
        ReleaseSMSArg,
    ]

class CAP_smsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = u'CAP-smsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 106, 7]
    
    _obj_ = [
        u'cap3-sms-AC',
        u'cap4-sms-AC',
        u'cap3SMS',
        u'cap4SMS',
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsProcessingPackage',
        u'smsReleasePackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        u'sms-AbstractSyntax',
        u'Generic-sms-PDUs',
        u'SmsInvokable',
        u'SmsReturnable',
        ]
    _type_ = [
        u'Generic-sms-PDUs',
        ]
    _set_ = [
        u'SmsInvokable',
        u'SmsReturnable',
        ]
    _val_ = [
        u'cap3-sms-AC',
        u'cap4-sms-AC',
        u'cap3SMS',
        u'cap4SMS',
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsProcessingPackage',
        u'smsReleasePackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        u'sms-AbstractSyntax',
        ]
    _class_ = [
        u'cap3-sms-AC',
        u'cap4-sms-AC',
        u'cap3SMS',
        u'cap4SMS',
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsProcessingPackage',
        u'smsReleasePackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        u'sms-AbstractSyntax',
        u'SmsInvokable',
        u'SmsReturnable',
        ]
    _param_ = [
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        ]
    
    #-----< cap3-sms-AC >-----#
    cap3_sms_AC = CLASS(name=u'cap3-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callingPartyNumber),
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_eventTypeSMS),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI),
        (u'locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationMSC),
        (u'locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sMSCAddress),
        (u'timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPProtocolIdentifier),
        (u'tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPDataCodingScheme),
        (u'tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPValidityPeriod),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions),
        (u'smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_smsReferenceNumber),
        (u'mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mscAddress),
        (u'sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sgsn_Number),
        (u'ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_ms_Classmark2),
        (u'gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass),
        (u'iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI),
        (u'calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysNumber),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_sMSCAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeSMS),
        (u'eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationSMS),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    cap3_sms_AC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 20, 26, 16))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 21, 3, 61))])
    
    #-----< cap4-sms-AC >-----#
    cap4_sms_AC = CLASS(name=u'cap4-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'serviceKey', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_serviceKey),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber),
        (u'callingPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_callingPartyNumber),
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_eventTypeSMS),
        (u'iMSI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMSI),
        (u'locationInformationMSC', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationMSC),
        (u'locationInformationGPRS', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationGPRS),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sMSCAddress),
        (u'timeAndTimezone', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier),
        (u'tPDataCodingScheme', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPDataCodingScheme),
        (u'tPValidityPeriod', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPValidityPeriod),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions),
        (u'smsReferenceNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_smsReferenceNumber),
        (u'mscAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_mscAddress),
        (u'sgsn-Number', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sgsn_Number),
        (u'ms-Classmark2', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_ms_Classmark2),
        (u'gPRSMSClass', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gPRSMSClass),
        (u'iMEI', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMEI),
        (u'calledPartyNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_calledPartyNumber),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'callingPartysNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callingPartysNumber),
        (u'destinationSubscriberNumber', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber),
        (u'sMSCAddress', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_sMSCAddress),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'sMSEvents', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7._ext = []
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._cont = ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_
    ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'eventTypeSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventTypeSMS),
        (u'eventSpecificInformationSMS', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS),
        (u'miscCallInfo', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_miscCallInfo),
        (u'extensions', ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions),
        ])
    __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._cont = ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_
    ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'timerID', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timerID),
        (u'timervalue', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timervalue),
        (u'extensions', ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions),
        ])
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8._ext = []
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    cap4_sms_AC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 16))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 61))])
    
    #-----< cap3SMS >-----#
    cap3SMS = CLASS(name=u'cap3SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap3SMS._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 20, 26, 16))])
    
    #-----< cap4SMS >-----#
    cap4SMS = CLASS(name=u'cap4SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap4SMS._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 16))])
    
    #-----< smsActivationPackage >-----#
    smsActivationPackage = CLASS(name=u'smsActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsConnectPackage >-----#
    smsConnectPackage = CLASS(name=u'smsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsProcessingPackage >-----#
    smsProcessingPackage = CLASS(name=u'smsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsProcessingPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])
    
    #-----< smsReleasePackage >-----#
    smsReleasePackage = CLASS(name=u'smsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsReleasePackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))])
    
    #-----< smsEventHandlingPackage >-----#
    smsEventHandlingPackage = CLASS(name=u'smsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsBillingPackage >-----#
    smsBillingPackage = CLASS(name=u'smsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsTimerPackage >-----#
    smsTimerPackage = CLASS(name=u'smsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< sms-AbstractSyntax >-----#
    sms_AbstractSyntax = CLASS(name=u'sms-AbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _sms_AbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    sms_AbstractSyntax._val = dict([('Type', _sms_AbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])
    
    #-----< Generic-sms-PDUs >-----#
    Generic_sms_PDUs = CHOICE(name=u'Generic-sms-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _Generic_sms_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __Generic_sms_PDUs_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___Generic_sms_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS),
        (u'eventSpecificInformationSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS),
        (u'miscCallInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'sMSEvents', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'timerID', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID),
        (u'timervalue', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'sMSEvents', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'timerID', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID),
        (u'timervalue', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_unidirectional_components__item_._ext = None
    __Generic_sms_PDUs_unidirectional_components._cont = ___Generic_sms_PDUs_unidirectional_components__item_
    __Generic_sms_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __Generic_sms_PDUs_unidirectional_dialoguePortion),
        (u'components', __Generic_sms_PDUs_unidirectional_components),
        ])
    _Generic_sms_PDUs_unidirectional._ext = None
    _Generic_sms_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __Generic_sms_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_begin_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_begin_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_begin_components__item_._ext = None
    __Generic_sms_PDUs_begin_components._cont = ___Generic_sms_PDUs_begin_components__item_
    __Generic_sms_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_begin._cont = ASN1Dict([
        (u'otid', __Generic_sms_PDUs_begin_otid),
        (u'dialoguePortion', __Generic_sms_PDUs_begin_dialoguePortion),
        (u'components', __Generic_sms_PDUs_begin_components),
        ])
    _Generic_sms_PDUs_begin._ext = None
    _Generic_sms_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __Generic_sms_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_end_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_end_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_end_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_end_components__item_._ext = None
    __Generic_sms_PDUs_end_components._cont = ___Generic_sms_PDUs_end_components__item_
    __Generic_sms_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_end._cont = ASN1Dict([
        (u'dtid', __Generic_sms_PDUs_end_dtid),
        (u'dialoguePortion', __Generic_sms_PDUs_end_dialoguePortion),
        (u'components', __Generic_sms_PDUs_end_components),
        ])
    _Generic_sms_PDUs_end._ext = None
    _Generic_sms_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __Generic_sms_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_continue__components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_continue__components__item__basicROS._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_continue__components__item_._ext = None
    __Generic_sms_PDUs_continue__components._cont = ___Generic_sms_PDUs_continue__components__item_
    __Generic_sms_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __Generic_sms_PDUs_continue__otid),
        (u'dtid', __Generic_sms_PDUs_continue__dtid),
        (u'dialoguePortion', __Generic_sms_PDUs_continue__dialoguePortion),
        (u'components', __Generic_sms_PDUs_continue__components),
        ])
    _Generic_sms_PDUs_continue_._ext = None
    _Generic_sms_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    Generic_sms_PDUs._cont = ASN1Dict([
        (u'unidirectional', _Generic_sms_PDUs_unidirectional),
        (u'begin', _Generic_sms_PDUs_begin),
        (u'end', _Generic_sms_PDUs_end),
        (u'continue', _Generic_sms_PDUs_continue_),
        (u'abort', _Generic_sms_PDUs_abort),
        ])
    Generic_sms_PDUs._ext = None
    
    #-----< SmsInvokable >-----#
    SmsInvokable = CLASS(name=u'SmsInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsInvokable_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsInvokable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_0_extensions._cont = ___SmsInvokable_val_ArgumentType_0_extensions__item_
    __SmsInvokable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', __SmsInvokable_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', __SmsInvokable_val_ArgumentType_0_sMSCAddress),
        (u'extensions', __SmsInvokable_val_ArgumentType_0_extensions),
        ])
    _SmsInvokable_val_ArgumentType_0._ext = []
    _SmsInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    __SmsInvokable_val_ArgumentType_1_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_1_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __SmsInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_1_extensions._cont = ___SmsInvokable_val_ArgumentType_1_extensions__item_
    __SmsInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'eventTypeSMS', __SmsInvokable_val_ArgumentType_1_eventTypeSMS),
        (u'eventSpecificInformationSMS', __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS),
        (u'miscCallInfo', __SmsInvokable_val_ArgumentType_1_miscCallInfo),
        (u'extensions', __SmsInvokable_val_ArgumentType_1_extensions),
        ])
    _SmsInvokable_val_ArgumentType_1._ext = []
    _SmsInvokable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsInvokable_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_3_extensions._cont = ___SmsInvokable_val_ArgumentType_3_extensions__item_
    __SmsInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsInvokable_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', __SmsInvokable_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', __SmsInvokable_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', __SmsInvokable_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', __SmsInvokable_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', __SmsInvokable_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', __SmsInvokable_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', __SmsInvokable_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', __SmsInvokable_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', __SmsInvokable_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', __SmsInvokable_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', __SmsInvokable_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', __SmsInvokable_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', __SmsInvokable_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', __SmsInvokable_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', __SmsInvokable_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', __SmsInvokable_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', __SmsInvokable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsInvokable_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _SmsInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents._cont = ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_
    __SmsInvokable_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_4_extensions._cont = ___SmsInvokable_val_ArgumentType_4_extensions__item_
    __SmsInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'sMSEvents', __SmsInvokable_val_ArgumentType_4_sMSEvents),
        (u'extensions', __SmsInvokable_val_ArgumentType_4_extensions),
        ])
    _SmsInvokable_val_ArgumentType_4._ext = []
    _SmsInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsInvokable_val_ArgumentType_5_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SmsInvokable_val_ArgumentType_5_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsInvokable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_5_extensions._cont = ___SmsInvokable_val_ArgumentType_5_extensions__item_
    __SmsInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'timerID', __SmsInvokable_val_ArgumentType_5_timerID),
        (u'timervalue', __SmsInvokable_val_ArgumentType_5_timervalue),
        (u'extensions', __SmsInvokable_val_ArgumentType_5_extensions),
        ])
    _SmsInvokable_val_ArgumentType_5._ext = []
    SmsInvokable._val = ASN1Set(rv=[dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    
    #-----< SmsReturnable >-----#
    SmsReturnable = CLASS(name=u'SmsReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsReturnable_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsReturnable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_0_extensions._cont = ___SmsReturnable_val_ArgumentType_0_extensions__item_
    __SmsReturnable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', __SmsReturnable_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', __SmsReturnable_val_ArgumentType_0_sMSCAddress),
        (u'extensions', __SmsReturnable_val_ArgumentType_0_extensions),
        ])
    _SmsReturnable_val_ArgumentType_0._ext = []
    _SmsReturnable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsReturnable_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_3_extensions._cont = ___SmsReturnable_val_ArgumentType_3_extensions__item_
    __SmsReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsReturnable_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', __SmsReturnable_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', __SmsReturnable_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', __SmsReturnable_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', __SmsReturnable_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', __SmsReturnable_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', __SmsReturnable_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', __SmsReturnable_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', __SmsReturnable_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', __SmsReturnable_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', __SmsReturnable_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', __SmsReturnable_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', __SmsReturnable_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', __SmsReturnable_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', __SmsReturnable_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', __SmsReturnable_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', __SmsReturnable_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', __SmsReturnable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsReturnable_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _SmsReturnable_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _SmsReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents._cont = ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_
    __SmsReturnable_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_5_extensions._cont = ___SmsReturnable_val_ArgumentType_5_extensions__item_
    __SmsReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'sMSEvents', __SmsReturnable_val_ArgumentType_5_sMSEvents),
        (u'extensions', __SmsReturnable_val_ArgumentType_5_extensions),
        ])
    _SmsReturnable_val_ArgumentType_5._ext = []
    _SmsReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsReturnable_val_ArgumentType_6_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SmsReturnable_val_ArgumentType_6_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_6_extensions._cont = ___SmsReturnable_val_ArgumentType_6_extensions__item_
    __SmsReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'timerID', __SmsReturnable_val_ArgumentType_6_timerID),
        (u'timervalue', __SmsReturnable_val_ArgumentType_6_timervalue),
        (u'extensions', __SmsReturnable_val_ArgumentType_6_extensions),
        ])
    _SmsReturnable_val_ArgumentType_6._ext = []
    SmsReturnable._val = ASN1Set(rv=[dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap3_sms_AC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0,
        __OPERATION_Errors_val_ParameterType_3,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_0,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_1,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_2,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_3,
        __OPERATION_Errors_val_ParameterType_2_0,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_4,
        __OPERATION_Errors_val_ParameterType_1,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        cap4_sms_AC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_serviceKey,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_callingPartyNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_eventTypeSMS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMSI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationMSC,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_locationInformationGPRS,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sMSCAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_timeAndTimezone,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPDataCodingScheme,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_tPValidityPeriod,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_extensions,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_smsReferenceNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_mscAddress,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_sgsn_Number,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_ms_Classmark2,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_gPRSMSClass,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_iMEI,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5_calledPartyNumber,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_5,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_callingPartysNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_sMSCAddress,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_6,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_sMSEvents,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_7,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventTypeSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_miscCallInfo,
        ____OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions__item_,
        ___OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0_extensions,
        __OPERATION_PACKAGE_Consumer_val_ArgumentType_0_0,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timerID,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_timervalue,
        ____OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions__item_,
        ___OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8_extensions,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_8,
        __OPERATION_PACKAGE_Supplier_val_ArgumentType_0_9,
        cap3SMS,
        cap4SMS,
        smsProcessingPackage,
        smsReleasePackage,
        sms_AbstractSyntax,
        _sms_AbstractSyntax_val_Type,
        __Generic_sms_PDUs_unidirectional_dialoguePortion,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject,
        ____Generic_sms_PDUs_unidirectional_components__item__basicROS,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_unidirectional_components__item_,
        __Generic_sms_PDUs_unidirectional_components,
        _Generic_sms_PDUs_unidirectional,
        __Generic_sms_PDUs_begin_otid,
        __Generic_sms_PDUs_begin_dialoguePortion,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_begin_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_begin_components__item__basicROS_reject,
        ____Generic_sms_PDUs_begin_components__item__basicROS,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_begin_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_begin_components__item_,
        __Generic_sms_PDUs_begin_components,
        _Generic_sms_PDUs_begin,
        __Generic_sms_PDUs_end_dtid,
        __Generic_sms_PDUs_end_dialoguePortion,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_end_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_end_components__item__basicROS_reject,
        ____Generic_sms_PDUs_end_components__item__basicROS,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_end_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_end_components__item_,
        __Generic_sms_PDUs_end_components,
        _Generic_sms_PDUs_end,
        __Generic_sms_PDUs_continue__otid,
        __Generic_sms_PDUs_continue__dtid,
        __Generic_sms_PDUs_continue__dialoguePortion,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_continue__components__item__basicROS_invoke,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnError,
        _____Generic_sms_PDUs_continue__components__item__basicROS_reject,
        ____Generic_sms_PDUs_continue__components__item__basicROS,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_continue__components__item__returnResultNotLast,
        ___Generic_sms_PDUs_continue__components__item_,
        __Generic_sms_PDUs_continue__components,
        _Generic_sms_PDUs_continue_,
        _Generic_sms_PDUs_abort,
        Generic_sms_PDUs,
        SmsInvokable,
        __SmsInvokable_val_ArgumentType_0_callingPartysNumber,
        __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_0_sMSCAddress,
        ___SmsInvokable_val_ArgumentType_0_extensions__item_,
        __SmsInvokable_val_ArgumentType_0_extensions,
        _SmsInvokable_val_ArgumentType_0,
        __SmsInvokable_val_ArgumentType_1_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS,
        __SmsInvokable_val_ArgumentType_1_miscCallInfo,
        ___SmsInvokable_val_ArgumentType_1_extensions__item_,
        __SmsInvokable_val_ArgumentType_1_extensions,
        _SmsInvokable_val_ArgumentType_1,
        _SmsInvokable_val_ArgumentType_2,
        __SmsInvokable_val_ArgumentType_3_serviceKey,
        __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_3_callingPartyNumber,
        __SmsInvokable_val_ArgumentType_3_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_3_iMSI,
        __SmsInvokable_val_ArgumentType_3_locationInformationMSC,
        __SmsInvokable_val_ArgumentType_3_locationInformationGPRS,
        __SmsInvokable_val_ArgumentType_3_sMSCAddress,
        __SmsInvokable_val_ArgumentType_3_timeAndTimezone,
        __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsInvokable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsInvokable_val_ArgumentType_3_extensions__item_,
        __SmsInvokable_val_ArgumentType_3_extensions,
        __SmsInvokable_val_ArgumentType_3_smsReferenceNumber,
        __SmsInvokable_val_ArgumentType_3_mscAddress,
        __SmsInvokable_val_ArgumentType_3_sgsn_Number,
        __SmsInvokable_val_ArgumentType_3_ms_Classmark2,
        __SmsInvokable_val_ArgumentType_3_gPRSMSClass,
        __SmsInvokable_val_ArgumentType_3_iMEI,
        __SmsInvokable_val_ArgumentType_3_calledPartyNumber,
        _SmsInvokable_val_ArgumentType_3,
        ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_,
        __SmsInvokable_val_ArgumentType_4_sMSEvents,
        ___SmsInvokable_val_ArgumentType_4_extensions__item_,
        __SmsInvokable_val_ArgumentType_4_extensions,
        _SmsInvokable_val_ArgumentType_4,
        __SmsInvokable_val_ArgumentType_5_timerID,
        __SmsInvokable_val_ArgumentType_5_timervalue,
        ___SmsInvokable_val_ArgumentType_5_extensions__item_,
        __SmsInvokable_val_ArgumentType_5_extensions,
        _SmsInvokable_val_ArgumentType_5,
        SmsReturnable,
        __SmsReturnable_val_ArgumentType_0_callingPartysNumber,
        __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_0_sMSCAddress,
        ___SmsReturnable_val_ArgumentType_0_extensions__item_,
        __SmsReturnable_val_ArgumentType_0_extensions,
        _SmsReturnable_val_ArgumentType_0,
        _SmsReturnable_val_ArgumentType_2,
        __SmsReturnable_val_ArgumentType_3_serviceKey,
        __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_3_callingPartyNumber,
        __SmsReturnable_val_ArgumentType_3_eventTypeSMS,
        __SmsReturnable_val_ArgumentType_3_iMSI,
        __SmsReturnable_val_ArgumentType_3_locationInformationMSC,
        __SmsReturnable_val_ArgumentType_3_locationInformationGPRS,
        __SmsReturnable_val_ArgumentType_3_sMSCAddress,
        __SmsReturnable_val_ArgumentType_3_timeAndTimezone,
        __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsReturnable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsReturnable_val_ArgumentType_3_extensions__item_,
        __SmsReturnable_val_ArgumentType_3_extensions,
        __SmsReturnable_val_ArgumentType_3_smsReferenceNumber,
        __SmsReturnable_val_ArgumentType_3_mscAddress,
        __SmsReturnable_val_ArgumentType_3_sgsn_Number,
        __SmsReturnable_val_ArgumentType_3_ms_Classmark2,
        __SmsReturnable_val_ArgumentType_3_gPRSMSClass,
        __SmsReturnable_val_ArgumentType_3_iMEI,
        __SmsReturnable_val_ArgumentType_3_calledPartyNumber,
        _SmsReturnable_val_ArgumentType_3,
        _SmsReturnable_val_ArgumentType_4,
        ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_,
        __SmsReturnable_val_ArgumentType_5_sMSEvents,
        ___SmsReturnable_val_ArgumentType_5_extensions__item_,
        __SmsReturnable_val_ArgumentType_5_extensions,
        _SmsReturnable_val_ArgumentType_5,
        __SmsReturnable_val_ArgumentType_6_timerID,
        __SmsReturnable_val_ArgumentType_6_timervalue,
        ___SmsReturnable_val_ArgumentType_6_extensions__item_,
        __SmsReturnable_val_ArgumentType_6_extensions,
        _SmsReturnable_val_ArgumentType_6,
    ]

class CAP_U_ABORT_Data:

    _name_  = u'CAP-U-ABORT-Data'
    _oid_   = [0, 4, 0, 0, 1, 3, 110, 7]
    
    _obj_ = [
        u'id-CAP-U-ABORT-Reason',
        u'cAP-U-ABORT-Reason-Abstract-Syntax',
        u'CAP-U-ABORT-REASON',
        ]
    _type_ = [
        u'CAP-U-ABORT-REASON',
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-CAP-U-ABORT-Reason',
        u'cAP-U-ABORT-Reason-Abstract-Syntax',
        ]
    _class_ = [
        u'cAP-U-ABORT-Reason-Abstract-Syntax',
        ]
    _param_ = [
        ]
    
    #-----< id-CAP-U-ABORT-Reason >-----#
    id_CAP_U_ABORT_Reason = OID(name=u'id-CAP-U-ABORT-Reason', mode=MODE_VALUE)
    id_CAP_U_ABORT_Reason._val = (0, 4, 0, 0, 1, 1, 2, 2)
    
    #-----< cAP-U-ABORT-Reason-Abstract-Syntax >-----#
    cAP_U_ABORT_Reason_Abstract_Syntax = CLASS(name=u'cAP-U-ABORT-Reason-Abstract-Syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _cAP_U_ABORT_Reason_Abstract_Syntax_val_Type = ENUM(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-U-ABORT-Data', 'CAP-U-ABORT-REASON')))
    cAP_U_ABORT_Reason_Abstract_Syntax._val = dict([('Type', _cAP_U_ABORT_Reason_Abstract_Syntax_val_Type), ('id', (0, 4, 0, 0, 1, 1, 2, 2))])
    
    #-----< CAP-U-ABORT-REASON >-----#
    CAP_U_ABORT_REASON = ENUM(name=u'CAP-U-ABORT-REASON', mode=MODE_TYPE)
    CAP_U_ABORT_REASON._cont = ASN1Dict([(u'no-reason-given', 1), (u'application-timer-expired', 2), (u'not-allowed-procedures', 3), (u'abnormal-processing', 4), (u'congestion', 5), (u'invalid-reference', 6), (u'missing-reference', 7), (u'overlapping-dialogue', 8)])
    CAP_U_ABORT_REASON._ext = None
    
    _all_ = [
        id_CAP_U_ABORT_Reason,
        cAP_U_ABORT_Reason_Abstract_Syntax,
        _cAP_U_ABORT_Reason_Abstract_Syntax_val_Type,
        CAP_U_ABORT_REASON,
    ]

class TCAP_CAP_Messages:

    _name_  = u'TCAP-CAP-Messages'
    _oid_   = []
    
    _obj_ = [
        u'TCAP-CAP-Message',
        u'AllCAPInvokable',
        u'AllCAPReturnable',
        ]
    _type_ = [
        u'TCAP-CAP-Message',
        ]
    _set_ = [
        u'AllCAPInvokable',
        u'AllCAPReturnable',
        ]
    _val_ = [
        ]
    _class_ = [
        u'AllCAPInvokable',
        u'AllCAPReturnable',
        ]
    _param_ = [
        ]
    
    #-----< TCAP-CAP-Message >-----#
    TCAP_CAP_Message = CHOICE(name=u'TCAP-CAP-Message', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _TCAP_CAP_Message_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __TCAP_CAP_Message_unidirectional_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_CAP_Message_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___TCAP_CAP_Message_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_CAP_Message_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress._cont = ASN1Dict([
        (u'legID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_legID),
        (u'srfConnection', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics),
        (u'partyToCharge', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_partyToCharge),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions),
        (u'aChChargingAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = []
    __OPERATION_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    __OPERATION_Errors_val_ParameterType_7 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_8 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_8._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_8._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'correlationID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_correlationID),
        (u'iPSSPCapabilities', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_iPSSPCapabilities),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    __OPERATION_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item_._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'requestedInformationList', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'legID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_legID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'requestedInformationTypeList', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_requestedInformationTypeList),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        (u'legID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_legID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = []
    __OPERATION_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_callSegmentID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'invokeID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_invokeID),
        (u'allRequests', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_allRequests),
        (u'callSegmentToCancel', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = None
    __OPERATION_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___OPERATION_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ___OPERATION_Errors_val_ParameterType_0_problem._ext = None
    ___OPERATION_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ___OPERATION_Errors_val_ParameterType_0_problem),
        (u'operation', ___OPERATION_Errors_val_ParameterType_0_operation),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = []
    __OPERATION_Errors_val_ParameterType_2_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    __OPERATION_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress),
        (u'alertingPattern', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_alertingPattern),
        (u'originalCalledPartyID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_originalCalledPartyID),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        (u'carrier', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_carrier),
        (u'callingPartysCategory', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_callingPartysCategory),
        (u'redirectingPartyID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectingPartyID),
        (u'redirectionInformation', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectionInformation),
        (u'genericNumbers', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_chargeNumber),
        (u'legToBeConnected', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeConnected),
        (u'cug-Interlock', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_cug_Interlock),
        (u'cug-OutgoingAccess', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_suppressionOfAnnouncement),
        (u'oCSIApplicable', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_oCSIApplicable),
        (u'naOliInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_naOliInfo),
        (u'bor-InterrogationRequested', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_bor_InterrogationRequested),
        (u'suppress-N-CSI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_suppress_N_CSI),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = [u'suppress-N-CSI']
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'accessPointName', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_accessPointName),
        (u'pdpID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_pdpID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        (u'callingPartysNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartysNumber),
        (u'destinationSubscriberNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_destinationSubscriberNumber),
        (u'sMSCAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_sMSCAddress),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_ipRoutingAddress),
        (u'none', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_none),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'resourceAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        (u'serviceInteractionIndicatorsTwo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callSegmentID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    __OPERATION_Errors_val_ParameterType_1_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'alertingPattern', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_alertingPattern),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        (u'serviceInteractionIndicatorsTwo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        (u'genericNumbers', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers),
        (u'cug-Interlock', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        (u'chargeNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_chargeNumber),
        (u'carrier', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier),
        (u'suppressionOfAnnouncement', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_suppressionOfAnnouncement),
        (u'naOliInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_naOliInfo),
        (u'bor-InterrogationRequested', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bor_InterrogationRequested),
        (u'suppress-O-CSI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    __OPERATION_Errors_val_ParameterType_0_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'callSegmentID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_callSegmentID),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'legToBeReleased', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_legToBeReleased),
        (u'releaseCause', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_releaseCause),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_callSegmentID),
        (u'cause', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_cause),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure._cont = ASN1Dict([
        (u'legID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_legID),
        (u'cause', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_cause),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'callSegmentFailure', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure),
        (u'bCSM-Failure', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'gPRSCause', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_gPRSCause),
        (u'pDPID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_pDPID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_assistingSSPIPRoutingAddress),
        (u'correlationID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_correlationID),
        (u'scfID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_scfID),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        (u'carrier', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_carrier),
        (u'serviceInteractionIndicatorsTwo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID),
        (u'naOliInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_naOliInfo),
        (u'chargeNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_chargeNumber),
        (u'originalCalledPartyID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_originalCalledPartyID),
        (u'callingPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callingPartyNumber),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'eventTypeBCSM', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM),
        (u'legID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legID),
        (u'miscCallInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_miscCallInfo),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        (u'gPRSEventType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventType),
        (u'miscGPRSInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation),
        (u'pDPID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_pDPID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        (u'eventTypeSMS', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_eventTypeSMS),
        (u'eventSpecificInformationSMS', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_eventSpecificInformationSMS),
        (u'miscCallInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_miscCallInfo),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_29 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_29._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability_bearerCap),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30._cont = ASN1Dict([
        (u'serviceKey', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_serviceKey),
        (u'calledPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyNumber),
        (u'callingPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartyNumber),
        (u'callingPartysCategory', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartysCategory),
        (u'cGEncountered', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cGEncountered),
        (u'iPSSPCapabilities', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iPSSPCapabilities),
        (u'locationNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationNumber),
        (u'originalCalledPartyID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_originalCalledPartyID),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions),
        (u'highLayerCompatibility', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_highLayerCompatibility),
        (u'additionalCallingPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_additionalCallingPartyNumber),
        (u'bearerCapability', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability),
        (u'eventTypeBCSM', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_eventTypeBCSM),
        (u'redirectingPartyID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectingPartyID),
        (u'redirectionInformation', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectionInformation),
        (u'cause', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cause),
        (u'serviceInteractionIndicatorsTwo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_serviceInteractionIndicatorsTwo),
        (u'carrier', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_carrier),
        (u'cug-Index', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_Index),
        (u'cug-Interlock', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_Interlock),
        (u'cug-OutgoingAccess', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_OutgoingAccess),
        (u'iMSI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iMSI),
        (u'subscriberState', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_subscriberState),
        (u'locationInformation', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationInformation),
        (u'ext-basicServiceCode', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_ext_basicServiceCode),
        (u'callReferenceNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callReferenceNumber),
        (u'mscAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_mscAddress),
        (u'calledPartyBCDNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyBCDNumber),
        (u'timeAndTimezone', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_timeAndTimezone),
        (u'callForwardingSS-Pending', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callForwardingSS_Pending),
        (u'initialDPArgExtension', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPAddress),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31._cont = ASN1Dict([
        (u'serviceKey', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_serviceKey),
        (u'gPRSEventType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gPRSEventType),
        (u'mSISDN', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_mSISDN),
        (u'iMSI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_iMSI),
        (u'timeAndTimeZone', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_timeAndTimeZone),
        (u'gPRSMSClass', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gPRSMSClass),
        (u'endUserAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress),
        (u'qualityOfService', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_qualityOfService),
        (u'accessPointName', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_accessPointName),
        (u'routeingAreaIdentity', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_routeingAreaIdentity),
        (u'chargingID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_chargingID),
        (u'sGSNCapabilities', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_sGSNCapabilities),
        (u'locationInformationGPRS', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_locationInformationGPRS),
        (u'pDPInitiationType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_pDPInitiationType),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions),
        (u'gGSNAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gGSNAddress),
        (u'secondaryPDP-context', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_secondaryPDP_context),
        (u'iMEI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_iMEI),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32._cont = ASN1Dict([
        (u'serviceKey', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_serviceKey),
        (u'destinationSubscriberNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_destinationSubscriberNumber),
        (u'callingPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_callingPartyNumber),
        (u'eventTypeSMS', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_eventTypeSMS),
        (u'iMSI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_iMSI),
        (u'locationInformationMSC', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_locationInformationMSC),
        (u'locationInformationGPRS', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_locationInformationGPRS),
        (u'sMSCAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_sMSCAddress),
        (u'timeAndTimezone', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPDataCodingScheme),
        (u'tPValidityPeriod', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPValidityPeriod),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions),
        (u'smsReferenceNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_smsReferenceNumber),
        (u'mscAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_mscAddress),
        (u'sgsn-Number', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_sgsn_Number),
        (u'ms-Classmark2', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_ms_Classmark2),
        (u'gPRSMSClass', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_gPRSMSClass),
        (u'iMEI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_iMEI),
        (u'calledPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_calledPartyNumber),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions),
        (u'legToBeCreated', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_legToBeCreated),
        (u'newCallSegment', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_newCallSegment),
        (u'callingPartyNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callingPartyNumber),
        (u'callReferenceNumber', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callReferenceNumber),
        (u'gsmSCFAddress', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_gsmSCFAddress),
        (u'suppress-T-CSI', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_suppress_T_CSI),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33._cont = ASN1Dict([
        (u'supportedCamelPhases', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_offeredCamel4Functionalities),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions),
        (u'releaseCallArgExtensionAllowed', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_releaseCallArgExtensionAllowed),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33._ext = [u'releaseCallArgExtensionAllowed']
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34._cont = ASN1Dict([
        (u'legIDToMove', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_legIDToMove),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_duration),
        (u'interval', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_interval),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo),
        (u'tone', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_tone),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35._cont = ASN1Dict([
        (u'informationToSend', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend),
        (u'disconnectFromIPForbidden', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_requestAnnouncementCompleteNotification),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions),
        (u'callSegmentID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_requestAnnouncementStartedNotification),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35._ext = []
    __OPERATION_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_callSegmentID),
        (u'legID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_legID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36._cont = ASN1Dict([
        (u'legOrCallSegment', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment),
        (u'bursts', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_bursts),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_duration),
        (u'interval', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_interval),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo),
        (u'tone', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_tone),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37._cont = ASN1Dict([
        (u'collectedInfo', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_collectedInfo),
        (u'disconnectFromIPForbidden', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_disconnectFromIPForbidden),
        (u'informationToSend', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions),
        (u'callSegmentID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_requestAnnouncementStartedNotification),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37._cont = ASN1Dict([
        (u'digitsResponse', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37_digitsResponse),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    __OPERATION_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38._cont = ASN1Dict([
        (u'allCallSegments', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegments),
        (u'allCallSegmentsWithExtension', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39._cont = ASN1Dict([
        (u'gprsCause', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_gprsCause),
        (u'pDPID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_pDPID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__monitorMode),
        (u'legID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__automaticRearm),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item_._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40._cont = ASN1Dict([
        (u'bcsmEvents', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41._cont = ASN1Dict([
        (u'gPRSEvent', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent),
        (u'pDPID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_pDPID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42._cont = ASN1Dict([
        (u'sMSEvents', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43._cont = ASN1Dict([
        (u'timerID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_timerID),
        (u'timervalue', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_timervalue),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions),
        (u'callSegmentID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_callSegmentID),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_44 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45._cont = ASN1Dict([
        (u'timerID', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_timerID),
        (u'timervalue', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_timervalue),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_partyToCharge),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_48 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions._cont = __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions__item_
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49._cont = ASN1Dict([
        (u'legToBeSplit', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_legToBeSplit),
        (u'newCallSegment', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_newCallSegment),
        (u'extensions', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49._ext = []
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33), (u'ResultType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37), (u'ResultType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_44), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_48), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))]), dict([(u'ArgumentType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke._ext = None
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_legID),
        (u'srfConnection', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics),
        (u'partyToCharge', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_partyToCharge),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions),
        (u'aChChargingAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'correlationID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_correlationID),
        (u'iPSSPCapabilities', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_iPSSPCapabilities),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo._ext = []
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo),
        (u'tone', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_tone),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend),
        (u'releaseCause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_releaseCause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'gapCriteria', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria),
        (u'gapIndicators', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapIndicators),
        (u'controlType', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_controlType),
        (u'gapTreatment', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item_._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'requestedInformationList', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        (u'legID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_legID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'requestedInformationTypeList', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_requestedInformationTypeList),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions),
        (u'legID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_legID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_callSegmentID),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'invokeID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_invokeID),
        (u'allRequests', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_allRequests),
        (u'callSegmentToCancel', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress),
        (u'alertingPattern', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_alertingPattern),
        (u'originalCalledPartyID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_originalCalledPartyID),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        (u'carrier', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_carrier),
        (u'callingPartysCategory', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_callingPartysCategory),
        (u'redirectingPartyID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectingPartyID),
        (u'redirectionInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectionInformation),
        (u'genericNumbers', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_chargeNumber),
        (u'legToBeConnected', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeConnected),
        (u'cug-Interlock', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_cug_Interlock),
        (u'cug-OutgoingAccess', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_suppressionOfAnnouncement),
        (u'oCSIApplicable', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_oCSIApplicable),
        (u'naOliInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_naOliInfo),
        (u'bor-InterrogationRequested', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_bor_InterrogationRequested),
        (u'suppress-N-CSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_suppress_N_CSI),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = [u'suppress-N-CSI']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        (u'accessPointName', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_accessPointName),
        (u'pdpID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_pdpID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'callingPartysNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartysNumber),
        (u'destinationSubscriberNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationSubscriberNumber),
        (u'sMSCAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_sMSCAddress),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_ipRoutingAddress),
        (u'none', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_none),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        (u'resourceAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions),
        (u'serviceInteractionIndicatorsTwo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_callSegmentID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'alertingPattern', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_alertingPattern),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions),
        (u'serviceInteractionIndicatorsTwo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_callingPartysCategory),
        (u'genericNumbers', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers),
        (u'cug-Interlock', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_cug_Interlock),
        (u'cug-OutgoingAccess', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_cug_OutgoingAccess),
        (u'chargeNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_chargeNumber),
        (u'carrier', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_carrier),
        (u'suppressionOfAnnouncement', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_suppressionOfAnnouncement),
        (u'naOliInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_naOliInfo),
        (u'bor-InterrogationRequested', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_bor_InterrogationRequested),
        (u'suppress-O-CSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'legToBeReleased', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_legToBeReleased),
        (u'releaseCause', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_releaseCause),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_callSegmentID),
        (u'cause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_cause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_legID),
        (u'cause', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_cause),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'callSegmentFailure', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure),
        (u'bCSM-Failure', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        (u'gPRSCause', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_gPRSCause),
        (u'pDPID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_pDPID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_assistingSSPIPRoutingAddress),
        (u'correlationID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_correlationID),
        (u'scfID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_scfID),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions),
        (u'carrier', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_carrier),
        (u'serviceInteractionIndicatorsTwo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callSegmentID),
        (u'naOliInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_naOliInfo),
        (u'chargeNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_chargeNumber),
        (u'originalCalledPartyID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_originalCalledPartyID),
        (u'callingPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callingPartyNumber),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        (u'eventTypeBCSM', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM),
        (u'legID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_legID),
        (u'miscCallInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_miscCallInfo),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_28 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_28._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_29 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_29._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_30 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_30._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability_bearerCap),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2._ext = None
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31._cont = ASN1Dict([
        (u'serviceKey', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_serviceKey),
        (u'calledPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyNumber),
        (u'callingPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartyNumber),
        (u'callingPartysCategory', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartysCategory),
        (u'cGEncountered', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cGEncountered),
        (u'iPSSPCapabilities', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iPSSPCapabilities),
        (u'locationNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationNumber),
        (u'originalCalledPartyID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_originalCalledPartyID),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions),
        (u'highLayerCompatibility', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_additionalCallingPartyNumber),
        (u'bearerCapability', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability),
        (u'eventTypeBCSM', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_eventTypeBCSM),
        (u'redirectingPartyID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectingPartyID),
        (u'redirectionInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectionInformation),
        (u'cause', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cause),
        (u'serviceInteractionIndicatorsTwo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_serviceInteractionIndicatorsTwo),
        (u'carrier', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_carrier),
        (u'cug-Index', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_Index),
        (u'cug-Interlock', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_Interlock),
        (u'cug-OutgoingAccess', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_OutgoingAccess),
        (u'iMSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iMSI),
        (u'subscriberState', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_subscriberState),
        (u'locationInformation', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationInformation),
        (u'ext-basicServiceCode', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_ext_basicServiceCode),
        (u'callReferenceNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callReferenceNumber),
        (u'mscAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_mscAddress),
        (u'calledPartyBCDNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyBCDNumber),
        (u'timeAndTimezone', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_timeAndTimezone),
        (u'callForwardingSS-Pending', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callForwardingSS_Pending),
        (u'initialDPArgExtension', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPAddress),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32._cont = ASN1Dict([
        (u'serviceKey', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_serviceKey),
        (u'gPRSEventType', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gPRSEventType),
        (u'mSISDN', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_mSISDN),
        (u'iMSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_iMSI),
        (u'timeAndTimeZone', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_timeAndTimeZone),
        (u'gPRSMSClass', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gPRSMSClass),
        (u'endUserAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress),
        (u'qualityOfService', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_qualityOfService),
        (u'accessPointName', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_accessPointName),
        (u'routeingAreaIdentity', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_routeingAreaIdentity),
        (u'chargingID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_chargingID),
        (u'sGSNCapabilities', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_sGSNCapabilities),
        (u'locationInformationGPRS', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_locationInformationGPRS),
        (u'pDPInitiationType', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_pDPInitiationType),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions),
        (u'gGSNAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gGSNAddress),
        (u'secondaryPDP-context', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_secondaryPDP_context),
        (u'iMEI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_iMEI),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33._cont = ASN1Dict([
        (u'serviceKey', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_serviceKey),
        (u'destinationSubscriberNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_destinationSubscriberNumber),
        (u'callingPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_callingPartyNumber),
        (u'eventTypeSMS', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_eventTypeSMS),
        (u'iMSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_iMSI),
        (u'locationInformationMSC', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_locationInformationMSC),
        (u'locationInformationGPRS', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_locationInformationGPRS),
        (u'sMSCAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_sMSCAddress),
        (u'timeAndTimezone', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPDataCodingScheme),
        (u'tPValidityPeriod', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPValidityPeriod),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions),
        (u'smsReferenceNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_smsReferenceNumber),
        (u'mscAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_mscAddress),
        (u'sgsn-Number', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_sgsn_Number),
        (u'ms-Classmark2', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_ms_Classmark2),
        (u'gPRSMSClass', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_gPRSMSClass),
        (u'iMEI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_iMEI),
        (u'calledPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_calledPartyNumber),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions),
        (u'legToBeCreated', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_legToBeCreated),
        (u'newCallSegment', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_newCallSegment),
        (u'callingPartyNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callingPartyNumber),
        (u'callReferenceNumber', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callReferenceNumber),
        (u'gsmSCFAddress', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_gsmSCFAddress),
        (u'suppress-T-CSI', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_suppress_T_CSI),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34._cont = ASN1Dict([
        (u'supportedCamelPhases', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_offeredCamel4Functionalities),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions),
        (u'releaseCallArgExtensionAllowed', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_releaseCallArgExtensionAllowed),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34._ext = [u'releaseCallArgExtensionAllowed']
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35._cont = ASN1Dict([
        (u'legIDToMove', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_legIDToMove),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_duration),
        (u'interval', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_interval),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo),
        (u'tone', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_tone),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36._cont = ASN1Dict([
        (u'informationToSend', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend),
        (u'disconnectFromIPForbidden', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_requestAnnouncementCompleteNotification),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions),
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_requestAnnouncementStartedNotification),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_callSegmentID),
        (u'legID', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_legID),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37._cont = ASN1Dict([
        (u'legOrCallSegment', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment),
        (u'bursts', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_bursts),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text._ext = None
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_duration),
        (u'interval', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_interval),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo._ext = []
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo),
        (u'tone', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_tone),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend._ext = None
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38._cont = ASN1Dict([
        (u'collectedInfo', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_collectedInfo),
        (u'disconnectFromIPForbidden', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_disconnectFromIPForbidden),
        (u'informationToSend', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions),
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_requestAnnouncementStartedNotification),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38._cont = ASN1Dict([
        (u'digitsResponse', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38_digitsResponse),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions._cont = ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions__item_
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions),
        ])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39._cont = ASN1Dict([
        (u'allCallSegments', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegments),
        (u'allCallSegmentsWithExtension', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40._cont = ASN1Dict([
        (u'gprsCause', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_gprsCause),
        (u'pDPID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_pDPID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_41 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__monitorMode),
        (u'legID', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__automaticRearm),
        ])
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item_._ext = []
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42._cont = ASN1Dict([
        (u'bcsmEvents', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43._cont = ASN1Dict([
        (u'gPRSEvent', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent),
        (u'pDPID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_pDPID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44._cont = ASN1Dict([
        (u'sMSEvents', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45._cont = ASN1Dict([
        (u'timerID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_timerID),
        (u'timervalue', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_timervalue),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions),
        (u'callSegmentID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_callSegmentID),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_46 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47._cont = ASN1Dict([
        (u'timerID', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_timerID),
        (u'timervalue', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_timervalue),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_partyToCharge),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49._ext = []
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_50 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions._cont = ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions__item_
    __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51._cont = ASN1Dict([
        (u'legToBeSplit', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_legToBeSplit),
        (u'newCallSegment', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_newCallSegment),
        (u'extensions', __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions),
        ])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51._ext = []
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34), (u'ResultType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38), (u'ResultType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_41), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_46), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_50), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))]), dict([(u'ArgumentType', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult._ext = None
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_11 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_11._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_11._ext = None
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_problem._ext = None
    _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12._cont = ASN1Dict([
        (u'problem', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_problem),
        (u'operation', _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_operation),
        ])
    ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12._ext = []
    _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 6))]), dict([(u'ParameterType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_11), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError._ext = None
    _____TCAP_CAP_Message_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_CAP_Message_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____TCAP_CAP_Message_unidirectional_components__item__basicROS_reject),
        ])
    ____TCAP_CAP_Message_unidirectional_components__item__basicROS._ext = None
    ____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast._ext = None
    ___TCAP_CAP_Message_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____TCAP_CAP_Message_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast),
        ])
    ___TCAP_CAP_Message_unidirectional_components__item_._ext = None
    __TCAP_CAP_Message_unidirectional_components._cont = ___TCAP_CAP_Message_unidirectional_components__item_
    __TCAP_CAP_Message_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_CAP_Message_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __TCAP_CAP_Message_unidirectional_dialoguePortion),
        (u'components', __TCAP_CAP_Message_unidirectional_components),
        ])
    _TCAP_CAP_Message_unidirectional._ext = None
    _TCAP_CAP_Message_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __TCAP_CAP_Message_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __TCAP_CAP_Message_begin_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_CAP_Message_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___TCAP_CAP_Message_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_CAP_Message_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_CAP_Message_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_opcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_argument._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____TCAP_CAP_Message_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_argument),
        ])
    _____TCAP_CAP_Message_begin_components__item__basicROS_invoke._ext = None
    _____TCAP_CAP_Message_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result._ext = None
    _____TCAP_CAP_Message_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result),
        ])
    _____TCAP_CAP_Message_begin_components__item__basicROS_returnResult._ext = None
    _____TCAP_CAP_Message_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_errcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_parameter._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____TCAP_CAP_Message_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_CAP_Message_begin_components__item__basicROS_returnError._ext = None
    _____TCAP_CAP_Message_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_CAP_Message_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____TCAP_CAP_Message_begin_components__item__basicROS_invoke),
        (u'returnResult', _____TCAP_CAP_Message_begin_components__item__basicROS_returnResult),
        (u'returnError', _____TCAP_CAP_Message_begin_components__item__basicROS_returnError),
        (u'reject', _____TCAP_CAP_Message_begin_components__item__basicROS_reject),
        ])
    ____TCAP_CAP_Message_begin_components__item__basicROS._ext = None
    ____TCAP_CAP_Message_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_result._ext = None
    ____TCAP_CAP_Message_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_result),
        ])
    ____TCAP_CAP_Message_begin_components__item__returnResultNotLast._ext = None
    ___TCAP_CAP_Message_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____TCAP_CAP_Message_begin_components__item__basicROS),
        (u'returnResultNotLast', ____TCAP_CAP_Message_begin_components__item__returnResultNotLast),
        ])
    ___TCAP_CAP_Message_begin_components__item_._ext = None
    __TCAP_CAP_Message_begin_components._cont = ___TCAP_CAP_Message_begin_components__item_
    __TCAP_CAP_Message_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_CAP_Message_begin._cont = ASN1Dict([
        (u'otid', __TCAP_CAP_Message_begin_otid),
        (u'dialoguePortion', __TCAP_CAP_Message_begin_dialoguePortion),
        (u'components', __TCAP_CAP_Message_begin_components),
        ])
    _TCAP_CAP_Message_begin._ext = None
    _TCAP_CAP_Message_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __TCAP_CAP_Message_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __TCAP_CAP_Message_end_dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_CAP_Message_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___TCAP_CAP_Message_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_CAP_Message_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_CAP_Message_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_opcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_argument._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____TCAP_CAP_Message_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______TCAP_CAP_Message_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______TCAP_CAP_Message_end_components__item__basicROS_invoke_argument),
        ])
    _____TCAP_CAP_Message_end_components__item__basicROS_invoke._ext = None
    _____TCAP_CAP_Message_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result._ext = None
    _____TCAP_CAP_Message_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result),
        ])
    _____TCAP_CAP_Message_end_components__item__basicROS_returnResult._ext = None
    _____TCAP_CAP_Message_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_errcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_parameter._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______TCAP_CAP_Message_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____TCAP_CAP_Message_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______TCAP_CAP_Message_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______TCAP_CAP_Message_end_components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_CAP_Message_end_components__item__basicROS_returnError._ext = None
    _____TCAP_CAP_Message_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_CAP_Message_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____TCAP_CAP_Message_end_components__item__basicROS_invoke),
        (u'returnResult', _____TCAP_CAP_Message_end_components__item__basicROS_returnResult),
        (u'returnError', _____TCAP_CAP_Message_end_components__item__basicROS_returnError),
        (u'reject', _____TCAP_CAP_Message_end_components__item__basicROS_reject),
        ])
    ____TCAP_CAP_Message_end_components__item__basicROS._ext = None
    ____TCAP_CAP_Message_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____TCAP_CAP_Message_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_CAP_Message_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____TCAP_CAP_Message_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_CAP_Message_end_components__item__returnResultNotLast_result._ext = None
    ____TCAP_CAP_Message_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____TCAP_CAP_Message_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____TCAP_CAP_Message_end_components__item__returnResultNotLast_result),
        ])
    ____TCAP_CAP_Message_end_components__item__returnResultNotLast._ext = None
    ___TCAP_CAP_Message_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____TCAP_CAP_Message_end_components__item__basicROS),
        (u'returnResultNotLast', ____TCAP_CAP_Message_end_components__item__returnResultNotLast),
        ])
    ___TCAP_CAP_Message_end_components__item_._ext = None
    __TCAP_CAP_Message_end_components._cont = ___TCAP_CAP_Message_end_components__item_
    __TCAP_CAP_Message_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_CAP_Message_end._cont = ASN1Dict([
        (u'dtid', __TCAP_CAP_Message_end_dtid),
        (u'dialoguePortion', __TCAP_CAP_Message_end_dialoguePortion),
        (u'components', __TCAP_CAP_Message_end_components),
        ])
    _TCAP_CAP_Message_end._ext = None
    _TCAP_CAP_Message_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __TCAP_CAP_Message_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __TCAP_CAP_Message_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __TCAP_CAP_Message_continue__dialoguePortion = SEQ(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __TCAP_CAP_Message_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___TCAP_CAP_Message_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____TCAP_CAP_Message_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____TCAP_CAP_Message_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_opcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_argument._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____TCAP_CAP_Message_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_argument),
        ])
    _____TCAP_CAP_Message_continue__components__item__basicROS_invoke._ext = None
    _____TCAP_CAP_Message_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result._ext = None
    _____TCAP_CAP_Message_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result),
        ])
    _____TCAP_CAP_Message_continue__components__item__basicROS_returnResult._ext = None
    _____TCAP_CAP_Message_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_errcode._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_parameter._const_tab = _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____TCAP_CAP_Message_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_parameter),
        ])
    _____TCAP_CAP_Message_continue__components__item__basicROS_returnError._ext = None
    _____TCAP_CAP_Message_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____TCAP_CAP_Message_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____TCAP_CAP_Message_continue__components__item__basicROS_invoke),
        (u'returnResult', _____TCAP_CAP_Message_continue__components__item__basicROS_returnResult),
        (u'returnError', _____TCAP_CAP_Message_continue__components__item__basicROS_returnError),
        (u'reject', _____TCAP_CAP_Message_continue__components__item__basicROS_reject),
        ])
    ____TCAP_CAP_Message_continue__components__item__basicROS._ext = None
    ____TCAP_CAP_Message_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_result._const_tab = ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_result),
        ])
    _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_result._ext = None
    ____TCAP_CAP_Message_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_result),
        ])
    ____TCAP_CAP_Message_continue__components__item__returnResultNotLast._ext = None
    ___TCAP_CAP_Message_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____TCAP_CAP_Message_continue__components__item__basicROS),
        (u'returnResultNotLast', ____TCAP_CAP_Message_continue__components__item__returnResultNotLast),
        ])
    ___TCAP_CAP_Message_continue__components__item_._ext = None
    __TCAP_CAP_Message_continue__components._cont = ___TCAP_CAP_Message_continue__components__item_
    __TCAP_CAP_Message_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TCAP_CAP_Message_continue_._cont = ASN1Dict([
        (u'otid', __TCAP_CAP_Message_continue__otid),
        (u'dtid', __TCAP_CAP_Message_continue__dtid),
        (u'dialoguePortion', __TCAP_CAP_Message_continue__dialoguePortion),
        (u'components', __TCAP_CAP_Message_continue__components),
        ])
    _TCAP_CAP_Message_continue_._ext = None
    _TCAP_CAP_Message_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    TCAP_CAP_Message._cont = ASN1Dict([
        (u'unidirectional', _TCAP_CAP_Message_unidirectional),
        (u'begin', _TCAP_CAP_Message_begin),
        (u'end', _TCAP_CAP_Message_end),
        (u'continue', _TCAP_CAP_Message_continue_),
        (u'abort', _TCAP_CAP_Message_abort),
        ])
    TCAP_CAP_Message._ext = None
    
    #-----< AllCAPInvokable >-----#
    AllCAPInvokable = CLASS(name=u'AllCAPInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AllCAPInvokable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __AllCAPInvokable_val_ArgumentType_2_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __AllCAPInvokable_val_ArgumentType_2_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_2_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __AllCAPInvokable_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_2_extensions._cont = ___AllCAPInvokable_val_ArgumentType_2_extensions__item_
    __AllCAPInvokable_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_2_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_2_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_legID),
        (u'srfConnection', ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_srfConnection),
        ])
    __AllCAPInvokable_val_ArgumentType_2_aChChargingAddress._ext = None
    _AllCAPInvokable_val_ArgumentType_2._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __AllCAPInvokable_val_ArgumentType_2_aChBillingChargingCharacteristics),
        (u'partyToCharge', __AllCAPInvokable_val_ArgumentType_2_partyToCharge),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_2_extensions),
        (u'aChChargingAddress', __AllCAPInvokable_val_ArgumentType_2_aChChargingAddress),
        ])
    _AllCAPInvokable_val_ArgumentType_2._ext = []
    _AllCAPInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _AllCAPInvokable_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _AllCAPInvokable_val_ArgumentType_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _AllCAPInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AllCAPInvokable_val_ArgumentType_6_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AllCAPInvokable_val_ArgumentType_6_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_6_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AllCAPInvokable_val_ArgumentType_6_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_6_extensions._cont = ___AllCAPInvokable_val_ArgumentType_6_extensions__item_
    __AllCAPInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'correlationID', __AllCAPInvokable_val_ArgumentType_6_correlationID),
        (u'iPSSPCapabilities', __AllCAPInvokable_val_ArgumentType_6_iPSSPCapabilities),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_6_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_6._ext = []
    _AllCAPInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __AllCAPInvokable_val_ArgumentType_7_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue._ext = None
    ___AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue),
        ])
    ___AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item_._ext = []
    __AllCAPInvokable_val_ArgumentType_7_requestedInformationList._cont = ___AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item_
    __AllCAPInvokable_val_ArgumentType_7_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_7_extensions._cont = ___AllCAPInvokable_val_ArgumentType_7_extensions__item_
    __AllCAPInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_7_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _AllCAPInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'requestedInformationList', __AllCAPInvokable_val_ArgumentType_7_requestedInformationList),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_7_extensions),
        (u'legID', __AllCAPInvokable_val_ArgumentType_7_legID),
        ])
    _AllCAPInvokable_val_ArgumentType_7._ext = []
    _AllCAPInvokable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __AllCAPInvokable_val_ArgumentType_8_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __AllCAPInvokable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_8_extensions._cont = ___AllCAPInvokable_val_ArgumentType_8_extensions__item_
    __AllCAPInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_8_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _AllCAPInvokable_val_ArgumentType_8._cont = ASN1Dict([
        (u'requestedInformationTypeList', __AllCAPInvokable_val_ArgumentType_8_requestedInformationTypeList),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_8_extensions),
        (u'legID', __AllCAPInvokable_val_ArgumentType_8_legID),
        ])
    _AllCAPInvokable_val_ArgumentType_8._ext = []
    _AllCAPInvokable_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AllCAPInvokable_val_ArgumentType_9_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AllCAPInvokable_val_ArgumentType_9_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_callSegmentID),
        ])
    __AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel._ext = []
    _AllCAPInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'invokeID', __AllCAPInvokable_val_ArgumentType_9_invokeID),
        (u'allRequests', __AllCAPInvokable_val_ArgumentType_9_allRequests),
        (u'callSegmentToCancel', __AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel),
        ])
    _AllCAPInvokable_val_ArgumentType_9._ext = None
    _AllCAPInvokable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _AllCAPInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __AllCAPInvokable_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_11_extensions._cont = ___AllCAPInvokable_val_ArgumentType_11_extensions__item_
    __AllCAPInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_11._cont = ASN1Dict([
        (u'extensions', __AllCAPInvokable_val_ArgumentType_11_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_11._ext = []
    _AllCAPInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress._cont = ___AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress__item_
    __AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_12_extensions._cont = ___AllCAPInvokable_val_ArgumentType_12_extensions__item_
    __AllCAPInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_12_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___AllCAPInvokable_val_ArgumentType_12_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_genericNumbers._cont = ___AllCAPInvokable_val_ArgumentType_12_genericNumbers__item_
    __AllCAPInvokable_val_ArgumentType_12_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_12_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_12_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AllCAPInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'destinationRoutingAddress', __AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress),
        (u'alertingPattern', __AllCAPInvokable_val_ArgumentType_12_alertingPattern),
        (u'originalCalledPartyID', __AllCAPInvokable_val_ArgumentType_12_originalCalledPartyID),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_12_extensions),
        (u'carrier', __AllCAPInvokable_val_ArgumentType_12_carrier),
        (u'callingPartysCategory', __AllCAPInvokable_val_ArgumentType_12_callingPartysCategory),
        (u'redirectingPartyID', __AllCAPInvokable_val_ArgumentType_12_redirectingPartyID),
        (u'redirectionInformation', __AllCAPInvokable_val_ArgumentType_12_redirectionInformation),
        (u'genericNumbers', __AllCAPInvokable_val_ArgumentType_12_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __AllCAPInvokable_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __AllCAPInvokable_val_ArgumentType_12_chargeNumber),
        (u'legToBeConnected', __AllCAPInvokable_val_ArgumentType_12_legToBeConnected),
        (u'cug-Interlock', __AllCAPInvokable_val_ArgumentType_12_cug_Interlock),
        (u'cug-OutgoingAccess', __AllCAPInvokable_val_ArgumentType_12_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __AllCAPInvokable_val_ArgumentType_12_suppressionOfAnnouncement),
        (u'oCSIApplicable', __AllCAPInvokable_val_ArgumentType_12_oCSIApplicable),
        (u'naOliInfo', __AllCAPInvokable_val_ArgumentType_12_naOliInfo),
        (u'bor-InterrogationRequested', __AllCAPInvokable_val_ArgumentType_12_bor_InterrogationRequested),
        (u'suppress-N-CSI', __AllCAPInvokable_val_ArgumentType_12_suppress_N_CSI),
        ])
    _AllCAPInvokable_val_ArgumentType_12._ext = [u'suppress-N-CSI']
    _AllCAPInvokable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __AllCAPInvokable_val_ArgumentType_13_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __AllCAPInvokable_val_ArgumentType_13_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_13_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPInvokable_val_ArgumentType_13._cont = ASN1Dict([
        (u'accessPointName', __AllCAPInvokable_val_ArgumentType_13_accessPointName),
        (u'pdpID', __AllCAPInvokable_val_ArgumentType_13_pdpID),
        ])
    _AllCAPInvokable_val_ArgumentType_13._ext = []
    _AllCAPInvokable_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __AllCAPInvokable_val_ArgumentType_14_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_14_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_14_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_14_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_14_extensions._cont = ___AllCAPInvokable_val_ArgumentType_14_extensions__item_
    __AllCAPInvokable_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_14._cont = ASN1Dict([
        (u'callingPartysNumber', __AllCAPInvokable_val_ArgumentType_14_callingPartysNumber),
        (u'destinationSubscriberNumber', __AllCAPInvokable_val_ArgumentType_14_destinationSubscriberNumber),
        (u'sMSCAddress', __AllCAPInvokable_val_ArgumentType_14_sMSCAddress),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_14_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_14._ext = []
    _AllCAPInvokable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AllCAPInvokable_val_ArgumentType_15_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AllCAPInvokable_val_ArgumentType_15_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_ipRoutingAddress),
        (u'none', ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_none),
        ])
    __AllCAPInvokable_val_ArgumentType_15_resourceAddress._ext = None
    __AllCAPInvokable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_15_extensions._cont = ___AllCAPInvokable_val_ArgumentType_15_extensions__item_
    __AllCAPInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_15._cont = ASN1Dict([
        (u'resourceAddress', __AllCAPInvokable_val_ArgumentType_15_resourceAddress),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_15_extensions),
        (u'serviceInteractionIndicatorsTwo', __AllCAPInvokable_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AllCAPInvokable_val_ArgumentType_15_callSegmentID),
        ])
    _AllCAPInvokable_val_ArgumentType_15._ext = []
    _AllCAPInvokable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __AllCAPInvokable_val_ArgumentType_17_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_17_extensions._cont = ___AllCAPInvokable_val_ArgumentType_17_extensions__item_
    __AllCAPInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_17_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___AllCAPInvokable_val_ArgumentType_17_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_17_genericNumbers._cont = ___AllCAPInvokable_val_ArgumentType_17_genericNumbers__item_
    __AllCAPInvokable_val_ArgumentType_17_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_17_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension._ext = []
    _AllCAPInvokable_val_ArgumentType_17._cont = ASN1Dict([
        (u'alertingPattern', __AllCAPInvokable_val_ArgumentType_17_alertingPattern),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_17_extensions),
        (u'serviceInteractionIndicatorsTwo', __AllCAPInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __AllCAPInvokable_val_ArgumentType_17_callingPartysCategory),
        (u'genericNumbers', __AllCAPInvokable_val_ArgumentType_17_genericNumbers),
        (u'cug-Interlock', __AllCAPInvokable_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __AllCAPInvokable_val_ArgumentType_17_cug_OutgoingAccess),
        (u'chargeNumber', __AllCAPInvokable_val_ArgumentType_17_chargeNumber),
        (u'carrier', __AllCAPInvokable_val_ArgumentType_17_carrier),
        (u'suppressionOfAnnouncement', __AllCAPInvokable_val_ArgumentType_17_suppressionOfAnnouncement),
        (u'naOliInfo', __AllCAPInvokable_val_ArgumentType_17_naOliInfo),
        (u'bor-InterrogationRequested', __AllCAPInvokable_val_ArgumentType_17_bor_InterrogationRequested),
        (u'suppress-O-CSI', __AllCAPInvokable_val_ArgumentType_17_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension),
        ])
    _AllCAPInvokable_val_ArgumentType_17._ext = []
    _AllCAPInvokable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __AllCAPInvokable_val_ArgumentType_19_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_19_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_19_extensions._cont = ___AllCAPInvokable_val_ArgumentType_19_extensions__item_
    __AllCAPInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_19._cont = ASN1Dict([
        (u'callSegmentID', __AllCAPInvokable_val_ArgumentType_19_callSegmentID),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_19_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_19._ext = []
    _AllCAPInvokable_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __AllCAPInvokable_val_ArgumentType_20_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPInvokable_val_ArgumentType_20_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __AllCAPInvokable_val_ArgumentType_20_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_20_extensions._cont = ___AllCAPInvokable_val_ArgumentType_20_extensions__item_
    __AllCAPInvokable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_20._cont = ASN1Dict([
        (u'legToBeReleased', __AllCAPInvokable_val_ArgumentType_20_legToBeReleased),
        (u'releaseCause', __AllCAPInvokable_val_ArgumentType_20_releaseCause),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_20_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_20._ext = []
    _AllCAPInvokable_val_ArgumentType_21 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __AllCAPInvokable_val_ArgumentType_21_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_21_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_callSegmentID),
        (u'cause', ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_cause),
        ])
    __AllCAPInvokable_val_ArgumentType_21_callSegmentFailure._ext = []
    __AllCAPInvokable_val_ArgumentType_21_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_21_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_legID),
        (u'cause', ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_cause),
        ])
    __AllCAPInvokable_val_ArgumentType_21_bCSM_Failure._ext = []
    _AllCAPInvokable_val_ArgumentType_21._cont = ASN1Dict([
        (u'callSegmentFailure', __AllCAPInvokable_val_ArgumentType_21_callSegmentFailure),
        (u'bCSM-Failure', __AllCAPInvokable_val_ArgumentType_21_bCSM_Failure),
        ])
    _AllCAPInvokable_val_ArgumentType_21._ext = None
    _AllCAPInvokable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __AllCAPInvokable_val_ArgumentType_22_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __AllCAPInvokable_val_ArgumentType_22_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_22_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPInvokable_val_ArgumentType_22._cont = ASN1Dict([
        (u'gPRSCause', __AllCAPInvokable_val_ArgumentType_22_gPRSCause),
        (u'pDPID', __AllCAPInvokable_val_ArgumentType_22_pDPID),
        ])
    _AllCAPInvokable_val_ArgumentType_22._ext = []
    _AllCAPInvokable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __AllCAPInvokable_val_ArgumentType_23_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __AllCAPInvokable_val_ArgumentType_23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_23_extensions._cont = ___AllCAPInvokable_val_ArgumentType_23_extensions__item_
    __AllCAPInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_23_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_23._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __AllCAPInvokable_val_ArgumentType_23_assistingSSPIPRoutingAddress),
        (u'correlationID', __AllCAPInvokable_val_ArgumentType_23_correlationID),
        (u'scfID', __AllCAPInvokable_val_ArgumentType_23_scfID),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_23_extensions),
        (u'carrier', __AllCAPInvokable_val_ArgumentType_23_carrier),
        (u'serviceInteractionIndicatorsTwo', __AllCAPInvokable_val_ArgumentType_23_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AllCAPInvokable_val_ArgumentType_23_callSegmentID),
        (u'naOliInfo', __AllCAPInvokable_val_ArgumentType_23_naOliInfo),
        (u'chargeNumber', __AllCAPInvokable_val_ArgumentType_23_chargeNumber),
        (u'originalCalledPartyID', __AllCAPInvokable_val_ArgumentType_23_originalCalledPartyID),
        (u'callingPartyNumber', __AllCAPInvokable_val_ArgumentType_23_callingPartyNumber),
        ])
    _AllCAPInvokable_val_ArgumentType_23._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _AllCAPInvokable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __AllCAPInvokable_val_ArgumentType_24_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM._ext = None
    __AllCAPInvokable_val_ArgumentType_24_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_24_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __AllCAPInvokable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_24_extensions._cont = ___AllCAPInvokable_val_ArgumentType_24_extensions__item_
    __AllCAPInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_24._cont = ASN1Dict([
        (u'eventTypeBCSM', __AllCAPInvokable_val_ArgumentType_24_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM),
        (u'legID', __AllCAPInvokable_val_ArgumentType_24_legID),
        (u'miscCallInfo', __AllCAPInvokable_val_ArgumentType_24_miscCallInfo),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_24_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_24._ext = []
    _AllCAPInvokable_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    __AllCAPInvokable_val_ArgumentType_25_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __AllCAPInvokable_val_ArgumentType_25_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    __AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    __AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation._ext = None
    __AllCAPInvokable_val_ArgumentType_25_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPInvokable_val_ArgumentType_25._cont = ASN1Dict([
        (u'gPRSEventType', __AllCAPInvokable_val_ArgumentType_25_gPRSEventType),
        (u'miscGPRSInfo', __AllCAPInvokable_val_ArgumentType_25_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', __AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation),
        (u'pDPID', __AllCAPInvokable_val_ArgumentType_25_pDPID),
        ])
    _AllCAPInvokable_val_ArgumentType_25._ext = []
    _AllCAPInvokable_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    __AllCAPInvokable_val_ArgumentType_26_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    __AllCAPInvokable_val_ArgumentType_26_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    __AllCAPInvokable_val_ArgumentType_26_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __AllCAPInvokable_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_26_extensions._cont = ___AllCAPInvokable_val_ArgumentType_26_extensions__item_
    __AllCAPInvokable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_26._cont = ASN1Dict([
        (u'eventTypeSMS', __AllCAPInvokable_val_ArgumentType_26_eventTypeSMS),
        (u'eventSpecificInformationSMS', __AllCAPInvokable_val_ArgumentType_26_eventSpecificInformationSMS),
        (u'miscCallInfo', __AllCAPInvokable_val_ArgumentType_26_miscCallInfo),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_26_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_26._ext = []
    _AllCAPInvokable_val_ArgumentType_27 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _AllCAPInvokable_val_ArgumentType_27._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_28 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _AllCAPInvokable_val_ArgumentType_28._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_29 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _AllCAPInvokable_val_ArgumentType_29._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_30 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __AllCAPInvokable_val_ArgumentType_30_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __AllCAPInvokable_val_ArgumentType_30_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_30_extensions._cont = ___AllCAPInvokable_val_ArgumentType_30_extensions__item_
    __AllCAPInvokable_val_ArgumentType_30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_30_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___AllCAPInvokable_val_ArgumentType_30_bearerCapability_bearerCap),
        ])
    __AllCAPInvokable_val_ArgumentType_30_bearerCapability._ext = None
    __AllCAPInvokable_val_ArgumentType_30_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_30_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2._ext = None
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _AllCAPInvokable_val_ArgumentType_30._cont = ASN1Dict([
        (u'serviceKey', __AllCAPInvokable_val_ArgumentType_30_serviceKey),
        (u'calledPartyNumber', __AllCAPInvokable_val_ArgumentType_30_calledPartyNumber),
        (u'callingPartyNumber', __AllCAPInvokable_val_ArgumentType_30_callingPartyNumber),
        (u'callingPartysCategory', __AllCAPInvokable_val_ArgumentType_30_callingPartysCategory),
        (u'cGEncountered', __AllCAPInvokable_val_ArgumentType_30_cGEncountered),
        (u'iPSSPCapabilities', __AllCAPInvokable_val_ArgumentType_30_iPSSPCapabilities),
        (u'locationNumber', __AllCAPInvokable_val_ArgumentType_30_locationNumber),
        (u'originalCalledPartyID', __AllCAPInvokable_val_ArgumentType_30_originalCalledPartyID),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_30_extensions),
        (u'highLayerCompatibility', __AllCAPInvokable_val_ArgumentType_30_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __AllCAPInvokable_val_ArgumentType_30_additionalCallingPartyNumber),
        (u'bearerCapability', __AllCAPInvokable_val_ArgumentType_30_bearerCapability),
        (u'eventTypeBCSM', __AllCAPInvokable_val_ArgumentType_30_eventTypeBCSM),
        (u'redirectingPartyID', __AllCAPInvokable_val_ArgumentType_30_redirectingPartyID),
        (u'redirectionInformation', __AllCAPInvokable_val_ArgumentType_30_redirectionInformation),
        (u'cause', __AllCAPInvokable_val_ArgumentType_30_cause),
        (u'serviceInteractionIndicatorsTwo', __AllCAPInvokable_val_ArgumentType_30_serviceInteractionIndicatorsTwo),
        (u'carrier', __AllCAPInvokable_val_ArgumentType_30_carrier),
        (u'cug-Index', __AllCAPInvokable_val_ArgumentType_30_cug_Index),
        (u'cug-Interlock', __AllCAPInvokable_val_ArgumentType_30_cug_Interlock),
        (u'cug-OutgoingAccess', __AllCAPInvokable_val_ArgumentType_30_cug_OutgoingAccess),
        (u'iMSI', __AllCAPInvokable_val_ArgumentType_30_iMSI),
        (u'subscriberState', __AllCAPInvokable_val_ArgumentType_30_subscriberState),
        (u'locationInformation', __AllCAPInvokable_val_ArgumentType_30_locationInformation),
        (u'ext-basicServiceCode', __AllCAPInvokable_val_ArgumentType_30_ext_basicServiceCode),
        (u'callReferenceNumber', __AllCAPInvokable_val_ArgumentType_30_callReferenceNumber),
        (u'mscAddress', __AllCAPInvokable_val_ArgumentType_30_mscAddress),
        (u'calledPartyBCDNumber', __AllCAPInvokable_val_ArgumentType_30_calledPartyBCDNumber),
        (u'timeAndTimezone', __AllCAPInvokable_val_ArgumentType_30_timeAndTimezone),
        (u'callForwardingSS-Pending', __AllCAPInvokable_val_ArgumentType_30_callForwardingSS_Pending),
        (u'initialDPArgExtension', __AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension),
        ])
    _AllCAPInvokable_val_ArgumentType_30._ext = []
    _AllCAPInvokable_val_ArgumentType_31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __AllCAPInvokable_val_ArgumentType_31_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __AllCAPInvokable_val_ArgumentType_31_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __AllCAPInvokable_val_ArgumentType_31_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __AllCAPInvokable_val_ArgumentType_31_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __AllCAPInvokable_val_ArgumentType_31_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __AllCAPInvokable_val_ArgumentType_31_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_31_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_31_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPAddress),
        ])
    __AllCAPInvokable_val_ArgumentType_31_endUserAddress._ext = None
    __AllCAPInvokable_val_ArgumentType_31_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_31_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_31_extensions._cont = ___AllCAPInvokable_val_ArgumentType_31_extensions__item_
    __AllCAPInvokable_val_ArgumentType_31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_31_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPInvokable_val_ArgumentType_31_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _AllCAPInvokable_val_ArgumentType_31._cont = ASN1Dict([
        (u'serviceKey', __AllCAPInvokable_val_ArgumentType_31_serviceKey),
        (u'gPRSEventType', __AllCAPInvokable_val_ArgumentType_31_gPRSEventType),
        (u'mSISDN', __AllCAPInvokable_val_ArgumentType_31_mSISDN),
        (u'iMSI', __AllCAPInvokable_val_ArgumentType_31_iMSI),
        (u'timeAndTimeZone', __AllCAPInvokable_val_ArgumentType_31_timeAndTimeZone),
        (u'gPRSMSClass', __AllCAPInvokable_val_ArgumentType_31_gPRSMSClass),
        (u'endUserAddress', __AllCAPInvokable_val_ArgumentType_31_endUserAddress),
        (u'qualityOfService', __AllCAPInvokable_val_ArgumentType_31_qualityOfService),
        (u'accessPointName', __AllCAPInvokable_val_ArgumentType_31_accessPointName),
        (u'routeingAreaIdentity', __AllCAPInvokable_val_ArgumentType_31_routeingAreaIdentity),
        (u'chargingID', __AllCAPInvokable_val_ArgumentType_31_chargingID),
        (u'sGSNCapabilities', __AllCAPInvokable_val_ArgumentType_31_sGSNCapabilities),
        (u'locationInformationGPRS', __AllCAPInvokable_val_ArgumentType_31_locationInformationGPRS),
        (u'pDPInitiationType', __AllCAPInvokable_val_ArgumentType_31_pDPInitiationType),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_31_extensions),
        (u'gGSNAddress', __AllCAPInvokable_val_ArgumentType_31_gGSNAddress),
        (u'secondaryPDP-context', __AllCAPInvokable_val_ArgumentType_31_secondaryPDP_context),
        (u'iMEI', __AllCAPInvokable_val_ArgumentType_31_iMEI),
        ])
    _AllCAPInvokable_val_ArgumentType_31._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _AllCAPInvokable_val_ArgumentType_32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __AllCAPInvokable_val_ArgumentType_32_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __AllCAPInvokable_val_ArgumentType_32_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_32_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_32_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_32_extensions._cont = ___AllCAPInvokable_val_ArgumentType_32_extensions__item_
    __AllCAPInvokable_val_ArgumentType_32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_32_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __AllCAPInvokable_val_ArgumentType_32_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AllCAPInvokable_val_ArgumentType_32._cont = ASN1Dict([
        (u'serviceKey', __AllCAPInvokable_val_ArgumentType_32_serviceKey),
        (u'destinationSubscriberNumber', __AllCAPInvokable_val_ArgumentType_32_destinationSubscriberNumber),
        (u'callingPartyNumber', __AllCAPInvokable_val_ArgumentType_32_callingPartyNumber),
        (u'eventTypeSMS', __AllCAPInvokable_val_ArgumentType_32_eventTypeSMS),
        (u'iMSI', __AllCAPInvokable_val_ArgumentType_32_iMSI),
        (u'locationInformationMSC', __AllCAPInvokable_val_ArgumentType_32_locationInformationMSC),
        (u'locationInformationGPRS', __AllCAPInvokable_val_ArgumentType_32_locationInformationGPRS),
        (u'sMSCAddress', __AllCAPInvokable_val_ArgumentType_32_sMSCAddress),
        (u'timeAndTimezone', __AllCAPInvokable_val_ArgumentType_32_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __AllCAPInvokable_val_ArgumentType_32_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __AllCAPInvokable_val_ArgumentType_32_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __AllCAPInvokable_val_ArgumentType_32_tPDataCodingScheme),
        (u'tPValidityPeriod', __AllCAPInvokable_val_ArgumentType_32_tPValidityPeriod),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_32_extensions),
        (u'smsReferenceNumber', __AllCAPInvokable_val_ArgumentType_32_smsReferenceNumber),
        (u'mscAddress', __AllCAPInvokable_val_ArgumentType_32_mscAddress),
        (u'sgsn-Number', __AllCAPInvokable_val_ArgumentType_32_sgsn_Number),
        (u'ms-Classmark2', __AllCAPInvokable_val_ArgumentType_32_ms_Classmark2),
        (u'gPRSMSClass', __AllCAPInvokable_val_ArgumentType_32_gPRSMSClass),
        (u'iMEI', __AllCAPInvokable_val_ArgumentType_32_iMEI),
        (u'calledPartyNumber', __AllCAPInvokable_val_ArgumentType_32_calledPartyNumber),
        ])
    _AllCAPInvokable_val_ArgumentType_32._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _AllCAPInvokable_val_ArgumentType_33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress._cont = ___AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress__item_
    __AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_33_extensions._cont = ___AllCAPInvokable_val_ArgumentType_33_extensions__item_
    __AllCAPInvokable_val_ArgumentType_33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_33_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_33_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_33_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_33_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_33_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_33_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __AllCAPInvokable_val_ArgumentType_33_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPInvokable_val_ArgumentType_33_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AllCAPInvokable_val_ArgumentType_33._cont = ASN1Dict([
        (u'destinationRoutingAddress', __AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_33_extensions),
        (u'legToBeCreated', __AllCAPInvokable_val_ArgumentType_33_legToBeCreated),
        (u'newCallSegment', __AllCAPInvokable_val_ArgumentType_33_newCallSegment),
        (u'callingPartyNumber', __AllCAPInvokable_val_ArgumentType_33_callingPartyNumber),
        (u'callReferenceNumber', __AllCAPInvokable_val_ArgumentType_33_callReferenceNumber),
        (u'gsmSCFAddress', __AllCAPInvokable_val_ArgumentType_33_gsmSCFAddress),
        (u'suppress-T-CSI', __AllCAPInvokable_val_ArgumentType_33_suppress_T_CSI),
        ])
    _AllCAPInvokable_val_ArgumentType_33._ext = []
    _AllCAPInvokable_val_ResultType_33 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __AllCAPInvokable_val_ResultType_33_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __AllCAPInvokable_val_ResultType_33_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __AllCAPInvokable_val_ResultType_33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ResultType_33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ResultType_33_extensions._cont = ___AllCAPInvokable_val_ResultType_33_extensions__item_
    __AllCAPInvokable_val_ResultType_33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ResultType_33_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AllCAPInvokable_val_ResultType_33._cont = ASN1Dict([
        (u'supportedCamelPhases', __AllCAPInvokable_val_ResultType_33_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __AllCAPInvokable_val_ResultType_33_offeredCamel4Functionalities),
        (u'extensions', __AllCAPInvokable_val_ResultType_33_extensions),
        (u'releaseCallArgExtensionAllowed', __AllCAPInvokable_val_ResultType_33_releaseCallArgExtensionAllowed),
        ])
    _AllCAPInvokable_val_ResultType_33._ext = [u'releaseCallArgExtensionAllowed']
    _AllCAPInvokable_val_ArgumentType_34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __AllCAPInvokable_val_ArgumentType_34_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPInvokable_val_ArgumentType_34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_34_extensions._cont = ___AllCAPInvokable_val_ArgumentType_34_extensions__item_
    __AllCAPInvokable_val_ArgumentType_34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_34._cont = ASN1Dict([
        (u'legIDToMove', __AllCAPInvokable_val_ArgumentType_34_legIDToMove),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_34_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_34._ext = []
    _AllCAPInvokable_val_ArgumentType_35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AllCAPInvokable_val_ArgumentType_35_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text._ext = None
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID._ext = None
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_duration),
        (u'interval', ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_interval),
        ])
    ___AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_35_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AllCAPInvokable_val_ArgumentType_35_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo),
        (u'tone', ___AllCAPInvokable_val_ArgumentType_35_informationToSend_tone),
        ])
    __AllCAPInvokable_val_ArgumentType_35_informationToSend._ext = None
    __AllCAPInvokable_val_ArgumentType_35_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AllCAPInvokable_val_ArgumentType_35_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AllCAPInvokable_val_ArgumentType_35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_35_extensions._cont = ___AllCAPInvokable_val_ArgumentType_35_extensions__item_
    __AllCAPInvokable_val_ArgumentType_35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_35_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_35_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AllCAPInvokable_val_ArgumentType_35._cont = ASN1Dict([
        (u'informationToSend', __AllCAPInvokable_val_ArgumentType_35_informationToSend),
        (u'disconnectFromIPForbidden', __AllCAPInvokable_val_ArgumentType_35_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __AllCAPInvokable_val_ArgumentType_35_requestAnnouncementCompleteNotification),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_35_extensions),
        (u'callSegmentID', __AllCAPInvokable_val_ArgumentType_35_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AllCAPInvokable_val_ArgumentType_35_requestAnnouncementStartedNotification),
        ])
    _AllCAPInvokable_val_ArgumentType_35._ext = []
    _AllCAPInvokable_val_ArgumentType_36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __AllCAPInvokable_val_ArgumentType_36_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPInvokable_val_ArgumentType_36_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_callSegmentID),
        (u'legID', ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_legID),
        ])
    __AllCAPInvokable_val_ArgumentType_36_legOrCallSegment._ext = None
    __AllCAPInvokable_val_ArgumentType_36_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __AllCAPInvokable_val_ArgumentType_36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_36_extensions._cont = ___AllCAPInvokable_val_ArgumentType_36_extensions__item_
    __AllCAPInvokable_val_ArgumentType_36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_36._cont = ASN1Dict([
        (u'legOrCallSegment', __AllCAPInvokable_val_ArgumentType_36_legOrCallSegment),
        (u'bursts', __AllCAPInvokable_val_ArgumentType_36_bursts),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_36_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_36._ext = []
    _AllCAPInvokable_val_ArgumentType_37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AllCAPInvokable_val_ArgumentType_37_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AllCAPInvokable_val_ArgumentType_37_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AllCAPInvokable_val_ArgumentType_37_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text._ext = None
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID._ext = None
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_duration),
        (u'interval', ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_interval),
        ])
    ___AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo._ext = []
    ___AllCAPInvokable_val_ArgumentType_37_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AllCAPInvokable_val_ArgumentType_37_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo),
        (u'tone', ___AllCAPInvokable_val_ArgumentType_37_informationToSend_tone),
        ])
    __AllCAPInvokable_val_ArgumentType_37_informationToSend._ext = None
    __AllCAPInvokable_val_ArgumentType_37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_37_extensions._cont = ___AllCAPInvokable_val_ArgumentType_37_extensions__item_
    __AllCAPInvokable_val_ArgumentType_37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_37_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_37_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AllCAPInvokable_val_ArgumentType_37._cont = ASN1Dict([
        (u'collectedInfo', __AllCAPInvokable_val_ArgumentType_37_collectedInfo),
        (u'disconnectFromIPForbidden', __AllCAPInvokable_val_ArgumentType_37_disconnectFromIPForbidden),
        (u'informationToSend', __AllCAPInvokable_val_ArgumentType_37_informationToSend),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_37_extensions),
        (u'callSegmentID', __AllCAPInvokable_val_ArgumentType_37_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AllCAPInvokable_val_ArgumentType_37_requestAnnouncementStartedNotification),
        ])
    _AllCAPInvokable_val_ArgumentType_37._ext = []
    _AllCAPInvokable_val_ResultType_37 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AllCAPInvokable_val_ResultType_37_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AllCAPInvokable_val_ResultType_37_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AllCAPInvokable_val_ResultType_37._cont = ASN1Dict([
        (u'digitsResponse', __AllCAPInvokable_val_ResultType_37_digitsResponse),
        ])
    _AllCAPInvokable_val_ResultType_37._ext = None
    _AllCAPInvokable_val_ArgumentType_38 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __AllCAPInvokable_val_ArgumentType_38_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __AllCAPInvokable_val_ArgumentType_38_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions._cont = ____AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions__item_
    ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions),
        ])
    __AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension._ext = None
    _AllCAPInvokable_val_ArgumentType_38._cont = ASN1Dict([
        (u'allCallSegments', __AllCAPInvokable_val_ArgumentType_38_allCallSegments),
        (u'allCallSegmentsWithExtension', __AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension),
        ])
    _AllCAPInvokable_val_ArgumentType_38._ext = None
    _AllCAPInvokable_val_ArgumentType_39 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __AllCAPInvokable_val_ArgumentType_39_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __AllCAPInvokable_val_ArgumentType_39_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_39_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPInvokable_val_ArgumentType_39._cont = ASN1Dict([
        (u'gprsCause', __AllCAPInvokable_val_ArgumentType_39_gprsCause),
        (u'pDPID', __AllCAPInvokable_val_ArgumentType_39_pDPID),
        ])
    _AllCAPInvokable_val_ArgumentType_39._ext = []
    _AllCAPInvokable_val_ArgumentType_40 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __AllCAPInvokable_val_ArgumentType_40_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__monitorMode),
        (u'legID', ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__automaticRearm),
        ])
    ___AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item_._ext = []
    __AllCAPInvokable_val_ArgumentType_40_bcsmEvents._cont = ___AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item_
    __AllCAPInvokable_val_ArgumentType_40_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_40_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_40_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_40_extensions._cont = ___AllCAPInvokable_val_ArgumentType_40_extensions__item_
    __AllCAPInvokable_val_ArgumentType_40_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_40._cont = ASN1Dict([
        (u'bcsmEvents', __AllCAPInvokable_val_ArgumentType_40_bcsmEvents),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_40_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_40._ext = []
    _AllCAPInvokable_val_ArgumentType_41 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __AllCAPInvokable_val_ArgumentType_41_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_41_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __AllCAPInvokable_val_ArgumentType_41_gPRSEvent._cont = ___AllCAPInvokable_val_ArgumentType_41_gPRSEvent__item_
    __AllCAPInvokable_val_ArgumentType_41_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_41_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPInvokable_val_ArgumentType_41._cont = ASN1Dict([
        (u'gPRSEvent', __AllCAPInvokable_val_ArgumentType_41_gPRSEvent),
        (u'pDPID', __AllCAPInvokable_val_ArgumentType_41_pDPID),
        ])
    _AllCAPInvokable_val_ArgumentType_41._ext = []
    _AllCAPInvokable_val_ArgumentType_42 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __AllCAPInvokable_val_ArgumentType_42_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPInvokable_val_ArgumentType_42_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __AllCAPInvokable_val_ArgumentType_42_sMSEvents._cont = ___AllCAPInvokable_val_ArgumentType_42_sMSEvents__item_
    __AllCAPInvokable_val_ArgumentType_42_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_42_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_42_extensions._cont = ___AllCAPInvokable_val_ArgumentType_42_extensions__item_
    __AllCAPInvokable_val_ArgumentType_42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_42._cont = ASN1Dict([
        (u'sMSEvents', __AllCAPInvokable_val_ArgumentType_42_sMSEvents),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_42_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_42._ext = []
    _AllCAPInvokable_val_ArgumentType_43 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AllCAPInvokable_val_ArgumentType_43_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AllCAPInvokable_val_ArgumentType_43_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AllCAPInvokable_val_ArgumentType_43_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_43_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_43_extensions._cont = ___AllCAPInvokable_val_ArgumentType_43_extensions__item_
    __AllCAPInvokable_val_ArgumentType_43_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_43_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_43_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_43._cont = ASN1Dict([
        (u'timerID', __AllCAPInvokable_val_ArgumentType_43_timerID),
        (u'timervalue', __AllCAPInvokable_val_ArgumentType_43_timervalue),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_43_extensions),
        (u'callSegmentID', __AllCAPInvokable_val_ArgumentType_43_callSegmentID),
        ])
    _AllCAPInvokable_val_ArgumentType_43._ext = []
    _AllCAPInvokable_val_ArgumentType_44 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _AllCAPInvokable_val_ArgumentType_45 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __AllCAPInvokable_val_ArgumentType_45_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AllCAPInvokable_val_ArgumentType_45_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AllCAPInvokable_val_ArgumentType_45_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_45_extensions._cont = ___AllCAPInvokable_val_ArgumentType_45_extensions__item_
    __AllCAPInvokable_val_ArgumentType_45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_45._cont = ASN1Dict([
        (u'timerID', __AllCAPInvokable_val_ArgumentType_45_timerID),
        (u'timervalue', __AllCAPInvokable_val_ArgumentType_45_timervalue),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_45_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_45._ext = []
    _AllCAPInvokable_val_ArgumentType_46 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __AllCAPInvokable_val_ArgumentType_46_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __AllCAPInvokable_val_ArgumentType_46_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_46_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __AllCAPInvokable_val_ArgumentType_46_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_46_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_46_extensions._cont = ___AllCAPInvokable_val_ArgumentType_46_extensions__item_
    __AllCAPInvokable_val_ArgumentType_46_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_46._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __AllCAPInvokable_val_ArgumentType_46_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __AllCAPInvokable_val_ArgumentType_46_partyToCharge),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_46_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_46._ext = []
    _AllCAPInvokable_val_ArgumentType_47 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __AllCAPInvokable_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __AllCAPInvokable_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_47._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __AllCAPInvokable_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics),
        ])
    _AllCAPInvokable_val_ArgumentType_47._ext = []
    _AllCAPInvokable_val_ArgumentType_48 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _AllCAPInvokable_val_ArgumentType_49 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __AllCAPInvokable_val_ArgumentType_49_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPInvokable_val_ArgumentType_49_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPInvokable_val_ArgumentType_49_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPInvokable_val_ArgumentType_49_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPInvokable_val_ArgumentType_49_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPInvokable_val_ArgumentType_49_extensions._cont = ___AllCAPInvokable_val_ArgumentType_49_extensions__item_
    __AllCAPInvokable_val_ArgumentType_49_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPInvokable_val_ArgumentType_49._cont = ASN1Dict([
        (u'legToBeSplit', __AllCAPInvokable_val_ArgumentType_49_legToBeSplit),
        (u'newCallSegment', __AllCAPInvokable_val_ArgumentType_49_newCallSegment),
        (u'extensions', __AllCAPInvokable_val_ArgumentType_49_extensions),
        ])
    _AllCAPInvokable_val_ArgumentType_49._ext = []
    AllCAPInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_7), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_20), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_21), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_22), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_25), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_33), (u'ResultType', _AllCAPInvokable_val_ResultType_33), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_34), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_37), (u'ResultType', _AllCAPInvokable_val_ResultType_37), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_39), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_40), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_41), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_42), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_43), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_44), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_45), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_46), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_47), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_48), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))]), dict([(u'ArgumentType', _AllCAPInvokable_val_ArgumentType_49), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])
    
    #-----< AllCAPReturnable >-----#
    AllCAPReturnable = CLASS(name=u'AllCAPReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AllCAPReturnable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __AllCAPReturnable_val_ArgumentType_2_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __AllCAPReturnable_val_ArgumentType_2_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_2_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __AllCAPReturnable_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_2_extensions._cont = ___AllCAPReturnable_val_ArgumentType_2_extensions__item_
    __AllCAPReturnable_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_2_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_2_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_legID),
        (u'srfConnection', ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_srfConnection),
        ])
    __AllCAPReturnable_val_ArgumentType_2_aChChargingAddress._ext = None
    _AllCAPReturnable_val_ArgumentType_2._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __AllCAPReturnable_val_ArgumentType_2_aChBillingChargingCharacteristics),
        (u'partyToCharge', __AllCAPReturnable_val_ArgumentType_2_partyToCharge),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_2_extensions),
        (u'aChChargingAddress', __AllCAPReturnable_val_ArgumentType_2_aChChargingAddress),
        ])
    _AllCAPReturnable_val_ArgumentType_2._ext = []
    _AllCAPReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _AllCAPReturnable_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _AllCAPReturnable_val_ArgumentType_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _AllCAPReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AllCAPReturnable_val_ArgumentType_6_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AllCAPReturnable_val_ArgumentType_6_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_6_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AllCAPReturnable_val_ArgumentType_6_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_6_extensions._cont = ___AllCAPReturnable_val_ArgumentType_6_extensions__item_
    __AllCAPReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'correlationID', __AllCAPReturnable_val_ArgumentType_6_correlationID),
        (u'iPSSPCapabilities', __AllCAPReturnable_val_ArgumentType_6_iPSSPCapabilities),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_6_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_6._ext = []
    _AllCAPReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __AllCAPReturnable_val_ArgumentType_7_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria._ext = None
    ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria._ext = None
    __AllCAPReturnable_val_ArgumentType_7_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria),
        ])
    __AllCAPReturnable_val_ArgumentType_7_gapCriteria._ext = None
    __AllCAPReturnable_val_ArgumentType_7_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __AllCAPReturnable_val_ArgumentType_7_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __AllCAPReturnable_val_ArgumentType_7_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo._ext = []
    ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo),
        (u'tone', ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_tone),
        ])
    ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend._ext = None
    ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_7_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend),
        (u'releaseCause', ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_releaseCause),
        ])
    __AllCAPReturnable_val_ArgumentType_7_gapTreatment._ext = None
    __AllCAPReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_7_extensions._cont = ___AllCAPReturnable_val_ArgumentType_7_extensions__item_
    __AllCAPReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'gapCriteria', __AllCAPReturnable_val_ArgumentType_7_gapCriteria),
        (u'gapIndicators', __AllCAPReturnable_val_ArgumentType_7_gapIndicators),
        (u'controlType', __AllCAPReturnable_val_ArgumentType_7_controlType),
        (u'gapTreatment', __AllCAPReturnable_val_ArgumentType_7_gapTreatment),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_7_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_7._ext = []
    _AllCAPReturnable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __AllCAPReturnable_val_ArgumentType_8_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue._ext = None
    ___AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue),
        ])
    ___AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item_._ext = []
    __AllCAPReturnable_val_ArgumentType_8_requestedInformationList._cont = ___AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item_
    __AllCAPReturnable_val_ArgumentType_8_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_8_extensions._cont = ___AllCAPReturnable_val_ArgumentType_8_extensions__item_
    __AllCAPReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_8_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _AllCAPReturnable_val_ArgumentType_8._cont = ASN1Dict([
        (u'requestedInformationList', __AllCAPReturnable_val_ArgumentType_8_requestedInformationList),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_8_extensions),
        (u'legID', __AllCAPReturnable_val_ArgumentType_8_legID),
        ])
    _AllCAPReturnable_val_ArgumentType_8._ext = []
    _AllCAPReturnable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __AllCAPReturnable_val_ArgumentType_9_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __AllCAPReturnable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_9_extensions._cont = ___AllCAPReturnable_val_ArgumentType_9_extensions__item_
    __AllCAPReturnable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_9_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _AllCAPReturnable_val_ArgumentType_9._cont = ASN1Dict([
        (u'requestedInformationTypeList', __AllCAPReturnable_val_ArgumentType_9_requestedInformationTypeList),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_9_extensions),
        (u'legID', __AllCAPReturnable_val_ArgumentType_9_legID),
        ])
    _AllCAPReturnable_val_ArgumentType_9._ext = []
    _AllCAPReturnable_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AllCAPReturnable_val_ArgumentType_10_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AllCAPReturnable_val_ArgumentType_10_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_callSegmentID),
        ])
    __AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel._ext = []
    _AllCAPReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'invokeID', __AllCAPReturnable_val_ArgumentType_10_invokeID),
        (u'allRequests', __AllCAPReturnable_val_ArgumentType_10_allRequests),
        (u'callSegmentToCancel', __AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel),
        ])
    _AllCAPReturnable_val_ArgumentType_10._ext = None
    _AllCAPReturnable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _AllCAPReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __AllCAPReturnable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_12_extensions._cont = ___AllCAPReturnable_val_ArgumentType_12_extensions__item_
    __AllCAPReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'extensions', __AllCAPReturnable_val_ArgumentType_12_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_12._ext = []
    _AllCAPReturnable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress._cont = ___AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress__item_
    __AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_13_extensions._cont = ___AllCAPReturnable_val_ArgumentType_13_extensions__item_
    __AllCAPReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_13_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___AllCAPReturnable_val_ArgumentType_13_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_genericNumbers._cont = ___AllCAPReturnable_val_ArgumentType_13_genericNumbers__item_
    __AllCAPReturnable_val_ArgumentType_13_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_13_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_13_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AllCAPReturnable_val_ArgumentType_13._cont = ASN1Dict([
        (u'destinationRoutingAddress', __AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress),
        (u'alertingPattern', __AllCAPReturnable_val_ArgumentType_13_alertingPattern),
        (u'originalCalledPartyID', __AllCAPReturnable_val_ArgumentType_13_originalCalledPartyID),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_13_extensions),
        (u'carrier', __AllCAPReturnable_val_ArgumentType_13_carrier),
        (u'callingPartysCategory', __AllCAPReturnable_val_ArgumentType_13_callingPartysCategory),
        (u'redirectingPartyID', __AllCAPReturnable_val_ArgumentType_13_redirectingPartyID),
        (u'redirectionInformation', __AllCAPReturnable_val_ArgumentType_13_redirectionInformation),
        (u'genericNumbers', __AllCAPReturnable_val_ArgumentType_13_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __AllCAPReturnable_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __AllCAPReturnable_val_ArgumentType_13_chargeNumber),
        (u'legToBeConnected', __AllCAPReturnable_val_ArgumentType_13_legToBeConnected),
        (u'cug-Interlock', __AllCAPReturnable_val_ArgumentType_13_cug_Interlock),
        (u'cug-OutgoingAccess', __AllCAPReturnable_val_ArgumentType_13_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __AllCAPReturnable_val_ArgumentType_13_suppressionOfAnnouncement),
        (u'oCSIApplicable', __AllCAPReturnable_val_ArgumentType_13_oCSIApplicable),
        (u'naOliInfo', __AllCAPReturnable_val_ArgumentType_13_naOliInfo),
        (u'bor-InterrogationRequested', __AllCAPReturnable_val_ArgumentType_13_bor_InterrogationRequested),
        (u'suppress-N-CSI', __AllCAPReturnable_val_ArgumentType_13_suppress_N_CSI),
        ])
    _AllCAPReturnable_val_ArgumentType_13._ext = [u'suppress-N-CSI']
    _AllCAPReturnable_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __AllCAPReturnable_val_ArgumentType_14_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __AllCAPReturnable_val_ArgumentType_14_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_14_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPReturnable_val_ArgumentType_14._cont = ASN1Dict([
        (u'accessPointName', __AllCAPReturnable_val_ArgumentType_14_accessPointName),
        (u'pdpID', __AllCAPReturnable_val_ArgumentType_14_pdpID),
        ])
    _AllCAPReturnable_val_ArgumentType_14._ext = []
    _AllCAPReturnable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __AllCAPReturnable_val_ArgumentType_15_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_15_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_15_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_15_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_15_extensions._cont = ___AllCAPReturnable_val_ArgumentType_15_extensions__item_
    __AllCAPReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_15._cont = ASN1Dict([
        (u'callingPartysNumber', __AllCAPReturnable_val_ArgumentType_15_callingPartysNumber),
        (u'destinationSubscriberNumber', __AllCAPReturnable_val_ArgumentType_15_destinationSubscriberNumber),
        (u'sMSCAddress', __AllCAPReturnable_val_ArgumentType_15_sMSCAddress),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_15_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_15._ext = []
    _AllCAPReturnable_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AllCAPReturnable_val_ArgumentType_16_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AllCAPReturnable_val_ArgumentType_16_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_ipRoutingAddress),
        (u'none', ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_none),
        ])
    __AllCAPReturnable_val_ArgumentType_16_resourceAddress._ext = None
    __AllCAPReturnable_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_16_extensions._cont = ___AllCAPReturnable_val_ArgumentType_16_extensions__item_
    __AllCAPReturnable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_16_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_16_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_16_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_16._cont = ASN1Dict([
        (u'resourceAddress', __AllCAPReturnable_val_ArgumentType_16_resourceAddress),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_16_extensions),
        (u'serviceInteractionIndicatorsTwo', __AllCAPReturnable_val_ArgumentType_16_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AllCAPReturnable_val_ArgumentType_16_callSegmentID),
        ])
    _AllCAPReturnable_val_ArgumentType_16._ext = []
    _AllCAPReturnable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _AllCAPReturnable_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __AllCAPReturnable_val_ArgumentType_20_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_20_extensions._cont = ___AllCAPReturnable_val_ArgumentType_20_extensions__item_
    __AllCAPReturnable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_20_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_20_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___AllCAPReturnable_val_ArgumentType_20_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_20_genericNumbers._cont = ___AllCAPReturnable_val_ArgumentType_20_genericNumbers__item_
    __AllCAPReturnable_val_ArgumentType_20_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_20_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_20_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_20_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension._ext = []
    _AllCAPReturnable_val_ArgumentType_20._cont = ASN1Dict([
        (u'alertingPattern', __AllCAPReturnable_val_ArgumentType_20_alertingPattern),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_20_extensions),
        (u'serviceInteractionIndicatorsTwo', __AllCAPReturnable_val_ArgumentType_20_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __AllCAPReturnable_val_ArgumentType_20_callingPartysCategory),
        (u'genericNumbers', __AllCAPReturnable_val_ArgumentType_20_genericNumbers),
        (u'cug-Interlock', __AllCAPReturnable_val_ArgumentType_20_cug_Interlock),
        (u'cug-OutgoingAccess', __AllCAPReturnable_val_ArgumentType_20_cug_OutgoingAccess),
        (u'chargeNumber', __AllCAPReturnable_val_ArgumentType_20_chargeNumber),
        (u'carrier', __AllCAPReturnable_val_ArgumentType_20_carrier),
        (u'suppressionOfAnnouncement', __AllCAPReturnable_val_ArgumentType_20_suppressionOfAnnouncement),
        (u'naOliInfo', __AllCAPReturnable_val_ArgumentType_20_naOliInfo),
        (u'bor-InterrogationRequested', __AllCAPReturnable_val_ArgumentType_20_bor_InterrogationRequested),
        (u'suppress-O-CSI', __AllCAPReturnable_val_ArgumentType_20_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension),
        ])
    _AllCAPReturnable_val_ArgumentType_20._ext = []
    _AllCAPReturnable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __AllCAPReturnable_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_22_extensions._cont = ___AllCAPReturnable_val_ArgumentType_22_extensions__item_
    __AllCAPReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_22._cont = ASN1Dict([
        (u'callSegmentID', __AllCAPReturnable_val_ArgumentType_22_callSegmentID),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_22_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_22._ext = []
    _AllCAPReturnable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __AllCAPReturnable_val_ArgumentType_23_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPReturnable_val_ArgumentType_23_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __AllCAPReturnable_val_ArgumentType_23_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_23_extensions._cont = ___AllCAPReturnable_val_ArgumentType_23_extensions__item_
    __AllCAPReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_23._cont = ASN1Dict([
        (u'legToBeReleased', __AllCAPReturnable_val_ArgumentType_23_legToBeReleased),
        (u'releaseCause', __AllCAPReturnable_val_ArgumentType_23_releaseCause),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_23_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_23._ext = []
    _AllCAPReturnable_val_ArgumentType_24 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __AllCAPReturnable_val_ArgumentType_24_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_24_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_callSegmentID),
        (u'cause', ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_cause),
        ])
    __AllCAPReturnable_val_ArgumentType_24_callSegmentFailure._ext = []
    __AllCAPReturnable_val_ArgumentType_24_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_24_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_legID),
        (u'cause', ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_cause),
        ])
    __AllCAPReturnable_val_ArgumentType_24_bCSM_Failure._ext = []
    _AllCAPReturnable_val_ArgumentType_24._cont = ASN1Dict([
        (u'callSegmentFailure', __AllCAPReturnable_val_ArgumentType_24_callSegmentFailure),
        (u'bCSM-Failure', __AllCAPReturnable_val_ArgumentType_24_bCSM_Failure),
        ])
    _AllCAPReturnable_val_ArgumentType_24._ext = None
    _AllCAPReturnable_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __AllCAPReturnable_val_ArgumentType_25_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __AllCAPReturnable_val_ArgumentType_25_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_25_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPReturnable_val_ArgumentType_25._cont = ASN1Dict([
        (u'gPRSCause', __AllCAPReturnable_val_ArgumentType_25_gPRSCause),
        (u'pDPID', __AllCAPReturnable_val_ArgumentType_25_pDPID),
        ])
    _AllCAPReturnable_val_ArgumentType_25._ext = []
    _AllCAPReturnable_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __AllCAPReturnable_val_ArgumentType_26_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __AllCAPReturnable_val_ArgumentType_26_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_26_extensions._cont = ___AllCAPReturnable_val_ArgumentType_26_extensions__item_
    __AllCAPReturnable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_26_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_26_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_26._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __AllCAPReturnable_val_ArgumentType_26_assistingSSPIPRoutingAddress),
        (u'correlationID', __AllCAPReturnable_val_ArgumentType_26_correlationID),
        (u'scfID', __AllCAPReturnable_val_ArgumentType_26_scfID),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_26_extensions),
        (u'carrier', __AllCAPReturnable_val_ArgumentType_26_carrier),
        (u'serviceInteractionIndicatorsTwo', __AllCAPReturnable_val_ArgumentType_26_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AllCAPReturnable_val_ArgumentType_26_callSegmentID),
        (u'naOliInfo', __AllCAPReturnable_val_ArgumentType_26_naOliInfo),
        (u'chargeNumber', __AllCAPReturnable_val_ArgumentType_26_chargeNumber),
        (u'originalCalledPartyID', __AllCAPReturnable_val_ArgumentType_26_originalCalledPartyID),
        (u'callingPartyNumber', __AllCAPReturnable_val_ArgumentType_26_callingPartyNumber),
        ])
    _AllCAPReturnable_val_ArgumentType_26._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _AllCAPReturnable_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __AllCAPReturnable_val_ArgumentType_27_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM._ext = None
    __AllCAPReturnable_val_ArgumentType_27_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_27_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __AllCAPReturnable_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_27_extensions._cont = ___AllCAPReturnable_val_ArgumentType_27_extensions__item_
    __AllCAPReturnable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_27._cont = ASN1Dict([
        (u'eventTypeBCSM', __AllCAPReturnable_val_ArgumentType_27_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM),
        (u'legID', __AllCAPReturnable_val_ArgumentType_27_legID),
        (u'miscCallInfo', __AllCAPReturnable_val_ArgumentType_27_miscCallInfo),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_27_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_27._ext = []
    _AllCAPReturnable_val_ArgumentType_28 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _AllCAPReturnable_val_ArgumentType_28._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_29 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _AllCAPReturnable_val_ArgumentType_29._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_30 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _AllCAPReturnable_val_ArgumentType_30._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __AllCAPReturnable_val_ArgumentType_31_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __AllCAPReturnable_val_ArgumentType_31_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_31_extensions._cont = ___AllCAPReturnable_val_ArgumentType_31_extensions__item_
    __AllCAPReturnable_val_ArgumentType_31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_31_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___AllCAPReturnable_val_ArgumentType_31_bearerCapability_bearerCap),
        ])
    __AllCAPReturnable_val_ArgumentType_31_bearerCapability._ext = None
    __AllCAPReturnable_val_ArgumentType_31_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_31_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2._ext = None
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _AllCAPReturnable_val_ArgumentType_31._cont = ASN1Dict([
        (u'serviceKey', __AllCAPReturnable_val_ArgumentType_31_serviceKey),
        (u'calledPartyNumber', __AllCAPReturnable_val_ArgumentType_31_calledPartyNumber),
        (u'callingPartyNumber', __AllCAPReturnable_val_ArgumentType_31_callingPartyNumber),
        (u'callingPartysCategory', __AllCAPReturnable_val_ArgumentType_31_callingPartysCategory),
        (u'cGEncountered', __AllCAPReturnable_val_ArgumentType_31_cGEncountered),
        (u'iPSSPCapabilities', __AllCAPReturnable_val_ArgumentType_31_iPSSPCapabilities),
        (u'locationNumber', __AllCAPReturnable_val_ArgumentType_31_locationNumber),
        (u'originalCalledPartyID', __AllCAPReturnable_val_ArgumentType_31_originalCalledPartyID),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_31_extensions),
        (u'highLayerCompatibility', __AllCAPReturnable_val_ArgumentType_31_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __AllCAPReturnable_val_ArgumentType_31_additionalCallingPartyNumber),
        (u'bearerCapability', __AllCAPReturnable_val_ArgumentType_31_bearerCapability),
        (u'eventTypeBCSM', __AllCAPReturnable_val_ArgumentType_31_eventTypeBCSM),
        (u'redirectingPartyID', __AllCAPReturnable_val_ArgumentType_31_redirectingPartyID),
        (u'redirectionInformation', __AllCAPReturnable_val_ArgumentType_31_redirectionInformation),
        (u'cause', __AllCAPReturnable_val_ArgumentType_31_cause),
        (u'serviceInteractionIndicatorsTwo', __AllCAPReturnable_val_ArgumentType_31_serviceInteractionIndicatorsTwo),
        (u'carrier', __AllCAPReturnable_val_ArgumentType_31_carrier),
        (u'cug-Index', __AllCAPReturnable_val_ArgumentType_31_cug_Index),
        (u'cug-Interlock', __AllCAPReturnable_val_ArgumentType_31_cug_Interlock),
        (u'cug-OutgoingAccess', __AllCAPReturnable_val_ArgumentType_31_cug_OutgoingAccess),
        (u'iMSI', __AllCAPReturnable_val_ArgumentType_31_iMSI),
        (u'subscriberState', __AllCAPReturnable_val_ArgumentType_31_subscriberState),
        (u'locationInformation', __AllCAPReturnable_val_ArgumentType_31_locationInformation),
        (u'ext-basicServiceCode', __AllCAPReturnable_val_ArgumentType_31_ext_basicServiceCode),
        (u'callReferenceNumber', __AllCAPReturnable_val_ArgumentType_31_callReferenceNumber),
        (u'mscAddress', __AllCAPReturnable_val_ArgumentType_31_mscAddress),
        (u'calledPartyBCDNumber', __AllCAPReturnable_val_ArgumentType_31_calledPartyBCDNumber),
        (u'timeAndTimezone', __AllCAPReturnable_val_ArgumentType_31_timeAndTimezone),
        (u'callForwardingSS-Pending', __AllCAPReturnable_val_ArgumentType_31_callForwardingSS_Pending),
        (u'initialDPArgExtension', __AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension),
        ])
    _AllCAPReturnable_val_ArgumentType_31._ext = []
    _AllCAPReturnable_val_ArgumentType_32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __AllCAPReturnable_val_ArgumentType_32_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __AllCAPReturnable_val_ArgumentType_32_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __AllCAPReturnable_val_ArgumentType_32_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __AllCAPReturnable_val_ArgumentType_32_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __AllCAPReturnable_val_ArgumentType_32_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __AllCAPReturnable_val_ArgumentType_32_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_32_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_32_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPAddress),
        ])
    __AllCAPReturnable_val_ArgumentType_32_endUserAddress._ext = None
    __AllCAPReturnable_val_ArgumentType_32_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_32_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_32_extensions._cont = ___AllCAPReturnable_val_ArgumentType_32_extensions__item_
    __AllCAPReturnable_val_ArgumentType_32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_32_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AllCAPReturnable_val_ArgumentType_32_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _AllCAPReturnable_val_ArgumentType_32._cont = ASN1Dict([
        (u'serviceKey', __AllCAPReturnable_val_ArgumentType_32_serviceKey),
        (u'gPRSEventType', __AllCAPReturnable_val_ArgumentType_32_gPRSEventType),
        (u'mSISDN', __AllCAPReturnable_val_ArgumentType_32_mSISDN),
        (u'iMSI', __AllCAPReturnable_val_ArgumentType_32_iMSI),
        (u'timeAndTimeZone', __AllCAPReturnable_val_ArgumentType_32_timeAndTimeZone),
        (u'gPRSMSClass', __AllCAPReturnable_val_ArgumentType_32_gPRSMSClass),
        (u'endUserAddress', __AllCAPReturnable_val_ArgumentType_32_endUserAddress),
        (u'qualityOfService', __AllCAPReturnable_val_ArgumentType_32_qualityOfService),
        (u'accessPointName', __AllCAPReturnable_val_ArgumentType_32_accessPointName),
        (u'routeingAreaIdentity', __AllCAPReturnable_val_ArgumentType_32_routeingAreaIdentity),
        (u'chargingID', __AllCAPReturnable_val_ArgumentType_32_chargingID),
        (u'sGSNCapabilities', __AllCAPReturnable_val_ArgumentType_32_sGSNCapabilities),
        (u'locationInformationGPRS', __AllCAPReturnable_val_ArgumentType_32_locationInformationGPRS),
        (u'pDPInitiationType', __AllCAPReturnable_val_ArgumentType_32_pDPInitiationType),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_32_extensions),
        (u'gGSNAddress', __AllCAPReturnable_val_ArgumentType_32_gGSNAddress),
        (u'secondaryPDP-context', __AllCAPReturnable_val_ArgumentType_32_secondaryPDP_context),
        (u'iMEI', __AllCAPReturnable_val_ArgumentType_32_iMEI),
        ])
    _AllCAPReturnable_val_ArgumentType_32._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _AllCAPReturnable_val_ArgumentType_33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __AllCAPReturnable_val_ArgumentType_33_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __AllCAPReturnable_val_ArgumentType_33_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_33_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_33_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_33_extensions._cont = ___AllCAPReturnable_val_ArgumentType_33_extensions__item_
    __AllCAPReturnable_val_ArgumentType_33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_33_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __AllCAPReturnable_val_ArgumentType_33_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AllCAPReturnable_val_ArgumentType_33._cont = ASN1Dict([
        (u'serviceKey', __AllCAPReturnable_val_ArgumentType_33_serviceKey),
        (u'destinationSubscriberNumber', __AllCAPReturnable_val_ArgumentType_33_destinationSubscriberNumber),
        (u'callingPartyNumber', __AllCAPReturnable_val_ArgumentType_33_callingPartyNumber),
        (u'eventTypeSMS', __AllCAPReturnable_val_ArgumentType_33_eventTypeSMS),
        (u'iMSI', __AllCAPReturnable_val_ArgumentType_33_iMSI),
        (u'locationInformationMSC', __AllCAPReturnable_val_ArgumentType_33_locationInformationMSC),
        (u'locationInformationGPRS', __AllCAPReturnable_val_ArgumentType_33_locationInformationGPRS),
        (u'sMSCAddress', __AllCAPReturnable_val_ArgumentType_33_sMSCAddress),
        (u'timeAndTimezone', __AllCAPReturnable_val_ArgumentType_33_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __AllCAPReturnable_val_ArgumentType_33_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __AllCAPReturnable_val_ArgumentType_33_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __AllCAPReturnable_val_ArgumentType_33_tPDataCodingScheme),
        (u'tPValidityPeriod', __AllCAPReturnable_val_ArgumentType_33_tPValidityPeriod),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_33_extensions),
        (u'smsReferenceNumber', __AllCAPReturnable_val_ArgumentType_33_smsReferenceNumber),
        (u'mscAddress', __AllCAPReturnable_val_ArgumentType_33_mscAddress),
        (u'sgsn-Number', __AllCAPReturnable_val_ArgumentType_33_sgsn_Number),
        (u'ms-Classmark2', __AllCAPReturnable_val_ArgumentType_33_ms_Classmark2),
        (u'gPRSMSClass', __AllCAPReturnable_val_ArgumentType_33_gPRSMSClass),
        (u'iMEI', __AllCAPReturnable_val_ArgumentType_33_iMEI),
        (u'calledPartyNumber', __AllCAPReturnable_val_ArgumentType_33_calledPartyNumber),
        ])
    _AllCAPReturnable_val_ArgumentType_33._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _AllCAPReturnable_val_ArgumentType_34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress._cont = ___AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress__item_
    __AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_34_extensions._cont = ___AllCAPReturnable_val_ArgumentType_34_extensions__item_
    __AllCAPReturnable_val_ArgumentType_34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_34_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_34_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_34_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_34_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __AllCAPReturnable_val_ArgumentType_34_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __AllCAPReturnable_val_ArgumentType_34_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AllCAPReturnable_val_ArgumentType_34._cont = ASN1Dict([
        (u'destinationRoutingAddress', __AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_34_extensions),
        (u'legToBeCreated', __AllCAPReturnable_val_ArgumentType_34_legToBeCreated),
        (u'newCallSegment', __AllCAPReturnable_val_ArgumentType_34_newCallSegment),
        (u'callingPartyNumber', __AllCAPReturnable_val_ArgumentType_34_callingPartyNumber),
        (u'callReferenceNumber', __AllCAPReturnable_val_ArgumentType_34_callReferenceNumber),
        (u'gsmSCFAddress', __AllCAPReturnable_val_ArgumentType_34_gsmSCFAddress),
        (u'suppress-T-CSI', __AllCAPReturnable_val_ArgumentType_34_suppress_T_CSI),
        ])
    _AllCAPReturnable_val_ArgumentType_34._ext = []
    _AllCAPReturnable_val_ResultType_34 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __AllCAPReturnable_val_ResultType_34_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __AllCAPReturnable_val_ResultType_34_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __AllCAPReturnable_val_ResultType_34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ResultType_34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ResultType_34_extensions._cont = ___AllCAPReturnable_val_ResultType_34_extensions__item_
    __AllCAPReturnable_val_ResultType_34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ResultType_34_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AllCAPReturnable_val_ResultType_34._cont = ASN1Dict([
        (u'supportedCamelPhases', __AllCAPReturnable_val_ResultType_34_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __AllCAPReturnable_val_ResultType_34_offeredCamel4Functionalities),
        (u'extensions', __AllCAPReturnable_val_ResultType_34_extensions),
        (u'releaseCallArgExtensionAllowed', __AllCAPReturnable_val_ResultType_34_releaseCallArgExtensionAllowed),
        ])
    _AllCAPReturnable_val_ResultType_34._ext = [u'releaseCallArgExtensionAllowed']
    _AllCAPReturnable_val_ArgumentType_35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __AllCAPReturnable_val_ArgumentType_35_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPReturnable_val_ArgumentType_35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_35_extensions._cont = ___AllCAPReturnable_val_ArgumentType_35_extensions__item_
    __AllCAPReturnable_val_ArgumentType_35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_35._cont = ASN1Dict([
        (u'legIDToMove', __AllCAPReturnable_val_ArgumentType_35_legIDToMove),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_35_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_35._ext = []
    _AllCAPReturnable_val_ArgumentType_36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AllCAPReturnable_val_ArgumentType_36_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text._ext = None
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID._ext = None
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_duration),
        (u'interval', ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_interval),
        ])
    ___AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_36_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AllCAPReturnable_val_ArgumentType_36_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo),
        (u'tone', ___AllCAPReturnable_val_ArgumentType_36_informationToSend_tone),
        ])
    __AllCAPReturnable_val_ArgumentType_36_informationToSend._ext = None
    __AllCAPReturnable_val_ArgumentType_36_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AllCAPReturnable_val_ArgumentType_36_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AllCAPReturnable_val_ArgumentType_36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_36_extensions._cont = ___AllCAPReturnable_val_ArgumentType_36_extensions__item_
    __AllCAPReturnable_val_ArgumentType_36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_36_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_36_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_36_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AllCAPReturnable_val_ArgumentType_36._cont = ASN1Dict([
        (u'informationToSend', __AllCAPReturnable_val_ArgumentType_36_informationToSend),
        (u'disconnectFromIPForbidden', __AllCAPReturnable_val_ArgumentType_36_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __AllCAPReturnable_val_ArgumentType_36_requestAnnouncementCompleteNotification),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_36_extensions),
        (u'callSegmentID', __AllCAPReturnable_val_ArgumentType_36_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AllCAPReturnable_val_ArgumentType_36_requestAnnouncementStartedNotification),
        ])
    _AllCAPReturnable_val_ArgumentType_36._ext = []
    _AllCAPReturnable_val_ArgumentType_37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __AllCAPReturnable_val_ArgumentType_37_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPReturnable_val_ArgumentType_37_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_callSegmentID),
        (u'legID', ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_legID),
        ])
    __AllCAPReturnable_val_ArgumentType_37_legOrCallSegment._ext = None
    __AllCAPReturnable_val_ArgumentType_37_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __AllCAPReturnable_val_ArgumentType_37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_37_extensions._cont = ___AllCAPReturnable_val_ArgumentType_37_extensions__item_
    __AllCAPReturnable_val_ArgumentType_37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_37._cont = ASN1Dict([
        (u'legOrCallSegment', __AllCAPReturnable_val_ArgumentType_37_legOrCallSegment),
        (u'bursts', __AllCAPReturnable_val_ArgumentType_37_bursts),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_37_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_37._ext = []
    _AllCAPReturnable_val_ArgumentType_38 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AllCAPReturnable_val_ArgumentType_38_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AllCAPReturnable_val_ArgumentType_38_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AllCAPReturnable_val_ArgumentType_38_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text._ext = None
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID._ext = None
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_duration),
        (u'interval', ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_interval),
        ])
    ___AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo._ext = []
    ___AllCAPReturnable_val_ArgumentType_38_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AllCAPReturnable_val_ArgumentType_38_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo),
        (u'tone', ___AllCAPReturnable_val_ArgumentType_38_informationToSend_tone),
        ])
    __AllCAPReturnable_val_ArgumentType_38_informationToSend._ext = None
    __AllCAPReturnable_val_ArgumentType_38_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_38_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_38_extensions._cont = ___AllCAPReturnable_val_ArgumentType_38_extensions__item_
    __AllCAPReturnable_val_ArgumentType_38_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_38_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_38_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_38_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AllCAPReturnable_val_ArgumentType_38._cont = ASN1Dict([
        (u'collectedInfo', __AllCAPReturnable_val_ArgumentType_38_collectedInfo),
        (u'disconnectFromIPForbidden', __AllCAPReturnable_val_ArgumentType_38_disconnectFromIPForbidden),
        (u'informationToSend', __AllCAPReturnable_val_ArgumentType_38_informationToSend),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_38_extensions),
        (u'callSegmentID', __AllCAPReturnable_val_ArgumentType_38_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AllCAPReturnable_val_ArgumentType_38_requestAnnouncementStartedNotification),
        ])
    _AllCAPReturnable_val_ArgumentType_38._ext = []
    _AllCAPReturnable_val_ResultType_38 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AllCAPReturnable_val_ResultType_38_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AllCAPReturnable_val_ResultType_38_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AllCAPReturnable_val_ResultType_38._cont = ASN1Dict([
        (u'digitsResponse', __AllCAPReturnable_val_ResultType_38_digitsResponse),
        ])
    _AllCAPReturnable_val_ResultType_38._ext = None
    _AllCAPReturnable_val_ArgumentType_39 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __AllCAPReturnable_val_ArgumentType_39_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __AllCAPReturnable_val_ArgumentType_39_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions._cont = ____AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions__item_
    ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions),
        ])
    __AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension._ext = None
    _AllCAPReturnable_val_ArgumentType_39._cont = ASN1Dict([
        (u'allCallSegments', __AllCAPReturnable_val_ArgumentType_39_allCallSegments),
        (u'allCallSegmentsWithExtension', __AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension),
        ])
    _AllCAPReturnable_val_ArgumentType_39._ext = None
    _AllCAPReturnable_val_ArgumentType_40 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __AllCAPReturnable_val_ArgumentType_40_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __AllCAPReturnable_val_ArgumentType_40_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_40_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPReturnable_val_ArgumentType_40._cont = ASN1Dict([
        (u'gprsCause', __AllCAPReturnable_val_ArgumentType_40_gprsCause),
        (u'pDPID', __AllCAPReturnable_val_ArgumentType_40_pDPID),
        ])
    _AllCAPReturnable_val_ArgumentType_40._ext = []
    _AllCAPReturnable_val_ArgumentType_41 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _AllCAPReturnable_val_ArgumentType_42 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __AllCAPReturnable_val_ArgumentType_42_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__monitorMode),
        (u'legID', ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__automaticRearm),
        ])
    ___AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item_._ext = []
    __AllCAPReturnable_val_ArgumentType_42_bcsmEvents._cont = ___AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item_
    __AllCAPReturnable_val_ArgumentType_42_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_42_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_42_extensions._cont = ___AllCAPReturnable_val_ArgumentType_42_extensions__item_
    __AllCAPReturnable_val_ArgumentType_42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_42._cont = ASN1Dict([
        (u'bcsmEvents', __AllCAPReturnable_val_ArgumentType_42_bcsmEvents),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_42_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_42._ext = []
    _AllCAPReturnable_val_ArgumentType_43 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __AllCAPReturnable_val_ArgumentType_43_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_43_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __AllCAPReturnable_val_ArgumentType_43_gPRSEvent._cont = ___AllCAPReturnable_val_ArgumentType_43_gPRSEvent__item_
    __AllCAPReturnable_val_ArgumentType_43_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_43_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _AllCAPReturnable_val_ArgumentType_43._cont = ASN1Dict([
        (u'gPRSEvent', __AllCAPReturnable_val_ArgumentType_43_gPRSEvent),
        (u'pDPID', __AllCAPReturnable_val_ArgumentType_43_pDPID),
        ])
    _AllCAPReturnable_val_ArgumentType_43._ext = []
    _AllCAPReturnable_val_ArgumentType_44 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __AllCAPReturnable_val_ArgumentType_44_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllCAPReturnable_val_ArgumentType_44_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __AllCAPReturnable_val_ArgumentType_44_sMSEvents._cont = ___AllCAPReturnable_val_ArgumentType_44_sMSEvents__item_
    __AllCAPReturnable_val_ArgumentType_44_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_44_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_44_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_44_extensions._cont = ___AllCAPReturnable_val_ArgumentType_44_extensions__item_
    __AllCAPReturnable_val_ArgumentType_44_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_44._cont = ASN1Dict([
        (u'sMSEvents', __AllCAPReturnable_val_ArgumentType_44_sMSEvents),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_44_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_44._ext = []
    _AllCAPReturnable_val_ArgumentType_45 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AllCAPReturnable_val_ArgumentType_45_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AllCAPReturnable_val_ArgumentType_45_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AllCAPReturnable_val_ArgumentType_45_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_45_extensions._cont = ___AllCAPReturnable_val_ArgumentType_45_extensions__item_
    __AllCAPReturnable_val_ArgumentType_45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_45_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_45_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_45._cont = ASN1Dict([
        (u'timerID', __AllCAPReturnable_val_ArgumentType_45_timerID),
        (u'timervalue', __AllCAPReturnable_val_ArgumentType_45_timervalue),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_45_extensions),
        (u'callSegmentID', __AllCAPReturnable_val_ArgumentType_45_callSegmentID),
        ])
    _AllCAPReturnable_val_ArgumentType_45._ext = []
    _AllCAPReturnable_val_ArgumentType_46 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _AllCAPReturnable_val_ArgumentType_47 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __AllCAPReturnable_val_ArgumentType_47_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AllCAPReturnable_val_ArgumentType_47_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AllCAPReturnable_val_ArgumentType_47_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_47_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_47_extensions._cont = ___AllCAPReturnable_val_ArgumentType_47_extensions__item_
    __AllCAPReturnable_val_ArgumentType_47_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_47._cont = ASN1Dict([
        (u'timerID', __AllCAPReturnable_val_ArgumentType_47_timerID),
        (u'timervalue', __AllCAPReturnable_val_ArgumentType_47_timervalue),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_47_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_47._ext = []
    _AllCAPReturnable_val_ArgumentType_48 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __AllCAPReturnable_val_ArgumentType_48_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __AllCAPReturnable_val_ArgumentType_48_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_48_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __AllCAPReturnable_val_ArgumentType_48_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_48_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_48_extensions._cont = ___AllCAPReturnable_val_ArgumentType_48_extensions__item_
    __AllCAPReturnable_val_ArgumentType_48_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_48._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __AllCAPReturnable_val_ArgumentType_48_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __AllCAPReturnable_val_ArgumentType_48_partyToCharge),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_48_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_48._ext = []
    _AllCAPReturnable_val_ArgumentType_49 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __AllCAPReturnable_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __AllCAPReturnable_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_49._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __AllCAPReturnable_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics),
        ])
    _AllCAPReturnable_val_ArgumentType_49._ext = []
    _AllCAPReturnable_val_ArgumentType_50 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _AllCAPReturnable_val_ArgumentType_51 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __AllCAPReturnable_val_ArgumentType_51_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __AllCAPReturnable_val_ArgumentType_51_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AllCAPReturnable_val_ArgumentType_51_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AllCAPReturnable_val_ArgumentType_51_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AllCAPReturnable_val_ArgumentType_51_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AllCAPReturnable_val_ArgumentType_51_extensions._cont = ___AllCAPReturnable_val_ArgumentType_51_extensions__item_
    __AllCAPReturnable_val_ArgumentType_51_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AllCAPReturnable_val_ArgumentType_51._cont = ASN1Dict([
        (u'legToBeSplit', __AllCAPReturnable_val_ArgumentType_51_legToBeSplit),
        (u'newCallSegment', __AllCAPReturnable_val_ArgumentType_51_newCallSegment),
        (u'extensions', __AllCAPReturnable_val_ArgumentType_51_extensions),
        ])
    _AllCAPReturnable_val_ArgumentType_51._ext = []
    AllCAPReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_7), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_8), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_23), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_25), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_27), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_34), (u'ResultType', _AllCAPReturnable_val_ResultType_34), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_35), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_38), (u'ResultType', _AllCAPReturnable_val_ResultType_38), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', __OPERATION_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_39), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_40), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_41), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_42), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_43), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_44), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_45), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_46), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_47), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_48), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_49), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_50), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))]), dict([(u'ArgumentType', _AllCAPReturnable_val_ArgumentType_51), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])
    
    _all_ = [
        __TCAP_CAP_Message_unidirectional_dialoguePortion,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_invokeId,
        _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_linkedId,
        _______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_partyToCharge,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_legID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_aChChargingAddress,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        __OPERATION_Errors_val_ParameterType_5,
        __OPERATION_Errors_val_ParameterType_6,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __OPERATION_Errors_val_ParameterType_7,
        __OPERATION_Errors_val_ParameterType_8,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_correlationID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_iPSSPCapabilities,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        __OPERATION_Errors_val_ParameterType_2,
        __OPERATION_Errors_val_ParameterType_3,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationType,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_requestedInformationList,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_legID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_requestedInformationTypeList,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_legID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        __OPERATION_Errors_val_ParameterType_2_0,
        __OPERATION_Errors_val_ParameterType_3_0,
        __OPERATION_Errors_val_ParameterType_4,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_invokeID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_allRequests,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_invokeID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel_callSegmentID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callSegmentToCancel,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        ___OPERATION_Errors_val_ParameterType_0_problem,
        ___OPERATION_Errors_val_ParameterType_0_operation,
        __OPERATION_Errors_val_ParameterType_0,
        __OPERATION_Errors_val_ParameterType_2_1,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10,
        __OPERATION_Errors_val_ParameterType_1,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_destinationRoutingAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_alertingPattern,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_originalCalledPartyID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_carrier,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_callingPartysCategory,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectingPartyID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_redirectionInformation,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_genericNumbers,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_chargeNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeConnected,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_cug_Interlock,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_cug_OutgoingAccess,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_suppressionOfAnnouncement,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_oCSIApplicable,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_naOliInfo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_bor_InterrogationRequested,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_suppress_N_CSI,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_accessPointName,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_pdpID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartysNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_destinationSubscriberNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_sMSCAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_ipRoutingAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress_none,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_resourceAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callSegmentID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        __OPERATION_Errors_val_ParameterType_1_0,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_alertingPattern,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_genericNumbers,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_chargeNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_suppressionOfAnnouncement,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_naOliInfo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bor_InterrogationRequested,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_suppress_O_CSI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_D_CSI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_N_CSI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_continueWithArgumentArgExtension,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        __OPERATION_Errors_val_ParameterType_0_0,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_legToBeReleased,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_releaseCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure_cause,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_callSegmentFailure,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_legID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure_cause,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bCSM_Failure,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_gPRSCause,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_pDPID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_assistingSSPIPRoutingAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_correlationID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_scfID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_carrier,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_serviceInteractionIndicatorsTwo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_naOliInfo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_chargeNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_originalCalledPartyID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callingPartyNumber,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventTypeBCSM,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_eventSpecificInformationBCSM,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_miscCallInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventType,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_miscGPRSInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_gPRSEventSpecificInformation,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_pDPID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_eventTypeSMS,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_eventSpecificInformationSMS,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_miscCallInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_29,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_serviceKey,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartyNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callingPartysCategory,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cGEncountered,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iPSSPCapabilities,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_originalCalledPartyID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_highLayerCompatibility,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_additionalCallingPartyNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability_bearerCap,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_bearerCapability,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_eventTypeBCSM,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectingPartyID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_redirectionInformation,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cause,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_serviceInteractionIndicatorsTwo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_carrier,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_Index,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_Interlock,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_cug_OutgoingAccess,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_iMSI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_subscriberState,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_locationInformation,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_ext_basicServiceCode,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callReferenceNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_mscAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_calledPartyBCDNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_timeAndTimezone,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_callForwardingSS_Pending,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_gmscAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_ms_Classmark2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_iMEI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_supportedCamelPhases,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_offeredCamel4Functionalities,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_bearerCapability2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_ext_basicServiceCode2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_highLayerCompatibility2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_enhancedDialledServicesAllowed,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_uu_Data,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_collectInformationAllowed,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30_initialDPArgExtension,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_30,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_serviceKey,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gPRSEventType,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_mSISDN,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_iMSI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_timeAndTimeZone,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gPRSMSClass,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeOrganization,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPTypeNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress_pDPAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_endUserAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_qualityOfService,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_accessPointName,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_routeingAreaIdentity,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_chargingID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_sGSNCapabilities,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_locationInformationGPRS,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_pDPInitiationType,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_gGSNAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_secondaryPDP_context,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31_iMEI,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_31,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_serviceKey,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_destinationSubscriberNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_callingPartyNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_eventTypeSMS,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_iMSI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_locationInformationMSC,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_locationInformationGPRS,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_sMSCAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_timeAndTimezone,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPShortMessageSpecificInfo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPProtocolIdentifier,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPDataCodingScheme,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_tPValidityPeriod,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_smsReferenceNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_mscAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_sgsn_Number,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_ms_Classmark2,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_gPRSMSClass,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_iMEI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32_calledPartyNumber,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_32,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_destinationRoutingAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_legToBeCreated,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_newCallSegment,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callingPartyNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_callReferenceNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_gsmSCFAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33_suppress_T_CSI,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_33,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_supportedCamelPhases,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_offeredCamel4Functionalities,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33_releaseCallArgExtensionAllowed,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_33,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_legIDToMove,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_34,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_messageID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_duration,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo_interval,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_inbandInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend_tone,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_informationToSend,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_disconnectFromIPForbidden,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_requestAnnouncementCompleteNotification,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_callSegmentID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35_requestAnnouncementStartedNotification,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_35,
        __OPERATION_Linked_val_ArgumentType_0,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment_legID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_legOrCallSegment,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_bursts,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_36,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_collectedInfo,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_disconnectFromIPForbidden,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_messageID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_duration,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo_interval,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_inbandInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend_tone,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_informationToSend,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_callSegmentID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37_requestAnnouncementStartedNotification,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_37,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37_digitsResponse,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_37,
        __OPERATION_Errors_val_ParameterType_4_0,
        __OPERATION_Errors_val_ParameterType_5_0,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegments,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38_allCallSegmentsWithExtension,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_38,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_gprsCause,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39_pDPID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_39,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__eventTypeBCSM,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__monitorMode,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__legID,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item__automaticRearm,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_bcsmEvents,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_40,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_gPRSEvent,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41_pDPID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_41,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_sMSEvents,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_42,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_timerID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_timervalue,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43_callSegmentID,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_43,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_44,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_timerID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_timervalue,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_45,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_sCIBillingChargingCharacteristics,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_partyToCharge,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_46,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_47,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_48,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_legToBeSplit,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_newCallSegment,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions__item_,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49_extensions,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_49,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_opcode,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke_argument,
        _____TCAP_CAP_Message_unidirectional_components__item__basicROS_invoke,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChBillingChargingCharacteristics,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_partyToCharge,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_extensions,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_legID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress_srfConnection,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_aChChargingAddress,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_correlationID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_iPSSPCapabilities,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_gapOnService,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_basicGapCriteria,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria_compoundGapCriteria,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapCriteria,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapIndicators,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_controlType,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend_tone,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_informationToSend,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment_releaseCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_gapTreatment,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationType,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_requestedInformationList,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_legID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_requestedInformationTypeList,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_legID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_invokeID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_allRequests,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_invokeID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callSegmentToCancel,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_destinationRoutingAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_alertingPattern,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_originalCalledPartyID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_carrier,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_callingPartysCategory,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectingPartyID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_redirectionInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_genericNumbers,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_chargeNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeConnected,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_cug_Interlock,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_cug_OutgoingAccess,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_suppressionOfAnnouncement,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_oCSIApplicable,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_naOliInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_bor_InterrogationRequested,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_suppress_N_CSI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_accessPointName,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_pdpID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartysNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationSubscriberNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_sMSCAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_ipRoutingAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress_none,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_resourceAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_serviceInteractionIndicatorsTwo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_callSegmentID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_alertingPattern,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_serviceInteractionIndicatorsTwo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_callingPartysCategory,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_genericNumbers,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_cug_Interlock,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_cug_OutgoingAccess,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_chargeNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_carrier,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_suppressionOfAnnouncement,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_naOliInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_bor_InterrogationRequested,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_suppress_O_CSI,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_D_CSI,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_N_CSI,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_continueWithArgumentArgExtension,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_legToBeReleased,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_releaseCause,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_callSegmentID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure_cause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_callSegmentFailure,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_legID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure_cause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_bCSM_Failure,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_gPRSCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_pDPID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_assistingSSPIPRoutingAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_correlationID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_scfID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_carrier,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_serviceInteractionIndicatorsTwo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_naOliInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_chargeNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_originalCalledPartyID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_callingPartyNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventTypeBCSM,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_eventSpecificInformationBCSM,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_legID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_miscCallInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_28,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_29,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_30,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_serviceKey,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartyNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callingPartysCategory,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cGEncountered,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iPSSPCapabilities,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_originalCalledPartyID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_highLayerCompatibility,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_additionalCallingPartyNumber,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability_bearerCap,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_bearerCapability,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_eventTypeBCSM,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectingPartyID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_redirectionInformation,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_serviceInteractionIndicatorsTwo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_carrier,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_Index,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_Interlock,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_cug_OutgoingAccess,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_iMSI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_subscriberState,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_locationInformation,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_ext_basicServiceCode,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callReferenceNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_mscAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_calledPartyBCDNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_timeAndTimezone,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_callForwardingSS_Pending,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_gmscAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_ms_Classmark2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_iMEI,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_supportedCamelPhases,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_offeredCamel4Functionalities,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_bearerCapability2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_ext_basicServiceCode2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_highLayerCompatibility2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_uu_Data,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_collectInformationAllowed,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31_initialDPArgExtension,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_31,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_serviceKey,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gPRSEventType,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_mSISDN,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_iMSI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_timeAndTimeZone,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gPRSMSClass,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeOrganization,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPTypeNumber,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress_pDPAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_endUserAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_qualityOfService,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_accessPointName,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_routeingAreaIdentity,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_chargingID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_sGSNCapabilities,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_locationInformationGPRS,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_pDPInitiationType,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_gGSNAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_secondaryPDP_context,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32_iMEI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_32,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_serviceKey,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_destinationSubscriberNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_callingPartyNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_eventTypeSMS,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_iMSI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_locationInformationMSC,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_locationInformationGPRS,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_sMSCAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_timeAndTimezone,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPShortMessageSpecificInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPProtocolIdentifier,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPDataCodingScheme,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_tPValidityPeriod,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_smsReferenceNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_mscAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_sgsn_Number,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_ms_Classmark2,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_gPRSMSClass,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_iMEI,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33_calledPartyNumber,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_33,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_destinationRoutingAddress,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_legToBeCreated,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_newCallSegment,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callingPartyNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_callReferenceNumber,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_gsmSCFAddress,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34_suppress_T_CSI,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_34,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_supportedCamelPhases,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_offeredCamel4Functionalities,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34_releaseCallArgExtensionAllowed,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_34,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_legIDToMove,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_35,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_messageID,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_duration,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo_interval,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_inbandInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend_tone,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_informationToSend,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_disconnectFromIPForbidden,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_requestAnnouncementCompleteNotification,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36_requestAnnouncementStartedNotification,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_36,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_callSegmentID,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment_legID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_legOrCallSegment,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_bursts,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_37,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_collectedInfo,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_disconnectFromIPForbidden,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_messageID,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_duration,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo_interval,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_inbandInfo,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend_tone,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_informationToSend,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_callSegmentID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38_requestAnnouncementStartedNotification,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_38,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38_digitsResponse,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_38,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegments,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions__item_,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39_allCallSegmentsWithExtension,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_39,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_gprsCause,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40_pDPID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_40,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_41,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__eventTypeBCSM,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__monitorMode,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__legID,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria,
        ____________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item__automaticRearm,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_bcsmEvents,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_42,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_gPRSEvent,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43_pDPID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_43,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_sMSEvents,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_44,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_timerID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_timervalue,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_extensions,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45_callSegmentID,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_45,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_46,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_timerID,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_timervalue,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_47,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_sCIBillingChargingCharacteristics,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_partyToCharge,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_48,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_49,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_50,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_legToBeSplit,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_newCallSegment,
        ___________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions__item_,
        __________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51_extensions,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_51,
        _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result_result,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult_result,
        _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnResult,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_invokeId,
        _______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_11,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_problem,
        _________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12_operation,
        ________TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_12,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_errcode,
        ______TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError_parameter,
        _____TCAP_CAP_Message_unidirectional_components__item__basicROS_returnError,
        _____TCAP_CAP_Message_unidirectional_components__item__basicROS_reject,
        ____TCAP_CAP_Message_unidirectional_components__item__basicROS,
        _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_invokeId,
        ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result_result,
        _____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast_result,
        ____TCAP_CAP_Message_unidirectional_components__item__returnResultNotLast,
        ___TCAP_CAP_Message_unidirectional_components__item_,
        __TCAP_CAP_Message_unidirectional_components,
        _TCAP_CAP_Message_unidirectional,
        __TCAP_CAP_Message_begin_otid,
        __TCAP_CAP_Message_begin_dialoguePortion,
        ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_invokeId,
        _______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId_present,
        _______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_linkedId,
        ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_opcode,
        ______TCAP_CAP_Message_begin_components__item__basicROS_invoke_argument,
        _____TCAP_CAP_Message_begin_components__item__basicROS_invoke,
        ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_invokeId,
        _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_opcode,
        _______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result_result,
        ______TCAP_CAP_Message_begin_components__item__basicROS_returnResult_result,
        _____TCAP_CAP_Message_begin_components__item__basicROS_returnResult,
        ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_invokeId,
        ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_errcode,
        ______TCAP_CAP_Message_begin_components__item__basicROS_returnError_parameter,
        _____TCAP_CAP_Message_begin_components__item__basicROS_returnError,
        _____TCAP_CAP_Message_begin_components__item__basicROS_reject,
        ____TCAP_CAP_Message_begin_components__item__basicROS,
        _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_invokeId,
        ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_opcode,
        ______TCAP_CAP_Message_begin_components__item__returnResultNotLast_result_result,
        _____TCAP_CAP_Message_begin_components__item__returnResultNotLast_result,
        ____TCAP_CAP_Message_begin_components__item__returnResultNotLast,
        ___TCAP_CAP_Message_begin_components__item_,
        __TCAP_CAP_Message_begin_components,
        _TCAP_CAP_Message_begin,
        __TCAP_CAP_Message_end_dtid,
        __TCAP_CAP_Message_end_dialoguePortion,
        ______TCAP_CAP_Message_end_components__item__basicROS_invoke_invokeId,
        _______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId_present,
        _______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_CAP_Message_end_components__item__basicROS_invoke_linkedId,
        ______TCAP_CAP_Message_end_components__item__basicROS_invoke_opcode,
        ______TCAP_CAP_Message_end_components__item__basicROS_invoke_argument,
        _____TCAP_CAP_Message_end_components__item__basicROS_invoke,
        ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_invokeId,
        _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_opcode,
        _______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result_result,
        ______TCAP_CAP_Message_end_components__item__basicROS_returnResult_result,
        _____TCAP_CAP_Message_end_components__item__basicROS_returnResult,
        ______TCAP_CAP_Message_end_components__item__basicROS_returnError_invokeId,
        ______TCAP_CAP_Message_end_components__item__basicROS_returnError_errcode,
        ______TCAP_CAP_Message_end_components__item__basicROS_returnError_parameter,
        _____TCAP_CAP_Message_end_components__item__basicROS_returnError,
        _____TCAP_CAP_Message_end_components__item__basicROS_reject,
        ____TCAP_CAP_Message_end_components__item__basicROS,
        _____TCAP_CAP_Message_end_components__item__returnResultNotLast_invokeId,
        ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_opcode,
        ______TCAP_CAP_Message_end_components__item__returnResultNotLast_result_result,
        _____TCAP_CAP_Message_end_components__item__returnResultNotLast_result,
        ____TCAP_CAP_Message_end_components__item__returnResultNotLast,
        ___TCAP_CAP_Message_end_components__item_,
        __TCAP_CAP_Message_end_components,
        _TCAP_CAP_Message_end,
        __TCAP_CAP_Message_continue__otid,
        __TCAP_CAP_Message_continue__dtid,
        __TCAP_CAP_Message_continue__dialoguePortion,
        ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_invokeId,
        _______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId_present,
        _______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId_absent,
        ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_linkedId,
        ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_opcode,
        ______TCAP_CAP_Message_continue__components__item__basicROS_invoke_argument,
        _____TCAP_CAP_Message_continue__components__item__basicROS_invoke,
        ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_invokeId,
        _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_opcode,
        _______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result_result,
        ______TCAP_CAP_Message_continue__components__item__basicROS_returnResult_result,
        _____TCAP_CAP_Message_continue__components__item__basicROS_returnResult,
        ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_invokeId,
        ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_errcode,
        ______TCAP_CAP_Message_continue__components__item__basicROS_returnError_parameter,
        _____TCAP_CAP_Message_continue__components__item__basicROS_returnError,
        _____TCAP_CAP_Message_continue__components__item__basicROS_reject,
        ____TCAP_CAP_Message_continue__components__item__basicROS,
        _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_invokeId,
        ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_opcode,
        ______TCAP_CAP_Message_continue__components__item__returnResultNotLast_result_result,
        _____TCAP_CAP_Message_continue__components__item__returnResultNotLast_result,
        ____TCAP_CAP_Message_continue__components__item__returnResultNotLast,
        ___TCAP_CAP_Message_continue__components__item_,
        __TCAP_CAP_Message_continue__components,
        _TCAP_CAP_Message_continue_,
        _TCAP_CAP_Message_abort,
        TCAP_CAP_Message,
        AllCAPInvokable,
        __AllCAPInvokable_val_ArgumentType_2_aChBillingChargingCharacteristics,
        __AllCAPInvokable_val_ArgumentType_2_partyToCharge,
        ___AllCAPInvokable_val_ArgumentType_2_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_2_extensions,
        ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_legID,
        ___AllCAPInvokable_val_ArgumentType_2_aChChargingAddress_srfConnection,
        __AllCAPInvokable_val_ArgumentType_2_aChChargingAddress,
        _AllCAPInvokable_val_ArgumentType_2,
        _AllCAPInvokable_val_ArgumentType_3,
        _AllCAPInvokable_val_ArgumentType_4,
        _AllCAPInvokable_val_ArgumentType_5,
        __AllCAPInvokable_val_ArgumentType_6_correlationID,
        __AllCAPInvokable_val_ArgumentType_6_iPSSPCapabilities,
        ___AllCAPInvokable_val_ArgumentType_6_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_6_extensions,
        _AllCAPInvokable_val_ArgumentType_6,
        ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationType,
        _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item__requestedInformationValue,
        ___AllCAPInvokable_val_ArgumentType_7_requestedInformationList__item_,
        __AllCAPInvokable_val_ArgumentType_7_requestedInformationList,
        ___AllCAPInvokable_val_ArgumentType_7_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_7_extensions,
        __AllCAPInvokable_val_ArgumentType_7_legID,
        _AllCAPInvokable_val_ArgumentType_7,
        __AllCAPInvokable_val_ArgumentType_8_requestedInformationTypeList,
        ___AllCAPInvokable_val_ArgumentType_8_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_8_extensions,
        __AllCAPInvokable_val_ArgumentType_8_legID,
        _AllCAPInvokable_val_ArgumentType_8,
        __AllCAPInvokable_val_ArgumentType_9_invokeID,
        __AllCAPInvokable_val_ArgumentType_9_allRequests,
        ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_invokeID,
        ___AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel_callSegmentID,
        __AllCAPInvokable_val_ArgumentType_9_callSegmentToCancel,
        _AllCAPInvokable_val_ArgumentType_9,
        _AllCAPInvokable_val_ArgumentType_10,
        ___AllCAPInvokable_val_ArgumentType_11_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_11_extensions,
        _AllCAPInvokable_val_ArgumentType_11,
        ___AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress__item_,
        __AllCAPInvokable_val_ArgumentType_12_destinationRoutingAddress,
        __AllCAPInvokable_val_ArgumentType_12_alertingPattern,
        __AllCAPInvokable_val_ArgumentType_12_originalCalledPartyID,
        ___AllCAPInvokable_val_ArgumentType_12_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_12_extensions,
        __AllCAPInvokable_val_ArgumentType_12_carrier,
        __AllCAPInvokable_val_ArgumentType_12_callingPartysCategory,
        __AllCAPInvokable_val_ArgumentType_12_redirectingPartyID,
        __AllCAPInvokable_val_ArgumentType_12_redirectionInformation,
        ___AllCAPInvokable_val_ArgumentType_12_genericNumbers__item_,
        __AllCAPInvokable_val_ArgumentType_12_genericNumbers,
        __AllCAPInvokable_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __AllCAPInvokable_val_ArgumentType_12_chargeNumber,
        __AllCAPInvokable_val_ArgumentType_12_legToBeConnected,
        __AllCAPInvokable_val_ArgumentType_12_cug_Interlock,
        __AllCAPInvokable_val_ArgumentType_12_cug_OutgoingAccess,
        __AllCAPInvokable_val_ArgumentType_12_suppressionOfAnnouncement,
        __AllCAPInvokable_val_ArgumentType_12_oCSIApplicable,
        __AllCAPInvokable_val_ArgumentType_12_naOliInfo,
        __AllCAPInvokable_val_ArgumentType_12_bor_InterrogationRequested,
        __AllCAPInvokable_val_ArgumentType_12_suppress_N_CSI,
        _AllCAPInvokable_val_ArgumentType_12,
        __AllCAPInvokable_val_ArgumentType_13_accessPointName,
        __AllCAPInvokable_val_ArgumentType_13_pdpID,
        _AllCAPInvokable_val_ArgumentType_13,
        __AllCAPInvokable_val_ArgumentType_14_callingPartysNumber,
        __AllCAPInvokable_val_ArgumentType_14_destinationSubscriberNumber,
        __AllCAPInvokable_val_ArgumentType_14_sMSCAddress,
        ___AllCAPInvokable_val_ArgumentType_14_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_14_extensions,
        _AllCAPInvokable_val_ArgumentType_14,
        ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_ipRoutingAddress,
        ___AllCAPInvokable_val_ArgumentType_15_resourceAddress_none,
        __AllCAPInvokable_val_ArgumentType_15_resourceAddress,
        ___AllCAPInvokable_val_ArgumentType_15_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_15_extensions,
        __AllCAPInvokable_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __AllCAPInvokable_val_ArgumentType_15_callSegmentID,
        _AllCAPInvokable_val_ArgumentType_15,
        __AllCAPInvokable_val_ArgumentType_17_alertingPattern,
        ___AllCAPInvokable_val_ArgumentType_17_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_17_extensions,
        __AllCAPInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __AllCAPInvokable_val_ArgumentType_17_callingPartysCategory,
        ___AllCAPInvokable_val_ArgumentType_17_genericNumbers__item_,
        __AllCAPInvokable_val_ArgumentType_17_genericNumbers,
        __AllCAPInvokable_val_ArgumentType_17_cug_Interlock,
        __AllCAPInvokable_val_ArgumentType_17_cug_OutgoingAccess,
        __AllCAPInvokable_val_ArgumentType_17_chargeNumber,
        __AllCAPInvokable_val_ArgumentType_17_carrier,
        __AllCAPInvokable_val_ArgumentType_17_suppressionOfAnnouncement,
        __AllCAPInvokable_val_ArgumentType_17_naOliInfo,
        __AllCAPInvokable_val_ArgumentType_17_bor_InterrogationRequested,
        __AllCAPInvokable_val_ArgumentType_17_suppress_O_CSI,
        ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_D_CSI,
        ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppress_N_CSI,
        ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension_legOrCallSegment,
        __AllCAPInvokable_val_ArgumentType_17_continueWithArgumentArgExtension,
        _AllCAPInvokable_val_ArgumentType_17,
        __AllCAPInvokable_val_ArgumentType_19_callSegmentID,
        ___AllCAPInvokable_val_ArgumentType_19_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_19_extensions,
        _AllCAPInvokable_val_ArgumentType_19,
        __AllCAPInvokable_val_ArgumentType_20_legToBeReleased,
        __AllCAPInvokable_val_ArgumentType_20_releaseCause,
        ___AllCAPInvokable_val_ArgumentType_20_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_20_extensions,
        _AllCAPInvokable_val_ArgumentType_20,
        ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_callSegmentID,
        ___AllCAPInvokable_val_ArgumentType_21_callSegmentFailure_cause,
        __AllCAPInvokable_val_ArgumentType_21_callSegmentFailure,
        ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_legID,
        ___AllCAPInvokable_val_ArgumentType_21_bCSM_Failure_cause,
        __AllCAPInvokable_val_ArgumentType_21_bCSM_Failure,
        _AllCAPInvokable_val_ArgumentType_21,
        __AllCAPInvokable_val_ArgumentType_22_gPRSCause,
        __AllCAPInvokable_val_ArgumentType_22_pDPID,
        _AllCAPInvokable_val_ArgumentType_22,
        __AllCAPInvokable_val_ArgumentType_23_assistingSSPIPRoutingAddress,
        __AllCAPInvokable_val_ArgumentType_23_correlationID,
        __AllCAPInvokable_val_ArgumentType_23_scfID,
        ___AllCAPInvokable_val_ArgumentType_23_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_23_extensions,
        __AllCAPInvokable_val_ArgumentType_23_carrier,
        __AllCAPInvokable_val_ArgumentType_23_serviceInteractionIndicatorsTwo,
        __AllCAPInvokable_val_ArgumentType_23_callSegmentID,
        __AllCAPInvokable_val_ArgumentType_23_naOliInfo,
        __AllCAPInvokable_val_ArgumentType_23_chargeNumber,
        __AllCAPInvokable_val_ArgumentType_23_originalCalledPartyID,
        __AllCAPInvokable_val_ArgumentType_23_callingPartyNumber,
        _AllCAPInvokable_val_ArgumentType_23,
        __AllCAPInvokable_val_ArgumentType_24_eventTypeBCSM,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __AllCAPInvokable_val_ArgumentType_24_eventSpecificInformationBCSM,
        __AllCAPInvokable_val_ArgumentType_24_legID,
        __AllCAPInvokable_val_ArgumentType_24_miscCallInfo,
        ___AllCAPInvokable_val_ArgumentType_24_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_24_extensions,
        _AllCAPInvokable_val_ArgumentType_24,
        __AllCAPInvokable_val_ArgumentType_25_gPRSEventType,
        __AllCAPInvokable_val_ArgumentType_25_miscGPRSInfo,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_detachSpecificInformation,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        _____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ____AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ___AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        __AllCAPInvokable_val_ArgumentType_25_gPRSEventSpecificInformation,
        __AllCAPInvokable_val_ArgumentType_25_pDPID,
        _AllCAPInvokable_val_ArgumentType_25,
        __AllCAPInvokable_val_ArgumentType_26_eventTypeSMS,
        __AllCAPInvokable_val_ArgumentType_26_eventSpecificInformationSMS,
        __AllCAPInvokable_val_ArgumentType_26_miscCallInfo,
        ___AllCAPInvokable_val_ArgumentType_26_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_26_extensions,
        _AllCAPInvokable_val_ArgumentType_26,
        _AllCAPInvokable_val_ArgumentType_27,
        _AllCAPInvokable_val_ArgumentType_28,
        _AllCAPInvokable_val_ArgumentType_29,
        __AllCAPInvokable_val_ArgumentType_30_serviceKey,
        __AllCAPInvokable_val_ArgumentType_30_calledPartyNumber,
        __AllCAPInvokable_val_ArgumentType_30_callingPartyNumber,
        __AllCAPInvokable_val_ArgumentType_30_callingPartysCategory,
        __AllCAPInvokable_val_ArgumentType_30_cGEncountered,
        __AllCAPInvokable_val_ArgumentType_30_iPSSPCapabilities,
        __AllCAPInvokable_val_ArgumentType_30_locationNumber,
        __AllCAPInvokable_val_ArgumentType_30_originalCalledPartyID,
        ___AllCAPInvokable_val_ArgumentType_30_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_30_extensions,
        __AllCAPInvokable_val_ArgumentType_30_highLayerCompatibility,
        __AllCAPInvokable_val_ArgumentType_30_additionalCallingPartyNumber,
        ___AllCAPInvokable_val_ArgumentType_30_bearerCapability_bearerCap,
        __AllCAPInvokable_val_ArgumentType_30_bearerCapability,
        __AllCAPInvokable_val_ArgumentType_30_eventTypeBCSM,
        __AllCAPInvokable_val_ArgumentType_30_redirectingPartyID,
        __AllCAPInvokable_val_ArgumentType_30_redirectionInformation,
        __AllCAPInvokable_val_ArgumentType_30_cause,
        __AllCAPInvokable_val_ArgumentType_30_serviceInteractionIndicatorsTwo,
        __AllCAPInvokable_val_ArgumentType_30_carrier,
        __AllCAPInvokable_val_ArgumentType_30_cug_Index,
        __AllCAPInvokable_val_ArgumentType_30_cug_Interlock,
        __AllCAPInvokable_val_ArgumentType_30_cug_OutgoingAccess,
        __AllCAPInvokable_val_ArgumentType_30_iMSI,
        __AllCAPInvokable_val_ArgumentType_30_subscriberState,
        __AllCAPInvokable_val_ArgumentType_30_locationInformation,
        __AllCAPInvokable_val_ArgumentType_30_ext_basicServiceCode,
        __AllCAPInvokable_val_ArgumentType_30_callReferenceNumber,
        __AllCAPInvokable_val_ArgumentType_30_mscAddress,
        __AllCAPInvokable_val_ArgumentType_30_calledPartyBCDNumber,
        __AllCAPInvokable_val_ArgumentType_30_timeAndTimezone,
        __AllCAPInvokable_val_ArgumentType_30_callForwardingSS_Pending,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_gmscAddress,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_forwardingDestinationNumber,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_ms_Classmark2,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_iMEI,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_supportedCamelPhases,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_offeredCamel4Functionalities,
        ____AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2_bearerCap,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_bearerCapability2,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_ext_basicServiceCode2,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_highLayerCompatibility2,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_lowLayerCompatibility2,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_uu_Data,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_collectInformationAllowed,
        ___AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __AllCAPInvokable_val_ArgumentType_30_initialDPArgExtension,
        _AllCAPInvokable_val_ArgumentType_30,
        __AllCAPInvokable_val_ArgumentType_31_serviceKey,
        __AllCAPInvokable_val_ArgumentType_31_gPRSEventType,
        __AllCAPInvokable_val_ArgumentType_31_mSISDN,
        __AllCAPInvokable_val_ArgumentType_31_iMSI,
        __AllCAPInvokable_val_ArgumentType_31_timeAndTimeZone,
        __AllCAPInvokable_val_ArgumentType_31_gPRSMSClass,
        ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeOrganization,
        ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPTypeNumber,
        ___AllCAPInvokable_val_ArgumentType_31_endUserAddress_pDPAddress,
        __AllCAPInvokable_val_ArgumentType_31_endUserAddress,
        __AllCAPInvokable_val_ArgumentType_31_qualityOfService,
        __AllCAPInvokable_val_ArgumentType_31_accessPointName,
        __AllCAPInvokable_val_ArgumentType_31_routeingAreaIdentity,
        __AllCAPInvokable_val_ArgumentType_31_chargingID,
        __AllCAPInvokable_val_ArgumentType_31_sGSNCapabilities,
        __AllCAPInvokable_val_ArgumentType_31_locationInformationGPRS,
        __AllCAPInvokable_val_ArgumentType_31_pDPInitiationType,
        ___AllCAPInvokable_val_ArgumentType_31_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_31_extensions,
        __AllCAPInvokable_val_ArgumentType_31_gGSNAddress,
        __AllCAPInvokable_val_ArgumentType_31_secondaryPDP_context,
        __AllCAPInvokable_val_ArgumentType_31_iMEI,
        _AllCAPInvokable_val_ArgumentType_31,
        __AllCAPInvokable_val_ArgumentType_32_serviceKey,
        __AllCAPInvokable_val_ArgumentType_32_destinationSubscriberNumber,
        __AllCAPInvokable_val_ArgumentType_32_callingPartyNumber,
        __AllCAPInvokable_val_ArgumentType_32_eventTypeSMS,
        __AllCAPInvokable_val_ArgumentType_32_iMSI,
        __AllCAPInvokable_val_ArgumentType_32_locationInformationMSC,
        __AllCAPInvokable_val_ArgumentType_32_locationInformationGPRS,
        __AllCAPInvokable_val_ArgumentType_32_sMSCAddress,
        __AllCAPInvokable_val_ArgumentType_32_timeAndTimezone,
        __AllCAPInvokable_val_ArgumentType_32_tPShortMessageSpecificInfo,
        __AllCAPInvokable_val_ArgumentType_32_tPProtocolIdentifier,
        __AllCAPInvokable_val_ArgumentType_32_tPDataCodingScheme,
        __AllCAPInvokable_val_ArgumentType_32_tPValidityPeriod,
        ___AllCAPInvokable_val_ArgumentType_32_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_32_extensions,
        __AllCAPInvokable_val_ArgumentType_32_smsReferenceNumber,
        __AllCAPInvokable_val_ArgumentType_32_mscAddress,
        __AllCAPInvokable_val_ArgumentType_32_sgsn_Number,
        __AllCAPInvokable_val_ArgumentType_32_ms_Classmark2,
        __AllCAPInvokable_val_ArgumentType_32_gPRSMSClass,
        __AllCAPInvokable_val_ArgumentType_32_iMEI,
        __AllCAPInvokable_val_ArgumentType_32_calledPartyNumber,
        _AllCAPInvokable_val_ArgumentType_32,
        ___AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress__item_,
        __AllCAPInvokable_val_ArgumentType_33_destinationRoutingAddress,
        ___AllCAPInvokable_val_ArgumentType_33_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_33_extensions,
        __AllCAPInvokable_val_ArgumentType_33_legToBeCreated,
        __AllCAPInvokable_val_ArgumentType_33_newCallSegment,
        __AllCAPInvokable_val_ArgumentType_33_callingPartyNumber,
        __AllCAPInvokable_val_ArgumentType_33_callReferenceNumber,
        __AllCAPInvokable_val_ArgumentType_33_gsmSCFAddress,
        __AllCAPInvokable_val_ArgumentType_33_suppress_T_CSI,
        _AllCAPInvokable_val_ArgumentType_33,
        __AllCAPInvokable_val_ResultType_33_supportedCamelPhases,
        __AllCAPInvokable_val_ResultType_33_offeredCamel4Functionalities,
        ___AllCAPInvokable_val_ResultType_33_extensions__item_,
        __AllCAPInvokable_val_ResultType_33_extensions,
        __AllCAPInvokable_val_ResultType_33_releaseCallArgExtensionAllowed,
        _AllCAPInvokable_val_ResultType_33,
        __AllCAPInvokable_val_ArgumentType_34_legIDToMove,
        ___AllCAPInvokable_val_ArgumentType_34_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_34_extensions,
        _AllCAPInvokable_val_ArgumentType_34,
        _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text_attributes,
        _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_text,
        ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID_variableMessage,
        ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_messageID,
        ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_numberOfRepetitions,
        ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_duration,
        ____AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo_interval,
        ___AllCAPInvokable_val_ArgumentType_35_informationToSend_inbandInfo,
        ___AllCAPInvokable_val_ArgumentType_35_informationToSend_tone,
        __AllCAPInvokable_val_ArgumentType_35_informationToSend,
        __AllCAPInvokable_val_ArgumentType_35_disconnectFromIPForbidden,
        __AllCAPInvokable_val_ArgumentType_35_requestAnnouncementCompleteNotification,
        ___AllCAPInvokable_val_ArgumentType_35_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_35_extensions,
        __AllCAPInvokable_val_ArgumentType_35_callSegmentID,
        __AllCAPInvokable_val_ArgumentType_35_requestAnnouncementStartedNotification,
        _AllCAPInvokable_val_ArgumentType_35,
        ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_callSegmentID,
        ___AllCAPInvokable_val_ArgumentType_36_legOrCallSegment_legID,
        __AllCAPInvokable_val_ArgumentType_36_legOrCallSegment,
        __AllCAPInvokable_val_ArgumentType_36_bursts,
        ___AllCAPInvokable_val_ArgumentType_36_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_36_extensions,
        _AllCAPInvokable_val_ArgumentType_36,
        __AllCAPInvokable_val_ArgumentType_37_collectedInfo,
        __AllCAPInvokable_val_ArgumentType_37_disconnectFromIPForbidden,
        _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text_attributes,
        _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_text,
        ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID_variableMessage,
        ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_messageID,
        ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_numberOfRepetitions,
        ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_duration,
        ____AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo_interval,
        ___AllCAPInvokable_val_ArgumentType_37_informationToSend_inbandInfo,
        ___AllCAPInvokable_val_ArgumentType_37_informationToSend_tone,
        __AllCAPInvokable_val_ArgumentType_37_informationToSend,
        ___AllCAPInvokable_val_ArgumentType_37_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_37_extensions,
        __AllCAPInvokable_val_ArgumentType_37_callSegmentID,
        __AllCAPInvokable_val_ArgumentType_37_requestAnnouncementStartedNotification,
        _AllCAPInvokable_val_ArgumentType_37,
        __AllCAPInvokable_val_ResultType_37_digitsResponse,
        _AllCAPInvokable_val_ResultType_37,
        __AllCAPInvokable_val_ArgumentType_38_allCallSegments,
        ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_allCallSegments,
        ____AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions__item_,
        ___AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension_extensions,
        __AllCAPInvokable_val_ArgumentType_38_allCallSegmentsWithExtension,
        _AllCAPInvokable_val_ArgumentType_38,
        __AllCAPInvokable_val_ArgumentType_39_gprsCause,
        __AllCAPInvokable_val_ArgumentType_39_pDPID,
        _AllCAPInvokable_val_ArgumentType_39,
        ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__eventTypeBCSM,
        ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__monitorMode,
        ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__legID,
        _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__dpSpecificCriteria,
        ____AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item__automaticRearm,
        ___AllCAPInvokable_val_ArgumentType_40_bcsmEvents__item_,
        __AllCAPInvokable_val_ArgumentType_40_bcsmEvents,
        ___AllCAPInvokable_val_ArgumentType_40_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_40_extensions,
        _AllCAPInvokable_val_ArgumentType_40,
        ___AllCAPInvokable_val_ArgumentType_41_gPRSEvent__item_,
        __AllCAPInvokable_val_ArgumentType_41_gPRSEvent,
        __AllCAPInvokable_val_ArgumentType_41_pDPID,
        _AllCAPInvokable_val_ArgumentType_41,
        ___AllCAPInvokable_val_ArgumentType_42_sMSEvents__item_,
        __AllCAPInvokable_val_ArgumentType_42_sMSEvents,
        ___AllCAPInvokable_val_ArgumentType_42_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_42_extensions,
        _AllCAPInvokable_val_ArgumentType_42,
        __AllCAPInvokable_val_ArgumentType_43_timerID,
        __AllCAPInvokable_val_ArgumentType_43_timervalue,
        ___AllCAPInvokable_val_ArgumentType_43_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_43_extensions,
        __AllCAPInvokable_val_ArgumentType_43_callSegmentID,
        _AllCAPInvokable_val_ArgumentType_43,
        _AllCAPInvokable_val_ArgumentType_44,
        __AllCAPInvokable_val_ArgumentType_45_timerID,
        __AllCAPInvokable_val_ArgumentType_45_timervalue,
        ___AllCAPInvokable_val_ArgumentType_45_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_45_extensions,
        _AllCAPInvokable_val_ArgumentType_45,
        __AllCAPInvokable_val_ArgumentType_46_sCIBillingChargingCharacteristics,
        __AllCAPInvokable_val_ArgumentType_46_partyToCharge,
        ___AllCAPInvokable_val_ArgumentType_46_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_46_extensions,
        _AllCAPInvokable_val_ArgumentType_46,
        __AllCAPInvokable_val_ArgumentType_47_sCIGPRSBillingChargingCharacteristics,
        _AllCAPInvokable_val_ArgumentType_47,
        _AllCAPInvokable_val_ArgumentType_48,
        __AllCAPInvokable_val_ArgumentType_49_legToBeSplit,
        __AllCAPInvokable_val_ArgumentType_49_newCallSegment,
        ___AllCAPInvokable_val_ArgumentType_49_extensions__item_,
        __AllCAPInvokable_val_ArgumentType_49_extensions,
        _AllCAPInvokable_val_ArgumentType_49,
        AllCAPReturnable,
        __AllCAPReturnable_val_ArgumentType_2_aChBillingChargingCharacteristics,
        __AllCAPReturnable_val_ArgumentType_2_partyToCharge,
        ___AllCAPReturnable_val_ArgumentType_2_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_2_extensions,
        ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_legID,
        ___AllCAPReturnable_val_ArgumentType_2_aChChargingAddress_srfConnection,
        __AllCAPReturnable_val_ArgumentType_2_aChChargingAddress,
        _AllCAPReturnable_val_ArgumentType_2,
        _AllCAPReturnable_val_ArgumentType_3,
        _AllCAPReturnable_val_ArgumentType_4,
        _AllCAPReturnable_val_ArgumentType_5,
        __AllCAPReturnable_val_ArgumentType_6_correlationID,
        __AllCAPReturnable_val_ArgumentType_6_iPSSPCapabilities,
        ___AllCAPReturnable_val_ArgumentType_6_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_6_extensions,
        _AllCAPReturnable_val_ArgumentType_6,
        ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressValue,
        ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_gapOnService,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_basicGapCriteria,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria_scfID,
        ___AllCAPReturnable_val_ArgumentType_7_gapCriteria_compoundGapCriteria,
        __AllCAPReturnable_val_ArgumentType_7_gapCriteria,
        __AllCAPReturnable_val_ArgumentType_7_gapIndicators,
        __AllCAPReturnable_val_ArgumentType_7_controlType,
        ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_messageID,
        _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_duration,
        _____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo_interval,
        ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_inbandInfo,
        ____AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend_tone,
        ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_informationToSend,
        ___AllCAPReturnable_val_ArgumentType_7_gapTreatment_releaseCause,
        __AllCAPReturnable_val_ArgumentType_7_gapTreatment,
        ___AllCAPReturnable_val_ArgumentType_7_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_7_extensions,
        _AllCAPReturnable_val_ArgumentType_7,
        ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationType,
        _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item__requestedInformationValue,
        ___AllCAPReturnable_val_ArgumentType_8_requestedInformationList__item_,
        __AllCAPReturnable_val_ArgumentType_8_requestedInformationList,
        ___AllCAPReturnable_val_ArgumentType_8_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_8_extensions,
        __AllCAPReturnable_val_ArgumentType_8_legID,
        _AllCAPReturnable_val_ArgumentType_8,
        __AllCAPReturnable_val_ArgumentType_9_requestedInformationTypeList,
        ___AllCAPReturnable_val_ArgumentType_9_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_9_extensions,
        __AllCAPReturnable_val_ArgumentType_9_legID,
        _AllCAPReturnable_val_ArgumentType_9,
        __AllCAPReturnable_val_ArgumentType_10_invokeID,
        __AllCAPReturnable_val_ArgumentType_10_allRequests,
        ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_invokeID,
        ___AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel_callSegmentID,
        __AllCAPReturnable_val_ArgumentType_10_callSegmentToCancel,
        _AllCAPReturnable_val_ArgumentType_10,
        _AllCAPReturnable_val_ArgumentType_11,
        ___AllCAPReturnable_val_ArgumentType_12_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_12_extensions,
        _AllCAPReturnable_val_ArgumentType_12,
        ___AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress__item_,
        __AllCAPReturnable_val_ArgumentType_13_destinationRoutingAddress,
        __AllCAPReturnable_val_ArgumentType_13_alertingPattern,
        __AllCAPReturnable_val_ArgumentType_13_originalCalledPartyID,
        ___AllCAPReturnable_val_ArgumentType_13_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_13_extensions,
        __AllCAPReturnable_val_ArgumentType_13_carrier,
        __AllCAPReturnable_val_ArgumentType_13_callingPartysCategory,
        __AllCAPReturnable_val_ArgumentType_13_redirectingPartyID,
        __AllCAPReturnable_val_ArgumentType_13_redirectionInformation,
        ___AllCAPReturnable_val_ArgumentType_13_genericNumbers__item_,
        __AllCAPReturnable_val_ArgumentType_13_genericNumbers,
        __AllCAPReturnable_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        __AllCAPReturnable_val_ArgumentType_13_chargeNumber,
        __AllCAPReturnable_val_ArgumentType_13_legToBeConnected,
        __AllCAPReturnable_val_ArgumentType_13_cug_Interlock,
        __AllCAPReturnable_val_ArgumentType_13_cug_OutgoingAccess,
        __AllCAPReturnable_val_ArgumentType_13_suppressionOfAnnouncement,
        __AllCAPReturnable_val_ArgumentType_13_oCSIApplicable,
        __AllCAPReturnable_val_ArgumentType_13_naOliInfo,
        __AllCAPReturnable_val_ArgumentType_13_bor_InterrogationRequested,
        __AllCAPReturnable_val_ArgumentType_13_suppress_N_CSI,
        _AllCAPReturnable_val_ArgumentType_13,
        __AllCAPReturnable_val_ArgumentType_14_accessPointName,
        __AllCAPReturnable_val_ArgumentType_14_pdpID,
        _AllCAPReturnable_val_ArgumentType_14,
        __AllCAPReturnable_val_ArgumentType_15_callingPartysNumber,
        __AllCAPReturnable_val_ArgumentType_15_destinationSubscriberNumber,
        __AllCAPReturnable_val_ArgumentType_15_sMSCAddress,
        ___AllCAPReturnable_val_ArgumentType_15_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_15_extensions,
        _AllCAPReturnable_val_ArgumentType_15,
        ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_ipRoutingAddress,
        ___AllCAPReturnable_val_ArgumentType_16_resourceAddress_none,
        __AllCAPReturnable_val_ArgumentType_16_resourceAddress,
        ___AllCAPReturnable_val_ArgumentType_16_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_16_extensions,
        __AllCAPReturnable_val_ArgumentType_16_serviceInteractionIndicatorsTwo,
        __AllCAPReturnable_val_ArgumentType_16_callSegmentID,
        _AllCAPReturnable_val_ArgumentType_16,
        _AllCAPReturnable_val_ArgumentType_18,
        __AllCAPReturnable_val_ArgumentType_20_alertingPattern,
        ___AllCAPReturnable_val_ArgumentType_20_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_20_extensions,
        __AllCAPReturnable_val_ArgumentType_20_serviceInteractionIndicatorsTwo,
        __AllCAPReturnable_val_ArgumentType_20_callingPartysCategory,
        ___AllCAPReturnable_val_ArgumentType_20_genericNumbers__item_,
        __AllCAPReturnable_val_ArgumentType_20_genericNumbers,
        __AllCAPReturnable_val_ArgumentType_20_cug_Interlock,
        __AllCAPReturnable_val_ArgumentType_20_cug_OutgoingAccess,
        __AllCAPReturnable_val_ArgumentType_20_chargeNumber,
        __AllCAPReturnable_val_ArgumentType_20_carrier,
        __AllCAPReturnable_val_ArgumentType_20_suppressionOfAnnouncement,
        __AllCAPReturnable_val_ArgumentType_20_naOliInfo,
        __AllCAPReturnable_val_ArgumentType_20_bor_InterrogationRequested,
        __AllCAPReturnable_val_ArgumentType_20_suppress_O_CSI,
        ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_D_CSI,
        ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppress_N_CSI,
        ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension_legOrCallSegment,
        __AllCAPReturnable_val_ArgumentType_20_continueWithArgumentArgExtension,
        _AllCAPReturnable_val_ArgumentType_20,
        __AllCAPReturnable_val_ArgumentType_22_callSegmentID,
        ___AllCAPReturnable_val_ArgumentType_22_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_22_extensions,
        _AllCAPReturnable_val_ArgumentType_22,
        __AllCAPReturnable_val_ArgumentType_23_legToBeReleased,
        __AllCAPReturnable_val_ArgumentType_23_releaseCause,
        ___AllCAPReturnable_val_ArgumentType_23_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_23_extensions,
        _AllCAPReturnable_val_ArgumentType_23,
        ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_callSegmentID,
        ___AllCAPReturnable_val_ArgumentType_24_callSegmentFailure_cause,
        __AllCAPReturnable_val_ArgumentType_24_callSegmentFailure,
        ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_legID,
        ___AllCAPReturnable_val_ArgumentType_24_bCSM_Failure_cause,
        __AllCAPReturnable_val_ArgumentType_24_bCSM_Failure,
        _AllCAPReturnable_val_ArgumentType_24,
        __AllCAPReturnable_val_ArgumentType_25_gPRSCause,
        __AllCAPReturnable_val_ArgumentType_25_pDPID,
        _AllCAPReturnable_val_ArgumentType_25,
        __AllCAPReturnable_val_ArgumentType_26_assistingSSPIPRoutingAddress,
        __AllCAPReturnable_val_ArgumentType_26_correlationID,
        __AllCAPReturnable_val_ArgumentType_26_scfID,
        ___AllCAPReturnable_val_ArgumentType_26_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_26_extensions,
        __AllCAPReturnable_val_ArgumentType_26_carrier,
        __AllCAPReturnable_val_ArgumentType_26_serviceInteractionIndicatorsTwo,
        __AllCAPReturnable_val_ArgumentType_26_callSegmentID,
        __AllCAPReturnable_val_ArgumentType_26_naOliInfo,
        __AllCAPReturnable_val_ArgumentType_26_chargeNumber,
        __AllCAPReturnable_val_ArgumentType_26_originalCalledPartyID,
        __AllCAPReturnable_val_ArgumentType_26_callingPartyNumber,
        _AllCAPReturnable_val_ArgumentType_26,
        __AllCAPReturnable_val_ArgumentType_27_eventTypeBCSM,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __AllCAPReturnable_val_ArgumentType_27_eventSpecificInformationBCSM,
        __AllCAPReturnable_val_ArgumentType_27_legID,
        __AllCAPReturnable_val_ArgumentType_27_miscCallInfo,
        ___AllCAPReturnable_val_ArgumentType_27_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_27_extensions,
        _AllCAPReturnable_val_ArgumentType_27,
        _AllCAPReturnable_val_ArgumentType_28,
        _AllCAPReturnable_val_ArgumentType_29,
        _AllCAPReturnable_val_ArgumentType_30,
        __AllCAPReturnable_val_ArgumentType_31_serviceKey,
        __AllCAPReturnable_val_ArgumentType_31_calledPartyNumber,
        __AllCAPReturnable_val_ArgumentType_31_callingPartyNumber,
        __AllCAPReturnable_val_ArgumentType_31_callingPartysCategory,
        __AllCAPReturnable_val_ArgumentType_31_cGEncountered,
        __AllCAPReturnable_val_ArgumentType_31_iPSSPCapabilities,
        __AllCAPReturnable_val_ArgumentType_31_locationNumber,
        __AllCAPReturnable_val_ArgumentType_31_originalCalledPartyID,
        ___AllCAPReturnable_val_ArgumentType_31_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_31_extensions,
        __AllCAPReturnable_val_ArgumentType_31_highLayerCompatibility,
        __AllCAPReturnable_val_ArgumentType_31_additionalCallingPartyNumber,
        ___AllCAPReturnable_val_ArgumentType_31_bearerCapability_bearerCap,
        __AllCAPReturnable_val_ArgumentType_31_bearerCapability,
        __AllCAPReturnable_val_ArgumentType_31_eventTypeBCSM,
        __AllCAPReturnable_val_ArgumentType_31_redirectingPartyID,
        __AllCAPReturnable_val_ArgumentType_31_redirectionInformation,
        __AllCAPReturnable_val_ArgumentType_31_cause,
        __AllCAPReturnable_val_ArgumentType_31_serviceInteractionIndicatorsTwo,
        __AllCAPReturnable_val_ArgumentType_31_carrier,
        __AllCAPReturnable_val_ArgumentType_31_cug_Index,
        __AllCAPReturnable_val_ArgumentType_31_cug_Interlock,
        __AllCAPReturnable_val_ArgumentType_31_cug_OutgoingAccess,
        __AllCAPReturnable_val_ArgumentType_31_iMSI,
        __AllCAPReturnable_val_ArgumentType_31_subscriberState,
        __AllCAPReturnable_val_ArgumentType_31_locationInformation,
        __AllCAPReturnable_val_ArgumentType_31_ext_basicServiceCode,
        __AllCAPReturnable_val_ArgumentType_31_callReferenceNumber,
        __AllCAPReturnable_val_ArgumentType_31_mscAddress,
        __AllCAPReturnable_val_ArgumentType_31_calledPartyBCDNumber,
        __AllCAPReturnable_val_ArgumentType_31_timeAndTimezone,
        __AllCAPReturnable_val_ArgumentType_31_callForwardingSS_Pending,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_gmscAddress,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_forwardingDestinationNumber,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_ms_Classmark2,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_iMEI,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_supportedCamelPhases,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_offeredCamel4Functionalities,
        ____AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2_bearerCap,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_bearerCapability2,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_ext_basicServiceCode2,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_highLayerCompatibility2,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_lowLayerCompatibility2,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_uu_Data,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_collectInformationAllowed,
        ___AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __AllCAPReturnable_val_ArgumentType_31_initialDPArgExtension,
        _AllCAPReturnable_val_ArgumentType_31,
        __AllCAPReturnable_val_ArgumentType_32_serviceKey,
        __AllCAPReturnable_val_ArgumentType_32_gPRSEventType,
        __AllCAPReturnable_val_ArgumentType_32_mSISDN,
        __AllCAPReturnable_val_ArgumentType_32_iMSI,
        __AllCAPReturnable_val_ArgumentType_32_timeAndTimeZone,
        __AllCAPReturnable_val_ArgumentType_32_gPRSMSClass,
        ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeOrganization,
        ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPTypeNumber,
        ___AllCAPReturnable_val_ArgumentType_32_endUserAddress_pDPAddress,
        __AllCAPReturnable_val_ArgumentType_32_endUserAddress,
        __AllCAPReturnable_val_ArgumentType_32_qualityOfService,
        __AllCAPReturnable_val_ArgumentType_32_accessPointName,
        __AllCAPReturnable_val_ArgumentType_32_routeingAreaIdentity,
        __AllCAPReturnable_val_ArgumentType_32_chargingID,
        __AllCAPReturnable_val_ArgumentType_32_sGSNCapabilities,
        __AllCAPReturnable_val_ArgumentType_32_locationInformationGPRS,
        __AllCAPReturnable_val_ArgumentType_32_pDPInitiationType,
        ___AllCAPReturnable_val_ArgumentType_32_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_32_extensions,
        __AllCAPReturnable_val_ArgumentType_32_gGSNAddress,
        __AllCAPReturnable_val_ArgumentType_32_secondaryPDP_context,
        __AllCAPReturnable_val_ArgumentType_32_iMEI,
        _AllCAPReturnable_val_ArgumentType_32,
        __AllCAPReturnable_val_ArgumentType_33_serviceKey,
        __AllCAPReturnable_val_ArgumentType_33_destinationSubscriberNumber,
        __AllCAPReturnable_val_ArgumentType_33_callingPartyNumber,
        __AllCAPReturnable_val_ArgumentType_33_eventTypeSMS,
        __AllCAPReturnable_val_ArgumentType_33_iMSI,
        __AllCAPReturnable_val_ArgumentType_33_locationInformationMSC,
        __AllCAPReturnable_val_ArgumentType_33_locationInformationGPRS,
        __AllCAPReturnable_val_ArgumentType_33_sMSCAddress,
        __AllCAPReturnable_val_ArgumentType_33_timeAndTimezone,
        __AllCAPReturnable_val_ArgumentType_33_tPShortMessageSpecificInfo,
        __AllCAPReturnable_val_ArgumentType_33_tPProtocolIdentifier,
        __AllCAPReturnable_val_ArgumentType_33_tPDataCodingScheme,
        __AllCAPReturnable_val_ArgumentType_33_tPValidityPeriod,
        ___AllCAPReturnable_val_ArgumentType_33_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_33_extensions,
        __AllCAPReturnable_val_ArgumentType_33_smsReferenceNumber,
        __AllCAPReturnable_val_ArgumentType_33_mscAddress,
        __AllCAPReturnable_val_ArgumentType_33_sgsn_Number,
        __AllCAPReturnable_val_ArgumentType_33_ms_Classmark2,
        __AllCAPReturnable_val_ArgumentType_33_gPRSMSClass,
        __AllCAPReturnable_val_ArgumentType_33_iMEI,
        __AllCAPReturnable_val_ArgumentType_33_calledPartyNumber,
        _AllCAPReturnable_val_ArgumentType_33,
        ___AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress__item_,
        __AllCAPReturnable_val_ArgumentType_34_destinationRoutingAddress,
        ___AllCAPReturnable_val_ArgumentType_34_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_34_extensions,
        __AllCAPReturnable_val_ArgumentType_34_legToBeCreated,
        __AllCAPReturnable_val_ArgumentType_34_newCallSegment,
        __AllCAPReturnable_val_ArgumentType_34_callingPartyNumber,
        __AllCAPReturnable_val_ArgumentType_34_callReferenceNumber,
        __AllCAPReturnable_val_ArgumentType_34_gsmSCFAddress,
        __AllCAPReturnable_val_ArgumentType_34_suppress_T_CSI,
        _AllCAPReturnable_val_ArgumentType_34,
        __AllCAPReturnable_val_ResultType_34_supportedCamelPhases,
        __AllCAPReturnable_val_ResultType_34_offeredCamel4Functionalities,
        ___AllCAPReturnable_val_ResultType_34_extensions__item_,
        __AllCAPReturnable_val_ResultType_34_extensions,
        __AllCAPReturnable_val_ResultType_34_releaseCallArgExtensionAllowed,
        _AllCAPReturnable_val_ResultType_34,
        __AllCAPReturnable_val_ArgumentType_35_legIDToMove,
        ___AllCAPReturnable_val_ArgumentType_35_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_35_extensions,
        _AllCAPReturnable_val_ArgumentType_35,
        _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text_attributes,
        _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_text,
        ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID_variableMessage,
        ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_messageID,
        ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_numberOfRepetitions,
        ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_duration,
        ____AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo_interval,
        ___AllCAPReturnable_val_ArgumentType_36_informationToSend_inbandInfo,
        ___AllCAPReturnable_val_ArgumentType_36_informationToSend_tone,
        __AllCAPReturnable_val_ArgumentType_36_informationToSend,
        __AllCAPReturnable_val_ArgumentType_36_disconnectFromIPForbidden,
        __AllCAPReturnable_val_ArgumentType_36_requestAnnouncementCompleteNotification,
        ___AllCAPReturnable_val_ArgumentType_36_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_36_extensions,
        __AllCAPReturnable_val_ArgumentType_36_callSegmentID,
        __AllCAPReturnable_val_ArgumentType_36_requestAnnouncementStartedNotification,
        _AllCAPReturnable_val_ArgumentType_36,
        ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_callSegmentID,
        ___AllCAPReturnable_val_ArgumentType_37_legOrCallSegment_legID,
        __AllCAPReturnable_val_ArgumentType_37_legOrCallSegment,
        __AllCAPReturnable_val_ArgumentType_37_bursts,
        ___AllCAPReturnable_val_ArgumentType_37_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_37_extensions,
        _AllCAPReturnable_val_ArgumentType_37,
        __AllCAPReturnable_val_ArgumentType_38_collectedInfo,
        __AllCAPReturnable_val_ArgumentType_38_disconnectFromIPForbidden,
        _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text_attributes,
        _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_text,
        ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID_variableMessage,
        ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_messageID,
        ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_numberOfRepetitions,
        ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_duration,
        ____AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo_interval,
        ___AllCAPReturnable_val_ArgumentType_38_informationToSend_inbandInfo,
        ___AllCAPReturnable_val_ArgumentType_38_informationToSend_tone,
        __AllCAPReturnable_val_ArgumentType_38_informationToSend,
        ___AllCAPReturnable_val_ArgumentType_38_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_38_extensions,
        __AllCAPReturnable_val_ArgumentType_38_callSegmentID,
        __AllCAPReturnable_val_ArgumentType_38_requestAnnouncementStartedNotification,
        _AllCAPReturnable_val_ArgumentType_38,
        __AllCAPReturnable_val_ResultType_38_digitsResponse,
        _AllCAPReturnable_val_ResultType_38,
        __AllCAPReturnable_val_ArgumentType_39_allCallSegments,
        ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_allCallSegments,
        ____AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions__item_,
        ___AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension_extensions,
        __AllCAPReturnable_val_ArgumentType_39_allCallSegmentsWithExtension,
        _AllCAPReturnable_val_ArgumentType_39,
        __AllCAPReturnable_val_ArgumentType_40_gprsCause,
        __AllCAPReturnable_val_ArgumentType_40_pDPID,
        _AllCAPReturnable_val_ArgumentType_40,
        _AllCAPReturnable_val_ArgumentType_41,
        ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__eventTypeBCSM,
        ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__monitorMode,
        ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__legID,
        _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__dpSpecificCriteria,
        ____AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item__automaticRearm,
        ___AllCAPReturnable_val_ArgumentType_42_bcsmEvents__item_,
        __AllCAPReturnable_val_ArgumentType_42_bcsmEvents,
        ___AllCAPReturnable_val_ArgumentType_42_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_42_extensions,
        _AllCAPReturnable_val_ArgumentType_42,
        ___AllCAPReturnable_val_ArgumentType_43_gPRSEvent__item_,
        __AllCAPReturnable_val_ArgumentType_43_gPRSEvent,
        __AllCAPReturnable_val_ArgumentType_43_pDPID,
        _AllCAPReturnable_val_ArgumentType_43,
        ___AllCAPReturnable_val_ArgumentType_44_sMSEvents__item_,
        __AllCAPReturnable_val_ArgumentType_44_sMSEvents,
        ___AllCAPReturnable_val_ArgumentType_44_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_44_extensions,
        _AllCAPReturnable_val_ArgumentType_44,
        __AllCAPReturnable_val_ArgumentType_45_timerID,
        __AllCAPReturnable_val_ArgumentType_45_timervalue,
        ___AllCAPReturnable_val_ArgumentType_45_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_45_extensions,
        __AllCAPReturnable_val_ArgumentType_45_callSegmentID,
        _AllCAPReturnable_val_ArgumentType_45,
        _AllCAPReturnable_val_ArgumentType_46,
        __AllCAPReturnable_val_ArgumentType_47_timerID,
        __AllCAPReturnable_val_ArgumentType_47_timervalue,
        ___AllCAPReturnable_val_ArgumentType_47_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_47_extensions,
        _AllCAPReturnable_val_ArgumentType_47,
        __AllCAPReturnable_val_ArgumentType_48_sCIBillingChargingCharacteristics,
        __AllCAPReturnable_val_ArgumentType_48_partyToCharge,
        ___AllCAPReturnable_val_ArgumentType_48_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_48_extensions,
        _AllCAPReturnable_val_ArgumentType_48,
        __AllCAPReturnable_val_ArgumentType_49_sCIGPRSBillingChargingCharacteristics,
        _AllCAPReturnable_val_ArgumentType_49,
        _AllCAPReturnable_val_ArgumentType_50,
        __AllCAPReturnable_val_ArgumentType_51_legToBeSplit,
        __AllCAPReturnable_val_ArgumentType_51_newCallSegment,
        ___AllCAPReturnable_val_ArgumentType_51_extensions__item_,
        __AllCAPReturnable_val_ArgumentType_51_extensions,
        _AllCAPReturnable_val_ArgumentType_51,
    ]

class Pycrate_TCAP_Dialogue:

    _name_  = u'Pycrate-TCAP-Dialogue'
    _oid_   = []
    
    _obj_ = [
        u'TCAP-DIALOGUE-ENCODING',
        u'Tcap-dialogue-encoding',
        u'TcapDialogueExternal',
        ]
    _type_ = [
        u'TCAP-DIALOGUE-ENCODING',
        u'TcapDialogueExternal',
        ]
    _set_ = [
        u'Tcap-dialogue-encoding',
        ]
    _val_ = [
        ]
    _class_ = [
        u'TCAP-DIALOGUE-ENCODING',
        u'Tcap-dialogue-encoding',
        ]
    _param_ = [
        ]
    
    #-----< TCAP-DIALOGUE-ENCODING >-----#
    TCAP_DIALOGUE_ENCODING = CLASS(name=u'TCAP-DIALOGUE-ENCODING', mode=MODE_TYPE)
    _TCAP_DIALOGUE_ENCODING_ref = OID(name=u'ref', mode=MODE_VALUE, uniq=True)
    _TCAP_DIALOGUE_ENCODING_Type = OPEN(name=u'Type', mode=MODE_TYPE)
    TCAP_DIALOGUE_ENCODING._cont = ASN1Dict([
        (u'ref', _TCAP_DIALOGUE_ENCODING_ref),
        (u'Type', _TCAP_DIALOGUE_ENCODING_Type),
        ])
    
    #-----< Tcap-dialogue-encoding >-----#
    Tcap_dialogue_encoding = CLASS(name=u'Tcap-dialogue-encoding', mode=MODE_SET, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING')))
    _Tcap_dialogue_encoding_val_Type_0 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    _Tcap_dialogue_encoding_val_Type_1 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    Tcap_dialogue_encoding._val = ASN1Set(rv=[dict([(u'ref', (0, 0, 17, 773, 1, 1, 1)), (u'Type', _Tcap_dialogue_encoding_val_Type_0)]), dict([(u'ref', (0, 0, 17, 773, 1, 2, 1)), (u'Type', _Tcap_dialogue_encoding_val_Type_1)])], rr=[], ev=[], er=[])
    
    #-----< TcapDialogueExternal >-----#
    TcapDialogueExternal = SEQ(name=u'TcapDialogueExternal', mode=MODE_TYPE, tag=(8, TAG_UNIVERSAL, TAG_IMPLICIT))
    _TcapDialogueExternal_direct_reference = OID(name=u'direct-reference', mode=MODE_TYPE, typeref=ASN1RefClassField(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING'), [u'ref']), opt=True)
    __TcapDialogueExternal_direct_reference_tab = CLASS(name='_tab_TCAP-DIALOGUE-ENCODING', mode=MODE_SET, typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING')))
    ___TcapDialogueExternal_direct_reference_tab_val_Type_0 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    ___TcapDialogueExternal_direct_reference_tab_val_Type_1 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    __TcapDialogueExternal_direct_reference_tab._val = ASN1Set(rv=[dict([(u'ref', (0, 0, 17, 773, 1, 1, 1)), (u'Type', ___TcapDialogueExternal_direct_reference_tab_val_Type_0)]), dict([(u'ref', (0, 0, 17, 773, 1, 2, 1)), (u'Type', ___TcapDialogueExternal_direct_reference_tab_val_Type_1)])], rr=[], ev=None, er=[])
    _TcapDialogueExternal_direct_reference._const_tab = __TcapDialogueExternal_direct_reference_tab
    _TcapDialogueExternal_direct_reference._const_tab_at = None
    _TcapDialogueExternal_direct_reference._const_tab_id = u'ref'
    _TcapDialogueExternal_indirect_reference = INT(name=u'indirect-reference', mode=MODE_TYPE, opt=True)
    _TcapDialogueExternal_data_value_descriptor = OBJ_DESC(name=u'data-value-descriptor', mode=MODE_TYPE, opt=True)
    _TcapDialogueExternal_encoding = CHOICE(name=u'encoding', mode=MODE_TYPE)
    __TcapDialogueExternal_encoding_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('Pycrate-TCAP-Dialogue', 'TCAP-DIALOGUE-ENCODING'), [u'Type']))
    __TcapDialogueExternal_encoding_single_ASN1_type._const_tab = __TcapDialogueExternal_direct_reference_tab
    __TcapDialogueExternal_encoding_single_ASN1_type._const_tab_at = ('..', '..', u'direct-reference')
    __TcapDialogueExternal_encoding_single_ASN1_type._const_tab_id = u'Type'
    __TcapDialogueExternal_encoding_octet_aligned = OCT_STR(name=u'octet-aligned', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TcapDialogueExternal_encoding_arbitrary = BIT_STR(name=u'arbitrary', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TcapDialogueExternal_encoding._cont = ASN1Dict([
        (u'single-ASN1-type', __TcapDialogueExternal_encoding_single_ASN1_type),
        (u'octet-aligned', __TcapDialogueExternal_encoding_octet_aligned),
        (u'arbitrary', __TcapDialogueExternal_encoding_arbitrary),
        ])
    _TcapDialogueExternal_encoding._ext = None
    TcapDialogueExternal._cont = ASN1Dict([
        (u'direct-reference', _TcapDialogueExternal_direct_reference),
        (u'indirect-reference', _TcapDialogueExternal_indirect_reference),
        (u'data-value-descriptor', _TcapDialogueExternal_data_value_descriptor),
        (u'encoding', _TcapDialogueExternal_encoding),
        ])
    TcapDialogueExternal._ext = None
    
    _all_ = [
        _TCAP_DIALOGUE_ENCODING_ref,
        _TCAP_DIALOGUE_ENCODING_Type,
        TCAP_DIALOGUE_ENCODING,
        Tcap_dialogue_encoding,
        _Tcap_dialogue_encoding_val_Type_0,
        _Tcap_dialogue_encoding_val_Type_1,
        __TcapDialogueExternal_direct_reference_tab,
        ___TcapDialogueExternal_direct_reference_tab_val_Type_0,
        ___TcapDialogueExternal_direct_reference_tab_val_Type_1,
        _TcapDialogueExternal_direct_reference,
        _TcapDialogueExternal_indirect_reference,
        _TcapDialogueExternal_data_value_descriptor,
        __TcapDialogueExternal_encoding_single_ASN1_type,
        __TcapDialogueExternal_encoding_octet_aligned,
        __TcapDialogueExternal_encoding_arbitrary,
        _TcapDialogueExternal_encoding,
        TcapDialogueExternal,
    ]

class TCAPMessages:

    _name_  = u'TCAPMessages'
    _oid_   = [0, 0, 17, 773, 2, 1, 3]
    
    _obj_ = [
        u'TCMessage',
        u'Unidirectional',
        u'Begin',
        u'End',
        u'Continue',
        u'Abort',
        u'DialoguePortion',
        u'OrigTransactionID',
        u'DestTransactionID',
        u'P-AbortCause',
        u'ComponentPortion',
        u'Component',
        u'TCInvokeIdSet',
        ]
    _type_ = [
        u'TCMessage',
        u'Unidirectional',
        u'Begin',
        u'End',
        u'Continue',
        u'Abort',
        u'DialoguePortion',
        u'OrigTransactionID',
        u'DestTransactionID',
        u'P-AbortCause',
        u'ComponentPortion',
        u'Component',
        ]
    _set_ = [
        u'TCInvokeIdSet',
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        u'TCMessage',
        u'Unidirectional',
        u'Begin',
        u'End',
        u'Continue',
        u'ComponentPortion',
        u'Component',
        ]
    
    #-----< TCMessage >-----#
    TCMessage = CHOICE(name=u'TCMessage', mode=MODE_TYPE, param=True)
    
    #-----< Unidirectional >-----#
    Unidirectional = SEQ(name=u'Unidirectional', mode=MODE_TYPE, param=True)
    
    #-----< Begin >-----#
    Begin = SEQ(name=u'Begin', mode=MODE_TYPE, param=True)
    
    #-----< End >-----#
    End = SEQ(name=u'End', mode=MODE_TYPE, param=True)
    
    #-----< Continue >-----#
    Continue = SEQ(name=u'Continue', mode=MODE_TYPE, param=True)
    
    #-----< Abort >-----#
    Abort = SEQ(name=u'Abort', mode=MODE_TYPE)
    _Abort_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    _Abort_reason = CHOICE(name=u'reason', mode=MODE_TYPE, opt=True)
    __Abort_reason_p_abortCause = INT(name=u'p-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'P-AbortCause')))
    __Abort_reason_u_abortCause = SEQ(name=u'u-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')))
    _Abort_reason._cont = ASN1Dict([
        (u'p-abortCause', __Abort_reason_p_abortCause),
        (u'u-abortCause', __Abort_reason_u_abortCause),
        ])
    _Abort_reason._ext = None
    Abort._cont = ASN1Dict([
        (u'dtid', _Abort_dtid),
        (u'reason', _Abort_reason),
        ])
    Abort._ext = None
    
    #-----< DialoguePortion >-----#
    DialoguePortion = SEQ(name=u'DialoguePortion', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_EXPLICIT), typeref=ASN1RefType(('Pycrate-TCAP-Dialogue', 'TcapDialogueExternal')))
    
    #-----< OrigTransactionID >-----#
    OrigTransactionID = OCT_STR(name=u'OrigTransactionID', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    OrigTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DestTransactionID >-----#
    DestTransactionID = OCT_STR(name=u'DestTransactionID', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT))
    DestTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< P-AbortCause >-----#
    P_AbortCause = INT(name=u'P-AbortCause', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT))
    P_AbortCause._cont = ASN1Dict([(u'unrecognizedMessageType', 0), (u'unrecognizedTransactionID', 1), (u'badlyFormattedTransactionPortion', 2), (u'incorrectTransactionPortion', 3), (u'resourceLimitation', 4)])
    P_AbortCause._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ComponentPortion >-----#
    ComponentPortion = SEQ_OF(name=u'ComponentPortion', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Component >-----#
    Component = CHOICE(name=u'Component', mode=MODE_TYPE, param=True)
    
    #-----< TCInvokeIdSet >-----#
    TCInvokeIdSet = CHOICE(name=u'TCInvokeIdSet', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    TCInvokeIdSet._val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    
    _all_ = [
        _Abort_dtid,
        __Abort_reason_p_abortCause,
        __Abort_reason_u_abortCause,
        _Abort_reason,
        Abort,
        DialoguePortion,
        OrigTransactionID,
        DestTransactionID,
        P_AbortCause,
        TCInvokeIdSet,
    ]

class TC_Notation_Extensions:

    _name_  = u'TC-Notation-Extensions'
    _oid_   = [0, 0, 17, 775, 2, 4, 1]
    
    _obj_ = [
        u'APPLICATION-CONTEXT',
        u'DialogueMode',
        u'Termination',
        u'dialogue-abstract-syntax',
        u'uniDialogue-abstract-syntax',
        u'TCSingleAS',
        u'TCConsumerAS',
        u'TCSupplierAS',
        u'ConnectionAS',
        ]
    _type_ = [
        u'APPLICATION-CONTEXT',
        u'DialogueMode',
        u'Termination',
        u'TCSingleAS',
        u'TCConsumerAS',
        u'TCSupplierAS',
        u'ConnectionAS',
        ]
    _set_ = [
        ]
    _val_ = [
        u'dialogue-abstract-syntax',
        u'uniDialogue-abstract-syntax',
        ]
    _class_ = [
        u'APPLICATION-CONTEXT',
        u'dialogue-abstract-syntax',
        u'uniDialogue-abstract-syntax',
        ]
    _param_ = [
        u'TCSingleAS',
        u'TCConsumerAS',
        u'TCSupplierAS',
        u'ConnectionAS',
        ]
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name=u'APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_associationContract = CLASS(name=u'associationContract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    _APPLICATION_CONTEXT_dialogueMode = ENUM(name=u'dialogueMode', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'DialogueMode')))
    _APPLICATION_CONTEXT_termination = ENUM(name=u'termination', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'Termination')), opt=True)
    _APPLICATION_CONTEXT_componentGrouping = BOOL(name=u'componentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_dialogueAndComponentGrouping = BOOL(name=u'dialogueAndComponentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_AdditionalASEs = OID(name=u'AdditionalASEs', mode=MODE_SET, opt=True)
    _APPLICATION_CONTEXT_AbstractSyntaxes = CLASS(name=u'AbstractSyntaxes', mode=MODE_SET, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _APPLICATION_CONTEXT_applicationContextName = OID(name=u'applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        (u'associationContract', _APPLICATION_CONTEXT_associationContract),
        (u'dialogueMode', _APPLICATION_CONTEXT_dialogueMode),
        (u'termination', _APPLICATION_CONTEXT_termination),
        (u'componentGrouping', _APPLICATION_CONTEXT_componentGrouping),
        (u'dialogueAndComponentGrouping', _APPLICATION_CONTEXT_dialogueAndComponentGrouping),
        (u'AdditionalASEs', _APPLICATION_CONTEXT_AdditionalASEs),
        (u'AbstractSyntaxes', _APPLICATION_CONTEXT_AbstractSyntaxes),
        (u'applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< DialogueMode >-----#
    DialogueMode = ENUM(name=u'DialogueMode', mode=MODE_TYPE)
    DialogueMode._cont = ASN1Dict([(u'structured', 1), (u'unstructured', 2)])
    DialogueMode._ext = None
    
    #-----< Termination >-----#
    Termination = ENUM(name=u'Termination', mode=MODE_TYPE)
    Termination._cont = ASN1Dict([(u'basic', 1), (u'prearranged', 2)])
    Termination._ext = None
    
    #-----< dialogue-abstract-syntax >-----#
    dialogue_abstract_syntax = CLASS(name=u'dialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _dialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    dialogue_abstract_syntax._val = dict([('Type', _dialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 1, 1))])
    
    #-----< uniDialogue-abstract-syntax >-----#
    uniDialogue_abstract_syntax = CLASS(name=u'uniDialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _uniDialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    uniDialogue_abstract_syntax._val = dict([('Type', _uniDialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 2, 1))])
    
    #-----< TCSingleAS >-----#
    TCSingleAS = CHOICE(name=u'TCSingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCConsumerAS >-----#
    TCConsumerAS = CHOICE(name=u'TCConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCSupplierAS >-----#
    TCSupplierAS = CHOICE(name=u'TCSupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< ConnectionAS >-----#
    ConnectionAS = CHOICE(name=u'ConnectionAS', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _APPLICATION_CONTEXT_associationContract,
        _APPLICATION_CONTEXT_dialogueMode,
        _APPLICATION_CONTEXT_termination,
        _APPLICATION_CONTEXT_componentGrouping,
        _APPLICATION_CONTEXT_dialogueAndComponentGrouping,
        _APPLICATION_CONTEXT_AdditionalASEs,
        _APPLICATION_CONTEXT_AbstractSyntaxes,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        DialogueMode,
        Termination,
        dialogue_abstract_syntax,
        _dialogue_abstract_syntax_val_Type,
        uniDialogue_abstract_syntax,
        _uniDialogue_abstract_syntax_val_Type,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(DialoguePDUs, UnidialoguePDUs, Remote_Operations_Generic_ROS_PDUs, Remote_Operations_Information_Objects, Remote_Operations_Useful_Definitions, MAP_BS_Code, MAP_CH_DataTypes, MAP_CommonDataTypes, MAP_ER_DataTypes, MAP_ExtensionDataTypes, MAP_MS_DataTypes, MAP_OM_DataTypes, MAP_SS_Code, MAP_SS_DataTypes, MAP_TS_Code, CS1_DataTypes, CS2_datatypes, CAP_classes, CAP_datatypes, CAP_errorcodes, CAP_errortypes, CAP_GPRS_ReferenceNumber, CAP_gprsSSF_gsmSCF_ops_args, CAP_gprsSSF_gsmSCF_pkgs_contracts_acs, CAP_gsmSCF_gsmSRF_ops_args, CAP_gsmSCF_gsmSRF_pkgs_contracts_acs, CAP_gsmSSF_gsmSCF_ops_args, CAP_gsmSSF_gsmSCF_pkgs_contracts_acs, CAP_object_identifiers, CAP_operationcodes, CAP_SMS_ops_args, CAP_smsSSF_gsmSCF_pkgs_contracts_acs, CAP_U_ABORT_Data, TCAP_CAP_Messages, Pycrate_TCAP_Dialogue, TCAPMessages, TC_Notation_Extensions, _IMPL_)
